// Action.cpp: implementation of the CAction class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

/*#include "LanguageParser.h" REMOVING FOR THIS DOS/LINUX VERSION */
#include "Action.h"
#include "CSentence.h"
/*#include ".\action.h" REMOVED IN THIS (LINUX) VERSION */

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
/*#define new DEBUG_NEW [REMOVING IN THIS (DOS/LINUX) VERSION] */
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CAction::counter=0;

CAction::CAction()
{
	//Lhs=Rhs=L"";
	op='=';
	counter++;
	option=-1;
	mainBlockName=-1;
	insertBlockName=-1;
	//Rank=1.0;
}

CAction::~CAction()
{	
	counter--;
}

CAction::CAction(wstring &lhs, 
				 wstring &rhs, 
				 char OP,
				 wstring &arg1, 
				 wstring &arg2, 
				 wstring &arg3, 
				 CLexicon*lex)
{	
	//Rank=1.0;

	counter++;

	//new code for INSERT
	if(OP==INSERT_OP){
		
		this->op=INSERT_OP;
		this->mainBlockName = CSymbolTableManager::GetNum(arg1,true);
		this->insertBlockName = CSymbolTableManager::GetNum(arg2,true);

		if (arg3 == L"NULL" || arg3 == L"")
			option = -1; //negative numebr to represent no backtracking
		else
		{
			int num=atoi((char*)arg3.c_str());
			if(num>0)
			{
				isMoveCount=true;				
				option=num;				
			}
			else
			{
				isMoveCount=false;
				option=CSymbolTableManager::GetNum(arg3,true);
			}
		}			 
	
		return;
	}
	
	//code for other operators
	
	Lhs.start_op=TARGET_OP;
	this->mainBlockName=-1;
	this->insertBlockName=-1;
	
	if(OP==0)
	{
		int pos=lhs.find(L"delete");
		if(pos>=0)
		{
			lhs=lhs.substr(7);
			GenerateSymbol(Lhs,lhs,lex);
			op='d';
			return;
		}
	}

	GenerateSymbol(Lhs,lhs,lex);

	op=OP;	
	
	if (op!=0)
	{									
	
		Lhs.start_op=SOURCE_OP;
		GenerateSymbol(Rhs,rhs,lex);
	}
}

bool CAction::GenerateSymbol(CActionString & astr,wstring & str,CLexicon*lex)
{
	if(!lex)
		return false;

	int pos=str.find(L"::",0);
	
	if(pos>0)
	{
		astr.start_op=(char)str.at(0);		
		str=str.substr(3);
	}
	
	vector<wstring> * slist=NULL;

	if(str.at(0)=='{' || str.at(0)=='\'')
	{
		slist=CSentence::GetLexemeList(str,L"<>{,}",false);
		astr.start_op=VALUE_OP;
	}
	else
		slist=CSentence::GetLexemeList(str,L".",false);
	
	if(!slist)
		return false;

	short num=0;
	
	for(vector<wstring>::iterator it=slist->begin();it!=slist->end();it++)	
	{
		num=CSymbolTableManager::GetNum(*it,true);
		astr.list.push_back(num);
	}

	if(slist)
	{
		try{
			delete slist;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### Gen Symbol");
			#endif
		}

		slist=NULL;
	}

	return true;
}

CAction* CAction::GetClone(void)
{
	CAction*temp=new CAction();
	temp->op=this->op;
	temp->Lhs=this->Lhs;
	temp->Rhs=this->Rhs; 
	
	temp->mainBlockName=this->mainBlockName;
	temp->insertBlockName=this->insertBlockName;
	temp->option=this->option; 
	temp->isMoveCount=this->isMoveCount;

	return temp;
}

bool CAction::IsBreakAction(short BreakId)
{
	if(Lhs.list.size()==0)
		return false;
	
	if(Lhs.list.at(0)==BreakId)
		return true;
	
	return false;
}

void CAction::Dump(short * Buffer,int & Bindex)
{
	/*
	short mainBlockName;
	short insertBlockName;
	short option;
	bool isMoveCount;

			class CActionString
			{
				public:
					char start_op;
					vector<short> list;
			};

	CActionString Lhs;
	CActionString Rhs;
	char op;	

	*/

	Buffer[++Bindex]=mainBlockName;
	Buffer[++Bindex]=insertBlockName;
	Buffer[++Bindex]=option;
	Buffer[++Bindex]=isMoveCount;
	
	Buffer[++Bindex]=Lhs.start_op;
	Buffer[++Bindex]=Lhs.list.size();
	for(int i=0;i<Lhs.list.size();i++)
		Buffer[++Bindex]=Lhs.list[i];

	Buffer[++Bindex]=Rhs.start_op;
	Buffer[++Bindex]=Rhs.list.size();

	for(int i=0;i<Rhs.list.size();i++)
		Buffer[++Bindex]=Rhs.list[i];

	Buffer[++Bindex]=op;

}

void CAction::Load(short* Buffer,int & Bindex)
{
	mainBlockName=Buffer[++Bindex];
	insertBlockName=Buffer[++Bindex];
	option=Buffer[++Bindex];
	isMoveCount=Buffer[++Bindex];
	
	Lhs.start_op=Buffer[++Bindex];
	Lhs.list.resize(Buffer[++Bindex]);

	for(int i=0;i<Lhs.list.size();i++)
		Lhs.list[i]=Buffer[++Bindex];

	Rhs.start_op=Buffer[++Bindex];
	Rhs.list.resize(Buffer[++Bindex]);

	for(int i=0;i<Rhs.list.size();i++)
		Rhs.list[i]=Buffer[++Bindex];

	op=Buffer[++Bindex];

}
