#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CCStructureItem.h"
/*#include ".\ccstructureitem.h" REMOVED IN THIS (LINUX) VERSION*/

typedef pair<CCStructureItem*,CCStructureItem*> map_pair;

int CCStructureItem::counter=0;

CCStructureItem::CCStructureItem(std::wstring label, 
								 wstring value, 
								 CCStructureItem *par,
								 CFStructureItem * fslink, 
								 CLexicalEntry*le)
{
	counter++;

	Label=label;
	Value=value;
	Parent=par;	
	LexEntry=le; 		

	Visited=false;

	UpFSLink=fslink;
	DownFSLink=NULL;
}

bool CCStructureItem::AddNewChild(CCStructureItem* child)
{
	if(!child)
		return false;
	
	child->Parent=this;
	ChildList.push_back(child);

	return true;
}

CCStructureItem* CCStructureItem::GetCloneAndTable(map<CCStructureItem*,CCStructureItem*> * MapTbl)
{
	using namespace std;

	if(!MapTbl)
		return NULL;
	
	CCStructureItem * parent=new CCStructureItem(this->Label,this->Value,NULL,this->UpFSLink,this->LexEntry);	
	parent->DownFSLink=DownFSLink;

	MapTbl->insert(map_pair(this,parent));

	CCStructureItem * node=NULL;

	for(vector<CCStructureItem*>::iterator it=ChildList.begin();it!=ChildList.end();it++)
	{
		node=(*it)->GetCloneAndTable(MapTbl);
		parent->AddNewChild(node);
	}	

	return parent;
}

CCStructureItem* CCStructureItem::GetCloneWithFSCSTable(map<CCStructureItem*,CCStructureItem*> & CSMapTbl,
													map<CFStructureItem*,CFStructureItem*> & FSMapTbl)
{
	using namespace std;	
	
	CCStructureItem * parent=new CCStructureItem(this->Label,this->Value,NULL,this->UpFSLink,this->LexEntry);	
	parent->DownFSLink=DownFSLink;

	CSMapTbl.insert(map_pair(this,parent));

	CFStructureItem*FSPtr=NULL;

	if(this->UpFSLink)
	{
		parent->UpFSLink=UpFSLink->GetCloneWithTable(FSMapTbl);
		parent->UpFSLink->UpdateLinkedNodeInfo(FSMapTbl);
		parent->UpFSLink->UpdateGenRefInfo(FSMapTbl);
	}
	else
	{
		parent->UpFSLink=UpFSLink;
	}

	if(this->DownFSLink)
	{
		parent->DownFSLink=DownFSLink->GetCloneWithTable(FSMapTbl);
		parent->DownFSLink->UpdateLinkedNodeInfo(FSMapTbl);
		parent->DownFSLink->UpdateGenRefInfo(FSMapTbl);
	}
	else
	{
		parent->DownFSLink=DownFSLink;
	}		

	CCStructureItem * node=NULL;

	for(vector<CCStructureItem*>::iterator it=ChildList.begin();it!=ChildList.end();it++)
	{
		node=(*it)->GetCloneAndTable(&CSMapTbl);
		parent->AddNewChild(node);
	}	

	return parent;
}

CCStructureItem* CCStructureItem::GetClone(CCStructureItem*OldPtr, CCStructureItem**NewPtr)
{
	using namespace std; 

	if(!OldPtr || !NewPtr)
		return NULL;	
	
	CCStructureItem * parent=new CCStructureItem(this->Label,this->Value,NULL,this->UpFSLink,this->LexEntry);			

	parent->Visited=this->Visited;	

	if(this==OldPtr)
		*NewPtr=parent;

	CCStructureItem * node=NULL;

	for(vector<CCStructureItem*>::iterator it=ChildList.begin();it!=ChildList.end();it++)
	{
		node=(*it)->GetClone(OldPtr,NewPtr);
		parent->AddNewChild(node);
	}	

	return parent;
}


CCStructureItem::~CCStructureItem(void)
{
	counter--;
	
	DownFSLink=NULL;
	UpFSLink=NULL;

	for(vector<CCStructureItem*>::iterator it=ChildList.begin();it!=ChildList.end();it++)	
		delete *it;
	
	ChildList.clear();	
}
