#ifndef CCSTRUCTUREITEM_H_HEADER_INCLUDED_BF67382B
#define CCSTRUCTUREITEM_H_HEADER_INCLUDED_BF67382B

#include <string>
#include <vector>
#include <map>

using std::wstring;
using std::vector;

#include "CFStructure.h"
#include "CLexicalEntry.h"

//##ModelId=406278BB0064
//##Documentation
//## It is the data structure that contains the information of node in a
//## C-Structure
class CCStructureItem
{ 	
public:

	static int counter;

//private:
	wstring Label;
	wstring Value;    
    CCStructureItem * Parent;    
	CFStructureItem * UpFSLink; 
	CFStructureItem * DownFSLink; 
    vector<CCStructureItem*> ChildList;	
	CLexicalEntry * LexEntry;
	bool Visited;

public:
	CCStructureItem(std::wstring label,wstring value,CCStructureItem*par,CFStructureItem * fslink,CLexicalEntry*le);
	bool AddNewChild(CCStructureItem* child);
	
	CCStructureItem* GetCloneAndTable(map<CCStructureItem*,CCStructureItem*> * MapTbl);
	CCStructureItem* GetCloneWithFSCSTable(map<CCStructureItem*,CCStructureItem*> & CSMapTbl,
													map<CFStructureItem*,CFStructureItem*> & FSMapTbl);


	CCStructureItem* GetClone(CCStructureItem*OldPtr, CCStructureItem**NewPtr);
	~CCStructureItem(void);
};




#endif /* CCSTRUCTUREITEM_H_HEADER_INCLUDED_BF67382B */
