#include "stdafx.h"
#pragma warning(disable: 4786)


#ifndef CChart_H
#define CChart_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "CChartColumn.h"
#include "CLexicalEntry.h"
#include "FileWriter.h"
#include "global.h"
#include "Mapper.h"
#include "FSCSPairInfo.h"

#include <string>
#include <vector>
#include <list>

using std::wstring;
using std::vector; 

class CMapper;
class CChart
    {
      public:
		  /* REMOVING IN THIS (DOS/LINUX) VERSION	
		  bool CChart::GenerateCStructuresXMLRec(CCStructureItem* CSPtr,
									   CFileWriter & FilePtr);
	      REMOVING IN THIS (DOS/LINUX) VERSION */

		  
		  CCStructureItem * RetrieveCStructure(CProduction * prod, CSentenceInfo * sen_info);

		  bool FS_ExistsInList(list<CFSCSPairInfo*> & fscs_list,CFStructureItem* fs);

		  bool GetSourceStructures(bool CheckCompletenessCoherence,list<CFSCSPairInfo*> & result);

	      void Generate_C_F_StructureXMLEx(string fs_fname,string cs_fname);
		  
	      bool ClearChart();
	      bool LoadSubCatFrameList(string & fname);

		  ~CChart();

		  vector<CFStructure*> * GetSourceFStructures(bool CheckCompletenessCoherence,CMapper*MapperInerface);

		  /*vector<CFStructure*> * DisplayAndRetrieveFStructures(CTreeCtrl *fs_TreeCtrl); REMOVING FOR THIS (DOS/LINUX) VERSION */

		  vector<CFStructure*> * GetGeneratedFStructures(bool TakeCurrentFSList);

		  /* REMOVING FOR THIS (DOS/LINUX) VERSION
		  void GenerateFStructureRecXML(CFStructureItem * fsitem,CFileWriter*fw);
		  void GenerateCStructureRecXML(CProduction *prod,CFileWriter * fw);
		  REMOVING FOR THIS (DOS/LINUX) VERSION */

	      bool SaveFStructure(CFStructureItem*nroot);
	      /* REMOVING FOR THIS (DOS/LINUX) VERSION
		  void Show_C_F_Structure(CTreeCtrl *fs_TreeCtrl,CTreeCtrl *cs_TreeCtrl);
		  void Generate_C_F_StructureXML(string fs_fname,string cs_fname);
		  REMOVING FOR THIS (DOS/LINUX) VERSION */
		  void PrintFDescW(CFDescription*fdesc, wstring title);
		  static bool IsIntersectionEmpty(vector<short> *list1,vector<short> *list2);	      
	      bool CheckForwardCompleteness(CFStructureItem*item);
	      
		  void AppendConstraints(CFStructureItem*fL,CFStructureItem*fR);
		  void AppendSet(CFStructureItem*fL,CFStructureItem*fR);
		  void AppendChilds(CFStructureItem*fL,CFStructureItem*fR);

	      static bool CheckListEquality(vector<short> *list1,vector<short> *list2);		 		  

		  short CheckConstraint(CFStructureItem*up,CFStructureItem*down,
							  wstring &left,wstring &right);

		  short CheckConstraintEx(CFStructureItem*up,CFStructureItem*down,
							  wstring &left,wstring &right);

	     // bool UnifySpecial(CFStructureItem * & fL,CFStructureItem*fR,vector<short> *vlist, 
		//				  bool CopyConstraint, bool ApplySetUnification=false);
		  
		  bool UnifySpecial(CFStructureItem * & fL,CFStructureItem*fR,vector<short> *vlist, 
						  bool ApplySetUnification=false);
		  
		  bool UnifySpecial_OLD(CFStructureItem * & fL,CFStructureItem*fR,vector<short> *vlist);

	      long EvaluateBooleanExpression(wstring bool_exp);
	      
		  bool EvaluateExpression(wstring &wstr, CFStructureItem * FSPtr_up,CFStructureItem * FSPtr_down);
	     
		  int EvaluateExpressionEx(wstring &wstr, CFStructureItem * FSPtr_up,CFStructureItem * FSPtr_down);
		/* REMOVING FOR THIS (DOS/LINUX) VERSION	
		 void ShowFStructureRec(CFStructureItem * fsitem,CTreeCtrl *m_TreeCtrl,HTREEITEM parent,bool use_parent);
	     void ShowFStructure(CTreeCtrl * m_TreeCtrl);

		 void ShowCStructureRec(CProduction *prod,CTreeCtrl *m_TreeCtrl,HTREEITEM parent,bool use_parent);
	     void ShowCStructure(CTreeCtrl * m_TreeCtrl);
		REMOVING FOR THIS (DOS/LINUX) VERSION */
	    static vector<short>* GetSetIntersection(vector<short> * list1, vector<short> * list2);
	      
	    void TraverseProduction(CProduction*prod,short tab_count=1);
	    void PrintTree();
	    
		void PrintChart();
	    bool SearchProductionInChartColumn(CProduction *prod,size_t chart_index,size_t start_index );
	

	    void SearchRelevantWords();
        		
		CFStructureItem* GetUnifiedValueFromLists(vector<wstring> * vlist1,
										 vector<wstring>* vlist2)
		{
			CFStructureItem*fsitem=NULL;
			return fsitem;	
		}

		CFStructureItem* GetUnifiedValue(CFStructureItem*item,
											 vector<CFStructureItem*>*vset)
		{
			CFStructureItem*fsitem=NULL;
			return fsitem;	
		}	
		
        bool LoadIntoChart(CProduction * prod, size_t chart_index, size_t start_index,bool CheckBeforeLoading);
		
		bool AddIntoDebugLog(wstring title,CProduction * prod, short chart_index, short start_index);

        CChartColumn * EarleyParse(vector<vector<CLexicalEntry*> * > * word_list);
		bool EarleyParse(	vector<vector<CLexicalEntry*> * > * word_list, 
							list<CFSCSPairInfo*> & result_list,
							bool CheckCompletenessCoherence);

        //##ModelId=4088BE7400BC
        bool Predictor(CChartItem *  chart_item);

        //##ModelId=4088BEDC033C
        bool Scanner(CChartItem * chart_item,vector<CLexicalEntry*>* le_list);

        //##ModelId=4088BF1D0062
        bool Completer(CChartItem * chart_item, unsigned short item_no);

        //##ModelId=4088C241039F
        bool BuildFStructureEx(CProduction * ProdDest, CProduction * ProdSrc);

		bool BuildFStructure(CProduction * Prod,CLexicalEntry*le,int CurrentIndex);

		//bool BuildFStructure(CProduction * Prod,CLexicalEntry*le);

		 bool Sort(list<CFSCSPairInfo*> & result);        

        //##ModelId=40987EA80306
		 CChart(CGrammar*grmr,string fname);
		 CChart(string fname);

		vector<CLexicalEntry*> * GetLexEntriesOnPOSAndFeatureMatch(vector<CLexicalEntry*> * word_list,
								 CProductionSymbol*psymb);

short CChart::FindandLoadProdOnChart(CChartItem*chart_item, CProduction * prod2, wstring str1, CChartItem*temp, bool NullCompletion);
      //private:
        //##ModelId=406277ED0147
        size_t ChartSize;

        //##ModelId=406277C8033A
        CChartColumn * Chart;
		CGrammar*Grammar;
		short ElementCounter;
		CLexicon*LexiconPtr;
		vector<short> SubCatFrameList;
		
		vector<CFStructure*> FSResults; //to be removed
		
		/////////////////////////
		///////Constants/////////
		/////////////////////////
		
		static short WordIndexId;
		static short PredId;

	private:
		bool CheckLexConstraints(CFStructureItem*nroot);
public:
	/*bool GenerateCFSXML(list<CFSCSPairInfo*> & SourceInfoList , const string & XMLFileName); REMOVING IN THIS (DOS/LINUX) VERSION */
};

#endif