
#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CChartItem.h"
#include "CFStructure.h"
#include "CGrammar.h"
#include "CLexicalEntry.h"
#include "CProduction.h"
#include "CChartItem.h"

#include "LogManager.h"

#include <string>
#include <vector>

using std::wstring;
using std::vector;

#include "CLexicalEntry.h"

#ifndef CChartColumn_H
#define CChartColumn_H

class CChartColumn
{

  public:	
	
	static int counter;
	void check();

	unsigned short citem_index;    
    vector<CLexicalEntry*> * WordLexEntries;	
	vector<CChartItem*> ItemVector;    
	
	vector<unsigned char> ProdFlags;
	
	//	1: new prod having same production number index can be inserted
	//	0: new prod having same production number index cannot be inserted
	//	x: place for any other value may be required in future .. (0-255)

	CChartColumn()
		:ProdFlags(500)
		//No. of english production rules found
		//in EGRules.cfg were around 500.
	{
		citem_index=0;
		WordLexEntries=NULL;
		counter++;

		for(int k=0;k<ProdFlags.size();k++)		
			ProdFlags[k]=0;		
	}
	
	virtual ~CChartColumn()
	{
		using namespace std;

		citem_index=0;
				
		CChartItem*itemptr=NULL;		

		for(vector<CChartItem*>::iterator it=ItemVector.begin();
			it!=ItemVector.end();it++)
		{
			itemptr=*it;			

			if(itemptr)
			{			
				//CLogManager::AddMessage(L"Deleting Production FS        ...\r\n");
				//itemptr->DeleteProductionFS();				
				//CLogManager::AddMessage(L"Deleted Production FS        ...\r\n");

				//CLogManager::AddMessage(L">>>>>>>>>> Deleting Chart Item    ...\r\n");
				
				try
				{					
					delete itemptr;										
					//CLogManager::AddMessage(L"<<<<<<<<<<<<< Deleted Chart Item    ...\r\n");
				}
				catch(...)
				{
					//CLogManager::AddMessage(L" ############# Exception Caught   ...\r\n");					
				}
								
			}

			itemptr=NULL;
		}

		
		
		ItemVector.clear();

		/************** DESTRUCT LEXICAL ENTRIES ************/
		
		/*if( WordLexEntries )
		{
			//CLogManager::AddMessage(L"Deleting Lex Entry...\r\n");

			CLexicalEntry * lex_ent=NULL;			

			for(vector<CLexicalEntry*>::iterator lex_it = WordLexEntries->begin();
				lex_it != WordLexEntries->end() ;lex_it++)	
			{
				lex_ent = *lex_it;

				if( lex_ent->IsCache )
					continue;
				try
				{
					delete lex_ent;				
					lex_ent=NULL;
				}
				catch(...)
				{
					CLogManager::AddMessage(L" ############# Exception Caught(DelLexEntry)   ...\r\n");
					lex_ent=NULL;
				}
			
			}

			WordLexEntries->clear();

			try
			{
				delete WordLexEntries;
				WordLexEntries=NULL;
			}
			catch(...)
			{
				CLogManager::AddMessage(L" ############# Exception Caught(DelLexEntryVec)   ...\r\n");
				WordLexEntries=NULL;
			}

			//CLogManager::AddMessage(L"Deleted Lex Entry...\r\n");

		}*/

		counter--;

	}

	void InitCurrPtr()
	{
		citem_index=0;
	}
	
	CChartItem* GetCurrent()
	{
		CChartItem*temp=NULL;

		unsigned int len=ItemVector.size();

		if(citem_index>len-1)
			return temp;

		return	ItemVector[citem_index];
	}
		
	bool MoveNext()
	{
		unsigned int len=ItemVector.size();

		if(citem_index>len-1)
			return false;

		citem_index++;
		return true;
	}
	
};


#endif
