
#include "stdafx.h"
#pragma warning(disable: 4786)

#ifndef CCHARTITEM_H_HEADER_INCLUDED_BF672629
#define CCHARTITEM_H_HEADER_INCLUDED_BF672629


#include "CProduction.h"
#include "LogManager.h"
#include "CFStructure.h"

//##ModelId=406276810167
//##Documentation
//## It is the data structure that contains the information of Parsing Chart
class CChartItem
{

public:
	bool first_null_prod;
	int StackSize;
	static int counter;

	void check();

    short StartIndex;    
    short CurrentIndex;
	bool IsMarked;	
    bool IsFailed;	

	CProduction * Prod; 
	CFStructureItem * FSPtr;
	


	CChartItem(CProduction*prod,short start,short index,bool marked,bool failed=false)
	{
		first_null_prod = true;
		StackSize = -1;
		FSPtr=NULL;
		Prod=prod;

		StartIndex=start;
		CurrentIndex=index;
		IsMarked=marked;
		IsFailed=failed;
		
		counter++;
	}

	CChartItem(CFStructureItem* FS, CProduction*prod,short start,short index,bool marked,bool failed=false)
	{
		first_null_prod = true;/*ADDED HERE*/
		FSPtr = FS;
		Prod=prod;

		StartIndex=start;
		CurrentIndex=index;
		IsMarked=marked;
		IsFailed=failed;
		
		counter++;
	}

	CChartItem * GetClone()
	{
		return new CChartItem(	FSPtr->GetClone(),
								Prod->GetClone(),
								StartIndex,
								CurrentIndex,
								IsMarked,
								IsFailed);			
	}

	~CChartItem()
	{		
		Prod=NULL;
		/*if(Prod) // cloned production will be destroyed by GC
		{
			try
			{
				delete Prod;
				Prod=NULL;
			}
			catch(...)
			{
				CLogManager::AddMessage(L" ############# Exception Caught(Del Prod)   ...\r\n");
				Prod=NULL;
			}

			//Prod->DeleteFStructures();		
		}*/

		FSPtr=NULL; //will be deleted by GC

		counter--;
	}
	
	bool DeleteProductionFS()
	{
		if(Prod)
		{
			try
			{
				delete Prod;
				Prod=NULL;
			}
			catch(...)
			{
				#ifdef GenLog
				CLogManager::AddMessage(L" ############# Exception Caught(Del Prod)   ...\r\n");
				#endif
				Prod=NULL;
			}
		}
		
		return true;
	}
};



#endif /* CCHARTITEM_H_HEADER_INCLUDED_BF672629 */
