#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CConfiguration.h"
#include "global.h" /*CASE CHANGED IN THIS (LINUX) VERSION*/
/*#include ".\cconfiguration.h" REMOVED IN THIS (LINUX) VERSION*/
typedef unsigned char* LPBYTE; /* ADDING FOR THIS (DOS/LINUX) VERSION */

hash_map< string,string > CConfiguration::InfoList;

wstring CConfiguration::RegKeyPath=L"CLSID\\{0ED07ED2-E892-4A65-B4B5-7BA3A3A0C7E3}\\InprocServer32";
string CConfiguration::ApplicationPath="";
bool CConfiguration::UseRegPath=false;


bool CConfiguration::InitializeConfigInfo(const string & ConfigFileName,bool _UseRegPath)
{
	UseRegPath=_UseRegPath;
	
		string path=ConfigFileName;

	if(UseRegPath)
	{
		/*ApplicationPath = GetApplicationPathFromRegistry(); REMOVING IN THIS (DOS/LINUX VERSION) */
		
		if(ApplicationPath=="")
		{
			/*AfxMessageBox(L"Configuration file not found",1,1); REMOVING IN THIS (DOS/LINUX VERSION) */
			return false;
		}
		/*ApplicationPath += "\\MTServer"; REMOVING IN THIS (DOS/LINUX VERSION) */
		path=ApplicationPath + "\\" + ConfigFileName;
	}	
	
	return ReadConfigurationFile(path);
}

bool CConfiguration::ReadConfigurationFile(const string & ConfigFileName)
{
	CFileReader fr(ConfigFileName.c_str(),1024);
	short ch=0;
	
	string str="";	
	string label="";
	string value="";
	
	while((ch=fr.GetCurrentChar())!=0)
	{
		switch(ch)
		{		
			case '=':
				label=str;
				str="";
				break;

			case ';':
				value=str;
				str="";
								
				AddNewEntry(label,value);

				label=value="";
				break;					
			
			case LF: case CR: break;
				
			default:
				str+=(char)ch;
		}

		fr.MoveNext();
	}
	
	return true;
}

string CConfiguration::GetConfigInfo(const string & label,bool IsVariable)
{
	using namespace std;
	hash_map<string,string>::iterator it=InfoList.find(label);

	string path="";
	
	if(it!=InfoList.end())	
		path=it->second;

	if(path=="")
	{
		wstring errmsg=L"File Not found - ";
		errmsg+=Convert_str2wstr(label);
		/* AfxMessageBox(errmsg.c_str(),1,0); REMOVING IN THIS (DOS/LINUX VERSION) */
		CLogManager::AddMessage(errmsg); /* ADDING IN THIS (DOS/LINUX VERSION) */
		return path;
	}

	if(UseRegPath && !IsVariable)
		path=ApplicationPath + "\\" + path;
	
	return path;
}

bool CConfiguration::AddNewEntry(string label, 
								 string value)
{
	using namespace std;

	//typedef pair<string,string> mkpair;
	//InfoList.insert(mkpair(label,value));

	try
	{
		InfoList[label]=value;
	}
	catch(...) /* CHANGING FOR THIS (DOS/LINUX) VERSION */
	{
		/* ex->Delete(); REMOVING IN THIS (DOS/LINUX VERSION) */
		#ifdef GenLog	
		wstring err=Convert_str2wstr(label);
			err+=L":";
			err+=Convert_str2wstr(value);
		CLogManager::AddMessage(L"New Entry could not be added in Configuration table: "+err+L"\r\n");
		#endif
		return false;
	}

	return true;
}

void Convert_ByteArrToString(LPBYTE ByteArr,size_t ByteArrSize,string & str)
{
	str="";	
	for(int k=0;k<ByteArrSize && ByteArr[k]!=0;k+=2)
		str+=ByteArr[k];
}

string CConfiguration::GetApplicationPathFromRegistry(void)
{
	/* REMOVING IN THIS (DOS/LINUX VERSION)
	wstring wpath=L"";
	string path="";

	/*Declarations*/
	/*
	HKEY phkResult;
	BYTE lpValue[500];
	DWORD ValueSize=500;
	DWORD type;

	//Open registry key
	LONG hr=RegOpenKeyEx(HKEY_CLASSES_ROOT,RegKeyPath.c_str(),0,KEY_READ,&phkResult);
	  
	//Read the default value of this key
	RegQueryValueEx(phkResult,NULL,0,&type,lpValue,&ValueSize);

	//Close Registry Key
	RegCloseKey(phkResult);

	//Assign the value and return
	if(lpValue!=NULL){
	//If the value was being read correctly
		Convert_ByteArrToString(lpValue,ValueSize,path);
				
		int index=path.size()-1;
		
		while(index>0)
		{
			if(path[index]=='\\')
			{
				path=path.substr(0,index);
				break;
			}
			index--;
		}

	}else{
	//Registry value wasn't read correctly
		path="";
	}  

	return path;
	REMOVING IN THIS (DOS/LINUX VERSION) */
	return "";
}
