#include "stdafx.h"
#pragma warning(disable: 4786)

#include <string>
/*#include <hash_map> REMOVED IN THIS (LINUX ONLY) VERSION*/

using namespace std;
/*using namespace stdext; REMOVED IN THIS (LINUX ONLY) VERSION*/

#ifndef CCONFIGURATION_H
#define CCONFIGURATION_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileReader.h"

class CConfiguration
{
  public:
	
	static bool AddNewEntry(string la,string val);
	
	static string GetConfigInfo(const string & label,bool IsVariable=false);		
	// IsVariable: True , when using label value pairs e.g. Frequency=1;
	// IsVairable: False, when using file path as value e.g. LexFileName=Data\English\ELexicon.lex

	static bool InitializeConfigInfo(const string & ConfigFileName,bool UseRegPath=false);	
	
	static string GetApplicationPath()
	{ 
		if(UseRegPath)
			return ApplicationPath;
		return "";
	}
	
	bool ClearConfigInfo()
	{
		InfoList.clear();
		return true;
	}

  private:

	static wstring RegKeyPath;
	static string ApplicationPath;
	static bool UseRegPath;

    static bool ReadConfigurationFile(const string & ConfigFileName);
	static hash_map< string,string > InfoList;    

public:

	static string GetApplicationPathFromRegistry(void);

};


#endif 
