#include "stdafx.h"
#pragma warning(disable: 4786)

#ifndef CFDESCRIPTION_H_HEADER_INCLUDED_BF670866
#define CFDESCRIPTION_H_HEADER_INCLUDED_BF670866

#include "LogManager.h"
#include "global.h"
#include "FDExpression.h"

//##ModelId=406261D4003C
//##Documentation
//## It is the data structure that contains the information of functional
//## descriptions and equations of grammar and lexicon.

class CFDescription
{

public:

	static int counter;

    CFDExpression * Label;
	CFDExpression * Value;
	short Operator;



	CFDescription()
	{
		counter++;
		
		Label=NULL;
		Value=NULL;

		Operator=0;
	}

	virtual ~CFDescription()
	{		
		counter--;

		if(Label)
		{
			try{
			delete Label;			
			}
		catch(...)
		{			
			//CLogManager::AddMessage(L"#### Label\r\n");
			Label=NULL;
		}

			Label=NULL;
		}

		if(Value)
		{
			try{
			delete Value;
			}
		catch(...)
		{
			//CLogManager::AddMessage(L"#### Value\r\n");			
			Value=NULL;
		}

			Value=NULL;
		}
	}

	bool isEqual(CFDescription*fd)
	{
		if(!fd)
			return false;
		
		if(fd->Operator!=Operator)
			return false;

		if(fd->Label->op!=Label->op)
			return false;
		
		if(!IsSubSet(&fd->Label->list,&Label->list))
			return false;

		if(!IsSubSet(&Label->list,&fd->Label->list))
			return false;

		if(fd->Value->op!=Value->op)
			return false;
		
		if(!IsSubSet(&fd->Value->list,&Value->list))			
			return false;

		if(!IsSubSet(&Value->list,&fd->Value->list))			
			return false;		
		
		return true;
	}

	CFDescription*GetClone()
	{
		CFDescription*fdesc=new CFDescription();		

		if(!fdesc)
			return NULL;
		
		fdesc->Operator=Operator;
		
		fdesc->Label=NULL;
		fdesc->Value=NULL;
				
		if(Label)			
			fdesc->Label=Label->GetClone();

		if(Value)			
			fdesc->Value=Value->GetClone();

		return fdesc;
	}
	    
  
	wstring GetFDescriptionString(void)
	{
		wstring wstr=L"";
		
		if(Label)
			wstr+=Label->GetFDExpressionString();
		else
			wstr+=L"NULL";

		wstr+=Operator;

		if(Value)
			wstr+=Value->GetFDExpressionString();
		else
			wstr+=L"NULL";

		return wstr;
	}
};

#endif /* CFDESCRIPTION_H_HEADER_INCLUDED_BF670866 */
