#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CFStructure.h"
#include "CChart.h"
/*#include ".\cfstructure.h" REMOVED IN THIS (LINUX) VERSION*/


int CFStructure::counter=0;
list<CFStructure*> CFStructure::GarbageCollector;

CFStructure* CFStructure::GetClone()
{
	CFStructure*temp=new CFStructure(NULL,1.0);

	if(!temp)
		return NULL;
	
	if(this->Root!=NULL)
		temp->Root=Root->GetClone();
	else
		temp->Root=Root;

	return temp;
}


CFStructure * CFStructure::GetCloneSpecial(CFStructureItem*old)
{
	CFStructure * temp=new CFStructure();	

	if(!temp)
		return NULL;

	temp->Root=Root->GetCloneEx(old,&temp->CurrentPtr);

	return temp;
}

CFStructure * CFStructure::GetCloneSpecialEx(CFStructureItem*old, 
											 stack<CFStructureItem*> * OldTargetPtrStk,
											 stack<CFStructureItem*> * NewTargetPtrStk)
{
	
	using namespace std;

	stack<CFStructureItem*> temp_stk1=*OldTargetPtrStk;

	stack<CFStructureItem*> temp_stk2;

	while(!temp_stk1.empty())
	{
		temp_stk2.push(temp_stk1.top());
		temp_stk1.pop();
	}	

	CFStructure * temp=new CFStructure();
	
	if(!temp)
		return NULL;

	temp->Root=Root->GetCloneEx2(old,&temp->CurrentPtr,&temp_stk2,NewTargetPtrStk);

	return temp;
}

bool CFStructure::AddNewFSItem(CFStructureItem * itm)
{
	if(!itm)
		return false;	

	if(!Root)
	{
		Root=new CFStructureItem();
		
		if(!Root)
			return false;

		Root->Label = -1;
	}
	
	Root->ChildList.push_back(itm->GetClone());		

return true;
}

bool CFStructure::AddNewSetElement(CFStructureItem * itm)
{
	if(!itm)
		return false;	

	if(!Root)
	{
		Root=new CFStructureItem();

		if(!Root)
			return false;

		Root->Label = -1;
	}
	
	Root->SetElements.push_back(itm->GetClone());		

return true;
}

CFStructure::CFStructure(CFStructureItem *itm,double rank)
{

	Root=itm;
	Rank=rank;
	CurrentPtr=Root;
	counter++;

	GarbageCollector.push_back(this);	
}

CFStructureItem * CFStructure::SearchInSet(vector<short>* vlist)
{
	using namespace std;
	
	if(!Root || Root->SetElements.empty())
		return NULL;	

	return Root->SearchInSet(vlist);
}

CFStructureItem * CFStructure::Search(vector<short>* vlist)
{
	using namespace std;

	if(!Root||!vlist)
		return NULL;
	
	return Root->Search(vlist);
}

void CFStructure::SetParentPointers()
{
	SetParentPointersRec(Root);
}

void CFStructure::SetParentPointersRec(CFStructureItem *itm)
{
	if(!itm)
		return;

	CFStructureItem*temp=NULL;
	
	for(vector<CFStructureItem*>::iterator it=itm->ChildList.begin();
		it!=itm->ChildList.end();it++)
	{
		temp=*it;
		temp->SetParent(itm);
		SetParentPointersRec(temp);
	}
	
	for(vector<CFStructureItem*>::iterator it2=itm->SetElements.begin();
		it2!=itm->SetElements.end();it2++)
	{
		temp=*it2;
		temp->SetParent(itm);
		SetParentPointersRec(temp);
	}

	SortFeatures(itm);

}

void CFStructure::SortFeatures(CFStructureItem *itm)
{
	if(!itm)
		return;

	if(!itm->ChildList.empty())
		sort(itm->ChildList.begin(),itm->ChildList.end(),sortfunc);
		
	if(!itm->SetElements.empty())
		sort(itm->SetElements.begin(),itm->SetElements.end(),sortfunc);
	
}

void CFStructure::AdjustSetElements(short set_id)
{
	AdjustSetElementsRec(Root,set_id);
}

void CFStructure::AdjustSetElementsRec(CFStructureItem *itm,short set_id)
{
	if(!itm)
		return;

	CFStructureItem * Set=NULL;
	CFStructureItem * Element=NULL;			

	if(itm->SetElements.size()!=0)
	{
		Set=new CFStructureItem(set_id);
		
		if(!Set)
			return;

		Set->SetParent(itm);				
		
		for(vector<CFStructureItem*>::iterator it2=itm->SetElements.begin();
			it2!=itm->SetElements.end();it2++)
		{
			Element=*it2;
			Element->SetParent(Set);
			Set->ChildList.push_back(Element);			
			//AdjustSetElementsRec(Element,set_id);
		}
		
		itm->ChildList.push_back(Set);
		
		itm->SetElements.erase(itm->SetElements.begin(),itm->SetElements.end());
	}
	
	for(vector<CFStructureItem*>::iterator it=itm->ChildList.begin(); it!=itm->ChildList.end();it++)
		AdjustSetElementsRec(*it,set_id);

}

void CFStructure::CollectGarbage()
{	
	CFStructure*fs=NULL;
	
	try
	{
		for(list<CFStructure*>::iterator it=GarbageCollector.begin();
			it!=GarbageCollector.end();it++)
		{
			fs=*it;
			try
			{
				delete fs;
			}
			catch(...)
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"error on deleting f-structure \r\n");
				#endif
			}
		}
	
		GarbageCollector.clear();	
	}
	catch(...)
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"Error on Clearing CFStructure::GC\r\n");
		#endif
	}	
}

bool CFStructure::IsEqual(CFStructure* fsptr)
{
	if(!fsptr)
		return false;

	if(fsptr->Root==NULL && Root==NULL)
		return true;

	if(!fsptr->Root || !Root)
		return true;

	if(!Root->IsEqual(fsptr->Root))
		return false;

	return true;
}

//by huma
bool CFStructure::insertCommon(hash_map<wstring,list<CFDescription*>*>* common)
{
	if(Root)	
		return Root->insertCommon(common);
	
	return false;
}
