#include "stdafx.h"
#pragma warning(disable: 4786)


#ifndef CFSTRUCTURE_H_HEADER_INCLUDED_BF6740B7
#define CFSTRUCTURE_H_HEADER_INCLUDED_BF6740B7

#include "CFStructureItem.h"
#include "CFDescription.h"

#include <algorithm>
#include <map>
#include <list>

using namespace std;

//##ModelId=406273A601B2
//##Documentation
//## It is the data structure that contains the information of  Functional
//## Structure (F-Structure) of  a sentence.
class CFStructure
{

 friend bool sortfunc(CFStructureItem*itm1,CFStructureItem*itm2)
 {
	if(!itm1 || !itm2)
		return false;
	
	return itm1->Label<itm2->Label;
 }
 
 void SortFeatures(CFStructureItem *itm);

 private:

	void AdjustSetElements(short set_id);
	void AdjustSetElementsRec(CFStructureItem *itm,short set_id);

 public:   	 
	 static void CollectGarbage();
	 
	 bool insertCommon(hash_map<wstring,list<CFDescription*>*>* common);
	 
	 static int counter;	 
	 static list<CFStructure*> GarbageCollector;

	 void SetParentPointers();
	 	 
	 CFStructure * GetCloneSpecial(CFStructureItem*old);

	 CFStructure * GetCloneSpecialEx(CFStructureItem*old, 
									 stack<CFStructureItem*> * OldTargetPtrStk,
									 stack<CFStructureItem*> * NewTargetPtrStk);	 
	 CFStructure()
	 {		
		Root=NULL;
		CurrentPtr=NULL;
		Rank=1.0;
		
		counter++;

		try
		{
			GarbageCollector.push_back(this);
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L" F-Structure could not be saved in GC\r\n");
			#endif
		}
	 }
	 
	 ~CFStructure()
	 {
		Root=NULL;
		CurrentPtr=NULL;
		counter--;				
		//Root (FStructureItem) has its own garbage collector		
	 }

	 //static short FSCounter;

	 CFStructureItem* GetClone(CFStructureItem*fs_item);

	 bool AddNewFDescription(CFDescription*fdesc);
	 CFStructure(CFStructureItem *itm,double Rank);

	 CFStructureItem * Search(vector<short>* vlist);	
	 
	 CFStructureItem * SearchInSet(vector<short>* vlist);

     CFStructureItem * Root;
	 CFStructureItem * CurrentPtr;
      	  
	  bool AddNewFSItem(CFStructureItem*);		
	  bool AddNewSetElement(CFStructureItem * itm);
	  CFStructure* GetClone();
	  double Rank;	  

private:
	void SetParentPointersRec(CFStructureItem*itm);
public:
	bool IsEqual(CFStructure* fsptr);
};


#endif /* CFSTRUCTURE_H_HEADER_INCLUDED_BF6740B7 */
