#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CFStructureItem.h"
#include "CLexicon.h"

#include "global.h"
#include "CFStructureItem.h"

#include "CChart.h"

extern CLogManager LogManager;

int CFStructureItem::counter=0;
int CFStructureItem::LastNodeId=0;

list<CFStructureItem*> CFStructureItem::GarbageCollector;

void CFStructureItem::AppendFSItem(CFStructureItem *fsitem,bool AddToSibling)
{
	if(AddToSibling && fsitem->Parent)
	{
		fsitem->Parent->AppendFSItem(fsitem,false);
		return;
	}
	
	ChildList.push_back(fsitem);	
	fsitem->Parent=this;
}

void CFStructureItem::CollectGarbage()
{	
	CFStructureItem * fsitem=NULL;
	
	try
	{
		for(list<CFStructureItem*>::iterator it=GarbageCollector.begin();
			it!=GarbageCollector.end();it++)
		{
			fsitem=*it;
			try
			{
				delete fsitem;
			}
			catch(...)
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"error on deleting f-structure \r\n");
				#endif
			}
		}
	
		GarbageCollector.clear();	
	}
	catch(...)
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"Error on Clearing CFStructure::GC\r\n");
		#endif
	}	
}

CFStructureItem* CFStructureItem::GetNewFSItem(CFDescription *fdesc,bool assign_value)
{
	CFStructureItem * root_item=NULL;

	if(!fdesc)
		return root_item;

	root_item=new CFStructureItem();

	if(!root_item)
		return root_item;

	CFStructureItem * fs_item=root_item;
	CFStructureItem * temp=NULL;
	short id=0;

	for(unsigned short p=0;p<fdesc->Label->list.size();p++)
	{
		if(p>0)
		{
			temp=new CFStructureItem();
			
			if(!temp)
				continue;

			fs_item->ChildList.push_back(temp);
			fs_item=temp;
		}

		fs_item->Label=fdesc->Label->list.at(p);

	}

	if(fs_item && assign_value)
	{
		fs_item->ValueList=fdesc->Value->list;
		//PrintShortVect(fs_item->ValueList);
	}

return root_item;
}

CFStructureItem * CFStructureItem::SearchInSet(short id)
{
	vector<short>v;
	v.push_back(id);
	return  SearchInSet(&v);	
}

CFStructureItem * CFStructureItem::SearchInSet(vector<short>* vlist)
{
	using namespace std;	

	CFStructureItem*found=NULL;
	CFStructureItem*itm=NULL;

	for(vector<CFStructureItem*>::iterator it=SetElements.begin();
		it!=SetElements.end();it++)
	{
		itm=*it;
		found=itm->Search(vlist);
		if(found)		
			return found;			
	}

return NULL;
}

/*
CFStructureItem * CFStructureItem::Search(vector<short>* vlist, short ind)
{
	using namespace std;

	if(!vlist||ind<0)
		return NULL;

	short vsize=vlist->size();
	
	if(ind>=vsize)
		return NULL;

	CFStructureItem*temp=NULL;
	bool found=false;

	for(vector<CFStructureItem*>::iterator it=ChildList.begin();
		it!=ChildList.end();it++)
	{
		temp=*it;
		if(temp->Label==vlist->at(ind))
		{
			found=true;
			break;
		}
	}

	if(!found)
		return NULL;
	
	if(ind=vsize-1)
		return temp;
	
	return temp->Search(vlist,ind+1);
}
*/

CFStructureItem * CFStructureItem::Search(vector<short>* vlist,bool search_always)
{
	using namespace std;

	//return NULL;

	if(!vlist)
		return NULL;

	short vsize=vlist->size();
	short index=0;
		
	CFStructureItem*temp=NULL;
	CFStructureItem*t=NULL;

	bool found=false;	
	temp=this;

	//while(temp->LDDPointer)
	//	temp=temp->LDDPointer;

	/*
	while(temp->Reference)
	{
		temp->Reference
	}
	*/

	for(unsigned short p=0;temp && p<temp->ChildList.size() && index<vsize;p++)
	{
		t=temp->ChildList.at(p);
		bool isELEMENT = false;
		if(vlist->at(index)== CSymbolTableManager::ElementId)
		{
			wstring temp = CSymbolTableManager::GetString(t->Label);
			if(temp.find(L"ELEMENT") != wstring::npos)
				isELEMENT = true;
		}
		if((isELEMENT || t->Label==vlist->at(index)) && (!(t->IsVisited) || search_always))
		{
			temp=t;
			
			//temp->Reference

			p=-1;
			index++;
		}		
	}	

	if(index==vsize)
	{
		//MessageBox(NULL,L"matched..........",L"",0);
		return temp;
	}
	
	return NULL;	
}

CFStructureItem * CFStructureItem::SearchAndCreate(vector<short>* vlist,char & created)
{
	using namespace std;

	created=0;

	if(!vlist)
		return NULL;

	short vsize=vlist->size();
	if(vsize==3)
	{
		vsize--;
		vsize++;
	}

	short index=0;
		
	CFStructureItem*temp=NULL;
	CFStructureItem*t=NULL;

	bool found=false;	

	temp=this;	
	
	if(temp->Reference)
	{
		temp=GetReferencedNode(temp->Reference);
		if(!temp)
			return NULL;
	}

	//added recently...
	if(temp->GenRef)	
		temp=temp->GenRef;

	for(unsigned short p=0;temp && p<temp->ChildList.size() && index<vsize;p++)
	{
		t=temp->ChildList.at(p);
		if(t->Label==vlist->at(index))
		{
			temp=t;
							
			if(temp->Reference)
			{
				temp=GetReferencedNode(temp->Reference);
				if(!temp)
					return NULL;
			}

			if(temp->GenRef)	
				temp=temp->GenRef;
			
			p=-1;
			index++;
		}		
	}	

	if(index==vsize)
		return temp;
	
	created=1;

	while(index<vsize)
	{
		t=new CFStructureItem();
		
		if(!t)
			continue;

		t->Label=vlist->at(index);
		t->Parent = temp;
		temp->AppendFSItem(t,false);
		temp=t;
		index++;
	}	
	
	return temp;	
}


CFStructureItem * CFStructureItem::SearchEx(short id)
{
	vector<short> vlist;
	vlist.push_back(id);
	
	return Search(&vlist);
}

CFStructureItem* CFStructureItem::GetPurifiedForm(CFStructureItem * fsitem)
{
	using namespace std;

	if(!fsitem)
		return fsitem;
	
	CFStructureItem*ret=new CFStructureItem();		
	
	if(!ret)
		return NULL;

	ret->Label=fsitem->Label;
	ret->ValueList=fsitem->ValueList;
		
	CFStructureItem*fstemp=NULL;
	
	CFStructureItem*fstemp_prev=NULL;
	
	CFStructureItem*temp=NULL;
	
	vector<CFStructureItem*> * elem_set=NULL;
	
	for(unsigned int p=0;p<fsitem->ChildList.size();p++)		
	{
		fstemp=fsitem->ChildList.at(p);
				
		if(fstemp->Label==-1)
		{
			while(fstemp && fstemp->Label==-1)		
			{
				fstemp_prev=fstemp;
				fstemp=fstemp->ChildList.at(0);
				elem_set=&fstemp->SetElements;
			}
			
			if(fstemp)
			{
				ret->AppendFSItem(fstemp,false);						
				
				if(elem_set)
				{
					for(vector<CFStructureItem*>::iterator it=elem_set->begin();it!=elem_set->end();it++)
						ret->SetElements.push_back(*it);

					elem_set=NULL;
				}
				
				if(fstemp_prev)
				{
					fsitem=fstemp_prev;
					p=0;
				}
			}
		}
		else
		{			
			ret->AppendFSItem(fstemp,false);										

			for(vector<CFStructureItem*>::iterator it=fstemp->SetElements.begin();
				it!=fstemp->SetElements.end();it++)
				ret->SetElements.push_back(*it);			
		}
		
	}

return ret;
}

void CFStructureItem::AddElementInSet(CFStructureItem *fsitem)
{
	using namespace std;
		
	/*
	CFStructureItem * req=NULL;
	CFStructureItem * temp=NULL;	
	
	for(vector<CFStructureItem*>::iterator it=SetElements.begin();
		it!=SetElements.end();it++)
	{
		temp=*it;
		
		if(temp->Label == fsitem->Label)
		{
			req=temp;
			break;
		}
	}

	if(req)
	{
		short len=fsitem->ChildList.size();
		for(short q=0;q<len;q++)
			req->AppendFSItem(fsitem->ChildList.at(q),false);
	}
	else
	*/
	
	SetElements.push_back(fsitem);
}

CFStructureItem* CFStructureItem::SearchItemInChilds(short id)
{
	using namespace std;	
	
	CFStructureItem*itm=NULL;

	for(vector<CFStructureItem*>::iterator it=ChildList.begin();
		it!=ChildList.end();it++)
	{
		itm=*it;
		if(itm->Label==id)
			return itm;		
	}

return NULL;	
}
bool CFStructureItem::eraseChild(short id)
{
	using namespace std;	
	
	CFStructureItem*itm=NULL;

	for(vector<CFStructureItem*>::iterator it=ChildList.begin();
		it!=ChildList.end();it++)
	{
		itm=*it;
		if(itm->Label==id)
		{
			ChildList.erase(it);
			return true;		
		}
	}

	return false;	
}
wstring CFStructureItem::GetValueString(CLexicon * lex)
{
	
	using namespace std;	
	
	wstring vstr=L"";

	if(!lex)
		return vstr;

	vector<short>::iterator it=ValueList.begin();

	if(it!=ValueList.end())
	{
		vstr+=CSymbolTableManager::GetString(*it);
		it++;
	}

	for(;it!=ValueList.end();it++)
	{
		vstr+=L",";
		vstr+=CSymbolTableManager::GetString(*it);
	}
	
	return vstr;
}

CFStructureItem* CFStructureItem::GetReferencedNode(short Id)
{
	using namespace std;
	
	CFStructureItem*temp=this;

	while(temp->Parent)
		temp=temp->Parent;

	return temp->GetReferencedNodeRec(Id);	
}

CFStructureItem* CFStructureItem::GetReferencedNodeRec(short Id)
{
	using namespace std;

	if(this->ItemNo==Id)
		return this;
	
	if(this->ChildList.size()==0)
		return NULL;

	CFStructureItem*temp=NULL;

	for(vector<CFStructureItem*>::iterator it=ChildList.begin();	it!=ChildList.end();it++)
	{		
		temp=*it;
		temp=temp->GetReferencedNodeRec(Id);
		if(temp)
			return temp;
	}

	for(vector<CFStructureItem*>::iterator it2=SetElements.begin(); it2!=SetElements.end();it2++)
	{		
		temp=*it2;
		temp=temp->GetReferencedNodeRec(Id);
		if(temp)
			return temp;
	}

	return NULL;
}

bool CFStructureItem::AddNewLink(CFStructureItem* LinkedFSPtr)
{	
	isLinked=true;
	LinkInfoList.push_back(LinkedFSPtr);
	return true;
}

bool CFStructureItem::RemoveLink(CFStructureItem* LinkedFSPtr)
{
	LinkInfoList.remove(LinkedFSPtr);
	return true;
}

bool CFStructureItem::CheckAndUpdateLinkedNodes(void)
{
	if(LinkInfoList.size()==0)
		return true;

	LogManager.AddMessage(L"Checking Linked Nodes....\r\n");
	
	CFStructureItem*node=NULL;

	list<CFStructureItem*>::iterator it=LinkInfoList.begin();
	list<CFStructureItem*>::iterator it_del;

	while(it!=LinkInfoList.end())
	{
		node=*it;								
		//it_del=it;
		it++;
		//LinkInfoList.remove(it_del);				

		if(node->ValueList.size()!=0)			
		{
			if(CChart::IsIntersectionEmpty(&ValueList,&node->ValueList))
				return false;						
		}						
		else
		{
			node->ValueList=ValueList;
		}		
	}

	return true;
}

bool CFStructureItem::UpdateLinkedNodeInfo(map<CFStructureItem*,CFStructureItem*> & MapTable)
{
	CFStructureItem * node=NULL;
	CFStructureItem * temp=NULL;

	if(LinkInfoList.size()!=0)
	{
		list<CFStructureItem*> templist;
		map<CFStructureItem*,CFStructureItem*>::iterator mapit;

		for(list<CFStructureItem*>::iterator fit=LinkInfoList.begin();fit!=LinkInfoList.end();fit++)
		{
			node=*fit;
			mapit=MapTable.find(node);
			
			if(mapit==MapTable.end())
			{
				LogManager.AddMessage(L"Could not find corrosponsing link in MAP table \r\n");
				return false;
				
			}
			
			templist.push_back(mapit->second);			
		}
		
		LinkInfoList=templist;
	}

	for(vector<CFStructureItem*>::iterator cit=ChildList.begin();cit!=ChildList.end();cit++)
	{
		node=*cit;
		if(!node->UpdateLinkedNodeInfo(MapTable))
			return false;
	}

	return true;
}

bool CFStructureItem::UpdateGenRefInfo(map<CFStructureItem*,CFStructureItem*> & MapTable)
{
	//If this code is called for more than once... for the same f-structure
	//then it cannot resolve the already resolved generator references.

	CFStructureItem * node=NULL;
	CFStructureItem * temp=NULL;

	if(IsReferredForGen)
	{
		map<CFStructureItem*,CFStructureItem*>::iterator found=MapTable.find(GenRef);
		
		if(found!=MapTable.end())
		{
			GenRef=found->second;
		}
		else
		{
			//LogManager.AddMessage(L"GenRef Not Found...\r\n");
			//return false;

			//already resolved...
			return true;
		}
	}
	
	for(vector<CFStructureItem*>::iterator cit=ChildList.begin();cit!=ChildList.end();cit++)
	{
		node=*cit;
		node->UpdateGenRefInfo(MapTable);
		//return false;
	}

	return true;
}

bool CFStructureItem::UpdateLinkedNode(void)
{
	if(isLinked)
	{
		if(LinkInfoList.size()==0)
		{
			isLinked=false;
			return true;
		}

		CFStructureItem*fsptr=NULL;
		vector<short> * vlist=NULL;
		
		for(list<CFStructureItem*>::iterator it=LinkInfoList.begin();
			it!=LinkInfoList.end();it++)
		{
			//LogManager.AddMessage(L"@@Linking Nodes...\r\n");

			fsptr=*it;
			
			if(fsptr->ValueList.size()==0)
				fsptr->GenRef = this; // fsptr->ValueList=   ValueList;
			else
			{
				vlist=CChart::GetSetIntersection(&fsptr->ValueList,&ValueList);
				
				if(!vlist)
					return false;

				////fsptr->ValueList=*vlist;
				fsptr->ValueList.clear() ;
				fsptr->GenRef = this;
				
				//////////////////MM//////////////////////////////
				if(vlist)
				{
					vlist->clear();
					delete vlist;
					vlist=NULL;
				}
				//////////////////MM//////////////////////////////

			}
		


			fsptr->RemoveLink(this);
		}		

		LinkInfoList.clear();
	}

	return true;
}

/*
//by huma
bool CFStructureItem::insertCommon(map<wstring,list<CFDescription*>*>* common)
{
	wstring PredValue;

	if (this->Label==CSymbolTableManager:GetNum(L"PRED",false))
	{
		//chk the value of pred "PredValue"
		for(vector<CFStructureItem*>::iterator it1=this->ChildList.begin(); it1!=this->ChildList.end();it1++)
		{
			if((*it1)->Label==CSymbolTableManager::GetNum(L"VALUE",false))
			{
				PredValue=CSymbolTableManager::GetString( (*it1)->ValueList[0] );
			}
		}
		for(vector<CFStructureItem*>::iterator itForGF=this->ChildList.begin(); itForGF!=this->ChildList.end();itForGF++)
		{
			if((*itForGF)->Label==CSymbolTableManager::GetNum(L"GF",false))
			{
				PredValue=TrimString(PredValue);
				PredValue=PredValue.substr(0,PredValue.size()-1);
				PredValue+=L"<";
				for(vector<short>::iterator valIt=(*itForGF)->ValueList.begin();valIt!=(*itForGF)->ValueList.end(); valIt++)
				{
					if(valIt!=(*itForGF)->ValueList.begin())
					{
						PredValue+=L",";
					}
					PredValue+=CSymbolTableManager::GetString(*valIt);
				}
				PredValue+=L">'";
			}
		}

	//	MessageBox(NULL,PredValue.c_str(),L"PRED",MB_OK);
		map<wstring,list<CFDescription*>*>::iterator found=common->find(PredValue);
		if(found!=common->end())
		{
			
            //traverse the common properties
			for(list<CFDescription*>::iterator foundIt=found->second->begin(); foundIt!=found->second->end(); foundIt++)
			{
	//			MessageBox(NULL,CSymbolTableManager::GetString((*foundIt)->Label->list[0]).c_str(),L"common ones",MB_OK);
				char created1=0;
				CFStructureItem*fsitem=NULL;
				CFDescription* fdptr=*foundIt;
			
				fsitem=this->Parent->SearchAndCreate(&fdptr->Label->list,created1);
				if(created1)
				{	
					fsitem->ValueList=fdptr->Value->list;
				}
				else
				{
					vector<short>*result=CChart::GetSetIntersection(&fsitem->ValueList,   &fdptr->Value->list);
					if (!result)
					{
						return false;
					}
					fsitem->ValueList=*result;
				}
			}
		}
	}

	
	//recurse this func for all children and TO DO(set nodes as well??)
	int i=0;

	
	//MessageBox(NULL,CSymbolTableManager::GetString(this->Label).c_str(),L"parent",MB_OK);
	for(vector<CFStructureItem*>::iterator it2=this->ChildList.begin(); it2!=this->ChildList.end();it2++)
	{
	//	MessageBox(NULL,CSymbolTableManager::GetString((*it2)->Label).c_str(),L"child",MB_OK);
		bool a=(*it2)->insertCommon(common);
		it2=this->ChildList.begin();
		for(int j=0;j<i;j++)
		{
			it2++;
		}
		if(a==false)
		{
			return false;
		}
		i++;
	}
	return true;
}*/


//written by huma -  revised by irfan
bool CFStructureItem::insertCommon(	hash_map<wstring,list<CFDescription*>*>* common)
{
	wstring PredValue;

	CFStructureItem * ValFSPtr=NULL;
	CFStructureItem * GFFSPtr=NULL;

	if (this->Label==CSymbolTableManager::PredId)
	{
		ValFSPtr  = this->SearchEx(CSymbolTableManager::ValueId);
		
		if(!ValFSPtr)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Value node not found in pred..");
			#endif

			return false;
		}

		PredValue = CSymbolTableManager::GetString(ValFSPtr->ValueList[0]);

		for(int p=1;p<ValFSPtr->ValueList.size();p++)
			PredValue = PredValue + L" " + CSymbolTableManager::GetString(ValFSPtr->ValueList[p]);
		
		GFFSPtr = this->SearchEx(CSymbolTableManager::GFId);

		if(GFFSPtr) //since GF is optional so if it does not exist then no error will be generated.
		{		
			PredValue=TrimString(PredValue);
			PredValue=PredValue.substr(0,PredValue.size()-1); //removing last single quote?
			PredValue+=L"<";
			
			vector<short>::iterator valIt=GFFSPtr->ValueList.begin();

			if(valIt!=GFFSPtr->ValueList.end())
			{
				PredValue+=CSymbolTableManager::GetString(*valIt);
				valIt++;
			
				for(;valIt!=GFFSPtr->ValueList.end(); valIt++)
				{								
					PredValue+=L",";
					PredValue+=CSymbolTableManager::GetString(*valIt);
				}				
			}

			PredValue+=L">'";			
			PredValue=PredValue.substr(1,PredValue.size()-2);
		}
		else
		{
			PredValue=PredValue.substr(1,PredValue.size()-2);
		}
	
		hash_map<wstring,list<CFDescription*>*>::iterator found=common->find(PredValue);
		vector<short> * result=NULL;

		if(found!=common->end())
		{			
			list<CFDescription*> * fdesc_list_ptr = found->second;
			CFStructureItem*fsitem=NULL;
			CFDescription* fdptr=NULL;
			char created1=0;		

			for(list<CFDescription*>::iterator foundIt=fdesc_list_ptr->begin(); 
				foundIt!=fdesc_list_ptr->end(); foundIt++)
			{
				created1=0;				
				fdptr=*foundIt;
			
				fsitem=this->Parent->SearchAndCreate(&fdptr->Label->list,created1);

				if(created1)
					fsitem->ValueList=fdptr->Value->list;
				else
				{
					result=CChart::GetSetIntersection(&fsitem->ValueList,&fdptr->Value->list);
					
					if (!result)					
						return false;	

					fsitem->ValueList=*result;
					delete result;
					result=NULL;
				}
			}
		}
	}
	
	CFStructureItem * child_fsptr=NULL;		

	for(int child_index=0;child_index<ChildList.size();child_index++)		
	{
		child_fsptr=ChildList[child_index];
		
		child_fsptr->insertCommon(common);
//			return false;
	}

	return true;
}
