#include "stdafx.h"
#pragma warning(disable: 4786)

#ifndef CLEXICALENTRY_H_HEADER_INCLUDED_BF670A59
#define CLEXICALENTRY_H_HEADER_INCLUDED_BF670A59

#include "CFDescription.h"
#include "CSymbolTableManager.h"

#include <string>
#include <vector>
#include <list>

using std::string;
using std::wstring;
using std::vector;
using std::list;

//##ModelId=406262770049
//##Documentation
//## It is the data structure for the Lexical Entry Information

// _STUCTNAME are stuctures made only for dumping

struct _CFDExpression
{	
	unsigned short list[15];
	short size;	
	short op; //up, down, ^, !, v
};

struct _CFDescription
{
	_CFDExpression Label;
	short Operator; // =, =c,$
	_CFDExpression Value;
	
	static int Max;

	static int GetMax()
	{
		return Max;
	}
	void Assign(const CFDescription & fdesc)
	{
			int vindex=0;
			vector<short>::iterator vit;
		
			this->Label.op = fdesc.Label->op ;
			this->Label.size = fdesc.Label->list.size();

			if(fdesc.Label && Max<fdesc.Label->list.size())
			{
				Max = fdesc.Label->list.size();
			}
			if(fdesc.Value && Max<fdesc.Value->list.size())
			{
				Max = fdesc.Value->list.size();
			}

		if(fdesc.Label)
		{
			for(vit=fdesc.Label->list.begin(); vit!=fdesc.Label->list.end();vit++)
			{
				this->Label.list[vindex]=*vit;
				vindex++;
			}
		}

			this->Operator = (char)fdesc.Operator  ;
		if(fdesc.Value)
		{
			this->Value.op = fdesc.Value->op ;
			this->Value.size = fdesc.Value->list.size();

			vindex=0;
		
			for(vit=fdesc.Value->list.begin(); vit!=fdesc.Value->list.end();vit++)
			{
				this->Value.list[vindex]=*vit;
				vindex++;
			}
		}
	}

};

struct _CLexicalEntry
{
	char ConditionListSize;
	char ConstraintListSize;
	_CFDescription ConditionList[10];		
    short ConstraintList[5][100];	
    short POS;    
    short Word[100];    
    short Predicate[50];
};


struct _CLexicalEntry_
{
    short POS;    
    short Predicate;
	short Word;
	short ConditionListSize;
	short ConstraintListSize;
    short ConstraintList[5];	
	_CFDescription ConditionList[10];
};



class CLexicalEntry
{

public:
	
	wstring ToString();

	CLexicalEntry();

	static int counter;

	~CLexicalEntry()
	{
		counter--;
				
		using namespace std;
		
		for(list<CFDescription*>::iterator it=ConditionList.begin();it!=ConditionList.end();it++)
		{
			try{
				delete *it;		
			  }
			catch(...)
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"#### Condition \r\n");
				#endif
			}

		}
		
		ConstraintList.clear();
	}

	void PrintW();
    
    list<CFDescription*> ConditionList;
    list<wstring> ConstraintList;
    
    short POS;
    wstring Word;
    wstring Predicate;
	bool IsCache;

};




#endif /* CLEXICALENTRY_H_HEADER_INCLUDED_BF670A59 */
