#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CLexicon.h"
#include "FileReader.h"
#include "FileWriter.h"
#include "CFDescription.h"
#include "CSentence.h"
#include "global.h"
#include <algorithm>
/*#include ".\clexicon.h"*/

using std::multimap;
using std::wstring;

//map<short,wstring> CLexicon::ConstNameArr; 
//map<wstring,short> CLexicon::ConstList;
//size_t CLexicon::CurrentConstListNumber=0;

bool CopyWSTR(short list[],const wstring & wstr)
{
	size_t tsize=wstr.size();
	
	size_t k;
	for(k=0;k<tsize;k++)
		list[k]=wstr[k];
	
	list[k]=0;

	return true;
}

bool CopyToWSTR(short list[],wstring & wstr)
{
	wstr=L"";	
	
	for(size_t k=0;list[k]!=0;k++)
		wstr+=list[k];		

	return true;
}

/*
CLexicon::CLexicon(string prefix, bool ProvideSearchByPred)
{
		using namespace std;		

		FileNamePrefix=prefix;
		SearchByPred=ProvideSearchByPred;

		string CompileLexicon=CConfiguration::GetConfigInfo("CompileLexicon");			
		string LexiconFileName = CConfiguration::GetConfigInfo(FileNamePrefix+"LexiconFileName");		
		string DumpLexiconFileName = CConfiguration::GetConfigInfo(FileNamePrefix+"LexiconDumpFileName");		
		
		if(CompileLexicon=="yes")
		{
			LoadOrderedFeatures();
			ReadLexicon(LexiconFileName);
			//IdentifyBoundaries(); //was needed to assess maximum size of lexical entry
			DumpLexiconInFile(DumpLexiconFileName);	
			CSymbolTableManager::WriteSymbolTableInFile();
		}
		else
		{
			CSymbolTableManager::ReadSymbolTableFromFile();
			LoadLexiconFromDumpFile(DumpLexiconFileName);				
		}					
}
*/


/*
	New Format New Format
*/

bool CLexicon::DumpLexicalEntriesInArray()
{
	CLexicalEntry* temp;
	FILE * fwriter=fopen(CConfiguration::GetConfigInfo("ULexiconInNumbers").c_str(),"wb");

	int Size=720;
	int ChunkSize=5;

	short* Buffer = new short[Size*ChunkSize];
	
	int Bindex=-1;
	int lexcount=0;

	short count = -2 ;/*ADDED IN THIS (LINUX ONLY) VERSION*/	
	hash_multimap<wstring,CLexicalEntry*>::iterator prevPtr;/*ADDED IN THIS (LINUX ONLY) VERSION*/	
	for(hash_multimap<wstring,CLexicalEntry*>::iterator i=LexiconHashTable.begin();i!=LexiconHashTable.end();i++)
	{		
		/*ADDED IN THIS (LINUX ONLY) VERSION*/	
		count++ ;	//so at any time in loop,cnt will carry i-1 value
		/*ADDED IN THIS (LINUX ONLY) VERSION*/	

		lexcount++;
		if(lexcount==21)
		{
			lexcount=lexcount;
		}
		temp = i->second;
		/*
		2 byte: POS
		2 byte: Predicate
		2 byte: Word
		2 byte: ConditionListSize
		2 byte: ConstraintListSize
		2*5:    Constraints
		10*70:  Conditions
		*/
		
		
		if(Bindex<=Size*(ChunkSize-1))	// if(!Last POrtion)
		{
			Buffer[++Bindex]=temp->POS;
			Buffer[++Bindex]=CSymbolTableManager::GetNum(temp->Predicate);
			Buffer[++Bindex]=CSymbolTableManager::GetNum(temp->Word);
			Buffer[++Bindex]=temp->ConstraintList.size();
			Buffer[++Bindex]=temp->ConditionList.size();

			for(list<wstring>::iterator ci=temp->ConstraintList.begin();ci!=temp->ConstraintList.end();ci++)
			{
				Buffer[++Bindex]= CSymbolTableManager::GetNum(*ci);
			}

			CFDescription* fdesc;

			for(list<CFDescription*>::iterator fdi = temp->ConditionList.begin();fdi!=temp->ConditionList.end();fdi++)
			{
				fdesc = *fdi;

				Buffer[++Bindex]=fdesc->Operator;
				if(fdesc->Value)
				{
					Buffer[++Bindex]=1;    // this is additional 1 is for Value Exists
					Buffer[++Bindex]=fdesc->Value->op;
					Buffer[++Bindex]=fdesc->Value->list.size();

					for(int i=0;i<fdesc->Value->list.size();i++)
					{
						Buffer[++Bindex]=fdesc->Value->list[i];
					}
				}
				else
				{
					Buffer[++Bindex]=0;    // this is additional 0 is for Value DoesNot Exist
				}
				if(fdesc->Label)
				{
					Buffer[++Bindex]=1;    // this is additional 1 is for Value Exists
					Buffer[++Bindex]=fdesc->Label->op;
					Buffer[++Bindex]=fdesc->Label->list.size();

					for(int i=0;i<fdesc->Label->list.size();i++)
					{
						Buffer[++Bindex]=fdesc->Label->list[i];
					}
				}
				else
				{
					Buffer[++Bindex]=0;    // this is additional 0 is for Value DoesNot Exist
				}
			}
		}
		else
		{
			// Write into the file
			// The No of Bytes to write is THe Value of "BIndex"
			lexcount--;
			i = prevPtr ;/*ADDED IN THIS (LINUX ONLY) VERSION*/
			/*i--;REMOVED IN THIS (LINUX ONLY) VERSION*/
			int bytes=fwrite((void*)Buffer,2,(Bindex+1),fwriter);
			Bindex=-1;
		}
		prevPtr=i;/*ADDED IN THIS (LINUX ONLY) VERSION*/


	}//end while

	if(Bindex!=-1)
	{
		// Entering Last Part
		fwrite((void*)Buffer,2,(Bindex+1),fwriter);
	}
			
	fclose(fwriter);
	return true;
}

/*
********************************************
	New Format
********************************************	
*/

bool CLexicon::LoadDumpLexicalEntriesInArray()
{
//	LexiconHashTable.clear();

	CLexicalEntry* temp;
	FILE * freader=fopen(CConfiguration::GetConfigInfo("ULexiconInNumbers").c_str(),"rb");
 	int Size=360;
	int ChunkSize=60;	// previously it was 10
	
	typedef pair <wstring,CLexicalEntry*> StrLexPtrPair;		  

	int bytes_read = 0;

	int Bindex=-1;
	short* Buffer = new short[Size*ChunkSize];
		/*
		2 byte: POS
		2 byte: Predicate
		2 byte: Word
		2 byte: ConditionListSize
		2 byte: ConstraintListSize
		2*5:    Constraints
		10*70:  Conditions
		*/
	CFDescription* fdesc;
	int ConstraintSize=0;
	int ConditionSize=0;
	int i=0;
	int ifValorLab=0;
	int Fdsize=0;
	int FDescSize=0;

////////////////////////////////////////
	int predicate_int=0;
	int Constraint_int=0;

////////////////////////////////////////

	if((bytes_read=fread((void*)Buffer,2,Size*ChunkSize,freader))==0)
	{
		// File Ends
		return false;
	}

	while(1)
	{
		if(LexiconHashTable.size()==44142)
		{
			Bindex=Bindex;
		}
		if(Bindex<=Size*(ChunkSize-1))
		{
			if(Bindex+1==bytes_read && bytes_read !=Size*(ChunkSize))
			{
				break;	// End of Input
			}
			temp = new CLexicalEntry();

			temp->POS = Buffer[++Bindex];
			temp->Predicate = CSymbolTableManager::GetString(Buffer[++Bindex]);
//			predicate_int = Buffer[++Bindex];
			temp->Word = CSymbolTableManager::GetString(Buffer[++Bindex]);
			ConstraintSize=Buffer[++Bindex];
			ConditionSize=Buffer[++Bindex];

			for(i=0;i<ConstraintSize;i++)
			{
//				Constraint_int = Buffer[++Bindex];
				temp->ConstraintList.push_back(CSymbolTableManager::GetString(Buffer[++Bindex]));
			}

///////////////////////////////////
	//		FDescSize = Buffer[++Bindex];
			for(i=0;i<ConditionSize ;i++)
			{
				fdesc = new CFDescription();

				fdesc->Operator=Buffer[++Bindex];
				ifValorLab = Buffer[++Bindex];
				if(ifValorLab)
				{
					fdesc->Value = new CFDExpression();
					fdesc->Value->op=Buffer[++Bindex];
					Fdsize = Buffer[++Bindex];//=fdesc->Value->list.size();

					fdesc->Value->list.resize(Fdsize);
					for(int i=0;i<Fdsize;i++)
					{
					//	fdesc->Value->list.push_back(Buffer[++Bindex]);
						fdesc->Value->list[i]=(Buffer[++Bindex]);
					}
				}
				ifValorLab = Buffer[++Bindex];
				if(ifValorLab)
				{
					fdesc->Label = new CFDExpression();
					fdesc->Label->op=Buffer[++Bindex];
					Fdsize = Buffer[++Bindex];//=fdesc->Value->list.size();

					fdesc->Label->list.resize(Fdsize);
				  	for(int i=0;i<Fdsize;i++)
					{
						fdesc->Label->list[i]=Buffer[++Bindex];
					}
				}
				temp->ConditionList.push_back(fdesc);
			}
		if(temp->Predicate[0]==39) //39 is ASCII for single quote
		{			
			short ind=temp->Predicate.find(L"<");
			if(ind>=0)
				temp->Predicate=temp->Predicate.substr(1,ind-1);
			else
				temp->Predicate=temp->Predicate.substr(1,temp->Predicate.size()-2);
		}
		LexiconHashTable.insert(StrLexPtrPair(temp->Predicate,temp));

		}
		else
		{
			int Seek_Back = Size*(ChunkSize)-Bindex-1;

			fseek(freader,-Seek_Back*2,1);	// Setting the Back 

			// pointer to specific location
			if((bytes_read=fread((void*)Buffer,2,Size*ChunkSize,freader))==0)
			{
				// File Ends
				break;
			}
			Bindex=-1;

		}
		
	}

	return true;
}

bool CLexicon::DumpLexicalEntriesInNumbers()
{
	using namespace std;		
	
	CFileReader FHandler(CConfiguration::GetConfigInfo("ULexiconFileName").c_str(),1024);

	FILE * fwriter=fopen(CConfiguration::GetConfigInfo("ULexiconInNumbers").c_str(),"wb");

	wstring str=L"";

	wstring label=L"";
	wstring value=L"";
	wstring op=L"";

	short bcount=1;

	_CLexicalEntry_ le;		

	short ch;
	bool comp_started=false;
	bool quote_started=false;
	int ci =0;
	int posi=0;
	CFDescription fdesc;
	while((ch=FHandler.GetCurrentChar())!=0)
	{		

		wstring POSName = L"";
		switch(ch)
		{
			case ':':
			
				posi++;
				le.Predicate = -1;
				le.ConditionListSize=0;
				le.ConstraintListSize=0;
		
				str=TrimString(str);
				le.Word=CSymbolTableManager::GetNum(str);
				str=L"";	
				break;

			case '{':
				str+=ch;
				comp_started=true;
				break;
			
			case '\'':
				str+=ch;
				quote_started=!quote_started;
				break;

			case '}':
				str+=ch;
				comp_started=false;
				break;

			case ',':

				if(str==L"")
					break;

				if(comp_started||quote_started)
				{
					str+=ch;
					break;
				}
				value=TrimString(str);
				if(op==L"")	
				{
					le.POS=CSymbolTableManager::GetNum(value,true);
				
					POSName=value;
				}
				else if(op==L"=c")
				{
				
					str=L"[" + label + L" =c " + value+L"]";
					
					le.ConstraintList[le.ConstraintListSize++] =CSymbolTableManager::GetNum(str);

				}
				else
				{					
					if(label==L"^PRED")
					{
						le.Predicate = CSymbolTableManager::GetNum(value);

					}

					fdesc.Label=GenerateFDExpression(label);

					if(op==L"=")
						fdesc.Operator='=';
					else
						fdesc.Operator='$';

					fdesc.Value=GenerateFDExpression(value);

					le.ConditionList[le.ConditionListSize++].Assign(fdesc);

				}
				

				str=L"";
				label=L"";
				value=L"";
				op=L"";
				break;
				
			case '=':
							
				label=TrimString(str);
				str=L"";

				FHandler.MoveNext();	 //find if it is '=c'
				ch=FHandler.GetCurrentChar();

				if(ch=='c') //if it is a constraint				
				{
					op.clear();
					op=L"=c";								
				}
				else
				{	
					op.clear();

					op=L"=";					
					str=ch;//missing one character 				
					if(ch=='{')
						comp_started=true;
					else if(ch=='\'')
						quote_started=true;
				}
				
				break;

			case '.' :

				if(str==L"")
					break;

				value=TrimString(str);
				if(op==L"")
				{
					le.POS=CSymbolTableManager::GetNum(value,true);
					POSName=value;
				}
				else if(op==L"=c")
				{
					str=L"[" + label + L" =c " + value+L"]";
					le.ConstraintList[le.ConstraintListSize++] =CSymbolTableManager::GetNum(str);

				}
				else if(value!=L"")
				{										
					if(label==L"^PRED")
						le.Predicate=CSymbolTableManager::GetNum(value);
		
					if(fdesc.Label!=NULL)
					{
						delete fdesc.Label;
					}
					fdesc.Label=GenerateFDExpression(label);
					
					fdesc.Operator='=';
	
					if(fdesc.Value!=NULL)
					{
						delete fdesc.Value;
					}				
					fdesc.Value=GenerateFDExpression(value);
					
					le.ConditionList[le.ConditionListSize++].Assign(fdesc);


				}				
			//	op.clear();

				str=label=value=op=L"";
				
				if(le.Predicate==-1)
				{
					le.Predicate=CSymbolTableManager::GetNum(POSName);
				}

				DumpLexicalEntryOfNumber(fwriter,&le);
				break;

			case '[':
			case '~':
				
				
				if(ch=='~')
				{
					str=L"~";
					bcount=0;
				}
				else
				{
					str=L"[";								
					bcount=1;
				}

					
				FHandler.MoveNext();

				while(true)
				{	
					
					ch=FHandler.GetCurrentChar();
						
					if(ch=='[')
						bcount++;
					else if(ch==']')
					{
						bcount--;						
						if(bcount==0)
						{
							str+=ch;				
							break;
						}
					}

					str+=ch;				
					FHandler.MoveNext();					
				}

				le.ConstraintList[le.ConstraintListSize++] =CSymbolTableManager::GetNum(str);

				str=L"";
				
				break;

			case LF:
			case CR:			
							
				break;
			
			case '/' :				
				
				while(true)
				{						
					ch=FHandler.GetCurrentChar();
						
					if(ch==LF||ch==CR||ch<=0)
						break;					

					str+=ch;
					FHandler.MoveNext();					
				}

				str=L"";
				break;

			default:		
	
				str+=ch;
			
			}//end switch

			FHandler.MoveNext();

		}//end while
	fclose(fwriter);
	return true;
}

bool CLexicon::DumpLexicalEntryOfNumber(FILE* fwriter, _CLexicalEntry_* le)
{
	if(!fwriter || !le)
		return false;
	
	size_t bytes_written=fwrite((void*)le,1,sizeof(_CLexicalEntry_),fwriter);

	if(bytes_written>0)
		return true;
	
	return false;
}


bool CLexicon::LoadFromNumberDump(const string & file_name)
{
	LexiconHashTable.clear();

	typedef pair<wstring,CLexicalEntry*> WSTR_LE_Pair;

	FILE * freader=fopen(file_name.c_str(),"rb");
	
	if(!freader)
		return false;

	CLexicalEntry*le=NULL;
	
	int bytes_read=0;
	int k=0;
	int m=0;
	
	CFDescription * fdesc=NULL;
	CFDescription * tfdesc=NULL;
	wstring tstr=L"";

	while((bytes_read=fread(&_DumpLexEntry,1,sizeof(_DumpLexEntry),freader))>0)
	{
		
		le=new CLexicalEntry();
		le->POS=_DumpLexEntry.POS;
		
		le->Predicate = CSymbolTableManager::GetString(_DumpLexEntry.Predicate);
		le->Word = CSymbolTableManager::GetString(_DumpLexEntry.Word);
		
		for(k=0;k<_DumpLexEntry.ConstraintListSize;k++)
		{
			tstr = CSymbolTableManager::GetString(_DumpLexEntry.ConstraintList[k]);
			le->ConstraintList.push_back(tstr);
		}
//////////////////////////////////////////////////////////////
////////////////////////___//////////////////////////////////////
//////////////////////////////////////////////////////////////
		for(k=0;k<_DumpLexEntry.ConditionListSize;k++)
		{
			tfdesc=new CFDescription();
			tfdesc->Operator = _DumpLexEntry.ConditionList[k].Operator;

			tfdesc->Label=new CFDExpression();
			tfdesc->Label->op = _DumpLexEntry.ConditionList[k].Label.op;

			for(m=0;m<_DumpLexEntry.ConditionList[k].Label.size;m++)
				tfdesc->Label->list.push_back(_DumpLexEntry.ConditionList[k].Label.list[m]);

			tfdesc->Value=new CFDExpression();
			tfdesc->Value->op=_DumpLexEntry.ConditionList[k].Value.op;

			for(m=0;m<_DumpLexEntry.ConditionList[k].Value.size;m++)
				tfdesc->Value->list.push_back(_DumpLexEntry.ConditionList[k].Value.list[m]);				

			le->ConditionList.push_back(tfdesc);
		}	
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
		SaveLexEntry(le);
		//if(SearchByPred)
		//	LexiconHashTable.insert(WSTR_LE_Pair(le->Predicate,le));
		//else
		//	LexiconHashTable.insert(WSTR_LE_Pair(le->Word,le));
	}
	
	fclose(freader);	

	return true;
}


CLexicon::CLexicon(string prefix, bool ProvideSearchByPred)
{
		using namespace std;		
		
		FileNamePrefix=prefix;
		SearchByPred=ProvideSearchByPred;

		string CompileLexicon=CConfiguration::GetConfigInfo("CompileLexicon",true);			
		string LexiconFileName = CConfiguration::GetConfigInfo(FileNamePrefix+"LexiconFileName");		
		string DumpLexiconFileName = CConfiguration::GetConfigInfo(FileNamePrefix+"LexiconDumpFileName");		
		string CommonLexFeaturesFileName;
		
		//**********************Tahira*************************
		string ExpansionsFileName=CConfiguration::GetConfigInfo("Expansions");
		//**********************Tahira*************************
		
		if(CompileLexicon=="yes")
		{
			LoadOrderedFeatures();

			ReadLexicon(LexiconFileName);
		
			DumpLexicalEntriesInArray();


			//by huma
			if(prefix=="U" && SearchByPred==true)
			{				
                CommonLexicalFeatureTable=GetCommonLexicalFeatureTable();

				CommonLexFeaturesFileName=CConfiguration::GetConfigInfo(FileNamePrefix+"CommonLexFeaturesFileName");
				FILE * fwriter=fopen(CommonLexFeaturesFileName.c_str(),"wb");
				this->WriteCommonLexicalFeaturesInFile(CommonLexicalFeatureTable, fwriter);
				fclose(fwriter);

				FILE* freader=fopen(CommonLexFeaturesFileName.c_str(),"rb");
				CommonLexicalFeatureTable=ReadCommonLexicalFeaturesFromFile(freader);
				fclose(freader);
			}
			else
			{
				CommonLexicalFeatureTable=NULL;
				LoadExpansions(ExpansionsFileName);
			}
			/////////////////////
//			IdentifyBoundaries(); //was needed to assess maximum size of lexical entry

			DumpLexiconInFile(DumpLexiconFileName);	

		}
		else
		{
	
			LoadDumpLexicalEntriesInArray();				
		
			if(prefix=="U" && SearchByPred==true)
			{
				CommonLexFeaturesFileName=CConfiguration::GetConfigInfo(FileNamePrefix+"CommonLexFeaturesFileName");
				FILE* freader=fopen(CommonLexFeaturesFileName.c_str(),"rb");
				CommonLexicalFeatureTable=ReadCommonLexicalFeaturesFromFile(freader);
				fclose(freader);
			}
			else
			{
				CommonLexicalFeatureTable=NULL;			
				LoadExpansions(ExpansionsFileName);
			}
		}					
}


CLexicon::CLexicon(string prefix)
{
		using namespace std;		

		FileNamePrefix=prefix;
	
		LoadOrderedFeatures();
}

CLexicon::~CLexicon()
{
	using namespace std;

	hash_multimap<wstring,CLexicalEntry*>::iterator lex_it = LexiconHashTable.begin();
	
	CLexicalEntry * le=NULL;

	for(; lex_it!=LexiconHashTable.end();lex_it++ )
	{
		le=lex_it->second;

		try
		{
			delete le;
			le=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Lexical Entry could be deleted /or already deleted.....");
			#endif
		}	
	}	

	Expansions->clear();
	delete Expansions;
}


void CLexicon::makestr(CLexicalEntry * lex_ent,unsigned  short lex_ent_str[])
{

	wchar_t t_c = 65535;
	unsigned short t_s = 65535;
	
	//short * lex_ent_str = new short[100];
	int stind = 0;

	//wstring lex_ent_str = L"";
	list<CFDescription*>::iterator fd_it = lex_ent->ConditionList.begin();
	
	while( fd_it != lex_ent->ConditionList.end() )
	{
		CFDescription * curr_fd = *fd_it;
				
		CFDExpression * fd_label = curr_fd->Label;

		vector<short>::iterator fdexlist_it = fd_label->list.begin();
 		while( fdexlist_it != fd_label->list.end() )
		{
			t_s = *fdexlist_it; //got a short
			t_c = t_s;         //converted to a wchar_t
			lex_ent_str[stind++] = t_c;//added to string
			fdexlist_it++;
		}
		
		t_c = 65533; //marking end of vector of shorts

		lex_ent_str[stind++]= t_c;
		
		t_c = fd_label->op;
		lex_ent_str[stind++]= t_c;

		CFDExpression * fd_value = curr_fd->Value;
		fdexlist_it = fd_label->list.begin();
		
		while( fdexlist_it != fd_label->list.end() )
		{
			t_s = *fdexlist_it; //got a short
			t_c = t_s;         //converted to a wchar_t
			lex_ent_str[stind++]= t_c;//added to string
				
			fdexlist_it++;
		}

		t_c = 65533; //marking end of vector of shorts
		lex_ent_str[stind++]= t_c;

		t_c = fd_value->op;
		lex_ent_str[stind++]= t_c;

		t_c = curr_fd->Operator;
		lex_ent_str[stind++]= t_c;

		//t_c = 65534;             //mark end of record
		//lex_ent_str += t_c;

		fd_it++;
	}

	t_c = 65535;             //mark end of record
	lex_ent_str[stind++]= t_c;

	list<wstring>::iterator const_list_it = lex_ent->ConstraintList.begin();
	while( const_list_it != lex_ent->ConstraintList.end() )
	{
		wstring t_s = *const_list_it;
		
		/*t_c = t_s.size();
		lex_ent_str += t_c; //size of string*/
		for(unsigned  int ai =0 ; ai < t_s.length() ; ai++)
			lex_ent_str[stind++]= t_s[ai]; //the actual string

		t_c = 65534;		//the end of string marker
		lex_ent_str[stind++]= t_c;
	}

	t_c = 65535;
	lex_ent_str[stind++]= t_c; //end of constraint list

	t_c = lex_ent->POS;
	lex_ent_str[stind++]= t_c;

	/*t_c = lex_ent->Predicate.size();
	lex_ent_str += t_c;*/
		
	for(unsigned  int ak = 0 ; ak < lex_ent->Predicate.length() ; ak++ )
		lex_ent_str[stind++]= lex_ent->Predicate[ak];

	t_c = 65534;
	lex_ent_str[stind++]= t_c; //end of predicate

	/*t_c = lex_ent->Word.size();
	lex_ent_str += t_c;*/

	for(unsigned  ak = 0 ; ak < lex_ent->Word.length() ; ak++ )
		lex_ent_str[stind++]= lex_ent->Word[ak];

	t_c = '*';
	lex_ent_str[stind++]= t_c; //end of word
		
	t_c = '&';
	lex_ent_str[stind++]= t_c; //end of constraint list

	
//	return lex_ent_str;
}

//##ModelId=406124CE0309
vector<CLexicalEntry*> * CLexicon::GetLexicalEntryList(wstring str)
{
	using namespace std;	
	
	hash_multimap<wstring,CLexicalEntry*>::iterator it=LexiconHashTable.find(str);
	
	vector<CLexicalEntry*>*vlist=NULL;
	CLexicalEntry*le=NULL;

	if(it!=LexiconHashTable.end())
	{
		vlist=new vector<CLexicalEntry*>;

		if(!vlist)
			return NULL;

		short lex_count=LexiconHashTable.count(str);

		for(short k=0;k<lex_count;k++)
		{
			le=it->second;						
			vlist->push_back(le);
			++it;
		}
	}

	return vlist;
}

/*void CLexicon::WriteBinarySTable(string fname)
{
	CSymbolTableManager::WriteSymbolTableInFile(fname);
}

void CLexicon::ReadBinarySTable(string fname)
{
	CSymbolTableManager::ReadSymbolTableFromFile(fname);
}*/
/*
CLexIndex * CLexicon::WriteBinaryLex( string fname, bool IsCache )
{
	using namespace std;

	CLexIndex * LexIndex=NULL;

	multimap<wstring,CLexicalEntry*> * CurrentSrc= NULL;

	int fileposition = 0;

	if ( IsCache )
		CurrentSrc = LexCache;
	else
	{
		LexIndex = new CLexIndex();
		CurrentSrc = LexEntries;
		/////////////////
		//CurrentSrc = LexEntries;
	}
	
	multimap<wstring,CLexicalEntry*>::iterator lex_it = CurrentSrc->begin();
	
	unsigned short t_s = 65535;
	wchar_t t_c = 65535;
	wstring curr_word = L"";

	wstring lex_ent_str = L"";
	
	CFileWriter Bin(fname);

	while(	lex_it != CurrentSrc->end() )
	{
		t_c = 65535;
		
		lex_ent_str = L"";
		curr_word = lex_it->first;
		CLexicalEntry * lex_ent = lex_it->second;
		vector<CFDescription*>::iterator fd_it = lex_ent->ConditionList.begin();

		if( IsCache ) //cache requires key as well
		{
			lex_ent_str += curr_word;
			t_c = 65532;
			lex_ent_str += t_c;
		}
		
		while( fd_it != lex_ent->ConditionList.end() )
		{

			CFDescription * curr_fd = *fd_it;
			
			CFDExpression * fd_label = curr_fd->Label;

			vector<short>::iterator fdexlist_it = fd_label->list.begin();
 
			while( fdexlist_it != fd_label->list.end() )
			{
				t_s = *fdexlist_it;		//got a short
				t_c = t_s;				//converted to a wchar_t
				lex_ent_str += t_c;		//added to string

				fdexlist_it++;
			}

			t_c = 65533; //marking end of vector of shorts
			lex_ent_str += t_c;
			
			t_c = fd_label->op;
			lex_ent_str += t_c;

			CFDExpression * fd_value = curr_fd->Value;

			fdexlist_it = fd_value->list.begin();

			while( fdexlist_it != fd_value->list.end() )
			{
				t_s = *fdexlist_it; //got a short
				t_c = t_s;         //converted to a wchar_t
				lex_ent_str += t_c;//added to string
				
				fdexlist_it++;
			}

			t_c = 65533; //marking end of vector of shorts
			lex_ent_str += t_c;

			t_c = fd_value->op;
			lex_ent_str += t_c;

			t_c = curr_fd->Operator;
			lex_ent_str += t_c;

			fd_it++;
		}

		t_c = 65535;             //mark end of record
		lex_ent_str += t_c;

		vector<wstring>::iterator const_list_it = lex_ent->ConstraintList.begin();
		while( const_list_it != lex_ent->ConstraintList.end() )
		{
			wstring t_s = *const_list_it;
			
			lex_ent_str += t_s; //the actual string

			t_c = 65534;		//the end of string marker
			lex_ent_str += t_c;
			
			const_list_it++;
		}

		t_c = 65535;
		lex_ent_str += t_c; //end of constraint list

		//lex_ent_str += GetConstantName( lex_ent->POS );
		lex_ent_str += CSymbolTableManager::GetString(lex_ent->POS);

		t_c = 65534;
		lex_ent_str += t_c; //end of POS

		lex_ent_str += lex_ent->Predicate;

		t_c = 65534;
		lex_ent_str += t_c; //end of predicate

		lex_ent_str += lex_ent->Word;

		t_c = 65534;
		lex_ent_str += t_c; //end of word
		
		t_c = 65535;
		lex_ent_str += t_c; //end of constraint list

		if( !IsCache )
		{
			/******************** INDEX BUILDING *************/
		
			/*int ent_ind = Bin.GetFPosition();
			int ent_siz = lex_ent_str.size();
			LexIndex->Add(curr_word, ent_ind ,ent_siz);*/
			
			/******************** INDEX BUILDING ENDS ********/
	/*	}
		else
		{
			t_c = 65532;
			lex_ent_str += t_c;

			lex_ent->IsCache = true;
		}

		Bin.Write(lex_ent_str);

		lex_it++;
	}

	lex_ent_str.erase();

	Bin.CloseFile();

	return LexIndex;
}
*/

/*
CLexicalEntry * CLexicon::ConstructLexEntFromString( wstring src_str )
{
	using namespace std;

	CLexicalEntry * LexEnt = new CLexicalEntry();

	int index = 0;
	wchar_t t_c = 0;
	
	CFDescription* currfd = NULL;

	t_c = src_str[index++];
	
	while( t_c != 65535 )
	{
		currfd = new CFDescription();

		currfd->Label = new CFDExpression();

		while( t_c != 65533 )
		{
			currfd->Label->list.push_back(t_c);
			t_c = src_str[index++];			
		}

		//index++;  //skip 65533

		t_c = src_str[index++]; //it is op
		currfd->Label->op = (char)t_c;

		t_c = src_str[index++]; 

		currfd->Value = new CFDExpression();

		while( t_c != 65533 )
		{
			currfd->Value->list.push_back(t_c);
			t_c = src_str[index++];			
		}

		//index++;  //skip 65533

		t_c = src_str[index++]; //FDExpression->op
		currfd->Value->op = (char)t_c;

		t_c = src_str[index++]; //FDescription->Operator
		currfd->Operator = t_c;

		LexEnt->ConditionList.push_back(currfd);

		t_c = src_str[index++]; //Next
	}

	t_c = src_str[index++];

	wstring curr_word = L"";
	while( t_c != 65535 )
	{
		curr_word = L"";
		while( t_c != 65534 )
		{
			curr_word += t_c;
			t_c = src_str[index++];
		}
		LexEnt->ConstraintList.push_back(curr_word);

		t_c = src_str[index++];
	}

	t_c = src_str[index++];

	curr_word = L"";
	while ( t_c != 65534 )
	{
		curr_word += t_c;
		t_c = src_str[index++];
	}

	LexEnt->POS = CSymbolTableManager::GetNum(curr_word,true);

	t_c = src_str[index++];

	curr_word = L"";
	while( t_c != 65534 )
	{
		curr_word += t_c;
		t_c = src_str[index++];
	}

	LexEnt->Predicate = curr_word;

	t_c = src_str[index++];

	curr_word = L"";
	while( t_c != 65534 )
	{
		curr_word += t_c;
		t_c = src_str[index++];
	}

	LexEnt->Word = curr_word;

	return LexEnt;
}*/

vector<CLexicalEntry*> * CLexicon::GetLexicalEntryListUsingPOS(const wstring & str,
															   const wstring & pos_str,
															   bool & found)
{
	using namespace std;	

	short pos=CSymbolTableManager::GetNum(pos_str,true);
	
	vector<CLexicalEntry*> * vlist=NULL;
	CLexicalEntry*le=NULL;
		
	hash_multimap<wstring,CLexicalEntry*>::iterator it= LexiconHashTable.find(str);
	
	if(it!=LexiconHashTable.end())
	{
		found=true;

		vlist=new vector<CLexicalEntry*>;

		if(!vlist)
			return NULL;

		short lex_count=LexiconHashTable.count(str);

		for(short k=0;k<lex_count;k++,it++)
		{
			le=it->second;
			if(le->POS==pos)
				vlist->push_back(le);
		}
	}

	return vlist;
}

bool CLexicon::ReadLexicon(string UniCodeFilePath)
//read lexicon file and build a list of lexical entries

{		
	using namespace std;		
	
	LexiconHashTable.clear();		
					
	CFileReader FHandler(UniCodeFilePath.c_str(),1024);
	wstring str=L"";

	wstring label=L"";
	wstring value=L"";
	wstring op=L"";
	wstring hash_key = L"";
	wstring POSName = L"";

	short bcount=1;

	CLexicalEntry*le=NULL;		

	short ch;
	bool comp_started=false;
	bool quote_started=false;
	
	while((ch=FHandler.GetCurrentChar())!=0)
	{	
		
		switch(ch)
		{
			case ':':
				
				le=new CLexicalEntry();
				
				if(!le)
					break;

				le->Word=TrimString(str);
				str=L"";	
				//wprintf(L"word:%s\n ",le->Word.c_str());
				break;

			case '{':
				str+=ch;
				comp_started=true;
				break;
			
			case '\'':
				str+=ch;
				quote_started=!quote_started;
				//printf("\nquote=%d\n",quote_started);
				break;

			case '}':
				str+=ch;
				comp_started=false;
				break;

			case ',':

				if(str==L"")
					break;

				if(comp_started||quote_started)
				{
					str+=ch;
					break;
				}
				value=TrimString(str);
				if(op==L"")	
				{
					le->POS=CSymbolTableManager::GetNum(value,true);
					POSName=value;
				}
				else if(op==L"=c")
				{
					//str=label;
					//str= str + L" =c ";
					//str+=value;
					
					str=L"[" + label + L" =c " + value+L"]";

					//wprintf(L"\n%s\n",str.c_str());
					le->ConstraintList.push_back(str);					
				}
				else
				{					
					if(label==L"^PRED")
						le->Predicate=value;
					
					CFDescription*fdesc=new CFDescription();																	
					
					if(!fdesc)
						break;

					fdesc->Label=GenerateFDExpression(label);

					if(op==L"=")
						fdesc->Operator='=';
					else
						fdesc->Operator='$';

					fdesc->Value=GenerateFDExpression(value);

					le->ConditionList.push_back(fdesc);					

					//just for printing					
					//str=label;
					//str=str+L" = ";
					//str+=value;
					//wprintf(L"\n%s\n",str.c_str());
					
				}

				str=label=value=op=L"";

				break;

			case '=':
							
				label=TrimString(str);
				str=L"";

				FHandler.MoveNext();	 //find if it is '=c'
				ch=FHandler.GetCurrentChar();

				if(ch=='c') //if it is a constraint				
					op=L"=c";								
				else
				{					
					op=L"=";					
					str=ch;//missing one character 				
					if(ch=='{')
						comp_started=true;
					else if(ch=='\'')
						quote_started=true;
				}
				
				break;

			case '.' :

				if(str==L"")
					break;

				value=TrimString(str);
				if(op==L"")
				{
					le->POS=CSymbolTableManager::GetNum(value,true);
					POSName=value;
				}
				else if(op==L"=c")
				{
					str=L"[" + label + L" =c " + value+L"]";
					//printf("\n%s\n",str.c_str());
					le->ConstraintList.push_back(str);															
				}
				else if(value!=L"")
				{										
					if(label==L"^PRED")
						le->Predicate=value;
					
					CFDescription*fdesc=new CFDescription();

					if(!fdesc)
						break;

					fdesc->Label=GenerateFDExpression(label);
					fdesc->Operator='=';
					fdesc->Value=GenerateFDExpression(value);

					le->ConditionList.push_back(fdesc);								

					//just for printing
					
					str=label;
					str=str+L" = ";
					str+=value;
					//wprintf(L"\n%s\n",str.c_str());
				}				
				
				str=label=value=op=L"";
				//le_list->push_back(le);					
				//MessageBox(NULL,le->Word.c_str(),L"Lexical Entry",MB_ICONINFORMATION);
				le->IsCache = true;
				
				if(le->Predicate==L"")
					le->Predicate=POSName;

				SaveLexEntry(le);
				
				break;

			case '[':
			case '~':
				
				
				if(ch=='~')
				{
					str=L"~";
					bcount=0;
				}
				else
				{
					str=L"[";								
					bcount=1;
				}

					
				FHandler.MoveNext();

				while(true)
				{	
					
					ch=FHandler.GetCurrentChar();
						
					if(ch=='[')
						bcount++;
					else if(ch==']')
					{
						bcount--;						
						if(bcount==0)
						{
							str+=ch;				
							break;
						}
					}

					str+=ch;				
					FHandler.MoveNext();					
				}
				
				le->ConstraintList.push_back(str);

				//MessageBox(NULL,str.c_str(),L"",MB_OK|MB_ICONINFORMATION);

				str=L"";
				
				break;

			case LF:
			case CR:			
							
				break;
			
			case '/' :				
				
				while(true)
				{						
					ch=FHandler.GetCurrentChar();
						
					if(ch==LF||ch==CR||ch<=0)
						break;					

					str+=ch;
					FHandler.MoveNext();					
				}

				//MessageBox(NULL,str.c_str(),L"\nComment(Lexicon)",MB_ICONINFORMATION);

				str=L"";
				break;

			default:		
	
				str+=ch;
			
			}//end switch
					
			//wprintf(L"%c : %s\n",ch,str.c_str());
			FHandler.MoveNext();

		}//end while

	return true;
}

multimap<wstring,CLexicalEntry*> * CLexicon::StructureFString(wstring LexEntry)
{
	using namespace std;
	
	multimap<wstring,CLexicalEntry*> * le_hash_list=new multimap<wstring,CLexicalEntry*>;

	if(!le_hash_list)
		return NULL;
	
	typedef pair <wstring,CLexicalEntry*> StrLexPtrPair;		

	wstring str=L"";

	wstring label=L"";
	wstring value=L"";
	wstring op=L"";
	unsigned short bcount=1,lexent_counter=0;

	CLexicalEntry*le=NULL;
		
	short ch;
	bool comp_started=false;
	bool quote_started=false;		
	
	while( LexEntry.length() > lexent_counter )
	{		
		ch = LexEntry[lexent_counter++];
		switch(ch)
		{
			case ':':
				le=new CLexicalEntry();
				
				if(!le)
					break;

				le->Word=TrimString(str);
				str=L"";	
				//wprintf(L"word:%s\n ",le->Word.c_str());
				break;

			case '{':
				str+=ch;
				comp_started=true;
				break;
			
			case '\'':
				str+=ch;
				quote_started=!quote_started;
				//printf("\nquote=%d\n",quote_started);
				break;

			case '}':
				str+=ch;
				comp_started=false;
				break;

			case ',':

				if(str==L"")
					break;

				if(comp_started||quote_started)
				{
					str+=ch;
					break;
				}
				value=TrimString(str);
				if(op==L"")				
					le->POS=CSymbolTableManager::GetNum(value,true);
				else if(op==L"=c")
				{
					str=L"[" + label + L" =c " + value+L"]";

					le->ConstraintList.push_back(str);					
				}
				else
				{					
					if(label==L"^PRED")
						le->Predicate=value;
					
					CFDescription*fdesc=new CFDescription();																	
					
					if(!fdesc)
						break;	
							
					fdesc->Label=GenerateFDExpression(label);
					if(op==L"=")
						fdesc->Operator='=';
					else
						fdesc->Operator='$';
					fdesc->Value=GenerateFDExpression(value);

					le->ConditionList.push_back(fdesc);					

				}

				str=label=value=op=L"";

				break;

			case '=':
							
				label=TrimString(str);
				str=L"";

				ch=LexEntry[lexent_counter++];

				if(ch=='c') //if it is a constraint				
					op=L"=c";								
				else
				{					
					op=L"=";					
					str=ch;//missing one character 				
					if(ch=='{')
						comp_started=true;
					else if(ch=='\'')
						quote_started=true;
				}
				
				break;

			case '.' :

				if(str==L"")
					break;

				value=TrimString(str);
				if(op==L"")				
					le->POS=CSymbolTableManager::GetNum(value,true);
				else if(op==L"=c")
				{
					str=L"[" + label + L" =c " + value+L"]";
					//printf("\n%s\n",str.c_str());
					le->ConstraintList.push_back(str);															
				}
				else if(value!=L"")
				{										
					if(label==L"^PRED")
						le->Predicate=value;
					
					CFDescription*fdesc=new CFDescription();
					
					if(!fdesc)
						break;

					fdesc->Label=GenerateFDExpression(label);
					fdesc->Operator='=';
					fdesc->Value=GenerateFDExpression(value);

					le->ConditionList.push_back(fdesc);								

					//just for printing
					
					str=label;
					str=str+L" = ";
					str+=value;
					//wprintf(L"\n%s\n",str.c_str());					

				}				
				
				str=label=value=op=L"";
				//le_list->push_back(le);					
				//MessageBox(NULL,le->Word.c_str(),L"Lexical Entry",MB_ICONINFORMATION);
								
				SaveLexEntry(le);

				le_hash_list->insert(StrLexPtrPair(le->Word,le));
				
				break;

			case '[':
			case '~':
				
				
				if(ch=='~')
				{
					str=L"~";								
					bcount=0;
				}
				else
				{
					str=L"[";								
					bcount=1;
				}

					
				while(true)
				{	
					
					ch=LexEntry[lexent_counter++];
						
					if(ch=='[')
						bcount++;
					else if(ch==']')
					{
						bcount--;						
						if(bcount==0)
						{
							str+=ch;				
							break;
						}
					}

					str+=ch;					
				}
				
				le->ConstraintList.push_back(str);

				//MessageBox(NULL,str.c_str(),L"",MB_OK|MB_ICONINFORMATION);

				str=L"";
				
				break;

			case LF:
			case CR:			
							
				break;
			
			case '/' :				
				
				while(true)
				{						
					ch=LexEntry[lexent_counter++];
						
					if(ch==LF||ch==CR||ch<=0||lexent_counter>=LexEntry.length())
						break;					

					str+=ch;				
				}

				str=L"";
				break;

			default:		
	
				str+=ch;
			
			}//end switch
					
		}//end while

	return le_hash_list;
}

/*
short CLexicon::GetConstantNumber(wstring str,bool InsertIfNotFound)
{
   using namespace std;

   str=TrimString(str);
     
   map <wstring, short> :: const_iterator m1_RcIter;
   short ret=-1;

   if(str==L"")
	   return ret;
   
   typedef pair <wstring,int> SInt_Pair;
   typedef pair <int,wstring> IntS_Pair;
 
   m1_RcIter = ConstList.find(str);

   if (m1_RcIter==ConstList.end() && InsertIfNotFound)
   {		   
		ret=++CurrentConstListNumber;
		ConstList.insert(SInt_Pair(str,ret));
		ConstNameArr.insert(IntS_Pair(CurrentConstListNumber,str)); //changed this statement

		return ret;
   }	
   
   if(m1_RcIter->second>0)	
		ret=m1_RcIter->second;
   
return ret;
}
*/

CFDExpression* CLexicon::GenerateFDExpression(wstring str1)
{
	
	if(str1==L""||str1.size()<=0)
		return NULL;

	
	wstring str=TrimString(str1);

	if(str.size()<=0)
		return NULL;

	short ch=str.at(0);	

	CFDExpression*fdexp=new CFDExpression();

	if(!fdexp)
		return NULL;
	
	if(ch=='^') 	
		fdexp->op='^';
	else if(ch=='!')
		fdexp->op='!';
	else
		fdexp->op='v';	//value

	vector<wstring> * vlist=CSentence::GetLexemeList(str,L"^!{},'<>",false);

	if(vlist)
	{
		short len=vlist->size();
		short num=0;

		for(short k=0;k<len;k++)
		{
			num=CSymbolTableManager::GetNum(vlist->at(k),true);
			fdexp->list.push_back(num);
		}
		
		try{
			delete vlist;
			vlist=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### vlist");
			#endif
		}

	}

return fdexp;
}

CFDExpression* CLexicon::GenerateFDExpressionEx(wstring str1)
{
	
	if(str1==L""||str1.size()<=0)
		return NULL;

	
	wstring str=TrimString(str1);

	if(str.size()<=0)
		return NULL;

	short ch=str.at(0);	
	
	CFDExpression*fdexp=new CFDExpression();

	if(!fdexp)
		return NULL;

	vector<wstring> * vlist=NULL;
	short num=0;

	if(ch=='{'||ch=='\'')
	{
		vlist=CSentence::GetLexemeList(str,L"{}<>,'",false);
		fdexp->op=VALUE_OP;
	}
	else
	{
		ch=str.at(1);		

		fdexp->op=SOURCE_OP;
		
		if(ch==':') 	
		{
			fdexp->op=(char)str.at(0);
			str=str.substr(3);
		}
	
		vlist=CSentence::GetLexemeList(str,L".",false);		
	}
			
	if(vlist)
	{
		for(vector<wstring>::iterator it=vlist->begin();it!=vlist->end();it++)
		{
			num=CSymbolTableManager::GetNum(*it,true);
			fdexp->list.push_back(num);		
		}

		try{
		delete vlist;
		vlist=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### vlist");
			#endif
		}

	}

return fdexp;
}

CFDExpression* CLexicon::GenerateFDExpressionEx2(wstring str1)
{
	
	if(str1==L""||str1.size()<=0)
		return NULL;

	
	wstring str=TrimString(str1);

	if(str.size()<=0)
		return NULL;

	short ch=str.at(0);	
	
	CFDExpression*fdexp=new CFDExpression();

	if(!fdexp)
		return NULL;

	vector<wstring> * vlist=NULL;
	short num=0;

	if(ch=='{'||ch=='\'')
	{
		vlist=CSentence::GetLexemeListSpecial(str,L"{},",false);
		fdexp->op=VALUE_OP;
	}
	else
	{				
		fdexp->op=SOURCE_OP;
		
		if(str.length()>1 && str.at(1)==':') 	
		{
			fdexp->op=(char)str.at(0);
			str=str.substr(3);
		}
	
		vlist=CSentence::GetLexemeList(str,L".",false);		
	}
	
	if(vlist)
	{
		for(vector<wstring>::iterator it=vlist->begin();it!=vlist->end();it++)
		{
			num=CSymbolTableManager::GetNum(*it,true);
			fdexp->list.push_back(num);		
		}
		
		try{
			delete vlist;
			vlist=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### vlist");
			#endif
		}

	}

return fdexp;
}

/*
wstring CLexicon::GetConstantName(short index)
{
	map<short,wstring>::iterator in_it = ConstNameArr.find(index);

	if( in_it != ConstNameArr.end() )
		return in_it->second;
	
	return L"EMPTY";
}
*/

/*
wstring CLexicon::GetConstantNameByList(vector<short> & vlist,wstring separator)
{
	using namespace std;
	short index=0;
	wstring line=L"";
	
	map<short,wstring>::iterator in_it;

	for(vector<short>::iterator it=vlist.begin();it!=vlist.end();)
	{
		index=*it;			
		in_it = ConstNameArr.find(index);		
		line+=in_it->second;

		it++;

		if(it!=vlist.end())		
			line+=separator;		
	}

	if(line!=L"")
		return line;
	
	return L"EMPTY";
}
*/

/*
CLexIndex * CLexicon::ReadBinaryLexIndex( string fname )
{
	CLexIndex * LexIndex = new CLexIndex();
	
	CFileReader Bin(fname.c_str() ,1024);
	unsigned int ind = 0 ;
	unsigned short siz = 0;
	//short t_s = 0;
	wchar_t t_c = 65535 , t_n = 0;
	wstring temp_str = L"";

	t_c = Bin.GetCurrentChar();
	t_n = Bin.MoveNext();
	
	while( t_c  != 0  ||  t_n !=0 )
	{
		ind = t_c;
		ind = ind << 16;
		ind  |= t_n;
		
		t_c = Bin.MoveNext();
		siz = t_c;

  		while( (t_c = Bin.MoveNext()) != 65535 )
			temp_str += t_c;
		
		LexIndex->Add(temp_str,ind,siz);

		temp_str = L"";

		t_c = Bin.MoveNext();
		t_n = Bin.MoveNext();
	}
	return LexIndex;
}

void CLexicon::WriteBinaryLexIndex(string fname , CLexIndex * LexInd)
{
	multimap<wstring,CLexIndexItem*>::iterator index_it = LexInd->Lexicon.begin();

	CFileWriter Bin(fname);

	unsigned short t_s = 65535;
	wchar_t t_c = 65535;

	wstring str_int_ent=L"";

	while( index_it != LexInd->Lexicon.end() )
	{
		CLexIndexItem * curr_ind = index_it->second;
		str_int_ent=L"";
		
		unsigned int temp_int = curr_ind->index;
		temp_int = temp_int >> 16 ;

		t_s = temp_int;
		t_c = t_s;
		str_int_ent += t_c;
		
		temp_int = curr_ind->index;
		temp_int = temp_int & 65535;

		t_s = temp_int;
		t_c = t_s;
		str_int_ent += t_c;

		t_s = curr_ind->length;
		t_c = t_s;
		str_int_ent += t_c;

		str_int_ent += curr_ind->word;

		t_s = 65535;
		t_c = t_s;
		
		str_int_ent += t_c;

		Bin.Write(str_int_ent);

		str_int_ent = L"";

		index_it++;
	}

	Bin.CloseFile();
}
*/

/*
bool CLexicon::ConstructCache(string fname)
{
	typedef pair <wstring,CLexicalEntry*> StrLexEnt_Pair;

	string lexbinfname = CConfiguration::GetConfigInfo(FileNamePrefix+"LexiconBinaryFileName");

	CFileReader Cachelist(512);

	CFileReader LexReader( lexbinfname.c_str() , 1024 );

	CLexicalEntry * lex_ent = NULL;

	multimap<wstring,CLexIndexItem*>::iterator ind_it = NULL;

	CLexIndexItem * currIItem = NULL;

	wstring flat_lex_ent = L"";

	wstring ccontent = Cachelist.ReadAll(fname);

	short ind_count;

	if( ccontent == L"" )
		return false;

	unsigned int index = 0;
	
	wstring temp_str = L"";

	while( index < ccontent.length() ) 
	{
		if( ccontent[index] == ',' || ccontent[index] == 0x060c || ccontent[index] == '.' || ccontent[index] == 0x06d4  ) //one word constructed //0x06d4 is urdu fullstop
		{
			if( temp_str != L"" ) //check for nullability
			{
				ind_it = LexiconIndex->Lexicon.find(temp_str);

				if( ind_it != LexiconIndex->Lexicon.end() )
				{
					ind_count=LexiconIndex->Lexicon.count(temp_str);
		
					for(short k=0;k<ind_count;k++)
					{
						currIItem = ind_it->second;
						
						flat_lex_ent = LexReader.Read( currIItem->index , currIItem->length );

						lex_ent = ConstructLexEntFromString( flat_lex_ent );
				///////////////////////////////
						LexCache->insert( StrLexEnt_Pair(temp_str,lex_ent) );
	
						ind_it++;
					}
				}
				
				temp_str = L"";
			}

			if( ccontent[index] == '.' || ccontent[index] == 0x06d4 )
				break;
		}
		else
			temp_str += ccontent[index];

		index++;
	}

	return true;
}



void CLexicon::LoadCache(string fname)
{
	typedef pair<wstring,CLexicalEntry*> StrLexEnt_Pair;

	CFileReader CacheR(512);

	CLexicalEntry * lex_ent = NULL;
	
	wstring rawcache = CacheR.ReadAll(fname);
	wstring str_lex_ent = L"";
	wstring str_key = L"";

	unsigned int rindex = 0;

	while( rindex < rawcache.length() )
	{
		while( rawcache[rindex] != 65532 )
		{
			str_key += rawcache[rindex];
			rindex++;
		}

		rindex++;

		while( rawcache[rindex] != 65532 )
		{
			str_lex_ent += rawcache[rindex];
			rindex++;
		}
		if( str_lex_ent != L""  && str_key != L"" )
		{
			lex_ent = ConstructLexEntFromString( str_lex_ent );
		//////////////////////
			LexCache->insert( StrLexEnt_Pair(str_key,lex_ent) );
		}

		str_key = L"";
		str_lex_ent = L"";

		rindex++;
	}
}*/

/*
bool CLexicon::CheckSymbolTableConsistency(string log_fname)
{
 
   using namespace std;
   bool ret=false;   
     
   map <wstring, short> :: const_iterator m1_RcIter;      
      
   vector<wstring> wlist;

   for(map<wstring,short>::iterator it=ConstList.begin();it!=ConstList.end();it++)
   {
		wlist.push_back(it->first);
   } 

   sort(wlist.begin(),wlist.end());

   CFileWriter fw(log_fname);
   
   wstring str1=L"";
   wstring str2=L"";
   wstring str_lower1=L"";
   wstring str_lower2=L"";

   for(vector<wstring>::iterator it2=wlist.begin();it2!=wlist.end();it2++)
   {
		str1=*it2;
		str_lower1=ConvertToLower(str1);		
		
		it2++;

		fw.Write(str1);

		for(vector<wstring>::iterator it3=it2;it3!=wlist.end();it3++)
		{
			str2=*it3;
			str_lower2=ConvertToLower(str2);		
			
			if(str_lower1!=str_lower2)
				break;
			
			fw.Write(L" : "+str2);
			
		}	

		fw.Write(L"\r\n");
		it2--;
   }

   fw.CloseFile();
    
return ret;

}
*/

bool CLexicon::SaveLexEntry(CLexicalEntry* le)
{
	if(!le)
		return false;	

	typedef pair <wstring,CLexicalEntry*> StrLexPtrPair;

	if(SearchByPred)
	{	
		///////////////////////////
		//updated on july 20, 2005
		///////////////////////////
		//Saving word only in key e.g. for
		//'URR<SUBJ>' key will be URR only without quotes.

		wstring keystr=le->Predicate;
		
		if(keystr[0]==39) //39 is ASCII for single quote
		{
			short ind=keystr.find(L"<");
			if(ind>=0)
				keystr=keystr.substr(1,ind-1);
			else
				keystr=keystr.substr(1,keystr.size()-2);
		}

		///////////////////////////
		LexiconHashTable.insert(StrLexPtrPair(keystr,le));
	}
	else
	{
		wstring	hash_key = CutOnSpace(le->Word);
		LexiconHashTable.insert(StrLexPtrPair(hash_key,le));
	}

	return true;
}

bool CLexicon::IdentifyBoundaries(void)
{
	/***	The function is made to check the boundaries of 
			dynamic objects for fixed size structure dumping ****/

	hash_multimap<wstring,CLexicalEntry*>::iterator it=LexiconHashTable.begin();

	///////////////////////////////////
	size_t MaxConditionListSize=0;
	size_t MaxLabelListSize=0;
	size_t MaxValueListSize=0;
	size_t MaxConstraintListSize=0;
	size_t MaxConstraintStringSize=0;
	size_t MaxWordLen=0;
	size_t MaxPredicateLen=0;

	//////////////////////////////////

	CLexicalEntry*le=NULL;
	CFDescription*fdesc=NULL;
	wstring constraint=L"";

	//////////////////////////////////

	for(;it!=LexiconHashTable.end();it++)
	{
		le=it->second;

		if(MaxConditionListSize < le->ConditionList.size())
			MaxConditionListSize=le->ConditionList.size();

		for(list<CFDescription*>::iterator it2= le->ConditionList.begin();
			it2!=le->ConditionList.end();it2++)
		{
			fdesc=*it2;
			
			if(fdesc->Label && MaxLabelListSize < fdesc->Label->list.size())			
				MaxLabelListSize=fdesc->Label->list.size();
			
			if(fdesc->Value && MaxValueListSize < fdesc->Value->list.size())			
				MaxValueListSize = fdesc->Value->list.size();
			
		}

		if(MaxConstraintListSize < le->ConstraintList.size())
			MaxConstraintListSize=le->ConstraintList.size();

		for(list<wstring>::iterator it3=le->ConstraintList.begin(); 
			it3!=le->ConstraintList.end();it3++)
		{
			constraint=*it3;
			if(MaxConstraintStringSize<constraint.size())
				MaxConstraintStringSize = constraint.size();
		}

		if(MaxPredicateLen < le->Predicate.size())
			MaxPredicateLen=le->Predicate.size();

		if(MaxWordLen < le->Word.size())
			MaxWordLen = le->Word.size();

	}
	
	#ifdef GenLog
	CLogManager::AddMessage(L"################ WORD BOUNDARIES ####################");
	CLogManager::AddMessage(L"MaxConditionListSize = "+GetWSTR(MaxConditionListSize));
	CLogManager::AddMessage(L"MaxLabelListSize = "+GetWSTR(MaxLabelListSize));
	CLogManager::AddMessage(L"MaxValueListSize = "+GetWSTR(MaxValueListSize));
	CLogManager::AddMessage(L"MaxConstraintListSize = "+GetWSTR(MaxConstraintListSize));
	CLogManager::AddMessage(L"MaxConstraintStringSize = "+GetWSTR(MaxConstraintStringSize));
	CLogManager::AddMessage(L"MaxWordLen = "+GetWSTR(MaxWordLen));
	CLogManager::AddMessage(L"MaxPredicateLen = "+GetWSTR(MaxPredicateLen));	
	CLogManager::AddMessage(L"#####################################################");
	CLogManager::AddMessage(L"sizeof(_CLexicalEntry) = "+GetWSTR(sizeof(_CLexicalEntry)));	
	CLogManager::AddMessage(L"#####################################################");
	#endif

	return true;
}

bool CLexicon::DumpLexiconInFile(const string & file_name)
								 
{
  	if(LexiconHashTable.size()==0)
		return false;

	FILE * fwriter=fopen(file_name.c_str(),"wb");
	
	if(!fwriter)
		return false;

	CLexicalEntry*le=NULL;

	for(hash_multimap<wstring,CLexicalEntry*>::iterator it=LexiconHashTable.begin();it!=LexiconHashTable.end();it++)
	{
		le=it->second;
		DumpLexicalEntryInFile(fwriter,le);
		fflush(fwriter);
	}

	fclose(fwriter);	

	return true;
}
bool CLexicon::LoadLexiconFromDumpFile(const string & file_name)
{
	LexiconHashTable.clear();

	typedef pair<wstring,CLexicalEntry*> WSTR_LE_Pair;

	FILE * freader=fopen(file_name.c_str(),"rb");
	
	if(!freader)
		return false;

	CLexicalEntry*le=NULL;
	
	int bytes_read=0;
	int k=0;
	int m=0;
	
	CFDescription * fdesc=NULL;
	CFDescription * tfdesc=NULL;
	wstring tstr=L"";

	while((bytes_read=fread(&DumpLexEntry,1,sizeof(DumpLexEntry),freader))>0)
	{
		le=new CLexicalEntry();
		le->POS=DumpLexEntry.POS;
		
		CopyToWSTR(DumpLexEntry.Predicate,le->Predicate);		
		CopyToWSTR(DumpLexEntry.Word,le->Word);
		
		for(k=0;k<DumpLexEntry.ConstraintListSize;k++)
		{
			CopyToWSTR(DumpLexEntry.ConstraintList[k],tstr);
			le->ConstraintList.push_back(tstr);
		}

		for(k=0;k<DumpLexEntry.ConditionListSize;k++)
		{
			tfdesc=new CFDescription();
			tfdesc->Operator = DumpLexEntry.ConditionList[k].Operator;
			
			tfdesc->Label=new CFDExpression();
			tfdesc->Label->op = DumpLexEntry.ConditionList[k].Label.op;

			for(m=0;m<DumpLexEntry.ConditionList[k].Label.size;m++)
				tfdesc->Label->list.push_back(DumpLexEntry.ConditionList[k].Label.list[m]);
			
			tfdesc->Value=new CFDExpression();
			tfdesc->Value->op=DumpLexEntry.ConditionList[k].Value.op;

			for(m=0;m<DumpLexEntry.ConditionList[k].Value.size;m++)
				tfdesc->Value->list.push_back(DumpLexEntry.ConditionList[k].Value.list[m]);				
			
			le->ConditionList.push_back(tfdesc);
		}	

		SaveLexEntry(le);
		//if(SearchByPred)
		//	LexiconHashTable.insert(WSTR_LE_Pair(le->Predicate,le));
		//else
		//	LexiconHashTable.insert(WSTR_LE_Pair(le->Word,le));
	}
	
	fclose(freader);	

	return true;
}



//8***********************************************************8//
bool CLexicon::DumpLexiconInFileV2(const string & file_name)
								 
{
  	if(LexiconHashTable.size()==0)
		return false;

	FILE * fwriter=fopen(file_name.c_str(),"wb");
	
	if(!fwriter)
		return false;

//	CLexicalEntry*le=NULL;

	for(hash_multimap<wstring,CLexicalEntry*>::iterator it=LexiconHashTable.begin();it!=LexiconHashTable.end();it++)
	{
//		le=it->second;
		DumpLexicalEntryInFileInMyStyle(fwriter,it->second);
//		DumpLexicalEntryInFileInMyStyle(fwriter,le);
		fflush(fwriter);
	}

	fclose(fwriter);	

	return true;
}



bool CLexicon::LoadLexiconFromDumpFileV2(const string & file_name)
{
/*	LexiconHashTable.clear();

	typedef pair<wstring,CLexicalEntry*> WSTR_LE_Pair;

	FILE * freader=fopen(file_name.c_str(),"rb");
	
	if(!freader)
		return false;

	CLexicalEntry*le=NULL;
	
	int bytes_read=0;
	int k=0;
	int m=0;
	
	CFDescription * fdesc=NULL;
	CFDescription * tfdesc=NULL;
	wstring tstr=L"";

	while((bytes_read=fread(&_DumpLexEntry,1,sizeof(_DumpLexEntry),freader))>0)
	{
		le=new CLexicalEntry();
		le->POS=_DumpLexEntry.POS;
		
		le->Predicate = CSymbolTableManager::GetString(_DumpLexEntry.Predicate);
		le->Word = CSymbolTableManager::GetString(_DumpLexEntry.Word);
		for(k=0;k<_DumpLexEntry.ConstraintListSize;k++)
		{
//			CopyToWSTR(_DumpLexEntry.ConstraintList[k],tstr);
			
			tstr = CSymbolTableManager::GetString(_DumpLexEntry.ConstraintList[k]);
			le->ConstraintList.push_back(tstr);
		}

		for(k=0;k<_DumpLexEntry.ConditionListSize;k++)
		{
			tfdesc=new CFDescription();
			tfdesc->Operator = _DumpLexEntry.ConditionList[k].Operator;
			
			tfdesc->Label=new CFDExpression();
			tfdesc->Label->op = _DumpLexEntry.ConditionList[k].Label.op;

			for(m=0;m<_DumpLexEntry.ConditionList[k].Label.size;m++)
				tfdesc->Label->list.push_back(_DumpLexEntry.ConditionList[k].Label.list[m]);
			
			tfdesc->Value=new CFDExpression();
			tfdesc->Value->op=_DumpLexEntry.ConditionList[k].Value.op;

			for(m=0;m<_DumpLexEntry.ConditionList[k].Value.size;m++)
				tfdesc->Value->list.push_back(_DumpLexEntry.ConditionList[k].Value.list[m]);				
			
			le->ConditionList.push_back(tfdesc);
		}	

		SaveLexEntry(le);
		//if(SearchByPred)
		//	LexiconHashTable.insert(WSTR_LE_Pair(le->Predicate,le));
		//else
		//	LexiconHashTable.insert(WSTR_LE_Pair(le->Word,le));
	}
	
	fclose(freader);	
 */
	return true;
}


bool CLexicon::DumpLexicalEntryInFileInMyStyle(FILE* fwriter, CLexicalEntry* le)
{
/*	if(!fwriter || !le)
		return false;
	
	short index=0;
//	wstring constraint;
	
	_DumpLexEntry.ConstraintListSize=le->ConstraintList.size();

	int check;

	for(list<wstring>::iterator it2=le->ConstraintList.begin();
		it2!=le->ConstraintList.end();it2++)
	{
//		constraint=*it2;		
//		CopyWSTR(_DumpLexEntry.ConstraintList[index],constraint);

//		CopyWSTR(_DumpLexEntry.ConstraintList[index],*it2);
		_DumpLexEntry.ConstraintList[index] = CSymbolTableManager::GetNum(*it2,false);
//		check = CSymbolTableManager::GetNum(*it2,false);

		index++;
	}

	index=0;
	CFDescription*fdesc=NULL;		
	_DumpLexEntry.ConditionListSize =le->ConditionList.size();
	int vindex=0;
	
	vector<short>::iterator vit;

	for(list<CFDescription*>::iterator it3=le->ConditionList.begin();
		it3!=le->ConditionList.end();it3++)
	{
		fdesc=*it3;
		
		_DumpLexEntry.ConditionList[index].Label.op = fdesc->Label->op ;
		_DumpLexEntry.ConditionList[index].Label.size = fdesc->Label->list.size();
		
		vindex=0;		
		for(vit=fdesc->Label->list.begin(); vit!=fdesc->Label->list.end();vit++)
		{
			_DumpLexEntry.ConditionList[index].Label.list[vindex]=*vit;
			vindex++;
		}

		_DumpLexEntry.ConditionList[index].Operator = (char)fdesc->Operator  ;

		_DumpLexEntry.ConditionList[index].Value.op = fdesc->Value->op ;
		_DumpLexEntry.ConditionList[index].Value.size = fdesc->Value->list.size();

		vindex=0;
		for(vit=fdesc->Value->list.begin(); vit!=fdesc->Value->list.end();vit++)
		{
			_DumpLexEntry.ConditionList[index].Value.list[vindex]=*vit;
			vindex++;
		}

		index++;		
	}

	_DumpLexEntry.POS = le->POS;
	
	_DumpLexEntry.Predicate = CSymbolTableManager::GetNum(le->Predicate);
	_DumpLexEntry.Word = CSymbolTableManager::GetNum(le->Word);

//	CopyWSTR(_DumpLexEntry.Predicate,le->Predicate);	
//	CopyWSTR(_DumpLexEntry.Word,le->Word);
	

	size_t bytes_written=fwrite(&_DumpLexEntry,1,sizeof(_DumpLexEntry),fwriter);

	if(bytes_written>0)
		return true;
*/	
	return false;
}


//8***********************************************************8//
bool CLexicon::DumpLexicalEntryInFile(FILE* fwriter, CLexicalEntry* le)
{
	if(!fwriter || !le)
		return false;
	
	short index=0;
	wstring constraint;
	
	DumpLexEntry.ConstraintListSize=le->ConstraintList.size();

	for(list<wstring>::iterator it2=le->ConstraintList.begin();
		it2!=le->ConstraintList.end();it2++)
	{
		constraint=*it2;		
		CopyWSTR(DumpLexEntry.ConstraintList[index],constraint);
		index++;
	}

	index=0;
	CFDescription*fdesc=NULL;		
	DumpLexEntry.ConditionListSize =le->ConditionList.size();
	int vindex=0;
	
	vector<short>::iterator vit;

	for(list<CFDescription*>::iterator it3=le->ConditionList.begin();
		it3!=le->ConditionList.end();it3++)
	{
		fdesc=*it3;
		
		DumpLexEntry.ConditionList[index].Label.op = fdesc->Label->op ;
		DumpLexEntry.ConditionList[index].Label.size = fdesc->Label->list.size();
		
		vindex=0;		
		for(vit=fdesc->Label->list.begin(); vit!=fdesc->Label->list.end();vit++)
		{
			DumpLexEntry.ConditionList[index].Label.list[vindex]=*vit;
			vindex++;
		}

		DumpLexEntry.ConditionList[index].Operator = (char)fdesc->Operator  ;

		DumpLexEntry.ConditionList[index].Value.op = fdesc->Value->op ;
		DumpLexEntry.ConditionList[index].Value.size = fdesc->Value->list.size();

		vindex=0;
		for(vit=fdesc->Value->list.begin(); vit!=fdesc->Value->list.end();vit++)
		{
			DumpLexEntry.ConditionList[index].Value.list[vindex]=*vit;
			vindex++;
		}

		index++;		
	}

	DumpLexEntry.POS = le->POS;
	
	CopyWSTR(DumpLexEntry.Predicate,le->Predicate);	
	CopyWSTR(DumpLexEntry.Word,le->Word);
	
	size_t bytes_written=fwrite(&DumpLexEntry,1,sizeof(_CLexicalEntry),fwriter);

	if(bytes_written>0)
		return true;
	
	return false;
}

bool CLexicon::LoadOrderedFeatures()
{
		string orderedfeaturefname = CConfiguration::GetConfigInfo(FileNamePrefix+"OrderedFeatureListFileName");
		
		CFileReader fr(256);		
		short id=-1;
		wstring all=fr.ReadAll(orderedfeaturefname);		
		fr.CloseFile();

		vector<wstring> * vlist = CSentence::GetLexemeList(all,L",",false);	

		if(vlist && !vlist->empty())
		{
			for(vector<wstring>::iterator it=vlist->begin();it!=vlist->end();it++)
			{		
				id=CSymbolTableManager::GetNum(*it,true);				
			}
		}

		if(vlist)
		{
			try{
				delete vlist;
				vlist=NULL;
			}
			catch(...)
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"Ordered feature.....exception raised on deletion.");
				#endif
				return false;
			}
		}
	
	return true;
}

//droorat copy-paste ki mother hay
vector<short>* CLexicon::GetSetIntersection(vector<short> * list1, vector<short> * list2)
{
	if(!list1||!list2)
		return NULL;	

	short len1= list1->size();
	short len2= list2->size();

	vector<short>*list3=new vector<short>;

	if(!list3)
		return NULL;

	short val;
	short val2;
	
	if(len1==0)
	{
		*list3=*list2;
		return list3;
	}

	for(short k=0;k<len2;k++)
	{		
		val=list2->at(k);								
		
		for(short p=0;p<len1;p++)	
		{			
			val2=list1->at(p);									

			if(val==val2)
				list3->push_back(val);	
		}
	}

	if(list3->size()==0)
	{
		try{
			delete list3;
			list3=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### list3");
			#endif
		}

		return NULL;
	}
			
	return list3;
}
//END droorat copy-paste ki mother hay

//by huma
hash_map<wstring,list<CFDescription*>*> *  CLexicon::GetCommonLexicalFeatureTable()
{
     //   CFileWriter fr("humatrial.txt");
        vector<list<CFDescription*>* > common; // to store the common features
		hash_map<wstring,list<CFDescription*>*> * final= new hash_map<wstring,list<CFDescription*>*>;
        hash_multimap<wstring,CLexicalEntry*>::iterator itr;
		itr=LexiconHashTable.begin();
		wstring currPred=itr->first;
		vector<CFDescription *> currPrGF;//=NULL;

		//For the time being
		vector<short> SubCatFrameList;
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"SUBJ"));
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"OBJ"));
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"OBJ2"));
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"OBL"));
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"XCOMP"));
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"COMP"));
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"PREDLINK"));
		SubCatFrameList.push_back(CSymbolTableManager::GetNum(L"DPRED"));
		//END For the time being

		int GFnum=0;
		common.resize(1);
		common[0]=new list<CFDescription*>;
		list<CFDescription*>::iterator fdesIt=itr->second->ConditionList.begin();
		while( fdesIt!=itr->second->ConditionList.end())
		{
			if((*fdesIt)->Label->list[0]!=CSymbolTableManager::PredId)
			{
				common[GFnum]->push_back((*fdesIt)->GetClone());
			}
			else if( GetSetIntersection( &SubCatFrameList,&(*fdesIt)->Value->list ) )//(*fdesIt)->Value->list.size()>1)
			{
				currPrGF.push_back(*fdesIt);
			}
			fdesIt++;
		}
		itr++;
        while(itr != LexiconHashTable.end())
        {
			if(currPred!=itr->first)// || (itr->second->ConditionList.begin()==itr->second->ConditionList.end() || !(currPrGF && currPrGF->isEqual(*(itr->second->ConditionList.begin()))))  )
			{
				// add (currPred,common) to final if there is atleast one entry in common
				for(int gf=0;gf<=GFnum;gf++)
				{
					if(common[gf]->size()>0)
					{
						wstring tempPred=currPred;
						if(currPrGF.size()>0 && currPrGF[gf] && currPrGF[gf]->Value->list.size()>1)
						{
							currPred+=L"<";
							currPred+=CSymbolTableManager::GetString(currPrGF[gf]->Value->list[1]);
							for(int x=2;x<currPrGF[gf]->Value->list.size();x++)
							{
								currPred+=L",";
								currPred+=CSymbolTableManager::GetString(currPrGF[gf]->Value->list[x]);
							}
							currPred+=L">";
						}
						final->insert(map<wstring,list<CFDescription*>*>::value_type(currPred,common[gf]));
						currPred=tempPred;
					}
				}
	//			fr.Write(currPred);
	//		    fr.Write(L"\r\n");
				currPred=itr->first;
				currPrGF.clear();//=NULL;

				//add all in itr->second to common

				common.clear();
				common.resize(1);
				common[0]=new list<CFDescription*>;
				GFnum=0;
				list<CFDescription*>::iterator fdesIt=itr->second->ConditionList.begin();
				while( fdesIt!=itr->second->ConditionList.end())
				{
					if((*fdesIt)->Label->list[0]!=CSymbolTableManager::PredId)
					{
						common[GFnum]->push_back((*fdesIt)->GetClone());
					}
					else if( GetSetIntersection( &SubCatFrameList,&(*fdesIt)->Value->list ) )//(*fdesIt)->Value->list.size()>1)
					{
						currPrGF.push_back(*fdesIt);
					}
					fdesIt++;
				}
			}
			else
			{
				// !(currPrGF && currPrGF->isEqual(*(itr->second->ConditionList.begin())
				int listnumber=0;
				if(currPrGF.size()>0)
				{
					int h;
					for(h=0;h<=GFnum;h++)
					{						
						if( ((*(itr->second->ConditionList.begin()))->Value->list.size()==1 && currPrGF[h]==NULL) 
							|| (currPrGF[h] && currPrGF[h]->isEqual(*(itr->second->ConditionList.begin()))) )
						{
							listnumber=h;
							break;
						}
					}
					if(h>GFnum)
					{
						GFnum++;
						currPrGF.push_back(NULL);
						common.push_back(new list<CFDescription*>);
						list<CFDescription*>::iterator fdesIt=itr->second->ConditionList.begin();
						while( fdesIt!=itr->second->ConditionList.end())
						{
							if((*fdesIt)->Label->list[0]!=CSymbolTableManager::PredId)
							{
								common[GFnum]->push_back((*fdesIt)->GetClone());
							}
							else if( GetSetIntersection( &SubCatFrameList, &(*fdesIt)->Value->list ) )//(*fdesIt)->Value->list.size()>1)
							{
								currPrGF[GFnum]=(*fdesIt);
							}
							fdesIt++;
						}

						listnumber=GFnum;
					}
				}

				list<CFDescription*>::iterator fdi=common[listnumber]->begin();
				list<CFDescription*>::iterator lei;
				while(fdi!=common[listnumber]->end())
				{
					bool found=false;
					lei=itr->second->ConditionList.begin();
					while(lei!=itr->second->ConditionList.end()) //get all the Fdescripitions in the currLexical entry one by one
					{
						if(((*lei)->Label->list[0] == (*fdi)->Label->list[0]) && (*fdi)->Label->list[0] == CSymbolTableManager::GetNum(L"SUBJ_CASE"))
						{
							found=true;
							break;
						}
						if((*lei)->isEqual((*fdi)))
						{
							found=true;
							break;
						}
					
						lei++;
					}
					if(!found)
					{
						fdi=common[listnumber]->erase(fdi);
					}
					else if(fdi!=common[listnumber]->end())
					{
						if(!((*lei)->isEqual((*fdi))))
						{
							if((*fdi)->Value->list[0] == CSymbolTableManager::GetNum(L"DAT"))
							{
								if((*lei)->Value->list[0] == CSymbolTableManager::GetNum(L"NOM"))
									(*fdi)->Value->list[0] = CSymbolTableManager::GetNum(L"NOM");
								else
									if((*lei)->Value->list[0] == CSymbolTableManager::GetNum(L"ERG"))
										(*fdi)->Value->list[0] = CSymbolTableManager::GetNum(L"ERG");
							}
						}
						fdi++;
					}
				}
				//find all entries in itr->second and remove the rest from c
			}
			itr++;
		}
		//add (currPred,common) to final

				for(int gf=0;gf<=GFnum;gf++)
				{
					wstring tempPred=currPred;
					if(common[gf]->size()>0)
					{
						if(currPrGF.size()>0 && currPrGF[gf] && currPrGF[gf]->Value->list.size()>1)
						{
							currPred+=L"<";
							currPred+=CSymbolTableManager::GetString(currPrGF[gf]->Value->list[1]);
							for(int x=2;x<currPrGF[gf]->Value->list.size();x++)
							{
								currPred+=L",";
								currPred+=CSymbolTableManager::GetString(currPrGF[gf]->Value->list[x]);
							}
							currPred+=L">";
						}
						final->insert(map<wstring,list<CFDescription*>*>::value_type(currPred,common[gf]));
					}
					currPred=tempPred;
				}

		/*if(common->size()>0)
		{
			if(currPrGF && currPrGF->Value->list.size()>1)
			{
				currPred+=L"<";
				for(int x=1;x<currPrGF->Value->list.size();x++)
					currPred+=CSymbolTableManager::GetString(currPrGF->Value->list[x]);
				currPred+=L">";
			}
			final->insert(map<wstring,list<CFDescription*>*>::value_type(currPred,common));
		}*/
/*
	//	fr.Write(currPred);
	//	fr.Write(L"\r\n");

	//	CFileWriter fr2("humatrial2.txt");
		hash_map<wstring,list<CFDescription*>*>::iterator ii=final->begin();
		while(ii!=final->end())
		{
	//		fr2.Write(ii->first);
			list<CFDescription*>::iterator itt=ii->second->begin();
			while(itt!=ii->second->end())
			{
	//			fr2.Write(CSymbolTableManager::GetString((*itt)->Label->list[0]));
	//			fr2.Write(L"  ");
				itt++;
			}
	//		fr2.Write(L"\r\n");
			ii++;
		}
		*/

        return final;
}

void CLexicon::WriteCommonLexicalFeaturesInFile(hash_map<wstring,list<CFDescription*>*> * comm, 
												FILE* fwriter)
{
    int size=comm->size();
	size_t bytes_written=fwrite(&size,sizeof(size),1,fwriter);

	//CLogManager::AddMessage(L"Lexicon Entries having Common Features:\r\n");

	for(hash_map<wstring,list<CFDescription*>*>::iterator i=comm->begin(); i!=comm->end(); i++)
	{
		CLexicalEntry* e=new CLexicalEntry;
		e->Predicate=i->first;
		e->Word=e->Predicate;
		list<CFDescription*>* sec=i->second;
		e->ConditionList.insert(e->ConditionList.begin(), 
								i->second->begin(), 
								i->second->end());
		
		this->DumpLexicalEntryInFile(fwriter,e);
		
		//CLogManager::AddMessage(e->ToString()+L"\r\n");

		delete e;

	}
}

hash_map<wstring,list<CFDescription*>*> * CLexicon::ReadCommonLexicalFeaturesFromFile(FILE* freader)
{
	hash_map<wstring,list<CFDescription*>*>* com=new hash_map<wstring,list<CFDescription*>*>;
	int size;
	fread(&(size),sizeof(size),1,freader);
	_CLexicalEntry DumpLexEntry;
	list<CFDescription*>* fdList;
	wstring pred;
	CFDescription* tfdesc;
	for(int i=0; i<size; i++)
	{
		int bytes_read=fread(&DumpLexEntry,1,sizeof(DumpLexEntry),freader);
		fdList=new list<CFDescription*>;
		pred=L"";
		CopyToWSTR(DumpLexEntry.Predicate,pred);
		
		int k;	
		for(k=0;k<DumpLexEntry.ConditionListSize;k++)
		{
			tfdesc=new CFDescription();
			tfdesc->Operator = DumpLexEntry.ConditionList[k].Operator;
			
			tfdesc->Label=new CFDExpression();
			tfdesc->Label->op = DumpLexEntry.ConditionList[k].Label.op;

			int m;
			for(m=0;m<DumpLexEntry.ConditionList[k].Label.size;m++)
				tfdesc->Label->list.push_back(DumpLexEntry.ConditionList[k].Label.list[m]);
			
			tfdesc->Value=new CFDExpression();
			tfdesc->Value->op=DumpLexEntry.ConditionList[k].Value.op;

			for(m=0;m<DumpLexEntry.ConditionList[k].Value.size;m++)
				tfdesc->Value->list.push_back(DumpLexEntry.ConditionList[k].Value.list[m]);				
			
			fdList->push_back(tfdesc);
		}	

		com->insert(map<wstring,list<CFDescription*>*>::value_type(pred,fdList));

	}
	return com;
}


void CLexicon::LoadExpansions(string FileName)
{
	Expansions=new hash_map<wstring,wstring>;
	ifstream exp_file;
	exp_file.open(FileName.c_str(),ios::binary);
	wchar_t ch;
	exp_file.read((char *)&ch,2);

	wstring str,word;
	while(!exp_file.eof())
	{
		exp_file.read((char *)&ch,2);
		switch(ch)
		{
		case '=':
			word=str;
			str=L"";
			break;
		case '\r':
			exp_file.read((char *)&ch,2);
			if(ch=='\n')
			{
				(*Expansions)[word]=str;
				str=L"";
			}
			else
				str+=ch;
			break;
		default:
			str+=ch;

		}
	}
	
}
