#include "stdafx.h"
#pragma warning(disable: 4786)

#ifndef CLEXICON_H_HEADER_INCLUDED_BF677AAB
#define CLEXICON_H_HEADER_INCLUDED_BF677AAB

#include <string>
#include <vector>
#include <map>
#include <fstream>


#pragma warning(disable: 4786)

using std::string;
using std::vector;
using std::map;
using std::multimap;
using std::pair;

/*#include <hash_map> REMOVED IN THIS (LINUX ONLY) VERSION*/

using namespace std;
/*using namespace stdext; REMOVED IN THIS (LINUX ONLY) VERSION*/


typedef pair<string,int> StrInt_Pair;

#include "CLexicalEntry.h"

#include "LexIndex.h"
#include "CConfiguration.h"
#include "CSymbolTableManager.h"



///-*********************************************************-///
wstring stringToWstring(string);
class FDescriptionsExtractor
{
public:
	void InsertUnique(vector<string> & AVec,string temp)
	{
		for(int i=0;i<AVec.size();i++)
		{
			if (AVec[i]==temp)
			{
				return;
			}
		}

		AVec.push_back(temp);
	}


	void Preprocess(char * A)
	{
		bool IsBra = false;
		bool IsLG = false;
		for(int i=0;i<strlen(A);i++)
		{
			if(A[i]=='<')
			{
				IsLG = true;
			}

			if(A[i]=='>')
			{
				IsLG = false;
			}

			if(A[i]=='{')
			{
				IsLG = true;
			}

			if(A[i]=='}')
			{
				IsLG = false;
			}

			if(IsLG==true && A[i] == ',')
			{
				A[i] = ':';
			}

		}
	}

	void ReplaceDot(char* A)
	{
		for(int i=0;i<strlen(A);i++)
		{
			if(A[i]=='.')
			{
				A[i]=0;
			}
		}
	}


	void Print(vector<string> & AVec)
	{
		CFileWriter fout(CConfiguration::GetConfigInfo("FDescriptions").c_str());
		string temp;
		for(int i=0;i<AVec.size();i++)
		{
			temp = trim(AVec[i]);
			fout.Write(stringToWstring(temp));
			fout.Write(L".\r\n");

		}
	}

	bool DoesContainPred(const char * A)
	{
		
		for(int i=0;i<strlen(A);i++)
		{
			if(A[i]=='\'')
			{
				return true;
			}
		}

		return false;
	}

	// 5072	202

	void ExtractAll()
	{
		CFileReader fin(CConfiguration::GetConfigInfo("preFdescription").c_str(),1000);
		vector<string> ELex;


		int lineNo=0;

		string temp;

		char A[2000];
		char * Atemp;
		bool DoRun = false;
		string DoesCPred;
		int i=0;
		string Ab;
		while (GetALine(fin,Ab))
		{
			lineNo++;
			
			if (i==3510)
			{
				lineNo = lineNo;
			}

			
			
			strcpy(A,Ab.c_str());
			DoesCPred = A;
			
			Preprocess(A);

			i=0;

			ReplaceDot(A);

			if(A[0]=='/')
			{
				continue;
			}

			DoRun = true;

			Atemp=strtok(A,",");

			if (Atemp==NULL)
			{
				DoRun = false;
			}
			else
			{
	//			DoesContainPred(DoesCPred.c_str());

				char * t2 =strtok(NULL,",");
				if(t2==NULL)
				{
					continue;
				}
				Atemp= t2;
				if(DoesContainPred(DoesCPred.c_str()))
				{

					char * t2 =strtok(NULL,",");
					if(t2==NULL)
					{
						continue;
					}

					Atemp=t2;
				}

			}

			
			while(DoRun)
			{
					
	//				ReplaceDot(Atemp);

					temp = Atemp;
					
					InsertUnique(ELex,temp);
			
					Atemp=strtok(NULL,",");

					if (Atemp==NULL)
					{
						DoRun = false;
						continue;
					}

					if (Atemp==NULL)
					{
						DoRun = false;
					}
			}

		}
	Print(ELex);
	}

	bool GetALine(CFileReader & FHandler,string & A)
	{
		A="";
		short ch=0;
		
		while((ch=FHandler.GetCurrentChar())!=0)
		{
		start:
			switch(ch)
			{
					case LF:
					case CR:
	//				case ' ':
	//				case '\t':
						A="";

						break;
					case '@':
//						A+=ch;
						FHandler.MoveNext();
						while((ch=FHandler.GetCurrentChar())!='@')
						{
//							A+=ch;
							FHandler.MoveNext();
						}
//						A+=ch;
						break;
					case '/' :				
							
							while(true)
							{						
								ch=FHandler.GetCurrentChar();
									
								if(ch==LF||ch==CR||ch<=0)
									break;					

								A+=ch;
								FHandler.MoveNext();					

							}
							break;

					case '.':
					{
						FHandler.MoveNext();
						return true;	// Line Ends
					}

					default:		
							A+=ch;
						
				}//end switch
		
			
			FHandler.MoveNext();
		}
		return false;
	}


	string trim(string & A)
	{
		string temp;
		int size = A.size();
		/* CHANGED FOR THIS (LINUX) VERSION
		for(int i=0;i<size;i++)
		*/
		int i;
		for(i=0;i<size;i++)
		{
			if(A[i]!=' ' && A[i]!='\t')
			{
				break;
			}
		}
		
		/* CHANGED FOR THIS (LINUX) VERSION
		for(int j=size-1;j>=0;j--)
		*/
		int j;
		for(j=size-1;j>=0;j--)
		{
			if(A[j]!=' ' && A[j]!='\t')
			{
				break;
			}
		}

		for(;i<=j;i++)
		{
			temp +=A[i];
		}


		return temp;
	}

};


///-*********************************************************-///

class CLexicon
{

public:

	/////////////////////////////////////////////////////////
	//member functions specific for Symbol Table
	/////////////////////////////////////////////////////////

	bool LoadOrderedFeatures();
	bool CheckSymbolTableConsistency(string log_fname);

	//static wstring GetConstantNameByList(vector<short> & vlist,wstring separator=L" ");	
	//static wstring GetConstantName(short index);
	//static short GetConstantNumber(wstring str,bool InsertIfNotFound);

	/////////////////////////////////////////////////////////
	// data members specific for Symbol Table
	/////////////////////////////////////////////////////////

	//static map<short,wstring> ConstNameArr; 
	//static map<wstring,short> ConstList;
	//static size_t CurrentConstListNumber;

	/////////////////////////////////////////////////////////

  public:	
	
	CFDExpression* GenerateFDExpressionEx(wstring str1);
	CLexIndex * WriteBinaryLex(string fname, bool IsCache);
	
	void WriteBinaryLexIndex(string fname , CLexIndex * LexInd);
		
	//CLexicon(string fname);
	CLexicon(std::string prefix,bool ProvideSearchByPred);
	//Dummy constructor only for ordered feature list
	CLexicon(string prefix);

	~CLexicon();

	CFDExpression* GenerateFDExpression(wstring str);	
	 	  
	bool ReadLexicon(string UniCodeFilePath);

	bool LoadLexiconFromDumpFile(const string & file_name);
	bool LoadLexiconFromDumpFileV2(const string & file_name);
	       
    void GenerateLexBinaryFile(string LexBinFileName);

    vector<CLexicalEntry*> * GetLexicalEntryList(wstring Lexeme);
	
	vector<CLexicalEntry*> * GetLexicalEntryListUsingPOS(	const wstring & str,
															const wstring & pos_str,
															bool & found);
    
    void LoadLexicon(string LexBinFileName);

	multimap<wstring,CLexicalEntry*> * StructureFString(wstring LexEntry); //Newly Added by Omar

	

	CFDExpression * GenerateFDExpressionEx2(wstring str1);

 // private:
    //##ModelId=40612BBC03B3
    //void ReadLexiconTextFile();

	//CLexIndex * ReadBinaryLexIndex( string fname ); //READ and LOad LEXICON INDEX

	//void LoadCache( string fname );

	//bool ConstructCache(string fname);

	//CLexicalEntry * ConstructLexEntFromString( wstring src_str );

	//void ReadBinarySTable(string fname);
	//void WriteBinarySTable(string fname);

	void makestr(CLexicalEntry * lex_ent, unsigned short str_lex_ent[]); //for testing formed lexical entries only

    //##ModelId=406123ED00A4
    //vector<CLexicalEntry*>* LexicalEntries;

	//multimap<wstring,CLexicalEntry*> * LexEntries;	
	//multimap<wstring,CLexicalEntry*> * LexCache;

	hash_multimap<wstring,CLexicalEntry*> LexiconHashTable;

    //##ModelId=4061245501E1
    //string LexFileName;

	//map<wstring,short> ConstList;
	
	//int ConstNameArrSize;
	//wstring*ConstNameArr;	

	//map<short,wstring> ConstNameArr; //replacing ConstNameArr
	
	//CLexIndex * LexiconIndex;	//lexicon index

	//CConfiguration * ConfigMngr; //Configuration manager
	
	string FileNamePrefix; //Lex File Names Prefix e.g. E for English, U for Urdu

	bool SearchByPred;
	//true: for generator / Search Lex Entries by Predicate
	//false: for parser / Search Lex Entries by Word

	_CLexicalEntry DumpLexEntry;
	_CLexicalEntry_ _DumpLexEntry;

public:

	bool SaveLexEntry(CLexicalEntry* le);

	bool IdentifyBoundaries(void);
	bool DumpLexiconInFile(const string & file_name);
	bool DumpLexiconInFileV2(const string & file_name);
	bool DumpLexicalEntryInFile(FILE* fwriter, CLexicalEntry* le);
	bool DumpLexicalEntryInFileInMyStyle(FILE* fwriter, CLexicalEntry* le);
	bool DumpLexicalEntriesInNumbers();
	bool DumpLexicalEntryOfNumber(FILE* fwriter, _CLexicalEntry_* le);
	bool LoadFromNumberDump(const string & file_name);
	bool DumpLexicalEntriesInArray();
	bool LoadDumpLexicalEntriesInArray();
	//////////////////////////////////////////////////////
	//functions written by huma - revised by irfan
	//////////////////////////////////////////////////////
	
	hash_map<wstring,list<CFDescription*>*> * CommonLexicalFeatureTable;
	hash_map<wstring,list<CFDescription*>*> * GetCommonLexicalFeatureTable();
		
	void WriteCommonLexicalFeaturesInFile(hash_map<wstring,list<CFDescription*>*> *, FILE* fwriter);
	hash_map<wstring,list<CFDescription*>*> * ReadCommonLexicalFeaturesFromFile(FILE* freader);

	vector<short>* GetSetIntersection(vector<short> * list1, vector<short> * list2);
	
	//////////////////////////////////////////////////////


	//*******************Tahira*******************
	hash_map<wstring,wstring> * Expansions;
	void LoadExpansions(string FileName);
	//*******************Tahira*******************

};


#endif /* CLEXICON_H_HEADER_INCLUDED_BF677AAB */
