#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CProduction.h"
/*#include ".\cproduction.h" REMOVED IN THIS (LINUX) VERSION*/

int CProduction::counter=0;
list<CProduction*> CProduction::ClonedProductionGarbageCollector;

void CProduction::PrintProductionW(wstring title)
{
	using namespace std;
	
	if(!LHS||RHS.empty())
		return;
	
	wstring output=L"";

	output =LHS->Label;
	output+=L" ==> \n";	
	
	vector<CProductionSymbol*> * rp_RHS=&RHS;
	CProductionSymbol*symb=NULL;

	short k=0;
	for(vector<CProductionSymbol*>::iterator it2= rp_RHS->begin(); it2!=rp_RHS->end();it2++)
		{
			if(curr_index==k)
				output+=L"\t.\n";
			symb=*it2;			
			
			output+=L"\t";
			output+=symb->Label;
			output+=L"\n";
			k++;
		}
		
	/*MessageBox(NULL,output.c_str(),title.c_str(),MB_ICONINFORMATION); REMOVING FOR THIS (DOS/LINUX VERSION */
	
}

void CProduction::PrintProductionF(CFileWriter*fw,wstring title)
{
	using namespace std;
	
	if(!LHS || RHS.empty() || !fw)
		return;
	
	wstring output=L"";

	//output+=L"\r\n=============================================\r\n";
	output+=title;
	//output+=L"\r\n=============================================\r\n";	

	output+=LHS->Label;	
	output+=L" ==> ";	
	
	vector<CProductionSymbol*> * rp_RHS=&RHS;
	CProductionSymbol*symb=NULL;

	short k=0;
	for(vector<CProductionSymbol*>::iterator it2= rp_RHS->begin(); it2!=rp_RHS->end();it2++)
		{
			if(curr_index==k)
				output+=L" @ ";
			symb=*it2;			
			
			output+=L" ";
			output+=symb->Label;			
			k++;
		}

	output+=L"\r\n";
	//output+=L"\n=============================================\n";

	fw->Write(output);
		
	//MessageBox(NULL,output.c_str(),title.c_str(),MB_ICONINFORMATION);
	
}

CProduction*CProduction::GetClone()
{
		using namespace std;

		CProduction*prod=new CProduction();

		if(!prod)
			return NULL;

		prod->curr_index=curr_index;				
		prod->LHS=LHS->GetClone();						
		prod->ProductionNo = ProductionNo;
		prod->extended_by = -1;
		for(vector<CProductionSymbol*>::iterator it=RHS.begin();it!=RHS.end();it++)
			prod->RHS.push_back((*it)->GetClone());

		AddCloneInGC(prod);

		return prod;
}

CProductionSymbol * CProduction::GetCurrentSymbol()
{
		CProductionSymbol * ret=NULL;
		
		if(RHS.empty())
			return ret;

		short len=RHS.size();
		
		if(curr_index<len)
			ret=RHS.at(curr_index);
		
		return ret;
}

CProduction::CProduction()
{
	curr_index=0;	
	counter++;	
	LHS=NULL;
	extended_by = -1;
}

CProduction::~CProduction()
{
	using namespace std;

	curr_index=0;		

	if(LHS)
	{
		try{
		delete LHS;
		LHS=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### LHS");
			#endif
		}

	}
	
	try
	{
		if(!RHS.empty())
		{
			CProductionSymbol*symb=NULL;
			for(vector<CProductionSymbol*>::iterator it=RHS.begin(); it!=RHS.end();it++)
			{
				symb=*it;
				try
				{
					delete symb;
					symb=NULL;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"#### symb");
					#endif
				}
			}		
			RHS.clear();		
		}	
	}
	catch(...)
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"#### Deleting RHS... \r\n");
		#endif
	}
		
	counter--;
}

void CProduction::InitCurrentIndex()
{
	curr_index=0;
}

bool CProduction::IsComplete()
{
	short len=RHS.size();
	
	if(curr_index==len-1)
		return true;

	return false;
}

bool CProduction::MoveDot()
{
	short len=RHS.size();
	
	if(curr_index<len-1)
	{
		curr_index++;
		return true;
	}
	
	return false;
}


bool CProduction::IsNullProduction()
{		
	if(RHS.size()==1)
		return true;
	
return false;
}

bool CProduction::DeleteFStructures()
{
	using namespace std;

	curr_index=0;

	if(LHS)
	{
		try{
		delete LHS;
		LHS=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### LHS");
			#endif
		}

	}
	
		
	if(!RHS.empty())
	{
		CProductionSymbol*symb=NULL;

		for(vector<CProductionSymbol*>::iterator it=RHS.begin(); it!=RHS.end();it++)
			{
			try{
				symb=*it;				
				delete symb;
				}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### symb");
			#endif
		}

			}		
		
		RHS.clear();
	}
	
return true;
}

bool CProduction::AddGenSelectionSetItem(short LabelId)
{
	GenSelectionSet.insert(LabelId);

	return true;
}
