#include "stdafx.h"
#pragma warning(disable: 4786)


#ifndef CPRODUCTION_H_HEADER_INCLUDED_BF676712
#define CPRODUCTION_H_HEADER_INCLUDED_BF676712


#include "CProductionSymbol.h"
#include "FileWriter.h"

#include <set>
#include <list>

using namespace std;

//##ModelId=40625F410026
//##Documentation
//## It is the data structure that contains the information of Grammar Rules
class CProduction
{

public:

	static list<CProduction*> ClonedProductionGarbageCollector;
	
	static bool AddCloneInGC(CProduction*prod)
	{
		try
		{
			ClonedProductionGarbageCollector.push_back(prod);
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Error on Adding Prod to GC");
			#endif

			return false;
		}
		
		return true;
	}

	static void CollectSelectiveGarbage()
	{
		CProduction*prod=NULL;
		
		try
		{
			for(list<CProduction*>::iterator it=ClonedProductionGarbageCollector.begin();
				it!=ClonedProductionGarbageCollector.end();it++)
			{
				prod=*it;
				try
				{
					delete prod;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"error on deleting f-structure \r\n");
					#endif
				}
			}
		
			ClonedProductionGarbageCollector.clear();	
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Error on Clearing CFStructure::GC\r\n");
			#endif
		}	
	}

	int ProductionNo;	////////////NEW
	int extended_by;
	static int counter;
	bool DeleteFStructures();
	bool IsNullProduction();
	
    CProductionSymbol*LHS;
    vector<CProductionSymbol*> RHS;        
	map<short,short> SelectionSet;
	set<short> GenSelectionSet;
	short curr_index;
		
	void PrintProductionW(wstring title);
	void CProduction::PrintProductionF(CFileWriter*fw,wstring title);

	CProduction*GetClone();
	CProductionSymbol * GetCurrentSymbol();	
	CProduction();
	~CProduction();
	void InitCurrentIndex();
	bool IsComplete();
	bool MoveDot();
	bool AddGenSelectionSetItem(short LabelId);
};




#endif /* CPRODUCTION_H_HEADER_INCLUDED_BF676712 */
