
#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CProductionSymbol.h"
#include "CFDescription.h"

int CProductionSymbol::counter=0;

CProductionSymbol::CProductionSymbol()
{
	Label=L"";
	isTerminal=false;	
	FSPtr=NULL;
	GenFSPtr=NULL;
	ChartItemPtr = NULL;
	counter++;
}

CProductionSymbol::~CProductionSymbol()
{
	counter--;
	FSPtr=NULL;
	GenFSPtr=NULL;

	using namespace std;

	CFDescription*temp=NULL;

	for(vector<CFDescription*>::iterator it=conditions.begin();it!=conditions.end();it++)
	{
		temp=*it;
		try{
			delete temp;
			temp=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### temp");
			#endif

			temp=NULL;
		}

	}

	conditions.clear();
	constraints.clear();

}


void CProductionSymbol::PrintProductionSymbol()
{
	using namespace std;

	//wprintf(L"\n-------------------------------\n");
	//wprintf(L"Label: %s ",Label);

	/*	wprintf(L"constraint: %s \n",constraints);
		
	for(vector<CFDescription*>::iterator it2= conditions.begin();
		it2!=conditions.end();it2++)
		{
			CFDescription*fdesc=*it2;

			short len=fdesc->Label->list.size();			
			printf("Labels: ");
			for(short k=0;k<len;k++)
				printf("%d ",fdesc->Label->list[k]);
			printf("\n");

			printf("Operator:%c \n",fdesc->Operator);

			len=fdesc->Value->list.size();			
			printf("Values: ");
			for(k=0;k<len;k++)
				printf("%d ",fdesc->Value->list[k]);
			printf("\n");
						
		}
		
	wprintf(L"\n-------------------------------\n");*/
}

CProductionSymbol* CProductionSymbol::GetClone()
{
	using namespace std;

	CProductionSymbol*psymb=new CProductionSymbol();

	if(!psymb)
		return NULL;
	
	psymb->constraints=constraints;
	
	if(FSPtr)
		psymb->FSPtr=FSPtr->GetClone();
	else
		psymb->FSPtr=FSPtr;

	psymb->isTerminal=isTerminal;
	psymb->Label=Label;
	psymb->LabelID=LabelID;
	psymb->SenWord=SenWord;
	psymb->ChartItemPtr=ChartItemPtr;

	CFDescription*fdesc=NULL;
	CFDescription*fdesc_new=NULL;

	if(!conditions.empty())
	{
		for(vector<CFDescription*>::iterator it=conditions.begin(); it!=conditions.end();it++)
		{		
			fdesc=*it;
			fdesc_new=fdesc->GetClone();
			psymb->conditions.push_back(fdesc_new);
		}	
	}

	psymb->GenFSPtr = GenFSPtr;

	return psymb;
}

bool CProductionSymbol::isEqual(CProductionSymbol *psymb)
{
	if(!psymb || Label!=psymb->Label)
		return false;

	if(psymb->isTerminal!=isTerminal)
		return false;			

	short len1=0;
	short len2=0;

	len1=conditions.size();
	len2=psymb->conditions.size();

	if(len1!=len2)
		return false;
	
	short p=0;

	CFDescription*fd1=NULL;
	CFDescription*fd2=NULL;

	for(p=0;p<len1;p++)
	{
		fd1=conditions[p];
		fd2=psymb->conditions[p];
		
		if(!fd1->isEqual(fd2))
			return false;
	}

	len1=constraints.size();
	len2=psymb->constraints.size();

	if(len1!=len2)
		return false;

	for(p=0;p<len1;p++)
	{				
		if(constraints[p]!=psymb->constraints[p])
			return false;		
	}

	if(FSPtr==NULL && psymb->FSPtr==NULL)
		return true;

	if(!FSPtr || !psymb->FSPtr)
		return false;
	
	if(!FSPtr->IsEqual(psymb->FSPtr))
		return false;

	return true;
}

bool CProductionSymbol::DeleteFStructure()
{
	if(FSPtr)
	{
		try{
		delete FSPtr;
		FSPtr=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### FSPtr");
			#endif
			FSPtr=NULL;
		}
	}	

	return true;
}
