#ifndef CPRODUCTIONSYMBOL_H_HEADER_INCLUDED_BF674EF5
#define CPRODUCTIONSYMBOL_H_HEADER_INCLUDED_BF674EF5

#include "CFStructure.h"
#include "CFDescription.h"

#include <string>
#include <vector>

using std::string;
using std::wstring;
using std::vector; 

class CChartItem;

//##ModelId=40625FA9011C
//##Documentation
//## It is the data structure that contains the information of
//## Terminal/Non-Terminal Symbols in Grammar Productions
class CProductionSymbol
{

public:

	static int counter;

    //##ModelId=406260AF02A2
    wstring Label;
	wstring SenWord;

	short LabelID;		//new code

    //##ModelId=406260BB02E0
    bool isTerminal;

    //##ModelId=4088CAF60026
    vector<CFDescription*> conditions;

    //##ModelId=406260C70169
    vector<wstring>  constraints;

    //##ModelId=407B6F330208
    CFStructure * FSPtr;

	CFStructureItem * GenFSPtr;

	CChartItem * ChartItemPtr;
	int ChartItemNo;
		//majboori hai warna aur zaroorat bhi hai.............

public:
	bool DeleteFStructure();
	bool isEqual(CProductionSymbol*prod);
	CProductionSymbol* GetClone();
	void PrintProductionSymbol();
	CProductionSymbol();
	~CProductionSymbol();
};




#endif /* CPRODUCTIONSYMBOL_H_HEADER_INCLUDED_BF674EF5 */
