
#include "stdafx.h"


#include"CSymbolTableManager.h"


/////////////////////////////////////////////////////////////////

	hash_map<wstring,short> CSymbolTableManager::String2NumTable;
	hash_map<short,wstring> CSymbolTableManager::Num2StringTable;
	int CSymbolTableManager::counter=0;

/////////////////////////////////////////////////////////////////

	short CSymbolTableManager::PredId=0;
	short CSymbolTableManager::GFId=0;
	short CSymbolTableManager::RootId=0;
	short CSymbolTableManager::SetId=0;
	short CSymbolTableManager::ElementId=0;
	short CSymbolTableManager::IndexId=0;
	short CSymbolTableManager::SpecialSetId=0;
	short CSymbolTableManager::NumId=0;
	short CSymbolTableManager::NumthId=0;
	short CSymbolTableManager::ValueId=0;
	short CSymbolTableManager::_ValueId=0;
	short CSymbolTableManager::ParentId=0;
	short CSymbolTableManager::NullId=0;
	short CSymbolTableManager::BreakId=0;
	short CSymbolTableManager::FinalId=0;

/////////////////////////////////////////////////////////////////

bool CSymbolTableManager::SetDataMemberValues()
{
	PredId=GetNum(L"PRED");
	GFId=GetNum(L"GF");
	RootId=GetNum(L"ROOT");
	SetId=GetNum(L"SET");
	ElementId=GetNum(L"ELEMENT");
	IndexId=GetNum(L"INDEX");
	SpecialSetId=GetNum(L"INDEX");
	NumId=GetNum(L"num");
	NumthId=GetNum(L"numth");
	ValueId=GetNum(L"VALUE");
	_ValueId=GetNum(L"_VALUE");
	ParentId=GetNum(L"PARENT");
	NullId=GetNum(L"NULL");
	BreakId=GetNum(L"BREAK");
	FinalId=GetNum(L"FINAL");
	
	return true;
}

wstring CSymbolTableManager::GetStringByList(vector<short> & vlist,
											 const wstring & separator)
{
	using namespace std;
	
	wstring line=L"";		
	wstring str=L"";
	short id=0;

	for(vector<short>::iterator it=vlist.begin();it!=vlist.end();)
	{
		id=*it;						

		str = CSymbolTableManager::GetString(id);		
		line+=str;		

		it++;

		if(it!=vlist.end())		
			line+=separator;		
	}

	if(line!=L"")
		return line;
	
	return L"EMPTY";
}

short CSymbolTableManager::Insert(const wstring & str)
{
	counter++;
    String2NumTable[str]=counter;	
	Num2StringTable[counter]=str;
	return counter;
}

short CSymbolTableManager::Insert(const wstring & str, const short id)
{
	if(id > counter)
		counter=id+1;
	
    String2NumTable[str]=id;	
	Num2StringTable[id]=str;

	return id;
}

short CSymbolTableManager::GetNum(const wstring & str, bool add)
{
	hash_map<wstring,short>::iterator it;
	it=String2NumTable.find(str);
	
	if(it!=String2NumTable.end())
		return it->second;
	
	if(add)
		return Insert(str);

	return -1;
}

wstring CSymbolTableManager::GetString(short num)
{
	hash_map<short,wstring>::iterator it;
	it=Num2StringTable.find(num);
	
	if(it!=Num2StringTable.end())
		return it->second;
	
	return L"EMPTY";
}
bool CSymbolTableManager::WriteSymbolTableInFile(const string & file_name)
{	
	hash_map<short,wstring>::iterator ar_it = Num2StringTable.begin();

	CSymbolTableEntry ste;
	wstring wstr;

	FILE * bfw =fopen(file_name.c_str(),"wb");

	//CFileWriter test_fw("data\\test_st.txt");

	if(!bfw)
		return false;
    
	short index=0;
	short len=0;
	int record_counter=0;

	while( ar_it != Num2StringTable.end() )
	{
		ste.Id=ar_it->first;
		wstr=ar_it->second;
	
		///////Copying Data In Object////////
		len=wstr.size();				
		for(index=0;index<len;index++)
			ste.String[index]=wstr[index];		
		ste.String[index]=0;
		/////////////////////////////////////

		//test_fw.Write(wstr+L"\t"+GetWSTR(ste.Id)+L"\r\n");

		fwrite(&ste,sizeof(ste),1,bfw);
		
		ar_it++;
		record_counter++;
	}

	fclose(bfw);
	//test_fw.CloseFile();
	
	return true;
}

bool CSymbolTableManager::ReadSymbolTableFromFile(const string & file_name)
{
	CSymbolTableEntry ste;
	wstring wstr;

	FILE * bfr =fopen(file_name.c_str(),"rb");
	
	//CFileWriter test_fw("data\\test_st_onread.txt");

	if(!bfr)
		return false;
    
	short index=0;
	short len=0;
	short bytes_read=0;

	while((bytes_read=fread(&ste,1,sizeof(ste),bfr))>0)
	{
		wstr=L"";
		
		for(index=0;ste.String[index]!=0;index++)
			wstr+=ste.String[index];
		
		Insert(wstr,ste.Id);
		
		//test_fw.Write(GetWSTR(ste.Id)+L"\t"+wstr+L"\r\n");

		if(feof(bfr))
			break;
	}

	fclose(bfr);
	//test_fw.CloseFile();

	return true;
}
