#include "stdafx.h"

/*#include <hash_map>REMOVED IN THIS (LINUX ONLY) VERSION*/
#include <string>

#include "FileReader.h"
#include "FileWriter.h"

#include "CConfiguration.h"
#include "LogManager.h"

using namespace std;
/*using namespace stdext; REMOVED IN THIS (LINUX ONLY) VERSION*/

#ifndef SYMBOL_TABLE_MANAGER
#define SYMBOL_TABLE_MANAGER

#define MaxStringLength 100

struct CSymbolTableEntry
{
	short Id;
	short String[MaxStringLength];
};

class CSymbolTableManager
{

public:	

	static short GetNum(const wstring & str, bool add=true);
	static wstring GetString(short num);	
	
	static size_t GetTotalCount()
	{ 
		return Num2StringTable.size(); 
	}

	/////////////////////////////////////////
	static short PredId;
	static short GFId;
	static short RootId;
	static short SetId;
	static short ElementId;
	static short IndexId;
	static short SpecialSetId;
	static short NumId;
	static short NumthId;
	static short ValueId;
	static short _ValueId;
	static short ParentId;
	static short NullId;
	static short BreakId;
	static short FinalId;
	//static short 
	/////////////////////////////////////////
	static bool SetDataMemberValues();
	static wstring CSymbolTableManager::GetStringByList(vector<short> & vlist,
												   const wstring & separator);

	/////////////////////////////////////////

private:
	/////////////////////////////////////////
	static hash_map<wstring,short> String2NumTable;
	static hash_map<short,wstring> Num2StringTable;
	static short Insert(const wstring & str);
	static short Insert(const wstring & str, const short id);
	static int counter;
	/////////////////////////////////////////	

public:	
	static bool WriteSymbolTableInFile(const string & file_name);
	static bool ReadSymbolTableFromFile(const string & file_name);

public:	
	static	bool GetALine(CFileReader & FHandler,wstring & A)
	{
		A=L"";
		short ch=0;
		
		while((ch=FHandler.GetCurrentChar())!=0)
		{
		start:
			switch(ch)
			{
					case LF:
					case CR:
	//				case ' ':
	//				case '\t':
						A=L"";

						break;
					case '@':
//						A+=ch;
						FHandler.MoveNext();
						while((ch=FHandler.GetCurrentChar())!='@')
						{
//							A+=ch;
							FHandler.MoveNext();
						}
//						A+=ch;
						break;
					case '/' :				
							
							while(true)
							{						
								ch=FHandler.GetCurrentChar();
									
								if(ch==LF||ch==CR||ch<=0)
									break;					

								A+=ch;
								FHandler.MoveNext();					

							}
							break;

					case '.':
					{
						FHandler.MoveNext();
						return true;	// Line Ends
					}

					default:		
							A+=ch;
						
				}//end switch
		
			
			FHandler.MoveNext();
		}
		return false;
	}



	static bool WriteSymbolTableInFile()
	{
		string CommonSymbolTableFileName=CConfiguration::GetConfigInfo("CommonSymbolTableFileName");	
		
		#ifdef GenLog
		CLogManager::AddMessage(L"Writing Symbol Table....");			
		#endif
		
		if(!WriteSymbolTableInFile(CommonSymbolTableFileName))
			return false;
	
		#ifdef GenLog
		CLogManager::AddMessage(L"Symbol Table has dumped "+GetWSTR(GetTotalCount())+L" Entries in file.");	
		#endif

		return true;
	}	

	static bool ReadSymbolTableFromFile()
	{
		Num2StringTable.clear();
		String2NumTable.clear();

		string CommonSymbolTableFileName=CConfiguration::GetConfigInfo("CommonSymbolTableFileName");	
		
		#ifdef GenLog
		CLogManager::AddMessage(L"Reading Symbol Table....");	
		#endif
		
		if(!CSymbolTableManager::ReadSymbolTableFromFile(CommonSymbolTableFileName))
			return false;

		#ifdef GenLog
		CLogManager::AddMessage(L"Symbol Table has read "+GetWSTR(GetTotalCount())+L" Entries from file.");		
		#endif

		return true;
	}
	static void ReadinSTFDescriptions()
	{
		CFileReader FReader(CConfiguration::GetConfigInfo("FDescriptions").c_str(),1000);
		
		wstring A;
		
		while(GetALine(FReader,A))
		{
			Insert(A);
		}
	}
};

#endif
