#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CTokenizer.h"
#include "CSentence.h"
#include "FileReader.h"

int CTokenizer::counter=0;

vector<CLEList*> * CTokenizer::GetTokenListEx(wstring sentence_str)
{	
	using namespace std;

	vector<CLEList*> * vlist=NULL;
	vector<wstring> * word_list=NULL;
	CLEList*le_list=NULL;

	CFileReader fr(128);
					
	if(!LexiconPtr)
		return vlist;

	CSentence sentence(sentence_str );

	word_list=sentence.GetLexemeList(&DelimList);

	if(!word_list)
		return vlist;

	vlist=new vector<CLEList*>;
	
	if(!vlist)
		return NULL;

	wstring wstr=L"";
	wstring err=L"";

	for(vector<wstring>::iterator it=word_list->begin(); it!=word_list->end();it++)
	{
		wstr=*it;
		le_list=LexiconPtr->GetLexicalEntryList(wstr);
		
		if(!le_list)
		{
			err=L"[ ";
			err+=wstr;
			err+=L" ] is not available in LEXICON";
			
			/*MessageBox(NULL,err.c_str(),L"Lexicon Manager",MB_ICONINFORMATION); REMOVING IN THIS (DOS/LINUX VERSION)*/
			return NULL;
		}
		else			
		{			
			vlist->push_back(le_list);
		}
	}

	try{
		delete word_list;
		word_list=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### word_list");
			#endif
		}


return vlist;

}

vector<CLEList*> * CTokenizer::GetTokenList(const wstring & sentence_str)
{
	using namespace std;

	vector<CLEList*> * vlist=NULL;

	if(!LexiconPtr)
		return vlist;

	vector<wstring> * word_list=NULL;
	CLEList*le_list=NULL;	

	//*********** applying expansions to abbriviations and clitics [Tahira] ******************************

	wstring tempstr;
	wstring tempsen=L"";
	hash_map<wstring,wstring>::iterator exp_it;
	for(int ind=0;ind<sentence_str.size();ind++)
	{
		if(sentence_str[ind]==' ')
		{
			exp_it=LexiconPtr->Expansions->find(tempstr);
			if(exp_it!=LexiconPtr->Expansions->end())
			{
				wstring s=exp_it->second;
				tempsen=tempsen+s+L" ";				
			}
			else
			{
				tempsen=tempsen+tempstr+L" ";
			}
			tempstr=L"";
		}
		else
		tempstr+=sentence_str[ind];
	}
	tempsen=tempsen+tempstr;


	//*************************************************************************************************

	//CSentence sentence(sentence_str); //for the time being
	CSentence sentence(tempsen);

	word_list=sentence.GetLexemeList(&DelimList);

	if(!word_list)
		return vlist;

	vlist=new vector<CLEList*>;

	if(!vlist)
		return NULL;

	wstring wstr=L"";
	wstring err=L"";
	
	char NumTest=0;
	//int siz = word_list->size();

	for(vector<wstring>::iterator sit=word_list->begin(); sit!=word_list->end();sit++)
	{				
		wstr=*sit;

		NumTest = IsNum(wstr);

		if( NumTest == 'n' || NumTest == 't')
		{
			//It is a number
			vector<CLexicalEntry*>*llist=new vector<CLexicalEntry*>;
			
			if(!llist)
				continue;

			CLexicalEntry * le = new CLexicalEntry;
			CFDescription * fdesc = new CFDescription();
			
			le->Word = TrimString(wstr);

			if( NumTest == 'n' )
				le->POS = CSymbolTableManager::NumId;
			else
			{
				le->POS = CSymbolTableManager::NumthId;
				wstr=wstr.substr(0,wstr.find(L"th"));//tahira
			}

			fdesc->Label = LexiconPtr->GenerateFDExpression(L"_VALUE");
			fdesc->Operator = '=';
			fdesc->Value = LexiconPtr->GenerateFDExpression(wstr);
			
			le->Predicate = L"'";
			le->Predicate += wstr;
			le->Predicate += L"'";
			le->ConditionList.push_back(fdesc);

			llist->push_back(le);
			le_list = llist;
			vlist->push_back(le_list);
		}
		
		else
		{			
			le_list=LexiconPtr->GetLexicalEntryList(wstr);

			if(!le_list)
			{	
				wstr=ConvertToLower(wstr);

				le_list=LexiconPtr->GetLexicalEntryList(wstr);

			}//end of if
		
		
		if(le_list)
		{
			int foundindex=-1,maxsize=0;
			wstring tempstr;
			vector<wstring>::iterator tempit;
			for( int t=0;  t<le_list->size() ; t++ )
			{
				if(le_list->at(t)->Word.size()>maxsize)
				{
					vector<wstring>::iterator it=sit+1;
					tempstr=wstr;

					if(tempstr==le_list->at(t)->Word)
					{
						foundindex=t;
						maxsize=le_list->at(t)->Word.size();
						tempit=sit;
						continue;
					}
                    
					while(it!=word_list->end()&&tempstr.size()<le_list->at(t)->Word.size())
					{
						tempstr=tempstr+L" "+*it;
						if(tempstr==le_list->at(t)->Word || ConvertToLower(tempstr)==le_list->at(t)->Word)
						{
							foundindex=t;
							maxsize=le_list->at(t)->Word.size();
							tempit=it;
						}
						it++;
					}
				}
			}

			if(foundindex!=-1)
			{
				vector<CLexicalEntry*> * new_list = new vector<CLexicalEntry*>;
				tempstr=le_list->at(foundindex)->Word;
				for(int x=0;x<le_list->size();x++)
					if(le_list->at(x)->Word==tempstr)
						new_list->push_back(le_list->at(x));
				
				try
				{
					delete le_list;
					le_list=NULL;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"Exception raised during deletion of temporary le_list");
					#endif
				}

				if(new_list->size()>0)
					le_list=new_list;

				sit=tempit;

				if(sit==word_list->end())
					sit--;
			
			}
		}

				/*
				wstring temp = L"";
				wstring prev_word = L"";
				vector<CLexicalEntry*> * prev_list = NULL;				

				//temp += wstr;
				
				for( ; sit != word_list->end() ; sit++ )
				{
					temp += *sit;
					bool IsExactMatch = false;
					bool IsPartialMatch = false;

					IsExactMatch = IsPartialMatch = false;
					
					vector<CLexicalEntry*> * NewList = new vector<CLexicalEntry*>;

					for( vector<CLexicalEntry*>::iterator t = le_list->begin(); t != le_list->end() ; t++ ) //compare with found entries
					{
						CLexicalEntry * target = *t;
						
						int comp_result = temp.compare(target->Word);
					
						if( comp_result == 0)
						{
							NewList->push_back(target);
							IsExactMatch = true;
						}
						else if( comp_result < 0 )
							IsPartialMatch = true;
					}

					if( IsExactMatch )
					{						
						if( prev_list )
						{
							word_list->erase(sit);
							sit--;
							wstring & t = *sit;
							t = temp;
							prev_list->clear();		//remove all previous
						}
						
						prev_word = temp;		//save new word	
						prev_list = NewList;
						//save vector of matching entries
						
						IsExactMatch = false;
					}
					else if( !IsPartialMatch )
					{
						sit--;
						break;
					}

					else
					{
						if( sit != word_list->begin() )
						{
							word_list->erase(sit);
							sit--;
							wstring & t = *sit;
							t = temp;
						}							
						IsPartialMatch = false;
					}
					temp += L" ";

				} //end of for
				if( prev_list )
					le_list = prev_list;
			*/				
			
		if(!le_list)
		{
			if(IsAlphaNum(wstr))
			{
			CLexicalEntry * le = new CLexicalEntry;
			CFDescription * fdesc = new CFDescription();

			fdesc->Label = LexiconPtr->GenerateFDExpression(L"ANUM");
			fdesc->Operator = '=';
			fdesc->Value = LexiconPtr->GenerateFDExpression(wstr);
			le->ConditionList.push_back(fdesc);

			
			//le->Word = TrimString(wstr);
			le->POS = CSymbolTableManager::GetNum(L"alphanum");
			vector<CLexicalEntry*>*llist=new vector<CLexicalEntry*>;

			llist->push_back(le);
			le_list=llist;
	
			}
			else
			{

			#ifdef GenLog
			CLogManager::AddMessage(L"[ "+wstr+L" ] is not available in LEXICON.");
			#endif
	            
				wstring lexent = wstr;
				lexent += L" : n,^PRED='";
				lexent += wstr;
				lexent += L"',";
				lexent += NounTemplate;
				lexent += L".";

				multimap<wstring,CLexicalEntry*>* LexEnt = LexiconPtr->StructureFString(lexent);

				multimap<wstring,CLexicalEntry*>::iterator iter=LexEnt->begin();

				vector<CLexicalEntry*>* llist=NULL;
				CLexicalEntry*le=NULL;

				if(iter!=LexEnt->end())
				{
					llist=new vector<CLexicalEntry*>;

					if(!llist)
						continue;

					le= iter->second;
	                
					llist->push_back(le);
					le_list = llist;
	                
					++iter;
				}
			}
		}

		vlist->push_back(le_list);
			}
	}

	try
	{
		delete word_list;
		word_list=NULL;
	}
	catch(...)
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"Exception raised during deletion of word_list");
		#endif
	}

return vlist;

}


char CTokenizer::IsNum(wstring lexeme)
{
	for(unsigned int a = 0 ; a < lexeme.length() ; a++ )
	{
		if( (lexeme[a]>= 48 && lexeme[a]<=57 ) || (lexeme[a]>= 0x0660 && lexeme[a]<=0x0669 || lexeme[a]==','|| lexeme[a]=='.') )
			continue;
		else
		{
			if( lexeme[a] == L't' && lexeme[a+1] == L'h' && lexeme.length() == a+2)
				return 't';
			
			else if( lexeme[a] == L's' && lexeme[a+1] == L't' && lexeme.length() == a+2)
				return 't';
			
			else if( lexeme[a] == L'r' && lexeme[a+1] == L'd' && lexeme.length() == a+2)
				return 't';
			
			else if( lexeme[a] == L'n' && lexeme[a+1] == L'd' && lexeme.length() == a+2)
				return 't';
			
			return 'f';
		}
	}
	return 'n';
}

bool CTokenizer::IsAlphaNum(wstring lexeme)
{
	for(int p=0;p<lexeme.size();p++)
		if( !((lexeme[p]<'Z' && lexeme[p]>'A') || (lexeme[p]<'z' && lexeme[p]>'a')) )
			return true;
	return false;
}

//##ModelId=4061225A0327
vector<CLEList*> * CTokenizer::GetTokenList(string SenFileName,string DelimFileName)
{
	using namespace std;

	vector<CLEList*> * vlist=NULL;
	vector<wstring> * word_list=NULL;
	CLEList*le_list=NULL;

	CFileReader fr(128);
	
	wstring sentence_str=L"";
	wstring delim_str=L"";
	
	sentence_str=fr.ReadAll(SenFileName.c_str());
	delim_str=fr.ReadAll(DelimFileName.c_str());

	//wprintf(L"\nSentence:%s\n",sentence_str.c_str());
	//wprintf(L"Delim:%s\n",delim_str.c_str());
	
	if(!LexiconPtr)
		return vlist;

	CSentence sentence(sentence_str);

	word_list=sentence.GetLexemeList(&DelimList);

	if(!word_list)
		return vlist;


	vlist=new vector<CLEList*>;
	
	if(!vlist)
		return NULL;

	wstring wstr=L"";
	wstring err=L"";

	for(vector<wstring>::iterator it=word_list->begin(); it!=word_list->end();it++)
	{
		wstr=*it;
		le_list=LexiconPtr->GetLexicalEntryList(wstr);
		
		if(!le_list)
		{
			err=L"[ ";
			err+=wstr;
			err+=L" ] is not available in LEXICON";
			
			/*MessageBox(NULL,err.c_str(),L"Lexicon Manager",MB_ICONINFORMATION); REMOVING IN THIS (DOS/LINUX VERSION)*/
			return NULL;
		}
		else			
		{
			//wprintf(L"[ %s ] available\n",wstr.c_str());
			vlist->push_back(le_list);
		}
	}
	try{
	delete word_list;
	word_list=NULL;
	}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### word_list");
			#endif
		}


return vlist;

}


CTokenizer::~CTokenizer()
{
	counter--;
}
