#ifndef CTOKENIZER_H_HEADER_INCLUDED_BF675A77
#define CTOKENIZER_H_HEADER_INCLUDED_BF675A77

#include "CLexicalEntry.h"
#include "CLexicon.h"
#include "CConfiguration.h"

#include <string>
#include <vector>

using std::string;
using std::vector;

typedef vector<CLexicalEntry*> CLEList;

//##ModelId=4061121402CB
//##Documentation
//## It is the main controller of the Tokenizer Component. It receives a
//## sentence and generate a list of words with their lexical information
class CTokenizer
{
  private:
	
	char IsNum(wstring lexeme);
	bool IsAlphaNum(wstring lexeme);
	CLexicon*LexiconPtr;

  public:
	  ~CTokenizer();
    
	static int counter;

    CTokenizer(CLexicon*LexPtr)
	{		
		counter++;
		LexiconPtr=LexPtr;

		wstring delim_str=L"";
					
		string NounTemplateFileName=CConfiguration::GetConfigInfo("NounTemplateFileName"); 
		string DelimFileName=CConfiguration::GetConfigInfo("DelimFileName"); 
					
		CFileReader fr(128);
		delim_str=fr.ReadAll(DelimFileName.c_str());
		NounTemplate=fr.ReadAll(NounTemplateFileName.c_str());
		
		short delim_len = delim_str.size();

		wstring temp;

		for( int i=0;i<delim_len;i++ ) //Seperate all delimeters into a vector
		{
			if( delim_str[i] != 10 && delim_str[i] != 13 )
				temp += delim_str[i];
			else if(temp!=L"")
			{
				DelimList.push_back(temp);	
				temp=L"";
			}
		}		
	}
    
    vector<CLEList*> * GetTokenList(string SenFileName,string DelimFileName);
	vector<CLEList*> * GetTokenListEx(wstring sentence_str);

	vector<CLEList*> * GetTokenList(const wstring & sentence_str);

	vector<wstring> DelimList;
	wstring NounTemplate;

};





#endif /* CTOKENIZER_H_HEADER_INCLUDED_BF675A77 */
