
#include "stdafx.h"
/*#include ".\ContextManager.h" REMOVED IN THIS (LINUX) VERSION*/
#include "ContextManager.h" /*ADDED IN THIS (LINUX) VERSION*/

int ContextManager::max_context;
vector<int> ContextManager::bit_pos_map;
int ContextManager::current_context;
int ContextManager::int_count;
int ContextManager::bits_in_int;
int ContextManager::size;

/*ContextManager::init(int max) CHANGED IN THIS (LINUX) VERSION*/
void ContextManager::init(int max)
{
	current_context=1;
	bits_in_int=sizeof(int)*8;
	size=1;
	//max_context=size*bits_in_int-1;
	max_context=max;
	bit_pos_map.resize(max_context+1);

	int x=1;
	for(int i=1;i<=max_context;i++)
	{
		if(x==0)
			x=1;
		bit_pos_map[i]=x;		
		x=x<<1;
	}
	//max_context=0;

}

bitwiseContext ContextManager::convertListTobitwiseContext(list<contextByte> &context)
{
	bitwiseContext ret_bc;
	int integer_number;
	
	for(list<contextByte>::iterator it=context.begin();it!=context.end();it++)
	{
		if((*it)<0)
		{
			integer_number=(-(*it))/bits_in_int;
			if((-(*it))%bits_in_int==0)
				integer_number--;
			ret_bc.neg[integer_number]|=bit_pos_map[-(*it)];
		}
		else if((*it)>0)
		{
			integer_number=(*it)/bits_in_int;
			if((*it)%bits_in_int==0)
				integer_number--;
			ret_bc.pos[integer_number]|=bit_pos_map[*it];
		}
	}	

	return ret_bc;
}

list<contextByte> ContextManager::convertbitwiseContextToList(bitwiseContext &bcont)
{
	list<contextByte> ret_cont;
	int integer_number;
	for(int i=1;i<max_context;i++)
	{
		integer_number=i/bits_in_int;
		if(i%bits_in_int==0)
			integer_number--;

		if( bcont.pos[integer_number]&bit_pos_map[i] )
			ret_cont.push_back(i);
		if( bcont.neg[integer_number]&bit_pos_map[i] )
			ret_cont.push_back(-i);
	}
	return ret_cont;
}

bitwiseContext ContextManager::getIntersection(bitwiseContext &source,bitwiseContext &target)
{
	bitwiseContext ret_cont;
	for(int i=0;i<size;i++)
	{
		ret_cont.pos[i]=source.pos[i]&target.pos[i];
		ret_cont.neg[i]=source.neg[i]&target.neg[i];
	}
	return ret_cont;
}

bitwiseContext ContextManager::getUnion(bitwiseContext &source,bitwiseContext &target)
{
	bitwiseContext ret_cont;
	for(int i=0;i<size;i++)
	{
		ret_cont.pos[i]=source.pos[i]|target.pos[i];
		ret_cont.neg[i]=source.neg[i]|target.neg[i];
	}
	return ret_cont;
}

vector<int> ContextManager::getIntersection(vector<int> &source,vector<int> &target)
{
	vector<int> ret;
	for(int i=0;i<size;i++)
		ret[i]=source[i]&target[i];
	return ret;
}

vector<int> ContextManager::getUnion(vector<int> &source,vector<int> &target)
{
	vector<int> ret;
	for(int i=0;i<size;i++)
		ret[i]=source[i]|target[i];
	return ret;
}

bool ContextManager::opposingContextsPresent(bitwiseContext &context1,bitwiseContext &context2)
{
	for(int i=0;i<size;i++)
	{
		if(context1.pos[i]&context2.neg[i])
			return true;
		if(context1.neg[i]&context2.pos[i])
			return true;
	}
	return false;
}

bool ContextManager::isValidContext(bitwiseContext &context)
{
	for(int i=0;i<size;i++)
	{
		if(context.pos[i]&context.neg[i])
			return false;
	}
	return true;
}

/*ContextManager::setSize(int biggest_context)CHANGED IN THIS (LINUX) VERSION*/
void ContextManager::setSize(int biggest_context)
{
	size=biggest_context/bits_in_int+1;
	//max_context=size*bits_in_int-1;
	//max_context=biggest_context+1;
}