
#include "fsglobal.h"
#pragma once

/*ADDED FOR THIS (LINUX) VERSION*/
#ifndef CONTEXTMANAGER_H
#define CONTEXTMANAGER_H
/*ADDED FOR THIS (LINUX) VERSION*/

class bitwiseContext
{
public:
	vector<int> pos;
	vector<int> neg;
	//int * pos;
	//int * neg;
	//int pos[3];
	//int neg[3];

	bitwiseContext(int size=5)
	{
		pos.resize(size,0);
		neg.resize(size,0);
		//pos=new int[size];
		//neg=new int[size];
	}

	/*setSize(int size=5) CHANGED IN THIS (LINUX) VERSION*/
	void setSize(int size=5)
	{
		pos.resize(size,0);
		neg.resize(size,0);
		//pos=new int[size];
		//neg=new int[size];
	}

	~bitwiseContext()
	{
		pos.clear();
		neg.clear();
		//delete pos[];
		//delete neg[];
	}

	bool operator==(const bitwiseContext &other)
	{
		for(int i=0;i<5;i++)
		{
			if( pos[i]!=other.pos[i] || neg[i]!=other.neg[i] )
				return false;			
		}
		return true;
	}

	//bitwiseContext operator=(const bitwiseContext &other)
	//{
	//	for(int i=0;i<3;i++)
	//	{
	//		pos[i]=other.pos[i];
	//		neg[i]=other.neg[i];		
	//	}
	//	return *this;
	//}

	bool operator<(const bitwiseContext &other)
	{
		for(int i=4;i>=0;i--)
		{
			if(pos[i] || neg[i] || other.pos[i] || other.neg[i])
			{
				if(pos[i]<neg[i])
				{
					if( pos[i]<other.pos[i] && pos[i]<other.neg[i] )
						return true;			
					else
						return false;
				}
				else
				{
					if( neg[i]<other.pos[i] && neg[i]<other.neg[i] )
						return true;			
					else
						return false;
				}
			}
		}
		return false;
	}
};

	//#ifndef lessop
	//#define lessop

	//bool operator<(const bitwiseContext &one,const bitwiseContext &other)
	//{
	//	for(int i=2;i>=0;i--)
	//	{
	//		if(one.pos[i] || one.neg[i] || other.pos[i] || other.neg[i])
	//		{
	//			if(one.pos[i]<one.neg[i])
	//			{
	//				if( one.pos[i]<other.pos[i] && one.pos[i]<other.neg[i] )
	//					return true;			
	//				else
	//					return false;
	//			}
	//			else
	//			{
	//				if( one.neg[i]<other.pos[i] && one.neg[i]<other.neg[i] )
	//					return true;			
	//				else
	//					return false;
	//			}
	//		}
	//	}
	//	return false;
	//}

	//#endif

class ContextManager
{
public:
	static int max_context;
	static vector<int> bit_pos_map;
	static int current_context;
	static int int_count;
	static int bits_in_int;
	static int size;

public:
	static bitwiseContext convertListTobitwiseContext(list<contextByte> &context);
	static list<contextByte> convertbitwiseContextToList(bitwiseContext &bcont);
	static bitwiseContext getIntersection(bitwiseContext &source,bitwiseContext &target);
	static bitwiseContext getUnion(bitwiseContext &source,bitwiseContext &target);
	static vector<int> getIntersection(vector<int> &source,vector<int> &target);
	static vector<int> getUnion(vector<int> &source,vector<int> &target);
	static bool opposingContextsPresent(bitwiseContext &context1,bitwiseContext &context2);
	static bool isValidContext(bitwiseContext &context);
	/*static init(int max=150); CHANGED IN THIS (LINUX) VERSION*/
	static void init(int max=150);
    /*static setSize(int biggest_context=3); CHANGED IN THIS (LINUX) VERSION*/
	static void setSize(int biggest_context=3);
	~ContextManager(void);
};
#endif /*ADDED IN THIS (LINUX) VERSION*/