// FDExpression.cpp: implementation of the CFDExpression class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

#include "FDExpression.h"
#include "CLexicon.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CFDExpression::counter=0;

CFDExpression::CFDExpression()
{
	counter++;
}

CFDExpression::~CFDExpression()
{	
	counter--;
	list.clear();
}

CFDExpression * CFDExpression::GetClone()
{
	using namespace std;
	
	CFDExpression *fdexp=new CFDExpression();

	if(!fdexp)
		return NULL;
		
	fdexp->op=op;
	fdexp->list=list;	
	
	return fdexp;
}

void CFDExpression::DeleteFDExpressions(CFDExpression *fde1, CFDExpression *fde2)
{
	if(fde1)
	{
		try{
			delete fde1;
			fde1=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### fde1");
			#endif
		}

	}
	
	if(fde2)
	{
		try{
		delete fde2;
		fde2=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### fde2");
			#endif
		}

	}
}

wstring CFDExpression::GetFDExpressionString(void)
{
	wstring wstr=L"";
	wstr+=op;
	wstr+=L" ";
	
	if(list.size()>0)
		wstr=wstr+CSymbolTableManager::GetStringByList(list,L" ");
	
	return wstr;
}
