// FileWriter.cpp: implementation of the CFileWriter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

#include "FileWriter.h"
/*#include ".\filewriter.h" REMOVED IN THIS (LINUX) VERSION*/

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CFileWriter::counter=0;

CFileWriter::CFileWriter(const string & fname)
{
	counter++;

	fptr=NULL;
	this->OpenFile(fname);
}

CFileWriter::~CFileWriter()
{
	counter--;

	this->CloseFile();
}

void CFileWriter::CloseFile()
{
	if(fptr)
	{
		fclose(fptr);
		fptr=NULL; /* ADDED FOR THIS (LINUX) VERSION */
	}
}

short CFileWriter::Write(const wstring & str)
{
	short bytes_written=0;

	if(!fptr || str==L"")
		return bytes_written;			
	
	short len=str.size();

	/*CHANGED IN THIS (LINUX ONLY) VERSION
	bytes_written = fwrite(str.c_str(),len*2,1,fptr);	
	CHANGED IN THIS (LINUX ONLY) VERSION*/

	/*REPLACED BY*/
	
	short *char_array=new short[len];
	for(int i=0;i<str.size();i++)
	{
		char_array[i]=str[i];
	}

	//bytes_written = fwrite(str.c_str(),len*2,1,fptr);	
	bytes_written = fwrite((char *)char_array,len*2,1,fptr);	
	delete []char_array;
	
	/*REPLACED BY*/
	
	fflush(fptr);

return bytes_written;
}

bool CFileWriter::OpenFile(const string & fname)
{
	/* CHANGED IN THIS (LINUX) VERSION
	if(fptr)
		fclose(fptr);
	CHANGED IN THIS (LINUX) VERSION */
	CloseFile();

	fptr=fopen(fname.c_str(),"wb");

	if(!fptr)
		return false;

	unsigned short ch=0xFEFF;

	fwrite(&ch,sizeof(unsigned short),1,fptr);

	return true;
}
int CFileWriter::GetFPosition()
{
	return ftell(fptr);
}

CFileWriter::CFileWriter()
{
	counter++;
	fptr=NULL;
}
