#include "stdafx.h"
#include "GenerationBlock.h" /*CHANGED CASE TO MATCH ACTUAL FILENAME CASE*/

using namespace std;

int CGenerationBlock::counter=0;

CGenerationBlock::CGenerationBlock(CCStructure * tree)
{
	counter++;
	Tree=tree;
	//Sentence=L"";
	IsIncomplete=false;
}

CGenerationBlock::~CGenerationBlock()
{
	counter--;

	CGenerationItem*itm=NULL;
	
	while(!GenStack.empty())
	{
		itm=GenStack.top();
		GenStack.pop();
		delete itm;
	}

	delete Tree;
}

CGenerationBlock* CGenerationBlock::GetCloneEx(CGenerationItem* OldCurrentGenItem,
											   CGenerationItem**NewCurrentGenItem)
{
	using namespace std;

	map<CCStructureItem*,CCStructureItem*> CSMapTable;
	map<CFStructureItem*,CFStructureItem*> FSLinkTable;

	CCStructure * tree = Tree->GetCloneWithFSCSTables(CSMapTable,FSLinkTable);	

	//CFStructureItem * NewRoot=NULL;	    
	//SaveFSLinksRec(tree->Root,FSLinkTable);	
	//UpdateCStructureFSLinksRec(tree->Root,FSLinkTable);		

	CGenerationBlock*block=new CGenerationBlock(tree);
	
	stack<CGenerationItem*> GenItemStack;
	stack<CGenerationItem*> TempStack=GenStack;	

	CGenerationItem * temp=NULL;

	//Buiding Stack having items in reverse order

	while(!TempStack.empty())
	{
		temp=TempStack.top();
		TempStack.pop();
		GenItemStack.push(temp);
	}

	CGenerationItem * gitem=NULL;
	CCStructureItem * TreeNode=NULL;	
	
	CFStructureItem * UpFSPtr  =NULL;
	CFStructureItem * DownFSPtr=NULL;

	map<CCStructureItem*,CCStructureItem*>::iterator it;
	map<CFStructureItem*,CFStructureItem*>::iterator fit;

	while(!GenItemStack.empty())
	{
		temp=GenItemStack.top();		
		GenItemStack.pop();

		it=CSMapTable.find(temp->CurrentTreeNode);
			
		if(it!=CSMapTable.end())		
			TreeNode=it->second;
		else
		{
			TreeNode=NULL;
			#ifdef GenLog
			CLogManager::AddMessage(L"Gen Block Cloning: Pointer Not found for " + temp->CurrentTreeNode->Label + L" in CS-MapTable(s)\r\n");
			#endif
			return NULL;
		}

		UpFSPtr  =NULL;
		DownFSPtr=NULL;

		if(temp->UpFSPtr)
		{
			fit=FSLinkTable.find(temp->UpFSPtr); 
			
			if(fit!=FSLinkTable.end())
				UpFSPtr=fit->second;		
		}
		
		if(temp->DownFSPtr)
		{
			fit=FSLinkTable.find(temp->DownFSPtr); 
		
			if(fit!=FSLinkTable.end())
				DownFSPtr=fit->second;		
		}		

		if(UpFSPtr || DownFSPtr)
		{
			gitem=new CGenerationItem(UpFSPtr,DownFSPtr,temp->ProdSymbPtr,TreeNode);			
			block->GenStack.push(gitem);
		}
		else
		{	
			#ifdef GenLog
			CLogManager::AddMessage(L" Up & Down FS Pointers are not found for tree node: " + TreeNode->Label + L" in Map Table(s)\r\n");
			#endif
		}
	}

	it=CSMapTable.find(OldCurrentGenItem->CurrentTreeNode);	

	TreeNode=NULL;
	
	if(it!=CSMapTable.end())
	{
		TreeNode=it->second;			
	}
	else
	{
		TreeNode=NULL;
		#ifdef GenLog
		CLogManager::AddMessage(L"Current Tree Node: Gen Block Cloning: Pointer Not found for " + OldCurrentGenItem->CurrentTreeNode->Label + L" in CS-MapTable(s)\r\n");	
		#endif
	}
	
	UpFSPtr=NULL;
	if(OldCurrentGenItem->UpFSPtr)
	{
		fit=FSLinkTable.find(OldCurrentGenItem->UpFSPtr); 		
		if(fit!=FSLinkTable.end())
			UpFSPtr=fit->second;
		else
		{
			//clone UpFSPtr...
			UpFSPtr=OldCurrentGenItem->UpFSPtr->GetClone();
			UpFSPtr->ResolveReferencesForGenerator(FSLinkTable);			
		}
	}		

	DownFSPtr=NULL;
	if(OldCurrentGenItem->DownFSPtr)
	{
		fit=FSLinkTable.find(OldCurrentGenItem->DownFSPtr); 		
		if(fit!=FSLinkTable.end())
			DownFSPtr=fit->second;
		else
		{
			//clone UpFSPtr...
			DownFSPtr=OldCurrentGenItem->DownFSPtr->GetClone();
			DownFSPtr->ResolveReferencesForGenerator(FSLinkTable);			
		}
	}		
		
	if(UpFSPtr || DownFSPtr)
	{	
		*NewCurrentGenItem=new CGenerationItem(UpFSPtr,
											   DownFSPtr,
											   OldCurrentGenItem->ProdSymbPtr,
											   TreeNode);				
	}
	else
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"Current Gen Item: Up & Down FS Pointers are not found for tree node: " + TreeNode->Label + L" in Map Table(s)\r\n");
		#endif
		*NewCurrentGenItem=NULL;
	}

	return block;
}


CGenerationBlock* CGenerationBlock::GetClone(CGenerationItem* OldCurrentGenItem,
											 CGenerationItem**NewCurrentGenItem)
{
	using namespace std;
	
	map<CCStructureItem*,CCStructureItem*> CSMapTable;
	map<CFStructureItem*,CFStructureItem*> FSLinkTable;

	CCStructure * tree = Tree->GetCloneAndTable(&CSMapTable);
		
	CFStructureItem * NewFSLink=NULL;
	
    if(tree->Root->UpFSLink && tree->Root->UpFSLink->Label>=-1)
	{
		NewFSLink=tree->Root->UpFSLink->GetCloneWithTable(FSLinkTable);
		NewFSLink->UpdateLinkedNodeInfo(FSLinkTable);						
	}
	else
	{
		tree->Root->UpFSLink=NULL;
	}
	
	SaveFSLinksRec(tree->Root,FSLinkTable);

	/*if(tree->Root->DownFSLink)
	{
		//down link can exist on every node..........so
		//need to traverse each node and get old down - new down pointers...
		NewRoot=tree->Root->DownFSLink->GetCloneWithTable(FSLinkTable);

		NewRoot->UpdateLinkedNodeInfo(FSLinkTable);				
		//tree->Root->DownFSLink=NewRoot;
	}*/

	UpdateCStructureFSLinksRec(tree->Root,FSLinkTable);	

	/***///

	CGenerationBlock*block=new CGenerationBlock(tree);
	
	stack<CGenerationItem*> GenItemStack;
	stack<CGenerationItem*> TempStack=GenStack;	

	CGenerationItem * temp=NULL;

	//Buiding Stack having items in reverse order

	while(!TempStack.empty())
	{
		temp=TempStack.top();
		TempStack.pop();
		GenItemStack.push(temp);
	}

	CGenerationItem * gitem=NULL;
	CCStructureItem * TreeNode=NULL;	
	
	CFStructureItem * UpFSPtr  =NULL;
	CFStructureItem * DownFSPtr=NULL;

	map<CCStructureItem*,CCStructureItem*>::iterator it;
	map<CFStructureItem*,CFStructureItem*>::iterator fit;

	while(!GenItemStack.empty())
	{
		temp=GenItemStack.top();		
		GenItemStack.pop();

		it=CSMapTable.find(temp->CurrentTreeNode);
			
		if(it!=CSMapTable.end())		
			TreeNode=it->second;
		else
		{
			TreeNode=NULL;
			#ifdef GenLog
			CLogManager::AddMessage(L"Gen Block Cloning: Pointer Not found for " + temp->CurrentTreeNode->Label + L" in CS-MapTable(s)\r\n");
			#endif
			return NULL;
		}

		UpFSPtr  =NULL;
		DownFSPtr=NULL;

		if(temp->UpFSPtr)
		{
			fit=FSLinkTable.find(temp->UpFSPtr); 
			
			if(fit!=FSLinkTable.end())
				UpFSPtr=fit->second;		
		}
		
		if(temp->DownFSPtr)
		{
			fit=FSLinkTable.find(temp->DownFSPtr); 
		
			if(fit!=FSLinkTable.end())
				DownFSPtr=fit->second;		
		}		

		if(UpFSPtr || DownFSPtr)
		{
			gitem=new CGenerationItem(UpFSPtr,DownFSPtr,temp->ProdSymbPtr,TreeNode);			
			block->GenStack.push(gitem);
		}
		else
		{	
			#ifdef GenLog
			CLogManager::AddMessage(L" Up & Down FS Pointers are not found for tree node: " + TreeNode->Label + L" in Map Table(s)\r\n");
			#endif
		}
	}

	it=CSMapTable.find(OldCurrentGenItem->CurrentTreeNode);	

	TreeNode=NULL;
	
	if(it!=CSMapTable.end())
	{
		TreeNode=it->second;			
	}
	else
	{
		TreeNode=NULL;
		#ifdef GenLog
		CLogManager::AddMessage(L"Current Tree Node: Gen Block Cloning: Pointer Not found for " + OldCurrentGenItem->CurrentTreeNode->Label + L" in CS-MapTable(s)\r\n");	
		#endif
	}
	
	UpFSPtr=NULL;
	if(OldCurrentGenItem->UpFSPtr)
	{
		fit=FSLinkTable.find(OldCurrentGenItem->UpFSPtr); 		
		if(fit!=FSLinkTable.end())
			UpFSPtr=fit->second;
		else
		{
			//clone UpFSPtr...
			UpFSPtr=OldCurrentGenItem->UpFSPtr->GetCloneWithTable(FSLinkTable);
			UpFSPtr->UpdateGenRefInfo(FSLinkTable);
			//UpFSPtr->ResolveReferencesForGenerator(FSLinkTable);			
		}
	}		

	DownFSPtr=NULL;
	if(OldCurrentGenItem->DownFSPtr)
	{
		fit=FSLinkTable.find(OldCurrentGenItem->DownFSPtr); 		
		if(fit!=FSLinkTable.end())
			DownFSPtr=fit->second;
		else
		{
			//clone UpFSPtr...
			DownFSPtr=OldCurrentGenItem->DownFSPtr->GetCloneWithTable(FSLinkTable);
			DownFSPtr->UpdateGenRefInfo(FSLinkTable);
			//DownFSPtr->ResolveReferencesForGenerator(FSLinkTable);						
		}
	}		
		
	if(UpFSPtr || DownFSPtr)
	{	
		*NewCurrentGenItem=new CGenerationItem(UpFSPtr,
											   DownFSPtr,
											   OldCurrentGenItem->ProdSymbPtr,
											   TreeNode);				
	}
	else
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"Current Gen Item: Up & Down FS Pointers are not found for tree node: " + TreeNode->Label + L" in Map Table(s)\r\n");
		#endif
		*NewCurrentGenItem=NULL;
	}

	return block;
}

CGenerationBlock* CGenerationBlock::GetCloneWithClonedFSInfo(CCStructureItem*OldPtr,
															CCStructureItem**NewPtr)
{
	//There is no cloning of generation stack info....as it is not required here..

	using namespace std;	

	if(!Tree)
		return NULL;

	CCStructure*tree=Tree->GetClone(OldPtr,NewPtr);
	CGenerationBlock*block=new CGenerationBlock(tree);

	map<CFStructureItem*,CFStructureItem*> FSLinkTable;

	CFStructureItem * NewRoot=NULL;

    if(tree->Root->UpFSLink && tree->Root->UpFSLink->Label>=-1)
	{
		
		NewRoot=tree->Root->UpFSLink->GetCloneWithTable(FSLinkTable);
		SaveFSLinksRec(tree->Root,FSLinkTable);

		NewRoot->UpdateLinkedNodeInfo(FSLinkTable);
		//add check here also.....
		UpdateCStructureFSLinksRec(tree->Root,FSLinkTable);
		return block;
	}
	else
	{
		delete block;
	}

	return NULL;
}

void CGenerationBlock::UpdateCStructureFSLinksRec(CCStructureItem*csptr, 
												 map<CFStructureItem*,CFStructureItem*> & FSLinkTable)
{
	//currently added....		

	if(!csptr)	
		return;
	
	CFStructureItem*temp=NULL;
	map<CFStructureItem*,CFStructureItem*>::iterator it;
	
	if(csptr->UpFSLink)
	{
		it=FSLinkTable.find(csptr->UpFSLink);
        
		if(it!=FSLinkTable.end())    
		{
			csptr->UpFSLink=it->second;			
		}
		else/* if(csptr->UpFSLink->Label!=-1)*/
		{			
			temp=csptr->UpFSLink->GetCloneWithTable(FSLinkTable);
			//FSLinkTable.insert(fs_pair(csptr->UpFSLink,temp));
			csptr->UpFSLink=temp;			
			//wstring str1=CLexicon::GetConstantName(csptr->UpFSLink->Label);
			//CLogManager::AddMessage(L"UP: Link Not Found ???????????? for "+csptr->Label+L" ( " + str1 + L" )"+L"\r\n");
		}
	}

	if(csptr->DownFSLink)
	{
		it=FSLinkTable.find(csptr->DownFSLink);
	
		if(it!=FSLinkTable.end())		
		{
			csptr->DownFSLink=it->second;					
		}
		else /*if (csptr->DownFSLink->Label!=-1)*/
		{
			temp=csptr->DownFSLink->GetCloneWithTable(FSLinkTable);
			//FSLinkTable.insert(fs_pair(csptr->DownFSLink,temp));
			csptr->DownFSLink=temp;
			//wstring str1=CLexicon::GetConstantName(csptr->DownFSLink->Label);
			//CLogManager::AddMessage(L"Down: Link Not Found ???????????? for "+csptr->Label+L" ( " + str1 + L" )"+L"\r\n");
		}		
	}

	CCStructureItem*item=NULL;

	for(vector<CCStructureItem*>::iterator cit=csptr->ChildList.begin();
		cit!=csptr->ChildList.end();cit++)
	{
		item=*cit;
		UpdateCStructureFSLinksRec(item,FSLinkTable);
	}

	if(csptr->UpFSLink)
		csptr->UpFSLink->UpdateGenRefInfo(FSLinkTable);

	if(csptr->DownFSLink)
		csptr->DownFSLink->UpdateGenRefInfo(FSLinkTable);
}

bool CGenerationBlock::SaveFSLinksRec(CCStructureItem*csptr, 
									 map<CFStructureItem*,CFStructureItem*> & FSLinkTable)
{
	if(!csptr)	
		return false;
	
	map<CFStructureItem*,CFStructureItem*>::iterator it;
	CFStructureItem*temp=NULL;
	
	if(csptr->UpFSLink)
	{
		it=FSLinkTable.find(csptr->UpFSLink);        
		if(it==FSLinkTable.end())		
		{			
			temp=csptr->UpFSLink;
			temp=temp->GetCloneWithTable(FSLinkTable);	
			
			//added recently ... hit and try			
			//FSLinkTable.insert(fs_pair(csptr->UpFSLink,temp));
			//csptr->UpFSLink=temp;
			////////////////////////////////			

		}		
	}

	if(csptr->DownFSLink)
	{
		it=FSLinkTable.find(csptr->DownFSLink);	
		if(it==FSLinkTable.end())				
		{
			temp=csptr->DownFSLink;
			temp=temp->GetCloneWithTable(FSLinkTable);					
			
			//added recently ... hit and try
			//FSLinkTable.insert(fs_pair(csptr->DownFSLink,temp));
			//csptr->DownFSLink=temp;
			////////////////////////////////
		}		
	}

	CCStructureItem*item=NULL;

	for(vector<CCStructureItem*>::iterator cit=csptr->ChildList.begin();
		cit!=csptr->ChildList.end();cit++)
	{
		item=*cit;
		SaveFSLinksRec(item,FSLinkTable);
	}

	return true;
}
