#pragma once

/* ADDED IN THIS (LINUX) VERSION*/
#ifndef GENERATOR_H
#define GENERATOR_H
/* ADDED IN THIS (LINUX) VERSION*/

#include "stdafx.h"
#pragma warning(disable: 4786)

#include "CLexicon.h"
#include "CGrammar.h"
#include "GenerationItem.h"
#include "GenerationBlock.h"
#include "CConfiguration.h"
#include "CChart.h"
#include "GenChart.h"
#include "Mapper.h"
#include "FileWriter.h"
#include "MorphologicalGenerator.h"

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
/*#include <hash_map>REMOVED IN THIS (LINUX ONLY) VERSION*/

using namespace std;
/*using namespace stdext;REMOVED IN THIS (LINUX ONLY) VERSION*/

wstring stringToWstring(string);


/*****************************************************/
/*****************************************************/
/*****************************************************/

class Production
{
public:

	string LHS;
	vector<string> RHS;
	vector<string> RHSFDesc;
	string FirstSet;




	bool operator==(const Production & A)
	{
		if(A.RHS==this->RHS && A.RHSFDesc== this->RHSFDesc)
		{
			return true;
		}
		return false;
	}
};



class ProductionMerger
{
	hash_multimap<string,Production*> Productions;

	typedef pair<string,Production*> AProductionEntry;

public:

	bool IsEqualVecs(vector<Production*> & A,vector<Production*> & B)
	{
		if(A.size()!=B.size())
		{
			return false;
		}

		for(int i=0;i<A.size();i++)
		{
			bool IsEqual=false;

			for(int j=0;j<B.size();j++)
			{
				if(*A[i]==*B[j])
				{
					IsEqual = true;
				}
			}
			if(!IsEqual)
			{
				return false;
			}
		}

		return true;

	}



	bool GetALine(CFileReader & FHandler,string & A)
	{
		A="";
		short ch=0;
		
		while((ch=FHandler.GetCurrentChar())!=0)
		{
	start:
			switch(ch)
			{
					case LF:
					case CR:
	//				case ' ':
					case '\t':
						A="";

						break;

					case '.':
					{
						A+=ch;
						FHandler.MoveNext();
						return true;	// Line Ends
					}

					default:		
							A+=ch;
						
				}//end switch
		
			
			FHandler.MoveNext();
		}
		return false;
	}

	void LoadProductions(string Path)
	{
		CFileReader Fin(Path.c_str(),1024);

//		fstream Fin(Path.c_str(),ios::in);
		Production* tempProd;


//		char C[1000];

		string C;
		char c;
		string temp;
		int index=0;

		//Fin.getline(C,1000,'\n');
	//	Fin.getline(C,1000,'\n');

		//string ALine;
		GetALine(Fin,C);
		//strcpy(C,ALine.c_str());
		c = C[index++];

		while(1)
		{
			
			
			if(c!='[' && c!=']' && c!=':' && c!=';' && c!='.')
			{
				temp+=c;
			}
			else
			{
				temp = trim(temp);

				if(c=='[')
				{
					tempProd = new Production;
					tempProd->LHS = temp;
					
				}
				else if(c==']')
				{
					tempProd->FirstSet =temp;
				}
				else if(c=='.')
				{
					Productions.insert(AProductionEntry(tempProd->LHS,tempProd));
//					Fin.getline(C,1000,'\n');
					if(GetALine(Fin,C))
					{
						index=0;
					}
					else
					{
						index=0;
						break;
					}
				}
				else if(c==':')
				{
					tempProd->RHS.push_back(temp);
				}
				else if(c==';')
				{
					tempProd->RHSFDesc.push_back(temp);
				}

				temp="";
			}

			c = C[index++];

			if(c=='-')
			{
				c = C[index++];	// ignoring ->
				c = C[index++];
			}

		}
	}

	void WriteProductions()
	{
		Production* temp =0;
		string strWrite;


	//	fstream Out("MergedCFG.txt",ios::out);
						
		CFileWriter Out("MergedCFG.cfg");
		
//		cs_fw.Write(L"<C-Structures>");	



		for(hash_multimap<string,Production*>::iterator i = Productions.begin(); i!=Productions.end(); i++)
		{
			temp = i->second;
			
			strWrite = temp->LHS;
			strWrite+="[";
			strWrite+=temp->FirstSet;
			strWrite+="]";
			strWrite+="->";

			for(int ii=0;ii<temp->RHS.size();ii++)
			{
				strWrite+=" ";
				strWrite+=temp->RHS[ii];
				strWrite+=":";
				strWrite+=temp->RHSFDesc[ii];
				strWrite+=";";
			}
			
			strWrite+=".\r\n";

			Out.Write(stringToWstring(strWrite));

			strWrite="";

		}
	}

	void MergeProductions()
	{
		int index=0;

		vector<Production*> A,B;

		hash_multimap<string,Production*>::iterator i=Productions.begin();
		
		string Next;
		string Current;

		short count = -1 ; /*ADDED IN THIS (LINUX ONLY) VERSION - for iter, ok in win*/

		while(1)
		{

		Current = i->first;
		Next = Current;

		A.clear();

			while(Next==Current)
			{
				A.push_back(i->second);
				i++;
				count++ ; /*ADDED IN THIS (LINUX ONLY) VERSION - for iter, ok in win*/
				if(i==Productions.end())
				break;
				Next = i->first;
			}

			hash_multimap<string,Production*>::iterator j = i;

			if(i==Productions.end())
			{
				break;
			}

			while(j!=Productions.end())
			{
					Current = j->first;
					Next = Current;

				while(Next==Current)
				{
					B.push_back(j->second);
					j++;
					if(j==Productions.end())
						break;
					Next = j->first;
				}
			
				if(!IsEqualVecs(A,B))
				{
					B.clear();
				}	
				else
				{
					// Remove from All the Productions 
					// of B Prduction By A 
					for(hash_multimap<string,Production*>::iterator k = Productions.begin();k!=Productions.end();k++)
					{
						Production * temp = k->second;

						for(int rhsi=0;rhsi<temp->RHS.size();rhsi++)
						{
							if(temp->RHS[rhsi]==B[0]->LHS)
							{
								temp->RHS[rhsi]=A[0]->LHS;
							}
						}
					}

					/*i--; CHANGED IN THIS (LINUX ONLY) VERSION - ok in Win*/
					/*REPLACED WITH*/
hash_multimap<string,Production*>::iterator prevPtr =  Productions.begin();
for(int cnt = 0 ; cnt < count ; cnt++)
{
	if(cnt == count - 1)
		break ;
	else
		prevPtr++ ;
}
i = prevPtr ;
	
					/*END REPLACED WITH*/

					for(int ri=0;ri<B.size();ri++)
					{
						Productions.erase(B[0]->LHS);
					}

					i++;
				}

			}
		}
	}

	string trim(const string & A)
	{
		string trimedString="";
		/*for(int i=0;i<A.size();i++) CHANGED IN THIS (LINUX) VERSION*/
		int i;
		for(i=0;i<A.size();i++)
		{
			if(A[i]!=' ' && A[i]!=10 && A[i]!=8)
			{
				break;
			}
		}

		/*for(int j= A.size()-1;j>i;j--) CHANGED IN THIS (LINUX) VERSION*/
		int j;
		for(j= A.size()-1;j>i;j--)
		{
			if(A[j]!=' ' && A[j]!=10 && A[j]!=8)
			{
				break;
			}
		}

		for(;i<=j;i++)
		{
			trimedString+=A[i];
		}

	return trimedString;

	}

};



/*****************************************************/
/*****************************************************/
/*****************************************************/
class CGenerator
{
	private:
		/* REMOVED IN THIS (DOS/LINUX) VERSION
		bool GenerateXMLForCStructures(CChartItem *ParsedChartItem);
		
		bool GenerateXMLForCStructuresRec(CChartItem *ParsedChartItem,
										 CFileWriter & xml_writer);
		REMOVED IN THIS (DOS/LINUX) VERSION */
		CLexicon * UrduLexicon;		
		CGrammar * UrduGrammarManager;
		CMapper * MapperInterface;
		CChart  * UtilityInterface;	
		CMorphologicalGenerator *  MorphGenerator;
		map<short,short> SpecialUnmarkedItems;
		map<short,short> HeadlessPredicateList;					

		bool EvaluateExpressionForGenerator(wstring &wstr_in, 
											CFStructureItem * FSPtr_up,
											CFStructureItem * FSPtr_down,
											bool ReadOnlyMode=false);

		short CheckConstraintForGenerator(	CFStructureItem*up,
											CFStructureItem*down,
											wstring &left,
											wstring &right,
											bool ReadOnlyMode=false);
		
		void Enqueue (	CGenChart * genChart, 
						CChartItem *ChartItem,
						bool AddInLookupTable=false);	
		
		void Scanner(CChartItem* ChartItem, CProductionSymbol * ProdSymb);
		
		void Predictor(	CChartItem* ChartItem,
						CProductionSymbol*CurrentProdSymb);
		
		bool Completer(	CChartItem * ChartItem,
						list<wstring> & SenList,
						list<CFStructure*> & FSList);	

		bool FoundInChart(CGenChart * GenChart,
						  CChartItem *NewChartItem);

		CChartItem* an_attempt;
		int marking_failed;

	public:
					
		CGenerator(CMapper*mapper, 
				   CLexicon * ULexicon, 
				   CGrammar * UGrammarMngr,
				   CMorphologicalGenerator * MorphGen);

		void LogUnificationError(CFDescription*fdesc);
		
		bool SetUpAndDownFStructures(CFDescription*fdptr,
									 CGenerationItem*GenItem,
									 bool AllowLinking,
									 bool ReadOnlyMode=false);

		bool UnifyForGenerator(CFStructureItem * & fL, 
						  CFStructureItem *fR, 
						  vector<short> *vR,
						  bool ApplySetUnification=false,
						  bool ReadOnlyMode=false);

		~CGenerator();
		
		bool ProduceGenerationBlocks(CFStructure * TargetFS, 								   
								   list<CGenerationBlock*> & FinalGenBlockList);


		//void GenerateFStructuresXML(list<CGenerationBlock*> & BlockList);
		
		/* REMOVING FROM THIS (DOS/LINUX) VERSION
		void GenerateFStructuresXML(list<CFStructure*> & FSList);
		bool GenerateFStructuresXMLRec(CFStructureItem* CSPtr,CFileWriter * FilePtr);
		void GenerateCStructuresXML(list<CGenerationBlock*> & BlockList);
		bool GenerateCStructuresXMLRec(CCStructureItem* CSPtr,CFileWriter * FilePtr);
		REMOVING FROM THIS (DOS/LINUX) VERSION */

		void GenerateWords(list<CGenerationBlock*> & BlockList);
	//	bool GenerateWordsRec(CCStructureItem* CSPtr,CGenerationBlock*GenBlock,list<CGenerationBlock*> & BlockList);
		//bool GenerateWord(CCStructureItem* CSPtr,CGenerationBlock*GenBlock,list<CGenerationBlock*> & BlockList);

		bool GenerateWord(	CChartItem * CurrentChartItem, 						
							CProductionSymbol*ProdSymb);

		vector<CFStructureItem*> GetLinkedFSItems(CFStructureItem* FSPtr);
		
		bool MakeGenerationBlockItem(stack<CGenerationBlock*>* BkpStk, 
									CGenerationBlock* GenBlock, 
									CGenerationItem*CurrentGenItem,
									vector<CProduction*>* ProdList);
		
		bool LoadGenItemFromProduction(	CProduction * production, 
										CGenerationBlock* GenBlock,
										CGenerationItem*CurrentGenItem);

		vector<CProduction*> GetProductionListEx(CProductionSymbol* ProdSymb, CFStructureItem* FSPtr);

		bool CheckProductionValidity(CProduction* prod, CFStructureItem* FSPtr);
		CFStructureItem* GetRelevantFSPtr(CFStructureItem* FSPtr, CProductionSymbol* prodsymb);

		bool ApplyUnification(	CFDescription  * FDesc, 
								CFStructureItem * FSPtrUp, 
								CFStructureItem * FSPtrDown,
								bool ReadOnlyMode=false);

		CFStructureItem* GetSetNextElement(	CFStructureItem* set_item,
											bool ReadOnlyMode=false);		

		CFDescription* GenerateFDescription(wstring &  fdstr);
		bool GenerateSentenceList(list<CGenerationBlock*> * GenBlockList, 
								  list<wstring> * SenList);
		
		bool GenerateSentenceListRec(CCStructureItem* cnode, 
									 std::wstring & sentence);

		bool RefineSentences(list<wstring> * SenList);

		list<wstring> GenerateSentencesEx(vector<CFStructure*> & TargetFSList);
		bool CheckFStructureIsMarked(CFStructureItem* FSPtr);
		vector<CLexicalEntry*> * GenerateLexEntriesByMorphGenerator(wstring word, wstring POS, CFStructureItem* fs);

		/////////////		NEW
		void Generator(CFStructure* FSPtr,
					   list<wstring> & SenList,
					   list<CFStructure*> & FSList);
		
//		void Enqueue(vector<CChartItem*> *Chart,CChartItem *ChartItem);
		
		void MakeSentencesByWords(CChartItem *ParsedChartItem,wstring &sent);

		bool SetUpAndDownFStructuresEx(	CFDescription*fdptr,
										CChartItem * ChartItem,
										CProductionSymbol * ProdSymb,
										bool AllowLinking,
										bool ReadOnlyMode=false);
		
	private:

		hash_multimap<int,CChartItem*> LookUpTable;
		CGenChart GenerationChart;
		CGenChart BackupGenerationChart;

		short SourceSymbolId;

/////////////
public:
	bool ApplyConstraints(	CFStructureItem* UpFSPtr, 
							CFStructureItem* DownFSPtr, 
							CProductionSymbol* ProdSymb, 
							bool ReadOnlyFlag);

	bool UpdateProductionFSPointers(CChartItem* ChartItem);
	bool CollectGarbage(void);
	bool EvaluateConstraintsAndConditionsInReadOnlyMode(CProduction* prod, CFStructureItem* FSPtr);
	bool DeleteFDescList(vector<CFDescription*> & FDescList);

};
#endif /* ADDED IN THIS (LINUX) VERSION*/
