// LexIndex.cpp: implementation of the CLexIndex class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)


/*#include "LanguageParser.h" REMOVING IN THIS (DOS/LINUX VERSION)*/
#include "LexIndex.h"

#include "LogManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
/*#define new DEBUG_NEW [REMOVING IN THIS (DOS/LINUX) VERSION] */
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CLexIndex::counter=0;


CLexIndex::CLexIndex()
{
	counter++;
}

CLexIndex::~CLexIndex()
{
	counter--;

	/************** DESTRUCT LEXICON INDEX ************/
	
	multimap<wstring,CLexIndexItem*>::iterator ind_it = Lexicon.begin();
	
	while( ind_it != Lexicon.end() )
	{
		CLexIndexItem * this_ind = ind_it->second;
		try{
		delete this_ind;
		this_ind=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### this_ind");
			#endif
		}

		ind_it++;
	}

	Lexicon.clear();
}

void CLexIndex::Add(wstring entry, int fileindex , int sizeofent)
{
	typedef pair <wstring,CLexIndexItem*> StrLexIndPair;
	CLexIndexItem* new_item = new CLexIndexItem();
	
	new_item->word = entry;
	new_item->length = sizeofent;
	new_item->index = fileindex;

	Lexicon.insert( StrLexIndPair(entry , new_item) );
}
