#include "stdafx.h"
/*#include ".\mtengine.h" REMOVED IN THIS (LINUX) VERSION*/

/*#include "afxwin.h" [REMOVING IN THIS (DOS/LINUX) VERSION] */
#include "FileWriter.h"
#include "MTEngine.h"
#include "global.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "FileReader.h"
#include "CSentence.h"
#include "CConfiguration.h"

CMTEngine::CMTEngine()
{		
//	P_init();
}

CMTEngine::~CMTEngine()
{
	/*destroy();REMOVED IN THIS (LINUX) VERSION (ALT SOLUTION?)*/
}


void CMTEngine::init()
{	
	//SendMessage( hwndPB , (UINT) PBM_STEPIT , 0 , 0 ) ;
	//AfxMessageBox(L"hello" , 1 , 1 ) ;
	//SendMessage(*hwndPB , (UINT) PBM_STEPIT , 0 , 0 ) ;
	//AfxMessageBox(L"bye" , 1 , 1 ) ;
	//int x=(int)hwndPB;
	//CString str;
	//str.Format(1,"%d",x);
	//AfxMessageBox(str);

	unsigned short DIR_PATH[200];

	/* REMOVING IN THIS (DOS/LINUX) VERSION
	GetCurrentDirectory(200,(LPWSTR)DIR_PATH);
	
	DirPath=(LPWSTR)DIR_PATH;
	DirPath+=L"\\data\\English\\ECS.xml";	
	REMOVING IN THIS (DOS/LINUX) VERSION */
	try
	{						
		//CConfiguration::InitializeConfigInfo("EConfig.inf",false);
		//CLogManager::InitializeLogManager("data\\LogFile.Log");
			
		string CompileLexicon=CConfiguration::GetConfigInfo("CompileLexicon",true);			

		string InsertRulesRawFName=CConfiguration::GetConfigInfo("InsertRulesRawFileName");	
		string InsertRulesMacroFName=CConfiguration::GetConfigInfo("InsertRulesMacrosFileName");
		string InsertRulesExtFName=CConfiguration::GetConfigInfo("InsertRulesExtFileName");
							
		string GRulesFName=CConfiguration::GetConfigInfo("GrammarRulesFileName");
		string GMacrosFName=CConfiguration::GetConfigInfo("GrammarMacrosFileName");			
		string LFG_FName=CConfiguration::GetConfigInfo("lfgFileName");
		string CFG_FName=CConfiguration::GetConfigInfo("cfgFileName");
		
		string SymbTblLogFName=CConfiguration::GetConfigInfo("SymbTblLogFileName");	
					
		string MapRulesMacroFName=CConfiguration::GetConfigInfo("MappingRulesMacrosFileName");	
		string MapRulesRawFName=CConfiguration::GetConfigInfo("MappingRulesRawFileName");	
		string MapRulesExtFName=CConfiguration::GetConfigInfo("MappingRulesExtFileName");	
		
		string MapLexMacroFName=CConfiguration::GetConfigInfo("MappingLexiconMacrosFileName");	
		string MapLexRawFName=CConfiguration::GetConfigInfo("MappingLexiconRawFileName");	
		string MapLexExtFName=CConfiguration::GetConfigInfo("MappingLexiconExtFileName");	
		
		string DelimFName = CConfiguration::GetConfigInfo("DelimFileName");
		string TransRulesFName=CConfiguration::GetConfigInfo("TransRulesFileName");
		string ESymbTblLogFName=CConfiguration::GetConfigInfo("SymbTblLogFileName");

		string SubCatFrameListFName = CConfiguration::GetConfigInfo("SubCatFrameListFileName");
		string OrderedFeatureListFName=CConfiguration::GetConfigInfo("EOrderedFeatureListFileName");
		
		string mlfstr=CConfiguration::GetConfigInfo("MapLexStdFreq",true);
		string mrfstr=CConfiguration::GetConfigInfo("MapRulesStdFreq",true);

		string DiscourseFileName=CConfiguration::GetConfigInfo("DiscourseFileName");

		////////////////////////////////////////////////////////////////////////////
		if(CompileLexicon!="yes")/////load symbol table
		{
			CSymbolTableManager::ReadSymbolTableFromFile();	
		}
		///////////////////////////////////////////////////////////////////////////

		double MapLexStandardFrequency=atof(mlfstr.c_str());
		double MapRulesStandardFrequency=atof(mrfstr.c_str());		
		
		LexiconPtr = new CLexicon("E",false);					

		TokenizerPtr=new CTokenizer(LexiconPtr);	
		
		GrammarMngr=new CGrammar(	GRulesFName,
									GMacrosFName,
									LFG_FName,
				 					CFG_FName,
									LexiconPtr);	

		CSymbolTableManager::SetDataMemberValues();
		
		//LexiconPtr->CheckSymbolTableConsistency(ESymbTblLogFName);
		
		GFId=CSymbolTableManager::GFId;
		PredId=CSymbolTableManager::PredId;

		ChartParser=new CChart(GrammarMngr,SubCatFrameListFName);	
		
		MappController=new CMapperController(
											 MapRulesMacroFName,
											 MapRulesRawFName,
											 MapRulesExtFName,
											 MapLexMacroFName,
											 MapLexRawFName,
											 MapLexExtFName,
											 MapRulesMacroFName,
											 InsertRulesRawFName,
											 InsertRulesExtFName,
											 MapLexStandardFrequency,
											 MapRulesStandardFrequency,
											 TransRulesFName,
											 LexiconPtr,
											 ChartParser);
		
		UrduLexicon=new CLexicon("U",true);	
		
		MorphGenerator=new CMorphologicalGenerator(UrduLexicon);

		UrduGrammarManager=new CGrammar(CConfiguration::GetConfigInfo("UGrammarRulesFileName"),
										CConfiguration::GetConfigInfo("UGrammarMacrosFileName"),
										CConfiguration::GetConfigInfo("UlfgFileName"),
										CConfiguration::GetConfigInfo("UcfgFileName"),
										UrduLexicon,true,true);

		Generator=new CGenerator(&MappController->Mapper,
				UrduLexicon,UrduGrammarManager,MorphGenerator);	
		
		DiscourseResolver = new CDiscourse(DiscourseFileName);

		////////////////////////////////////////////////////////////////////////////
		if(CompileLexicon=="yes")/////load symbol table
		{
			CSymbolTableManager::WriteSymbolTableInFile();
		}
		///////////////////////////////////////////////////////////////////////////

	}
	catch(...) /*CHANGED IN THIS (DOS/LINUX) VERSION*/
	{
		CLogManager::AddMessage(L"Exception occurred in MTEngine::init() function \r\n");		
	}	

	/*

	//wstring str1=L"qwejkl hqwe-tahir,";
	//wstring str2=str1.substr(0,str1.size()-1);

	unsigned short DIR_PATH[200];
	
	GetCurrentDirectory(200,DIR_PATH);
	
	DirPath=DIR_PATH;
	DirPath+=L"\\data\\English\\ECS.xml";	

	//temporary
	//CLexicon*ULexiconPtr=NULL;
	
	try
	{												
		string InsertRulesRawFName=CConfiguration::GetConfigInfo("InsertRulesRawFileName");	
		string InsertRulesMacroFName=CConfiguration::GetConfigInfo("InsertRulesMacrosFileName");
		string InsertRulesExtFName=CConfiguration::GetConfigInfo("InsertRulesExtFileName");
		
		////////////////////////
				
		string GRulesFName=CConfiguration::GetConfigInfo("GrammarRulesFileName");
		string GMacrosFName=CConfiguration::GetConfigInfo("GrammarMacrosFileName");			
		string LFG_FName=CConfiguration::GetConfigInfo("lfgFileName");
		string CFG_FName=CConfiguration::GetConfigInfo("cfgFileName");
		
		string SymbTblLogFName=CConfiguration::GetConfigInfo("SymbTblLogFileName");	
					
		string MapRulesMacroFName=CConfiguration::GetConfigInfo("MappingRulesMacrosFileName");	
		string MapRulesRawFName=CConfiguration::GetConfigInfo("MappingRulesRawFileName");	
		string MapRulesExtFName=CConfiguration::GetConfigInfo("MappingRulesExtFileName");	
		
		string MapLexMacroFName=CConfiguration::GetConfigInfo("MappingLexiconMacrosFileName");	
		string MapLexRawFName=CConfiguration::GetConfigInfo("MappingLexiconRawFileName");	
		string MapLexExtFName=CConfiguration::GetConfigInfo("MappingLexiconExtFileName");	
		
		string DelimFName = CConfiguration::GetConfigInfo("DelimFileName");
		string TransRulesFName=CConfiguration::GetConfigInfo("TransRulesFileName");
		string ESymbTblLogFName=CConfiguration::GetConfigInfo("SymbTblLogFileName");

		string SubCatFrameListFName = CConfiguration::GetConfigInfo("SubCatFrameListFileName");
		string OrderedFeatureListFName=CConfiguration::GetConfigInfo("EOrderedFeatureListFileName");
		
		string mlfstr=CConfiguration::GetConfigInfo("MapLexStdFreq");
		string mrfstr=CConfiguration::GetConfigInfo("MapRulesStdFreq");

		string DiscourseFileName=CConfiguration::GetConfigInfo("DiscourseFileName");

		//string CommonSymbolTableFileName=CConfiguration::GetConfigInfo("CommonSymbolTableFileName");
		
		//if(!CSymbolTableManager::ReadSymbolTableFromFile())
		//	CLogManager::AddMessage(L"Symbol Table file could not be loaded.");

		double MapLexStandardFrequency=atof(mlfstr.c_str());
		double MapRulesStandardFrequency=atof(mrfstr.c_str());		
		
		LexiconPtr = new CLexicon("E",false);			

		//ULexiconPtr = new CLexicon(ConfigMngr,"U",true);			

		TokenizerPtr=new CTokenizer(LexiconPtr);	
		
		GrammarMngr=new CGrammar(	GRulesFName,
									GMacrosFName,
									LFG_FName,
				 					CFG_FName,
									LexiconPtr);	

		CSymbolTableManager::SetDataMemberValues();
		
		//LexiconPtr->CheckSymbolTableConsistency(ESymbTblLogFName);
		
		GFId=CSymbolTableManager::GFId;
		PredId=CSymbolTableManager::PredId;

		ChartParser=new CChart(GrammarMngr,SubCatFrameListFName);					

		MappController=new CMapperController(
											 MapRulesMacroFName,
											 MapRulesRawFName,
											 MapRulesExtFName,
											 MapLexMacroFName,
											 MapLexRawFName,
											 MapLexExtFName,
											 MapRulesMacroFName,
											 InsertRulesRawFName,
											 InsertRulesExtFName,
											 MapLexStandardFrequency,
											 MapRulesStandardFrequency,
											 TransRulesFName,
											 LexiconPtr,
											 ChartParser);
		
		UrduLexicon=new CLexicon("U",true);	
		
		MorphGenerator=new CMorphologicalGenerator(UrduLexicon);

		UrduGrammarManager=new CGrammar(CConfiguration::GetConfigInfo("UGrammarRulesFileName"),
										CConfiguration::GetConfigInfo("UGrammarMacrosFileName"),
										CConfiguration::GetConfigInfo("UlfgFileName"),
										CConfiguration::GetConfigInfo("UcfgFileName"),
										UrduLexicon,true,true);

		Generator=new CGenerator(&MappController->Mapper,
				UrduLexicon,UrduGrammarManager,MorphGenerator);	
		
		DiscourseResolver = new CDiscourse(DiscourseFileName);

	}
	catch(CException*exp)
	{
		unsigned short p[100];		
		exp->GetErrorMessage(p,100);		
		//MessageBox(p);
	}
	*/
}

/* not needed
wstring CMTEngine::TranslateSentence(wstring& sentence) 
{
	wstring UrduSentence=L"";	

	RemoveEndMarkers(sentence);

	short slen=sentence.size();			
				
	vector<CLEList*> * lex_list=TokenizerPtr->GetTokenList(sentence);

	if(!lex_list)	
		return UrduSentence;
		
	CFStructure*tfs=NULL;
	
	list<CFSCSPairInfo*> SourceInfoList;
	
	CFSCSPairInfo*sinfo=NULL;

	ChartParser->EarleyParse(lex_list,SourceInfoList,true);
		
	if(SourceInfoList.size()>0)
	{				
		vector<CFStructure*> TargetFSCollection;

		CSourceTargetFSInfo*temp=NULL;
		vector<CSourceTargetFSInfo*> * STList=NULL;
		
		STList=MappController->GenerateTargetFStructuresEx(SourceInfoList);		

		//////////////////////////////MM///////////10.08.2005//////////////
		for(list<CFSCSPairInfo*>::iterator it=SourceInfoList.begin();
			it!=SourceInfoList.end();it++)
		{
			sinfo=*it;
			delete sinfo;
		}
		SourceInfoList.clear();
		//////////////////////////////////////////////////////////////////
			
		list<wstring> SentenceList;

		if(STList)
		{
			for(vector<CSourceTargetFSInfo*>::iterator it3=STList->begin();
				it3!=STList->end();it3++)
			{		
				temp=*it3;

				for(vector<CFStructure*>::iterator it=temp->TargetFSList.begin();it!=temp->TargetFSList.end();it++)
				{	
					tfs=*it;
					
					////////////////////////////////////////////////////////////
					tfs->insertCommon(UrduLexicon->CommonLexicalFeatureTable);
					DiscourseResolver->Apply(tfs->Root);						
					tfs->SetParentPointers(); //added on 04-08-2005
					////////////////////////////////////////////////////////////

					//////////Added For Generator//////////
					TargetFSCollection.push_back(tfs);
					///////////////////////////////////////			
				}	
				
				//deleting temp
				delete temp;
			}							

				STList->clear();
				delete STList;
			}
			else
			{
				CLogManager::AddMessage(L"Sentence Target Urdu F-Structure could not be generated.\r\n");
			}						

		 	if(Generator && TargetFSCollection.size()>0)
			{			
				CLogManager::AddMessage(L"Generator Started: ");

				SentenceList=Generator->GenerateSentencesEx(TargetFSCollection);

				if(SentenceList.size()>0)
				{					
					list<wstring>::iterator sit=SentenceList.begin();
					UrduSentence=*sit;
					
					//////////////////////////////////////////////////
					// Un-Comment Following if muliple generated
					// sentences would be required.
					//////////////////////////////////////////////////

					//sit++;
					//for(;sit!=SentenceList.end();sit++)
					//{	
					//	if((*sit).size()>UrduSentence)
					//	UrduSentence+=L", ";
					//	UrduSentence+=*sit;						
					//}										

					//////////////////////////////////////////////////
					//////////////////////////////////////////////////
				}
			}			
		}
		else
		{
			CLogManager::AddMessage(L"Sentence could not be parsed.\r\n");
		}

		if(lex_list)
		{
			try			
			{	
				CLEList * le_itm = NULL;
				
				vector<CLEList*>::iterator vit=lex_list->begin();
				vector<CLexicalEntry*>::iterator le_it;

				for(;vit!=lex_list->end();vit++)
				{
					le_itm=*vit;
					le_itm->clear();
					delete le_itm;					
				}
				lex_list->clear();
				delete lex_list;		
			}
			catch(...)
			{
				CLogManager::AddMessage(L"#### lex_list");
			}
		}
		else
		{
			CLogManager::AddMessage(L"Sentence Could not be parsed.");
		}			   

		CLogManager::AddMessage(L"Generated Urdu Sentences: "+UrduSentence+L"\r\n");

		CollectGarbage();

	return UrduSentence;
}
*/

void CMTEngine::TestTokenizer(vector<CLEList*> * le_list)
{
	if(!le_list)
		return;
	
	using namespace std;

	/*CFileWriter fw1("data\\tokens.tok"); CHANGED IN THIS (LINUX ONLY) VERSION*/
	CFileWriter fw1("Data/tokens.tok");

	CLEList*list=NULL;
	CLexicalEntry*le=NULL;
	wstring data;
	wstring temp;

	for(vector<CLEList*>::iterator it=le_list->begin();it!=le_list->end();it++)
	{
		list=*it;
		for(vector<CLexicalEntry*>::iterator it2=list->begin();it2!=list->end();it2++)
		{
			le=*it2;
			
			/*data=le->Word;
			data+=L"\t\t";
			temp=CSymbolTableManager::GetString(le->POS);
			data+=temp;
			data+=L"\r\n";
			fw1.Write(data);	*/
			data=le->ToString();
			data+=L"\r\n";
			fw1.Write(data);	
		}
	}

	fw1.CloseFile();
}	


void CMTEngine::destroy()
{			
	/////////////////////////////English Language Parser/////////////////////
	try{


		if(LexiconPtr)
		{
			delete LexiconPtr;	
			LexiconPtr=NULL;
		}

		if(TokenizerPtr)
		{
			delete TokenizerPtr;	
			TokenizerPtr=NULL;
		}
		
		if(ChartParser)
		{
			delete ChartParser;	
			ChartParser=NULL;
		}

		if(GrammarMngr)
		{
			delete GrammarMngr;		
			GrammarMngr=NULL;
		}

		if(MappController)
		{
			delete MappController;
			MappController=NULL;
		}

		if(Generator)
		{
			delete Generator;
			Generator=NULL;
		}
		
		if(UrduLexicon)
		{
			delete UrduLexicon;
			UrduLexicon=NULL;
		}

		if(UrduGrammarManager)
		{
			delete UrduGrammarManager;
			UrduGrammarManager=NULL;
		}

		if(MorphGenerator)
		{
			delete MorphGenerator;
			MorphGenerator=NULL;
		}

		if(DiscourseResolver)
		{
			delete DiscourseResolver;
			DiscourseResolver=NULL;
		}

	}
	catch(...)
	{
		CLogManager::AddMessage(L" destroy() -- exception");
	}

}

bool CMTEngine::CollectGarbage(void)
{
	Generator->CollectGarbage();

	CProduction::CollectSelectiveGarbage();
	
	if(ChartParser)
		ChartParser->ClearChart();	

	CFStructure::CollectGarbage();
	CFStructureItem::CollectGarbage();

	return true;
}

bool CMTEngine::RemoveEndMarkers(wstring & Sentence)
{
	CLogManager::AddMessage(Sentence);

	TrimString(Sentence);
	size_t SenLen=Sentence.size();
	size_t index=SenLen-1;

	//CLogManager::AddMessage(enLen);
	
	
	while(index>0)
	{
		/*if(	Sentence[index]!='.' &&
			Sentence[index]!=':' && 
			Sentence[index]!=';' && 
			Sentence[index]!='!' && 
			Sentence[index]!='|')
		{
			break;			
		}*/

		if(isalpha(Sentence[index]))//<'a' || Sentence[index]>'Z')
		{
			break;
		}
	
		index--;
	}

	if(index!=SenLen-1)
		Sentence=Sentence.substr(0,index+1);

	CLogManager::AddMessage(Sentence);

	return true;
}

void CMTEngine::P_init(void)
{
	unsigned short DIR_PATH[200];
	/* REMOVING IN THIS (DOS/LINUX) VERSION
	GetCurrentDirectory(200,(LPWSTR)DIR_PATH);
	
	DirPath=(LPWSTR)DIR_PATH;
	DirPath+=L"\\data\\LFGParserCStructures.xml";	
	REMOVING IN THIS (DOS/LINUX) VERSION */	
	try
	{						
		CConfiguration::InitializeConfigInfo("EConfig.inf",false);/* USEREGPATH MADE FALSE FOR THIS (DOS/LINUX) VERSION */
		CLogManager::InitializeLogManager("Data/LogFile.Log"); /*CHANGED IN THIS (LINUX ONLY) VERSION*/
			
		string CompileLexicon=CConfiguration::GetConfigInfo("CompileLexicon",true);			

		string InsertRulesRawFName=CConfiguration::GetConfigInfo("InsertRulesRawFileName");	
		string InsertRulesMacroFName=CConfiguration::GetConfigInfo("InsertRulesMacrosFileName");
		string InsertRulesExtFName=CConfiguration::GetConfigInfo("InsertRulesExtFileName");
							
		string GRulesFName=CConfiguration::GetConfigInfo("GrammarRulesFileName");
		string GMacrosFName=CConfiguration::GetConfigInfo("GrammarMacrosFileName");			
		string LFG_FName=CConfiguration::GetConfigInfo("lfgFileName");
		string CFG_FName=CConfiguration::GetConfigInfo("cfgFileName");
		
		string SymbTblLogFName=CConfiguration::GetConfigInfo("SymbTblLogFileName");	
					
		string MapRulesMacroFName=CConfiguration::GetConfigInfo("MappingRulesMacrosFileName");	
		string MapRulesRawFName=CConfiguration::GetConfigInfo("MappingRulesRawFileName");	
		string MapRulesExtFName=CConfiguration::GetConfigInfo("MappingRulesExtFileName");	
		
		string MapLexMacroFName=CConfiguration::GetConfigInfo("MappingLexiconMacrosFileName");	
		string MapLexRawFName=CConfiguration::GetConfigInfo("MappingLexiconRawFileName");	
		string MapLexExtFName=CConfiguration::GetConfigInfo("MappingLexiconExtFileName");	
		
		string DelimFName = CConfiguration::GetConfigInfo("DelimFileName");
		string TransRulesFName=CConfiguration::GetConfigInfo("TransRulesFileName");
		string ESymbTblLogFName=CConfiguration::GetConfigInfo("SymbTblLogFileName");

		string SubCatFrameListFName = CConfiguration::GetConfigInfo("SubCatFrameListFileName");
		string OrderedFeatureListFName=CConfiguration::GetConfigInfo("EOrderedFeatureListFileName");
		
		string mlfstr=CConfiguration::GetConfigInfo("MapLexStdFreq",true);
		string mrfstr=CConfiguration::GetConfigInfo("MapRulesStdFreq",true);

		string DiscourseFileName=CConfiguration::GetConfigInfo("DiscourseFileName");

		////////////////////////////////////////////////////////////////////////////
		if(CompileLexicon!="yes")/////load symbol table
		{
			CSymbolTableManager::ReadSymbolTableFromFile();
			CSymbolTableManager::ReadinSTFDescriptions();
		}
		///////////////////////////////////////////////////////////////////////////

		double MapLexStandardFrequency=atof(mlfstr.c_str());
		double MapRulesStandardFrequency=atof(mrfstr.c_str());		

		//#TAHIRA#//LexiconPtr = new CLexicon("E",false);					
		
		//##########TAHIRA#############	
		//Dummy constructor only for loading ordered feature list
		LexiconPtr = new CLexicon("E");	
		//##########TAHIRA#############	

		//#TAHIRA#//TokenizerPtr=new CTokenizer(LexiconPtr);	
		
		//#TAHIRA#//GrammarMngr=new CGrammar(	GRulesFName,
		//#TAHIRA#//							GMacrosFName,
		//#TAHIRA#//							LFG_FName,
		//#TAHIRA#//		 					CFG_FName,
		//#TAHIRA#//							LexiconPtr);	

		CSymbolTableManager::SetDataMemberValues();
		
		//LexiconPtr->CheckSymbolTableConsistency(ESymbTblLogFName);
		
		GFId=CSymbolTableManager::GFId;
		PredId=CSymbolTableManager::PredId;

		//#TAHIRA#//ChartParser=new CChart(GrammarMngr,SubCatFrameListFName);	
		
        
		//##########TAHIRA#############	
		ChartParser=new CChart(SubCatFrameListFName);	//just to load subcat frames at right time
		string elex=CConfiguration::GetConfigInfo("ELexiconFileName");
		P_FSInitializer::init();
		
		if(CConfiguration::GetConfigInfo("CompileP_Grammar", true)!="yes")
		{
			P_FSInitializer::LoadP_FSInitializer();
			P_FSSymbolTable::Load_SymbolTable();
		}	

		PGrammar=new P_Grammar(GRulesFName,
									GMacrosFName,
									LFG_FName,
				 					CFG_FName,
									true);
		PLexicon=new P_Lexicon(elex,PGrammar);
		PScanner=new P_Scanner(PLexicon);
		PChartParser=new P_ChartParser(PLexicon,PGrammar,PScanner);
		//##########TAHIRA#############	

		// HUDA

		// END HUDA
		
		MappController=new CMapperController(
											 MapRulesMacroFName,
											 MapRulesRawFName,
											 MapRulesExtFName,
											 MapLexMacroFName,
											 MapLexRawFName,
											 MapLexExtFName,
											 MapRulesMacroFName,
											 InsertRulesRawFName,
											 InsertRulesExtFName,
											 MapLexStandardFrequency,
											 MapRulesStandardFrequency,
											 TransRulesFName,
											 LexiconPtr,
											 ChartParser);
		
		UrduLexicon=new CLexicon("U",true);	
		
		MorphGenerator=new CMorphologicalGenerator(UrduLexicon);

		UrduGrammarManager=new CGrammar(CConfiguration::GetConfigInfo("UGrammarRulesFileName"),
										CConfiguration::GetConfigInfo("UGrammarMacrosFileName"),
										CConfiguration::GetConfigInfo("UlfgFileName"),
										CConfiguration::GetConfigInfo("UcfgFileName"),
										UrduLexicon,false,true);

		Generator=new CGenerator(&MappController->Mapper,
				UrduLexicon,UrduGrammarManager,MorphGenerator);	
		
		DiscourseResolver = new CDiscourse(DiscourseFileName);

		if(CConfiguration::GetConfigInfo("CompileP_Grammar", true)=="yes")
		{
			P_FSInitializer::DumpP_FSInitializer();
			P_FSSymbolTable::Dump_SymbolTable();
		}
		P_FSInitializer::endInitialization();

		////////////////////////////////////////////////////////////////////////////
		if(CompileLexicon=="yes")/////load symbol table
		{
			CSymbolTableManager::WriteSymbolTableInFile();
		}
		///////////////////////////////////////////////////////////////////////////
		
		// for segmentation (huda 25-08-06)
		string pos_filename = CConfiguration::GetConfigInfo("POSs");
		string segment_sentence_str = CConfiguration::GetConfigInfo("SegmentSentence", true);
		string min_length_str = CConfiguration::GetConfigInfo("MinSentLengthForSegmentation", true);
		
		POSTable::initialize(pos_filename);
		string SegmentRulesFileName=CConfiguration::GetConfigInfo("SegmentRules");
		PSegmenter = new P_Segmenter(SegmentRulesFileName);

		if (segment_sentence_str == "yes")
			segment_sentence = true;
		else
			segment_sentence = false;

		min_sentence_length = atoi(min_length_str.c_str());

		Transliterator = new CTransliterator(TransRulesFName);
		// for segmentatio (huda 25-08-06) END
	}
	/* CHANGED IN THIS (DOS/LINUX) VERSION */ 
	catch(...)
	{
	//	unsigned short p[100];		
	//	exp->GetErrorMessage((LPTSTR)p,100);		
//		MessageBox(p);
		CLogManager::AddMessage(L"Exception thrown in P_init().");
	}	
	/* CHANGED IN THIS (DOS/LINUX) VERSION */
}

/* OLD
wstring CMTEngine::P_TranslateSentence(wstring& sentence)
{
		
//#TAHIRA#//
	short slen=sentence.size();			
	
	PScanner->init(sentence);

	

//	RemoveEndMarkers(sentence);

	

	
				
	//#TAHIRA#//vector<CLEList*> * lex_list=TokenizerPtr->GetTokenList(sentence);

	//#TAHIRA#//if(!lex_list)	
	//#TAHIRA#//	return UrduSentence;

	//#TAHIRA#//GIVE sentence TO THE INIT FUNCTION OF SCANNER HERE

		CFStructure*tfs=NULL;
		list<CFSCSPairInfo*> SourceInfoList;
		CFSCSPairInfo*sinfo=NULL;

	
		wstring UrduSentence=L"";	
		//#TAHIRA#//ChartParser->EarleyParse(lex_list,SourceInfoList,true);
	

	//while(1)//!PScanner->Eof()) // (1)
	{
		if(PChartParser->Parse()) //   parse should return true/false  //(1)
		{
			sinfo=PChartParser->GetNextCSFSPair();
			if (sinfo)	// added check (HUDA 23-01-06)
				SourceInfoList.push_back(sinfo);
		}		
		
		if(SourceInfoList.size()>0)
		{				


//			fs_fw.Write(L"<Sentence>"+sentence+L"</Sentence>");	
//			ChartParser->GenerateFStructureRecXML((*SourceInfoList.begin())->FSRef->Root,&fs_fw);
			
			vector<CFStructure*> TargetFSCollection;

			CSourceTargetFSInfo*temp=NULL;
			vector<CSourceTargetFSInfo*> * STList=NULL;
			
			STList=MappController->GenerateTargetFStructuresEx(SourceInfoList);		

			//////////////////////////////MM///////////10.08.2005//////////////
	//		for(list<CFSCSPairInfo*>::iterator it=SourceInfoList.begin();
	//			it!=SourceInfoList.end();it++)
	//		{
	//			sinfo=*it;
	//			delete sinfo;
	//		}
			SourceInfoList.clear();
			//////////////////////////////////////////////////////////////////
				
			list<wstring> SentenceList;

			if(STList)
			{
				for(vector<CSourceTargetFSInfo*>::iterator it3=STList->begin();
					it3!=STList->end();it3++)
				{		
					temp=*it3;

					for(vector<CFStructure*>::iterator it=temp->TargetFSList.begin();it!=temp->TargetFSList.end();it++)
					{	
						tfs=*it;
						
						////////////////////////////////////////////////////////////
						tfs->insertCommon(UrduLexicon->CommonLexicalFeatureTable);
						DiscourseResolver->Apply(tfs->Root);						
						tfs->SetParentPointers(); //added on 04-08-2005
						////////////////////////////////////////////////////////////

						//////////Added For Generator//////////
						TargetFSCollection.push_back(tfs);
						///////////////////////////////////////			
					}	
					
					//deleting temp
					delete temp;
				}							

					STList->clear();
					delete STList;
			}
			else
			{
			//	CLogManager::AddMessage(L"Sentence Target Urdu F-Structure could not be generated.\r\n");
//				UrduSentence=L"Parsed";
			}						

		 	if(Generator && TargetFSCollection.size()>0)
			{			
			//	CLogManager::AddMessage(L"Generator Started: ");

				SentenceList=Generator->GenerateSentencesEx(TargetFSCollection);

				if(SentenceList.size()>0)
				{					
					list<wstring>::iterator sit=SentenceList.begin();
					UrduSentence=*sit;
					//UrduSentence=L"Generated";
					//////////////////////////////////////////////////
					// Un-Comment Following if muliple generated
					// sentences would be required.
					//////////////////////////////////////////////////

				//	sit++;
				//	for(;sit!=SentenceList.end();sit++)
				//	{	
				//		UrduSentence+=L"\r\n";
				//		UrduSentence+=*sit;						
				//	}										

					//////////////////////////////////////////////////
					//////////////////////////////////////////////////
				}
//				else
//				{
//					UrduSentence=L"Parsed";
//				}
			}	
//			else
//			{
//				UrduSentence=L"Parsed";
//			}
		}
		else
		{
		//	CLogManager::AddMessage(L"Sentence could not be parsed.\r\n");
//			UrduSentence=L"Not Parsed";
		}
	}

		//CLogManager::AddMessage(L"Generated Urdu Sentences: "+UrduSentence+L"\r\n");

		// changed 24-01-06 HUDA
		// CollectGarbage();
		P_CollectGarbage();

	return UrduSentence;

}
*/

wstring CMTEngine::P_TranslateSentence(wstring& sentence, string& domain)
{
	short slen=sentence.size();			
	PScanner->init(sentence);
	

	CFStructure*tfs=NULL;
	list<CFSCSPairInfo*> SourceInfoList;
	CFSCSPairInfo*sinfo=NULL;

	//#TAHIRA#//ChartParser->EarleyParse(lex_list,SourceInfoList,true);
	wstring UrduSentence=L"";
	wstring final_sentence=L"";	// for segmentation (huda 25-08-06)
	vector<P_Segment*> segments;
	//while(!PScanner->Eof())//(1)//!PScanner.EOF())
	{
		CLogManager::AddMessage(sentence);	
		
		// shifted here from Parse() for segmenter (huda segment)
		vector<vector<P_LexicalEntry*> > AllLexEntries;
		vector<Token*> AllTokensHavingBNCInfo;
		PChartParser->GetSentence(AllLexEntries,AllTokensHavingBNCInfo); 
		// shifted here from Parse() for segmenter (huda segment) END

		// now segment
		
		P_Segment* single_segment;
		if (segment_sentence && AllLexEntries.size() >= min_sentence_length)
		{
			segments = PSegmenter->startRecursiveSegmentation(AllLexEntries,AllTokensHavingBNCInfo);
			#ifdef GenLog
			CLogManager::AddMessage(L"-----------------SEGMENTS-------------------");	
			vector<P_Segment*>::iterator segs_it;
			for (segs_it = segments.begin(); segs_it != segments.end(); segs_it++)
			{
				wstring seg_str = L"";
				vector<Token*>::iterator toks_it;
				for (toks_it = (*segs_it)->token_list.begin(); toks_it != (*segs_it)->token_list.end(); toks_it++)
				{
					seg_str += (*toks_it)->lexeme;
					seg_str += L" ";
				}
				CLogManager::AddMessage(L"segment: " + seg_str + L"(rule index: " + GetWSTR((*segs_it)->rule_no) + L")");	
			}
			CLogManager::AddMessage(L"---------------END SEGMENTS-----------------");	
			#endif
		}
		else
		{
			single_segment = new P_Segment();
			single_segment->lexical_entry_list = AllLexEntries;
			single_segment->token_list = AllTokensHavingBNCInfo;
			single_segment->connector = L"";
			segments.push_back(single_segment);
		}

		// translate all segments
		vector<P_Segment*>::iterator segments_it;
		for (segments_it = segments.begin(); segments_it != segments.end(); segments_it++)
		{
			vector<Token*>::iterator toks_it;
			#ifdef GenLog
			wstring seg_str = L"";
			for (toks_it = (*segments_it)->token_list.begin(); toks_it != (*segments_it)->token_list.end(); toks_it++)
			{
				seg_str += (*toks_it)->lexeme;
				seg_str += L" ";
			}
			CLogManager::AddMessage(L"--------------------------------------------");	
			CLogManager::AddMessage(L"segment: " + seg_str);
			CLogManager::AddMessage(L"--------------------------------------------");	
			#endif
			// adding re-initialization 4 new sentence (huda segment)
			UrduSentence = L"";
			SourceInfoList.clear();
			// adding re-initialization 4 new sentence (huda segment)	
			
			if(PChartParser->Parse((*segments_it)->lexical_entry_list,(*segments_it)->token_list)) //make parser to return true/false    (0)
			{
				sinfo=PChartParser->GetNextCSFSPair();
				if (sinfo)	// added check (HUDA 23-01-06)
					SourceInfoList.push_back(sinfo);
			}
			
			CLogManager::AddMessage(L"--------------------------------------------");	
	
			if(SourceInfoList.size()>0)
			{				
				vector<CFStructure*> TargetFSCollection;
				CSourceTargetFSInfo*temp=NULL;
				vector<CSourceTargetFSInfo*> * STList=NULL;

				

				/******************** Change for domain- By mariam***************************/
				STList=MappController->GenerateTargetFStructuresEx(SourceInfoList,domain);		
				/********************** end of change ***************************************/
				
				//////////////////////////////MM///////////10.08.2005//////////////
				/*for(list<CFSCSPairInfo*>::iterator it=SourceInfoList.begin();
					it!=SourceInfoList.end();it++)
				{
					sinfo=*it;
					delete sinfo;
				}
				SourceInfoList.clear();*/
				//////////////////////////////////////////////////////////////////
			
				list<wstring> SentenceList;

				if(STList)
				{
					for(vector<CSourceTargetFSInfo*>::iterator it3=STList->begin();
						it3!=STList->end();it3++)
					{
						temp=*it3;
						for(vector<CFStructure*>::iterator it=temp->TargetFSList.begin();it!=temp->TargetFSList.end();it++)
						{	
							tfs=*it;
						
							////////////////////////////////////////////////////////////
							tfs->insertCommon(UrduLexicon->CommonLexicalFeatureTable);
							DiscourseResolver->Apply(tfs->Root);						
							tfs->SetParentPointers(); //added on 04-08-2005
							////////////////////////////////////////////////////////////

							//////////Added For Generator//////////
							TargetFSCollection.push_back(tfs);
							///////////////////////////////////////

							
						}	
					
						//deleting temp
						delete temp;
					}							

					STList->clear();
					delete STList;
				}
				else
				{
	//				MessageBox(L"Sentence's Target Urdu F-Structure could not be generated.",L"Functional Mapper Module",MB_ICONINFORMATION|MB_OK);
				}		

		 		if(Generator && TargetFSCollection.size()>0)
				{
					SentenceList=Generator->GenerateSentencesEx(TargetFSCollection);
					if(SentenceList.size()>0)
					{
						list<wstring>::iterator sit=SentenceList.begin();
						UrduSentence+=*sit;

					}	
					CLogManager::AddMessage(UrduSentence);
					CLogManager::AddMessage(L"--------------------------------------------");				
				}	
			
				/**/		
			}
			
			if (UrduSentence == L"")
			{
				// transliterate all tokens
				for (toks_it = (*segments_it)->token_list.begin(); toks_it != (*segments_it)->token_list.end(); toks_it++)
				{
					UrduSentence += Transliterator->transliterate((*toks_it)->lexeme);
					UrduSentence += L" ";
				}

			}
		//	final_sentence += UrduSentence + L" " + (*segments_it)->connector + L" ";
			(*segments_it)->segment_translation = UrduSentence;
			P_CollectSegmentGarbage();
		}
	}
	final_sentence = makeSentenceFromSegments(segments);
	P_FSInitializer::collectSelectiveGarbage();
	PSegmenter->collectSelectiveGarbage();
	RemoveEndSpaces(final_sentence);
	return final_sentence;
}

bool CMTEngine::P_CollectGarbage(void)
{
	Generator->CollectGarbage();

	CProduction::CollectSelectiveGarbage();
	
	if(ChartParser)
		ChartParser->ClearChart();	

	CFStructure::CollectGarbage();
	CFStructureItem::CollectGarbage();

	P_FSInitializer::collectSelectiveGarbage();
	return true;
}

bool CMTEngine::P_CollectSegmentGarbage(void)
{
	Generator->CollectGarbage();

	CProduction::CollectSelectiveGarbage();
	
	if(ChartParser)
		ChartParser->ClearChart();	

	CFStructure::CollectGarbage();
	CFStructureItem::CollectGarbage();

	return true;
}

wstring CMTEngine::makeSentenceFromSegments(vector<P_Segment*>& segments)
{
	wstring trans;
	vector<P_Segment*>::iterator segments_it;
	vector<P_Segment*>::iterator segments_it_temp;	
	/*
	// simple concatenation of all segments 
	for (segments_it = segments.begin(); segments_it != segments.end(); segments_it++)
	{
		trans += (*segments_it)->segment_translation;
		if ((*segments_it)->connector != L"")
		{
			trans += L" ";
			trans += (*segments_it)->connector;
		}
		trans += L" ";
	}
	*/
	
	/*
	// add dummy prep insertion point for all segment translations;
	wstring prep_pos = L"p";
	for (segments_it = segments.begin(); segments_it != segments.end(); segments_it++)
		(*segments_it)->segment_translation.insert(0, prep_pos);
	*/


	// either one of 2 actions needs to be taken: 1) concat to the translation 2) save and re-order
	bool concat = true;
	wstring prep_sequence = L"";
	wstring prep_connector = L"";
	short p_pos = -1;
	
	// PSegmenter->p_rule_no is the rule no. that indicates a segment based on a p
	for (segments_it = segments.begin(); segments_it != segments.end(); segments_it++)
	{
		if (concat)
		{
			// remove p from current translation
			while ((p_pos = trans.find('p')) != wstring::npos)
				trans.erase(p_pos, 1);
			
			// if there is no p position marked in the current segment put one at the start
			if ((p_pos = (*segments_it)->segment_translation.find('p')) == wstring::npos)
			{	
				/* CHANGED IN THIS (LINUX ONLY) VERSION - will work in Win
				(*segments_it)->segment_translation.insert(0, 'p'); 
				NOT TESTED*/
				wchar_t* p_char = new wchar_t[1];
				p_char[0] = 'p';
				(*segments_it)->segment_translation.insert(0, p_char); 
			}
			trans += (*segments_it)->segment_translation;
			if ((*segments_it)->connector != L"")
			{
				trans += L" ";
				trans += (*segments_it)->connector;
			}
			trans += L" ";
		}
		else
		{
			prep_sequence.insert(0, L" ");
			prep_sequence.insert(0, (*segments_it)->segment_translation);
			if ((*segments_it)->connector != L"")
				prep_connector = (*segments_it)->connector;
		}
		
		segments_it_temp = segments_it;
		segments_it_temp++;
		if (segments_it_temp == segments.end())
			segments_it_temp = segments_it;

		// set the action to be taken during the next iteration
		if (((*segments_it_temp)->rule_no != PSegmenter->and_rule_no) && ((*segments_it)->rule_no == PSegmenter->p_rule_no))
		{
			concat = false;
		}
		else
		{
			if ((concat == false) && ((*segments_it+1)->rule_no != PSegmenter->p_rule_no))
			{
				// insert prep sequence
				p_pos = trans.find('p');
				if ((p_pos = trans.find('p')) != wstring::npos)
					trans.insert(p_pos, prep_sequence);
				else
					trans.insert(0, prep_sequence);
				
				prep_sequence = L"";

				if (prep_connector != L"")
				{
					trans += prep_connector;
					trans += L" ";
					prep_connector = L"";
				}
				concat = true;
			}
		}
		p_pos = -1;
	}
		
	// remove 'p's from translation (in single segment case)
	while ((p_pos = trans.find('p')) != wstring::npos)
		trans = trans.erase(p_pos, 1);	
	
	// remove newline char
	while ((p_pos = trans.find('\n')) != wstring::npos)
		trans = trans.erase(p_pos, 1);	

	// remove multiple spaces
	int sp_pos;
	while ((sp_pos = trans.find(L"  ", 0)) != wstring::npos)
		trans.erase(sp_pos, 1);
	// remove multiple spaces

	RemoveEndSpaces(trans);

	return trans;
}
