#pragma once

/* ADDED IN THIS (LINUX) VERSION*/
#ifndef MTENGINE_H
#define MTENGINE_H
/* ADDED IN THIS (LINUX) VERSION*/

#include <string>
#include <vector>

using std::string;
using std::vector; 

#include "CLexicon.h"
#include "CTokenizer.h"
#include "CConfiguration.h"
#include "CGrammar.h"
#include "CChart.h"
#include "MapperController.h"
#include "Generator.h"
#include "MorphologicalGenerator.h"
#include "Discourse.h"

#include "P_Lexicon.h"
#include "P_Grammar.h"
#include "P_FSInitializer.h"
#include "P_FSSymbolTable.h"
#include "P_Scanner.h"
#include "P_ChartParser.h"

#include "P_Segment.h"
#include "P_Segmenter.h"
#include "POSTable.h"
#include "Transliterator.h"

class CMTEngine
{
		// Construction
private:
	
	CLexicon * LexiconPtr;
	CTokenizer * TokenizerPtr;
	//CConfiguration * ConfigMngr;
	CGrammar * GrammarMngr;
	CChart * ChartParser;
	CMapperController*MappController;
	CGenerator * Generator;

	CLexicon * UrduLexicon;	
	CMorphologicalGenerator * MorphGenerator;
	CGrammar * UrduGrammarManager;		

	CDiscourse * DiscourseResolver;

	short GFId;
	short PredId;

	wstring DirPath;

	P_Lexicon *PLexicon;
	P_Grammar *PGrammar;
	P_Scanner *PScanner;
	P_ChartParser *PChartParser;

	// for segmentation (huda 25-08-06)
	P_Segmenter *PSegmenter;
	bool segment_sentence;
	short min_sentence_length;
	CTransliterator *Transliterator;
	// adding 06-12-06
	wstring makeSentenceFromSegments(vector<P_Segment*>& segments);
	// for segmentation (huda 25-08-06) END
		
public:
	/////////////////////////
/*	HWND *hwnd ;	REMOVED FOR THIS (LINUX/DOS) VERSION */
	/////////////////////////
	void TestTokenizer(vector<CLEList*> * le_list); //only for testing
	void destroy(); //main controller function
	void init(); //main controller function
//	wstring TranslateSentence(wstring& inputSentence);

	CMTEngine();
	~CMTEngine(void);
	bool CollectGarbage(void);
	bool RemoveEndMarkers(wstring & Sentence);

	void P_init(void);
	wstring P_TranslateSentence(wstring& sentence, string& domain);
private:
	bool P_CollectGarbage(void);
	bool P_CollectSegmentGarbage(void);
};
#endif /* ADDED IN THIS (LINUX) VERSION*/
