// MTEngineLINUX.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "MTEngine.h"
#include "FileReader.h"
#include "FileWriter.h"

#include "string"
using namespace std;
using std::wstring;

int main()
{
	short ch ;
	wstring sentence = L"" ;
	wstring translatedSentence = L"" ;
	string domain = "None";
	
	CFileReader fr("inputSentences.txt" , 512) ;

	CFileWriter fw("translatedSentences.txt") ;	

	CMTEngine MTEngine ;

	cout<<"Loading...\n";
	MTEngine.P_init();
	cout<<"Loaded\n";

	while((ch = fr.GetCurrentChar()) != 0 )
	{
		if(ch != '\r')
			sentence += ch ;
		else
		{
			fr.MoveNext() ;
			translatedSentence = MTEngine.P_TranslateSentence(sentence, domain) ;
			CLogManager::AddMessage(translatedSentence);
			cout<<"One Sentence Translated\n";
			fw.Write(translatedSentence) ;
			fw.Write(L"\r\n") ;

			sentence.clear() ;
		}

		fr.MoveNext() ;
	}

	if(sentence.size() != 0 )
	{
		translatedSentence = MTEngine.P_TranslateSentence(sentence, domain) ;
		CLogManager::AddMessage(translatedSentence);
		cout<<"One Sentence Translated\n";
		fw.Write(translatedSentence) ;
		fw.Write(L"\r\n") ;
	}
	
	cout<<"Translated\n";
	fr.CloseFile() ;
	fw.CloseFile() ;

	cout<<"Done\n";
	return 0;
}

