// Mapper.cpp: implementation of the CMapper class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

/*#include "LanguageParser.h" REMOVING FROM THIS DOS/LINUX VERSION */
#include "Transliterator.h"
#include "Mapper.h" 
#include "FDExpression.h"
#include "CSentence.h"
#include "SourceTargetFSInfo.h"
#include "global.h"
#include "LogManager.h"

#include "CChart.h"
#include "ControlKeywords.h" 
/*#include ".\mapper.h" REMOVED IN THIS (LINUX) VERSION*/


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
/*#define new DEBUG_NEW [REMOVING IN THIS (DOS/LINUX) VERSION] */
#endif

using namespace std;

extern long EvaluateBooleanExpressionEx(std::string);

typedef pair<short,CMappingRuleBlock*> MapRulePair;

//////////// will be removed afterwards when a new Symbol Table will be added////////
/*
short CMapper::PredId=0;
short CMapper::ParentId=0;
short CMapper::RootId=0;
short CMapper::SetId=0;
short CMapper::ElementId=0;
short CMapper::ValueId=0;
short CMapper::GFId=0;
short CMapper::NULLId=0;
short CMapper::BreakId=0;
*/
///////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMapper::CMapper(CLexicon*Lex,CChart* utinterface,string trfname)
:Transliterator(trfname)
{
	WSDMngr.Initialize(); //this line added by tahira
	LexPtr=Lex;
	UtilityInterface=utinterface;
	FSCloneLimit=1;	
	ElementCounter=1;										  
	string res=CConfiguration::GetConfigInfo("GenerateAllPossibleVariationsForMapper",true);
	
	if(res=="yes")
		GenerateAllPossibleVariations=true;
	else
		GenerateAllPossibleVariations=false;

	/*
	RootId=LexPtr->GetConstantNumber(L"ROOT",true);
	PredId=LexPtr->GetConstantNumber(L"PRED",true);
	ParentId=LexPtr->GetConstantNumber(L"PARENT",true);
	SetId=LexPtr->GetConstantNumber(L"SET",true);	
	ElementId=LexPtr->GetConstantNumber(L"ELEMENT",true);
	
	ValueId=LexPtr->GetConstantNumber(L"VALUE",true);
	GFId=LexPtr->GetConstantNumber(L"GF",true);

	NULLId=LexPtr->GetConstantNumber(L"NULL",true);		
	BreakId=LexPtr->GetConstantNumber(L"BREAK",true);	
*/

	////////////// Init Pred Rule ///////////////////////////

	PredRule=new CMappingRuleBlock();	
		
	PredRule->BlockId=CSymbolTableManager::PredId;
	PredRule->DefaultRule=NULL;

	CMappingRule*rule=new CMappingRule();
	
	rule->SenseNumber =0;
	rule->WhenCondition=L"";
	rule->Operator='-';
	
	PredAction=new CAction();
	PredAction->op=UNIFY_OP;
	PredAction->Lhs.start_op=TARGET_OP;
	PredAction->Lhs.list.push_back(CSymbolTableManager::PredId);
	PredAction->Rhs.start_op='v';
	
	GFaction=new CAction();
	GFaction->Lhs.list.push_back(CSymbolTableManager::PredId);
	GFaction->Lhs.list.push_back(CSymbolTableManager::GFId);
	GFaction->Rhs.list.push_back(CSymbolTableManager::PredId);
	GFaction->Rhs.list.push_back(CSymbolTableManager::GFId);	
	GFaction->op='=';

	rule->ActionList.push_back(PredAction);
	PredRule->AddRule(rule);

	///////////////////////////////////////////////////////////////
		
}

CMapper::~CMapper()
{

}

vector<CSourceTargetFSInfo*> * CMapper::GenerateTargetFStructures( vector<CFStructure*> * SourceFSList,
										CMappingRuleManager * RuleMngr,
										CMappingRuleManager * LexMngr,
										CMappingRuleManager * InsertRMngr)
{
	using namespace std;

	vector<CSourceTargetFSInfo*> * STFSList=NULL;
	
	vector<CFStructure*> TargetFSList;
	vector<CFStructure*> FinalTargetFSList;		
	ElementCounter=1;
	if(!SourceFSList || !RuleMngr || !LexMngr)
	   return STFSList;

	STFSList=new vector<CSourceTargetFSInfo*>;

	if(!STFSList)
		return NULL;

	this->RuleMngr=RuleMngr;
	this->LexMngr=LexMngr;
	this->InsertRuleMngr=InsertRMngr;

	////////////////// Added on April 1, 2005 ////////////////
	ActiveInsertRuleList.clear();
	/////////////////////////////////////////////////////////

	//short RootId=LexPtr->GetConstantNumber(L"ROOT",true);
	//short SetId=LexPtr->GetConstantNumber(L"SET",true);
	
//	CFStructure * SourceFS=NULL;
	CFSPairInfo * FSPair=NULL;	

	CFStructure * SrcFS=NULL;
	CFStructure * TargetFS=NULL;

	stack<CFSPairInfo*> FSPairStack;
	CSourceTargetFSInfo*info=NULL;


	for(vector<CFStructure*>::iterator it=SourceFSList->begin();it!=SourceFSList->end();it++)
	{					
		SrcFS=*it;		
		//SrcFS->AdjustSetElements(SetId);
		SrcFS->CurrentPtr=SrcFS->Root;
		
		info=new CSourceTargetFSInfo();
		
		if(!info)
			continue;

		info->SourceFS=SrcFS;
		
		FSPair=new CFSPairInfo();

		if(!FSPair)
			continue;

		//FSPair->SourceFS.CurrentPtr=FSPair->SourceFS.Root;
		//FSPair->SourceFS->CurrentPtr=FSPair->SourceFS->Root;
		//FSPair->SourceFS=FSPair->SourceFS

		FSPair->SourceFS=SrcFS;
		FSPair->SourceFS->CurrentPtr=FSPair->SourceFS->Root;
		FSPair->UpdateCurrentPtr(true);
		
		FSPair->TargetFS=new CFStructure(new CFStructureItem(CSymbolTableManager::RootId),1.0);
		
		if(!FSPair->TargetFS)
			continue;

		FSPair->TargetFS->CurrentPtr=FSPair->TargetFS->Root;
		
		//FSPair->FeatureStack.push(FSPair->SourceFS->CurrentPtr);
		AddChildAndSetElementsInFeatureStack(&FSPair->FeatureStack,FSPair->SourceFS->CurrentPtr);

		FSPairStack.push(FSPair);					

		TargetFSList.clear();

		//just to run....this....		
		CSentenceInfo sen;
		GenerateFStructures(&FSPairStack,&TargetFSList,sen);
		///removed later

		for(vector<CFStructure*>::iterator it2=TargetFSList.begin();
			it2!=TargetFSList.end();it2++)
		{
			TargetFS=*it2;
			
			if(ApplyFinalRule(SrcFS,TargetFS))
			{
				if(UtilityInterface->CheckForwardCompleteness(TargetFS->Root))
				{
					//FinalTargetFSList.push_back(*it2);
					if(!SaveUniqueFStructure(&FinalTargetFSList,*it2))
					{
						try{
							delete TargetFS;
							TargetFS=NULL;
						}
						catch(...)
						{
							#ifdef GenLog
							CLogManager::AddMessage(L"#### TargetFS");
							#endif
						}
					}
				}
				else
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"Mapper: Completeness/Coherence Check Failed on Target F-Structure\r\n");
					#endif

					try{
						delete TargetFS;
						TargetFS=NULL;
					}
					catch(...)
					{
						#ifdef GenLog
						CLogManager::AddMessage(L"#### TargetFS");
						#endif
					}
				}					
			}
			else
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"Mapper: Final Rule Failed on Target F-Structure\r\n");
				#endif

				try{
					delete TargetFS;
					TargetFS=NULL;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"#### TargetFS");
					#endif
				}	
			}
		}

		info->TargetFSList=FinalTargetFSList;
		FinalTargetFSList.clear();
		STFSList->push_back(info);
	}	

/*	CFSPairInfo*apair=NULL;
	
	while(!FSPairStack.empty())
	{
		apair=FSPairStack.top();
		FSPairStack.pop();
		delete apair;
	}
*/
   
	return STFSList;
}
vector<CSourceTargetFSInfo*> * CMapper::GenerateTargetFStructuresEx( 
										list<CFSCSPairInfo*> & FSCSList,
										CMappingRuleManager * RuleMngr,
										CMappingRuleManager * LexMngr,
										CMappingRuleManager * DLexMngr,
										CMappingRuleManager * InsertRMngr)
{
	using namespace std;

	vector<CSourceTargetFSInfo*> * STFSList=NULL;
	
	vector<CFStructure*> TargetFSList;
	vector<CFStructure*> FinalTargetFSList;		

	if(FSCSList.size()<=0 || !RuleMngr || !LexMngr)
	   return STFSList;

	STFSList=new vector<CSourceTargetFSInfo*>;

	if(!STFSList)
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"Source Target FS List could not be allocated in Memory");			
		#endif
		return NULL;
	}

	this->RuleMngr=RuleMngr;
	this->LexMngr=LexMngr;
	this->DLexMngr=DLexMngr;
	this->InsertRuleMngr=InsertRMngr;

	////////////////// Added on April 1, 2005 ////////////////
	ActiveInsertRuleList.clear();
	/////////////////////////////////////////////////////////

	//short RootId=LexPtr->GetConstantNumber(L"ROOT",true);
	//short SetId=LexPtr->GetConstantNumber(L"SET",true);
	
	//CFStructure * SourceFS=NULL;
	CFSPairInfo * FSPair=NULL;	

	CFStructure * SrcFS=NULL;
	CFStructure * TargetFS=NULL;

	stack<CFSPairInfo*> FSPairStack;
	CSourceTargetFSInfo*info=NULL;

	CFSCSPairInfo * fscsinfo = NULL;

	int counter=1;	

//	list<CFSCSPairInfo*>::iterator itr=FSCSList.begin();	//added by tahira
//	WSDMngr.OnSentenceStart((*itr)->SenWords.Words.size());	//added by tahira

	for(list<CFSCSPairInfo*>::iterator it=FSCSList.begin();it!=FSCSList.end();it++)
	{	
		#ifdef GenLog
		CLogManager::AddMessage(L"Generating Target F-Structure for Source F-Structure # "+GetWSTR(counter));
		#endif

		counter++;

		fscsinfo=*it;
		SrcFS=fscsinfo->FSRef;		
		//SrcFS->AdjustSetElements(SetId);
		SrcFS->CurrentPtr=SrcFS->Root;
		
		info=new CSourceTargetFSInfo();
		
		if(!info)
			continue;

		info->SourceFS=SrcFS;
		
		FSPair=new CFSPairInfo();

		if(!FSPair)
			continue;

		//FSPair->SourceFS.CurrentPtr=FSPair->SourceFS.Root;
		//FSPair->SourceFS->CurrentPtr=FSPair->SourceFS->Root;
		//FSPair->SourceFS=FSPair->SourceFS

		FSPair->SourceFS=SrcFS;
		FSPair->SourceFS->CurrentPtr=FSPair->SourceFS->Root;
		FSPair->UpdateCurrentPtr(true);
		
		FSPair->TargetFS=new CFStructure(new CFStructureItem(CSymbolTableManager::RootId),1.0);
		
		if(!FSPair->TargetFS)
			continue;

		FSPair->TargetFS->CurrentPtr=FSPair->TargetFS->Root;
		
		//FSPair->FeatureStack.push(FSPair->SourceFS->CurrentPtr);
		AddChildAndSetElementsInFeatureStack(&FSPair->FeatureStack,FSPair->SourceFS->CurrentPtr);

		FSPairStack.push(FSPair);					

		TargetFSList.clear();
		
		GenerateFStructures(&FSPairStack,&TargetFSList,fscsinfo->SenWords);

		counter=TargetFSList.size();
		
		#ifdef GenLog
		CLogManager::AddMessage(L"Total No. of Target F-Structure Generated : "+GetWSTR(counter));
		#endif

		for(vector<CFStructure*>::iterator it2=TargetFSList.begin();
			it2!=TargetFSList.end();it2++)
		{
			TargetFS=*it2;
			
			if(ApplyFinalRule(SrcFS,TargetFS))
			{
				if(UtilityInterface->CheckForwardCompleteness(TargetFS->Root))
				{
					//FinalTargetFSList.push_back(*it2);
					if(!SaveUniqueFStructure(&FinalTargetFSList,*it2))
					{
						/*try{
							delete TargetFS;
							TargetFS=NULL;
						}
						catch(...)
						{
							CLogManager::AddMessage(L"#### TargetFS");
						}*/
					}
				}
				else
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"Mapper: Completeness/Coherence Check Failed on Target F-Structure\r\n");
					#endif
				}					
			}
			else
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"Mapper: Final Rule Failed on Target F-Structure\r\n");
				#endif
			}
		}

		info->TargetFSList=FinalTargetFSList;
		FinalTargetFSList.clear();
		STFSList->push_back(info);
	}	

/*	CFSPairInfo*apair=NULL;
	
	while(!FSPairStack.empty())
	{
		apair=FSPairStack.top();
		FSPairStack.pop();
		delete apair;
	}
*/
   
	return STFSList;
}

bool CMapper::SaveUniqueFStructure(vector<CFStructure * > * FSResults, CFStructure * fs)
{
	using namespace std;	

	CFStructure*temp=NULL;
	
	for(vector<CFStructure*>::iterator it=FSResults->begin();it!=FSResults->end();it++)
	{
		temp=*it;	
		if(temp->Root->IsEqual(fs->Root))
			return false;
	}
	
	FSResults->push_back(fs);

	return true;
}

bool CMapper::ApplyFinalRule(CFStructure * SrcFS, 
							 CFStructure * TargetFS)
{
	bool WhenSuccess=false;
	bool AllWhenFailed=true;
	bool RuleSuccess=false;
	//bool ContainsNULL=false;
	CControlKeywords ControlKeywords;

	short final_label=CSymbolTableManager::FinalId;

	CMappingRuleBlock * block=RuleMngr->GetRuleBlock(final_label);
	
	if(!block || block->GetRuleCount()==0)
		return true;	
	
	CMappingRule*rule;
	
	for(vector<CMappingRule*>::iterator it=block->RuleList.begin();
		it!=block->RuleList.end();it++)
	{
		rule=*it;
		
		WhenSuccess=CheckWhenCondition(rule->WhenCondition,SrcFS->Root,TargetFS->Root);

		if(WhenSuccess)
		{
			AllWhenFailed=false;

			SrcFS->CurrentPtr=SrcFS->Root;
			TargetFS->CurrentPtr=TargetFS->Root;

			RuleSuccess=ApplyRule(rule,SrcFS,TargetFS,ControlKeywords);

			if(!RuleSuccess)
				return false;		
			
			//if any rule application failed then
			//reject the corrosponding F-Structure

		}//end if(WhenSuccess)
		else
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"When Condition Failed: "+rule->WhenCondition);
			#endif
		}
					
	}//end for
	
	if(AllWhenFailed || RuleSuccess)
		return true;

return false;
		
}


bool CMapper::GenerateFStructures(stack<CFSPairInfo*> * FSPairStack,
					  			  vector<CFStructure*> * TargetFSList,
								  CSentenceInfo & sen_info)
{
	if(!FSPairStack || !TargetFSList)
		return false;
	
	stack<CFStructureItem*> * sFeatureStack;
	
	CFStructure * sFS=NULL;
	CFStructure * tFS=NULL;

	CFStructureItem * sFSItem=NULL;
	CFStructureItem * tFSItem=NULL;

	CFSPairInfo * FSPair=NULL;
	CFSPairInfo*npair=NULL;
	stack<CFStructureItem*> * TargetPointerStack=NULL;
	stack<CFStructureItem*> * SourcePointerStack=NULL;

	//CFStructureItem * SEPARATOR = NULL; /*separator*/
	bool success=false;
	bool flag=false;
	//bool containsNULL=false;
	CControlKeywords ControlKeywords;
	wstring delstr;

	while(!FSPairStack->empty())
	{
		flag=false;

		//clearing all the active insert rules inserted during the previous parse.
		ActiveInsertRuleList.clear();
		

		FSPair=FSPairStack->top();
		FSPairStack->pop();

		ActiveInsertRuleList=FSPair->InsertRuleList; //by tahira (reason: every pair needs its personal insert rule block
		
		sFS =  FSPair->SourceFS;
		tFS =  FSPair->TargetFS;

		sFeatureStack=&FSPair->FeatureStack;
		TargetPointerStack=&FSPair->TargetPointerStack;
		SourcePointerStack=&FSPair->SourcePointerStack;
		success=true;

		while(!sFeatureStack->empty() && success)
		{
			
			sFSItem=sFeatureStack->top();
			sFeatureStack->pop();		
			sFS->CurrentPtr=sFSItem;						

			while(sFSItem==SEPARATOR && !sFeatureStack->empty() && !TargetPointerStack->empty())
			{
				tFSItem=TargetPointerStack->top();
				TargetPointerStack->pop();
				
				//SourcePointerStack is used only for backtracking.....
				SourcePointerStack->pop();
				
				if(tFSItem)
					tFS->CurrentPtr=tFSItem;
				
				sFSItem=sFeatureStack->top();						

					sFeatureStack->pop();
				
				if(sFSItem)
					sFS->CurrentPtr=sFSItem;
			}	
            //###############change by tahira#######################
			//(reason: when depths of source and traget structures are different, it wasn,t comming out enough)
			while(sFSItem==SEPARATOR && !sFeatureStack->empty())
			{
				sFSItem=sFeatureStack->top();					    
				sFeatureStack->pop();   
				if(sFSItem)
					sFS->CurrentPtr=sFSItem;
			}
			//##############end change by tahira####################

			if(!sFSItem)
				break;

			//FSPair->UpdateCurrentPtr(false);

			delstr=CSymbolTableManager::GetString(sFSItem->Label);

			//CLogManager::AddMessage(L"CHECKING.... " + delstr + L"\r\n");
			
			//tFSItem=tFS->CurrentPtr;
			//sFSItem=sFS->CurrentPtr;
			
			//code by tafseer
			ControlKeywords.init();

			//success=GenerateTargetFeatureEx(FSPair,FSPairStack,ControlKeywords,sen_info);
			////REPLACE ABOVE WITH THE FOLLOWING TO INCORPORATE WSD			
			success=GenerateTargetFeatureExtended(FSPair,FSPairStack,ControlKeywords,sen_info);			
			
			if(!success)			
			{				
				continue;						
			}

			if(ControlKeywords.getNull())			
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"Contains NULL\r\n");			
				#endif
			}

			

			if(ControlKeywords.m_insertInvoked && ControlKeywords.m_insertMovePosition>0)
			{
				if(ControlKeywords.m_isMoveCount)
				{
					//move to the Nth parent....
					npair=BackTrackFSCurrentPtr(FSPair,ControlKeywords.m_insertMovePosition,ControlKeywords.m_isMoveCount);
					if(npair)					
						FSPairStack->push(npair);					
				}
				else
				{
					if(ControlKeywords.m_insertMovePosition==CSymbolTableManager::RootId)
					//Move Source and Target pointers to ROOT and run the cycle again
					{																				
						while(!FSPair->FeatureStack.empty())
							FSPair->FeatureStack.pop();

						while(!FSPair->TargetPointerStack.empty())
							FSPair->TargetPointerStack.pop();					
						
						FSPair->SourceFS->CurrentPtr=FSPair->SourceFS->Root;
						FSPair->TargetFS->CurrentPtr=FSPair->TargetFS->Root;

						CFSPairInfo * newpair=GenerateNewFSPair(FSPair);					

						AddChildAndSetElementsInFeatureStack(&newpair->FeatureStack,newpair->SourceFS->CurrentPtr);

						FSPairStack->push(newpair);
					}
					else
					{
						//ControlKeywords.m_insertMovePosition;
						npair=BackTrackFSCurrentPtr(FSPair,ControlKeywords.m_insertMovePosition,ControlKeywords.m_isMoveCount);
						if(npair)						
							FSPairStack->push(npair);						
						//move to the node given in ControlKeywords.m_insertMovePosition
					}
				}
			}		

			flag=true;
		}				
		
		if(!ControlKeywords.m_insertInvoked && success)
			TargetFSList->push_back(tFS);		
		else
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Insert Operator Invoked");
			#endif
		}
		

		try{
			delete FSPair;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"FSPair could not be deleted.");
			#endif
		}
	}

	return true;
}

bool CMapper::AddChildAndSetElementsInFeatureStack(stack<CFStructureItem*> * sFeatureStack,CFStructureItem*sFS)
{
	using namespace std;

	if(!sFS)
		return false;
 
	for(vector<CFStructureItem*>::reverse_iterator it=sFS->ChildList.rbegin(); it!=sFS->ChildList.rend();it++)
		if((*it)!=NULL)
			sFeatureStack->push(*it);

	return true;

}

CFSPairInfo*CMapper::GenerateNewFSPair(CFSPairInfo*OrigFSPair)
{
	if(!OrigFSPair)
		return NULL;

	CFSPairInfo*pinfo=new CFSPairInfo();
						
	pinfo->SourceFS=OrigFSPair->SourceFS;
	//pinfo->UpdateCurrentPtr(true);

	//pinfo->SourceFSCurrentPtr=OrigFSPair->SourceFS->CurrentPt;

	pinfo->FeatureStack=OrigFSPair->FeatureStack;
	
	pinfo->TargetFS = OrigFSPair->TargetFS->GetCloneSpecialEx(
											OrigFSPair->TargetFS->CurrentPtr,
											&OrigFSPair->TargetPointerStack,
											&pinfo->TargetPointerStack);						

	return pinfo;		
}

bool CMapper::UpdateSourceAndTargetStacks(CFSPairInfo*pinfo,CFStructureItem*oldptr)
{
	bool ret=false;

	if(!pinfo)
		return ret;

	if(pinfo->SourceFS->CurrentPtr->ChildList.size()>0 || 
		pinfo->SourceFS->CurrentPtr->SetElements.size()>0 )
	{
		//pinfo->TargetPointerStack.push(pinfo->TargetFS->CurrentPtr);		
		pinfo->TargetPointerStack.push(oldptr);
		pinfo->SourcePointerStack.push(pinfo->SourceFS->CurrentPtr);
		pinfo->FeatureStack.push(SEPARATOR);
		AddChildAndSetElementsInFeatureStack(&pinfo->FeatureStack,pinfo->SourceFS->CurrentPtr);							
		ret=true;
	}
	
return ret;
}

bool CMapper::GenerateTargetFeatureEx(CFSPairInfo * FirstPair,
									  stack<CFSPairInfo*> * FSPairStack,
									  CControlKeywords & ControlKeywords,
									  CSentenceInfo & sen_info)
{	
	if(!FirstPair)	
		return false;

	//FirstPair->UpdateCurrentPtr(false);

	CFSPairInfo * OrigFSPair=NULL;		

	CFStructureItem * sFSItem=FirstPair->SourceFS->CurrentPtr;
	CFStructureItem * tFSItem=FirstPair->TargetFS->CurrentPtr;		
	
	CFStructureItem * StoredPtr=NULL;

	bool WhenSuccess=false;
	bool AllWhenFailed=true;
	bool AllRuleApplicationFailed=true;

	bool RuleSuccess=false;		
	
	CMappingRuleBlock * block=NULL;
	CFStructureItem*gfnode=NULL;
	short gfid=CSymbolTableManager::GFId;	

	if(FirstPair->SourceFS->CurrentPtr->Label==CSymbolTableManager::PredId)
	{			
		CFStructureItem * ValPtr = FirstPair->SourceFS->CurrentPtr->SearchEx(CSymbolTableManager::ValueId);
	
		if(ValPtr)
		{
			wstring wstr(L"");
			short pid = ValPtr->ValueList.at(0);
			//block=LexMngr->GetRuleBlock(pid);		
			block=GetPriortizedRuleBlock(pid,true);
		
			if(!block)
			{
				gfnode=FirstPair->SourceFS->CurrentPtr->SearchEx(gfid);
				wstr=CSymbolTableManager::GetString(pid);
				block=GetPredRuleBlockEx(wstr);				
				//gfnode->ValueList;
			}
		}
		else
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"PRED.VALUE not found....\r\n");
			#endif
		}	
	}
	else
	{
		//block=RuleMngr->GetRuleBlock(FirstPair->SourceFS->CurrentPtr->Label);			
		block=GetPriortizedRuleBlock(FirstPair->SourceFS->CurrentPtr->Label,false);

	}
	
	if(!block || (block->GetRuleCount()==0 && !block->DefaultRule))
	{
		UpdateSourceAndTargetStacks(FirstPair,FirstPair->TargetFS->CurrentPtr);	
		return true;		
	}

	///june 02,2005/////////////////////////////////////////////////////////////////////////
	///////////////// changed following to incorporate WSD enhancements ////////////////////
	////////////////////////////////////////////////////////////////////////////////////////

	CFSPairInfo*temp_fspair=NULL; 
	CMappingRule*rule=NULL;
	
	double StdFreq=RuleMngr->StandardFrequency;

	list<CMappingRule*> TempRuleList;
	
	for(vector<CMappingRule*>::iterator it=block->RuleList.begin();
		it!=block->RuleList.end();it++)
	{
		rule=*it;

		temp_fspair=NULL;
		
		if(StdFreq!=1.0)
			WhenSuccess=true;
		else
		{
			WhenSuccess=CheckWhenCondition(rule->WhenCondition,
											FirstPair->SourceFS->CurrentPtr,
											FirstPair->TargetFS->CurrentPtr);
		}

		if(WhenSuccess)
		{				
			if(OrigFSPair==NULL)
			{
				OrigFSPair=GenerateNewFSPair(FirstPair);
				
				if(rule->Operator==OPTIONAL_OP)
				{
					CFSPairInfo*pinfo=GenerateNewFSPair(OrigFSPair);
					UpdateSourceAndTargetStacks(pinfo,pinfo->TargetFS->CurrentPtr);										
					FSPairStack->push(pinfo);						
				}	
				
				StoredPtr=FirstPair->TargetFS->CurrentPtr;
				RuleSuccess= ApplyRule(rule,
									  FirstPair->SourceFS,
									  FirstPair->TargetFS,
									  ControlKeywords);
				
				if(RuleSuccess)
				{											
					//FirstPair->TargetFS->Rank*=rule->SenseNumber;
					UpdateSourceAndTargetStacks(FirstPair,StoredPtr);						

					//FirstPair->UpdateCurrentPtr(true);

					//new code by Tafseer
					if (ControlKeywords.getBreak())
						return true;// break;

					if(ControlKeywords.m_insertInvoked)
						return true;
				}
			}
			else
			{
				temp_fspair=GenerateNewFSPair(OrigFSPair);

				if(rule->Operator==OPTIONAL_OP)
				{
					CFSPairInfo*pinfo=GenerateNewFSPair(OrigFSPair);
					UpdateSourceAndTargetStacks(pinfo,pinfo->TargetFS->CurrentPtr);						
					FSPairStack->push(pinfo);
				}								

				//UpdateSourceAndTargetStacks(temp_fspair);
				
				StoredPtr=temp_fspair->TargetFS->CurrentPtr;

				RuleSuccess = ApplyRule(rule,
										temp_fspair->SourceFS,
										temp_fspair->TargetFS,
										ControlKeywords);
									
				if(RuleSuccess)						
				{					
					//temp_fspair->TargetFS->Rank*=rule->Frequency;					
					UpdateSourceAndTargetStacks(temp_fspair,StoredPtr);						
					FSPairStack->push(temp_fspair);
					//FirstPair->UpdateCurrentPtr(true);

					//new code by Tafseer
					if (ControlKeywords.getBreak())
						return true;//break;
				}
			}
		
			AllWhenFailed=false;

			if(RuleSuccess)
				AllRuleApplicationFailed=false;

		}//end if(WhenSuccess)
		else
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"When Condition Failed: "+rule->WhenCondition);
			#endif
		}
					
	}//end for

	if(block->DefaultRule)
	{
		if(StdFreq!=1.0 && OrigFSPair)
		{
				temp_fspair=GenerateNewFSPair(OrigFSPair);

				//UpdateSourceAndTargetStacks(temp_fspair);
				
				StoredPtr=temp_fspair->TargetFS->CurrentPtr;

				RuleSuccess = ApplyRule(block->DefaultRule,
										temp_fspair->SourceFS,
										temp_fspair->TargetFS,
										ControlKeywords);																		

				if(RuleSuccess)						
				{					
					//temp_fspair->TargetFS->Rank*=rule->Frequency;						
					UpdateSourceAndTargetStacks(temp_fspair,StoredPtr);
					FSPairStack->push(temp_fspair);												
					//FirstPair->UpdateCurrentPtr(true);
				}
		}
		else if(AllWhenFailed || AllRuleApplicationFailed)
		{			
			StoredPtr=FirstPair->TargetFS->CurrentPtr;
			RuleSuccess=ApplyRule(block->DefaultRule,
								FirstPair->SourceFS,
								FirstPair->TargetFS,
								ControlKeywords);				
			if(!RuleSuccess)
				return false;

			
			//FirstPair->TargetFS->Rank*=block->DefaultRule->Frequency;
			UpdateSourceAndTargetStacks(FirstPair,StoredPtr);
			//FirstPair->UpdateCurrentPtr(true);
			AllWhenFailed=false;				
		}
	}

	if(OrigFSPair)
	{
		//OrigFSPair->SourceFS=NULL;
		try{
			delete OrigFSPair;
			}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### OrigFSPair");
			#endif
		}
	}

	if(AllWhenFailed)
		return false;

	
return true;
}


bool CMapper::GenerateTargetFeatureExtended(CFSPairInfo * FirstPair,
											stack<CFSPairInfo*> * FSPairStack,
											CControlKeywords & ControlKeywords,
											CSentenceInfo & SenPOSInfo)
{	
	if(!FirstPair)	
		return false;
	
	CFSPairInfo * OrigFSPair=NULL;		

	CFStructureItem * sFSItem=FirstPair->SourceFS->CurrentPtr;
	CFStructureItem * tFSItem=FirstPair->TargetFS->CurrentPtr;		
	
	CFStructureItem * StoredPtr=NULL;

	bool WhenSuccess=false;
	bool AllWhenFailed=true;
	bool AllRuleApplicationFailed=true;

	bool RuleSuccess=false;		
	
	CMappingRuleBlock * block=NULL;

	list<CMappingRule*> RuleList;
	list<CMappingRule*> RankedRuleList;
	int success_count=0;
	int WordIndex=0;
	short pid=0;
	size_t length=0;
	wstring wstr(L"");

	bool IsPredBlockUsed=false;

	if(FirstPair->SourceFS->CurrentPtr->Label==CSymbolTableManager::PredId)
	{			
		CFStructureItem * ValPtr = FirstPair->SourceFS->CurrentPtr->SearchEx(CSymbolTableManager::ValueId);
		//chart::word_index_id is replaced by indexid
		CFStructureItem * IndPtr = FirstPair->SourceFS->CurrentPtr->SearchEx(CSymbolTableManager::IndexId);

		//get index also from here...
		//WordIndex=??

		if (IndPtr)
		{			
			pid = IndPtr->ValueList.at(0);		
			wstr=CSymbolTableManager::GetString(pid);			
			WordIndex=atoi(Convert_wstr2str(wstr).c_str());
		}
		else
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Index Value not found for the predicate.");
			#endif
		}

		if(ValPtr)
		{			
			pid = ValPtr->ValueList.at(0);
			//block=LexMngr->GetRuleBlock(pid);		
			block=GetPriortizedRuleBlock(pid,true);

			if(!block)			
			{
				IsPredBlockUsed=true; // Memory Management

				wstr=CSymbolTableManager::GetString(pid);
				block=GetPredRuleBlockEx(wstr);
				/////////////////////////////////

			//#######################added by tahira###########################
			//reason: otherwise completeness/coherence tests fail for transliterated preds
				CFStructureItem * GFPtr = FirstPair->SourceFS->CurrentPtr->SearchEx(CSymbolTableManager::GFId);
				if(GFPtr)
					block->RuleList[0]->ActionList.push_back(GFaction);
				else if(block->RuleList[0]->ActionList.size()>1)
					block->RuleList[0]->ActionList.pop_back();
			//#######################added by tahira###########################

			}

			//#######################added by tahira###########################
			//reason: if rule blosk is not founnd the whole structure gets upset, not allowing disappearance of preds
			if(block->GetRuleCount()==0 && !block->DefaultRule)
			{
				UpdateSourceAndTargetStacks(FirstPair,FirstPair->TargetFS->CurrentPtr);	
				
				if(!IsPredBlockUsed)
					DeleteMappingRuleBlockOnly(block);

				return true;		
			}
			//#######################added by tahira###########################
			wstring ambiguous_word_pred=CSymbolTableManager::GetString(pid);//tahira: to get base form of word rather than the inf;ection gounf in cstructure

			length=block->ConditionedRuleList.size();
			
			if(length>0)
			{											
				//GetSuccessfulConditionedRules(block,FirstPair,RuleList);
				GetSuccessfulConditionedRulesWithUniqueSenses(block,FirstPair,RuleList);

				length=RuleList.size();

				if(length==1)
				{
					success_count=ExecuteRules(RuleList,NULL,FirstPair,FSPairStack,ControlKeywords);
				}
				else if(length>1)
	
				{
					if(!GenerateAllPossibleVariations)
					{
						GetRankedRules(ambiguous_word_pred,RuleList,WordIndex,SenPOSInfo);
						//Rank the rules in the same RuleList
					}
					success_count=ExecuteRules(RuleList,NULL,FirstPair,FSPairStack,ControlKeywords);
				}				

			}
			

			//if no conditioned rule was successfull
			list<CMappingRule*> EmptyRuleList;
			bool SuccessfullyDisambiguated=false;

			if(success_count==0)
			{
				RuleList=block->UnConditionedRuleList;
				if(!GenerateAllPossibleVariations && RuleList.size()>0)
				{
					if(RuleList.size()>1)	//rank only if there are more than one rules (tahira)
						SuccessfullyDisambiguated=GetRankedRules(ambiguous_word_pred,RuleList,WordIndex,SenPOSInfo);
				}

				if(!SuccessfullyDisambiguated && block->DefaultRule!=NULL)
				{
					success_count=ExecuteRules(EmptyRuleList,block->DefaultRule,FirstPair,FSPairStack,ControlKeywords);
					if(success_count==0)
						success_count=ExecuteRules(RuleList,block->DefaultRule,FirstPair,FSPairStack,ControlKeywords);

				}
				else
					success_count=ExecuteRules(RuleList,block->DefaultRule,FirstPair,FSPairStack,ControlKeywords);
			}	
		}
		else
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"PRED.VALUE not found....\r\n");
			#endif
		}	
	}
	else
	{
		//block=RuleMngr->GetRuleBlock(FirstPair->SourceFS->CurrentPtr->Label);	
		
		block=GetPriortizedRuleBlock(FirstPair->SourceFS->CurrentPtr->Label,false);
		
		if(!block || (block->GetRuleCount()==0 && !block->DefaultRule))
		{
			if(!block)
			{
				wstring temp = CSymbolTableManager::GetString(FirstPair->SourceFS->CurrentPtr->Label);
				/*if(temp.find(L"ELEMENT") != wstring.npos) CHANGED IN THIS (LINUX) VERSION*/
				if(temp.find(L"ELEMENT") != wstring::npos)
					block=GetPriortizedRuleBlock(CSymbolTableManager::GetNum(L"ELEMENT"),false);
				if(!block)
				{
					UpdateSourceAndTargetStacks(FirstPair,FirstPair->TargetFS->CurrentPtr);				
			
					#ifdef GenLog
					CLogManager::AddMessage(L"No Mapping Rule found for "+CSymbolTableManager::GetString(FirstPair->SourceFS->CurrentPtr->Label));
					#endif
			
					if(!IsPredBlockUsed)
						DeleteMappingRuleBlockOnly(block);
					return true;		
				}
			}
			else
			{
				UpdateSourceAndTargetStacks(FirstPair,FirstPair->TargetFS->CurrentPtr);				
			
				#ifdef GenLog
				CLogManager::AddMessage(L"No Mapping Rule found for "+CSymbolTableManager::GetString(FirstPair->SourceFS->CurrentPtr->Label));
				#endif
			
				if(!IsPredBlockUsed)
					DeleteMappingRuleBlockOnly(block);

				return true;		
			}
		}

		///june 02,2005/////////////////////////////////////////////////////////////////////////
		///////////////// changed following to incorporate WSD enhancements ////////////////////
		////////////////////////////////////////////////////////////////////////////////////////

		//handling Non-Mapping Lexicon Rules.....

		GetSuccessfulConditionedRules(block,FirstPair,RuleList);
		success_count=ExecuteRules(RuleList,NULL,FirstPair,FSPairStack,ControlKeywords);

		if(success_count==0)
		{
			success_count=ExecuteRules(block->UnConditionedRuleList,block->DefaultRule,FirstPair,FSPairStack,ControlKeywords);
		}
	}
	

	if(success_count==0)
	{
		UpdateSourceAndTargetStacks(FirstPair,FirstPair->TargetFS->CurrentPtr);				
		wstring wstr1=CSymbolTableManager::GetString(block->BlockId);
		
		if(!IsPredBlockUsed)
			DeleteMappingRuleBlockOnly(block);

		#ifdef GenLog
		CLogManager::AddMessage(L"None of the mapping rules for "+wstr1+L" was successfull.");
		#endif
	
		return true;
	}

			
	if(!IsPredBlockUsed)
		DeleteMappingRuleBlockOnly(block);

return true;
}

bool CMapper::CheckWhenCondition(wstring & WhenConditon, 
								 CFStructureItem *SrcFSItem, 
								 CFStructureItem *TargetFSItem)
{
	
	if(WhenConditon==L"")
		return true;

	if(!SrcFSItem && !TargetFSItem)
		return false;
	
	/* REPLACING IN THIS (DOS/LINUX)VERSION
	CString cstr=WhenConditon.c_str();			
	cstr.Replace(L"=c",L"=="); 

	wstring wstr=cstr.GetBuffer(512);
	END REPLACING IN THIS (DOS/LINUX)VERSION*/
	/* REPLACING WITH */
	wstring wstr=L"";
	wstring temp=WhenConditon;

	if(temp.find(L"=c")!= wstring::npos)
	{
		while(temp.find(L"=c")!= wstring::npos)
		{
			wstr=temp.replace(temp.find(L"=c"),2,L"==");
			temp=wstr;
		}
	}
	else
		wstr=temp;
	/* END REPLACING WITH */
	wstring	left=L"";
	wstring	right=L"";
	wstring	str=L"";	

	string bool_exp="";	
	bool test = false;
	short cond_len= wstr.size();		
	short last_op=0;
	short result=0;	
	
	for(short n=0;n<cond_len;n++)
	{
		switch(wstr[n])
		{
		   case ')':

			    if(str==L"")
				{
					bool_exp+=")";
					last_op=')';					
					break;
				}
												
				if(left==L"")
				{					
					left=TrimString(str);
					result=CheckConstraint(SrcFSItem,TargetFSItem,left,right);				
					bool_exp += (result+48);

					bool_exp+=")";
					last_op=')';
					left=right=str=L"";	
					break;
				}
								
				right=TrimString(str);
				left=TrimString(left);
			//	if(right==L"ADJUNCT.MOD_N")
			//		test = true;
					//result = false;

				result=CheckConstraint(SrcFSItem,TargetFSItem,left,right);				
				bool_exp += (result+48);
				
				bool_exp+=")";
				last_op=')';

				left=right=str=L"";
				break;

		   case '&':
		   case '|':

				if(last_op==wstr[n])
					break;

				if(last_op==')' && left==L"")
				{					
					last_op= wstr[n];	
					bool_exp +=(char) wstr[n];
					break;
				}

				last_op= wstr[n];
				
				right=TrimString(str);

				result=CheckConstraint(SrcFSItem,TargetFSItem,left,right);
						
				bool_exp += (char)(result+48);
				bool_exp += (char)wstr[n];
				left=right=str=L"";
				
				break;

		   case '(':
				
				bool_exp+="(";		
				break;
   		   			
		   case '=':

				if(last_op=='=')
					break;

				last_op='=';
				left=str;
				str=L"";
				break;
					
			case '~':

				bool_exp += "!";	
				break;
					
  			default:
		
				str+= wstr[n];					

		}//end switch					
	
	}//end for
	/*wstring t = Convert_str2wstr(bool_exp);
	if(WhenConditon == L"((ADJUNCT.MOD_N) && ~(ADJUNCT.ADJ))")
		MessageBox(NULL,t.c_str(), L"wrong condition", MB_ICONINFORMATION);*/

	long rs=EvaluateBooleanExpressionEx(bool_exp);
	/*if(WhenConditon == L"((ADJUNCT.MOD_N) && ~(ADJUNCT.ADJ))")
		MessageBox(NULL,Convert_str2wstr(int2string(rs)).c_str(), L"wrong condition", MB_ICONINFORMATION);*/

	if(rs>0)
		return true;
	
	return false;
		
	//return true;
}

bool CMapper::ApplyRule(CMappingRule *rule, 
						CFStructure *SrcFS, 
						CFStructure *TargetFS,
						CControlKeywords & ControlKeywords)
{
	if(!rule)
		return false;

	CAction*action=NULL;

	//CFStructureItem * Src    = SrcFS->CurrentPtr;
	//CFStructureItem * Target = TargetFS->CurrentPtr;

	for(vector<CAction*>::iterator it=rule->ActionList.begin();
		it!=rule->ActionList.end() && !ControlKeywords.m_insertInvoked ;it++)
		{
			action=*it;
			
			ControlKeywords.m_insertInvoked=false;

			if(!ExecuteAction(action,SrcFS,TargetFS,ControlKeywords))
				return false;			
			
		}

	//ranking target f-structure.
	TargetFS->Rank*=rule->Rank;

	return true;
}

short CMapper::CheckConstraint(CFStructureItem * source_fsitem,
							   CFStructureItem * target_fsitem,
							   wstring &left,wstring &right)
{
	using namespace std;	

	if(!source_fsitem && !target_fsitem)
		return 0;	
		
	CFDExpression * left_exp=LexPtr->GenerateFDExpressionEx(left);
	CFDExpression * right_exp=LexPtr->GenerateFDExpressionEx(right);

	if(!left_exp)
	{
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 0;
	}

	CFStructureItem * source=NULL;
	CFStructureItem * target=NULL;

	if(left_exp->op==TARGET_OP)
		source=target_fsitem;
	else
		source=source_fsitem;

	if(!source)
		return 0;

	if(right_exp && right_exp->op==SOURCE_OP)
		target=source_fsitem;		
	else
		target=target_fsitem;		

	if(!target)
	{
		if(source->GetParent()->Search(&(left_exp->list)))
			return 1;
		else
			return 0;
	}
		
	if(left_exp->list.at(0)==CSymbolTableManager::RootId)
	{
		left_exp->list.erase(left_exp->list.begin());

		while(source->Label!=CSymbolTableManager::RootId && source->GetParent())		
			source=source->GetParent();		

	}
	else 
	{
		wstring temp = CSymbolTableManager::GetString(source->Label);
		bool isELEMENT = false;
		/*if(temp.find(L"ELEMENT") != wstring.npos) CHANGED IN THIS (LINUX) VERSION*/
		if(temp.find(L"ELEMENT") != wstring::npos)
			isELEMENT = true;
		if(left_exp->list.at(0)!=CSymbolTableManager::ParentId && 
			!isELEMENT && left_exp->op!=TARGET_OP)
		{
			if(source->GetParent())
				source=source->GetParent();
		}
		else
		{
			vector<short> vlist;
			for(vector<short>::iterator it=left_exp->list.begin();it!=left_exp->list.end();it++)
			{
				if(*it==CSymbolTableManager::ParentId && source->GetParent())			
					source=source->GetParent(true);							
				else
					if(*it!=CSymbolTableManager::ParentId)
						vlist.push_back(*it);
			}
			left_exp->list=vlist;
		}
	}
	if(!source)
	{
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 0;
	}
	
	CFStructureItem*sfs=NULL;
	CFStructureItem*tfs=NULL;
	
	if(left_exp->list.size()==0)
	{
		vector<short> vlist;
		
		/*if(source->Parent)
			vlist.push_back(source->Parent->Label);
		else*/

		vlist.push_back(source->Label);
		
		if(!UtilityInterface->IsIntersectionEmpty(&vlist,&right_exp->list))
		{
			CFDExpression::DeleteFDExpressions(left_exp,right_exp);
			return 1;
		}
	
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 0;
	}
	else
	{	
		sfs=source->Search(&left_exp->list);		
		
		if(sfs && sfs->Label==CSymbolTableManager::PredId)
		{			
			sfs=sfs->SearchEx(CSymbolTableManager::ValueId);
		}
	}
	
	if(!sfs)
	{
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 0;
	}

	if(sfs && !right_exp)
	{
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 1;
	}

	if(right_exp->op==VALUE_OP)
	{
		if(sfs->Label==CSymbolTableManager::GFId)
		{
			if(CChart::CheckListEquality(&sfs->ValueList,&right_exp->list)) 
			{
				CFDExpression::DeleteFDExpressions(left_exp,right_exp);
				return 1;
			}
		}
		else if(!CChart::IsIntersectionEmpty(&sfs->ValueList,&right_exp->list)) 
		{
			CFDExpression::DeleteFDExpressions(left_exp,right_exp);
			return 1;
		}
		
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 0;
	}

	if(right_exp->list.at(0)==CSymbolTableManager::RootId)
	{
		right_exp->list.erase(right_exp->list.begin());

		while(target->Label!=CSymbolTableManager::RootId && target->GetParent())		
			target=target->GetParent();		
	}
	
	if(right_exp->op==SOURCE_OP)	
		tfs=source->Search(&right_exp->list);		
	else
		tfs=target->Search(&right_exp->list);

	if(!tfs)
	{
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 0;
	}

	if(!CChart::IsIntersectionEmpty(&sfs->ValueList,&tfs->ValueList)) 
	{
		CFDExpression::DeleteFDExpressions(left_exp,right_exp);
		return 1;
	}

	CFDExpression::DeleteFDExpressions(left_exp,right_exp);
	return 0;		
}

bool CMapper::ExecuteAction(CAction *action, 
							CFStructure * SrcFS, 
							CFStructure * TargetFS,
							CControlKeywords & ControlKeywords
							)
{		
	CFStructureItem *Src	= SrcFS->CurrentPtr;
	CFStructureItem *Target	= TargetFS->CurrentPtr;

	if(!action || !Target)
		return false;

	CAction *act=action->GetClone();

	CFStructureItem * fsitem=NULL;
//	CFStructureItem * fsitem2=NULL;

	char created=0;
	bool success=true;
	bool DontChange=false;
	short someid=0;

	switch(act->op)
	{
		case DELETE_OP:
			
			fsitem=Target->Search(&act->Rhs.list);

			if(fsitem && fsitem->GetParent())		
			{
				vector<CFStructureItem*> TempList;
				
				vector<CFStructureItem*>::iterator it=fsitem->GetParent()->ChildList.begin();				
				
				for(;it!=fsitem->GetParent()->ChildList.end();it++)
					{						
						if(*it!=fsitem)
							TempList.push_back(*it);						
					}		

				fsitem->GetParent()->ChildList=TempList;

				try{
					delete fsitem;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"#### fsitem");
					#endif
				}

			}	
			else
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"No Item is found in Target F-Structure, mentioned in DELETE COMMAND.");
				#endif
			}


			break;
		
		case NO_OP:
			
			someid=act->Lhs.list.at(0);

			if(someid==CSymbolTableManager::ElementId)
			{
				wstring str = L"ELEMENT" + GetWSTR(ElementCounter);
				ElementCounter++;
				fsitem=new CFStructureItem(CSymbolTableManager::GetNum(str),Target);
				
				if(!fsitem)
					break;

				Target->ChildList.push_back(fsitem);
			}
			else if(someid==CSymbolTableManager::NullId)	
			{
				ControlKeywords.setNull(true);			
			}
			else if(someid==CSymbolTableManager::BreakId)	
			{
				ControlKeywords.setBreak(true);
				//printf("Break encountered");
				//ContainsNULL=true;			
			}
			else
			{
				//printf("%d=%d\n", someid, someid  );
				fsitem=Target->SearchAndCreate(&act->Lhs.list,created);							
			}

			if(fsitem)
			{					
				/** L D D **/
				fsitem->ItemNo=Src->ItemNo;
				fsitem->IsReferred=Src->IsReferred;
				fsitem->Reference=Src->Reference;
				/*********************************/

				if(fsitem->Reference<=0)
					TargetFS->CurrentPtr=fsitem;
			}
			
			break;

		case INSERT_OP:
			{
				CMappingRuleBlock*iRuleBlock=NULL;
				iRuleBlock=InsertRuleMngr->GetRuleBlock(act->insertBlockName);
				if(iRuleBlock)
				{
					//ActiveInsertRuleList.insert(MapRulePair(iRuleBlock->BlockId,iRuleBlock));
					
					AddActiveInsertRule(act->mainBlockName,iRuleBlock);
					
					if(act->option>0)
					{
						if(act->option==CSymbolTableManager::NullId)//if insert has NULL as argument then no change...					
							ControlKeywords.m_insertInvoked=false;						
						else 
						{
							ControlKeywords.m_insertInvoked=true;
							ControlKeywords.m_insertMovePosition=act->option;						
							ControlKeywords.m_isMoveCount=act->isMoveCount;
						}
					}
				}				
			}
			break;


		case UNIFY_OP:

			if(act->Lhs.list.at(0)==CSymbolTableManager::RootId)
			{
				DontChange=true;
				act->Lhs.list.erase(act->Lhs.list.begin());
				while(Target->GetParent())
					Target=Target->GetParent();
			}

			//////////////////////////////////////////////////
			
			if(act->Lhs.list.at(0)==CSymbolTableManager::ParentId)
			{
				DontChange=true;
				vector<short> vlist;
				for(vector<short>::iterator it=act->Lhs.list.begin();it!=act->Lhs.list.end();it++)
				{
					if(*it==CSymbolTableManager::ParentId && Target->GetParent())			
						Target=Target->GetParent(true);							
					else if(*it!=CSymbolTableManager::ParentId)
						vlist.push_back(*it);
				}				
				act->Lhs.list=vlist;
			}
		
			//else if(Target->Label!=RootId)
			//	Target=Target->Parent;
			
			//////////////////////////////////////////////////

			/////added
			//act->Lhs.list.at(0)
				
			fsitem=Target->SearchAndCreate(&act->Lhs.list,created);
			
			if(fsitem)
			{				
				if(act->Rhs.start_op==VALUE_OP)
				{					
					if(fsitem->Label==CSymbolTableManager::PredId)
					{						
						fsitem=fsitem->SearchAndCreate(CSymbolTableManager::ValueId,created);						
						
						if(fsitem->ValueList.size()==0)
						{
							fsitem->ValueList=act->Rhs.list;
							//TargetFS->CurrentPtr=fsitem->GetParent()->GetParent();
							if(!fsitem->UpdateLinkedNode())
								return false;
						}
					}
					else
						success=UtilityInterface->UnifySpecial(fsitem,NULL,&act->Rhs.list,false);
					//fsitem->ValueList=act->Rhs.list;
				}
				else if(act->Rhs.start_op=SOURCE_OP)
				{
					if(act->Rhs.list.at(0)!=CSymbolTableManager::ParentId && Src->GetParent())
					{
						Src=Src->GetParent();
					}

					Src=Src->Search(&act->Rhs.list);
					
					if(Src)
						success=UtilityInterface->UnifySpecial(fsitem,Src,NULL,false);										
					else
					{
						#ifdef GenLog
						wstring err_str=CSymbolTableManager::GetStringByList(act->Rhs.list,L" ");						
						CLogManager::AddMessage(L"Source FSItem not found for "+err_str);
						#endif
					}
				}
				else if(act->Rhs.start_op=TARGET_OP)
				{
					if(act->Rhs.list.at(0)!=CSymbolTableManager::ParentId && Target->GetParent())
					{
						Target=Target->GetParent();
					}

					Target=Target->Search(&act->Rhs.list);
					
					if(Target)
						success=UtilityInterface->UnifySpecial(fsitem,Target,NULL,false);									
					else
					{
						#ifdef GenLog
						wstring err_str=CSymbolTableManager::GetStringByList(act->Rhs.list,L" ");
						CLogManager::AddMessage(L"Target FSItem not found for "+err_str);
						#endif
					}
					
				}
				else
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"No operator defined for Action ???");
					#endif
				}
				
				//if(success)
				//	TargetFS->CurrentPtr=fsitem;
			}

			break;							
	}
	
	if(act)
	{
		delete act;		
	}

	return success;
}


CMappingRuleBlock* CMapper::GetPredRuleBlock(short id)
{
	if(PredAction)		
	{
		PredAction->Rhs.list.clear();
		PredAction->Rhs.list.push_back(id);
	}
	
	return PredRule;
}

CMappingRuleBlock* CMapper::GetPredRuleBlockEx(wstring & eng_str)
{
	if(PredAction)		
	{
		PredAction->Rhs.list.clear();		

		short ind=eng_str.find('_');
		
		if(ind>0)		
			eng_str=eng_str.substr(0,ind);
		
		wstring urdu_str=Transliterator.transliterate(eng_str);
		
		short id=CSymbolTableManager::GetNum(urdu_str,true);

		PredAction->Rhs.list.push_back(id);
	}
	
	return PredRule;
}


bool CMapper::AdjustFStructure(CFStructure* FSPtr)
{
	if(!FSPtr)
		return false;
	
	return AdjustFStructureRec(FSPtr->Root);	
}

bool CMapper::AdjustFStructureRec(CFStructureItem* FSItemPtr)
{
	if(!FSItemPtr)
		return false;	

	if(FSItemPtr->Label==CSymbolTableManager::PredId)
	{
		return GenerateExtendedPred(FSItemPtr);	
	}

	CFStructureItem * Set=NULL;
	CFStructureItem * Element=NULL;			

	if(FSItemPtr->SetElements.size()!=0)
	{
		Set=new CFStructureItem(CSymbolTableManager::SetId);
		
		if(!Set)
			return false;

		Set->SetParent(FSItemPtr);				
		
		for(vector<CFStructureItem*>::iterator it2=FSItemPtr->SetElements.begin();
			it2!=FSItemPtr->SetElements.end();it2++)
		{
			Element=*it2;
			Element->SetParent(Set);
			Set->ChildList.push_back(Element);			
		}
		
		FSItemPtr->ChildList.push_back(Set);
		
		FSItemPtr->SetElements.erase(FSItemPtr->SetElements.begin(),FSItemPtr->SetElements.end());
	}
	
	for(vector<CFStructureItem*>::iterator it=FSItemPtr->ChildList.begin(); 
		it!=FSItemPtr->ChildList.end();it++)
		AdjustFStructureRec(*it);

	return true;
}

bool CMapper::GenerateExtendedPred(CFStructureItem* FSItemPtr)
{
	wstring pstr=L"";

	CFStructureItem * ValueItem=NULL;
	CFStructureItem * GFItem=NULL;	

	vector<short>::iterator it=FSItemPtr->ValueList.begin();

	ValueItem=new CFStructureItem(CSymbolTableManager::ValueId);
	ValueItem->ValueList.push_back(*it);

	ValueItem->SetParent(FSItemPtr);
	FSItemPtr->ChildList.push_back(ValueItem);

	it++;

	if(it!=FSItemPtr->ValueList.end())
	{
		GFItem=new CFStructureItem(CSymbolTableManager::GFId);
		GFItem->SetParent(FSItemPtr);

		for(;it!=FSItemPtr->ValueList.end();it++)	
			GFItem->ValueList.push_back(*it);			
		
		FSItemPtr->ChildList.push_back(GFItem);
	}

	FSItemPtr->ValueList.erase(FSItemPtr->ValueList.begin(),FSItemPtr->ValueList.end());
    	
	//CLogManager::AddMessage(pstr+L"\r\n");

	return true;
}

CMappingRuleBlock* CMapper::GetPriortizedRuleBlock(short BlockId,bool isMapLexRule)
{
	using namespace std;

	multimap<short,CMappingRuleBlock*>::iterator it=ActiveInsertRuleList.find(BlockId);
	
	CMappingRuleBlock * NewRuleBlock=new CMappingRuleBlock();
	CMappingRuleBlock * iRuleBlock=NULL;
	CMappingRule*rule=NULL;

	if(it!=ActiveInsertRuleList.end())	
	{
		iRuleBlock=it->second;
		NewRuleBlock->BlockId=iRuleBlock->BlockId;

		while(it!=ActiveInsertRuleList.end())
		{
			iRuleBlock=it->second;

			for(vector<CMappingRule*>::iterator rit=iRuleBlock->RuleList.begin();
				rit!=iRuleBlock->RuleList.end();rit++)
			{
				rule=*rit;				
				NewRuleBlock->AddRule(rule);
			}			

			it++;
		}	
		
		iRuleBlock=NewRuleBlock;
	}
	//else
	//{		
		if(isMapLexRule)
		{
			if(this->DLexMngr!=NULL)
			{
				iRuleBlock = this->DLexMngr->GetRuleBlock(BlockId);
				if(iRuleBlock==NULL)
					iRuleBlock = this->LexMngr->GetRuleBlock(BlockId);
			}
			else
					iRuleBlock = this->LexMngr->GetRuleBlock(BlockId);

		}
		else
			iRuleBlock = this->RuleMngr->GetRuleBlock(BlockId);
		
		if(iRuleBlock)
		{
			NewRuleBlock->BlockId=iRuleBlock->BlockId;

			for(vector<CMappingRule*>::iterator rit=iRuleBlock->RuleList.begin();
					rit!=iRuleBlock->RuleList.end();rit++)
			{
					rule=*rit;					
					NewRuleBlock->AddRule(rule);
			}
			NewRuleBlock->DefaultRule=iRuleBlock->DefaultRule;			
			iRuleBlock=NewRuleBlock;
		}
		else
		{
			delete NewRuleBlock;
		}
	//}

	return iRuleBlock;
}

bool CMapper::AddActiveInsertRule(short FaceId,CMappingRuleBlock* iRuleBlock)
{
	if(!iRuleBlock)
		return false;

	bool found=false;

	multimap<short,CMappingRuleBlock*>::iterator it=ActiveInsertRuleList.find(FaceId);
	
	CMappingRuleBlock * temp_block=NULL;

	while(it!=ActiveInsertRuleList.end())
	{
		temp_block=it->second;
		if(temp_block->BlockId==iRuleBlock->BlockId)
		{
			found=true;
			break;
		}
		it++;
	}

	//CMappingRuleBlock * rule_blk=iRuleBlock->GetClone();

	/*wstring block_name=LexPtr->GetConstantName(rule_blk->BlockId);
	short found=block_name.find(L"_");
	if(found)
	{
		block_name=block_name.substr(0,found);
		rule_blk->BlockId=LexPtr->GetConstantNumber(block_name,true);
	}*/
	
	if(found)
		return false;

	ActiveInsertRuleList.insert(MapRulePair(FaceId,iRuleBlock));

	return true;
}

CFSPairInfo* CMapper::BackTrackFSCurrentPtr(CFSPairInfo* fspair, short NodeId, bool Levels)
{
	if(!fspair)
		return NULL;

	CFSPairInfo* newpair=NULL;
	CFStructureItem*ptr=NULL;
	
	ptr=fspair->SourceFS->CurrentPtr;

	if(!ptr)
		return NULL;

	if(Levels)
	{
		while(ptr->GetParent() && NodeId>0)
		{
			ptr=ptr->GetParent();
			if(ptr && ptr->Label!=CSymbolTableManager::SetId && ptr->Label!=CSymbolTableManager::ElementId)
				NodeId--;
		}
	}
	else
	{
		while(ptr->Label!=NodeId && ptr->GetParent())		
			ptr=ptr->GetParent(true);					
	}
	
	if(ptr->Label==CSymbolTableManager::RootId)
	{
		while(!fspair->FeatureStack.empty())
			fspair->FeatureStack.pop();

		while(!fspair->TargetPointerStack.empty())
			fspair->TargetPointerStack.pop();					
		
		fspair->SourceFS->CurrentPtr=fspair->SourceFS->Root;
		fspair->TargetFS->CurrentPtr=fspair->TargetFS->Root;

		newpair=GenerateNewFSPair(fspair);			
		
		AddChildAndSetElementsInFeatureStack(&newpair->FeatureStack,newpair->SourceFS->CurrentPtr);

	}
	else
	{				
		CFStructureItem * tempfs=NULL;
		CFStructureItem * fptr=NULL;
		CFStructureItem * sfs=NULL;
		CFStructureItem * tfs=NULL;

		while(!fspair->SourcePointerStack.empty())
		{
			sfs=fspair->SourcePointerStack.top();
			fspair->SourcePointerStack.pop();

			fspair->SourceFS->CurrentPtr=sfs;

			if(sfs->Label==ptr->Label)
			{						
				AddChildAndSetElementsInFeatureStack(&fspair->FeatureStack,fspair->SourceFS->CurrentPtr);
				newpair=NULL;				
				break;
			}			

			if(!fspair->TargetPointerStack.empty())
			{
				tfs=fspair->TargetPointerStack.top();
				fspair->TargetPointerStack.pop();

				fspair->TargetFS->CurrentPtr=tfs;
			}

			while(!fspair->FeatureStack.empty())
			{
				fptr=fspair->FeatureStack.top();
				fspair->FeatureStack.pop();
				if(fptr==SEPARATOR)
					break;
			}
		}
	}

	return newpair;
}

bool CMapper::GetSuccessfulConditionedRules(CMappingRuleBlock * block, 
											CFSPairInfo* FSPair,
											list<CMappingRule*> & SuccessfulResultList)
{
	SuccessfulResultList.clear();

	if(!block || !FSPair)
		return false;

	CMappingRule*rule=NULL;

	for(list<CMappingRule*>::iterator it=block->ConditionedRuleList.begin();
		it!=block->ConditionedRuleList.end();it++)
	{
		rule=*it;

		if(CheckWhenCondition(rule->WhenCondition, FSPair->SourceFS->CurrentPtr,FSPair->TargetFS->CurrentPtr))
		{
		/*	if(rule->WhenCondition == L"(ADJUNCT.MOD_N && ~(ADJUNCT.ADJ))")
				MessageBox(NULL, L"wrong condition", L"wrong condition", MB_ICONINFORMATION);*/
			SuccessfulResultList.push_back(rule);
		}
	}

	return true;
}

bool CMapper::GetSuccessfulConditionedRulesWithUniqueSenses(
										CMappingRuleBlock * block, 
										CFSPairInfo* FSPair,
										list<CMappingRule*> & SuccessfulResultList)
{
	SuccessfulResultList.clear();

	if(!block || !FSPair)
		return false;

	CMappingRule*rule=NULL;

	map<int,CMappingRule*> SelectedRules;
	map<int,CMappingRule*>::iterator tofind;
	typedef pair<int,CMappingRule*> IntMapRulePair;
	int i=1; //for the time being to check
	for(list<CMappingRule*>::iterator it=block->ConditionedRuleList.begin();
		it!=block->ConditionedRuleList.end();it++)
	{
		rule=*it;

		if(CheckWhenCondition(rule->WhenCondition, FSPair->SourceFS->CurrentPtr,FSPair->TargetFS->CurrentPtr))
		{
			if(rule->SenseNumber==0)
			{
				SelectedRules.insert(IntMapRulePair(i,rule));			
			}
			else
			{
			tofind=SelectedRules.find(rule->SenseNumber);
			
			if(tofind==SelectedRules.end()) //not found
			{				
				SelectedRules.insert(IntMapRulePair(rule->SenseNumber,rule));			
			}
			else // has found the sense
			{
				if(rule->HasBreak)
					tofind->second=rule;
			}
			}			
			if(rule->HasBreak)
				break;	
			i++; //to check
		}
	}

	for(map<int,CMappingRule*>::iterator mit=SelectedRules.begin();mit!=SelectedRules.end();mit++)		
	{
		SuccessfulResultList.push_back(mit->second);
	}

	SelectedRules.clear();

	return true;
}

bool CMapper::GetRankedRules(wstring amb_word, list<CMappingRule*> & RuleList, 
							 short CurrentWordIndex, 
							 CSentenceInfo & SenPOSInfo)
{
	list< CSenseInfo* > SenseInfoList;
	
	CMappingRule*rule=NULL;
	CSenseInfo*sense=NULL;

	for(list<CMappingRule*>::iterator mit=RuleList.begin();mit!=RuleList.end();mit++)
	{
		rule=*mit;
		sense=new CSenseInfo(rule->SenseNumber,rule);
		SenseInfoList.push_back(sense);
	}

	bool ret_val=WSDMngr.RankData(amb_word, SenseInfoList,SenPOSInfo,CurrentWordIndex);

	RuleList.clear();

	for(list<CSenseInfo*>::iterator sit=SenseInfoList.begin();sit!=SenseInfoList.end();sit++)
	{
		sense=*sit;
		sense->RulePtr->Rank=sense->Rank;
		RuleList.push_back(sense->RulePtr);
	}

	return ret_val;
}

int CMapper::ExecuteRules(list<CMappingRule*> & RuleList , 
		CMappingRule* DefaultRule, 
		CFSPairInfo* FSPair, 
		stack<CFSPairInfo*> * FSPairStack , 
		CControlKeywords & ControlKeywords)
{	

	CFStructureItem * StoredPtr = NULL;

	size_t RuleListSize=RuleList.size();
	
	int success_count=0;

	if(RuleListSize==0)
	{
		if(DefaultRule)
		{
			StoredPtr=FSPair->TargetFS->CurrentPtr;
			if(ApplyRule(DefaultRule,FSPair->SourceFS,FSPair->TargetFS,ControlKeywords))
			{
				if (ControlKeywords.m_boolNull)
				{
					StoredPtr=FSPair->TargetFS->CurrentPtr;
					if(FSPair->SourceFS->CurrentPtr->ChildList.size()>0 || 
						FSPair->SourceFS->CurrentPtr->SetElements.size()>0 )
					{
						FSPair->TargetPointerStack.push(StoredPtr);
						FSPair->SourcePointerStack.push(FSPair->SourceFS->CurrentPtr);
						FSPair->FeatureStack.push(SEPARATOR);
					}
				}
				else
					UpdateSourceAndTargetStacks(FSPair,StoredPtr);
				success_count++;
			}
		}
	
	return success_count;
	}

	CFSPairInfo * OrigFSPair=GenerateNewFSPair(FSPair);
	multimap<short,CMappingRuleBlock*> OrigInsertRuleList;	//tahira*
	OrigInsertRuleList=ActiveInsertRuleList;		//tahira*

	CMappingRule*rule=NULL;
	list<CMappingRule*>::iterator rit=RuleList.begin();
	rule=*rit;	//first rule

	
	StoredPtr=FSPair->TargetFS->CurrentPtr;
	
	if(ApplyRule(rule,FSPair->SourceFS,FSPair->TargetFS,ControlKeywords))
	{
		if (ControlKeywords.m_boolNull)
		{
			StoredPtr=FSPair->TargetFS->CurrentPtr;
			if(FSPair->SourceFS->CurrentPtr->ChildList.size()>0 || 
				FSPair->SourceFS->CurrentPtr->SetElements.size()>0 )
			{
			//pinfo->TargetPointerStack.push(pinfo->TargetFS->CurrentPtr);		
				FSPair->TargetPointerStack.push(StoredPtr);
				FSPair->SourcePointerStack.push(FSPair->SourceFS->CurrentPtr);
				FSPair->FeatureStack.push(SEPARATOR);
			}
		}
		else
			UpdateSourceAndTargetStacks(FSPair,StoredPtr);
		success_count++;
	}
	
	if(RuleListSize==1 && success_count>0)
	{
		delete OrigFSPair;
		return success_count;
	}

	CFSPairInfo * TempFSPair=NULL;
	multimap<short,CMappingRuleBlock*> TempInsertRuleList=ActiveInsertRuleList;	//tahira*

	
	rit++;
	for(;rit!=RuleList.end() && !ControlKeywords.m_boolBreak && success_count < FSCloneLimit ;rit++)
	{
		rule=*rit;
		TempFSPair=GenerateNewFSPair(OrigFSPair);
		
		StoredPtr=TempFSPair->TargetFS->CurrentPtr;
		
		ActiveInsertRuleList=OrigInsertRuleList;	//tahira*

		if(ApplyRule(rule,TempFSPair->SourceFS,TempFSPair->TargetFS,ControlKeywords))
		{
			if (ControlKeywords.m_boolNull)
			{
				StoredPtr=FSPair->TargetFS->CurrentPtr;
				if(FSPair->SourceFS->CurrentPtr->ChildList.size()>0 || 
					FSPair->SourceFS->CurrentPtr->SetElements.size()>0 )
				{
			
					FSPair->TargetPointerStack.push(StoredPtr);
					FSPair->SourcePointerStack.push(FSPair->SourceFS->CurrentPtr);
					FSPair->FeatureStack.push(SEPARATOR);
				}
			}
			else
				UpdateSourceAndTargetStacks(TempFSPair,StoredPtr);
			success_count++;
			TempFSPair->InsertRuleList=ActiveInsertRuleList;	//tahira*
			FSPairStack->push(TempFSPair);	
			ActiveInsertRuleList=TempInsertRuleList;	//tahira* (*reason: current list should not contain the insert rules of those fspairs which are yet on stack)
			
			if(ControlKeywords.m_boolBreak)
				break;
		}
		else
		{
			delete TempFSPair;
			TempFSPair=NULL;
		}
	}

	if(success_count==0 && DefaultRule!=NULL)
	{
		StoredPtr=FSPair->TargetFS->CurrentPtr;

		if (ApplyRule(DefaultRule,FSPair->SourceFS,FSPair->TargetFS,ControlKeywords))
		{
			if (ControlKeywords.m_boolNull)
			{
				StoredPtr=FSPair->TargetFS->CurrentPtr;
				if(FSPair->SourceFS->CurrentPtr->ChildList.size()>0 || 
					FSPair->SourceFS->CurrentPtr->SetElements.size()>0 )
				{
			
					FSPair->TargetPointerStack.push(StoredPtr);
					FSPair->SourcePointerStack.push(FSPair->SourceFS->CurrentPtr);
					FSPair->FeatureStack.push(SEPARATOR);
				}
			}
			else
			UpdateSourceAndTargetStacks(OrigFSPair,StoredPtr);
			FSPairStack->push(OrigFSPair);
			//success_count=0, suppressing the current FS Pair.
		}
		else
		{	
			delete OrigFSPair;
		}	
	}
	
	return success_count;	
}

bool CMapper::DeleteMappingRuleBlockOnly(CMappingRuleBlock * block)
{
	if(!block)
		return false;
	
	block->ConditionedRuleList.clear();
	block->UnConditionedRuleList.clear();
	block->RuleList.clear();
	block->DefaultRule=NULL;

	delete block;
	
	return true;
}
