// Mapper.h: interface for the CMapper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAPPER_H__46D97747_E4C4_49AD_A0B4_48A20C6466E9__INCLUDED_)
#define AFX_MAPPER_H__46D97747_E4C4_49AD_A0B4_48A20C6466E9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "stdafx.h"
#pragma warning(disable: 4786)

#include<vector>
#include<stack>
#include<list>

#include "SourceTargetFSInfo.h"
#include "Transliterator.h"
#include "MappingRuleManager.h"
//#include "InsertMappingRuleBlock.h"
#include "CFStructure.h"
#include "FSPairInfo.h"
#include "CLexicon.h"
#include "CChart.h"
#include "ControlKeywords.h"
#include "FSCSPairInfo.h"
#include "SenseInfo.h"
#include "WSDManager.h"
#include "SentenceInfo.h"

using namespace std;

class CChart;

class CMapper  
{

public:

	CWSDManager WSDMngr;
	short ElementCounter;
	short FSCloneLimit;
	bool GenerateAllPossibleVariations;


	vector<CSourceTargetFSInfo*> *	GenerateTargetFStructuresEx( 
										list<CFSCSPairInfo*> & FSCSList,
										CMappingRuleManager * RuleMngr,
										CMappingRuleManager * LexMngr,
										CMappingRuleManager * DLexMngr,
										CMappingRuleManager * InsertRMngr);
	
	bool UpdateSourceAndTargetStacks(CFSPairInfo*pinfo,CFStructureItem*oldptr);
	CFSPairInfo * GenerateNewFSPair(CFSPairInfo*OrigFSPair);
	
	CMappingRuleBlock* GetPredRuleBlock(short id);
	CMappingRuleBlock* GetPredRuleBlockEx(wstring & eng_str);
	bool SaveUniqueFStructure(vector<CFStructure * > * FSResults, CFStructure * fs);

	bool AddChildAndSetElementsInFeatureStack(stack<CFStructureItem*> * sFeatureStack,CFStructureItem*sFS);
	bool ExecuteAction(CAction *act, CFStructure * SrcFS, CFStructure * TargetFS,CControlKeywords & ControlKeywords);
	bool ApplyRule(CMappingRule*rule,CFStructure * Src,CFStructure * Target,CControlKeywords & ControlKeywords);
	bool CheckWhenCondition(wstring & when, CFStructureItem*SrcFSItem,CFStructureItem*TargetFSItem);

	CMappingRuleManager * RuleMngr;
	CMappingRuleManager * LexMngr;
	CMappingRuleManager * DLexMngr;
	CMappingRuleManager * InsertRuleMngr;

	CLexicon*LexPtr;
	CChart* UtilityInterface;
	CMappingRuleBlock * PredRule;
	CAction*PredAction;
	CAction *GFaction;
	CTransliterator Transliterator;
    
	multimap<short,CMappingRuleBlock*> ActiveInsertRuleList;
/*
	static short PredId;
	static short ParentId;
	static short RootId;
	static short SetId;
	static short ElementId;
	static short ValueId;
	static short GFId;
	static short NULLId;
	static short BreakId;
*/
	bool ApplyFinalRule(CFStructure * SrcFS, CFStructure * TargetFS);

	short CheckConstraint(CFStructureItem * source,CFStructureItem * target,
						  wstring &left,wstring &right);

	/*bool GenerateTargetFeature1(CFStructure * SrcFS, 
								CFStructure * TargetFS,
								stack<CFStructureItem*> * FeatureStack,
								stack<CFStructureItem*> * TargetPtrStack,
								stack<CFSPairInfo*> * FSPairStack,
								bool & ContainsNULL);
	*/

	bool GenerateTargetFeatureEx(CFSPairInfo*FirstPair,
								stack<CFSPairInfo*> * FSPairStack,
								CControlKeywords & ControlKeywords,
								CSentenceInfo & sen_info);

	bool GenerateFStructures(stack<CFSPairInfo*>*FSPairStack,
							 vector<CFStructure*>*,
							 CSentenceInfo & sen_info);

	vector<CSourceTargetFSInfo*> * GenerateTargetFStructures( vector<CFStructure*> * SourceFSList,
									CMappingRuleManager * ,
									CMappingRuleManager * ,
									CMappingRuleManager * );
	
	CMapper(CLexicon*Lex,CChart* utinterface, string trfname);

	~CMapper();
	
	static bool AdjustFStructure(CFStructure* FSPtr);
	static bool AdjustFStructureRec(CFStructureItem* FSItemPtr);
	static bool GenerateExtendedPred(CFStructureItem* FSItemPtr);

	CMappingRuleBlock* GetPriortizedRuleBlock(short BlockId,bool isMapLexRule);
	bool AddActiveInsertRule(short faceid,CMappingRuleBlock* iRuleBlock);
	CFSPairInfo* BackTrackFSCurrentPtr(CFSPairInfo* fspair, short Node, bool Levels);

	bool GetSuccessfulConditionedRules(CMappingRuleBlock * block,
									   CFSPairInfo* FSPair,
									   list<CMappingRule*> & SuccessfulResultList);

	bool GetSuccessfulConditionedRulesWithUniqueSenses(
										CMappingRuleBlock * block, 
										CFSPairInfo* FSPair,
										list<CMappingRule*> & SuccessfulResultList);
	
	bool GenerateTargetFeatureExtended(CFSPairInfo * FirstPair,
											stack<CFSPairInfo*> * FSPairStack,
											CControlKeywords & ControlKeywords,
											CSentenceInfo & SenPOSInfo);

	bool GetRankedRules(wstring amb_word/*added to get baseform, tahira*/,list<CMappingRule*> & RuleList, short CurrentWordIndex, CSentenceInfo & SenPOSInfo);
	
	int ExecuteRules(list<CMappingRule*> & RuleList , 
		CMappingRule* DefaultRule, 
		CFSPairInfo* FSPair, 
		stack<CFSPairInfo*> * FSPairStack , 
		CControlKeywords & ControlKeywords);
	bool DeleteMappingRuleBlockOnly(CMappingRuleBlock* block);
};

#endif // !defined(AFX_MAPPER_H__46D97747_E4C4_49AD_A0B4_48A20C6466E9__INCLUDED_)
