// MapperController.cpp: implementation of the CMapperController class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

/*#include "LanguageParser.h" REMOVED IN THIS (DOS/LINUX) VERSION */
#include "MapperController.h"
#include "CChart.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
/*#define new DEBUG_NEW [REMOVING IN THIS (DOS/LINUX) VERSION] */
#endif

#include <string>

#include "LogManager.h"

//////////////////////////////////////////////////////////////////////
// Constru5ction/Destruction
//////////////////////////////////////////////////////////////////////

CMapperController::CMapperController(
									 string macro_fname,
									 string raw_fname, 
									 string ext_fname,									 
									 string macro_fname2,
									 string raw_fname2, 
									 string ext_fname2,
									 string macro_fname3,
									 string raw_fname3, 
									 string ext_fname3,
									 double MapLexStandardFrequency,
									 double MapRulesStandardFrequency,
									 string trrulesfname,
									 CLexicon*LexPtr,
									 CChart* UtilityInterface)
	
	:MappingRulesManager(macro_fname,raw_fname,ext_fname,LexPtr,MapRulesStandardFrequency),
	MappingLexiconManager(macro_fname2,raw_fname2,ext_fname2,LexPtr,MapLexStandardFrequency),
    InsertRuleManager(macro_fname3,raw_fname3,ext_fname3,LexPtr,MapRulesStandardFrequency),
	Mapper(LexPtr,UtilityInterface,trrulesfname)	
{	

	/********************** changes for domain**********************************/
	string DomainMapLexRawFName=CConfiguration::GetConfigInfo("News");	
	NDomainMappingLexiconManager=new CMappingRuleManager(macro_fname2,DomainMapLexRawFName,ext_fname2,LexPtr,MapLexStandardFrequency);
	
	DomainMapLexRawFName=CConfiguration::GetConfigInfo("Weather");	
	WDomainMappingLexiconManager=new CMappingRuleManager(macro_fname2,DomainMapLexRawFName,ext_fname2,LexPtr,MapLexStandardFrequency);

	DomainMapLexRawFName=CConfiguration::GetConfigInfo("Agriculture");	
    ADomainMappingLexiconManager=new CMappingRuleManager(macro_fname2,DomainMapLexRawFName,ext_fname2,LexPtr,MapLexStandardFrequency);
	/*******************************************************************************/

	using namespace std;

	int bcount=0;
	int rcount=0;
	wstring str=L"";
	
	MappingRulesManager.GetStatistics(bcount,rcount);

	#ifdef GenLog

	str=L"Mapping Rules Blocks: ";
	str+=GetWSTR(bcount);
	str+=L" , Total Mapping Rules: ";
	str+=GetWSTR(rcount);
	str+=L"\r\n";

	CLogManager::AddMessage(str);
	
	#endif

	MappingLexiconManager.GetStatistics(bcount,rcount);

	#ifdef GenLog
	
	str=L"Mapping Lexicon Blocks: ";
	str+=GetWSTR(bcount);
	str+=L" , Total Mapping Lexical Entries: ";
	str+=GetWSTR(rcount);
	str+=L"\r\n";

	CLogManager::AddMessage(str);

	#endif

}

CMapperController::~CMapperController()
{

}

void CMapperController::Initialize(string MappRules,string MappLex, string InsertRules, CLexicon * lex)
{
	MappingLexiconManager.Initialize(MappLex);
	MappingRulesManager.Initialize(MappRules);
	MappingRulesManager.Initialize(InsertRules);
}

vector<CSourceTargetFSInfo*> * CMapperController::GenerateTargetFStructures(vector<CFStructure*> * fs)
{	
	return Mapper.GenerateTargetFStructures(fs,&MappingRulesManager,&MappingLexiconManager,&InsertRuleManager);
}

vector<CSourceTargetFSInfo*> * CMapperController::GenerateTargetFStructuresEx(list<CFSCSPairInfo*> & fscs_list,string domain_name)
{	
if(domain_name=="News")
			return Mapper.GenerateTargetFStructuresEx(fscs_list,
											&MappingRulesManager,
											&MappingLexiconManager,
											NDomainMappingLexiconManager,
											&InsertRuleManager);
	else if(domain_name=="Weather")
			return Mapper.GenerateTargetFStructuresEx(fscs_list,
											&MappingRulesManager,
											&MappingLexiconManager,
											WDomainMappingLexiconManager,
											&InsertRuleManager);
	else if(domain_name=="Agriculture")
			return Mapper.GenerateTargetFStructuresEx(fscs_list,
											&MappingRulesManager,
											&MappingLexiconManager,
											ADomainMappingLexiconManager,
											&InsertRuleManager);
	else if(domain_name=="None")
			return Mapper.GenerateTargetFStructuresEx(fscs_list,
											&MappingRulesManager,
											&MappingLexiconManager,
											NULL,
											&InsertRuleManager);
//cater empty domain
}
