// MappingRuleBlock.cpp: implementation of the CMappingRuleBlock class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

/*#include "LanguageParser.h" REMOVING FOR THIS (DOS/LINUX VERSION) */
#include "MappingRuleBlock.h"

#include "LogManager.h"
/*#include ".\mappingruleblock.h" REMOVED IN THIS (LINUX) VERSION*/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
/*#define new DEBUG_NEW [REMOVING IN THIS (DOS/LINUX) VERSION] */
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CMappingRuleBlock::counter=0;

CMappingRuleBlock::CMappingRuleBlock()
{
	counter++;

	DefaultRule=NULL;
}

CMappingRuleBlock::~CMappingRuleBlock()
{

	counter--;

	using namespace std;

	if(DefaultRule)
	{
		try{
		delete DefaultRule;
		DefaultRule=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"~CMappingRuleBlock(): #### DefaultRule");
			#endif
		}

	}	

	for(vector<CMappingRule*>::iterator it=RuleList.begin();it!=RuleList.end();it++)
	{
		try{
			delete *it;
			}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"~CMappingRuleBlock(): deleting CMappingRule*\r\n");
			#endif
		}

	}
	
	RuleList.clear();
		
}

CMappingRuleBlock* CMappingRuleBlock::GetClone(void)
{
	CMappingRuleBlock*block=new CMappingRuleBlock();
	
	block->BlockId=this->BlockId;
	block->DefaultRule=this->DefaultRule;
	block->RuleList=this->RuleList;

	return block;
}

bool CMappingRuleBlock::AddRule(CMappingRule* rule)
{
	if(!rule)
		return false;

	RuleList.push_back(rule);

	if(rule->WhenCondition==L"")
		UnConditionedRuleList.push_back(rule);		
	else
		ConditionedRuleList.push_back(rule);

	return true;
}

unsigned int CMappingRuleBlock::GetRuleCount()
{
	return ConditionedRuleList.size()+UnConditionedRuleList.size();
}

void CMappingRuleBlock::Dump(short * Buffer,int & Bindex)
{
	/*
		vector<CMappingRule*> RuleList;	
		list<CMappingRule*> ConditionedRuleList;
		list<CMappingRule*> UnConditionedRuleList;

		static int counter;
		short BlockId;	
		CMappingRule*DefaultRule;
	*/

	Buffer[++Bindex]=RuleList.size();
	for(int i=0;i<RuleList.size();i++)
	{
		RuleList[i]->Dump(Buffer,Bindex);
	}

	CMappingRule* temp;

	Buffer[++Bindex]=ConditionedRuleList.size();
	for(list<CMappingRule*>::iterator j=ConditionedRuleList.begin();j!=ConditionedRuleList.end();j++)
	{
		temp=*j;
		temp->Dump(Buffer,Bindex);
	}

	Buffer[++Bindex]=UnConditionedRuleList.size();
	for(list<CMappingRule*>::iterator k=UnConditionedRuleList.begin();k!=UnConditionedRuleList.end();k++)
	{
		temp=*k;
		temp->Dump(Buffer,Bindex);
	}

	Buffer[++Bindex]=BlockId;
	if(DefaultRule)
	{
		Buffer[++Bindex]=1;
		DefaultRule->Dump(Buffer,Bindex);
	}
	else
	{
		Buffer[++Bindex]=0;
	}
}
void CMappingRuleBlock::Load(short* Buffer,int & Bindex)
{
	/*
		vector<CMappingRule*> RuleList;	
		list<CMappingRule*> ConditionedRuleList;
		list<CMappingRule*> UnConditionedRuleList;

		static int counter;
		short BlockId;	
		CMappingRule*DefaultRule;
	*/

	RuleList.resize(Buffer[++Bindex]);
	for(int i=0;i<RuleList.size();i++)
	{
		RuleList[i] = new CMappingRule();
		RuleList[i]->Load(Buffer,Bindex);
	}

	CMappingRule* temp;
	ConditionedRuleList.resize(Buffer[++Bindex]);

	for(list<CMappingRule*>::iterator j=ConditionedRuleList.begin();j!=ConditionedRuleList.end();j++)
	{
//		temp=*j;
		*j = new CMappingRule();
		temp=*j;
		temp->Load(Buffer,Bindex);
	}

	UnConditionedRuleList.resize(Buffer[++Bindex]);
	for(list<CMappingRule*>::iterator k=UnConditionedRuleList.begin();k!=UnConditionedRuleList.end();k++)
	{
		*k = new CMappingRule();
		temp=*k;
		temp->Load(Buffer,Bindex);
	}

	BlockId=Buffer[++Bindex];
	int DefOption = Buffer[++Bindex];
	if(DefOption)
	{
		DefaultRule = new CMappingRule();
		DefaultRule->Load(Buffer,Bindex);
	}
	else
	{
		DefaultRule=0;
	}
}