// MappingRuleManager.cpp: implementation of the CMappingRuleManager class.
//
//////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#pragma warning(disable: 4786)

#include "MappingRuleMacro.h"
/*#include "LanguageParser.h" REMOVING IN THIS DOS/LINUX VERSION */
#include "MappingRuleManager.h"


#include "global.h"
#include "FileReader.h"
#include "Action.h" /*CHANGED IN THIS (LINUX) VERSION*/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
/*#define new DEBUG_NEW [REMOVING IN THIS (DOS/LINUX) VERSION] */
#endif

#include <map>
#include <string>

/*#include ".\mappingrulemanager.h" REMOVED IN THIS (LINUX) VERSION*/
using namespace std;

typedef pair<long,CMappingRuleBlock*> rule_pair;
typedef pair<wstring,CMappingRuleMacro*> macro_pair;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

short CMappingRuleManager::BreakId=0;

CMappingRuleManager::~CMappingRuleManager()
{
	using namespace std;

	CMappingRuleBlock * mr=NULL;

	for(map<int,CMappingRuleBlock*>::iterator it=MappingRuleBlockList.begin();
		it!=MappingRuleBlockList.end();it++)
		{
			if(it->second)
			{
				mr=it->second;
				try{
					delete mr;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"#### it->second");
					#endif
				}
			}
		}
}

CMappingRuleManager::CMappingRuleManager(
							string macro_fname,
							string raw_fname, 
							string ext_fname,
							CLexicon*lex_ptr,
							double freq)
{

	//if(raw_fname=="Data\\English\\MapLexRaw.mlr")
	LexPtr=lex_ptr;
	/*CHANGED IN THIS (LINUX) VERSION*/
	/*if (raw_fname.find("MapLexRaw.mlr") != string.npos || raw_fname=="")*/
	if (raw_fname.find("MapLexRaw.mlr") != string::npos || raw_fname=="")
	{		
			if(CConfiguration::GetConfigInfo("CompileMapper" , true)=="yes")
			{
				GenerateExtendedMappingRules(macro_fname,raw_fname,ext_fname);
 				Initialize(ext_fname);	
				DumpInDumpFile(raw_fname);
					
			}
			else
				LoadFromDumpFile(raw_fname);
					
			
	}

	else
	{
		GenerateExtendedMappingRules(macro_fname,raw_fname,ext_fname);
		Initialize(ext_fname);	
	}
		StandardFrequency=freq;
		

	BreakId=CSymbolTableManager::BreakId;
}

bool CMappingRuleManager::Initialize(string fname)
{
	CFileReader fr(fname.c_str(),256);

	wstring str=L"";
	short ch=0;	
	short ind=-1;
	short carryon=true;

	CMappingRuleBlock*block=NULL;
	CMappingRule*rule=NULL;
	CAction*action=NULL;
	string tstr;
	int bcount=0;
	
	bool start=false;
		
	while((ch=fr.GetCurrentChar())!=0)
	{		
		switch(ch)
		{	
			case LF:
			case CR:
				break;

			//handling comments
			case '/' :				
			
				ch=fr.GetCurrentChar();
				
				if(ch!='/')
				{
					str=L"/";
					str+=ch;
					break;
				}
				
				while(true)
				{							
					ch=fr.GetCurrentChar();
					if(ch==LF)	
					{
						fr.MoveNext();	
						ch=fr.GetCurrentChar();
						if(ch==CR)
							break;
					}
					if(ch<=0)
						break;					
					
					fr.MoveNext();					
				}

				str.erase();

				break;

			case '[':
				
				block=new CMappingRuleBlock();
				str=TrimString(str);
				block->BlockId=CSymbolTableManager::GetNum(str,true);	
				
				//MessageBox(NULL,str.c_str(),L"",MB_ICONQUESTION||MB_YESNO);
				
				str=L"";
				break;

			case ']':
				
				MappingRuleBlockList.insert(rule_pair(block->BlockId,block));
				block=NULL;
				str=L"";
				break;

			case '?':
				
				fr.MoveNext();
				ch=fr.GetCurrentChar();
				
				if(ch=='-')
				{
					rule=new CMappingRule;				
					
					if(!rule)
						break;

					rule->Operator='?';
					rule->WhenCondition=TrimString(str);
					str=L"";
				}	
				
				break;

			case '-':

				fr.MoveNext();
				ch=fr.GetCurrentChar();
				
				if(ch=='-')
				{
					rule=new CMappingRule;				
					
					if(!rule)
						break;

					rule->Operator='-';
					rule->WhenCondition=TrimString(str);
					str=L"";
				}	
				
				break;

			case '(':				

				bcount=1;				
				ch=fr.GetCurrentChar();
				str+=ch;

				while(bcount!=0 && ch!=0)	
				{
					fr.MoveNext();
					ch=fr.GetCurrentChar();

					if(ch=='(')
						bcount++;
					
					if(ch==')')
						bcount--;

					str+=ch;
//					fr.MoveNext();										
				}								
				
				break;

			case '>':				
				
				str=L"";
				fr.MoveNext();
				
				while((ch=fr.GetCurrentChar())!='@' && ch!=';' && ch!=0)	
				{
					str+=ch;
					fr.MoveNext();										
				}
				
				str=TrimString(str);								
				////////////////////////////////////////////
				//LogManager.AddMessage(str+L"\r\n");
				///////////////////////////////////////////
				if(str!=L"")
				{
					GenerateActionList(rule,str);
					str=L"";				

					if(ch=='@')
					{
						fr.MoveNext();
						while((ch=fr.GetCurrentChar())!=';' && ch!=0)	
						{
							str+=ch;
							fr.MoveNext();										
						}
					
						tstr=Convert_wstr2str(str);
						rule->SenseNumber=atoi(tstr.c_str());
					}
					else
						rule->SenseNumber=0;
					
					ind=-1;
					ind=rule->WhenCondition.find(L"DEFAULT");
					
					if(ind>0)
					{
						rule->WhenCondition=L"";
						block->DefaultRule=rule;
					}
					else
					{
						block->AddRule(rule);					
					}				
				}
                
				rule=NULL;
				str.erase();				

				break;

			 default:
				str+=ch;
		
		}//end switch
	
		fr.MoveNext();
	}
		
	return true;
}

bool CMappingRuleManager::GenerateActionList(CMappingRule*rule,
											 wstring & actions_str)
{
	//LogManager.AddMessage( L"ACTION: " + actions_str + L"\r\n");

	wstring inputString, arg1, arg2, arg3; 

	if(!rule)
		return false;

	vector<CAction*> action_list;
	CAction*action=NULL;

	int	size= actions_str.size();
	bool bstarted=false;

	wstring lhs=L"";
	wstring rhs=L"";
	char op=0;

	wstring str=L"";	
	short ch=0;
			
	for(int i=0;i<size;i++)
	{
		ch=actions_str[i];
		
		switch(ch)		
		{
			case ',':
			
				if (op == INSERT_OP){
					op=0;
					str=L"";
				}
				else if(!bstarted)
					{					
						if(op=='='||op=='d')
							rhs=TrimString(str);
						else
							lhs=TrimString(str);

						action=new CAction(lhs,rhs,op,arg1,arg2,arg3,LexPtr);

						if(action->IsBreakAction(BreakId))
							rule->HasBreak = true;
						
						if(!action)
							break;
						
						rule->ActionList.push_back(action);
						lhs=rhs=L"";
						op=0;
						str=L"";
					}
					else
						str+= ch;
			
				break;
			
			case '<':
			case '{':
				
				str+= ch;
				bstarted=true;
				break;
			
			case '>':
			case '}':
				str+= ch;
				bstarted=false;
				break;

			case '=':
				op='=';
				lhs=TrimString(str);
				str=L"";
				break;

			case ' ':
				if(str!=L"" && op!='d')
				{
					str=TrimString(str);
					if(str==L"DELETE")
					{
						op='d';
						str=L"";
					}
					else
						str+= ch;
				}
				else
					str+= ch;
				break;

			case '(':
			
				inputString = TrimString(str);
				if (inputString==L"INSERT"){					
					i++;
					str = L"";
					while(',' != actions_str[i]){
						str += actions_str[i];
						i++;
					}
					arg1 = TrimString(str);
					i++;
					str = L"";
					while(',' != actions_str[i]){
						str += actions_str[i];
						i++;
					}
					arg2 = TrimString(str);
					i++;
					str = L"";
					while(')' != actions_str[i]){
						str += actions_str[i];
						i++;
					}
					arg3 = TrimString(str);
				
					op = INSERT_OP;
					action=new CAction(lhs,rhs,op,arg1,arg2,arg3,LexPtr);

					if(action->IsBreakAction(BreakId))
						rule->HasBreak = true;

					if(action)
						rule->ActionList.push_back(action);										
				}
				break;

			default:
				str+= ch;

		} //end switch
			
	} //end for

	if(!bstarted && op!= INSERT_OP)
	{					
		if(op=='='||op=='d')
			rhs=TrimString(str);
		else
			lhs=TrimString(str);

		action=new CAction(lhs,rhs,op,arg1,arg2,arg3,LexPtr);
	
		if(action->IsBreakAction(BreakId))
			rule->HasBreak = true;

		if(action)
			rule->ActionList.push_back(action);		
	}

	return true;
}

CMappingRuleBlock* CMappingRuleManager::GetRuleBlock(int id)
{
	using namespace std;

	map<int,CMappingRuleBlock*>::iterator it=MappingRuleBlockList.find(id);
	
	if(it!=MappingRuleBlockList.end())
		return it->second;
	
	return NULL;
}

CMappingRuleBlock* CMappingRuleManager::GetRuleBlock(vector<short>*vlist)
{
	using namespace std;	

	if(!vlist)
		return NULL;

	short id=0;

	if(vlist->size()==1)
		id=vlist->at(0);
	else
	{
		wstring astr;
		
		for(vector<short>::iterator it=vlist->begin();it!=vlist->end();it++)
			astr+=CSymbolTableManager::GetString(*it);
		
		id=CSymbolTableManager::GetNum(astr,false);
		
		if(id==-1)
			return NULL;

	}

	map<int,CMappingRuleBlock*>::iterator it=MappingRuleBlockList.find(id);
	
	if(it!=MappingRuleBlockList.end())
		return it->second;
	
	return NULL;

}

bool CMappingRuleManager::GetStatistics(int &BlockCount, int &RuleCount)
{
	using namespace std;

	BlockCount=MappingRuleBlockList.size();
	
	CMappingRuleBlock*block=NULL;
	
	int count=0;
	
	for(map<int,CMappingRuleBlock*>::iterator it=MappingRuleBlockList.begin();
		it!=MappingRuleBlockList.end();it++)
	{
		block=it->second;
		
		if(block)
		{
			//count+=block->RuleList.size();
			
			count+=block->ConditionedRuleList.size();
			count+=block->UnConditionedRuleList.size();

			if(block->DefaultRule)
				count++;
		}
	}
	
	RuleCount=count;
	
	return true;
}

bool CMappingRuleManager::GenerateExtendedMappingRules(														
							string macro_fname,
							string raw_fname, 
							string ext_fname
)
{
	using namespace std;

	map<wstring,CMappingRuleMacro*> MacroList;		
	LoadMacroList(MacroList,macro_fname);

	CFileReader fr(raw_fname.c_str(),512);
	CFileWriter fw(ext_fname.c_str());
	
	int counter=0;
	wstring data=L"";
	wstring str=L"";
	short ch=0;
	
	wstring macro_name=L"";
	vector<wstring> tlist;
	CMappingRuleMacro*macro=NULL;
	
	while((ch=fr.GetCurrentChar())!=0)
	{		
		if(ch=='#')
		{
			data=L"";
			str=L"";
			fr.MoveNext();
			tlist.clear();
			
			while((ch=fr.GetCurrentChar())!='(')
			{
				str+=ch;
				fr.MoveNext();	
			}
			
			macro_name=TrimString(str);
			str=L"";
			fr.MoveNext();
			
			while((ch=fr.GetCurrentChar())!=')')
			{
				if(ch==',')
				{
					tlist.push_back(str);
					str=L"";
				}
				else
					str+=ch;				
				fr.MoveNext();	
			}

			if(str!=L"")
				tlist.push_back(str);
			
			map<wstring,CMappingRuleMacro*>::iterator it=MacroList.find(macro_name);
			
			if(it!=MacroList.end())
			{
				macro=it->second;
				str=macro->GenerateRequiredCode(tlist);
				fw.Write(str);
			}            			
		}
		else
		{
			data=ch;
			fw.Write(data);			
		}

		fr.MoveNext();
	}

	//fw.Write(data);	
	fw.CloseFile();
	
	return false;
}

bool CMappingRuleManager::LoadMacroList(map<wstring,CMappingRuleMacro*> & MacroList, 
										std::string macro_fname)
{
	using namespace std;
		
	CFileReader fr(macro_fname.c_str(),256);	
	
	wstring str=L"";
	
	short ch=0;	
		
	CMappingRuleMacro *macro=NULL;
	int bcount=0;	

	while((ch=fr.GetCurrentChar())!=0)
	{		
		switch(ch)
		{	
			case '#':
				macro=new CMappingRuleMacro();
				str=L"";
				fr.MoveNext();
				while((ch=fr.GetCurrentChar())!='(' && ch!=':')				
				{
					str+=ch;				
					fr.MoveNext();
				}
				macro->MacroName=str;
				
				if(ch=='(')
				{
					str=L"";
					fr.MoveNext();
					while((ch=fr.GetCurrentChar())!=')')
					{
						if(ch==',')
						{
							str=TrimString(str);
							macro->ArgumentList.push_back(str); 
							str=L"";
						}
						else
							str+=ch;

						fr.MoveNext();
					}
					
					if(str!=L"")
						macro->ArgumentList.push_back(str);
					
					//skipping characters till ':'
					while((ch=fr.GetCurrentChar())!=':' && ch!=0)
						fr.MoveNext();
				}

				str=L"";
				fr.MoveNext();
				while((ch=fr.GetCurrentChar())!='$' && ch!=0)
				{
					str+=ch;
					fr.MoveNext();
				}
				macro->MacroDefinition=TrimString(str);
				MacroList.insert(macro_pair(macro->MacroName,macro));
				break;
			case LF:
			case CR:
				break;			
		}
		
		fr.MoveNext();
	}
	
	return true;
}

void CMappingRuleManager::DumpInDumpFile(string raw_fname)
{
	FILE* FWriter;
		int BlockSize=200;
	int TotalBlock=MappingRuleBlockList.size();
	
	if(raw_fname.find("WDomainMapLexRaw.mlr")!= string::npos)/*CHANGED IN THIS (LINUX ONLY) VERSION - ok in win*/

		 FWriter=fopen(CConfiguration::GetConfigInfo("WDomainMapLexDump").c_str(),"wb");
	else if(raw_fname.find("NDomainMapLexRaw.mlr")!= string::npos)
			FWriter=fopen(CConfiguration::GetConfigInfo("NDomainMapLexDump").c_str(),"wb");
	else if(raw_fname.find("ADomainMapLexRaw.mlr")!= string::npos)
			FWriter=fopen(CConfiguration::GetConfigInfo("ADomainMapLexDump").c_str(),"wb");
	else if(raw_fname.find("MapLexRaw.mlr")!= string::npos)
		 FWriter=fopen(CConfiguration::GetConfigInfo("MapLexDump").c_str(),"wb");
	
	int Bindex=-1;
	short * Buffer = new short[BlockSize*TotalBlock];

	Buffer[++Bindex]=BlockSize;
	Buffer[++Bindex]=TotalBlock;

	CMappingRuleBlock* temp;

	for(map<int,CMappingRuleBlock*>::iterator i=MappingRuleBlockList.begin();i!=MappingRuleBlockList.end();i++)
	{
		temp = i->second;
		temp->Dump(Buffer,Bindex);
	}
	
	fwrite(Buffer,2,Bindex+1,FWriter);

	fclose(FWriter);

	delete [] Buffer;
}

void CMappingRuleManager::LoadFromDumpFile(string raw_fname)
{
int BlockSize=0;;
	int TotalBlocks=0;
	
	FILE* FReader;
	
	if(raw_fname.find("WDomainMapLexRaw.mlr")!= string::npos)
		 FReader=fopen(CConfiguration::GetConfigInfo("WDomainMapLexDump").c_str(),"rb");
	else if(raw_fname.find("NDomainMapLexRaw.mlr")!= string::npos)
		FReader=fopen(CConfiguration::GetConfigInfo("NDomainMapLexDump").c_str(),"rb");
	else if(raw_fname.find("ADomainMapLexRaw.mlr")!= string::npos)
		FReader=fopen(CConfiguration::GetConfigInfo("ADomainMapLexDump").c_str(),"rb");
	else if(raw_fname.find("MapLexRaw.mlr")!= string::npos)
		 FReader=fopen(CConfiguration::GetConfigInfo("MapLexDump").c_str(),"rb");
	
	short * Buffer = new short[2];

	fread(Buffer,2,2,FReader);

	int Bindex=-1;


	BlockSize = Buffer[++Bindex];
	TotalBlocks = Buffer[++Bindex];

	delete [] Buffer;

	Bindex=-1;
	Buffer = new short[BlockSize*TotalBlocks];

	fread(Buffer,2,BlockSize*TotalBlocks,FReader);

	CMappingRuleBlock* temp;

	for(int i=0;i!=TotalBlocks;i++)
	{
		temp = new CMappingRuleBlock() ;
		temp->Load(Buffer,Bindex);
		
		MappingRuleBlockList.insert(rule_pair(temp->BlockId,temp));
	}
	
	fclose(FReader);

	delete [] Buffer;
}
