// MappingRuleManager.h: interface for the CMappingRuleManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAPPINGRULEMANAGER_H__78E69301_B877_405B_A851_C37548A7F6CF__INCLUDED_)
#define AFX_MAPPINGRULEMANAGER_H__78E69301_B877_405B_A851_C37548A7F6CF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning(disable: 4786)

#include <map>
#include <string>

#include "MappingRuleBlock.h"
#include "MappingRuleMacro.h"
#include "CLexicon.h"

using namespace std;

class CMappingRuleManager  
{
	public:

		bool GenerateActionList(CMappingRule*rule,wstring & action_str);
		map<int,CMappingRuleBlock*> MappingRuleBlockList;
		CLexicon*LexPtr;
		double StandardFrequency;

		static short BreakId;
	
		bool GetStatistics(int & BlockCount,int & RuleCount);
		CMappingRuleBlock * GetRuleBlock(int id);
		CMappingRuleBlock * GetRuleBlock(vector<short>*vlist);
		bool Initialize(string fname);
		
		CMappingRuleManager(string macro_fname,
							string raw_fname, 
							string ext_fname,
							CLexicon*lex_ptr,
							double freq);
		
		virtual ~CMappingRuleManager();

		bool GenerateExtendedMappingRules(string maro_fname, string raw_fname, string ext_fname);
		bool LoadMacroList(map<wstring,CMappingRuleMacro*> & MacroList, std::string macro_fname);
		void LoadFromDumpFile(string);
		void DumpInDumpFile(string);
};

#endif // !defined(AFX_MAPPINGRULEMANAGER_H__78E69301_B877_405B_A851_C37548A7F6CF__INCLUDED_)
