// MorphologicalGenerator.h: interface for the CMorphologicalGenerator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MORPHOLOGICALGENERATOR_H__ADB5DE9F_67A8_4550_ACD5_B65FD46F4862__INCLUDED_)
#define AFX_MORPHOLOGICALGENERATOR_H__ADB5DE9F_67A8_4550_ACD5_B65FD46F4862__INCLUDED_

#include "stdafx.h"
#pragma warning(disable: 4786)

#include "global.h"
#include "MorphologicalRule.h"	
#include "CConfiguration.h"
#include "CLexicon.h"

// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMorphologicalGenerator  
{
public:
	CMorphologicalGenerator(CLexicon * LexPtr);
	virtual ~CMorphologicalGenerator();
	vector<CLexicalEntry*> * GenerateForms(wstring word, wstring pos,  PROPVECT* props);

private:
	void ReadRules(char*, RULEVECTOR*);
	RULEVECTOR adjRules;
	RULEVECTOR verbRules;
	RULEVECTOR nounRules;

	////////////New by tahira////////////////////////
	wstring Months[12+1];
	wstring Days[7+1];
	wstring Numbers[100];
	short DayInDigits,DayInWords,Month,Year,Type,Hours,Minutes,Seconds;
	/////////////////////////////////////////////////

	CLexicon * UrduLexicon;

	CONDITIONVECTOR* GetEndCondVect(wstring str);
	PROPVECT* GetPropVect(wstring propStr);
	REPVECT* GetRepVect(wstring repStr);
	WSTRPAIR* GetPair(wstring pairStr);
	CFDescription* GetCFDescription(wstring str);
	void ExtractStr(wstring& wstr);

	////////////////New Huma////modified tahira///////
	wstring getDate(PROPVECT* props);
	wstring getTime(PROPVECT* props);
	wstring getinWords(wstring eng);
	wstring getUrduNumberinWords(wstring eng);
	wstring getCardinal(wstring word, PROPVECT* props);
	wstring getOrdinal(wstring word, PROPVECT* props);
	///////////////////////////////////////////////////
};

#endif // !defined(AFX_MORPHOLOGICALGENERATOR_H__ADB5DE9F_67A8_4550_ACD5_B65FD46F4862__INCLUDED_)
