
#ifndef P_CHARTCOLUMN
#define P_CHARTCOLUMN

#include<string>
#include<vector>
/*#include<hash_map>REMOVED IN THIS (LINUX ONLY) VERSION*/
#include<list>
using namespace std;

#include "FirstSet.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "P_ChartItem.h"
#include "P_LexicalEntry.h"
#include "P_Grammar.h"

class P_ChartColumn 
{
public:

	P_ChartColumn(vector<P_LexicalEntry*>* LexEntries);

	bool LoadItem(P_ChartItem* item);

	vector<P_LexicalEntry *>* GetLexEntries();

	P_ChartItem * GetCurrentItem();

	bool LoadItem(P_ChartItem item);

	vector<short>* GetItemsWithDotAt(short pos);

	short GetCurrentIndex();

	P_FirstSet GetFirstSet();

	short GetItemCount();

	list<P_ChartItem *> GetChartItems(short);

	void MoveNext();

	void Clear();

	P_ChartItem * GetItemAt(int index);

private:

	vector<P_ChartItem*> Items;

	P_FirstSet FirstSet;

	vector<P_LexicalEntry*> *LexEntryList;

	typedef pair<short,vector<short> > ProdEntry;

	hash_map<short,vector<short> > ProductionsIndex;

	hash_map<short,vector<short> > ProdsWithDotAt;

	short ItemCount;

	short CurrentIndex;


/****************************************************/
	/////  My temperary Data
public:

	int debug;
	P_Grammar* GrammarPtr;
	void AssignGrammarPtr(P_Grammar*Ptr)
	{
		debug=1;
		GrammarPtr=Ptr;
	}

		/*
	Garbage Collector
	.................
	*/
								
	static list<P_ChartColumn*> ClonedP_ChartColumnGarbageCollector;
	

	static void CollectSelectiveGarbage()
	{
		P_ChartColumn*prod=NULL;

		try
		{
			for(list<P_ChartColumn*>::iterator it=ClonedP_ChartColumnGarbageCollector.begin();
				it!=ClonedP_ChartColumnGarbageCollector.end();it++)
			{
				prod=*it;
				try
				{
					delete prod;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"error on deleting f-structure \r\n");
					#endif
				}
			}
			ClonedP_ChartColumnGarbageCollector.clear();	
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Error on Clearing CFStructure::GC\r\n");
			#endif
		}	
	}

/****************************************************/

vector<short> ProdWDot;

};

#endif 
