

#ifndef P_CHARTITEM
#define P_CHARTITEM

#include "P_Production.h"
#include "P_LexicalEntry.h"
#include "P_FStructure.h"

#include<string>
#include<vector>
using namespace std;

class P_ChartItem 
{
public:
	bool IsFailed();
	short GetStart();
	bool MoveDot(void * CompleterItem);

	void AddBackPtrs(vector<void *> *ItemPtrs);

	void AddBackPtrs(vector<vector<void *> *> ItemPtrs);


	vector< vector<void*>* > GetBackPtrs();

//	vector<P_FStructure *> * GetFSIndices();

	P_Symbol* GetCurrentSymbol();

	bool IsComplete();

	P_Production * GetProdPtr();

	char GetDotPos();

	void SetFailed(bool Failed);

	void SetColumnNo(short num);

	void ComputeProbability();

	float GetProbability();		// Wrong

	P_ChartItem(short start,P_Production* Prodptr);

	P_ChartItem* GetClone();

private:
	short Start;

	short ColumnNo;

	P_FStructure * FSPtr;

	char DotPosition;

	bool Failed;

	P_Production * Production;

	vector< vector<void*>* > BackPointers;

	vector<float> probability;

	bool operator==(P_ChartItem& B);

public:

	/*
	Garbage Collector
	.................
	*/

	static list<P_ChartItem*> ClonedP_ChartItemGarbageCollector;
	
	static bool AddCloneInGC(P_ChartItem*prod)
	{
		try
		{
			ClonedP_ChartItemGarbageCollector.push_back(prod);
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Error on Adding Prod to GC");
			#endif
			return false;
		}
		return true;
	}
	static void CollectSelectiveGarbage()
	{
		P_ChartItem*prod=NULL;

		try
		{
			for(list<P_ChartItem*>::iterator it=ClonedP_ChartItemGarbageCollector.begin();
				it!=ClonedP_ChartItemGarbageCollector.end();it++)
			{
				prod=*it;
				try
				{
					delete prod;
				}
				catch(...)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"error on deleting f-structure \r\n");
					#endif
				}
			}
			ClonedP_ChartItemGarbageCollector.clear();	
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"Error on Clearing CFStructure::GC\r\n");
			#endif
		}	
	}

	// ADDED BY HUDA (09-01-06)
	P_FStructure* getFSPtr(void);
	void setFSPtr(P_FStructure* fs_ptr);
	short GetColumnNo(void);
	// ADDED BY HUDA (END)
};
#endif