// Copyright (C) 1991 - 1999 Rational Software Corporation
#ifndef P_CHARTPARSER
#define P_CHARTPARSER

#include<string>
#include<vector>
#include<fstream>
using namespace std;

#include "Token.h"
#include "POSTagger.h"
#include "P_Scanner.h"
#include "P_Grammar.h"
#include "P_Lexicon.h"
#include "P_FStructure.h"
#include "FSCSPairInfo.h"
/* ADDING F-STRUCTURE BUILDING CODE (HUDA) */
#include "P_FSItemComplexInstConst.h"
#include "P_FSInitializer.h"
/* ADDING F-STRUCTURE BUILDING CODE (HUDA) END */
class P_ChartColumn;

class P_ChartParser 
{
public:

	P_ChartParser(P_Lexicon * Lexptr, P_Grammar * Gramptr, P_Scanner* Scanptr);
	
	void GenerateFStructure();
	
//	P_FStructure * GetNextFS();

	bool ParseSentence();

	bool Parse();

	// added (huda 25-08-06) to incorporate segmentation:
	bool Parse(vector<vector<P_LexicalEntry*> > &AllLexEntries, vector<Token*> &AllTokensHavingBNCInfo);
	
	void SetTimeLimit(long & time);
	void GetSentence(vector< vector<P_LexicalEntry* > > & AllLexEntries,
						vector<Token*> & AllTokensHavingBNCInfo);
	vector<P_LexicalEntry* > SearchEntryInLex(wstring );
	void SetSpaceLimit(long & space);

private:
	
	vector<P_ChartColumn*> *Chart;
	
	vector<P_LexicalEntry*> DummyEntries;

	POSTagger* PTagger;
	
	P_Scanner * ScannerPtr;
	
	P_Grammar * GrammarPtr;

	P_Lexicon * LexiconPtr;
/********************************************************/
/*			Added	 by		me[Sarfraz]		*/
/********************************************************/
	P_ChartColumn* CurrentChartColumn;
	P_ChartItem* CurrentChartItem;
	P_Symbol* CurrentSym;

//	short sym;  // Use for Predicting the production
	
	vector<P_LexicalEntry*>* LexEntriesVec;
	P_LexicalEntry* CurrLexEntry;
/********************************************************/
/*			Added	 by		me		*/
/********************************************************/
	char CurrentColumn;

	long TimeLimit;

	long SpaceLimit;

	char ChartSize;

	long StartTime;

	long SpaceCount;

	//vector<FSCSpair>  ParseSentence();

	void Predict();

	void Scan();

	void Complete();

	void OutPutChart(fstream & fout,int iteration);

	bool LoadInChart(P_ChartItem &item, int col);

	

	//##########TAHIRA#############
public:
	CFSCSPairInfo * GetNextCSFSPair();
private:
//	clock_t cstart, cend; TEMPORARY REOVAL */
	CFStructure* NewFStoOldFS(P_FStructure *newfs);//,CSentenceInfo &sen
	CFStructureItem* GetOldFS(P_FStructure * newfs,CFStructureItem* old=0);//,CSentenceInfo &sen
	P_FStructure * DigOutNextFS();
	void PreProcessPOStags(vector<vector<P_LexicalEntry*> > &AllLexEntries, vector<Token*> &tokens);
	void PostProcessPOStags(vector<vector<P_LexicalEntry*> > &AllLexEntries, vector<vector<P_LexicalEntry*> > &AllLexEntriesBKUp);
	void GenerateCSItemXML(P_ChartItem *item, CFileWriter &fw);
	vector<short> PredMap;
	vector<byte> IndexMap;
	CSentenceInfo sentence;
	//##########TAHIRA#############

	// wd be implemented by ....
	/* ADDING F-STRUCTURE BUILDING CODE (HUDA) */
public:
	bool buildFStructure(P_ChartItem* chart_item);	// initial function which will require chart_item for S
	bool buildFStructures(P_ChartItem* chart_item, P_FStructure* f_structure, contextByte& context_offset);	// recursive function 
	void GenerateCSXML(string XMLfile);

private:
	list< list<contextByte> > prepareBkPtrContextList(short no_of_contexts);
	bool vectorContainsItem(vector<P_ChartItem*>& item_vector, P_ChartItem* chart_item);
	int FindItemInVector(vector<P_ChartItem*>& item_vector, P_ChartItem* chart_item);
	contextByte adjustBkPtrContextList(list< list<contextByte> >& prepared_context, contextByte start_from);
	/* ADDING F-STRUCTURE BUILDING CODE (HUDA) END */
};

#endif /* _INC_P_CHARTPARSER_435C8AAE036E_INCLUDED */
