#include "stdafx.h"
#include "P_ConValFDLink.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_ConValFDLink::P_ConValFDLink(void)
{
}

P_ConValFDLink::~P_ConValFDLink(void)
{
	// no pointers to delete
}

bool P_ConValFDLink::operator==(P_ContextedValue* right_value)
{
	if (this->context != right_value->context)
		return false;

	if (this->value != right_value->getFDLinkVal())
		return false;

	if (this->value_type != right_value->getValueType())
		return false;

	return true;
}

PFSsymID P_ConValFDLink::getPlainVal(void)
{
	return 0;	// does not have a plain value
}

string P_ConValFDLink::getValString(void)
{
	return P_FSSymbolTable::getSym(value);
}

PFSsymID P_ConValFDLink::getFDLinkVal(void)
{
	return this->value;
}

byte P_ConValFDLink::getValueType(void)
{
	return this->value_type;
}

int P_ConValFDLink::getNoInPlainValList(void)
{
	return 0;
}

bool P_ConValFDLink::containsVal(PFSsymID value)
{
	return false;
}

void P_ConValFDLink::printValue(ofstream& myfile)
{
	myfile << "Printing P_ConValFDLink:\n";

	myfile << "value: " << (int)this->value << "\n";
	myfile << "value_type: " << (int)this->value_type << "\n";

	myfile << "context: ";
	list<contextByte>::iterator it;
	for (it = this->context.begin(); it != this->context.end(); it++)
		myfile << (int)(*it) << " ";

	myfile << "\n";
}

P_ContextedValue* P_ConValFDLink::instantiate(P_FStructure* up_arrow, P_FStructure* down_arrow, contextByte offset)
// construct an equivalent item of type P_ConValFSLink and insert the f-structure link for it
{
	P_ContextedValue* contexted_val;
	
	P_ContValFSLink* fs_link;
	fs_link = new P_ContValFSLink();
	
	fs_link->context = context;
	fs_link->value = value;
	fs_link->value_type = value_type;
	
	// isolate first bit to determine arrow direction
	byte value_type_check = (this->value_type & 128);	// 100000000
	if (value_type_check == DOWNARROWVAL)
		fs_link->link = down_arrow;
	else
		fs_link->link = up_arrow;

	contexted_val = fs_link;

	// set the context using the offset and add the bkptr contexts
	contexted_val->setContext(offset);
	contexted_val->bcontext = ContextManager::convertListTobitwiseContext(contexted_val->context);
	return contexted_val;
}

bool P_ConValFDLink::zeroValue(void)
// in principle this should never actually be called but just in case:
{
	return (this->value == 0);
}

list<P_ContextedValue*> P_ConValFDLink::instantiate(P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows, contextByte offset)
// this the actual reason for putting in all the overloaded functions that don't do anything special:
// PUTTING IN A LIST OF BACKPOINTER FSTRUCTURES IN LINKS 
// 07-02-06 NEW COPIES OF DOWNARROWS ARE MADE SO IT CAN BE DELETED AFTER ALL CALLS HAVE BEEN MADE
{
	list<P_ContextedValue*> ret_list;
	byte value_type_check = this->getValueType() & DOWNARROWVAL;
	
	// added 07-02-06 because down_arrows is a pointer and should not be modified, may be required 
	// if there is another iteration
	P_ContextedValue* current_down_arrows;	

	if (value_type_check == DOWNARROWVAL)	// down-arrow
	{
		this->setContext(offset);
		// traverse the vector and set required values such that they become this value except that they
		// are instantiated (IF THE ARROW IS A DOWN ARROW)
		vector<P_ContextedValue*>::iterator down_arrows_it;
		for (down_arrows_it = down_arrows.begin(); down_arrows_it != down_arrows.end(); down_arrows_it++)
		{
			current_down_arrows = (*down_arrows_it)->makeCopy();
			current_down_arrows->setFSLinkValue(this->value);
			current_down_arrows->setFSLinkValueType(this->value_type);
			current_down_arrows->addContexts(this->context);
			current_down_arrows->bcontext = ContextManager::convertListTobitwiseContext(current_down_arrows->context);
			ret_list.push_back(current_down_arrows);
			
			/* replaced by above 07-02-06
			(*down_arrows_it)->setFSLinkValue(this->value);
			(*down_arrows_it)->setFSLinkValueType(this->value_type);
			(*down_arrows_it)->addContexts(this->context);
			//(*down_arrows_it)->setContext(offset);	the offset of this's context is already set and the contexts of downarrows were offsetted in the begining
			ret_list.push_back(*down_arrows_it);
			*/
		}
	}
	else
	{
		P_ContextedValue* contexted_val;
	
		P_ContValFSLink* fs_link;
		fs_link = new P_ContValFSLink();
	
		fs_link->context = this->context;
	
		fs_link->link = up_arrow;
		contexted_val = fs_link;

		// set the context using the offset and add the bkptr contexts
		contexted_val->setContext(offset);
		contexted_val->bcontext = ContextManager::convertListTobitwiseContext(contexted_val->context);
		ret_list.push_back(contexted_val);
	}
	return ret_list;
}

void P_ConValFDLink::setFSLinkValue(PFSsymID value)
{
	// SHOULD NEVER BE CALLED
}

void P_ConValFDLink::setFSLinkValueType(byte value_type)
{
	// SHOULD NEVER BE CALLED
}

P_FStructure* P_ConValFDLink::getFSLinkLink(void)
// cannot have an FSLink as
{
	return NULL;
}

bool P_ConValFDLink::isConsistent(P_ContextedValue* cont_value)
// should never be called
{		
	return true;	// safer to return true here in case of an error
}

list<PFSsymID> P_ConValFDLink::getPlainValList(void)
// has no list therefore returns emty list
{
	return list<PFSsymID>();
}

PFSsymID P_ConValFDLink::getFSLinkValue(void)
// has no FSLinkValue; cannot be 0 because that is valid value for an FSLinkValue
{
	return -1;
}

P_ContextedValue* P_ConValFDLink::makeCopy(void)
{
	P_ContextedValue* ret_value;
	P_ConValFDLink* fdlink_val = new P_ConValFDLink();

	fdlink_val->context = context;
	fdlink_val->bcontext = bcontext;//new
	fdlink_val->value = value;
	fdlink_val->value_type = value_type;

	ret_value = fdlink_val;

	return ret_value;
}

void P_ConValFDLink::makeLinksNull(void)
// has no links so do mothing
{
}

void P_ConValFDLink::Dump(short* Buffer,int& Bindex)
{
	Buffer[++Bindex]=2;
	Buffer[++Bindex]=this->value;
	Buffer[++Bindex]=this->value_type;
	Buffer[++Bindex]=context.size();

	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		Buffer[++Bindex]=*i;
	}
}

void P_ConValFDLink::Load(short* Buffer,int& Bindex)
{
//	Buffer[++Bindex]=2;
	this->value=Buffer[++Bindex];
	this->value_type=Buffer[++Bindex];
	context.resize(Buffer[++Bindex]);

	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		*i=Buffer[++Bindex];
	}

}
