#include "stdafx.h"
#include "P_ConValPlainVal.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_ConValPlainVal::P_ConValPlainVal(void)
{
}

P_ConValPlainVal::~P_ConValPlainVal(void)
{
	// no pointers to delete
}

bool P_ConValPlainVal::operator==(P_ContextedValue* right_value)
{
	if (this->context != right_value->context)
		return false;
	
	if (this->value != right_value->getPlainVal())
		return false;
	
	return true;
}

PFSsymID P_ConValPlainVal::getPlainVal(void)
{
	return this->value;
}

PFSsymID P_ConValPlainVal::getFDLinkVal(void)
{
	return 0;	// has no FDLink value
}

byte P_ConValPlainVal::getValueType(void)
{
	return NOVALTYPE;
}

int P_ConValPlainVal::getNoInPlainValList(void)
{
	return 0;
}

bool P_ConValPlainVal::containsVal(PFSsymID value)
{
	return false;
}

void P_ConValPlainVal::printValue(ofstream& myfile)
{
	myfile << "Printing P_ConValPlainVal:\n";

	myfile << "value: " << (int)this->value << "\n";

	myfile << "context: ";
	list<contextByte>::iterator it;
	for (it = this->context.begin(); it != this->context.end(); it++)
		myfile << (int)(*it) << " ";

	myfile << "\n";
}

P_ContextedValue* P_ConValPlainVal::instantiate(P_FStructure* up_arrow, P_FStructure* down_arrow, contextByte offset)
{
	// makes a copy of itself and returns it (adjusting the context as required)
	P_ContextedValue* context_val; 
	P_ConValPlainVal* plain_val;
	plain_val = new P_ConValPlainVal();

	plain_val->value = this->value;
	plain_val->context = this->context;
	
	context_val = plain_val;
	
	// set the context using the offset and add the bkptr contexts
	context_val->setContext(offset);
	context_val->bcontext = ContextManager::convertListTobitwiseContext(context_val->context);
	return context_val;
}

bool P_ConValPlainVal::zeroValue(void)
{
	return (this->value == 0);
}

list<P_ContextedValue*> P_ConValPlainVal::instantiate(P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows, contextByte offset)
// is the same as the above (because there is no link) except that the value is placed in a list and returned
{
	// makes a copy of itself and returns it (adjusting the context as required)
	P_ContextedValue* context_val; 
	P_ConValPlainVal* plain_val;
	plain_val = new P_ConValPlainVal();

	plain_val->value = this->value;
	plain_val->context = this->context;
	
	context_val = plain_val;
	
	// set the context using the offset and add the bkptr contexts
	context_val->setContext(offset);
	
	list<P_ContextedValue*> ret_list;
	context_val->bcontext = ContextManager::convertListTobitwiseContext(context_val->context);
	ret_list.push_back(context_val);
	return ret_list;
}

void P_ConValPlainVal::setFSLinkValue(PFSsymID value)
{
	// SHOULD NEVER BE CALLED
}

void P_ConValPlainVal::setFSLinkValueType(byte value_type)
{
	// SHOULD NEVER BE CALLED
}

P_FStructure* P_ConValPlainVal::getFSLinkLink(void)
// has no FSLink value
{
	return NULL;
}

bool P_ConValPlainVal::isConsistent(P_ContextedValue* cont_value)
// (DONE) cont_value can validly be either one of two value types: P_ConValPlainVal or P_ConValPlainValList
{
	PFSsymID check_val;
	list<PFSsymID> check_val_list;
	list<PFSsymID>::iterator it;
	check_val = cont_value->getPlainVal();
	check_val_list = cont_value->getPlainValList();

	if (check_val != 0)
	{
		if (check_val == this->value)
			return true;
		else 
		{
			#ifdef GenLog
			wstring str=L"";
			str=Convert_str2wstr( P_FSSymbolTable::getSym(check_val) );
			str+=L" clashed with ";
			str+=Convert_str2wstr( P_FSSymbolTable::getSym(this->value) );
			CLogManager::AddMessage(str);
			#endif GenLog
			return false;
		}
	}
	if (!check_val_list.empty())
	{
		for (it = check_val_list.begin(); it != check_val_list.end(); it++)
		{	
			if (this->value == *it)
				return true;
		}		
		#ifdef GenLog
		wstring str=L"";
		str=Convert_str2wstr( P_FSSymbolTable::getSym(this->value) );
		str+=L" clashed";
		CLogManager::AddMessage(str);
		#endif GenLog
		return false;
	}
	return true;	// no explicit clash detected
}

list<PFSsymID> P_ConValPlainVal::getPlainValList(void)
// has no list therefore returns empty list
{
	return list<PFSsymID>();
}

PFSsymID P_ConValPlainVal::getFSLinkValue(void)
// has no FSLinkValue; cannot be 0 because that is valid value for an FSLinkValue
{
	return -1;
}

P_ContextedValue* P_ConValPlainVal::makeCopy(void)
{
	P_ContextedValue* ret_value;
	P_ConValPlainVal* plain_val = new P_ConValPlainVal();
	plain_val->context = context;
	plain_val->bcontext = bcontext;//new
	plain_val->value = value;
	ret_value = plain_val;
	return ret_value;
}

void P_ConValPlainVal::makeLinksNull(void)
// has no links so do mothing
{
}
string P_ConValPlainVal::getValString(void)
{
	return P_FSSymbolTable::getSym(value);
}

void P_ConValPlainVal::Dump(short* Buffer,int & Bindex)
{
	Buffer[++Bindex]=3;
	Buffer[++Bindex]=this->value;
	Buffer[++Bindex]=context.size();
	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		Buffer[++Bindex]=*i;
	}

}
void P_ConValPlainVal::Load(short* Buffer,int & Bindex)
{
//	Buffer[++Bindex]=1;
	this->value=Buffer[++Bindex];
	context.resize(Buffer[++Bindex]);
	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		*i=Buffer[++Bindex];
	}
}
