#include "stdafx.h"
#include "P_ConValPlainValList.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_ConValPlainValList::P_ConValPlainValList(void)
{
}

P_ConValPlainValList::~P_ConValPlainValList(void)
{
	// no pointers to delete
}

bool P_ConValPlainValList::operator==(P_ContextedValue* right_value)
{
	if (this->context != right_value->context)
		return false;

	if (this->getNoInPlainValList() != right_value->getNoInPlainValList())
		return false;

	list<PFSsymID>::iterator it;
	for (it = this->values.begin(); it != this->values.end(); it++)
	{
		if (!(right_value->containsVal(*it)))
			return false;
	}
	return true;
}

PFSsymID P_ConValPlainValList::getPlainVal(void)
{
	return 0;	// does not contain a single plain value
}

PFSsymID P_ConValPlainValList::getFDLinkVal(void)
{
	return 0;	// has no FDLink value
}

byte P_ConValPlainValList::getValueType(void)
{
	return NOVALTYPE;
}

int P_ConValPlainValList::getNoInPlainValList(void)
{
	return this->values.size();
}

bool P_ConValPlainValList::containsVal(PFSsymID value)
{
	list<PFSsymID>::iterator it;
	for (it = this->values.begin(); it != this->values.end(); it++)
	{
		if (value == (*it))
			return true;
	}
		
	return false;
}

void P_ConValPlainValList::printValue(ofstream& myfile)
{
	myfile << "Printing P_ConValPlainValList:\n";

	myfile << "values: ";
	list<PFSsymID>::iterator xit;
	for (xit = this->values.begin(); xit != this->values.end(); xit++)
		myfile << (int)(*xit) << " ";

	myfile << "\n" << "context: ";
	list<contextByte>::iterator it;
	for (it = this->context.begin(); it != this->context.end(); it++)
		myfile << (int)(*it) << " ";
}

P_ContextedValue* P_ConValPlainValList::instantiate(P_FStructure* up_arrow, P_FStructure* down_arrow, contextByte offset)
// makes a copy of itself and returns it
{
	P_ContextedValue* contexted_val;
	P_ConValPlainValList* val_list;

	val_list = new P_ConValPlainValList();
	val_list->values = this->values;
	val_list->context = this->context;
	
	contexted_val = val_list;
	
	// set the context using the offset and add the bkptr contexts
	contexted_val->setContext(offset);
	contexted_val->bcontext = ContextManager::convertListTobitwiseContext(contexted_val->context);
	return contexted_val;
}

bool P_ConValPlainValList::zeroValue(void)
// (DONE) should always return false because an "^=!" type item is being searched for when this is called
{
	return false;
}

list<P_ContextedValue*> P_ConValPlainValList::instantiate(P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows, contextByte offset)
// is the same as the above (because there is no link) except that the value is returned in a list
{
	P_ContextedValue* contexted_val;
	P_ConValPlainValList* val_list;

	val_list = new P_ConValPlainValList();
	val_list->values = this->values;
	val_list->context = this->context;
	
	contexted_val = val_list;
	
	// set the context using the offset and add the bkptr contexts
	contexted_val->setContext(offset);

	list<P_ContextedValue*> ret_list;
	contexted_val->bcontext = ContextManager::convertListTobitwiseContext(contexted_val->context);
	ret_list.push_back(contexted_val);
	return ret_list;
}

void P_ConValPlainValList::setFSLinkValue(PFSsymID value)
{
	// SHOULD NEVER BE CALLED
}

void P_ConValPlainValList::setFSLinkValueType(byte value_type)
{
	// SHOULD NEVER BE CALLED
}

P_FStructure* P_ConValPlainValList::getFSLinkLink(void)
// has no FSLink value
{
	return NULL;
}

bool P_ConValPlainValList::isConsistent(P_ContextedValue* cont_value)
// examples:
// X = {A}, X = {A, B}: consistent
// X = {A, B}, X = {B, C}: consistent
// X = {A}, X = {B, C}: inconsistent
// X = {A, B}, X = {C, D}: inconsistent
// X = {A}, X = {B}: inconsistent
{
	PFSsymID check_val;
	list<PFSsymID> check_val_list;
	list<PFSsymID>::iterator par_it, self_it;
	check_val = cont_value->getPlainVal();
	check_val_list = cont_value->getPlainValList();

	if (check_val != 0)
	{
		for (self_it = values.begin(); self_it != values.end(); self_it++)
		{
			if (*self_it == check_val)
				return true;
		}
		return false;
	}
	if (!check_val_list.empty())
	{
		for (self_it = values.begin(); self_it != values.end(); self_it++)
		{
			for (par_it = check_val_list.begin(); par_it != check_val_list.end(); par_it++)
			{
				if (*self_it == *par_it)
					return true;
			}
		}
		return false;
	}
	return true;	// no explicit clash detected
}

list<PFSsymID> P_ConValPlainValList::getPlainValList(void)
{
	return values;
}

PFSsymID P_ConValPlainValList::getFSLinkValue(void)
// has no FSLinkValue; cannot be 0 because that is valid value for an FSLinkValue
{
	return -1;
}

P_ContextedValue* P_ConValPlainValList::makeCopy(void)
{
	P_ContextedValue* ret_value;
	P_ConValPlainValList* list_val = new P_ConValPlainValList();
	list_val->context = context;
	list_val->bcontext = bcontext;//new
	list_val->values = values;
	ret_value = list_val;
	return ret_value;
}

void P_ConValPlainValList::makeLinksNull(void)
// has no links so do mothing
{
}

string P_ConValPlainValList::getValString(void)
{
	string str="{";
	list<PFSsymID>::iterator it=values.begin();
	str+=(P_FSSymbolTable::getSym(*it));
	it++;
	for(;it!=values.end();it++)
	{
		str+=",";
		str+=(P_FSSymbolTable::getSym(*it));
	}
	str+="}";
	return str;
}


void P_ConValPlainValList::Dump(short* Buffer,int & Bindex)
{
	Buffer[++Bindex]=4;

	Buffer[++Bindex]=this->values.size();

	for(list<PFSsymID>::iterator j=this->values.begin();j!=values.end();j++)
	{
		Buffer[++Bindex]=*j;
	}	

	Buffer[++Bindex]=context.size();
	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		Buffer[++Bindex]=*i;
	}	

}
void P_ConValPlainValList::Load(short* Buffer,int & Bindex)
{
//	Buffer[++Bindex]=1;		Already Checked

	values.resize(Buffer[++Bindex]);

	for(list<PFSsymID>::iterator j=this->values.begin();j!=values.end();j++)
	{
		*j=Buffer[++Bindex];
	}	

	context.resize(Buffer[++Bindex]);
	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		*i=Buffer[++Bindex];
	}	

}
