#include "stdafx.h"
#include "P_ContValFSLink.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_ContValFSLink::P_ContValFSLink(void)
: link(NULL)
{
}
P_ContValFSLink::P_ContValFSLink(P_FStructure *link1, PFSsymID value1)
{
	link = link1;
	value = value1;
}
P_ContValFSLink::~P_ContValFSLink(void)
{
	if (link != NULL)
	{
		delete link;
		link = NULL;
	}
}

bool P_ContValFSLink::operator==(P_ContextedValue* right_value)
// always false because no items of this type are instantiated when this oeprator is used
{
	return false;
}

PFSsymID P_ContValFSLink::getPlainVal(void)
{
	return 0;	// this type has no plain value
}

PFSsymID P_ContValFSLink::getFDLinkVal(void)
{
	return 0;	// does not have an FDLink value
}

byte P_ContValFSLink::getValueType(void)
{
	// fixing error 07-03-06
	//return NOVALTYPE;
	return this->value_type;
}

int P_ContValFSLink::getNoInPlainValList(void)
{
	return 0;
}

bool P_ContValFSLink::containsVal(PFSsymID value)
{
	return false;
}

void P_ContValFSLink::printValue(ofstream& myfile)
{
	myfile << "NOT IMPLEMENTED";
}

P_ContextedValue* P_ContValFSLink::instantiate(P_FStructure* up_arrow, P_FStructure* down_arrow, contextByte offset)
// should never be called because all P_FSItems of this type are already instantiated
{
	return NULL;
}

bool P_ContValFSLink::zeroValue(void)
// (DONE)
{
	return (this->value == 0);
}

list<P_ContextedValue*> P_ContValFSLink::instantiate(P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows, contextByte offset)
// should never be called because all P_FSItems of this type are already instantiated; is returning empty
// list
{
	return list<P_ContextedValue*>();
}

// THIS AND THE FOLLOWING EXISTS SO THAT MULTIPLE VALUES FOR !s CAN BE ASSIGNED
void P_ContValFSLink::setFSLinkValue(PFSsymID in_value)
{
	this->value = in_value;
}

void P_ContValFSLink::setFSLinkValueType(byte in_value_type)
{
	this->value_type = in_value_type;
}
P_FStructure* P_ContValFSLink::getFSLinkLink(void)
{
	return this->link;
}

bool P_ContValFSLink::isConsistent(P_ContextedValue* cont_value)
// should never be called
{		
	return true;	// safer to return true here in case of an error
}

list<PFSsymID> P_ContValFSLink::getPlainValList(void)
// has no list therefor returns empty list
{
	return list<PFSsymID>();
}

PFSsymID P_ContValFSLink::getFSLinkValue(void)
{
	return this->value;
}

P_ContextedValue* P_ContValFSLink::makeCopy(void)
{
	P_ContextedValue* ret_value;
	P_ContValFSLink* fslink_val;
	fslink_val = new P_ContValFSLink();

	fslink_val->link = link;
	fslink_val->value = value;
	fslink_val->value_type = value_type;
	fslink_val->context = context;
	fslink_val->bcontext = bcontext;//new
	
	ret_value = fslink_val;
	return ret_value;
}

void P_ContValFSLink::makeLinksNull(void)
{
	link = NULL;
}

string P_ContValFSLink::getValString(void)
{
	return P_FSSymbolTable::getSym(value);
}

void P_ContValFSLink::Dump(short* Buffer,int& Bindex)
{
	Buffer[++Bindex]=1;
	Buffer[++Bindex]=this->value;
	Buffer[++Bindex]=context.size();
	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		Buffer[++Bindex]=*i;
	}
}

void P_ContValFSLink::Load(short* Buffer,int& Bindex)
{
//	Buffer[++Bindex]=1;
	this->value=Buffer[++Bindex];
	context.resize(Buffer[++Bindex]);
	for(list<contextByte>::iterator i=this->context.begin();i!=context.end();i++)
	{
		*i=Buffer[++Bindex];
	}
}
