#pragma once

/*ADDED IN THIS (LINUX) VERSION*/
#ifndef P_DISQUALIFIERELEMENT_H
#define P_DISQUALIFIERELEMENT_H
/*ADDED IN THIS (LINUX) VERSION*/

#include <string>
using std::wstring;

#include "CSymbolTableManager.h"
#include "POSTable.h"
#include "P_LexicalEntry.h"
#include "Token.h"
#include "P_SegmentMatch.h"

class P_DisqualifierElement
{
public:
	P_DisqualifierElement(void);
	P_DisqualifierElement(wstring element_string);
	~P_DisqualifierElement(void);
	bool disqualified(vector<vector<P_LexicalEntry*> > &lexical_entry_list, vector<Token*> &token_list, short segment_index);
	void removeInvalidEntries(vector<vector<P_LexicalEntry*> >& lexical_entry_list, P_SegmentMatch* match);

private:
	// there are actually 2 types of disqualifier elements:
	// 1. when the disqualifier is a word (includes a POS) e.g. said_v
	// 2. when the disqualifier is a POS e.g. v
	
	// both of these types will be represented as one of the following sets:
	// 1.
	wstring disqualifier_lexeme;
	short lexeme_pos;	// will only be used when eliminating redundant lexical entries during extraction

	// 2.
	short disqualifier_pos;
	
	// this will tell whether 1 or 2 is applicable
	bool is_lexeme;	// // true: use 1, false: use 2

	// note: either 1 OR 2 can be valid at one time

	short disqualifier_position;
	bool is_plus;	// if +x (to the right) then true, if -x (to the left) then false
};
#endif /*ADDED IN THIS (LINUX) VERSION*/