#include "stdafx.h"
#include "P_FSInitializer.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_FSItem** P_FSInitializer::fsitem_lookup_table;
P_TempFSItemArray P_FSInitializer::temp_fsitems;
//string* P_FSInitializer::symbol_table;
list<contextByte>* P_FSInitializer::fdesc_num_contexts;
hash_map<string, PFSitemID> P_FSInitializer::dummy_hash;
int P_FSInitializer::fdesc_num_counter;
PFSitemID* P_FSInitializer::fdesc_numeric;
PFSitemID P_FSInitializer::temp_FD_si_index;
P_TempFDStringItem* P_FSInitializer::temp_FD_string_item;
list< list<contextByte> > P_FSInitializer::prod_context;
contextByte P_FSInitializer::max_assigned_context;
list<string> P_FSInitializer::fsTypeAttr;
bool P_FSInitializer::initialization_complete;
PFSitemID P_FSInitializer::lookup_table_temp_index;
PFSitemID P_FSInitializer::fsitem_insertion_index;
vector<PFSitemID>* P_FSInitializer::fsitem_insert_acc;
bool P_FSInitializer::internal_call;

P_FSInitializer::P_FSInitializer(void)
{
}

P_FSInitializer::~P_FSInitializer(void)
{
}

vector<PFSitemID> P_FSInitializer::getFDVector(string f_desc, contextByte &max_context)
{
	if (internal_call == false)
		max_assigned_context = 0;
	
	vector<PFSitemID> fd_vector;
	
	fdesc_numeric = new PFSitemID[FDESCNUMSIZE];
	fdesc_num_counter = 0;

	fdesc_num_contexts = new list<contextByte>[FDESCNUMSIZE];

	fixFormat(f_desc);
	preprocess(f_desc);
	// whole description is now in numeric form (fdesc_numeric), apply contexts and build up temp_fsitems:
	
	resolveNots();
	applyContexts();
	buildTempFSItemList();
	temp_fsitems.merge();

	// get each item from the merged list (temp_fsitems) and get it's item number; 
	// if required these will be automatically inserted into fsitem_lookup_table
	vector<P_FSItem*>::iterator it;
	for (int i = 0; i < (FSSYMBOLTABLESIZE+1); i++)
	{
		if (temp_fsitems.temp_fsitem_array[i].size() > 0)
		{
			for (it = temp_fsitems.temp_fsitem_array[i].begin(); it != temp_fsitems.temp_fsitem_array[i].end(); it++)
				fd_vector.push_back(getFSItemID(*it));	
		}
	}
	
	delete [] fdesc_numeric;
	delete [] fdesc_num_contexts;
	temp_fsitems.clear();
	max_context = max_assigned_context;
	return fd_vector;
}

P_FSItem* P_FSInitializer::getFSItem(PFSitemID itemID)
{
	return fsitem_lookup_table[itemID - 1]->makeCopy();
}

bool P_FSInitializer::preprocess(string f_desc)
{
	string token;	// e.g., "^NUM = SG", "^GEND =c F"
	int index = 0, sub_index = 0;
		
	token = getNextToken(f_desc, index);
	while (token.compare(""))
	{
		if (token.length() == 1)
		{
			if (token.compare("[") == 0)
				fdNumInsert(OPEN_SQ_BRK);
			if (token.compare("]") == 0)
				fdNumInsert(CLOSE_SQ_BRK);
			if (token.compare("|") == 0)
				fdNumInsert(OR);
			if (token.compare(",") == 0)
				fdNumInsert(AND);
			if (token.compare("~") == 0)
				fdNumInsert(NOT);
		}
		else
		{
			token = cleanUpToken(token);
			fdNumInsert(getTempFDStringItemID(token));
		}
		token = getNextToken(f_desc, index);
	}
	fdNumInsert(ENDFD);
	return false;
}

string P_FSInitializer::getNextToken(string input, int &index)
{
	int start_index, count = 0;
	bool comma_flag = false;	// to check for occurences of type NUM = {SG, PL}
	
	while (input[index] == ' ')
		index++;

	start_index = index;

	if (input[index] == '|')
	{
		index++;
		return("|");
	}
	if (input[index] == '[')
	{
		index++;
		return("[");
	}
	if (input[index] == ']')
	{
		index++;
		return("]");
	}
	if (input[index] == ',')
	{
		index++;
		return(",");
	}
	if (input[index] == '~')
	{
		index++;
		return("~");
	}
	
	while ( (input[index] != ',') && (input[index] != '[') && (input[index] != ']') && (input[index] != '|') && (input[index] != '~') && (index < input.size()))
	{
		if (input[index] == '{')
			comma_flag = true;
		if (input[index] == '}')
			comma_flag = false;
		index++;
		count++;
	}
	if (comma_flag)
	{
		while (input[index] != '}')
		{
			index++;
			count++;
		}
		// the '}' is part of the token and needs to be included
		index++;
		count++;
	}
	return input.substr(start_index, count); 
}

bool P_FSInitializer::fdNumInsert(PFSitemID op)
{
	fdesc_numeric[fdesc_num_counter] = op;
	fdesc_num_counter++;
	return false;
}

string P_FSInitializer::cleanUpToken(string token)
// cleans up all white space except for the single space required between expressions like "SUBJ NUM"
{
	// clears starting whitespace
	while (token[0] == ' ')
		token = token.erase(0, 1);
	
	// clears trailing whitespace
	while (token[token.length() - 1] == ' ')
		token = token.erase((token.length() - 1), 1);
	
	// reduce to single white spaces
	int sp_pos;
	/*while ((sp_pos = token.find("  ", 0)) != string.npos) CHANGED IN THIS (LINUX) VERSION*/
	while ((sp_pos = token.find("  ", 0)) != string::npos)
		token.erase(sp_pos, 1);
	
	string fin_token;
	int fin_token_index = 0;
	// remove all useless white spaces (leave the ones in expressions like "SUBJ NUM")
	for (int i = 0; i < token.length(); i++)
	{
		if (token[i] != ' ')
			fin_token.append(token.substr(i, 1));
		else
		{
			if ( ((token[i+1] != ',') && (token[i+1] != '=') && (token[i+1] != '{') && (token[i+1] != '}') && (token[i+1] != '^') && (token[i+1] != '!')) && 
				 ((token[i-1] != ',') && (token[i-1] != '=') && (token[i-1] != '{') && (token[i-1] != '}') && (token[i-1] != 'c') && (token[i-1] != '^') && (token[i-1] != '!')) )
			{
				fin_token.append(token.substr(i, 1));	
			}
		}
	}
	return fin_token;
}

PFSitemID P_FSInitializer::getTempFDStringItemID(string fdesc)
// check if the string already exists in temp_FD_string_item; if it does return the ID, else 
// construct the P_FSItem, insert and then return ID
{
	hash_map<string, PFSitemID>::iterator it;

	
	it = dummy_hash.find(fdesc);
	if (it != dummy_hash.end() && !(dummy_hash.empty()))
		return (it->second);
	
	// entry is non-existent; make new entry for string ("^NUM=SG", "^SUBJ NUM=!SUBJ NUM", "NUM = {SG, PL}")
	string lhs_op, op, rhs_op;
	string* ops;
	P_TempFDStringItem* temp_FD_str_item;
	temp_FD_str_item = new P_TempFDStringItem();

	ops = reGetNextToken(fdesc);
	lhs_op = ops[0];	// LHS operand
	op = ops[1];	// operator
	rhs_op = ops[2];	// RHS operand
	
	// check if the f-desc can be put in an P_FSItemSimple (^SIMPLEATTR = SIMPLEVALUE)
	/* CHANGED IN THIS (LINUX) VERSION
	if ( (op.compare("=") == 0) && (rhs_op[0] != '{') && (rhs_op[0] != '!') && (rhs_op[0] != '^') && (rhs_op.find(" ", 0) == string.npos) && (lhs_op.find(" ", 0) == string.npos) )
    CHANGED IN THIS (LINUX) VERSION */
	if ( (op.compare("=") == 0) && (rhs_op[0] != '{') && (rhs_op[0] != '!') && (rhs_op[0] != '^') && (rhs_op.find(" ", 0) == string::npos) && (lhs_op.find(" ", 0) == string::npos) )
	{
		P_FSItemSimple* temp_simple_item;
		temp_simple_item = new P_FSItemSimple();
		temp_simple_item->attribute = P_FSSymbolTable::getSymID(lhs_op.substr(1));	// substring because we're getting rid of the ^ from ^attribute
		temp_simple_item->value = P_FSSymbolTable::getSymID(rhs_op);
		
		temp_FD_str_item->f_desc_string = fdesc;
		temp_FD_str_item->f_item = temp_simple_item;
		
		temp_FD_string_item[temp_FD_si_index] = *temp_FD_str_item;
		temp_FD_si_index++;	// increment b4 assigning because ID# should never be zero; is index+1
		dummy_hash[fdesc] = temp_FD_si_index;
		return (temp_FD_si_index);	
	}
	
	// complex item
	else
	{
		P_FSItemComplex* temp_complex_item;
		temp_complex_item = new P_FSItemComplex();
		byte attr_type = 0, value_type = 0;
		
		// get attribute info
		
		list<string>::iterator it;
		bool is_fstype = false;
		
		for (it = fsTypeAttr.begin(); it != fsTypeAttr.end(); it++)
		{
			/*if (lhs_op.substr(1, string.npos) == (*it)) CHANGED IN THIS (LINUX) VERSION*/
			if (lhs_op.substr(1, string::npos) == (*it))
			{
				is_fstype = true;
				break;
			}
		}
		
		if (is_fstype)
			attr_type = attr_type | FSATTR;
		
		/*if (lhs_op.find(" ") != string.npos)CHANGED IN THIS (LINUX) VERSION*/
		if (lhs_op.find(" ") != string::npos)
			attr_type = attr_type | COMPLEXATTR;
		
		if (lhs_op[0] == '!')
			attr_type = attr_type | DOWNARROWATTR;
		
		if (op.compare("=") == 0)
			attr_type = attr_type | OPEQUAL;
		
		if (op.compare("$") == 0)
			attr_type = attr_type | OPSET;
		
		if (op.compare("=c") == 0)
			attr_type = attr_type | OPEQUALC;
		
		// NOT operator will be non-existent at this point
		
		temp_complex_item->attribute_type = attr_type;

		if (lhs_op.length() > 1)	// if there is something additional to the arrow
			temp_complex_item->attribute = P_FSSymbolTable::getSymID(lhs_op.substr(1));
		else 
			temp_complex_item->attribute = 0;

		// attribute done; now get value info
		if (rhs_op[0] == '^' || rhs_op[0] == '!' || rhs_op[0] == '{')
		{
			if (rhs_op[0] == '{')
			{
				P_ConValPlainValList* val_list;
				val_list = new P_ConValPlainValList();
				val_list->values = reReGetNextToken(rhs_op);
				temp_complex_item->contexted_values.push_back(val_list);
			}
			else
			{
				P_ConValFDLink* fd_link;
				fd_link = new P_ConValFDLink();
				byte val_type = 0;
			
				/*if (rhs_op.find(" ") != string.npos)CHANGED IN THIS (LINUX) VERSION*/
				if (rhs_op.find(" ") != string::npos)
					val_type = val_type | COMPLEXVAL;

				if (rhs_op[0] == '!')
					val_type = val_type | DOWNARROWVAL;

				fd_link->value_type = val_type;
				
				if (rhs_op.length() > 1)	// if there is something additional to the arrow
					fd_link->value = P_FSSymbolTable::getSymID(rhs_op.substr(1));
				else 
					fd_link->value = 0;
			
				temp_complex_item->contexted_values.push_back(fd_link);
			}
		}
		else 
		{
			P_ConValPlainVal* val;
			val = new P_ConValPlainVal();
			val->value = P_FSSymbolTable::getSymID(rhs_op);
			temp_complex_item->contexted_values.push_back(val);
		}

		// complex item is complete now
		temp_FD_str_item->f_desc_string = fdesc;
		temp_FD_str_item->f_item = temp_complex_item;
		
		temp_FD_string_item[temp_FD_si_index] = *temp_FD_str_item;
		temp_FD_si_index++;	// increment b4 assigning because ID# should never be zero; is index+1
		dummy_hash[fdesc] = temp_FD_si_index;
		return (temp_FD_si_index);	
	}
}

P_FSItem* P_FSInitializer::getTempFDStringItemCopy(PFSitemID item_id)
{
	P_FSItem* copy;
	copy = temp_FD_string_item[item_id - 1].f_item->makeCopy();
	return copy;
}

string* P_FSInitializer::reGetNextToken(string input)
// retrieves components of an f-description assuming that redundant white spaces have been cleaned up
{
	string* ops;
	ops = new string[3];
	int i;

	/*if ((i = input.find("=")) != string.npos)CHANGED IN THIS (LINUX) VERSION*/
	if ((i = input.find("=")) != string::npos)
	{
		ops[0] = input.substr(0, i);
		ops[1] = input.substr(i, 1);
		ops[2] = input.substr(i + 1);
	}

	/*if ((i = input.find("$")) != string.npos)CHANGED IN THIS (LINUX) VERSION*/
	if ((i = input.find("$")) != string::npos)
	{
		// switch the LHS and RHS operands when the operator is $
		ops[2] = input.substr(0, i);
		ops[1] = input.substr(i, 1);
		ops[0] = input.substr(i + 1);
	}

    /*if ((i = input.find("=c")) != string.npos)CHANGED IN THIS (LINUX) VERSION*/
	if ((i = input.find("=c")) != string::npos)
	{
		ops[0] = input.substr(0, i);
		ops[1] = input.substr(i, 2);
		ops[2] = input.substr(i + 2);
	}

	return ops;
}

list<PFSsymID> P_FSInitializer::reReGetNextToken(string input)
// retrieves individual value IDs from a list e.g., {SG, PL} -> "SG", "PL"
{
	list<PFSsymID> vals;
	int comma_pos, start_index, last_comma;

    start_index = 0;
	last_comma = 0;
	input.erase(0, 1);
	input.erase(input.length() - 1);

	/*while ((comma_pos = input.find(",", start_index)) != string.npos)CHANGED IN THIS (LINUX) VERSION*/
	while ((comma_pos = input.find(",", start_index)) != string::npos)
	{
		vals.push_back(P_FSSymbolTable::getSymID(input.substr(start_index, comma_pos - last_comma)));
		start_index = comma_pos + 1;
		last_comma = comma_pos + 1;
	}
	vals.push_back(P_FSSymbolTable::getSymID(input.substr(last_comma)));
	return vals;
}

list<string> P_FSInitializer::reReGetNextTokenString(string input)
// retrieves individual value IDs from a list e.g., {SG, PL} -> "SG", "PL"
{
	list<string> vals;
	int comma_pos, start_index, last_comma;

    start_index = 0;
	last_comma = 0;
	input.erase(0, 1);
	input.erase(input.length() - 1);
	
	//if (input.find(",", start_index) != string.npos)
	//{
		/*while ((comma_pos = input.find(",", start_index)) != string.npos)CHANGED IN THIS (LINUX) VERSIO*/
		while ((comma_pos = input.find(",", start_index)) != string::npos)
		{
			vals.push_back(input.substr(start_index, comma_pos - last_comma));
			start_index = comma_pos + 1;
			last_comma = comma_pos + 1;
		}
		vals.push_back(input.substr(last_comma));
		return vals;
	//}
	
}

bool P_FSInitializer::resolveNots(void)
// resolve the NOTs from the f-description using DeMorgan's Law; expressions with upto 2 operands are 
// handled, e.g., ~[a | b], ~[c], ~[a , b]
{
	PFSitemID temp_fdesc_numeric[FDESCNUMSIZE];
	int index = 0, temp_index = 0;
	bool changed = false;

	while (fdesc_numeric[index] != ENDFD)
	{
		
		if (fdesc_numeric[index] == NOT)
		{
			// 3 possible cases for a NOT:
			// ~[a|b] -> ~a,~b 
			if (fdesc_numeric[index + 3] == OR)
			{
				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy the ~	
				index = index + 2;	// skip the [
				temp_index++;
				
				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy the a
				temp_index++;
				temp_fdesc_numeric[temp_index] = AND;	// insert the ,
				index = index + 2;	// skip the |	
				temp_index++;	

				temp_fdesc_numeric[temp_index] = NOT;	// insert the ~ for b
				temp_index++;

				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy the b
				index = index + 2;	// skip the ]
				temp_index++;	
			}

			// ~[a,b] -> [~a|~b]
			if (fdesc_numeric[index + 3] == AND)
			{	
				temp_fdesc_numeric[temp_index] = OPEN_SQ_BRK;
				temp_index++;

				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy the ~
				temp_index++;
				index++;

				index++;	// skip the [
				
				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy a
				temp_index++;
				index++;

				index++;	// skip the ,

				temp_fdesc_numeric[temp_index] = OR;
				temp_index++;
				
				temp_fdesc_numeric[temp_index] = NOT;
				temp_index++;
				
				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy b
				temp_index++;
				index++;

				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy ]
				temp_index++;
				index++;
			}	

			// ~[a] -> ~a
			if (fdesc_numeric[index + 3] == CLOSE_SQ_BRK)
			{
				// copy the ~
				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];
				index = index + 2;	// skip the [
				temp_index++;
				
				// copy a
				temp_fdesc_numeric[temp_index] = fdesc_numeric[index];
				index = index + 2;	// skip the ]
				temp_index++;
			}
			changed = true;
		}
		else
		{
			temp_fdesc_numeric[temp_index] = fdesc_numeric[index];
			index++;
			temp_index++;
		}
	}
	temp_fdesc_numeric[temp_index] = fdesc_numeric[index];	// copy ENDFD

	if (changed)
	{
		index = 0;
		temp_index = 0;
		while (temp_fdesc_numeric[temp_index] != ENDFD)
		{
			fdesc_numeric[index] = temp_fdesc_numeric[temp_index];	
			index++;
			temp_index++;
		}
		fdesc_numeric[index] = temp_fdesc_numeric[temp_index];	// copy ENDFD
	}
		
	return false;
}

bool P_FSInitializer::buildTempFSItemList(void)
// traverse the numeric list; get each item (from temp_FD_string_item) as it was originally constructed;
// modify item  to accomodate: 1) the negations (change operator), & 2) the contexts;
// insert final structure in temp_fsitems
{
	P_FSItem* init_fs_item;
	P_FSItem* interm_fs_item;
	P_FSItem* final_fs_item;

	int index = 0;

	while (fdesc_numeric[index] != ENDFD)
	{
		if (fdesc_numeric[index] > 0)
		{
			init_fs_item = (getTempFDStringItemCopy(fdesc_numeric[index]));
			interm_fs_item = init_fs_item;
			if (fdesc_numeric[index - 1] == NOT)
			{
				interm_fs_item = init_fs_item->makeOpNotEq();	
				delete init_fs_item;		
			}
			
			final_fs_item = interm_fs_item->insertContext(fdesc_num_contexts[index]);
			delete interm_fs_item;

			temp_fsitems.insertFSItem(final_fs_item);
		}
		index++;
	}
	
	return false;
}



bool P_FSInitializer::applyContexts(void)
{
	int index = 0, inner_index = 0, brk_open = 0, or_index = 0; 
	contextByte context_counter = max_assigned_context;
	bool after_or = false;

	// add context 0 to all expressions (if there is only a single fd per production: this is figured out
	// through the context list that is prepared for such expressions); else add the prepared contexts
	if (prod_context.empty())
	{
		for (inner_index = 0; fdesc_numeric[inner_index] != ENDFD; inner_index++)
		{
			if (fdesc_numeric[inner_index] > 0)
				fdesc_num_contexts[inner_index].push_back(0);
		}
	}
	else
	{
		list <contextByte> current_context;
		for (inner_index = 0; fdesc_numeric[inner_index] != ENDFD; inner_index++)
		{
			if (fdesc_numeric[inner_index] > 0)
			{
				current_context = prod_context.back();
				list<contextByte>::iterator it;
				for (it = current_context.begin(); it != current_context.end(); it++)
					fdesc_num_contexts[inner_index].push_back(*it);
			}
		}
	}
	inner_index = 0;

	while (fdesc_numeric[index] != ENDFD)
	{
		inner_index = index;
		after_or = false;
		if (fdesc_numeric[index] == OPEN_SQ_BRK)
		{
			// check if the OPEN_SQ_BRK is being used with an OR
			if ((or_index = getCorrespondingOr(index)))	// this is NOT supposed to be '=='	
			{
				context_counter++;
				brk_open++;
				inner_index++;
				while (brk_open)
				{
					if (inner_index == or_index)
						after_or = true;
					if (fdesc_numeric[inner_index] == OPEN_SQ_BRK)
						brk_open++;
					if (fdesc_numeric[inner_index] == CLOSE_SQ_BRK)
						brk_open--;
					if (fdesc_numeric[inner_index] > 0)
					{
						if (!after_or)
							fdesc_num_contexts[inner_index].push_back(context_counter);
						else
							fdesc_num_contexts[inner_index].push_back(-context_counter);
					}
					inner_index++;
				}
			//	context_counter++;
			}
		}
		index++;
		inner_index = index;
	}
	
	if (context_counter != max_assigned_context)	// if it has changed
		max_assigned_context = context_counter;
		//max_assigned_context = context_counter - 1;
	return false;
}

PFSitemID P_FSInitializer::getFSItemID(P_FSItem* fs_item)
// check if the item is already in, if it is, delete it and return the ID, else insert and return ID
{
	/*
	int index = 0;
	while (fsitem_lookup_table[index] != NULL)
	{
		if (*(fsitem_lookup_table[index]) == fs_item)
		{
			delete fs_item;
			return (index + 1);
		}
		index++;	
		if (index >= FSITEMTABLESIZE)
			MessageBox(NULL, L"FS item table full.", L"FS item table full.", MB_ICONINFORMATION);
	}
	fsitem_lookup_table[index] = fs_item;
	
	return (index + 1);
	*/

	PFSitemID item_ID = findFSItem(fs_item);
	
	if (item_ID != -1)	// if found
	{
		delete fs_item;
		return (item_ID + 1);
	}
	
	else
	{
		
		/* REMOVED IN THIS (DOS/LINUX) VERSION
		if (fsitem_insertion_index >= FSITEMTABLESIZE)
			MessageBox(NULL, L"FS item table full.", L"FS item table full.", MB_ICONINFORMATION);
		REMOVED IN THIS (DOS/LINUX) VERSION */
		fsitem_lookup_table[fsitem_insertion_index] = fs_item;
		updateFSItemInsertAcc(fs_item->attribute, fsitem_insertion_index);
		fsitem_insertion_index++;
		return (fsitem_insertion_index);	// needs to be incremented so the ++ above is ok
	}
}

void P_FSInitializer::printDataStructures(ofstream &myfile)
{
	P_FSSymbolTable::printSymbolTable(myfile);

	myfile << "Printing fsitem_lookup_table:\n";
	for (int i = 0; i < FSITEMTABLESIZE; i++)
	{
		if (fsitem_lookup_table[i] != NULL)
		{
			myfile << i+1 << " ";
			fsitem_lookup_table[i]->printItem(myfile);
			myfile << "\n";
		}
	}
	
	// REST ARE TEMPORARY STRUCTURES
}

PFSitemID P_FSInitializer::getCorrespondingOr(int start_index)
{
	short brk_open = 1, or_index, index = start_index + 1, bk_brk_open = 1;
	bool or_found = false;

	while (fdesc_numeric[index] != ENDFD)
	{
		if (fdesc_numeric[index] == OPEN_SQ_BRK)
			brk_open++;
		if (fdesc_numeric[index] == CLOSE_SQ_BRK)
			brk_open--;
		if (fdesc_numeric[index] == OR)	// check if it matches the "[" at start_index
		{
			or_index = index - 1;	// index will anchor the OR
			// start going backwards
			while (or_index != (start_index - 1))
			{
				if (fdesc_numeric[or_index] == OPEN_SQ_BRK)	// [
					bk_brk_open--;
				if (fdesc_numeric[or_index] == CLOSE_SQ_BRK)	// ]
					bk_brk_open++;
				if (!bk_brk_open)	
				// "[" has been found for the current OR; check if it is the required one
				{
					if (or_index == start_index)
						return index;
				}
				or_index--;
			}
			bk_brk_open = 1;	// reset
		}
		if (!brk_open)
			break;
        index++;
	}
	return 0;	
}

void P_FSInitializer::init(void)
{
	P_FSSymbolTable::init();

	internal_call = false;

	initialization_complete = false;
	
	fsitem_lookup_table = new P_FSItem*[FSITEMTABLESIZE];
	for (int i = 0; i < FSITEMTABLESIZE; i++)
		fsitem_lookup_table[i] = NULL;
	fsitem_insertion_index = 0;
	fsitem_insert_acc = new vector<PFSitemID>[FSSYMBOLTABLESIZE];

	temp_FD_string_item = new P_TempFDStringItem[TEMPFDSTRSIZE];
	for (int i = 0; i < TEMPFDSTRSIZE; i++)
		temp_FD_string_item[i].f_item = NULL;
	temp_FD_si_index = 0;	// insertion index;

	// read list fsTypeAttr from file
	string fsattr_filename = CConfiguration::GetConfigInfo("FSAttrTypeFile");
	fstream fsattr_file;
	char entry[256];
	string entry_string;
	fsattr_file.open(fsattr_filename.c_str(), ios::in);
	while (!fsattr_file.eof())
	{
		fsattr_file.getline(entry, 256);
		entry_string = entry;
		fsTypeAttr.push_back(entry_string);
	}
}

void P_FSInitializer::deleteExtraInfo(void)
// free memory allocated to temp_FD_string_item at the end of lexicon processing; 
// !NOT IMPLEMENTED YET!; THIS IS TENTATIVE; 
// 20-01-06: THIS IS FINAL NOW;
{
	P_FSItem * p= temp_FD_string_item[0].f_item;
	for (int i = 0; i < TEMPFDSTRSIZE; i++)
	{
		if (temp_FD_string_item[i].f_item != NULL)
		{
			delete temp_FD_string_item[i].f_item;
			temp_FD_string_item[i].f_item = NULL;
			temp_FD_string_item[i].f_desc_string = "";
		}
	}
	delete [] temp_FD_string_item;
	temp_FD_string_item = new P_TempFDStringItem[PERCTEMPFDSTRSIZE];	// space for one cycle
	for (int i = 0; i < PERCTEMPFDSTRSIZE; i++)
		temp_FD_string_item[i].f_item = NULL;
	temp_FD_si_index = 0;

	// clean up dummy hash
	dummy_hash.clear();
}

// INCOMPLETE: check if only one row then send directly
vector<vector <PFSitemID> > P_FSInitializer::getFDVectors(vector< vector<string> > f_descriptions, contextByte &max_context)
// gets a whole set of f-descriptions that go with a production 
// = no. of RHS symbols * no. of different f-descriptions for the production;
// max_context is not used here, it is assigned the maximum context number at the end so that it can be 
// used later on
{
	internal_call = true;
	contextByte dummy;
	byte no_of_fdescs = f_descriptions.size();	// no. of f-descriptions attached to each production RHS symbol
												// are treated as if they are ORed	
	
	// final_fd_vectors that will be returned
	vector< vector<PFSitemID> > final_fd_vectors;
	vector<PFSitemID>* each_final_fd_vector;

	// fd_vectors in the form they're returned in from getFDVector; need to be merged before they're ready
	vector< vector< vector<PFSitemID> > > raw_fd_vectors;
	// to be inserted into above; all that belong to a single fd option (all RHS symbols)
	vector< vector<PFSitemID> >* fd_vectors_per_desc;
	// iterators
	vector< vector< vector<PFSitemID> > >::iterator raw_it, raw_it_sec;
	vector< vector<PFSitemID> >::iterator per_it, prod_it;

	// to find out the predefined pattern of contexts that will be needed if there are multiple 
	// f-descriptions corresponding to a single production
	if (no_of_fdescs > 1)
	{
		max_assigned_context = no_of_fdescs - 1;
		prod_context = prepareProductionContextList(no_of_fdescs); 
	}
	else 
		max_assigned_context = 0;

	vector< vector<string> >::iterator outer_it;
	vector<string>::iterator inner_it;
	
	// filling up raw_fd_vectors
	for (outer_it = f_descriptions.begin(); outer_it != f_descriptions.end(); outer_it++)
	{
		fd_vectors_per_desc = new vector< vector<PFSitemID> >();
		for (inner_it = (*outer_it).begin(); inner_it != (*outer_it).end(); inner_it++)
		{
			fd_vectors_per_desc->push_back(getFDVector(*inner_it, dummy));
		}
		// modify context list to bring next context to top of list
		//prod_cont_it++;
		if (prod_context.size()) /*CONDITION ADDED FOR LINUX VERSION*/
			prod_context.pop_back();
		raw_fd_vectors.push_back(*fd_vectors_per_desc);
	}
	
	// traverse raw_fd_vectors to get everything merged and put in the order that it has to be sent back in
	byte it_index = 0;
	raw_it = raw_fd_vectors.begin();
//	for (raw_it = raw_fd_vectors.begin(); raw_it != raw_fd_vectors.end(); raw_it++)
//	{
		prod_it = (*raw_it).begin();	
		while (prod_it != (*raw_it).end())	// to reach the f-desc with each symbol
		{
			for (raw_it_sec = raw_fd_vectors.begin(); raw_it_sec != raw_fd_vectors.end(); raw_it_sec++)
			{
				per_it = (*raw_it_sec).begin() + it_index;
				// here per_it is an FDVector; get each element of this vector and put it into 
				// a P_TempFSItem array for merging
				vector<PFSitemID>::iterator it;
				for (it = (*per_it).begin(); it != (*per_it).end(); it++)
					temp_fsitems.insertFSItem(getFSItem(*it));
			}

			if (no_of_fdescs > 0)
				temp_fsitems.merge();
			
			// merged; now traverse and get id for each and put in the final vector
			vector<P_FSItem*>::iterator it2;
			each_final_fd_vector = new vector<PFSitemID>();
			for (int i = 0; i < FSSYMBOLTABLESIZE+1; i++)
			{
				if (temp_fsitems.temp_fsitem_array[i].size() > 0)
				{
					for (it2 = temp_fsitems.temp_fsitem_array[i].begin(); it2 != temp_fsitems.temp_fsitem_array[i].end(); it2++)
					{
						each_final_fd_vector->push_back(getFSItemID(*it2));	
					}	
				}
			}
			final_fd_vectors.push_back(*each_final_fd_vector);
			
			// free so that it can be used in other places
			temp_fsitems.clear();
			it_index++;
			prod_it++;
		}
//	}
		
	prod_context.clear();
	max_context = max_assigned_context;

	internal_call = false;

	return final_fd_vectors;
}

list< list<contextByte> > P_FSInitializer::prepareProductionContextList(byte no_of_fdescs)
// exactly the same as the context preparation function in P_ChartParser
{
	/* 
	context pattern: 
	-5 -4 -3 -2 -1
	-5 -4 -3 -2  1
	-5 -4 -3  2
	-5 -4  3
	-5  4
	 5
	*/
	list< list<contextByte> > prepared_contexts;
	list<contextByte> first_list, next_list;

	for (contextByte i = 1; i < no_of_fdescs; i++)
	{
		first_list.push_back(-i);
	}
	prepared_contexts.push_back(first_list);

	for (contextByte k = 1; k < no_of_fdescs; k++)
	{
		for (contextByte j = k; j < no_of_fdescs; j++)
		{
			if (j == k)
				next_list.push_back(j);
			else
				next_list.push_back(-j);
		}
		prepared_contexts.push_back(next_list);
		next_list.clear();
	}

	return prepared_contexts;
}

void P_FSInitializer::endInitialization(void)
// to be called after the main initialization process (grammar and lexicon) has ended; after this all
// items sent to get their FDVector constructed will have their items and symbols stored 
// temporarily (will be deleted as soon as they're useless - at the end of each sentence);
{
	initialization_complete = true;
	
	// setting index from where the elements in fsitem_lookup_table will be temporary
	lookup_table_temp_index = fsitem_insertion_index;

	// plus we need to something about the symbol table now
	P_FSSymbolTable::endInitialization();	// DONE
	
	deleteExtraInfo();
}

void P_FSInitializer::collectSelectiveGarbage(void)
// delete all the temp entries from fsitem_lookup_table
{
	P_FSSymbolTable::collectSelectiveGarbage();
	
	PFSitemID i = lookup_table_temp_index;
	while (i<FSITEMTABLESIZE && fsitem_lookup_table[i] != NULL)
	{
		// first remove entries from acc
		removeFromAcc(fsitem_lookup_table[i]->attribute, i);	
		
		delete fsitem_lookup_table[i];
		fsitem_lookup_table[i] = NULL;
		i++;
		fsitem_insertion_index--;
	}

	


	// doing cleanup for temp string item stuff; can't use function deleteExtraInfo()
	// because size is different for orig and temp
	for (int i = 0; i < PERCTEMPFDSTRSIZE; i++)
	{
		if (temp_FD_string_item[i].f_item != NULL)
		{
			delete temp_FD_string_item[i].f_item;
			temp_FD_string_item[i].f_item = NULL;
			temp_FD_string_item[i].f_desc_string = "";
		}
	}
	delete [] temp_FD_string_item;
	temp_FD_string_item = new P_TempFDStringItem[PERCTEMPFDSTRSIZE];	// space for one cycle
	for (int i = 0; i < PERCTEMPFDSTRSIZE; i++)
		temp_FD_string_item[i].f_item = NULL;

	temp_FD_si_index = 0;

	// clean up dummy hash
	dummy_hash.clear();

	// also reset static attribute element_no to 1 in P_FSItemComplex
	P_FSItemComplex dummy;
	dummy.resetElementNo();
}

void P_FSInitializer::fixFormat(string& fdesc)
// change the format of the incoming string so that:
// 1. all "&&"s are changed to ","s
// 2. all "||"s are changed to "|"s
{
	/*if ( (fdesc.find("||") != string.npos) || (fdesc.find("&&") != string.npos) )CHANGED IN THIS (LINUX) VERSION*/
	if ( (fdesc.find("||") != string::npos) || (fdesc.find("&&") != string::npos) )
	{
		string original = fdesc;
		fdesc.clear();
		for (int i = 0; i < original.size(); i++)
		{
			if ((original[i] == '&') && (original[i+1] == '&'))
			{
				fdesc.push_back(',');
				i++;
				continue;
			}
			if ((original[i] == '|') && (original[i+1] == '|'))	
			{
				fdesc.push_back('|');
				i++;
				continue;
			}
			fdesc.push_back(original[i]);
		}
	}

	// third thing added 23-02-06: also change all f-descriptions like "NUM = {SG, PL}"
	// to "[NUM = SG | NUM = PL]"
//	changeSetToOrs(fdesc);	
}

PFSitemID P_FSInitializer::findFSItem(P_FSItem* fs_item)
{
	vector<PFSitemID>::iterator it;
	PFSitemID index;

	for (it = fsitem_insert_acc[fs_item->attribute].begin(); it != fsitem_insert_acc[fs_item->attribute].end(); it++)
	{
		index = (*it);
		if (*(fsitem_lookup_table[index]) == fs_item)
			return (*it);
	}
	return -1;
}

void P_FSInitializer::updateFSItemInsertAcc(PFSsymID attr, PFSitemID insert_index)
// here we're talking about the actual indices NOT the incremented ones that we use as IDs
{
	fsitem_insert_acc[attr].push_back(insert_index);
}

void P_FSInitializer::removeFromAcc(PFSsymID attr, PFSitemID insert_index)
{
	vector<PFSitemID>::iterator it;
	for (it = fsitem_insert_acc[attr].begin(); it != fsitem_insert_acc[attr].end(); it++)
	{
		if (insert_index == (*it))
		{
			fsitem_insert_acc[attr].erase(it);
			return;
		}

	}
}

void P_FSInitializer::changeSetToOrs(string& fdesc)
{
	int i, replace_pos, replace_size;
	string tok, new_tok;
	string* ops;
	list<string> vals;
	list<string>::iterator it;
	bool a_not;
	
	/*while ( (i = fdesc.find("{")) != string.npos)CHANGED IN THIS (LINUX) VERSION*/
	while ( (i = fdesc.find("{")) != string::npos)
	{
		tok = "";
		new_tok = "";
		a_not = false;
		// get the token
		while ((fdesc[i] != ',')  && (fdesc[i] != '[') && (fdesc[i] != '|') && (i != 0))
			i--;
		if (fdesc[i-1] == '~')
		{
			i = i - 2;
			a_not = true;
		}
		if (i != 0)
			i++;
		else
		{
			if (fdesc[i] == '[')
			i++;
		}
		
		replace_pos = i;
		
		// calculate size to be replaced
		replace_size = replace_pos;
		while (replace_size < fdesc.size() && fdesc[replace_size] != '}')
			replace_size++;
		while (replace_size < fdesc.size() && fdesc[replace_size] != ','&& fdesc[replace_size] != '|')
		{
			if (fdesc[replace_size] == ']' && !a_not)
				break;

			if (fdesc[replace_size] == ']' && a_not)
			{
                replace_size++;
				break;		
			}
			replace_size++;
		}

		replace_size = replace_size - replace_pos;

		tok = getNextToken(fdesc, i);
		
		// tok should be something like NUM = {SG, PL}
		tok = cleanUpToken(tok);
		

		if (tok == "~")
		{
			a_not = true;
			tok = getNextToken(fdesc, i);
			tok = getNextToken(fdesc, i);
			tok = cleanUpToken(tok);
		}
		else
			a_not = false;
		if (tok == "[")
		{
			tok = getNextToken(fdesc, i);
			tok = cleanUpToken(tok);
		}
		if (tok == "|")
		{
			tok = getNextToken(fdesc, i);
			tok = cleanUpToken(tok);
		}
		// make the new token: [NUM = SG | NUM = PL]
		ops = reGetNextToken(tok);
		vals = reReGetNextTokenString(ops[2]);

		
		if (vals.size() > 1)
		{
			if (a_not)
				new_tok += "~";
			for (int j = 1; j < vals.size(); j++)
				new_tok += "[";

			it = vals.begin();
			new_tok += ops[0];
			new_tok += ops[1];
			new_tok += (*it);
			new_tok += "|";
			new_tok += ops[0];
			new_tok += ops[1];
			it++;
			new_tok += (*it);
			new_tok += "]";
			it++;
			for (it; it != vals.end(); it++)
			{
				new_tok += "|";
				new_tok += ops[0];
				new_tok += ops[1];
				new_tok += (*it);
				new_tok += "]";
			}
		}
		else
		{
			if (a_not)
			{
				new_tok += "~";
				new_tok += "[";
			}
			new_tok += ops[0];
			new_tok += ops[1];
			it = vals.begin();
			new_tok += (*it);
			if (a_not)
			{
				new_tok += "]";
			}
		}
		// now we have the new token, replace the old one with the new one	
        fdesc.replace(replace_pos, replace_size, new_tok);	
	}

}


void P_FSInitializer::DumpP_FSInitializer()
{
	int AnEntry=100;
	int TotalEntries = fsitem_insertion_index;
	short *Buffer = new short[AnEntry*TotalEntries];
	int Bindex=-1;
	P_FSItem* CurremtFSItem;

	Buffer[++Bindex]=AnEntry;
	Buffer[++Bindex]=TotalEntries;

	for(int i=0;i<fsitem_insertion_index;i++)
	{
		CurremtFSItem = fsitem_lookup_table[i];
		CurremtFSItem->Dump(Buffer,Bindex);
		Buffer[++Bindex]=CurremtFSItem->attribute;
	}

	FILE * fwriter=fopen(CConfiguration::GetConfigInfo("P_FSInitializerDump").c_str(),"wb");
	size_t bytes_written=fwrite(Buffer,2,Bindex+1,fwriter);

	fclose(fwriter);
}
void P_FSInitializer::LoadP_FSInitializer()
{
	int AnEntry=0;
	int TotalEntries = 0;
	int Bindex=-1;

	short *Buffer = new short[2];

	FILE * freader=fopen(CConfiguration::GetConfigInfo("P_FSInitializerDump").c_str(),"rb");
	size_t bytes_read=fread(Buffer,2,2,freader);

	AnEntry = Buffer[0];
	TotalEntries = Buffer[1];

	fsitem_insertion_index = TotalEntries;

	delete [] Buffer;

	Buffer = new short[AnEntry*TotalEntries];

	fsitem_lookup_table = new P_FSItem*[FSITEMTABLESIZE];
	for (int i = 0; i < FSITEMTABLESIZE; i++)
		fsitem_lookup_table[i] = NULL;
	
	bytes_read=fread(Buffer,2,TotalEntries*AnEntry,freader);
	int debug=5500;
	P_FSItem* CurremtFSItem;
	for(int i=0;i<fsitem_insertion_index;i++)
	{
		int option = Buffer[++Bindex];
		switch(option)
		{
		case 1:
				CurremtFSItem = new P_FSItemSimple();
			break;
		case 2:
			CurremtFSItem = new P_FSItemComplex();	
			break;
		}
		if(i>debug)
		{
			i=i;
		}
		CurremtFSItem->Load(Buffer,Bindex);
		CurremtFSItem->attribute=Buffer[++Bindex];
		
		fsitem_lookup_table[i]=CurremtFSItem;
	}
}
