#pragma once

/*ADDED IN THIS (LINUX) VERSION*/
#ifndef P_FSITEM_H
#define P_FSITEM_H
/*ADDED IN THIS (LINUX) VERSION*/

#include "fsglobal.h"
#include "P_ContextedValue.h"

#include <list>
#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

class P_FStructure;

class P_FSItem
{
public:
	P_FSItem(void);
	virtual ~P_FSItem(void);

	PFSsymID attribute;
	
	virtual P_FSItem* makeOpNotEq(void) = 0;
	virtual P_FSItem* insertContext(list<contextByte> context_list) = 0;
	virtual P_FSItem* makeCopy(void) = 0;
	virtual bool addContextedValue(P_ContextedValue* cont_val) = 0;
	virtual int numberOfValues(void) = 0;
	virtual bool operator==(P_FSItem* right_item) = 0;
	virtual PFSsymID getSimpleValue(void) = 0;
	virtual byte getAttributeType(void) = 0;
	virtual bool containsContextedValue(P_ContextedValue* contexted_val) = 0;
	virtual void printItem(ofstream &myfile) = 0;
	virtual bool eqMergeInto(P_FSItem* fs_item) = 0;
	virtual bool setMergeInto(P_FSItem* fs_item) = 0;
	virtual bool eqcMergeInto(P_FSItem* fs_item) = 0;
	virtual bool noteqMergeInto(P_FSItem* fs_item) = 0;
	virtual bool eqcDownMergeInto(P_FSItem* fs_item) = 0;
	virtual bool noteqDownMergeInto(P_FSItem* fs_item) = 0;
	virtual P_FSItem* instantiate(contextByte context_offset, P_FStructure* up_arrow, P_FStructure* down_arrow) = 0;
	virtual P_FSItem* instantiate(contextByte context_offset, P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows) = 0;
	bool operator<(P_FSItem* right_item);
	virtual P_FSItem* getItemForFS(void) = 0;
	virtual P_FSItem* getConstraintForFS(void) = 0;
	virtual P_FSItem* getLinkForFS(void) = 0;
	virtual list<P_ContextedValue*> getContextedValues(void) = 0;
	virtual list< bitwiseContext > isConsistent(void) = 0;
	virtual list< bitwiseContext > isConsistentWithItem(P_FSItem* in_item) = 0;
	virtual P_FSItem * getSolution(list<contextByte> & solution) = 0;
	virtual void verifySolution(list<contextByte> & solution) = 0;
	virtual P_FStructure* getInstConstAttrLink(void) = 0;
	virtual void makeLinksNull(void) = 0;
	virtual void removeAllValues(void) = 0;
	virtual void Dump(short* Buffer,int& Bindex)=0;
	virtual void Load(short* Buffer,int& Bindex)=0;
};

struct forSort
{
	bool operator()(P_FSItem* item1, P_FSItem* item2)
	{
		return (item1->attribute < item2->attribute);
	}
};
#endif /*ADDED IN THIS (LINUX) VERSION*/