#include "stdafx.h"
#include "P_FSItemComplex.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "P_FSInitializer.h"
short P_FSItemComplex::element_no = 1;
bitwiseContext zero_c;
P_FSItemComplex::P_FSItemComplex(void)
{
}

P_FSItemComplex::P_FSItemComplex(P_FSItemComplex* complex_item)
{
	this->attribute = complex_item->attribute;
	this->attribute_type = complex_item->attribute_type;
	list<P_ContextedValue*>::iterator it;
	for (it = complex_item->contexted_values.begin(); it != complex_item->contexted_values.end(); it++)
		this->contexted_values.push_back((*it)->makeCopy());
	//this->contexted_values = complex_item->contexted_values;
}
/*
P_FSItemComplex::P_FSItemComplex(P_FSItemSimple* simple_item)
// NOT BEING USED ANYWHERE YET
{
	this->attribute = complex_item->attribute;

	P_ContextedValue* cont_val;
	P_ConValPlainVal* plain_val;

	plain_val = new P_ConValPlainVal();
	plain_val->context.push_back(0);
	plain_val->value = simple_item->value;
	cont_val = plain_val;

	this->attribute_type = complex_item->attribute_type;
	this->contexted_values.push_back(cont_val);
}
*/
P_FSItemComplex::~P_FSItemComplex(void)
// delete all it's values
{
	list<P_ContextedValue*>::iterator it;
	contexted_values.sort();
	contexted_values.unique();
	for (it = contexted_values.begin(); it != contexted_values.end(); it++)
	{
		delete (*it);
	}
}

P_FSItem* P_FSItemComplex::makeOpNotEq(void)
{
	P_FSItem* fs_item;
	P_FSItemComplex* complex_item;

	this->attribute_type = this->attribute_type | OPNOT;
	complex_item = new P_FSItemComplex(this);
	
	fs_item = complex_item;

	return fs_item;
}

P_FSItem* P_FSItemComplex::insertContext(list<contextByte> context_list)
// at this point there is only one value in each item and the context is supposed to be linked to that value
{
	// make new item to return
	P_FSItem* fs_item;
	P_FSItemComplex* complex_item = new P_FSItemComplex(this);
	
	// insert context_list (expression) into first value

	list<P_ContextedValue*>::iterator it;
	it = complex_item->contexted_values.begin();
	(*it)->context = context_list;

	fs_item = complex_item;
	return fs_item;
}

P_FSItem* P_FSItemComplex::makeCopy(void)
{
	P_FSItem* fs_item;
	P_FSItemComplex* copy;
	copy = new P_FSItemComplex();

	copy->attribute = this->attribute;
	copy->attribute_type = this->attribute_type;
	//copy->contexted_values = this->contexted_values;
	list<P_ContextedValue*>::iterator it;
	for (it = contexted_values.begin(); it != contexted_values.end(); it++)
		copy->contexted_values.push_back((*it)->makeCopy());

	fs_item = copy;

	return fs_item;
}

bool P_FSItemComplex::addContextedValue(P_ContextedValue* contexted_value)
{
	this->contexted_values.push_back(contexted_value);
	return true;
}

int P_FSItemComplex::numberOfValues(void)
{
	return this->contexted_values.size();
}

bool P_FSItemComplex::operator==(P_FSItem* right_item)
{
	if (this->attribute != right_item->attribute)
		return false;

	if (this->attribute_type != right_item->getAttributeType())
		return false;

	if (this->numberOfValues() != right_item->numberOfValues())
		return false;

	list<P_ContextedValue*>::iterator it;
	for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
	{
		if (!right_item->containsContextedValue(*it))
			return false;
	}
	return true;
}

PFSsymID P_FSItemComplex::getSimpleValue(void)
{
	return 0;	// indicates that there is no simple value
}

byte P_FSItemComplex::getAttributeType(void)
{
	return this->attribute_type;
}

bool P_FSItemComplex::containsContextedValue(P_ContextedValue* contexted_val)
{
	if (this->numberOfValues() > 0)
	{
		list<P_ContextedValue*>::iterator it;
		for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		{
			
			if (*contexted_val == *it)
				return true;
		}
	}
	return false;
}

void P_FSItemComplex::printItem(ofstream &myfile)
{
	myfile << "Printing P_FSItemComplex:\n";
	myfile << "attribute = " << (int)this->attribute << "\n";
	myfile << "attribute_type = " << (int)this->attribute_type << "\n";

	list<P_ContextedValue*>::iterator it;
	for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		(*it)->printValue(myfile);

	myfile << "\n";
}

bool P_FSItemComplex::eqMergeInto(P_FSItem* fs_item)
// fs_item is always (^attribute =)
// ensure that the object iteself is appropriate for merging and then do it
{
	byte this_attrib_type;
	this_attrib_type = this->attribute_type << 2;

	if (this_attrib_type == 0)
	{
		list<P_ContextedValue*>::iterator it;
		for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		{
			fs_item->addContextedValue(*it);
		}
		return true;	// indicates an addition
	}

	return false;	// no addition
}

bool P_FSItemComplex::setMergeInto(P_FSItem* fs_item)
// fs_item is always (^attribute $)
// ensure that the object iteself is appropriate for merging and then do it
{
	byte this_attrib_type;
	this_attrib_type = this->attribute_type << 2;

	if (this_attrib_type == 32)	// 00100000
	{
		list<P_ContextedValue*>::iterator it;
		for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		{
			fs_item->addContextedValue(*it);
		}
		return true;	// indicates an addition
	}

	return false;	// no addition
}

bool P_FSItemComplex::eqcMergeInto(P_FSItem* fs_item)
// fs_item is always (^attribute =c)
// ensure that the object iteself is appropriate for merging and then do it
{
	byte this_attrib_type;
	this_attrib_type = this->attribute_type << 2;

	if (this_attrib_type == 64)	// 01000000
	{
		list<P_ContextedValue*>::iterator it;
		for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		{
			fs_item->addContextedValue(*it);
		}
		return true;	// indicates an addition
	}

	return false;	// no addition
}

bool P_FSItemComplex::noteqMergeInto(P_FSItem* fs_item)
// fs_item is always (^attribute !=)
// ensure that the object iteself is appropriate for merging and then do it
{
	byte this_attrib_type;
	this_attrib_type = this->attribute_type << 2;

	if (this_attrib_type == 96)	// 01100000
	{
		list<P_ContextedValue*>::iterator it;
		for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		{
			fs_item->addContextedValue(*it);
		}
		return true;	// indicates an addition
	}

	return false;	// no addition
}

bool P_FSItemComplex::eqcDownMergeInto(P_FSItem* fs_item)
// fs_item is always (!attribute =c)
// ensure that the object iteself is appropriate for merging and then do it
{
	byte this_attrib_type;
	this_attrib_type = this->attribute_type << 2;

	if (this_attrib_type == 192)	// 11000000
	{
		list<P_ContextedValue*>::iterator it;
		for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		{
			fs_item->addContextedValue(*it);
		}
		return true;	// indicates an addition
	}

	return false;	// no addition
}

bool P_FSItemComplex::noteqDownMergeInto(P_FSItem* fs_item)
// fs_item is always (!attribute !=)
// ensure that the object iteself is appropriate for merging and then do it
{
	byte this_attrib_type;
	this_attrib_type = this->attribute_type << 2;

	if (this_attrib_type == 224)	// 11100000
	{
		list<P_ContextedValue*>::iterator it;
		for (it = this->contexted_values.begin(); it != this->contexted_values.end(); it++)
		{
			fs_item->addContextedValue(*it);
		}
		return true;	// indicates an addition
	}

	return false;	// no addition
}

P_FSItem* P_FSItemComplex::instantiate(contextByte context_offset, P_FStructure* up_arrow, P_FStructure* down_arrow)
// when the item is a constraint the instantiation will be incomplete;
{
	// three cases are possible: 
	// 1) make a copy and simply instantiate it with the required P_FStructure*;
	// 2) if the attribute is complex ("SUBJ NUM" or "XCOMP SUBJ PRONTYPE"), and the operator
	// is a condition ("=" or "$") make a copy such that the attribute is the first thing 
	// ("SUBJ" or "XCOMP") and it's value is the stuff that follows taking care that the whole depth is 
	// traversed;
	// 3) if the operator is "$", convert to required form (this may be additional to a complex attribute)
	
	P_FSItem* inst_item = NULL;	// final pointer that will be returned

	P_FSItemComplex* inst_comp;	// actual instantiated item (will always be complex) 
	inst_comp = new P_FSItemComplex();
	
	// check if attribute_type is complex
	byte attribute_check = (this->attribute_type & COMPLEXATTR);

	char el_no_str[5]; // to make strings "1", "2" ... for elements - added 14-02-06
		
    if (attribute_check == COMPLEXATTR)
	{
		attribute_check = (this->attribute_type << 3);
		if (attribute_check == 0 || attribute_check == 64)	// op "=" || "$"; 00000000 || 01000000
		{
			if (attribute_check == 0)	// complex and "="
			{
				// CHANGED 26-01-06
				/*
				string head, remaining;
				P_ContValFSLink* link_val;
				P_FStructure* inner_fs;

				remaining = P_FSSymbolTable::getSym(this->attribute);
				head = getHeadOfComplexAttr(remaining);

				inst_comp->attribute = P_FSSymbolTable::getSymID(head);
				inst_comp->attribute_type = FSATTR;
				
				link_val = new P_ContValFSLink();
				link_val->value = 0;
				link_val->value_type = 0;
				link_val->context; // ? what context should be attached to this link?
								   // there may be multiple contexted values here each with it's own 
								   // context, e.g., SUBJ NUM = [SG], [PL] 
				inner_fs = new P_FStructure();
				link_val->link = inner_fs;

				// traverse list of value and instantiate each
				list<P_ContextedValue*>::iterator val_it;
				list<P_ContextedValue*> inst_vals;

				for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
				{
					inst_vals.push_back((*val_it)->instantiate(up_arrow, down_arrow, context_offset));	
				}

				makeFStructure(inner_fs, remaining, inst_vals);
				inst_comp->addContextedValue(link_val);
				inst_item = inst_comp;
				*/
				/* DONE 1*/
				string head, remaining;
				P_ContValFSLink* link_val;
				P_FStructure* inner_fs;

				remaining = P_FSSymbolTable::getSym(this->attribute);
				head = getHeadOfComplexAttr(remaining);
				PFSsymID headid=P_FSSymbolTable::getSymID(head);
				P_FSItem *item=up_arrow->SearchInItemsUnordered(headid);

				if(item)
				{
					delete inst_comp;
					inst_comp=(P_FSItemComplex *)item;
					inner_fs=(*inst_comp->contexted_values.begin())->getFSLinkLink();
					//inner_fs=(*(inner_fs->links->getContextedValues().begin()))->getFSLinkLink();
				} 
				else
				{
					inst_comp->attribute = P_FSSymbolTable::getSymID(head);
					inst_comp->attribute_type = FSATTR;

					link_val = new P_ContValFSLink();
					link_val->value = 0;
					link_val->value_type = 0;
					//link_val->context = inst_val->context; 
					inner_fs = new P_FStructure();
					link_val->link = inner_fs;
					inst_comp->addContextedValue(link_val);
				}

				// traverse list of value and instantiate each
				list<P_ContextedValue*>::iterator val_it;
				P_ContextedValue* inst_val;

				for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
				{
					inst_val = (*val_it)->instantiate(up_arrow, down_arrow, context_offset);
					inst_val->bcontext = ContextManager::convertListTobitwiseContext( inst_val->context );
					makeFStructure(inner_fs, remaining, inst_val);
				}
				inst_item = inst_comp;
			}
			else	// complex and "$"	
			{
				// modify the item such that the "$" is changed to a "=" by appending " ELEMENT" to the attribute;
				// then make a recursive call, the fs_item returned will meet the requirements;
				string new_attr;
				byte new_attr_type = 231;	// 11100111
				
				if (this->attribute != 0)
				{
					new_attr = P_FSSymbolTable::getSym(this->attribute) + " SET ELEMENT";
					itoa(element_no, el_no_str, 10);
					new_attr += el_no_str;
				}
				else
				{
                    new_attr = "SET ELEMENT";
					itoa(element_no, el_no_str, 10);
					new_attr += el_no_str;
				}
				element_no++;

				this->attribute = P_FSSymbolTable::getSymID(new_attr);
				this->attribute_type = (this->attribute_type & new_attr_type);
				this->attribute_type = this->attribute_type | COMPLEXATTR;
				
				inst_item = instantiate(context_offset, up_arrow, down_arrow);

			}
		}
		else	// complex and "=c" or "!="
		{
			inst_comp->attribute = this->attribute;
			inst_comp->attribute_type = this->attribute_type;
			
			// traverse list of value and instantiate each
			list<P_ContextedValue*>::iterator val_it;
			list<P_ContextedValue*> inst_vals;

			for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
			{
				inst_vals.push_back((*val_it)->instantiate(up_arrow, down_arrow, context_offset));	
			}
			//inst_comp->contexted_values = inst_vals;
			// FIXED HERE
			for (val_it = inst_vals.begin(); val_it != inst_vals.end(); val_it++)
			{
				inst_comp->contexted_values.push_back((*val_it)->makeCopy());	
				(*val_it)->makeLinksNull();
				delete (*val_it);
			}
			inst_item = inst_comp; 
		}
	}
	else
	{
		attribute_check = (this->attribute_type << 3);
		if (attribute_check == 64)	// non-complex and op "$"
		{
			// modify the item such that the "$" is changed to a "=" by appending " ELEMENT" to the attribute;
			// then make a recursive call, the fs_item returned will meet the requirements;
			string new_attr;
			byte new_attr_type = 231;	// 11100111

			if (this->attribute != 0)
			{
				new_attr = P_FSSymbolTable::getSym(this->attribute) + " SET ELEMENT";
				itoa(element_no, el_no_str, 10);
				new_attr += el_no_str;
			}
			else
			{
				new_attr = "SET ELEMENT";
				itoa(element_no, el_no_str, 10);
				new_attr += el_no_str;
			}
			element_no++;

			this->attribute = P_FSSymbolTable::getSymID(new_attr);
			this->attribute_type = this->attribute_type & new_attr_type;
			this->attribute_type = this->attribute_type | COMPLEXATTR;
            
			inst_item = instantiate(context_offset, up_arrow, down_arrow);
		}
		else	// simple and ops "=", "=c", "!="
		{
			inst_comp->attribute = this->attribute;
			inst_comp->attribute_type = this->attribute_type;
			
			// traverse list of value and instantiate each
			list<P_ContextedValue*>::iterator val_it;
			list<P_ContextedValue*> inst_vals;

			for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
			{
				inst_vals.push_back((*val_it)->instantiate(up_arrow, down_arrow, context_offset));	
			}
			// FIXED HERE
			for (val_it = inst_vals.begin(); val_it != inst_vals.end(); val_it++)
			{
				inst_comp->contexted_values.push_back((*val_it)->makeCopy());	
				(*val_it)->makeLinksNull();
				delete (*val_it);
			}
			
			inst_item = inst_comp; 
		}
	}
	
	return inst_item;
}

P_FSItem* P_FSItemComplex::getItemForFS(void)
// if it's not a constraint, and it's not an ^=! return a copy else return NULL
{
	byte operator_bits = 0;
	operator_bits = this->attribute_type & 24;	// 00011000

	// only "=" operator is checked because after instantiation all "$"s are converted to "="s
	if (operator_bits == 0 && this->attribute != 0)
		//return (makeCopy());
		return this;
	else
		return NULL;
}

P_FSItem* P_FSItemComplex::getConstraintForFS(void)
// check if the operator is a constraint ("=c" or "!="), if it is make a copy and return it, else return NULL
{
	byte operator_bits = 0;
	operator_bits = this->attribute_type & 24;	// 00011000

	if ((operator_bits == OPEQUALC) | (operator_bits == OPNOT))	
		//return (makeCopy());
		return this;
	else
		return NULL;
}

P_FSItem* P_FSItemComplex::getLinkForFS(void)
// if attribute = 0, value = 0 & operator is "=", return a copy else return NULL
{
	byte operator_bits = 0;
	operator_bits = this->attribute_type & 24;	// 00011000
	list<P_ContextedValue*>::iterator it = contexted_values.begin();
	
	// checking only one value because if the attribute is "^=" then the value should always be "!";
	// therefore there should only be a single value in an item like this
	if ((this->attribute == 0) && (operator_bits == 0) && ((*it)->zeroValue()))
		//return (makeCopy());
		return this;
	else
		return NULL;
}

list<P_ContextedValue*> P_FSItemComplex::getContextedValues(void)
{
	return this->contexted_values;
}

void P_FSItemComplex::makeFStructure(P_FStructure* fs, string attr, P_ContextedValue* in_value)
{
	// first make the item; then make the three function calls (NOT REQUIRED), one of which will determine where it
	// is supposed to go in the P_FStructure 
	
	// CHANGED 26-01-06: only ONE value comes in now (DONE 2)

	// either the end of the complex attribute has been reached, or it needs to be broken down furthur:
	/*if (attr.find(" ") == string.npos)	// end CHANGED IN THIS (LINUX) VERSION*/
	if (attr.find(" ") == string::npos)	// end
	{
		P_FSItem* fs_item;
		P_FSItemComplex* complex_item;
		
		complex_item = new P_FSItemComplex();
		complex_item->attribute = P_FSSymbolTable::getSymID(attr);
		
		// attribute_type is 0 because attribute will always be simple at this point; it will always have an
		// up-arrow next to it (a down-arrow can only come next to a constraint attribute and constraints
		// will not be processed here); the operator will always be "=", even "$" turns into it during
		// this processing
		complex_item->attribute_type = 0;

		if (attr.substr(0,7) == "ELEMENT")
			complex_item->attribute_type = FSATTR;

		for(list<string>::iterator it=P_FSInitializer::fsTypeAttr.begin();it!=P_FSInitializer::fsTypeAttr.end();it++)
		{
			if(attr==(*it))
			{
				complex_item->attribute_type = FSATTR;
				break;
			}
		}
		//list<P_ContextedValue*>::iterator it;
		//for (it = values.begin(); it != values.end(); it++)
		//	complex_item->contexted_values.push_back((*it)->makeCopy());
		
		complex_item->contexted_values.push_back((in_value)->makeCopy());	// only ONE value

		fs_item = complex_item;
		
		// now the item is done, but it needs to be placed in it's proper list in the P_FStructure;
		// we know that this item can only go into fs_items (not constraints or links) therefore:
		fs->addItem(fs_item);
		fs->resolveValueLinks();
	}
    else	// furthur breakup required
	{
		// make the item to put in the fs

		P_FStructure* inner_fs;	
		
		string head;
		head = getHeadOfComplexAttr(attr);

		/*
		list<P_FSItem *> items= fs->SearchInItemsLinks(P_FSSymbolTable::getSymID(head));

		if(items.size())
		{
			P_FSItemComplex * item_comp=(P_FSItemComplex *)(*items.begin());
			inner_fs=(*item_comp->contexted_values.begin())->getFSLinkLink();
		} 
		*/

		/**/
		if(fs->links->getContextedValues().size())
			fs=(*(fs->links->getContextedValues().begin()))->getFSLinkLink();
		P_FSItem *item=fs->SearchInItemsUnordered(P_FSSymbolTable::getSymID(head));

		if(item)
		{
			P_FSItemComplex * item_comp=(P_FSItemComplex *)item;
			inner_fs=(*item_comp->contexted_values.begin())->getFSLinkLink();
		} 
		/**/
		else
		{
			// making the value:
			P_ContextedValue* val;
			P_ContValFSLink* link_val;
			
			link_val = new P_ContValFSLink();
			
			// there is only ONE value in the list so get it's context
			//link_val->context = in_value->context;	

			link_val->value = 0;
			link_val->value_type = 0;

			inner_fs = new P_FStructure();
			link_val->link = inner_fs;
			val = link_val;

			// making the item:
			P_FSItem* fs_item;
			P_FSItemComplex* complex_item;
			
			complex_item = new P_FSItemComplex();

			complex_item->attribute = P_FSSymbolTable::getSymID(head);
			complex_item->attribute_type = FSATTR;
			complex_item->contexted_values.push_back(val);

			fs_item = complex_item;
			fs->fs_items.push_back(fs_item);
		}
		makeFStructure(inner_fs, attr, in_value);		
	}
}

P_FSItem* P_FSItemComplex::instantiate(contextByte context_offset, P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows)
// is the same as the other overloaded instantiate except that the value instantiated calls go to the 
// similarly overloaded functions for value instantiation; this should return a list of values all
// of which should be added (the list will be of more than 1 element if the value is a !value)
{
	// three cases are possible: 
	// 1) make a copy and simply instantiate it with the required P_FStructure*;
	// 2) if the attribute is complex ("SUBJ NUM" or "XCOMP SUBJ PRONTYPE"), and the operator
	// is a condition ("=" or "$") make a copy such that the attribute is the first thing 
	// ("SUBJ" or "XCOMP") and it's value is the stuff that follows taking care that the whole depth is 
	// traversed;
	// 3) if the operator is "$", convert to required form (this may be additional to a complex attribute);
	
	P_FSItem* inst_item = NULL;	// final pointer that will be returned

	P_FSItemComplex* inst_comp;	// actual instantiated item (will always be complex) 
	inst_comp = new P_FSItemComplex();
	
	// check if attribute_type is complex
	byte attribute_check = (this->attribute_type & COMPLEXATTR);

	char el_no_str[5]; // to make strings "1", "2" ... for elements - added 14-02-06
	
	if (attribute_check == COMPLEXATTR)
	{
		attribute_check = (this->attribute_type << 3);
		if ((attribute_check == 0) || (attribute_check == 64))	// op "=" || "$"; 00000000 || 01000000
		{
			if (attribute_check == 0)	// complex and "="
			{
				/*
				string head, remaining;
				P_ContValFSLink* link_val;
				P_FStructure* inner_fs;

				remaining = P_FSSymbolTable::getSym(this->attribute);
				head = getHeadOfComplexAttr(remaining);

				inst_comp->attribute = P_FSSymbolTable::getSymID(head);
				inst_comp->attribute_type = FSATTR;
				
				link_val = new P_ContValFSLink();
				link_val->value = 0;
				link_val->value_type = 0;
				link_val->context; // ? what context should be attached to this link?
								   // there may be multiple contexted values here each with it's own 
								   // context, e.g., SUBJ NUM = [SG], [PL] 
				inner_fs = new P_FStructure();
				link_val->link = inner_fs;

				// traverse list of values and instantiate each
				list<P_ContextedValue*>::iterator val_it;
				list<P_ContextedValue*> inst_vals;
				list<P_ContextedValue*> multiple_vals;
				list<P_ContextedValue*>::iterator mul_val_it;
				
				// HAVE RE-DONE THIS ONE
				for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
				{
					multiple_vals = (*val_it)->instantiate(up_arrow, down_arrows, context_offset);
					for (mul_val_it = multiple_vals.begin(); mul_val_it != multiple_vals.end(); mul_val_it++)
						inst_vals.push_back(*mul_val_it);
				}

				makeFStructure(inner_fs, remaining, inst_vals);
				inst_item = inst_comp;
				*/
				// DONE LAST			
				string head, remaining;
				P_ContValFSLink* link_val;
				P_FStructure* inner_fs;

				remaining = P_FSSymbolTable::getSym(this->attribute);
				head = getHeadOfComplexAttr(remaining);

				inst_comp->attribute = P_FSSymbolTable::getSymID(head);
				inst_comp->attribute_type = FSATTR;

				
				// traverse list of values and instantiate each
				list<P_ContextedValue*>::iterator val_it;
				//list<P_ContextedValue*> inst_vals;
				P_ContextedValue* inst_val;
				list<P_ContextedValue*> multiple_vals;
				list<P_ContextedValue*>::iterator mul_val_it;
				
				// HAVE RE-DONE THIS ONE
				for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
				{
					multiple_vals = (*val_it)->instantiate(up_arrow, down_arrows, context_offset);
					for (mul_val_it = multiple_vals.begin(); mul_val_it != multiple_vals.end(); mul_val_it++)
					{
						//inst_vals.push_back(*mul_val_it);
						inst_val = (*mul_val_it);
						link_val = new P_ContValFSLink();
						link_val->value = 0;
						link_val->value_type = 0;
						link_val->context = inst_val->context; 
						link_val->bcontext = ContextManager::convertListTobitwiseContext( link_val->context );
						inner_fs = new P_FStructure();
						link_val->link = inner_fs;

						makeFStructure(inner_fs, remaining, inst_val);
						inst_comp->addContextedValue(link_val);
					}
				}
				inst_item = inst_comp;
			}
			else	// complex and "$"	
			{
				// modify the item such that the "$" is changed to a "=" by appending " ELEMENT" to the attribute;
				// then make a recursive call, the fs_item returned will meet the requirements;
				string new_attr;
				byte new_attr_type = 231;	// 11100111

				if (this->attribute != 0)
				{
					new_attr = P_FSSymbolTable::getSym(this->attribute) + " SET ELEMENT";
					itoa(element_no, el_no_str, 10);
					new_attr += el_no_str;
				}
				else
				{
					new_attr = "SET ELEMENT";
					itoa(element_no, el_no_str, 10);
					new_attr += el_no_str;
				}
				element_no++;

				this->attribute = P_FSSymbolTable::getSymID(new_attr);
				this->attribute_type = this->attribute_type & new_attr_type;
				this->attribute_type = this->attribute_type | COMPLEXATTR;

				inst_item = instantiate(context_offset, up_arrow, down_arrows);

			}
		}
		else	// complex and "=c" or "!="
		{
			inst_comp->attribute = this->attribute;
			inst_comp->attribute_type = this->attribute_type;
			
			// traverse list of value and instantiate each
			list<P_ContextedValue*>::iterator val_it;
			list<P_ContextedValue*> inst_vals;
			
			list<P_ContextedValue*> multiple_vals; 
			list<P_ContextedValue*>::iterator mul_val_it;
			
			// RE-DONE
			for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
			{
				multiple_vals = (*val_it)->instantiate(up_arrow, down_arrows, context_offset);
				for (mul_val_it = multiple_vals.begin(); mul_val_it != multiple_vals.end(); mul_val_it++)
					inst_vals.push_back(*mul_val_it);
			}
			inst_comp->contexted_values = inst_vals;
			inst_item = inst_comp; 
		}
	}
	else
	{
		attribute_check = (this->attribute_type << 3);
		if (attribute_check == 64)	// non-complex and op "$"
		{
			// modify the item such that the "$" is changed to a "=" by appending " ELEMENT" to the attribute;
			// then make a recursive call, the fs_item returned will meet the requirements;
			string new_attr;
			byte new_attr_type = 231;	// 11100111

			if (this->attribute != 0)
			{
				new_attr = P_FSSymbolTable::getSym(this->attribute) + " SET ELEMENT";
				itoa(element_no, el_no_str, 10);
				new_attr += el_no_str;
			}
			else
			{
				new_attr = "SET ELEMENT";
				itoa(element_no, el_no_str, 10);
				new_attr += el_no_str;
			}
			element_no++;

			this->attribute = P_FSSymbolTable::getSymID(new_attr);
			this->attribute_type = this->attribute_type & new_attr_type;	
			this->attribute_type = this->attribute_type | COMPLEXATTR;

			inst_item = instantiate(context_offset, up_arrow, down_arrows);
		}
		else	// simple and ops "=", "=c", "!="
		{
			inst_comp->attribute = this->attribute;
			inst_comp->attribute_type = this->attribute_type;
			
			// traverse list of value and instantiate each
			list<P_ContextedValue*>::iterator val_it;
			list<P_ContextedValue*> inst_vals;

			list<P_ContextedValue*> multiple_vals; 
			list<P_ContextedValue*>::iterator mul_val_it;
				
			// RE-DONE
			for (val_it = this->contexted_values.begin(); val_it != this->contexted_values.end(); val_it++)
			{
				multiple_vals = (*val_it)->instantiate(up_arrow, down_arrows, context_offset);
				for (mul_val_it = multiple_vals.begin(); mul_val_it != multiple_vals.end(); mul_val_it++)
					inst_vals.push_back(*mul_val_it);
			}
			inst_comp->contexted_values = inst_vals;
			inst_item = inst_comp; 
		}
	}
	
	return inst_item;
}

/*list< list<contextByte> > P_FSItemComplex::isConsistent(void)
{
	// for nogoods manipulation
	list < list<contextByte> > current_nogoods;
	list<contextByte> union_expr;
	list < list<contextByte> >::iterator cur_ng_it;
	list<contextByte>::iterator union_it;


	list< list<contextByte> > nogoods;
	list<P_ContextedValue*>::iterator vals_anchor_it, vals_it;
	for (vals_anchor_it = contexted_values.begin(); vals_anchor_it != contexted_values.end(); vals_anchor_it++)
	{
		vals_it = vals_anchor_it;
		if (vals_it == contexted_values.end())
			break;
		vals_it++;
		for (vals_it; vals_it != contexted_values.end(); vals_it++)
		{
			if (!opposingContextsPresent((*vals_anchor_it)->context, (*vals_it)->context))
			{
				// here both the anchor and non anchor can be of three types:
				// 1) values(single or list), 2) ! with zero value, 3) NULL link with zero value
				// (arises due to resolveValueLinks)
				if (!(*vals_anchor_it)->zeroValue())	// either single value or list({SG, PL})
				{
					// now check type for vals_it
					if (!(*vals_it)->zeroValue())
					{
						if (!(*vals_anchor_it)->isConsistent(*vals_it))
						{
							nogoods.push_back(getUnion((*vals_anchor_it)->context, (*vals_it)->context));
							#ifdef GenLog
							wstring att=Convert_str2wstr( P_FSSymbolTable::getSym(attribute) );
							CLogManager::AddMessage(att+L"is not consistent");
							LogContextByteList(getUnion((*vals_anchor_it)->context, (*vals_it)->context));
							#endif GenLog
						}
					}
					else
					{
						// a NULL link here does not mean an inconsistency, it just means that there is 
						// no value here; so only if there is a link a nogood should be added
						// (no value consistency checking required here because a value and a link
						// inconsistent types)
						if ((*vals_it)->getFSLinkLink() != NULL)
							nogoods.push_back(getUnion((*vals_anchor_it)->context, (*vals_it)->context));
					}
				}
				else	// an fs link or a NULL link
				{
					P_FStructure* anchor_FS;
					anchor_FS = (*vals_anchor_it)->getFSLinkLink();
					// if it is a NULL link then it will not be inconsistent with anything
					if (anchor_FS != NULL)
					{
						// now check type for vals_it
						if (!(*vals_it)->zeroValue())	// then it is inconsistent
							nogoods.push_back(getUnion((*vals_anchor_it)->context, (*vals_it)->context));
						else
						{
							if(anchor_FS->failed)
								nogoods.push_back((*vals_anchor_it)->context);
							else
							{
								current_nogoods = anchor_FS->isConsistentWithFS((*vals_it)->getFSLinkLink());
								if (!current_nogoods.empty())
								{
									// need to take list of nogoods and add the union of the contexts obtained
									// at this level to each before adding those nogoods to this f-structure
									// (i.e., nogoods need to be modified before they are ready for use)
									for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
									{	
										union_expr = getUnion((*vals_anchor_it)->context, (*vals_it)->context);
										for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
											(*cur_ng_it).push_back(*union_it);
										nogoods.push_back(*cur_ng_it);
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return nogoods;
}

list< list<contextByte> > P_FSItemComplex::isConsistentWithItem(P_FSItem* in_item)
// the incoming thing here is always an item from fs_items (i.e. not a ^=!);
// attributes have already been matched so only check values;
// each value of in_item will be checked for consistency against each value of this item
{
	// for nogoods manipulation
	list < list<contextByte> > current_nogoods;
	list<contextByte> union_expr;
	list < list<contextByte> >::iterator cur_ng_it;
	list<contextByte>::iterator union_it;
	
	list< list<contextByte> > ret_nogoods;
	list<P_ContextedValue*> in_values;
	in_values = in_item->getContextedValues();
	list<P_ContextedValue*>::iterator in_it, self_it;

	for (self_it = contexted_values.begin(); self_it != contexted_values.end(); self_it++)
	{
		for (in_it = in_values.begin(); in_it != in_values.end(); in_it++)
		{
			// possible types of self and in values:
			// 1) values(single or list), 2) ! with zero value, 3) NULL link with zero value
			if (!(*self_it)->zeroValue())	// either single value or list({SG, PL})
			{
				if (!(*in_it)->zeroValue())
				{
					if (!(*self_it)->isConsistent(*in_it))
					{
						ret_nogoods.push_back(getUnion((*self_it)->context, (*in_it)->context));
						#ifdef GenLog
						wstring att=Convert_str2wstr( P_FSSymbolTable::getSym(attribute) );
						CLogManager::AddMessage(att+L"is not consistent");
						LogContextByteList(getUnion((*self_it)->context, (*in_it)->context));
						#endif GenLog
					}
				}
				else
				{
					// a NULL link here does not mean an inconsistency, it just means that there is 
					// no value here; so only if there is a link a nogood should be added
					// (no value consistency checking required here because a value and a link
					// inconsistent types)
					if ((*in_it)->getFSLinkLink() != NULL)
						ret_nogoods.push_back(getUnion((*self_it)->context, (*in_it)->context));
				}
			}
			else	// an fs link or a NULL link
			{
				P_FStructure* self_FS;
				self_FS = (*self_it)->getFSLinkLink();
				// if it is a NULL link then it will not be inconsistent with anything
				if (self_FS != NULL)
				{
					// now check type for in_it
					if (!(*in_it)->zeroValue())	// then it is inconsistent
						ret_nogoods.push_back(getUnion((*self_it)->context, (*in_it)->context));
					else
					{
						current_nogoods = self_FS->isConsistentWithFS((*in_it)->getFSLinkLink());
						if (!current_nogoods.empty())
						{
							// need to take list of nogoods and add the union of the contexts obtained
							// at this level to each before adding those nogoods to this f-structure
							// (i.e., nogoods need to be modified before they are ready for use)
							for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
							{	
								union_expr = getUnion((*self_it)->context, (*in_it)->context);
								for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
									(*cur_ng_it).push_back(*union_it);
								ret_nogoods.push_back(*cur_ng_it);
							}
						}
					}
				}
			}
		}
	}
		
	return ret_nogoods;
}*/

list< bitwiseContext > P_FSItemComplex::isConsistent(void)
{
	/* REMOVED IN THIS (DOS/LINUX) VERSION
	#ifndef DEBUG
	current_time = clock();
	if ((current_time - P_FStructure::start_time)>P_FStructure::max_time)
	{
		list < bitwiseContext > nogoods;
		nogoods.push_back(zero_c);
        return nogoods;
	}
	#endif
	REMOVED IN THIS (DOS/LINUX) VERSION */
	// for nogoods manipulation
	list < bitwiseContext > current_nogoods;
	bitwiseContext union_expr;
	list < bitwiseContext >::iterator cur_ng_it;
	//list<contextByte>::iterator union_it;


	list< bitwiseContext > nogoods;
	list<P_ContextedValue*>::iterator vals_anchor_it, vals_it;
	for (vals_anchor_it = contexted_values.begin(); vals_anchor_it != contexted_values.end(); vals_anchor_it++)
	{
		vals_it = vals_anchor_it;
		if (vals_it == contexted_values.end())
			break;
		vals_it++;
		for (vals_it; vals_it != contexted_values.end(); vals_it++)
		{
			if (!ContextManager::opposingContextsPresent((*vals_anchor_it)->bcontext, (*vals_it)->bcontext))
			{
				// here both the anchor and non anchor can be of three types:
				// 1) values(single or list), 2) ! with zero value, 3) NULL link with zero value
				// (arises due to resolveValueLinks)
				if (!(*vals_anchor_it)->zeroValue())	// either single value or list({SG, PL})
				{
					// now check type for vals_it
					if (!(*vals_it)->zeroValue())
					{
						if (!(*vals_anchor_it)->isConsistent(*vals_it))
						{
							nogoods.push_back(ContextManager::getUnion((*vals_anchor_it)->bcontext, (*vals_it)->bcontext));
							#ifdef GenLog
							wstring att=Convert_str2wstr( P_FSSymbolTable::getSym(attribute) );
							CLogManager::AddMessage(att+L"is not consistent");
							/*CHANGED IN THIS (LINUX ONLY) VERSION
							LogContextByteList( ContextManager::convertbitwiseContextToList( ContextManager::getUnion((*vals_anchor_it)->bcontext, (*vals_it)->bcontext)) );
							CHANGED IN THIS (LINUX ONLY) VERSION*/
							/*CHANGE*/
							bitwiseContext btw_context = ContextManager::getUnion((*vals_anchor_it)->bcontext, (*vals_it)->bcontext);
							LogContextByteList( ContextManager::convertbitwiseContextToList(btw_context) );
							/*CAHNGE ENDS*/	
							#endif GenLog
						}
					}
					else
					{
						// a NULL link here does not mean an inconsistency, it just means that there is 
						// no value here; so only if there is a link a nogood should be added
						// (no value consistency checking required here because a value and a link
						// inconsistent types)
						if ((*vals_it)->getFSLinkLink() != NULL)
							nogoods.push_back(ContextManager::getUnion((*vals_anchor_it)->bcontext, (*vals_it)->bcontext));
					}
				}
				else	// an fs link or a NULL link
				{
					P_FStructure* anchor_FS;
					anchor_FS = (*vals_anchor_it)->getFSLinkLink();
					// if it is a NULL link then it will not be inconsistent with anything
					if (anchor_FS != NULL)
					{
						// now check type for vals_it
						if (!(*vals_it)->zeroValue())	// then it is inconsistent
							nogoods.push_back(ContextManager::getUnion((*vals_anchor_it)->bcontext, (*vals_it)->bcontext));
						else
						{
							if(anchor_FS->failed)
								nogoods.push_back((*vals_anchor_it)->bcontext);
							else
							{
								current_nogoods = anchor_FS->isConsistentWithFS((*vals_it)->getFSLinkLink());
								if (!current_nogoods.empty())
								{
									// need to take list of nogoods and add the union of the contexts obtained
									// at this level to each before adding those nogoods to this f-structure
									// (i.e., nogoods need to be modified before they are ready for use)
									for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
									{	
										union_expr = ContextManager::getUnion((*vals_anchor_it)->bcontext, (*vals_it)->bcontext);
										//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
										//	(*cur_ng_it).push_back(*union_it);
										nogoods.push_back(ContextManager::getUnion(*cur_ng_it,union_expr));
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return nogoods;
}

list< bitwiseContext > P_FSItemComplex::isConsistentWithItem(P_FSItem* in_item)
// the incoming thing here is always an item from fs_items (i.e. not a ^=!);
// attributes have already been matched so only check values;
// each value of in_item will be checked for consistency against each value of this item
{
	/* REMOVED IN THIS (DOS/LINUX) VERSION
	#ifndef DEBUG
	current_time = clock();
	if ((current_time - P_FStructure::start_time)>P_FStructure::max_time)
	{
		list < bitwiseContext > nogoods;
		nogoods.push_back(zero_c);
        return nogoods;
	}
	#endif
	REMOVED IN THIS (DOS/LINUX) VERSION */
	// for nogoods manipulation
	list < bitwiseContext > current_nogoods;
	bitwiseContext union_expr;
	list < bitwiseContext >::iterator cur_ng_it;
	//list<contextByte>::iterator union_it;
	
	list< bitwiseContext > ret_nogoods;
	list<P_ContextedValue*> in_values;
	in_values = in_item->getContextedValues();
	list<P_ContextedValue*>::iterator in_it, self_it;

	for (self_it = contexted_values.begin(); self_it != contexted_values.end(); self_it++)
	{
		for (in_it = in_values.begin(); in_it != in_values.end(); in_it++)
		{
			// possible types of self and in values:
			// 1) values(single or list), 2) ! with zero value, 3) NULL link with zero value
			if (!(*self_it)->zeroValue())	// either single value or list({SG, PL})
			{
				if (!(*in_it)->zeroValue())
				{
					if (!(*self_it)->isConsistent(*in_it))
					{
						ret_nogoods.push_back(ContextManager::getUnion((*self_it)->bcontext, (*in_it)->bcontext));
						#ifdef GenLog
						wstring att=Convert_str2wstr( P_FSSymbolTable::getSym(attribute) );
						CLogManager::AddMessage(att+L"is not consistent");
						/*CHANGED IN THIS (LINUX ONLY) VERSION
						LogContextByteList( ContextManager::convertbitwiseContextToList( ContextManager::getUnion((*self_it)->bcontext, (*in_it)->bcontext)) );
						CHANGED IN THIS (LINUX ONLY) VERSION*/
						bitwiseContext btw_context = ContextManager::getUnion((*self_it)->bcontext, (*in_it)->bcontext);
						LogContextByteList( ContextManager::convertbitwiseContextToList(btw_context));
						/*CHANGED*/
						/*END CHANGED*/
						#endif GenLog
					}
				}
				else
				{
					// a NULL link here does not mean an inconsistency, it just means that there is 
					// no value here; so only if there is a link a nogood should be added
					// (no value consistency checking required here because a value and a link
					// inconsistent types)
					if ((*in_it)->getFSLinkLink() != NULL)
						ret_nogoods.push_back(ContextManager::getUnion((*self_it)->bcontext, (*in_it)->bcontext));
				}
			}
			else	// an fs link or a NULL link
			{
				P_FStructure* self_FS;
				self_FS = (*self_it)->getFSLinkLink();
				// if it is a NULL link then it will not be inconsistent with anything
				if (self_FS != NULL)
				{
					// now check type for in_it
					if (!(*in_it)->zeroValue())	// then it is inconsistent
						ret_nogoods.push_back(ContextManager::getUnion((*self_it)->bcontext, (*in_it)->bcontext));
					else
					{
						current_nogoods = self_FS->isConsistentWithFS((*in_it)->getFSLinkLink());
						if (!current_nogoods.empty())
						{
							// need to take list of nogoods and add the union of the contexts obtained
							// at this level to each before adding those nogoods to this f-structure
							// (i.e., nogoods need to be modified before they are ready for use)
							for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
							{	
								union_expr = ContextManager::getUnion((*self_it)->bcontext, (*in_it)->bcontext);
								//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
								//	(*cur_ng_it).push_back(*union_it);
								ret_nogoods.push_back(ContextManager::getUnion(*cur_ng_it,union_expr));
							}
						}
					}
				}
			}
		}
	}
		
	return ret_nogoods;
}

P_FStructure* P_FSItemComplex::getInstConstAttrLink(void)
{
	return getAttrLink();
}

P_FStructure* P_FSItemComplex::getAttrLink(void)
// always returns null because this is not an inst const and does not have an attr link
{
	return NULL;
}
P_FSItem * P_FSItemComplex::getSolution(list<contextByte> & solution)
{
	//list<P_FSItem*>::iterator item_it;
	P_FSItem* item;
	bool is_valid = false;

	item = new P_FSItemComplex;
	item->attribute = attribute;
	((P_FSItemComplex *)item)->attribute_type = attribute_type;
	list<contextByte> added_contexts;
	list<contextByte>::iterator it2;
	P_FStructure* fs_sol;
	for(list<P_ContextedValue*>::iterator valit=contexted_values.begin();valit!=contexted_values.end();valit++)
	{
		if(IsSubset((*valit)->context, solution))
		{
			is_valid = true;
					
			P_FStructure* fs = (*valit)->getFSLink();
			if(fs)
			{
				//if(!(*valit)->zeroValue())//(P_FSSymbolTable::isIsolatedFS(attribute)||
				/**/if(attribute && fs->solutions.size() )
				{
					fs_sol = fs->extractSolution(solution);
				}
				else
				/**/	fs_sol = fs->extractSolutionDeep(solution);
				P_ContextedValue * new_value = new P_ContValFSLink(fs_sol, 0);
				new_value->context = (*valit)->context;
				new_value->bcontext = (*valit)->bcontext;
				((P_FSItemComplex *)item)->contexted_values.push_back(new_value);
			}
			else
			{
				((P_FSItemComplex *)item)->contexted_values.push_back(*valit);
			}
		}
		else
		{
			added_contexts = UnknowContexts((*valit)->context, solution);
			if(!added_contexts.empty())
			{
				/*for ( it2 = added_contexts.begin(); it2 != added_contexts.end(); it2++)
				{
					solution.push_back(*it2);
				}*/
				list<contextByte> temp_solution=getUnion(solution,added_contexts);
				if(IsSubset((*valit)->context, temp_solution))
				//if(IsSubset((*valit)->context, solution))
				{
					is_valid = true;
					
					P_FStructure* fs = (*valit)->getFSLink();
					if(fs)
					{
						//if(!(*valit)->zeroValue())//(P_FSSymbolTable::isIsolatedFS(attribute)||
				/**/	if(attribute && fs->solutions.size() )
						{
							fs_sol = fs->extractSolution(solution);
						}
						else/**/
							fs_sol = fs->extractSolutionDeep(solution);
						P_ContextedValue * new_value = new P_ContValFSLink(fs_sol, 0);
						new_value->context = (*valit)->context;
						new_value->bcontext = (*valit)->bcontext;
						((P_FSItemComplex *)item)->contexted_values.push_back(new_value);
					}
					else
					{
						((P_FSItemComplex *)item)->contexted_values.push_back(*valit);
					}
				}
			}
		}
	}
	if(!is_valid)
	{
		delete item;
		item = NULL;
	}
	return item;
}
void P_FSItemComplex::makeLinksNull(void)
// go through all your items and make the links NULL 
{
	list<P_ContextedValue*>::iterator it;
	for (it = contexted_values.begin(); it != contexted_values.end(); it++)
		(*it)->makeLinksNull();
}

void P_FSItemComplex::resetElementNo(void)
{
	element_no = 1;
}

void P_FSItemComplex::removeAllValues(void)
{
	contexted_values.clear();
}
void P_FSItemComplex::verifySolution(list<contextByte> & solution)
{
	/*ADDED IN THIS (LINUX ONLY) VERSION*/
	bitwiseContext objBC1;	
	list<contextByte> objlistCB1;
	list<contextByte> objlistCB2;
	/*ADDED IN THIS (LINUX ONLY) VERSION*/

	list<contextByte> added_contexts;
	list<contextByte>::iterator it2;
	list<P_ContextedValue*>::iterator temp_it;

	for(list<P_ContextedValue*>::iterator valit=contexted_values.begin();valit!=contexted_values.end();)
	{
		/* CHANGED IN THIS (LINUX ONLY) VERSION
		if( !ContextManager::opposingContextsPresent((*valit)->bcontext, ContextManager::convertListTobitwiseContext(solution) ) )
		CHANGED IN THIS (LINUX ONLY) VERSION */
		objBC1 = ContextManager::convertListTobitwiseContext(solution) ;
		if( !ContextManager::opposingContextsPresent((*valit)->bcontext, objBC1 ) )
		{
			/* CHANGED IN THIS (LINUX ONLY) VERSION
			added_contexts = UnknowContexts( ContextManager::convertbitwiseContextToList((*valit)->bcontext), solution);
			CHANGED IN THIS (LINUX ONLY) VERSION */
			objlistCB1 = ContextManager::convertbitwiseContextToList((*valit)->bcontext) ;
			added_contexts = UnknowContexts( objlistCB1 , solution);
			if(!added_contexts.empty())
			{
				for ( it2 = added_contexts.begin(); it2 != added_contexts.end(); it2++)
				{
					solution.push_back(*it2);
					#ifdef GenLog
					CLogManager::AddMessage(L"Context added: "+Convert_str2wstr(int2string(*it2)));
					#endif
				}
			}
			P_FStructure* fs = (*valit)->getFSLink();
			if(fs)
			{
				fs->verifySolution(solution);
			}
			valit++;
		}
		else
		{
			/* CHANGED IN THIS (LINUX ONLY) VERSION
			added_contexts = UnknowContexts( ContextManager::convertbitwiseContextToList((*valit)->bcontext) , solution);
			CHANGED IN THIS (LINUX ONLY) VERSION */
			objlistCB2 = ContextManager::convertbitwiseContextToList((*valit)->bcontext) ;
			added_contexts = UnknowContexts( objlistCB2 , solution);
			if(!added_contexts.empty())
			{
				for ( it2 = added_contexts.begin(); it2 != added_contexts.end(); it2++)
				{
					solution.push_back(-*it2);
					#ifdef GenLog
					CLogManager::AddMessage(L"Context added: "+Convert_str2wstr(int2string(-*it2)));
					#endif
				}
			}
			temp_it = valit;
			valit++;
			contexted_values.erase(temp_it);
			//if(valit!=contexted_values.begin())
			//	valit--;
		}
	}
	
}

void P_FSItemComplex::Dump(short * Buffer,int & Bindex)
{
	Buffer[++Bindex] = 2;	// For P_FSItemComplex
	Buffer[++Bindex] = this->attribute_type;	
	Buffer[++Bindex] = contexted_values.size();

	P_ContextedValue* temp;
	for(list<P_ContextedValue*>::iterator i=contexted_values.begin();i!=contexted_values.end();i++)
	{
		temp = *i;
		temp->Dump(Buffer,Bindex);
	}

}

void P_FSItemComplex::Load(short * Buffer,int & Bindex)
{
//	Buffer[++Bindex] = 2;	// For P_FSItemComplex
	this->attribute_type=Buffer[++Bindex];	
	contexted_values.resize(Buffer[++Bindex]);
	P_ContextedValue* temp;

/*
		hERE I M, NEED TO DECIDE WHAT TO DO
*/

	for(list<P_ContextedValue*>::iterator i=contexted_values.begin();i!=contexted_values.end();i++)
	{
		/*
		HERE coNDITIONS
		*/		
		int choice = Buffer[++Bindex];

		switch(choice)
		{
		case 1:
			temp = new P_ContValFSLink();

			break;
		case 2:
			temp = new P_ConValFDLink();
			break;
		case 3:
			temp = new P_ConValPlainVal();

			break;
		case 4:
			temp = new P_ConValPlainValList();

		}
		temp->Load(Buffer,Bindex);

		*i=temp;
	}

}
