#pragma once

/*ADDED IN THIS (LINUX) VERSION*/
#ifndef P_FSITEMCOMPLEX_H
#define P_FSITEMCOMPLEX_H
/*ADDED IN THIS (LINUX) VERSION*/

#include "P_FSItem.h" /*CHANGED IN THIS (LINUX) VERSION*/

#include "fsglobal.h"
#include "P_ContextedValue.h"
#include "P_ContValFSLink.h"
#include "P_FSSymbolTable.h"

#include <list>
#include <string>
#include <stdlib.h> 

using namespace std;

class P_FSItemComplex :
	public P_FSItem
{
public:
	P_FSItemComplex(void);
	P_FSItemComplex(P_FSItemComplex* complex_item);	
//	P_FSItemComplex(P_FSItemSimple* simple_item);
	~P_FSItemComplex(void);

	byte attribute_type;
	list<P_ContextedValue*> contexted_values;
	P_FSItem* makeOpNotEq(void);
	P_FSItem* insertContext(list<contextByte> context_list);
	P_FSItem* makeCopy(void);
	bool addContextedValue(P_ContextedValue* contexted_value);
	int numberOfValues(void);
	bool operator==(P_FSItem* right_item);
	PFSsymID getSimpleValue(void);
	byte getAttributeType(void);
	bool containsContextedValue(P_ContextedValue* contexted_val);
	void printItem(ofstream &myfile);
	bool eqMergeInto(P_FSItem* fs_item);
	bool setMergeInto(P_FSItem* fs_item);
	bool eqcMergeInto(P_FSItem* fs_item);
	bool noteqMergeInto(P_FSItem* fs_item);
	bool eqcDownMergeInto(P_FSItem* fs_item);
	bool noteqDownMergeInto(P_FSItem* fs_item);
	P_FSItem* instantiate(contextByte context_offset, P_FStructure* up_arrow, P_FStructure* down_arrow);
	P_FSItem* instantiate(contextByte context_offset, P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows);
	P_FSItem* getItemForFS(void);
	P_FSItem* getConstraintForFS(void);
	P_FSItem* getLinkForFS(void);
	list<P_ContextedValue*> getContextedValues(void);
	//string getHeadOfComplexAttr(string& attr_symbol);
	void makeFStructure(P_FStructure* fs, string attr, P_ContextedValue* in_value);
	//list< list<contextByte> > isConsistent(void);
	//list< list<contextByte> > isConsistentWithItem(P_FSItem* in_item);

	list< bitwiseContext > isConsistent(void);//new
	list< bitwiseContext > isConsistentWithItem(P_FSItem* in_item);//new

	virtual P_FSItem * getSolution(list<contextByte> & solution);
	virtual void verifySolution(list<contextByte> & solution);
	P_FStructure* getInstConstAttrLink(void);
	virtual P_FStructure* getAttrLink(void);
	void makeLinksNull(void);
	void resetElementNo(void);
	virtual void Dump(short* Buffer,int& Bindex);
	virtual void Load(short* Buffer,int& Bindex);
private:
	static short element_no;
public:
	void removeAllValues(void);
};
#endif /*ADDED IN THIS (LINUX) VERSION*/