#include "stdafx.h"
#include "P_FSItemSimple.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_FSItemSimple::P_FSItemSimple(void)
{
}

P_FSItemSimple::P_FSItemSimple(P_FSItemSimple* simple_item)
{
	this->attribute = simple_item->attribute;
	this->value = simple_item->value;
}

P_FSItemSimple::~P_FSItemSimple(void)
// has no pointers so no deletes required
{
}

P_FSItem* P_FSItemSimple::makeOpNotEq(void)
{
	// make new P_FSItemComplex and return it
	P_FSItem* fs_item;
	P_FSItemComplex* complex_item;
	complex_item = new P_FSItemComplex();
	P_ConValPlainVal* val;
	val = new P_ConValPlainVal();
	
	complex_item->attribute_type = OPNOT;	// rest of the bits set to zero
	complex_item->attribute = this->attribute;
	val->value = this->value;
	complex_item->contexted_values.push_back(val);
	fs_item = complex_item;

	return fs_item;
}

P_FSItem* P_FSItemSimple::insertContext(list<contextByte> context_list)
{
	// context is 0; make no change
	if ( (context_list.size() == 1) && (context_list.back() == 0) )
	{
		// make new item to return
		P_FSItem* fs_item; 
		P_FSItemSimple* simple_item = new P_FSItemSimple(this);
		fs_item = simple_item;
		return fs_item;
	}

	else
	{
		P_FSItem* fs_item;
		P_FSItemComplex* complex_item;
		P_ConValPlainVal* plain_val;

		complex_item = new P_FSItemComplex();
		plain_val = new P_ConValPlainVal();

		plain_val->value = this->value;
		plain_val->context = context_list;
		
		complex_item->contexted_values.push_back(plain_val);
		complex_item->attribute = this->attribute;
		complex_item->attribute_type = 0;	// ^attribute=

		fs_item = complex_item;

		return fs_item;
	}
}

P_FSItem* P_FSItemSimple::makeCopy(void)
{
	P_FSItem* fs_item;
	P_FSItemSimple* copy;
	copy = new P_FSItemSimple();

	copy->attribute = this->attribute;
	copy->value = this->value;

	fs_item = copy;

	return fs_item;
}

bool P_FSItemSimple::addContextedValue(P_ContextedValue* cont_val)
{
	// does nothing because it is not expected to add anything; returns false to indicate that it
	// hasn't added incase it is called; it is not expected that this will ever be called
	return false;
}

int P_FSItemSimple::numberOfValues(void)
{
	return 1;	// always has one value
}

bool P_FSItemSimple::operator==(P_FSItem* right_item)
{
	if (right_item->attribute != this->attribute)
		return false;

	if (right_item->getSimpleValue() != this->value)
		return false;
	
	return true;
}

PFSsymID P_FSItemSimple::getSimpleValue(void)
{
	return this->value;
}

byte P_FSItemSimple::getAttributeType(void)
{
	return 0;	// ^attribute =
}

bool P_FSItemSimple::containsContextedValue(P_ContextedValue* contexted_val)
{
	return false;	// never contains a contexted value
}

void P_FSItemSimple::printItem(ofstream &myfile)
{
	myfile << "Printing P_FSItemSimple:\n";
	myfile << "attribute = " << (int)this->attribute << "\n";
	myfile << "value = " << (int)this->value << "\n";
}

bool P_FSItemSimple::eqMergeInto(P_FSItem* fs_item)
// will always get the correct type of fs_item (^attribute =)
{
	P_ContextedValue* cont_val;
	
	P_ConValPlainVal* plain_val;
	plain_val = new P_ConValPlainVal();
	plain_val->value = this->value;
	plain_val->context.push_back(0);

	cont_val = plain_val;

	fs_item->addContextedValue(cont_val);
	
	return true;	// to indicate that something has been added
}

bool P_FSItemSimple::setMergeInto(P_FSItem* fs_item)
// fs_item is always of type (^attribut $)
{
	// don't do anything and always return false beacuse a P_FSItemSimple can only have the "=" operator
	// and is therefore not a legal merge
	return false;
}

bool P_FSItemSimple::eqcMergeInto(P_FSItem* fs_item)
// fs_item is always of type (^attribut =c)
{
	// don't do anything and always return false beacuse a P_FSItemSimple can only have the "=" operator
	// and is therefore not a legal merge
	return false;
}

bool P_FSItemSimple::noteqMergeInto(P_FSItem* fs_item)
// fs_item is always of type (^attribut !=)
{
	// don't do anything and always return false beacuse a P_FSItemSimple can only have the "=" operator
	// and is therefore not a legal merge
	return false;
}

bool P_FSItemSimple::eqcDownMergeInto(P_FSItem* fs_item)
// fs_item is always of type (!attribut =c)
{
	// don't do anything and always return false beacuse a P_FSItemSimple can only have the "=" operator
	// and is therefore not a legal merge
	return false;
}

bool P_FSItemSimple::noteqDownMergeInto(P_FSItem* fs_item)
// fs_item is always of type (!attribut !=)
{
	// don't do anything and always return false beacuse a P_FSItemSimple can only have the "=" operator
	// and is therefore not a legal merge
	return false;
}

P_FSItem* P_FSItemSimple::instantiate(contextByte context_offset, P_FStructure* up_arrow, P_FStructure* down_arrow)
// instantiated version will be the same therefore just make a copy and return it
{
	return makeCopy();
}

P_FSItem* P_FSItemSimple::getItemForFS(void)
// always returns a copy of itself
{
	//return makeCopy();
	return this;
}

P_FSItem* P_FSItemSimple::getConstraintForFS(void)
// (DONE) always returns NULL because it can never be a constraint; operator is assumed to be "="
{
	return NULL;
}

P_FSItem* P_FSItemSimple::getLinkForFS(void)
// (DONE) always returns NULL because it cannot hold a link value
{
	return NULL;
}

list<P_ContextedValue*> P_FSItemSimple::getContextedValues(void)
// is not expected to be called; should return nothing (empty list)
// CHANGING 07-01-06 (DOING UNIFICATION): MIGHT BE CALLED THEREFORE MAKE AN ITEM, PUT IN LIST AND RETURN
{
	
	list<P_ContextedValue*> ret_values;
	P_ContextedValue* cont_val;
	P_ConValPlainVal* plain_val;
	
	plain_val = new P_ConValPlainVal();
	plain_val->context.push_back(0);
	plain_val->bcontext.setSize(3);
	plain_val->value = value;
	
	cont_val = plain_val;
	ret_values.push_back(cont_val);
	return ret_values;
}

P_FSItem* P_FSItemSimple::instantiate(contextByte context_offset, P_FStructure* up_arrow, vector<P_ContextedValue*> down_arrows)
// instantiated version will be the same therefore just make a copy and return it
{
	return makeCopy();
}

list< bitwiseContext > P_FSItemSimple::isConsistent(void)
// (DONE) returns an empty list because this will always be consistent and there will be no nogoods
{
	return list< bitwiseContext >();
}

list< bitwiseContext > P_FSItemSimple::isConsistentWithItem(P_FSItem* in_item)
// the incoming thing here is always an item from fs_items (i.e. not a ^=!);
// opposing contexts cannot be present here therefore always check consistency;
// attributes have already been matched so only check values;
{
	list< bitwiseContext > ret_context;
	bitwiseContext current_context;
	
	// make a P_ContextedValue for the P_FSItemSimple and check it's consistency with each value in in_item
	P_ConValPlainVal* plain_val;
	
	plain_val = new P_ConValPlainVal();
	plain_val->context.push_back(0);
	plain_val->value = this->value;
	// now we have a value corresponding to a simple item
	
	// need to iterate through all in_items and see if they're consistent with the above value;
	// check for all, do not find opposing pairs (see above)
	list<P_ContextedValue*> val_list;
	list<P_ContextedValue*>::iterator val_list_it;
	val_list = in_item->getContextedValues();
	
	for (val_list_it = val_list.begin(); val_list_it != val_list.end(); val_list_it++)
	{
		if ((*val_list_it)->getFSLinkLink() != NULL)	
		{
			// then it is inconsistent because a value cannot be consistent with a link
			current_context = ContextManager::getUnion(plain_val->bcontext, (*val_list_it)->bcontext);
			ret_context.push_back(current_context);
		}
		else
		{
			if (!plain_val->isConsistent(*val_list_it))
			{
				current_context = ContextManager::getUnion(plain_val->bcontext, (*val_list_it)->bcontext);
				ret_context.push_back(current_context);
				#ifdef GenLog
				wstring att=Convert_str2wstr( P_FSSymbolTable::getSym(attribute) );
				CLogManager::AddMessage(att+L"is not consistent");
				LogContextByteList( ContextManager::convertbitwiseContextToList(current_context) );
				#endif GenLog
			}	
		}
	}
	return ret_context;
}

P_FSItem* P_FSItemSimple::getSolution(list<contextByte> &solution)
// instantiated version will be the same therefore just make a copy and return it
{
    return makeCopy();
}
void P_FSItemSimple::verifySolution(list<contextByte> &solution)
{
    return;
}
P_FStructure* P_FSItemSimple::getInstConstAttrLink(void)
// always null because this is never a constraint
{
	return NULL;
}

void P_FSItemSimple::makeLinksNull(void)
// has no links so do nothing
{
}

void P_FSItemSimple::removeAllValues(void)
{
	// should never be called so does nothing; is meant only for P_FSItemComplexInstConst
}

void P_FSItemSimple::Dump(short* Buffer,int & Bindex)
{
	Buffer[++Bindex] = 1;	// For P_FSItemSimple
	Buffer[++Bindex] = this->value;	// thats it
}

void P_FSItemSimple::Load(short* Buffer,int & Bindex)
{
//	Buffer[++Bindex] = 1;	// For P_FSItemSimple
	this->value=Buffer[++Bindex];	// thats it
}