#include "stdafx.h"
#include "P_FSSymbolTable.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "CConfiguration.h"
#include <fstream>

string* P_FSSymbolTable::symbol_table;
bool P_FSSymbolTable::initialization_complete;
short* P_FSSymbolTable::temp_entries;

P_FSSymbolTable::P_FSSymbolTable(void)
{
}

P_FSSymbolTable::~P_FSSymbolTable(void)
{
}

//##########TAHIRA#############
PFSsymID P_FSSymbolTable::GFID;	//(by me)
PFSsymID P_FSSymbolTable::PredID;
PFSsymID P_FSSymbolTable::IndexID;
list<PFSsymID> P_FSSymbolTable::Subcats;	//(by me)
//##########TAHIRA#############

PFSsymID P_FSSymbolTable::getSymID(string symbol)
// if symbol exists return its ID, else insert symbol and return it's ID
{
	#ifdef GenLog 
	ofstream myfile;
	myfile.open("SYMBOLTABLE.txt", ios::app);
	#endif

	PFSsymID index;
	bool found = false;
	index = hash(symbol);

	if (symbol_table[index].compare("") == 0)	// there is no entry
	{
		symbol_table[index] = symbol;
		#ifdef GenLog 
		myfile << symbol << "\n";
		#endif
		if (initialization_complete)
			addTempIndex(index);
		return (index + 1);	// +1 because 0 should never be assigned
	}

	else
	// either the symbol is in the hashed index or it needs to be searched
	{
		if (symbol_table[index].compare(symbol) == 0)
			return (index + 1);	// +1 because 0 should never be assigned
		
		else
		{
			/*for (int i = index; i < FSSYMBOLTABLESIZE; i++) CHANGED IN THIS (LINUX) VERSION*/
			int i;
			for (i = index; i < FSSYMBOLTABLESIZE; i++)
			{
				if (symbol_table[i].compare(symbol) == 0)
				{	
					found = true;
					break;
				}
				if (symbol_table[i].compare("") == 0)
					break;
			}
			if (found)
				return (i + 1);
			
			else	// need to check if we've reached the end of the symbol table
			{
				if (i < FSSYMBOLTABLESIZE)
				{
					symbol_table[i] = symbol;
					#ifdef GenLog 
					myfile << symbol << "\n";
					#endif
					if (initialization_complete)
						addTempIndex(i);
					return (i + 1);
				}
				else
				{
					for (int j = 0; j < FSSYMBOLTABLESIZE; j++)	// start search from begining
					{
						if (symbol_table[j].compare(symbol) == 0)
							return (j + 1);
						if (symbol_table[j].compare("") == 0)	// empty slot, entry doesn't exist
						{
							symbol_table[j] = symbol;
							#ifdef GenLog 
							myfile << symbol << "\n";
							#endif
							if (initialization_complete)
								addTempIndex(j);
							return (j + 1);
						}
					}
					// symbol table full
					//MessageBox(NULL, L"FS symbol table full.", L"FS symbol table full.", MB_ICONINFORMATION);
				}
			}
		}
	}
	#ifdef GenLog 
	myfile.close();
	#endif
}

string P_FSSymbolTable::getSym(PFSsymID symbol)
{
	if(symbol>0 && symbol<=FSSYMBOLTABLESIZE)
		return symbol_table[symbol - 1];
	else
		return "";
}

PFSsymID P_FSSymbolTable::hash(string key, int size)
{
	unsigned long h = 0, a = 31415, b = 27183;
	//PFSsymID h = 0, a = 31415, b = 27183;
	if (size > 1)
	{
		if(size > 0)
		{
			for(int i = 0; i < key.size(); i++, a = a*b%(size - 1))
			{
				h = (a*h + key[i]) % (size);
			}
		}
	}
	else
		h = 0;
	
	return h;
}
void P_FSSymbolTable::init(void)
{
	symbol_table = new string[FSSYMBOLTABLESIZE];	// stored in byte - changed 25-01-06: now in short 
	initialization_complete = false;
	//##########TAHIRA#############
	GFID=getSymID("GF"); //(by me)
	PredID=getSymID("PRED"); //(by me)
	IndexID=getSymID("INDEX"); //(by me)
	LoadSubcats();//read subcats...yet to be done......done now
	//##########TAHIRA#############
}

void P_FSSymbolTable::LoadSubcats(void)
{
string SubCatFrameListFName = CConfiguration::GetConfigInfo("SubCatFrameListFileName");
fstream subcatfile;
subcatfile.open(SubCatFrameListFName.c_str());
string PosSym="";
wchar_t ch;
subcatfile.read((char*)&ch,2);
char smallch;
while(!subcatfile.eof())
{
	subcatfile.read((char*)&ch,2);
	/*if(ch==',')CHANGED IN THIS (LINUX) VERSION*/
	if((char)ch==',')
	{
		Subcats.push_back(getSymID(PosSym));
		PosSym="";
	}
	else
	{
		smallch=ch;
		//if (smallch >= 'A' && smallch <= 'Z')
		PosSym.push_back(smallch);
	}
}
	Subcats.push_back(getSymID(PosSym));
	Subcats.sort();
}
void P_FSSymbolTable::printSymbolTable(ofstream& myfile)
{
	myfile << "Printing symbol_table:\n";

	for (int i = 0; i < FSSYMBOLTABLESIZE; i++)
	{
		myfile << i+1 << " " << symbol_table[i] << "\n";
	}
	myfile << "\n";
}

void P_FSSymbolTable::endInitialization(void)
{
	initialization_complete = true;
	temp_entries = new short[TEMPSTENTRIES];	// to store index values for all the temp entries
	for (int i = 0; i < TEMPSTENTRIES; i++)
		temp_entries[i] = -1;	// because an actual entry may be zero
}

void P_FSSymbolTable::addTempIndex(int index)
{
	/*for (int i = 0; i < TEMPSTENTRIES; i++)CHANGED IN THIS (LINUX) VERSION*/
	int i;
	for (i = 0; i < TEMPSTENTRIES; i++)
	{
		if (temp_entries[i] == -1)
			break;
	}
	temp_entries[i] = index;
}

void P_FSSymbolTable::collectSelectiveGarbage(void)
{
	// delete all the temp entries from the symbol table and re-initialize temp entry index array
	int i = 0;
	while (temp_entries[i] != -1)
	{
		symbol_table[temp_entries[i]] = "";
		temp_entries[i] = -1;
		i++;
	}
}

bool P_FSSymbolTable::isIsolatedFS(PFSsymID att)
{
	//for(list<PFSsymID>::iterator it=Subcats.begin();it!=Subcats.end();it++)
	//	if((*it)==att)
	//		return true;

	string att_str=getSym(att);
	if(att_str=="PARTICIPLE"||att_str=="INFINITIVE"||att_str=="XCOMP"||att_str=="COMP"||att_str=="SUBORD"||att_str=="COMPARITIVE"||att_str=="REL_CL"||att_str=="RESTRICTIVE_NP")//||att_str.substr(0,7) == "ELEMENT")//[OBL and adjunct fight in <subj,obj,obl>]//
		return true;

	return false;
}

void P_FSSymbolTable::Dump_SymbolTable()
{
	FILE* fwriter=fopen(CConfiguration::GetConfigInfo("SymbolTableDumpFile").c_str(),"wb");

	short* Buffer = new short[20*FSSYMBOLTABLESIZE];
	int Bindex=-1;
//	Writer<<FSSYMBOLTABLESIZE<<" ";
	


	for(int i=0;i<FSSYMBOLTABLESIZE;i++)
	{
		Buffer[++Bindex]=symbol_table[i].size();
		for(int sl=0;sl<symbol_table[i].size();sl++)
		{
			Buffer[++Bindex]=symbol_table[i][sl];
		}
	}

	size_t bytesRead = fwrite(Buffer,2,2*(Bindex+1),fwriter);

	fclose(fwriter);
	delete []Buffer;
}
void P_FSSymbolTable::Load_SymbolTable()
{
	FILE* fReader=fopen(CConfiguration::GetConfigInfo("SymbolTableDumpFile").c_str(),"rb");

	short * Buffer = new short[20*FSSYMBOLTABLESIZE];
	int Bindex=-1;
	size_t bytesRead = fread(Buffer,2,20*FSSYMBOLTABLESIZE,fReader);
		
//	bytesRead = fread(Buffer,2,20*FSSYMBOLTABLESIZE,fReader);

	int debug= 473;
	symbol_table = new string[FSSYMBOLTABLESIZE];

	for(int i=0;i<FSSYMBOLTABLESIZE;i++)
	{
		if(i==debug)
		{
			debug=debug;
		}
		symbol_table[i].resize(Buffer[++Bindex]);
		for(int sl=0;sl<symbol_table[i].size();sl++)
		{
			symbol_table[i][sl]=Buffer[++Bindex];
		}
	}

	delete []Buffer;
}
