#pragma once

/*ADDED IN THIS (LINUX) VERSION*/
#ifndef P_FSSYMBOLTABLE_H
#define P_FSSYMBOLTABLE_H
/*ADDED IN THIS (LINUX) VERSION*/

#include "fsglobal.h"

#include <string>
#include <fstream>

using namespace std;

class P_FSSymbolTable
{
public:
	P_FSSymbolTable(void);
	~P_FSSymbolTable(void);
	
	static void init(void);
	static PFSsymID getSymID(string symbol);
	static string getSym(PFSsymID symbol);
	static void printSymbolTable(ofstream& myfile);
	static void endInitialization(void);
	static void collectSelectiveGarbage(void);
	static bool isIsolatedFS(PFSsymID att);

	//##########TAHIRA#############	
	static PFSsymID GFID;	//(by me)GF will be called frequently whynot keep it out side
	static PFSsymID PredID;
	static PFSsymID IndexID;
	static list<PFSsymID> Subcats;	//(by me) it is to be loaded from file in init, not yet loaded
	static void LoadSubcats(void);
	//##########TAHIRA#############
private:
	static string* symbol_table;	// keeps symbols e.g., NUM, GEND, SUBJ NUM, etc.
									// symbolID is the index of the array (uses a hash function to enable 
									// 2-way access)
	static PFSsymID hash(string key, int size = FSSYMBOLTABLESIZE);	// hash function for symbol table
	static bool initialization_complete;
	static short* temp_entries;
	static void addTempIndex(int index);
public:
	static void Dump_SymbolTable();
	static void Load_SymbolTable();

};
#endif /*ADDED IN THIS (LINUX) VERSION*/