#include "stdafx.h"
#include "P_FStructure.h"
#include "SolutionTree.h"


bitwiseContext zero;
/* REMOVED FOR THIS (DOS/LINUX) VERSION
clock_t P_FStructure::start_time;
clock_t P_FStructure::max_time;
REMOVED FOR THIS (DOS/LINUX) VERSION */

list<list<contextByte> > new2oldContext(list<bitwiseContext> cont_list)
{
	list<list<contextByte> > ret_lists;
	list<contextByte> zero_list;zero_list.push_back(0);
	for(list<bitwiseContext>::iterator it=cont_list.begin();it!=cont_list.end();it++)
	{
		if( (*it)==zero )
			ret_lists.push_back(zero_list);
		else
			ret_lists.push_back(ContextManager::convertbitwiseContextToList(*it) );
	}
	
	return ret_lists;
}

 list<bitwiseContext> old2newContext(list<list<contextByte> > cont_list)
{
	list<bitwiseContext> ret_lists;
	for(list<list<contextByte> >::iterator it=cont_list.begin();it!=cont_list.end();it++)
		ret_lists.push_back(ContextManager::convertListTobitwiseContext(*it) );
	
	return ret_lists;
}

P_FStructure::P_FStructure(void)
{
	//zero.push_back(0);
	P_FSItemComplex* complex_item;
	complex_item = new P_FSItemComplex();
	complex_item->attribute = 0;
	complex_item->attribute_type = 0;

	links = complex_item;
	failed = false;
	cc_checked=false;
	conts_checked=false;
	nogoods_extracted=false;
	unified=false;
}

P_FStructure::~P_FStructure(void)
// take each item from items and constraints and delete them; also delete the link
{
	list<P_FSItem*>::iterator items_it, constraints_it;
	
	if (!fs_items.empty())
	{
		for (items_it = fs_items.begin(); items_it != fs_items.end(); items_it++)
			delete (*items_it);
	}
	if (!constraints.empty())
	{
		for (constraints_it = constraints.begin(); constraints_it != constraints.end(); constraints_it++)
			delete (*constraints_it);
	}
	if (links != NULL)
	{
		delete links;
		links = NULL;
	}
}	

void P_FStructure::addItem(P_FSItem* fs_item)
// this is only called when the P_FSItem is definitely an item, not a link or a constraint;
// if an item with the same attribute type exists, add only the new values to that, else put the whole
// item in;
// CHANGE (09-01-06): if the attribute is such that it requires a link on the value side then that attribute
// should have a link as it's value, and the f-structure that is pointed to by that link will contain
// the actual link values in the links variable;
// this implies that items such as ^SUBJ = !SUBJ will get stored such that the value link will be in
// the links of the newly created f-structure but the value part ("SUBJ") of !SUBJ will not be placed
// anywhere explicitly;
// the folowing are examples that qualify for this special treatment:
// 1) ^SUBJ = !SUBJ
// 2) ^SUBJ NUM = SG (which will have been transformed to ^SUBJ = ! at this point)
// (if there is a long chain like the one above then only the head will be treated this way, the rest of it
// will remain as originally built in instantiate)
// the folowing are examples that DO NOT qualify for this special treatment:
// 1) ^NUM = !NUM
// 2) ^NUM = SG
// STATUS OF CONTEXTS:
{
	P_FSItem* found_item;
	byte attr_byte = fs_item->getAttributeType();
	found_item = this->SearchInItemsUnordered(fs_item->attribute);
	
	
	if (found_item)
	{
		if(found_item!=fs_item)
		{
			if ((attr_byte & FSATTR) == 0)
			{
				// traverse through all values of item and add
				list<P_ContextedValue*> values;
				list<P_ContextedValue*>::iterator it;
				values = fs_item->getContextedValues();
				for (it = values.begin(); it != values.end(); it++)
					found_item->addContextedValue(*it);
			}
			else	// special treatment required
			{
				// find the value in the item that is the dummy fs pointing to an fs containing all the links
				// this should be the only value that is a link;
				list<P_ContextedValue*> found_vals;
				list<P_ContextedValue*>::iterator found_it;
				found_vals = found_item->getContextedValues();

				// also make the value that is to be inserted:
				for (found_it = found_vals.begin(); found_it != found_vals.end(); found_it++)
				{
					P_FStructure* dummy_fs;
					dummy_fs = (*found_it)->getFSLinkLink();
					if (dummy_fs != NULL)
					{
						list<P_ContextedValue*> in_vals;
						list<P_ContextedValue*>::iterator in_it;
						in_vals = fs_item->getContextedValues();
						for (in_it = in_vals.begin(); in_it != in_vals.end(); in_it++)
							dummy_fs->links->addContextedValue(*in_it);
						dummy_fs->resolveValueLinks();
						break;
					}
				}
			}
		}
		else
			int x=1;
	}
	else
	{
		if ((attr_byte & FSATTR) == 0)
			this->fs_items.push_back(fs_item);
		else	// special treatment required
		{
			// need to create the new fs that will be the value that is to be added
			P_FStructure* new_fs;
            new_fs = new P_FStructure();
		
			list<P_ContextedValue*> in_vals;
			list<P_ContextedValue*>::iterator in_it;
			in_vals = fs_item->getContextedValues();
			for (in_it = in_vals.begin(); in_it != in_vals.end(); in_it++)
				new_fs->links->addContextedValue(*in_it);
			
			// make a new item that will take the place of the one that is sent as parameter
			P_FSItem* new_item;
			P_FSItemComplex* new_complex;
			new_complex = new P_FSItemComplex();
			new_complex->attribute = fs_item->attribute;
			new_complex->attribute_type = fs_item->getAttributeType();
			// prep value
			P_ContextedValue* cont_val;
			P_ContValFSLink* link_val;
			link_val = new P_ContValFSLink();
			link_val->bcontext=zero;//.push_back(0);	// ! setting context to zero 
			new_fs->resolveValueLinks();
			link_val->link = new_fs;
			link_val->value = 0;
			link_val->value_type = 0;
			cont_val = link_val;

			// add new value to new item
			new_complex->addContextedValue(cont_val);
			new_item = new_complex;

			this->fs_items.push_back(new_item);
			
		}
	}
}

void P_FStructure::addConstraint(P_FSItem* constraint)
// this is only called when the P_FSItem is definitely a constraint, not an item or a link;
// if an item with the same attribute type exists, add only the new values to that, else put the whole
// item in;
{
	P_FSItem* found_item;
	found_item = this->SearchInConstraintsUnordered(constraint->attribute);
	
	if (found_item && (found_item->getAttributeType() == constraint->getAttributeType()))
	{
		// traverse through all values of item and add
		list<P_ContextedValue*> values;
		list<P_ContextedValue*>::iterator it;
		values = constraint->getContextedValues();
		for (it = values.begin(); it != values.end(); it++)
		{
			found_item->addContextedValue(*it);
		}
	}
	else
		this->constraints.push_back(constraint);
}

void P_FStructure::addLink(P_FSItem* link)
// this is only called when the P_FSItem is definitely a link ("^=!" only ), not an item or a constraint;
// if an item with the same attribute type exists, add only the new values to that, else put the whole
// item in; here since the attribute is always the same (i.e. nothing), the value will always be added to
// the item
{
		// traverse through all values of item and add
		list<P_ContextedValue*> values;
		list<P_ContextedValue*>::iterator it;
		values = link->getContextedValues();
		for (it = values.begin(); it != values.end(); it++)
			links->addContextedValue(*it);
}

void checkDownArrowConstraints(P_FStructure *FS, bitwiseContext ext_context)
{


    // doing stuff like ^constraint = x or !constraint = y: therefore get the attribute link and 
	// make a call for that link sending the constraint as parameter to the function below:
	if(1)
	{
		list<P_FSItem*>::iterator constraint_it;
		P_FStructure* constattr_link;
		list< bitwiseContext > returned_nogoods;
		list< bitwiseContext >::iterator ng_it;
		list<P_ContextedValue*>::iterator link_val_it; 
		list<bool*> FoundFlags;
		list<bool*>::iterator flag_it;
		list<P_ContextedValue*> constvals;
		list<P_ContextedValue*>::iterator constvals_it; 
		bool* flag_ptr;
		
		byte operator_check;
		for (constraint_it = FS->constraints.begin(); constraint_it != FS->constraints.end(); constraint_it++)
		{

			operator_check = (*constraint_it)->getAttributeType() & DOWNARROWATTR;
			if(operator_check==0)
				continue;

			FoundFlags.clear();
			constvals=(*constraint_it)->getContextedValues();
			//FoundFlags.resize(constvals.size(),false);
			for (int i = 0; i < constvals.size(); i++)
			{
				flag_ptr = new bool;
				*flag_ptr = false;
				FoundFlags.push_back(flag_ptr);
			}
			constattr_link = (*constraint_it)->getInstConstAttrLink();
			returned_nogoods = constattr_link->checkConstraint(*constraint_it,FoundFlags);

			#ifdef GenLog
			if(returned_nogoods.size())
			{
				CLogManager::AddMessage(L"Nogoods for constraint failure");
			}
			#endif

			for (ng_it = returned_nogoods.begin(); ng_it != returned_nogoods.end(); ng_it++)
				FS->addNogood(*ng_it);
			
			// only need to use the flags if he constraint is '=c', not when it is !=
			operator_check = (*constraint_it)->getAttributeType() << 3;
			if (operator_check == 128)	// =c, 10 000 000
			{
				for(constvals_it=constvals.begin(),flag_it=FoundFlags.begin();constvals_it!=constvals.end();constvals_it++,flag_it++)
				{
					if( !(*(*flag_it)) )
					{
							#ifdef GenLog
							wstring msg=L"Constraint:   ";
							msg+=L"!";
							msg+=Convert_str2wstr(P_FSSymbolTable::getSym((*constraint_it)->attribute));
							msg+=L"=c";
							msg+=Convert_str2wstr( (*constvals_it)->getValString() );
							msg+=L"   failed.    NOT FOUND";
							CLogManager::AddMessage(msg);
							#endif

							FS->addNogood((*constvals_it)->bcontext);
					}
				}
			}
		}		
	}
}


void P_FStructure::unify(void)
// 3 things are to be done here:
// 1. check if each fsitem from the list fs_items is consistent within itself;
// 2. check if each item in the list fs_items is consistent with each link in the list links
// 3. check if each link in list links is consistent with all the other links in the list
{
	if(!unified && !failed)
	{
	checkItemsConsistency();
	checkItemsLinksConsistency();
	checkLinkLinksConsistency();
	list<P_ContextedValue*> link_values = links->getContextedValues();
	list<P_ContextedValue*>::iterator link_val_it; 
	for (link_val_it = link_values.begin(); link_val_it != link_values.end(); link_val_it++)
	{	
		P_FStructure* lnk;
		lnk = (*link_val_it)->getFSLinkLink();
		if(lnk->failed)
		{
			addNogood((*link_val_it)->bcontext);
			#ifdef GenLog
			CLogManager::AddMessage(L"link failed during unification");
			LogContextByteList( ContextManager::convertbitwiseContextToList((*link_val_it)->bcontext) );
			#endif
		}
	}
	
	checkDownArrowConstraints(this,zero);

	if(!nogoods.empty())
	{
		//first_solution = getSolution(nogoods);
		first_solution = makesolution( new2oldContext(nogoods) );
		if(first_solution.empty())
			failed = true;
		else 
			failed = false;
	}
	else 
		failed = false;

	unified=true;
	}	

}

bool isValidNogood(bitwiseContext nogood)
{
	/*int neg[256]={0};
	int pos[256]={0};
	for(bitwiseContext::iterator it=nogood.begin();it!=nogood.end();it++)
	{
		if((*it)>0)
		{
			if(neg[*it]==1)
				return false;
			else
				pos[*it]=1;
		}
		else if((*it)<0)
		{
			if(pos[-(*it)]==1)
				return false;
			else
				neg[-(*it)]=1;
		}
	}*/
	return ContextManager::isValidContext(nogood);
}

void P_FStructure::addNogood(bitwiseContext nogood)
{
	if(isValidNogood(nogood))
	{
		//nogood.unique();
		list<bitwiseContext >::iterator it=nogoods.begin();
		while(it!=nogoods.end())
		{
			if(nogood==(*it))
				return;
			it++;
		}
		#ifdef GenLog
		LogContextByteList( ContextManager::convertbitwiseContextToList(nogood) );
		#endif
		nogoods.push_back(nogood);
	}
}

list< bitwiseContext > P_FStructure::isConsistentWithItem(P_FSItem* in_item)
// 1. check the fs_item with the element of list fs_items that matches it's attribute
// 2. checks the fs_item with all the f-structures in links
{
	/* REMOVED FOR THIS (DOS/LINUX) VERSION
	#ifndef DEBUG
	current_time = clock();
	if ((current_time - start_time)>max_time)
	{
		list< bitwiseContext > ret_nogoods;
		ret_nogoods.push_back(zero);
        return ret_nogoods;
	}
	#endif
	REMOVED FOR THIS (DOS/LINUX) VERSION*/
	list< bitwiseContext > ret_contexts;
	list< bitwiseContext > current_contexts;
	list< bitwiseContext >::iterator curr_it;
	
    // 1. do fs_items vs fs_item
	list<P_FSItem*>::iterator fsitems_it;
	for (fsitems_it = fs_items.begin(); fsitems_it != fs_items.end(); fsitems_it++)
	{
		if ((*fsitems_it)->attribute == in_item->attribute)
		{
			current_contexts = (*fsitems_it)->isConsistentWithItem(in_item);
			if( current_contexts.size()==1 && (*current_contexts.begin())==zero)
				return current_contexts;
			for (curr_it = current_contexts.begin(); curr_it != current_contexts.end(); curr_it++)
				ret_contexts.push_back(*curr_it);
		}
	}

	// 2.
	current_contexts.clear();	// clean up before re-using
	
	list<P_ContextedValue*> link_values;
	P_FStructure* a_link; 
	link_values = links->getContextedValues();
    bitwiseContext linkValCont;

	list<P_ContextedValue*>::iterator links_it;
	for (links_it = link_values.begin(); links_it != link_values.end(); links_it++)
	{
		a_link = (*links_it)->getFSLinkLink();
		current_contexts = a_link->isConsistentWithItem(in_item);
		for (curr_it = current_contexts.begin(); curr_it != current_contexts.end(); curr_it++)
		{
			linkValCont=(*links_it)->bcontext;
			//(*curr_it).merge(linkValCont);
			ret_contexts.push_back(ContextManager::getUnion(*curr_it,linkValCont));
		}
	}

	return ret_contexts;
}

void P_FStructure::checkItemsConsistency(void)
{
	// 1. go through all items to see if they're consistent
	list<P_FSItem*>::iterator fs_items_it;
	list< bitwiseContext > current_nogoods;
	list< bitwiseContext >::iterator curr_nogd_it;

	byte attr_byte;
	P_FStructure* dummy_fs;
	list<P_ContextedValue*> value_list;

	for (fs_items_it = fs_items.begin(); fs_items_it != fs_items.end(); fs_items_it++)
	{
		current_nogoods = (*fs_items_it)->isConsistent();
		if (!current_nogoods.empty())
		{
			for (curr_nogd_it = current_nogoods.begin(); curr_nogd_it != current_nogoods.end(); curr_nogd_it++)
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"items consistency failed:");
				#endif
				this->addNogood(*curr_nogd_it);
			}

		}

		// 13-02-06: change to accomodate the dummy f-structure (need to check the link)
		attr_byte = (*fs_items_it)->getAttributeType();
		if ((attr_byte & FSATTR) != 0)
		{	
			value_list = (*fs_items_it)->getContextedValues();
			dummy_fs = (value_list.front())->getFSLinkLink();
			dummy_fs->unify();
			
			if(dummy_fs->failed)
				addNogood(value_list.front()->bcontext);
		}	
	}
}

void P_FStructure::checkItemsLinksConsistency(void)
{
	// 2. go through all fs_items and for each, check with all links and see if they're consistent
	list < bitwiseContext > current_nogoods;
	bitwiseContext union_expr;
	list < bitwiseContext >::iterator cur_ng_it;
	//bitwiseContext::iterator union_it;

	list<P_FSItem*>::iterator fs_items_it;
		
	list<P_ContextedValue*> link_values = links->getContextedValues();
	list<P_ContextedValue*>::iterator link_val_it;

	bitwiseContext item_context, link_context; 
	
	list<P_ContextedValue*> temp_list;
	P_ContextedValue* temp_value;
	if (links->numberOfValues() > 0)
	{
		for (fs_items_it = fs_items.begin(); fs_items_it != fs_items.end(); fs_items_it++)
		{
			// if there is only one value in an item then only that needs to be checked;
			// otheriwse the required value(s) need to be extracted and checked
			if ((*fs_items_it)->numberOfValues() == 1)	// one value
			{
				temp_list =(*fs_items_it)->getContextedValues();
				temp_value = temp_list.front();
				item_context = temp_value->bcontext;
				//item_context = ((*fs_items_it)->getContextedValues()).front()->bcontext;		
			
				for (link_val_it = link_values.begin(); link_val_it != link_values.end(); link_val_it++)
				{	
					link_context = (*link_val_it)->bcontext;
					if (!ContextManager::opposingContextsPresent(item_context, link_context))
					{
						P_FStructure* lnk;
						lnk = (*link_val_it)->getFSLinkLink();
						if(lnk->failed)
							continue;
						current_nogoods = lnk->isConsistentWithItem(*fs_items_it);
						if (!current_nogoods.empty())
						{
							// need to take list of nogoods and add the union of the contexts obtained
							// at this level to each before adding those nogoods to this f-structure
							// (i.e., nogoods need to be modified before they are ready for use)
							for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
							{	
								union_expr = ContextManager::getUnion(item_context, link_context);
								//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
								//{
								//	(*cur_ng_it).push_back(*union_it);
								//}
								#ifdef GenLog
								CLogManager::AddMessage(L"items links consistency failed:");
								#endif
								addNogood(ContextManager::getUnion(*cur_ng_it,union_expr));
							}	
						}
					}
				}
			}
			if ((*fs_items_it)->numberOfValues() > 1)	// multiple values
			{
				list<P_ContextedValue*> item_vals = (*fs_items_it)->getContextedValues();
				list<P_ContextedValue*>::iterator item_vals_it;	
				for (item_vals_it = item_vals.begin(); item_vals_it != item_vals.end(); item_vals_it++)
				{
					item_context = (*item_vals_it)->bcontext;
				
					for (link_val_it = link_values.begin(); link_val_it != link_values.end(); link_val_it++)
					{	
						link_context = (*link_val_it)->bcontext;
						if (!ContextManager::opposingContextsPresent(item_context, link_context))
						{
							P_FStructure* lnk;
							lnk = (*link_val_it)->getFSLinkLink();
							if(lnk->failed)
								continue;

							// construct an item with only the current value:
							P_FSItem* extracted_item;
							P_FSItemComplex* ex_complex;
							ex_complex = new P_FSItemComplex();
							ex_complex->attribute = (*fs_items_it)->attribute;
							ex_complex->attribute_type = (*fs_items_it)->getAttributeType();
							ex_complex->contexted_values.push_back(*item_vals_it);
							extracted_item = ex_complex;
						
							current_nogoods = lnk->isConsistentWithItem(extracted_item);
							if (!current_nogoods.empty())
							{
								// need to take list of nogoods and add the union of the contexts obtained
								// at this level to each before adding those nogoods to this f-structure
								// (i.e., nogoods need to be modified before they are ready for use)
								for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
								{	
									union_expr = ContextManager::getUnion(item_context, link_context);
									//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
									//{
									//	(*cur_ng_it).push_back(*union_it);
									//}
									#ifdef GenLog
									CLogManager::AddMessage(L"items links consistency failed:");
									#endif
									addNogood(ContextManager::getUnion(*cur_ng_it,union_expr));
								}	
							}
						}
					}
				}
			}
		}
	}
}

void P_FStructure::checkLinkLinksConsistency(void)
{
	// for nogoods manipulation
	list < bitwiseContext > current_nogoods;
	bitwiseContext union_expr;
	list < bitwiseContext >::iterator cur_ng_it;
	//bitwiseContext::iterator union_it;

	list<P_ContextedValue*> link_values;
	list<P_ContextedValue*>::iterator links_anchor_it;
	list<P_ContextedValue*>::iterator links_it;
	
	link_values = links->getContextedValues();

	for (links_anchor_it = link_values.begin(); links_anchor_it != link_values.end(); links_anchor_it++)
	{
		links_it = links_anchor_it;
		if (links_it == link_values.end())
			break;

		P_FStructure* anchor = (*links_anchor_it)->getFSLinkLink();
		
		if(anchor->failed)
		{
			//addNogood((*links_anchor_it)->bcontext);
			continue;
		}

		links_it++;
		for (links_it; links_it != link_values.end(); links_it++)
		{
			if (!ContextManager::opposingContextsPresent((*links_anchor_it)->bcontext, (*links_it)->bcontext))
			{
				P_FStructure* not_anchor = (*links_it)->getFSLinkLink();
				if(not_anchor->failed)
				{
					//addNogood((*links_it)->bcontext);
					continue;
				}				
				current_nogoods = anchor->isConsistentWithFS(not_anchor);
				if (!current_nogoods.empty())
				{
					// need to take list of nogoods and add the union of the contexts obtained
					// at this level to each before adding those nogoods to this f-structure
					// (i.e., nogoods need to be modified before they are ready for use)
					union_expr = ContextManager::getUnion((*links_anchor_it)->bcontext, (*links_it)->bcontext);
					for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
					{	
						//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
						//	(*cur_ng_it).push_back(*union_it);
						#ifdef GenLog
						CLogManager::AddMessage(L"links links consistency failed:");
						#endif
						addNogood(ContextManager::getUnion(*cur_ng_it,union_expr));
					}	
				}
			}
		}
	}
}

list< bitwiseContext > P_FStructure::isConsistentWithFS(P_FStructure* in_fs)
// all items and links in one fs are to be checked for consistency with all the items and links in the 
// other fs
{
	list < bitwiseContext > current_nogoods;
	list < bitwiseContext >::iterator cur_ng_it;

	list< bitwiseContext > ret_nogoods;
	
	list<P_FSItem*>::iterator self_items_it;
    list<P_FSItem*>::iterator in_items_it;
	list<P_ContextedValue*> in_links;
	list<P_ContextedValue*> self_links;
	list<P_ContextedValue*>::iterator in_links_it, self_links_it;

	bitwiseContext union_expr;
	//bitwiseContext::iterator union_it;
	
	// first check all self items:
	for (self_items_it = fs_items.begin(); self_items_it != fs_items.end(); self_items_it++)
	{
		// with in_items
		for (in_items_it = in_fs->fs_items.begin(); in_items_it != in_fs->fs_items.end(); in_items_it++)
		{
			if((*self_items_it)->attribute==(*in_items_it)->attribute)
			{
				current_nogoods = (*self_items_it)->isConsistentWithItem(*in_items_it);
				if( current_nogoods.size()==1 && (*current_nogoods.begin())==zero)
					return current_nogoods;
				for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
					ret_nogoods.push_back(*cur_ng_it);
			}
		}
		
		current_nogoods.clear();
		
		// with all in_links
		in_links = in_fs->links->getContextedValues();
		P_FStructure* in_link;
		for (in_links_it = in_links.begin(); in_links_it != in_links.end(); in_links_it++)
		{
			in_link = (*in_links_it)->getFSLinkLink();
			current_nogoods = in_link->isConsistentWithItem(*self_items_it);
			union_expr = (*in_links_it)->bcontext;
			for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
			{
				//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
				//	(*cur_ng_it).push_back(*union_it);
				ret_nogoods.push_back(ContextManager::getUnion(*cur_ng_it,union_expr));
			}
		}
	}

	// now check all self links:
    self_links = links->getContextedValues();
	P_FStructure* self_link;
	for (self_links_it = self_links.begin(); self_links_it != self_links.end(); self_links_it++)
	{
		self_link = (*self_links_it)->getFSLinkLink();
		// with all in_items
		for (in_items_it = in_fs->fs_items.begin(); in_items_it != in_fs->fs_items.end(); in_items_it++)
		{
			current_nogoods = self_link->isConsistentWithItem(*in_items_it);
			union_expr = (*self_links_it)->bcontext;
			for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
			{
				//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
				//	(*cur_ng_it).push_back(*union_it);
				ret_nogoods.push_back(ContextManager::getUnion(*cur_ng_it,union_expr));
			}
		}

		// with all in_links
		in_links = in_fs->links->getContextedValues();
		P_FStructure* in_link;
		for (in_links_it = in_links.begin(); in_links_it != in_links.end(); in_links_it++)
		{
			in_link = (*in_links_it)->getFSLinkLink();
			current_nogoods = self_link->isConsistentWithFS(in_link);

			union_expr = ContextManager::getUnion((*self_links_it)->bcontext, (*in_links_it)->bcontext);
			for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
			{
				//for (union_it = union_expr.begin(); union_it != union_expr.end(); union_it++)
				//	(*cur_ng_it).push_back(*union_it);
				ret_nogoods.push_back(ContextManager::getUnion(*cur_ng_it,union_expr));
			}
		}
	}
	return ret_nogoods;
}

//list<P_ContextedValue*> P_FStructure::FindValueDeep(PFSsymID att)
//{
	// DONE BY TAHIRA
//	return list<P_ContextedValue*>();
//}

//void P_FStructure::resolveValueLinks(void)
//{
	// TO BE DONE LATER
//}

//##########TAHIRA#############

/*void P_FStructure::CheckCompleteness()
{
	//see if the FS has GF, if not then mark FS as checked
	//get GFs
	list<P_FSItem*> GFitems;
	list<bitwiseContext > extcontexts;
	bitwiseContext dummyCont;
	vector<vector<PFSsymID> > GFsubcats;	//actual subcats against all GF values
	vector<vector<PFSsymID> > GFSCflags;	//found-flags against all GF values
	vector<bitwiseContext > GFcontexts;	//contexts against all GF values
	list<P_FSItem*>::iterator GFit;
	list<bitwiseContext >::iterator exContIt;
	list<P_ContextedValue*> GF_values;
	list<P_ContextedValue*>::iterator valit;

	SearchItemsDeepWithContext(P_FSSymbolTable::GFID,GFitems,extcontexts,dummyCont);
	//bring actual subcat frame and their coresponding context litsts for each GF value
	exContIt=extcontexts.begin();
	GFit=GFitems.begin();
	while(GFit!=GFitems.end())
	{
		GF_values=(*GFit)->getContextedValues();
		valit=GF_values.begin();
		while(valit!=GF_values.end())
		{
			//GFcontexts.push_back((*valit)->bcontext);
			GFcontexts.push_back(ContextManager::getUnion((*valit)->bcontext,(*exContIt)));
			GFsubcats.push_back(P_Lexicon::GetSubcatFrame1(string2int(P_FSSymbolTable::getSym(((P_ContValFSLink *)(*valit))->value))));
			vector<PFSsymID> flags;
			flags.resize(GFsubcats[GFsubcats.size()-1].size(),1);
			GFSCflags.push_back(flags);
			valit++;
		}
		GFit++;
		exContIt++;
	}


	//get the vector of all the symbols of the type SUBJ, OBJ from P_FSSymbolTable
	//get the pointers of all GF{SUB, OBJ ...} items from the FS
	list<PFSsymID>::iterator scit=P_FSSymbolTable::Subcats.begin();
	list<P_FSItem*> FSsubcats;					//subcats present in the FS
	list<P_ContextedValue*> values;
	list<P_FSItem*>::iterator fscit;
	bitwiseContext::iterator cbit;
	bool found;
	while(scit!=P_FSSymbolTable::Subcats.end())
	{
		//FSsubcats=SearchInItemsLinks(*scit);
		extcontexts.clear();
		FSsubcats.clear();
		SearchItemsDeepWithContext(*scit,FSsubcats,extcontexts,dummyCont);
		fscit=FSsubcats.begin();
		exContIt=extcontexts.begin();
		while(fscit!=FSsubcats.end())//for each item 
		{
			values=(*fscit)->getContextedValues();
			valit=values.begin();
			while(valit!=values.end())//for each of its value
			{
				found=false;
				bitwiseContext valCont=ContextManager::getUnion((*valit)->bcontext,(*exContIt));
				for(int i=0;i<GFcontexts.size();i++)//find the GF value with which its context matches
				{
					if(!opposingContextsPresent(GFcontexts[i],valCont) && (*valit)->getFSLink()->failed!=true)
					{
						found=true;
						//if that GF needs it, well and good, delete its number from the GF vecter to show that it was found
						for(int j=0;j<GFsubcats[i].size();j++)
						{
							if(GFsubcats[i][j]==(*fscit)->attribute)
							{
								//GFsubcats[i].erase(GFsubcats[i].begin()+j); //this one is a costly operation
								GFSCflags[i][j]=0;
								break;
							}
						}
						//otherwise put the context in no goods and move on (coherence for the context failed)
						if(j==GFsubcats[i].size())
						{
							addNogood(ContextManager::getUnion(GFcontexts[i],valCont));
						}
					}
				}

				if(!found)//it is a dangling Subj,Obj type thing existing in a predless structure (coherence for its FS's context failed)
					addNogood(valCont);

				valit++;
			}
			fscit++;
			exContIt++;
		}
		scit++;
	}




	for(int k=0;k<GFsubcats.size();k++)//traverse all the GF vectors 
	{
		for(int l=0;l<GFsubcats[k].size();l++)//traverse values of every GF vectors 
		{
			if(GFSCflags[k][l]!=0)//if any of them was not satisfied
			{
				addNogood(GFcontexts[k]);//put its context list in no goods (completeness for the context failed)
				break;
			}
		}
	}

	//mark FS as checked
	cc_checked=true;
	
	
	//call this function for all children of link type
	list<P_FSItem*> AllChildItems=GetItemsDeep();
	list<P_FSItem*>::iterator it=AllChildItems.begin();
	P_FStructure *fs=0;
	while(it!=AllChildItems.end())
	{
		values.clear();
		values=(*it)->getContextedValues();
		fs=(*values.begin())->getFSLink();
		if( fs!=0 && ((*values.begin())->getFSLinkValue()==0))
		{
			fs->CheckCompleteness();
		}
		it++;
	}

	if(!nogoods.empty())
	{
		first_solution = getSolution(nogoods);
		if(first_solution.empty())
			failed = true;
		else 
			failed = false;
	}
	else 
		failed = false;

}*/

void P_FStructure::CheckCompleteness()
{
	/* REMOVED FOR THIS (DOS/LINUX) VERSION
	#ifndef DEBUG
	current_time = clock();
	if ((current_time - start_time)>max_time)
	{
        return;
	}
	#endif
	REMOVED FOR THIS (DOS/LINUX) VERSION*/

	if(!cc_checked && !failed)
	{
		list<P_FStructure *> GFFS;
		list<list<bitwiseContext > > exContextsLists;
		bitwiseContext dummyCont;
		SearchGFFS(GFFS,exContextsLists,dummyCont);
//		list<bitwiseContext > exContextsCommon;

	//ContextManager::setSize(90);
	//see if the FS has GF, if not then mark FS as checked
	//get GFs
	list<P_FSItem*> GFitems;
	list<bitwiseContext > extcontexts;
	vector<vector<PFSsymID> > GFsubcats;	//actual subcats against all GF values
	vector<short> GFsubcatsID;
	vector<list<bitwiseContext > > GFcontexts;	//contexts against all GF values
	list<P_FSItem*>::iterator GFit;
	list<bitwiseContext >::iterator exContIt;
	list<P_ContextedValue*> GF_values;
	list<P_ContextedValue*>::iterator valit;

	//vector<P_FStructure *> visited;
	//GFitems=SearchGF(visited);
	//visited.clear();

	if(GFFS.size())
	{
		if(GFFS.size()>1)
		{
			list<list<bitwiseContext > >::iterator contlistit=exContextsLists.begin();
			list<P_FStructure *>::iterator fsit=GFFS.begin();
			while(contlistit!=exContextsLists.end())
			{
				#ifdef GenLog
				LogContextByteLists( new2oldContext(*contlistit) );
				#endif
				
				//extcontexts.push_back(getIntersection(*contlistit));
				list<contextByte> intersection=getIntersection(new2oldContext(*contlistit));
				if(intersection.empty())
				{
					for(list<bitwiseContext>::iterator bcit=(*contlistit).begin();bcit!=(*contlistit).end();bcit++)
					{
						GFitems.push_back( (*fsit)->SearchInItemsUnordered(P_FSSymbolTable::GFID) );
					}
					extcontexts.merge(*contlistit);
				}
				else
				{
					extcontexts.push_back(ContextManager::convertListTobitwiseContext(intersection));
					GFitems.push_back( (*fsit)->SearchInItemsUnordered(P_FSSymbolTable::GFID) );
				}

				#ifdef GenLog
				LogContextByteList( ContextManager::convertbitwiseContextToList(extcontexts.back()) );
				#endif
				
				contlistit++;
				fsit++;
			}
			//GFitems.clear();
			//SearchItemsDeepWithContext(P_FSSymbolTable::GFID,GFitems,extcontexts,dummyCont);
			exContIt=extcontexts.begin();
		}	
		else
			GFitems.push_back( (*GFFS.begin())->SearchInItemsUnordered(P_FSSymbolTable::GFID) );
	}

	//GFitems=SearchInItemsLinks(P_FSSymbolTable::GFID);
	//bring actual subcat frame and their coresponding context litsts for each GF value
	
	GFit=GFitems.begin();
	bitwiseContext val_context;

	while(GFit!=GFitems.end())
	{
		GF_values=(*GFit)->getContextedValues();
		valit=GF_values.begin();
		//valit++;
		while(valit!=GF_values.end())
		{
			if(GFFS.size()>1)
				val_context=ContextManager::getUnion(*exContIt,(*valit)->bcontext);//---------------
			else
                val_context=(*valit)->bcontext;

			int i;
			for(i=0;i<GFsubcatsID.size();i++)
			{
				if(((P_ContValFSLink *)(*valit))->value==GFsubcatsID[i])
				{
					list<bitwiseContext >::iterator ContIt;
					for(ContIt=GFcontexts[i].begin();ContIt!=GFcontexts[i].end();ContIt++)
					{
						//if((*ContIt)==(*valit)->bcontext)
						if((*ContIt)==val_context)
							break;
					}
					if(ContIt==GFcontexts[i].end())
					{
						//GFcontexts[i].push_back((*valit)->bcontext);
						GFcontexts[i].push_back(val_context);
					}
					break;
				}
			}
			if(i==GFsubcatsID.size())
			{
				GFsubcatsID.push_back(((P_ContValFSLink *)(*valit))->value);
				list<bitwiseContext > new_list;
				//new_list.push_back((*valit)->bcontext);
				new_list.push_back(val_context);
				GFcontexts.push_back(new_list);
			}
			valit++;
		}
		GFit++;
		if(GFFS.size()>1)
			exContIt++;//-----------
	}

	//sorting GFs
	vector<list<bitwiseContext > > temp_GFcontexts;
	temp_GFcontexts.resize(30);
	for(int i=0;i<GFsubcatsID.size();i++)
	{
		temp_GFcontexts[string2int( P_FSSymbolTable::getSym(GFsubcatsID[i]) )]=GFcontexts[i];
	}
	GFcontexts.clear();GFsubcatsID.clear();
	for(int i=0;i<temp_GFcontexts.size();i++)
	{
		if(temp_GFcontexts[i].size())
		{
			GFcontexts.push_back(temp_GFcontexts[i]);
			GFsubcatsID.push_back(P_FSSymbolTable::getSymID( int2string(i) ));
		}
	}
	//end sorting GFs

	for(int i=0;i<GFsubcatsID.size();i++)
	{
		GFsubcats.push_back(P_Lexicon::GetSubcatFrame1(string2int(P_FSSymbolTable::getSym( GFsubcatsID[i] ))));
	}

	#ifdef GenLog
	wstring str=L"Subcat Frames Found:\r\n";
	for(int i=0;i<GFsubcats.size();i++)
	{
		str+=L"GF: <";
		for(int p=0;p<GFsubcats[i].size();p++)
		{
			str+=Convert_str2wstr(P_FSSymbolTable::getSym(GFsubcats[i][p]));
			str+=L" ";
		}
		str+=L">\r\n";
		CLogManager::AddMessage(str);
		str=L"";
		for(list< bitwiseContext >::iterator cit=GFcontexts[i].begin();cit!=GFcontexts[i].end();cit++)
		{
			LogContextByteList( ContextManager::convertbitwiseContextToList(*cit) );
		}		
	}
	#endif

	//get the vector of all the symbols of the type SUBJ, OBJ from P_FSSymbolTable
	//get the pointers of all GF{SUB, OBJ ...} items from the FS
	vector<list<P_ContextedValue*> > FSsubcats;					//subcats present in the FS
	FSsubcats.resize(P_FSSymbolTable::Subcats.size());
	vector<list<bitwiseContext > > extcontextstable;
	extcontextstable.resize(P_FSSymbolTable::Subcats.size());
			
	//list<bitwiseContext > nogoodsbelow=SearchSubcatsDeepWithContext(FSsubcats,extcontextstable);//,dummyCont);
	list<bitwiseContext > nogoodsbelow=SearchSubcatsDeepWithContext2(FSsubcats);//,extcontextstable);//,dummyCont);

	/*for(list<bitwiseContext >::iterator it=nogoodsbelow.begin();it!=nogoodsbelow.end();it++)
	{
		//addNogood(*it);
		#ifdef GenLog
		CLogManager::AddMessage(L"nogoods brought from below by CC");
		LogContextByteList(*it);
		#endif
	}*/

	list<P_ContextedValue*> values;
	list<P_ContextedValue*>::iterator fscit;
	vector<PFSsymID> sc_list;
	vector<vector<bitwiseContext > > cb_table;
	bool found;
	int size;

	list<PFSsymID>::iterator scit=P_FSSymbolTable::Subcats.begin();
	for(int i=0;i<FSsubcats.size();i++)
	{
		if(FSsubcats[i].size())
		{
			vector<bitwiseContext > cb_list;
			for(fscit=FSsubcats[i].begin();fscit!=FSsubcats[i].end();fscit++)
			{
				if((*fscit)->getFSLinkLink()->failed!=true)
				{
					size=cb_list.size();
					int x;
					for(x=0;x<size;x++)
					{ 
						if(cb_list[x]==(*fscit)->bcontext)
							break;
					}
					if(x==size)
					{
						cb_list.push_back((*fscit)->bcontext);

						#ifdef GenLog
						wstring str=L"[";
						str+=Convert_str2wstr(P_FSSymbolTable::getSym(*scit));
						str+=L"]";
						CLogManager::AddMessage(str);
                        LogContextByteList( ContextManager::convertbitwiseContextToList((*fscit)->bcontext) );
						#endif
					}
				}
			}
			if(cb_list.size())
			{
				cb_table.push_back(cb_list);
				sc_list.push_back(*scit);
			}
		}
		scit++;
	}

	if(GFitems.size()==0)
	{
		for(int j=0;j<sc_list.size();j++)
		{
			for(int k=0;k<cb_table[j].size();k++)
			{
				addNogood(cb_table[j][k]);
			}
		}
	}

	for(int i=0;i<GFsubcats.size();i++)
	{
		vector<bool> gf_found;
		vector<bool> sc_needed;
		sc_needed.resize(sc_list.size(),false);

		for(int j=0;j<sc_list.size();j++)
		{
			for(int n=0;n<GFsubcats[i].size();n++)
			{
				if(GFsubcats[i][n]==sc_list[j])
				{
					gf_found.push_back(true);
					sc_needed[j]=true;
					break;
				}				
			}
		}

		if(gf_found.size()!=GFsubcats[i].size())
		{
			#ifdef GenLog
			wstring str=L"GF: <";
			for(int p=0;p<GFsubcats[i].size();p++)
			{
				str+=Convert_str2wstr(P_FSSymbolTable::getSym(GFsubcats[i][p]));
				str+=L" ";
			}
			str+=L"> could not find enough functions.";
			CLogManager::AddMessage(str);
			#endif

			for(list<bitwiseContext >::iterator it=GFcontexts[i].begin();it!=GFcontexts[i].end();it++)
			{
				addNogood(*it);
			}
			continue;
		}

		gf_found.clear();
		
		list<bitwiseContext > sub_cat_frames_contexts;
		list<bitwiseContext > contexttemp;

		for(int j=0;j<sc_list.size();j++)
		{
			if(sc_needed[j])
			{
				list<bitwiseContext > contextold=sub_cat_frames_contexts; sub_cat_frames_contexts.clear();

				for(int k=0;k<cb_table[j].size();k++)
				{
					contexttemp=contextold;
					list<bitwiseContext >::iterator it=contexttemp.begin();
					if(contexttemp.size()==0)
					{
						sub_cat_frames_contexts.push_back(cb_table[j][k]);
					}
					else
					{
						while(it!=contexttemp.end())
						{
							if(!ContextManager::opposingContextsPresent(*it,cb_table[j][k]))
							{
								sub_cat_frames_contexts.push_back( ContextManager::getUnion(*it,cb_table[j][k]) );
							}
							it++;
						}
					}
				}
			}
			else
			{

				#ifdef GenLog
				wstring str=L"GF: <";
				for(int p=0;p<GFsubcats[i].size();p++)
				{
					str+=Convert_str2wstr(P_FSSymbolTable::getSym(GFsubcats[i][p]));
					str+=L" ";
				}
				str+=L"> does not like ";
				str+=Convert_str2wstr(P_FSSymbolTable::getSym(sc_list[j]));
				CLogManager::AddMessage(str);
				#endif

				for(int k=0;k<cb_table[j].size();k++)
				{
					//for all contexts of that type of GF
					for(list<bitwiseContext >::iterator it=GFcontexts[i].begin();it!=GFcontexts[i].end();it++)
					{
						addNogood(ContextManager::getUnion(cb_table[j][k],*it));
					}
				}
			}
		}

		if(sub_cat_frames_contexts.size()==0)
		{
			for(list<bitwiseContext >::iterator it=GFcontexts[i].begin();it!=GFcontexts[i].end();it++)
			{
				addNogood(*it);
			}
		}
		else
		{
			//sub_cat_frames_contexts.remove(zero);
			/*for(list<bitwiseContext >::iterator ii=sub_cat_frames_contexts.begin();ii!=sub_cat_frames_contexts.end();ii++)
			{
				if((*ii)==zero)//IsContextSubset((*ii),zero) )
				{
					sub_cat_frames_contexts.remove(*ii);
					if(sub_cat_frames_contexts.size())
						ii=sub_cat_frames_contexts.begin();
				}
			}*/
			if(sub_cat_frames_contexts.size())
			{
				sub_cat_frames_contexts.sort();
				sub_cat_frames_contexts.unique();
				/*list<bitwiseContext > nogoods_against_solition= old2newContext(getSolNogoods( new2oldContext(sub_cat_frames_contexts) ) );
				//list<bitwiseContext > nogoods_against_solition=getNogoodsAgainstSolution(sub_cat_frames_contexts);
				
				list<bitwiseContext > usefull_nogoods;
				for(list<bitwiseContext >::iterator it_gf=GFcontexts[i].begin();it_gf!=GFcontexts[i].end();it_gf++)
				{
					for(list<bitwiseContext >::iterator ngit=nogoods_against_solition.begin();ngit!=nogoods_against_solition.end();ngit++)
					{
						//bitwiseContext temp=*it_gf;
						//(*ngit).merge(temp);
						bitwiseContext temp_gf_context=*it_gf;
						bitwiseContext temp_sc_context=(*ngit);
						temp_sc_context=ContextManager::getUnion(*it_gf,*ngit);
						if(isValidNogood(temp_sc_context))
							usefull_nogoods.push_back(temp_sc_context);
					}
				}
				nogoods_against_solition.clear();
				//usefull_nogoods.unique();

				#ifdef GenLog
				CLogManager::AddMessage(L"Possible CC solutions:");
				LogContextByteLists(sub_cat_frames_contexts);
				CLogManager::AddMessage(L"Nogoods against solutions:");
				LogContextByteLists(usefull_nogoods);
				#endif

				//sub_cat_frames_contexts.clear();
				nogoods.merge(usefull_nogoods);/**/

				//rather than creating nogoods, solutions are being saved
				
				for(list<bitwiseContext >::iterator it_gf=GFcontexts[i].begin();it_gf!=GFcontexts[i].end();it_gf++)
				{
					for(list<bitwiseContext >::iterator ngit=sub_cat_frames_contexts.begin();ngit!=sub_cat_frames_contexts.end();ngit++)
					{
						bitwiseContext temp_gf_context=*it_gf;
						bitwiseContext temp_sc_context=(*ngit);
						bitwiseContext temp_sol_context=ContextManager::getUnion(temp_gf_context,temp_sc_context);
						if(isValidNogood(temp_sol_context) && !inNogoods(temp_sol_context))
						{
							solutions.push_back(temp_sol_context);
						}
					}
				}
			}
		}
 	}       
		//mark FS as checked
		cc_checked=true;

		//call this function for all children of link type
		list<P_FSItem*> AllChildItems=GetItemsDeep();
		list<P_FSItem*>::iterator it=AllChildItems.begin();
		P_FStructure *fs=0;
		while(it!=AllChildItems.end())
		{
			values.clear();
			values=(*it)->getContextedValues();
			fs=(*values.begin())->getFSLink();
			if( fs!=0 && ((*values.begin())->getFSLinkValue()==0))
			{
				#ifdef GenLog
				wstring str=L"Entering in ";
				str+=Convert_str2wstr(P_FSSymbolTable::getSym( (*it)->attribute ));
				CLogManager::AddMessage(str);
				#endif
				fs->CheckCompleteness();
				//if(fs->failed)
				//	addNogood((*values.begin())->bcontext);
				#ifdef GenLog
				str=L"Out of ";
				str+=Convert_str2wstr(P_FSSymbolTable::getSym( (*it)->attribute ));
				CLogManager::AddMessage(str);
				#endif
			}
			it++;
		}

		/*if(!nogoods.empty())
		{
			first_solution = makesolution(new2oldContext(nogoods));
			if(first_solution.empty())
				failed = true;
			else 
				failed = false;
			
			#ifdef GenLog
			CLogManager::AddMessage(L"CC Nogoods:");
			LogContextByteLists(nogoods);
			CLogManager::AddMessage(L"CC Solution against Nogoods:");
			LogContextByteList(first_solution);
			#endif
		}
		else 
			failed = false;*/
		}
}

bool P_FStructure::inNogoods(bitwiseContext context)
{
	list<bitwiseContext >::iterator it=nogoods.begin();
	while(it!=nogoods.end())
	{
		if( ContextManager::getIntersection( (*it), context)==(*it) )
			return true;
		it++;
	}
	return false;
}

list<bitwiseContext > P_FStructure::SearchSubcatsDeepWithContext2(vector<list<P_ContextedValue*> > &ResultList)//, vector<list<bitwiseContext > > &exContList)//, bitwiseContext extCont)
{
		list<bitwiseContext > nogoodsbelow;
		list<bitwiseContext > localnogoods;
		if(!failed)
		{
		bitwiseContext one_context;
		list<PFSsymID>::iterator scit=P_FSSymbolTable::Subcats.begin();
		list<P_FSItem*>::iterator it;
		list<P_FSItem*>::iterator point=fs_items.begin();
		list<P_ContextedValue*> vals;
		list<P_ContextedValue*>::iterator valit;

		bool found=false;
		int i=0;

		while(scit!=P_FSSymbolTable::Subcats.end()) //fs-items are sorted on attribute
		{
			if(!found)
				it=point;
			else
			{
				found=false;
				point=it;
			}
			for(;it!=fs_items.end();it++)
			{
				if((*it)->attribute==*scit)
				{
					P_FStructure *fs;
					fs=(*(*it)->getContextedValues().begin())->getFSLinkLink();
					if( !fs->failed )
					{
						//if(fs->fs_items.size())
						//	vals=(*it)->getContextedValues();
						//else
						//	vals=fs->links->getContextedValues();

						if(fs->links->getContextedValues().size())
							vals=fs->links->getContextedValues();
						else
							vals=(*it)->getContextedValues();							

						for(valit=vals.begin();valit!=vals.end();valit++)
						{
							list<bitwiseContext >::iterator it=nogoods.begin();
							one_context=(*valit)->bcontext;
							one_context=ContextManager::getUnion(zero,one_context);
							while(it!=nogoods.end())
							{
								if( ContextManager::getIntersection((*it),one_context)==(*it) )
									break;
								it++;
							}
							if( it==nogoods.end() )
							{
								P_ContextedValue* newval=(*valit)->makeCopy();
								ResultList[i].push_back(newval);
							}
							else
							{
								localnogoods.push_back(*it);
							}
						}
					}
					else
					{
						#ifdef GenLog
						wstring msg=L"a failed ";
						msg+=Convert_str2wstr( P_FSSymbolTable::getSym(*scit) );
						msg+=L" found";
						CLogManager::AddMessage(msg);
						#endif
					}

					found=true;
					break;
				}

			}
			scit++;i++;
		}

		list<P_ContextedValue*> link_values;
		
		list<P_ContextedValue*>::iterator scvalit;
		link_values=links->getContextedValues();
		valit=link_values.begin();
		bitwiseContext newExCont,valCont;

		while(valit!=link_values.end())
		{
			if( (*valit)->getFSLink() && !inNogoods(ContextManager::getUnion(zero,(*valit)->bcontext)) )
			{
				vector<list<P_ContextedValue*> > ResList;
				ResList.resize(P_FSSymbolTable::Subcats.size());
				nogoodsbelow=((P_ContValFSLink *)(*valit))->link->SearchSubcatsDeepWithContext2(ResList);

				scit=P_FSSymbolTable::Subcats.begin();
				for(int x=0;x<ResList.size();x++,scit++)
				{
					if(ResList[x].size())
					{
						for(scvalit=ResList[x].begin(); scvalit!=ResList[x].end(); scvalit++)
						{
							(*scvalit)->bcontext = ContextManager::getUnion( (*valit)->bcontext , (*scvalit)->bcontext ) ;
							if(!inNogoods( (*scvalit)->bcontext  ))
							{
								ResultList[x].push_back(*scvalit);
							}
							else
							{
								localnogoods.push_back( (*scvalit)->bcontext );
								#ifdef GenLog
								wstring msg=L"a ";
								msg+=Convert_str2wstr( P_FSSymbolTable::getSym(*scit) );
								msg+=L" found on an invalid path";
								CLogManager::AddMessage(msg);
								LogContextByteList( ContextManager::convertbitwiseContextToList((*scvalit)->bcontext) );
								#endif
							}
						}
					}
				}
			}
			valit++;
		}
	}

	nogoodsbelow.merge(localnogoods);

	return nogoodsbelow;
}

list<bitwiseContext > P_FStructure::SearchSubcatsDeepWithContext(vector<list<P_ContextedValue*> > &ResultList, vector<list<bitwiseContext > > &exContList)//, bitwiseContext extCont)
{
		list<bitwiseContext > nogoodsbelow;
		list<bitwiseContext > localnogoods;
		if(!failed)
		{
		bitwiseContext one_context;
		list<PFSsymID>::iterator scit=P_FSSymbolTable::Subcats.begin();
		list<P_FSItem*>::iterator it;
		list<P_FSItem*>::iterator point=fs_items.begin();
		list<P_ContextedValue*> vals;
		list<P_ContextedValue*>::iterator valit;

		bool found=false;
		int i=0;

		while(scit!=P_FSSymbolTable::Subcats.end()) //fs-items are sorted on attribute
		{
			if(!found)
				it=point;
			else
			{
				found=false;
				point=it;
			}
			for(;it!=fs_items.end();it++)
			{
				if((*it)->attribute==*scit)
				{
					P_FStructure *fs;
					fs=(*(*it)->getContextedValues().begin())->getFSLinkLink();
					if( !fs->failed )
					{
						vals=fs->links->getContextedValues();
						for(valit=vals.begin();valit!=vals.end();valit++)
						{
							list<bitwiseContext >::iterator it=nogoods.begin();
							one_context=(*valit)->bcontext;
							one_context=ContextManager::getUnion(zero,one_context);
							while(it!=nogoods.end())
							{
								if( ContextManager::getIntersection((*it),one_context)==(*it) )
									break;
								it++;
							}
							if( it==nogoods.end() )
							{
								ResultList[i].push_back(*valit);
								//exContList[i].push_back(extCont);
								exContList[i].push_back(zero);
							}
							else
							{
								localnogoods.push_back(*it);
							}
						}
						found=true;
						break;
					}
				}
			}
			scit++;i++;
		}

		list<P_ContextedValue*> link_values;
		
		list<P_ContextedValue*>::iterator scvalit;
		list<bitwiseContext >::iterator contit;

		link_values=links->getContextedValues();
		valit=link_values.begin();
		bitwiseContext newExCont,valCont;
		while(valit!=link_values.end())
		{
			if( (*valit)->getFSLink() && !inNogoods((*valit)->bcontext) )
			{
				//valCont=(*valit)->bcontext;
				//newExCont=extCont;
				//newExCont.merge(valCont);
				
				vector<list<P_ContextedValue*> > ResList;
				ResList.resize(P_FSSymbolTable::Subcats.size());
				vector<list<bitwiseContext > > ContList;
				ContList.resize(P_FSSymbolTable::Subcats.size());
				//bitwiseContext newExCont=ContextManager::getUnion((*valit)->bcontext,extCont);			
				nogoodsbelow=((P_ContValFSLink *)(*valit))->link->SearchSubcatsDeepWithContext(ResList,ContList);//,newExCont);

				for(int x=0;x<ResList.size();x++)
				{
					if(ResList[x].size())
					{
						for(scvalit=ResList[x].begin(),contit=ContList[x].begin(); scvalit!=ResList[x].end(); scvalit++,contit++)
						{
							valCont= ContextManager::getUnion( (*valit)->bcontext , (*contit) ) ;
							if(!inNogoods( valCont ))
							{
								ResultList[x].push_back(*scvalit);
								//exContList[x].push_back(*contit);
								exContList[x].push_back(valCont);
							}
							else
							{
								localnogoods.push_back( valCont );
							}
						}
					}
				}
			}
			valit++;
		}
	}

	//return ResultList.size();
	nogoodsbelow.merge(localnogoods);

	return nogoodsbelow;
}

bool P_FStructure::SearchItemsDeepWithContext(PFSsymID att,list<P_FSItem*> &ResultList, list<bitwiseContext > &exContList, bitwiseContext extCont)
{
	
	list<P_FSItem*>::iterator it;

	it=fs_items.begin();

	while(it!=fs_items.end() && (*it)->attribute<=att) //fs-items are sorted on attribute
	{
		if((*it)->attribute==att)
		{
			P_FStructure *fs;
			fs=(*(*it)->getContextedValues().begin())->getFSLinkLink();
			if(fs)
				ResultList.push_back(fs->links);
			else
				ResultList.push_back(*it);

			exContList.push_back(extCont);
		}
		it++;
	}

	list<P_ContextedValue*> link_values;
	list<P_ContextedValue*>::iterator valit;

	link_values=links->getContextedValues();
	valit=link_values.begin();
	while(valit!=link_values.end())
	{
		P_FStructure *lnk = (*valit)->getFSLink();
		if(lnk && lnk->failed==false && !inNogoods(ContextManager::getUnion(zero,(*valit)->bcontext)))
		{
			bitwiseContext newExCont=ContextManager::getUnion((*valit)->bcontext,extCont);
            ((P_ContValFSLink *)(*valit))->link->SearchItemsDeepWithContext(att,ResultList,exContList,newExCont);
		}
		valit++;
	}

	return ResultList.size();
}

void CheckCompletenessCoherence(list<P_FStructure *> FS)
{
	list<P_FSItem*> objlistP_FSItem1 ;/*ADDED IN THIS (LINUX ONLY) VERSION*/	
	
	list<P_FStructure *>::iterator FSit;
	if((FS.size()==1 && !((*FS.begin())->cc_checked)) || FS.size()>1)
	{
		//see if the FS has GF, if not then mark FS as checked
		//get GFs
		list<P_FSItem*> GFitems;
		FSit=FS.begin();
		vector<vector<PFSsymID> > GFsubcats;	//actual subcats against all GF values
		vector<vector<PFSsymID> > GFSCflags;	//found-flags against all GF values
		vector<bitwiseContext > GFcontexts;	//contexts against all GF values
		vector<P_FStructure *> GFFS;			//FS pointers for all GF values
		list<P_FSItem*>::iterator GFit;
		list<P_ContextedValue*> GF_values;
		list<P_ContextedValue*>::iterator valit;

		while(FSit!=FS.end())
		{
			GFitems=((*FSit)->SearchInItemsLinks(P_FSSymbolTable::GFID));
			//bring actual subcat frame and their coresponding context litsts for each GF value
			GFit=GFitems.begin();
			while(GFit!=GFitems.end())
			{
				GF_values=(*GFit)->getContextedValues();
				valit=GF_values.begin();
				while(valit!=GF_values.end())
				{
					GFcontexts.push_back((*valit)->bcontext);
					GFsubcats.push_back(P_Lexicon::GetSubcatFrame1(string2int(P_FSSymbolTable::getSym(((P_ContValFSLink *)(*valit))->value))));
					GFFS.push_back(*FSit);
					valit++;
				}
				GFit++;
			}
			GFitems.clear();
		}


		//get the vector of all the symbols of the type SUBJ, OBJ from P_FSSymbolTable
		//get the pointers of all GF{SUB, OBJ ...} items from the FS
		list<PFSsymID>::iterator scit=P_FSSymbolTable::Subcats.begin();
		list<P_FSItem*> FSsubcats;					//subcats present in the FS
		list<P_ContextedValue*> values;
		list<P_FSItem*>::iterator fscit;
		//bitwiseContext::iterator cbit;
		bool found;
		while(scit!=P_FSSymbolTable::Subcats.end())
		{
			FSit=FS.begin();
			while(FSit!=FS.end())
			{
				FSsubcats=((*FSit)->SearchInItemsLinks(*scit));
				fscit=FSsubcats.begin();
				while(fscit!=FSsubcats.end())//for each item 
				{
					values=(*fscit)->getContextedValues();
					valit=values.begin();
					while(valit!=values.end())//for each of its value
					{
						found=false;
						for(int i=0;i<GFcontexts.size();i++)//find the GF value with which its context matches
						{
							if(!ContextManager::opposingContextsPresent(GFcontexts[i],(*valit)->bcontext))
							{
								found=true;
								//if that GF needs it, well and good, delete its number from the GF vecter to show that it was found
								int j=0;
								for(j=0;j<GFsubcats[i].size();j++)
								{
									if(GFsubcats[i][j]==(*fscit)->attribute)
									{
										//GFsubcats[i].erase(GFsubcats[i].begin()+j); //this one is a costly operation
										GFSCflags[i][j]=0;
										break;
									}
								}
								//otherwise put the context in no goods and move on (coherence for the context failed)
								if(j==GFsubcats[i].size())
								{
									GFFS[i]->addNogood(ContextManager::getUnion(GFcontexts[i],(*valit)->bcontext));
								}
							}
						}

						if(!found)//it is a dangling Subj,Obj type thing existing in a predless structure (coherence for its FS's context failed)
							(*FSit)->addNogood((*valit)->bcontext);

						valit++;
					}
					fscit++;
				}
				FSit++;
			}
			scit++;
		}
	



		for(int k=0;k<GFsubcats.size();k++)//traverse all the GF vectors 
		{
			for(int l=0;l<GFsubcats[k].size();l++)//traverse values of every GF vectors 
			{
				if(GFSCflags[k][l]!=0)//if any of them was not satisfied
				{
					GFFS[k]->addNogood(GFcontexts[k]);//put its context list in no goods (completeness for the context failed)
					break;
				}
			}
		}

		//mark FS as checked if possible
        if(FS.size()==1)
			(*FS.begin())->cc_checked=true;
	}
	
	//call this function for all children of link type

	list<P_FSItem*> AllChildItems;
	FSit=FS.begin();
	while(FSit!=FS.end())
	{
		/*AllChildItems.merge((*FSit)->GetItemsDeep());CHANGED IN THIS (LINUX ONLY) VERSION*/
		objlistP_FSItem1 = (*FSit)->GetItemsDeep();
		AllChildItems.merge(objlistP_FSItem1);
		FSit++;
	}	

	list<P_FSItem*>::iterator it=AllChildItems.begin();
	list<P_ContextedValue*> values;
	list<P_ContextedValue*>::iterator valit;
	P_FStructure *fs;
	while(it!=AllChildItems.end())
	{
		values=(*it)->getContextedValues();
		if((*values.begin())->getFSLink())
		{
			FS.clear();
			valit=values.begin();
			while(valit!=values.end())
			{
				FS.push_back((*valit)->getFSLink());
				valit++;
			}
			CheckCompletenessCoherence(FS);
		}
		it++;
	}
}

list<P_FSItem*> P_FStructure::SearchInItemsLinksWithContext(PFSsymID Att)
{
	list<P_FSItem*> ResultList;

	//if(!failed)
	{
		list<P_FSItem*>::iterator it;

		it=fs_items.begin();

		while(it!=fs_items.end() && (*it)->attribute<=Att) //fs-items are sorted on attribute
		{
			if((*it)->attribute==Att)
			{
				ResultList.push_back((*it)->makeCopy());
			}
			it++;
		}

		list<P_ContextedValue*> link_values;
		list<P_ContextedValue*>::iterator valit;

		link_values=links->getContextedValues();
		valit=link_values.begin();
		while(valit!=link_values.end())
		{
			if((*valit)->getFSLink())
			{
				list<P_FSItem *> result=((P_ContValFSLink *)(*valit))->link->SearchInItemsLinksWithContext(Att);
				if( !((*valit)->bcontext==zero) )
				{
					for(it=result.begin();it!=result.end();it++)
					{
						list<P_ContextedValue*> below_val_list=(*it)->getContextedValues();
						for(list<P_ContextedValue *>::iterator below_valit=below_val_list.begin();below_valit!=below_val_list.end();below_valit++)
						{
							(*below_valit)->addContexts((*valit)->bcontext);
						}					
						ResultList.push_back(*it);
					}
				}
				else
				{
					ResultList.merge(result);
				}
			}
			valit++;
		}
	}

	return ResultList;
}

void P_FStructure::SearchGFFS(list<P_FStructure *> &GFFS, list<list<bitwiseContext > > &exContLists, bitwiseContext extCont)
{

	if(!failed)
	{
		list<P_FSItem*>::iterator it;

		it=fs_items.begin();

		while(it!=fs_items.end() && (*it)->attribute<=P_FSSymbolTable::GFID) //fs-items are sorted on attribute
		{
			if((*it)->attribute==P_FSSymbolTable::GFID)
			{
				list<list<bitwiseContext > >::iterator fscontit=exContLists.begin();
				list<P_FStructure *>::iterator fsit;
				for(fsit=GFFS.begin();fsit!=GFFS.end();fsit++,fscontit++)
				{
					if(this==(*fsit))
						break;
				}
				if(fsit!=GFFS.end())
					(*fscontit).push_back(extCont);
				else
				{
					list<bitwiseContext > newlist;
					newlist.push_back(extCont);
					exContLists.push_back(newlist);
					GFFS.push_back(this);
				}
			}
			it++;
		}

		list<P_ContextedValue*> link_values;
		list<P_ContextedValue*>::iterator valit;

		link_values=links->getContextedValues();
		valit=link_values.begin();
		while(valit!=link_values.end())
		{
			P_FStructure *lnk = (*valit)->getFSLink();
			if(lnk && lnk->failed==false && !inNogoods(ContextManager::getUnion(zero,(*valit)->bcontext)))
			{
				bitwiseContext newExCont=ContextManager::getUnion((*valit)->bcontext,extCont);
				((P_ContValFSLink *)(*valit))->link->SearchGFFS(GFFS,exContLists,newExCont);
			}
			valit++;
		}
	}

}

list<P_FSItem*> P_FStructure::SearchGF(vector<P_FStructure *> &visited)
{
	list<P_FSItem*> objlistP_FSItem1 ;/*ADDED IN THIS (LINUX ONLY) VERSION*/
	list<P_FSItem*> ResultList;

	if(!failed)
	{
		list<P_FSItem*>::iterator it;

		it=fs_items.begin();

		while(it!=fs_items.end() && (*it)->attribute<=P_FSSymbolTable::GFID) //fs-items are sorted on attribute
		{
			if((*it)->attribute==P_FSSymbolTable::GFID)
			{
				if(visited.size()>0 && visited[0]!=this)
				{
					visited.push_back(this);
					ResultList.clear();
					return ResultList;
				}
				else
				{
					if(visited.size()==0)
						visited.push_back(this);
					ResultList.push_back(*it);
				}
			}
			it++;
		}

		list<P_ContextedValue*> link_values;
		list<P_ContextedValue*>::iterator valit;

		link_values=links->getContextedValues();
		valit=link_values.begin();
		while(valit!=link_values.end())
		{
			P_FStructure *lnk=(*valit)->getFSLink();
			if(lnk && visited.size()<2 && (visited.size()==0 || lnk!=visited[0]) )
			{	/*CHANGED IN THIS (LINUX ONLY) VERSION
				ResultList.merge(((P_ContValFSLink *)(*valit))->link->SearchGF(visited));
				CHANGED IN THIS (LINUX ONLY) VERSION*/
				objlistP_FSItem1 = ((P_ContValFSLink *)(*valit))->link->SearchGF(visited) ;	
				ResultList.merge(objlistP_FSItem1);
			}
			valit++;
		}
	}

	return ResultList;
}

list<P_FSItem*> P_FStructure::SearchInItemsLinks(PFSsymID att)
{
	list<P_FSItem*> objlistP_FSItem1 ; /*CHANGED IN THIS (LINUX ONLY) VERSION*/	
	
	list<P_FSItem*> ResultList;

	if(!failed)
	{
		list<P_FSItem*>::iterator it;

		it=fs_items.begin();

		while(it!=fs_items.end() && (*it)->attribute<=att) //fs-items are sorted on attribute
		{
			if((*it)->attribute==att)
				ResultList.push_back(*it);
			it++;
		}

		list<P_ContextedValue*> link_values;
		list<P_ContextedValue*>::iterator valit;

		link_values=links->getContextedValues();
		valit=link_values.begin();
		while(valit!=link_values.end())
		{
			if((*valit)->getFSLink())
			{	/*CHANGED IN THIS (LINUX ONLY) VERSION
				ResultList.merge(((P_ContValFSLink *)(*valit))->link->SearchInItemsLinks(att));
				CHANGED IN THIS (LINUX ONLY) VERSION*/
				objlistP_FSItem1 = ((P_ContValFSLink *)(*valit))->link->SearchInItemsLinks(att) ;
				ResultList.merge(objlistP_FSItem1);
			}
			valit++;
		}
	}

	return ResultList;
}

P_FSItem* P_FStructure::SearchInItemsUnordered(PFSsymID att)
{
	list<P_FSItem*> ResultList;
	list<P_FSItem*>::iterator it;

	it=fs_items.begin();

	while(it!=fs_items.end())
	{
		if((*it)->attribute==att)
			return *it;
		it++;
	}

	return NULL;
}

P_FSItem* P_FStructure::SearchInConstraintsUnordered(PFSsymID att)
{
	list<P_FSItem*> ResultList;
	list<P_FSItem*>::iterator it;

	it=constraints.begin();

	while(it!=constraints.end())
	{
		if((*it)->attribute==att)
			return *it;
		it++;
	}

	return NULL;
}

list<P_FSItem*> P_FStructure::GetItemsDeep()
{
	list<P_FSItem*> objlistP_FSItem1 ;/*ADDED IN THIS (LINUX ONLY) VERSION*/

	list<P_FSItem*> ResultList=fs_items;
	list<P_ContextedValue*> link_values;
	list<P_ContextedValue*>::iterator valit;
	link_values=links->getContextedValues();
	valit=link_values.begin();
	while(valit!=link_values.end())
	{
		if((*valit)->getFSLink())
		{
			/*CHANGED IN THIS (LINUX ONLY) VERSION
			ResultList.merge(((P_ContValFSLink *)(*valit))->link->GetItemsDeep());
			CHANGED IN THIS (LINUX ONLY) VERSION*/
			objlistP_FSItem1 = ((P_ContValFSLink *)(*valit))->link->GetItemsDeep() ;	
			 ResultList.merge(objlistP_FSItem1); 
		}
		valit++;
	}

	return ResultList;
}

list<P_ContextedValue*> P_FStructure::FindValuesDeep(PFSsymID att, list<bitwiseContext > &nogoodsbelow)
{
	list<P_FSItem*> ItemsList=SearchInItemsLinks(att);
	list<P_FSItem*>::iterator it=ItemsList.begin();
	list<P_ContextedValue*> Result;
	list<P_ContextedValue*>::iterator valit;
	list<bitwiseContext >::iterator nogoodit;
	list<P_ContextedValue*> values;
	P_FStructure *pfs;
	while(it!=ItemsList.end())
	{
		//if((*it)->attribute==att)
		//{
			values=(*it)->getContextedValues();
			valit=values.begin();
			while(valit!=values.end())
			{
				nogoodit=nogoods.begin();
				while(nogoodit!=nogoods.end())
				{
					if(ContextManager::getIntersection(*nogoodit,(*valit)->bcontext)==(*nogoodit))
					{
						break;
					}
					nogoodit++;
				}
				if(nogoodit==nogoods.end())
					Result.push_back(*valit);
				valit++;
			}
			//break;
		//}
		it++;
	}

	if(Result.size()>0)
	{
		bitwiseContext nogoodunion;

		for(list<P_ContextedValue*>::iterator rit=Result.begin();rit!=Result.end();rit++)
		{
			nogoodunion=ContextManager::getUnion(nogoodunion,(*rit)->bcontext);
		}

		nogoodit=nogoods.begin();
		while(nogoodit!=nogoods.end())
		{
			if(ContextManager::getIntersection(*nogoodit,nogoodunion)==(*nogoodit))
			{
				nogoodsbelow.push_back(*nogoodit);
			}
			nogoodit++;
		}
	}

	return Result;
}

list<P_ContextedValue*> P_FStructure::FindValuesDeepWithContext(PFSsymID att, list<bitwiseContext > &nogoods_below, bitwiseContext & ext_context)
{
	list<P_ContextedValue*> objlistP_FSItem1 ;/*ADDED IN THIS (LINUX ONLY) VERSION*/
	
	//list<P_FSItem*> ItemsList=SearchInItemsLinks(att);
	list<P_FSItem*>::iterator it=fs_items.begin();
	list<P_ContextedValue*> Result;
	list<P_ContextedValue*>::iterator valit;
	list<bitwiseContext >::iterator nogoodit;
	list<P_ContextedValue*> values;

	P_FStructure *pfs;
	while(it!=fs_items.end() && (*it)->attribute<=att)	//assyming items are sorted
	{
		if( (*it)->attribute==att ) 
		{
			values=(*it)->getContextedValues();
			valit=values.begin();
			while(valit!=values.end())
			{
				nogoodit=nogoods.begin();
				while(nogoodit!=nogoods.end())
				{
					if(ContextManager::getIntersection(*nogoodit,(*valit)->bcontext)==(*nogoodit))
					{
						break;
					}
					nogoodit++;
				}
				if(nogoodit==nogoods.end())
				{
					P_ContextedValue * cv=(*valit)->makeCopy();
					//cv->bcontext.clear();//for the time being
					cv->bcontext=ContextManager::getUnion(cv->bcontext,ext_context);
					Result.push_back(cv);
				}
				valit++;
			}
		}
		it++;
	}

	/*if(Result.size()>0)
	{
		bitwiseContext nogoodunion;

		for(list<P_ContextedValue*>::iterator rit=Result.begin();rit!=Result.end();rit++)
		{
			nogoodunion=ContextManager::getUnion(nogoodunion,(*rit)->bcontext);
		}

		nogoodit=nogoods.begin();
		while(nogoodit!=nogoods.end())
		{
			if(IsContextSubset(*nogoodit,nogoodunion))
			{
				nogoods_below.push_back(*nogoodit);
			}
			nogoodit++;
		}
	}*/

	list<P_ContextedValue*> link_values;
	link_values=links->getContextedValues();
	valit=link_values.begin();
	while(valit!=link_values.end())
	{
		if( (*valit)->getFSLink()  && !inNogoods((*valit)->bcontext) )
		{

			//bitwiseContext new_ext_context=ContextManager::getUnion(ext_context,(*valit)->bcontext);
			bitwiseContext new_ext_context=ext_context;
			bitwiseContext val_context=(*valit)->bcontext;
			new_ext_context=ContextManager::getUnion(new_ext_context,val_context);

			/*CHANGED IN THIS (LINUX ONLY) VERSION
			Result.merge( ((P_ContValFSLink *)(*valit))->link->FindValuesDeepWithContext(att,nogoods_below,new_ext_context));
			CHANGED IN THIS (LINUX ONLY) VERSION*/
			objlistP_FSItem1 = ((P_ContValFSLink *)(*valit))->link->FindValuesDeepWithContext(att,nogoods_below,new_ext_context);
			Result.merge(objlistP_FSItem1);	

		}
		valit++;
	}

	/*
		if( (*valit)->getFSLink() && !inNogoods((*valit)->bcontext) )
			{
				vector<list<P_ContextedValue*> > ResList;
				ResList.resize(P_FSSymbolTable::Subcats.size());
				nogoodsbelow=((P_ContValFSLink *)(*valit))->link->SearchSubcatsDeepWithContext2(ResList);

				for(int x=0;x<ResList.size();x++)
				{
					if(ResList[x].size())
					{
						for(scvalit=ResList[x].begin(); scvalit!=ResList[x].end(); scvalit++)
						{
							(*scvalit)->bcontext = ContextManager::getUnion( (*valit)->bcontext , (*scvalit)->bcontext ) ;
							if(!inNogoods( (*scvalit)->bcontext  ))
							{
								ResultList[x].push_back(*scvalit);
							}
							else
							{
								localnogoods.push_back( (*scvalit)->bcontext );
							}
						}
					}
				}
			}
	*/
	return Result;
}

void P_FStructure::resolveValueLinks(void)
{
	list<P_ContextedValue*> values;
	list<P_ContextedValue*> valuesbelow;
	list<list<P_ContextedValue*> > allvaluesbelow;
	for(list<P_FSItem*>::iterator it=fs_items.begin();it!=fs_items.end();it++)
	{
		//values=(*it)->getContextedValues();
		byte att_type_byte = (*it)->getAttributeType();
		if((*it)->getSimpleValue()==0 && (*it)->attribute!=P_FSSymbolTable::IndexID)
		{
			for(list<P_ContextedValue*>::iterator valit=((P_FSItemComplex *)(*it))->contexted_values.begin();valit!=((P_FSItemComplex *)(*it))->contexted_values.end();valit++)
			{
				if((*valit)->getFSLink()&&(*valit)->getFSLinkValue())
				{
					list<bitwiseContext > nogoodsbelow;
					byte value_type_byte = (*valit)->getValueType();

					valuesbelow=((*valit)->getFSLink())->FindComplextValuesDeep(P_FSSymbolTable::getSym((*valit)->getFSLinkValue()),nogoodsbelow,(*valit)->bcontext);

					if(valuesbelow.size()>0)
					{
						((P_ContValFSLink*)(*valit))->link=NULL;	//link is set to null to avoid the deletion of the FS pointed by the value
						delete (*valit);
						(*valit)=(*valuesbelow.begin())->makeCopy();

						if(valuesbelow.size()>1)
						{
							valuesbelow.pop_front();//first value is already assigned
							allvaluesbelow.push_back(valuesbelow);
						}
						nogoods.merge(nogoodsbelow);//same noggod list might be repeated, are we assuming no repeatition??

					}
					else	//see to it, it should be handled during FS conversion
					{
						nogoods.push_back((*valit)->bcontext);//am i right here ?
						((P_ContValFSLink*)(*valit))->link=new P_FStructure();
						//((P_ContValFSLink*)(*valit))->link=0;
						((P_ContValFSLink*)(*valit))->value=0;
						//(*valit)->bcontext.clear();
						
					}
					valuesbelow.clear();
				}
			}
		}

		//values are added at the end to avoid any probelems in the iterator's state
		for(list<list<P_ContextedValue*> >::iterator allvalit=allvaluesbelow.begin();allvalit!=allvaluesbelow.end();allvalit++)
		{
			for(list<P_ContextedValue*>::iterator valit=((*allvalit).begin()/*++*/);valit!=(*allvalit).end();valit++)
			{
				P_ContextedValue *p=(*valit)->makeCopy();
				(*it)->addContextedValue(p);
			}
		}
		allvaluesbelow.clear();
	}

	//noew for links of the type ^=!SOMETHING

	for(list<P_ContextedValue*>::iterator valit=((P_FSItemComplex *)links)->contexted_values.begin();valit!=((P_FSItemComplex *)links)->contexted_values.end();valit++)
	{
		if((*valit)->getFSLink()&&(*valit)->getFSLinkValue())
		{
			list<bitwiseContext > nogoodsbelow;
			byte value_type_byte = (*valit)->getValueType();
			//if ((value_type_byte & COMPLEXVAL) == 0)	// then it's not complex
			//{
			//	valuesbelow=((*valit)->getFSLink())->FindValuesDeep((*valit)->getFSLinkValue(),nogoodsbelow);
			//}
			//else
			//{
				valuesbelow=((*valit)->getFSLink())->FindComplextValuesDeep(P_FSSymbolTable::getSym((*valit)->getFSLinkValue()),nogoodsbelow,(*valit)->bcontext);
			//}

			if(valuesbelow.size()>0)
			{
				((P_ContValFSLink*)(*valit))->link=NULL;	//link is set to null to avoid the deletion of the FS pointed by the value
				delete (*valit);
				(*valit)=(*valuesbelow.begin())->makeCopy();

				if(valuesbelow.size()>1)
				{
					valuesbelow.pop_front();//first value is already assigned
					allvaluesbelow.push_back(valuesbelow);
				}
				nogoods.merge(nogoodsbelow);//same noggod list might be repeated, are we assuming no repeatition??

			}
			else	//see to it, it should be handled during FS conversion
			{
				nogoods.push_back((*valit)->bcontext);//am i right here ?
				((P_ContValFSLink*)(*valit))->link=new P_FStructure();
				//((P_ContValFSLink*)(*valit))->link=0;
				((P_ContValFSLink*)(*valit))->value=0;
				//(*valit)->bcontext.clear();
				
			}
			valuesbelow.clear();
		}
	}

	//constraints  [ ^X =c !Y ] or [ !X =c ^Y ] <-- this makes passives slow but otherwise they may not get a passive parse
	/*
	for(list<P_FSItem*>::iterator it=constraints.begin();it!=constraints.end();it++)
	{
		byte att_type_byte = (*it)->getAttributeType();
		if((*it)->getSimpleValue()==0 && (*it)->attribute!=P_FSSymbolTable::IndexID)
		{
			for(list<P_ContextedValue*>::iterator valit=((P_FSItemComplex *)(*it))->contexted_values.begin();valit!=((P_FSItemComplex *)(*it))->contexted_values.end();valit++)
			{
				if((*valit)->getFSLink()&&(*valit)->getFSLinkValue())
				{
					list<bitwiseContext > nogoodsbelow;
					byte value_type_byte = (*valit)->getValueType();
					valuesbelow=((*valit)->getFSLink())->FindComplextValuesDeep(P_FSSymbolTable::getSym((*valit)->getFSLinkValue()),nogoodsbelow,(*valit)->bcontext);

					if(valuesbelow.size()>0)
					{
						((P_ContValFSLink*)(*valit))->link=NULL;	//link is set to null to avoid the deletion of the FS pointed by the value
						delete (*valit);
						(*valit)=(*valuesbelow.begin())->makeCopy();

						if(valuesbelow.size()>1)
						{
							valuesbelow.pop_front();//first value is already assigned
							allvaluesbelow.push_back(valuesbelow);
						}
						nogoods.merge(nogoodsbelow);//same noggod list might be repeated, are we assuming no repeatition??

					}
					else	//see to it, it should be handled during FS conversion
					{
						nogoods.push_back((*valit)->bcontext);//am i right here ?
						((P_ContValFSLink*)(*valit))->link=new P_FStructure();
						//((P_ContValFSLink*)(*valit))->link=0;
						((P_ContValFSLink*)(*valit))->value=0;
						//(*valit)->bcontext.clear();
						
					}
					valuesbelow.clear();
				}
			}
		}

		//values are added at the end to avoid any probelems in the iterator's state
		for(list<list<P_ContextedValue*> >::iterator allvalit=allvaluesbelow.begin();allvalit!=allvaluesbelow.end();allvalit++)
		{
			for(list<P_ContextedValue*>::iterator valit=((*allvalit).begin());valit!=(*allvalit).end();valit++)
			{
				P_ContextedValue *p=(*valit)->makeCopy();
				(*it)->addContextedValue(p);
			}
		}
		allvaluesbelow.clear();
	}
	*/

	//values are added at the end to avoid any probelems in the iterator's state
	for(list<list<P_ContextedValue*> >::iterator allvalit=allvaluesbelow.begin();allvalit!=allvaluesbelow.end();allvalit++)
	{
		for(list<P_ContextedValue*>::iterator valit=((*allvalit).begin()/*++*/);valit!=(*allvalit).end();valit++)
		{
			P_ContextedValue *p=(*valit)->makeCopy();
			links->addContextedValue(p);
		}
	}
}

list<P_ContextedValue*> P_FStructure::FindComplextValuesDeep(string string_trace, list<bitwiseContext > &nogoodsbelow, bitwiseContext & ext_context)
{
	/*ADDED IN THIS (LINUX ONLY) VERSION*/
	list<P_ContextedValue*> objlistP_FSItem1 ;
	list<P_ContextedValue*> objlistP_FSItem2 ;	
	/*ADDED IN THIS (LINUX ONLY) VERSION*/

	string head;
	list<P_FSItem*> searched_items;
	list<P_FSItem*>::iterator si_it;
	list<P_ContextedValue*> ret_values, current_values;
	list<P_ContextedValue*>::iterator cv_it;
	P_FStructure* furthur_fs;
	if (string_trace.find(' ') == string::npos)	// at end, no furthur break-up
	{
		list<bitwiseContext > nogoodsfrombelow;
		/*CHANGED IN THIS (LINUX ONLY) VERSION
		ret_values.merge(FindValuesDeepWithContext(P_FSSymbolTable::getSymID(string_trace),nogoodsfrombelow,ext_context));
		CHANGED IN THIS (LINUX ONLY) VERSION*/
		objlistP_FSItem1 = FindValuesDeepWithContext(P_FSSymbolTable::getSymID(string_trace),nogoodsfrombelow,ext_context) ;
		ret_values.merge(objlistP_FSItem1);

		//ret_values.merge(FindValuesDeep(P_FSSymbolTable::getSymID(string_trace),nogoodsfrombelow));
		nogoodsbelow.merge(nogoodsfrombelow);
	}
	else	// furthur breakup required
	{
		head = getHeadOfComplexAttr(string_trace);
		searched_items = SearchInItemsLinks(P_FSSymbolTable::getSymID(head));
		for (si_it = searched_items.begin(); si_it != searched_items.end(); si_it++)
		{	
			current_values = (*si_it)->getContextedValues();
			for (cv_it = current_values.begin(); cv_it != current_values.end(); cv_it++)
			{
				// need to get the link from each value and call se
				furthur_fs = (*cv_it)->getFSLinkLink();
				/*CHANGED IN THIS (LINUX ONLY) VERSION
				ret_values.merge(furthur_fs->FindComplextValuesDeep(string_trace,nogoodsbelow,ext_context));
				CHANGED IN THIS (LINUX ONLY) VERSION*/
				objlistP_FSItem2 = furthur_fs->FindComplextValuesDeep(string_trace,nogoodsbelow,ext_context) ;
				ret_values.merge(objlistP_FSItem2);
			}
		}
	}
	return ret_values;
}
//##########TAHIRA#############

bool P_FStructure::FindInParents(P_FStructure *FS)
{
	for(list<P_FStructure *>::iterator it=c_parents.begin();it!=c_parents.end();it++)
	{
		if((*it)==FS)
			return true;
	}
	return false;
}

void P_FStructure::checkConstraints(P_FStructure *FS, bitwiseContext ext_context)
// 3 things to do here:
// 1. check the constraint list with all the items (different from consistency checking because
//	a. if attribute not there then fail;
//	b. attributes like "SUBJ NUM" have not been resolved;)
// 2. check the constraint list with all the links (need a function here that gets the constraint as a 
// parameter and checks if it's ok with the f-structure) - also call checkConstraints for all the links;
// 3. for all the pure links in the items list (like ^SUBJ = !) - those which are stored within a dummy 
// f-structure - call the consistency check for all the !s (these will have the FSATTR bit set; for
// details see void P_FStructure::addItem(P_FSItem* fs_item) above)
// CHANGED (16-01-06), comment above no longer true;
{
	if(!failed)
	{
		if(!conts_checked)
		{
			c_parents.push_back(FS);
			list<P_FSItem*>::iterator constraint_it;
			P_FStructure* constattr_link;
			list< bitwiseContext > returned_nogoods;
			list< bitwiseContext >::iterator ng_it;
			list<P_ContextedValue*>::iterator link_val_it; 
			list<bool*> FoundFlags;
			list<bool*>::iterator flag_it;
			list<P_ContextedValue*> constvals;
			list<P_ContextedValue*>::iterator constvals_it; 
			bool* flag_ptr;
			
			byte operator_check;
			for (constraint_it = constraints.begin(); constraint_it != constraints.end(); constraint_it++)
			{
				operator_check = (*constraint_it)->getAttributeType() & DOWNARROWATTR;
				if(operator_check!=0)
				{
						continue;
				}
				FoundFlags.clear();
				constvals=(*constraint_it)->getContextedValues();
				//FoundFlags.resize(constvals.size(),false);
				for (int i = 0; i < constvals.size(); i++)
				{
					flag_ptr = new bool;
					*flag_ptr = false;
					FoundFlags.push_back(flag_ptr);
				}
				constattr_link = (*constraint_it)->getInstConstAttrLink();
				returned_nogoods = constattr_link->checkConstraint(*constraint_it,FoundFlags);

				#ifdef GenLog
				if(returned_nogoods.size())
				{
					CLogManager::AddMessage(L"Nogoods for constraint failure");
				}
				#endif

				for (ng_it = returned_nogoods.begin(); ng_it != returned_nogoods.end(); ng_it++)
					addNogood(*ng_it);
				
				// only need to use the flags if he constraint is '=c', not when it is !=
				operator_check = (*constraint_it)->getAttributeType() << 3;
				if (operator_check == 128)	// =c, 10 000 000
				{
					operator_check = (*constraint_it)->getAttributeType() & DOWNARROWATTR;
					for(constvals_it=constvals.begin(),flag_it=FoundFlags.begin();constvals_it!=constvals.end();constvals_it++,flag_it++)
					{
						if( !(*(*flag_it)) )
						{
							if(operator_check==0)//^
							{
								if(FS!=constattr_link)
								{
									FS->ex_constraints.push_back(*constraint_it);
									this->ex_constraints.push_back(*constraint_it);
									list<bitwiseContext> list;list.push_back(ext_context);
									FS->ex_contexts.push_back(list);
									break;
								}
								else
								{
									FS->addNogood(ContextManager::getUnion((*constvals_it)->bcontext,ext_context));
								}
								
							}
							else//!
							{
								#ifdef GenLog
								wstring msg=L"Constraint:   ";
								msg+=L"!";
								msg+=Convert_str2wstr(P_FSSymbolTable::getSym((*constraint_it)->attribute));
								msg+=L"=c";
								msg+=Convert_str2wstr( (*constvals_it)->getValString() );
								msg+=L"   failed.    NOT FOUND";
								CLogManager::AddMessage(msg);
								#endif

								addNogood((*constvals_it)->bcontext);
							}
						}
					}
				}
				else
				{
					operator_check = (*constraint_it)->getAttributeType() & DOWNARROWATTR;
					for(constvals_it=constvals.begin(),flag_it=FoundFlags.begin();constvals_it!=constvals.end();constvals_it++,flag_it++)
					{
						if( !(*(*flag_it)) )
						{
							if(operator_check==0)//^
							{
								FS->ex_constraints.push_back(*constraint_it);
								this->ex_constraints.push_back(*constraint_it);
								list<bitwiseContext> list;list.push_back(ext_context);
								FS->ex_contexts.push_back(list);
								break;
							}
						}
					}

				}
			}
			
			// ADDITION 21-01-06
			// call this function for all the links and all the links in the items
			P_FStructure* lnk;

			// doing links first
			list<P_ContextedValue*> link_values = links->getContextedValues();
			list<P_ContextedValue*>::iterator lv_it;
			
			
			for (lv_it = link_values.begin(); lv_it != link_values.end(); lv_it++)
			{
				lnk = (*lv_it)->getFSLinkLink();
				bitwiseContext new_ext_context=ContextManager::getUnion((*lv_it)->bcontext,ext_context);
				lnk->checkConstraints(FS,new_ext_context);
				if(lnk->failed)
				{
					#ifdef GenLog
					CLogManager::AddMessage(L"link failed during constraints checking");
					#endif
					addNogood((*lv_it)->bcontext);
				}
			}


			// do the item links now

			list<P_FSItem*>::iterator items_it;
			byte attr_byte;
			list<P_ContextedValue*> item_link;
			list<P_ContextedValue*>::iterator il_it;
			for (items_it = fs_items.begin(); items_it != fs_items.end(); items_it++)
			{
				attr_byte = (*items_it)->getAttributeType();
				//if (!((attr_byte & FSATTR) == 0))	// fs expected
				{
					item_link = (*items_it)->getContextedValues();
					lnk = (*(item_link.begin()))->getFSLinkLink();	// only one item when an fs is expected
					if(lnk)
					{

						//bitwiseContext new_ext_context=ContextManager::getUnion((*(item_link.begin()))->bcontext,ext_context);
						//lnk->checkConstraints(lnk,new_ext_context);
						#ifdef GenLog
						wstring str=L"Entering in ";
						str+=Convert_str2wstr(P_FSSymbolTable::getSym( (*items_it)->attribute ));
						CLogManager::AddMessage(str);
						#endif
						lnk->checkConstraints(lnk,zero);
						#ifdef GenLog
						str=L"Out of ";
						str+=Convert_str2wstr(P_FSSymbolTable::getSym( (*items_it)->attribute ));
						CLogManager::AddMessage(str);
						#endif

						if(lnk->failed)
						{
							#ifdef GenLog
							wstring msg=Convert_str2wstr( P_FSSymbolTable::getSym((*items_it)->attribute) );
							msg+=L" FS failed during constraints checking";
							CLogManager::AddMessage(msg);
							#endif
							
							addNogood((*(item_link.begin()))->bcontext);

						}
					}
				}
			}
			

			if(FS==this)
			{
				byte operator_check;
				list<list<bitwiseContext> >::iterator context_it;
				context_it=ex_contexts.begin();
				for (constraint_it = ex_constraints.begin(); constraint_it != ex_constraints.end(); constraint_it++,context_it++)
				{
					FoundFlags.clear();
					constvals=(*constraint_it)->getContextedValues();
					for (int i = 0; i < constvals.size(); i++)
					{
						flag_ptr = new bool;
						*flag_ptr = false;
						FoundFlags.push_back(flag_ptr);
					}
					
					returned_nogoods = checkConstraint(*constraint_it,FoundFlags);

					for (ng_it = returned_nogoods.begin(); ng_it != returned_nogoods.end(); ng_it++)
					{
						list<bitwiseContext>::iterator cit;
						for( cit=(*context_it).begin(); cit!=(*context_it).end();cit++)
						{
							addNogood(ContextManager::getUnion(*ng_it,*cit));
						}
					}

					operator_check = (*constraint_it)->getAttributeType() << 3;
					if (operator_check == 128)	// =c, 10 000 000
					{
						for(constvals_it=constvals.begin(),flag_it=FoundFlags.begin();constvals_it!=constvals.end();constvals_it++,flag_it++)
						{
							if( !(*(*flag_it)) )
							{
								//addNogood(ContextManager::getUnion((*constvals_it)->bcontext,*context_it));
								list<bitwiseContext>::iterator cit;
								for(cit=(*context_it).begin();cit!=(*context_it).end();cit++)
								{
									addNogood(ContextManager::getUnion((*constvals_it)->bcontext,*cit));
								}
							}
						}
					}
				}


			}
			conts_checked=true;

			if(!nogoods.empty())
			{
				/*P_SolutionTree sol;
				list<bitwiseContext >::iterator nogoods_it;
				nogoods_it = nogoods.begin();
				for(; nogoods_it != nogoods.end(); nogoods_it++)
				{
					(*nogoods_it).unique();
					sol.addNogoods(abs_sort(*nogoods_it));
				}
				first_solution = sol.getSolution();*/
	        
			//	first_solution = getSolution(nogoods);
				#ifdef GenLog
				CLogManager::AddMessage(L"make solution");
				#endif
				first_solution = makesolution( new2oldContext(nogoods) );
				if(first_solution.empty())
					failed = true;
				else 
					failed = false;
			}
			else 
				failed = false;
		}
		else
		{
			if(!FindInParents(FS))
			{
				//put all extra constraints with path context in FS
				list<P_FSItem*>::iterator constraint_it;
				for (constraint_it = ex_constraints.begin(); constraint_it != ex_constraints.end(); constraint_it++)
				{
					FS->ex_constraints.push_back(*constraint_it);
					list<bitwiseContext> list;list.push_back(ext_context);
					FS->ex_contexts.push_back(list);
				}
			}
			else
			{
				//add this path's context to the FS's extra constraints contexts
				if(ex_constraints.size())
				{
					list<P_FSItem*>::iterator constraint_it;
					list<P_FSItem*>::iterator local_constraint_it=ex_constraints.begin();
					
					list<list<bitwiseContext> >::iterator cont_it=FS->ex_contexts.begin();
					for (constraint_it = FS->ex_constraints.begin(); constraint_it != FS->ex_constraints.end(); constraint_it++,cont_it++)
					{
						if((*constraint_it)==(*local_constraint_it))
						{
							while(local_constraint_it!=ex_constraints.end())
							{
								(*cont_it).push_back(ext_context);
								cont_it++;
								local_constraint_it++;
							}
							break;
						}
					}
				}

				list<P_ContextedValue*> link_values = links->getContextedValues();
				list<P_ContextedValue*>::iterator lv_it;
				P_FStructure *lnk;
				for (lv_it = link_values.begin(); lv_it != link_values.end(); lv_it++)
				{
					lnk = (*lv_it)->getFSLinkLink();
					bitwiseContext new_ext_context=ContextManager::getUnion((*lv_it)->bcontext,ext_context);
					lnk->checkConstraints(FS,new_ext_context);
				}

			}
		}
	}
}

/*list< bitwiseContext > P_FStructure::checkConstraint(P_FSItem* constraint)
// is the same as the above except that instead of doing the checking with all your own constraints do it
// with the constraint sent as the parameter
// CHANGED 16-01-06 (the one above this changed actually): 
// 3 things to do here:
// 1. check the constraint with all the items (different from consistency checking because
//	a. if attribute not there then fail;
//	b. attributes like "SUBJ NUM" have not been resolved;)
// 2. check the constraint with all the links (need a function here that gets the constraint as a 
// parameter and checks if it's ok with the f-structure) - also call checkConstraints for all the links;
// 3. for all the pure links in the items list (like ^SUBJ = !) - those which are stored within a dummy 
// f-structure - call the consistency check for all the !s (these will have the FSATTR bit set; for
// details see void P_FStructure::addItem(P_FSItem* fs_item) above)
{
	byte check_attr_byte;
	list< bitwiseContext > ret_nogoods;
	// go through all the constraints first (1 & 2):
	
	list < bitwiseContext > current_nogoods;
	list < bitwiseContext >::iterator cur_ng_it;

	list<P_FSItem*>::iterator item_it;
    list<P_ContextedValue*> constraint_values, item_values;
	list<P_ContextedValue*>::iterator cval_it, ival_it;	
	list<P_ContextedValue*> this_links;
	list<P_ContextedValue*>::iterator links_it;
	P_FStructure* current_link;
	bool found_attrib = false;
	
	constraint_values = constraint->getContextedValues();
	check_attr_byte = constraint->getAttributeType() & COMPLEXATTR;
	string attribute_string, attribute_head;
	PFSsymID head_ID, attribute;
	if (check_attr_byte == 0)
		attribute=constraint->attribute;
	else
	{
		// so get head to compare with the item attributes: get "SUBJ" from the above example and see 
		// if there are any items with that attribute;
		attribute_string = P_FSSymbolTable::getSym(constraint->attribute);
		attribute_head = getHeadOfComplexAttr(attribute_string);
		head_ID = P_FSSymbolTable::getSymID(attribute_head);
		attribute = head_ID;
	}
		

	// first check all items (1)
	item_it = fs_items.begin();
	while ((item_it != fs_items.end()) && (attribute >= (*item_it)->attribute))
	{
		if (check_attr_byte == 0)	// then it's not complex
		{
			// have found matching attribute in item list
			if (constraint->attribute == (*item_it)->attribute)
			{
				// check all the values in the constraint with all the values in the item
				item_values = (*item_it)->getContextedValues();
				for (cval_it = constraint_values.begin(); cval_it != constraint_values.end(); cval_it++)
				{	
					for (ival_it = item_values.begin(); ival_it != item_values.end(); ival_it++)
					{
						if (!opposingContextsPresent((*cval_it)->bcontext, (*ival_it)->bcontext))
						{
							if (!(*cval_it)->isConsistent(*ival_it))
								ret_nogoods.push_back(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext));
						}
					}
				}
			}
			else
			{
				// REPLACED (because it might find that the constraint has been fulfilled in link)
				/*
				// constraint had failed due to the non-existence of the attribute in the items,
				// so add it's context to the nogoods
				for (cval_it = constraint_values.begin(); cval_it != constraint_values.end(); cval_it++)
					ret_nogoods.push_back((*cval_it)->bcontext);
				*/
				// REPLACEMENT
				// go through all links passing on the constraint


				//##TAHIRA## Commented by me, Tahira. i think need not be done in every iteration
				//this_links = links->getContextedValues();

				//for (links_it = this_links.begin(); links_it != this_links.end(); links_it++)
				//{
				//	current_link = (*links_it)->getFSLinkLink();
				//	current_nogoods = current_link->checkConstraint(constraint);
				//	for	(cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
				//		ret_nogoods.push_back(*cur_ng_it);
				//}
			/*}
		}
		else	// attribute of constraint is complex e.g. ^SUBJ NUM =c SG
		{
			// have found matching attribute in item list
			if (head_ID == (*item_it)->attribute)
			{
				// now have to find out what value is required (from the attribute string obtained from
				// the constraint), trace that out and check it's consistency with the values in the 
				// constraints
				
				// for the next function call we need the dummy f-structure that's keeping the links;
				// this should be the first (and only) value in item_it; therefor get it:
				list<P_ContextedValue*> to_get_value;
				list<P_ContextedValue*>::iterator tgv_it;
				P_FStructure* tgv_fs;
				to_get_value = (*item_it)->getContextedValues();
				tgv_it = to_get_value.begin();
				tgv_fs = (*tgv_it)->getFSLinkLink();
				item_values = tgv_fs->getComplexValues(attribute_string);

				// now we have both sets of values; proceed with the checking
				for (cval_it = constraint_values.begin(); cval_it != constraint_values.end(); cval_it++)
				{	
					for (ival_it = item_values.begin(); ival_it != item_values.end(); ival_it++)
					{
						if (!opposingContextsPresent((*cval_it)->bcontext, (*ival_it)->bcontext))
						{
							if (!(*cval_it)->isConsistent(*ival_it))
								ret_nogoods.push_back(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext));
						}
					}
				}
				///////////////////////// OLD FOR SIMPLE
				/*
				// check all the values in the constraint with all the values in the item
				item_values = (*item_it)->getContextedValues();
				for (cval_it = constraint_values.begin(); cval_it != constraint_values.end(); cval_it++)
				{	
					for (ival_it = item_values.begin(); ival_it != item_values.end(); ival_it++)
					{
						if (!(*cval_it)->isConsistent(*ival_it))
							ret_nogoods.push_back(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext));
					}
				}
				*/
				////////////////////////// END OF OLD FOR SIMPLE
			/*}
			else
			{
				// REPLACED (because it might find that the constraint has been fulfilled in link)
				/*
				// constraint had failed due to the non-existence of the attribute in the items,
				// so add it's context to the nogoods
				for (cval_it = constraint_values.begin(); cval_it != constraint_values.end(); cval_it++)
					ret_nogoods.push_back((*cval_it)->bcontext);
				*/
				// REPLACEMENT
				// go through all links passing on the constraint

				//##TAHIRA## Commented by me, Tahira. i think need not be done in every iteration
				//this_links = links->getContextedValues();

				//for (links_it = this_links.begin(); links_it != this_links.end(); links_it++)
				//{
				//	current_link = (*links_it)->getFSLinkLink();
				//	current_nogoods = current_link->checkConstraint(constraint);
				//	for	(cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
				//		ret_nogoods.push_back(*cur_ng_it);
				//}
			/*}
		}
		item_it++;
	}*/

	/*
	// now check all links (2)
	this_links = links->getContextedValues();

	for (links_it = this_links.begin(); links_it != this_links.end(); links_it++)
	{
		current_link = (*links_it)->getFSLinkLink();
		current_nogoods = current_link->checkConstraint(constraint);
		for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
			ret_nogoods.push_back(*cur_ng_it);
		
		current_link->checkConstraints();	// calling same for all links
	}
	*/

	// re-doing (2) (see above)
	/*this_links = links->getContextedValues();

	for (links_it = this_links.begin(); links_it != this_links.end(); links_it++)
	{
		current_link = (*links_it)->getFSLinkLink();
		current_nogoods = current_link->checkConstraint(constraint);
		for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
			ret_nogoods.push_back(*cur_ng_it);
	}*/

	//if(ret_nogoods.size()==0)
	//	ret_nogoods.push_back((*cval_it)->bcontext);

	// NOT REQUIRED 21-01-06
	/*
	// 3. for all ^X = ! type items call same function for all the links
	byte attr_byte = 0;
	list<P_ContextedValue*> item_link_vals;
	list<P_ContextedValue*>::iterator ilvals_it;
	P_FStructure* item_link;
	for (item_it = fs_items.begin(); item_it != fs_items.end(); item_it++)
	{
		attr_byte = (*item_it)->getAttributeType();	
		if (attr_byte && FSATTR == 0)	// this means that it will be a type that has a ! value
		{
			item_link_vals = (*item_it)->getContextedValues();
			for (ilvals_it = item_link_vals.begin(); ilvals_it != item_link_vals.end(); ilvals_it++)
			{
				item_link = (*ilvals_it)->getFSLinkLink();
				item_link->checkConstraints();
			}
		}
	}
	*//*
	return ret_nogoods;
}*/

list< bitwiseContext > P_FStructure::checkConstraint(P_FSItem* constraint,list<bool*> &FoundFlags)
// is the same as the above except that instead of doing the checking with all your own constraints do it
// with the constraint sent as the parameter
// CHANGED 16-01-06 (the one above this changed actually): 
// 3 things to do here:
// 1. check the constraint with all the items (different from consistency checking because
//	a. if attribute not there then fail;
//	b. attributes like "SUBJ NUM" have not been resolved;)
// 2. check the constraint with all the links (need a function here that gets the constraint as a 
// parameter and checks if it's ok with the f-structure) - also call checkConstraints for all the links;
// 3. for all the pure links in the items list (like ^SUBJ = !) - those which are stored within a dummy 
// f-structure - call the consistency check for all the !s (these will have the FSATTR bit set; for
// details see void P_FStructure::addItem(P_FSItem* fs_item) above)
{
	byte check_attr_byte;
	list< bitwiseContext > ret_nogoods;
	// go through all the constraints first (1 & 2):
	/* REMOVED FOR THIS (DOS/LINUX) VERSION
	#ifndef DEBUG
	current_time = clock();
	if ((current_time - start_time)>max_time)
	{
		ret_nogoods.push_back(zero);
        return ret_nogoods;
	}
	#endif
	REMOVED FOR THIS (DOS/LINUX) VERSION*/

	list < bitwiseContext > current_nogoods;
	list < bitwiseContext >::iterator cur_ng_it;
	list<bool*>::iterator flags_it;

	list<P_FSItem*>::iterator item_it;
    list<P_ContextedValue*> constraint_values, item_values;
	list<P_ContextedValue*>::iterator cval_it, ival_it;	
	list<P_ContextedValue*> this_links;
	list<P_ContextedValue*>::iterator links_it;
	P_FStructure* current_link;
	bool found_attrib = false;
	bool complex_val;
	
	// need to check if the constraint is an '=c' or a '!='
	byte operator_check = constraint->getAttributeType() << 3;

	constraint_values = constraint->getContextedValues();
	check_attr_byte = constraint->getAttributeType() & COMPLEXATTR;
	string attribute_string, attribute_head, val_string;
	PFSsymID head_ID, attribute;
	if (check_attr_byte == 0)
		attribute=constraint->attribute;
	else
	{
		// so get head to compare with the item attributes: get "SUBJ" from the above example and see 
		// if there are any items with that attribute;
		attribute_string = P_FSSymbolTable::getSym(constraint->attribute);
		attribute_head = getHeadOfComplexAttr(attribute_string);
		head_ID = P_FSSymbolTable::getSymID(attribute_head);
		attribute = head_ID;
	}
		
	
	{
	// first check all items (1)
	item_it = fs_items.begin();
	while ((item_it != fs_items.end()) && (attribute >= (*item_it)->attribute))
	{
		if (check_attr_byte == 0)	// then it's not complex
		{
			// have found matching attribute in item list
			if (constraint->attribute == (*item_it)->attribute)
			{
				// check all the values in the constraint with all the values in the item
				item_values = (*item_it)->getContextedValues();
				for (cval_it = constraint_values.begin(),flags_it=FoundFlags.begin(); cval_it != constraint_values.end(); cval_it++,flags_it++)
				{	
					for (ival_it = item_values.begin(); ival_it != item_values.end(); ival_it++)
					{
						if (!ContextManager::opposingContextsPresent((*cval_it)->bcontext, (*ival_it)->bcontext))
						{
							if (operator_check == 128)	// =c, 10 000 000
							{
								if (!(*cval_it)->isConsistent(*ival_it))
								{
									ret_nogoods.push_back(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext));

									#ifdef GenLog
									wstring msg=L"Constraint:   ";
									byte operator_check = constraint->getAttributeType() & DOWNARROWATTR;
									if(operator_check == 0)	msg+=L"^";
									else msg+=L"!";
									msg+=Convert_str2wstr(P_FSSymbolTable::getSym(attribute));
									msg+=L"=c";
									msg+=Convert_str2wstr( (*cval_it)->getValString() );
									msg+=L"   failed.\r\n\t\t value found = ";
									msg+=Convert_str2wstr( (*ival_it)->getValString() );
									CLogManager::AddMessage(msg);
									/* CHANGED IN THIS (LINUX ONLY) VERSION
									LogContextByteList( ContextManager::convertbitwiseContextToList(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext)) );
									CHANGED IN THIS (LINUX ONLY) VERSION */
									/*CHANGE*/
									bitwiseContext btw_context = ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext);
									LogContextByteList( ContextManager::convertbitwiseContextToList(btw_context) );
									/*END CHANGE*/
									#endif
								}
							}
							else
							{	
								if ((*cval_it)->isConsistent(*ival_it))
								{
									ret_nogoods.push_back(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext));

									#ifdef GenLog
                                    wstring msg=L"Constraint:   ~[";
									byte operator_check = constraint->getAttributeType() & DOWNARROWATTR;
									if(operator_check == 0)	msg+=L"^";
									else msg+=L"!";
									msg+=Convert_str2wstr(P_FSSymbolTable::getSym(attribute));
									msg+=L"=c";
									msg+=Convert_str2wstr( (*cval_it)->getValString() );
									msg+=L"   failed.\r\n\t\t value found = ";
									msg+=Convert_str2wstr( (*ival_it)->getValString() );
									CLogManager::AddMessage(msg);
									/* CHANGED IN THIS (LINUX ONLY) VERSION
									LogContextByteList( ContextManager::convertbitwiseContextToList(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext)) );
									CHANGED IN THIS (LINUX ONLY) VERSION */
									/*CHANGE*/
									bitwiseContext btw_context = ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext);
									LogContextByteList( ContextManager::convertbitwiseContextToList(btw_context) );
									/*CHANGE*/
									#endif
								}
							}
							*(*flags_it)=true;
						}
					}
				}
			}

		}
		else	// attribute of constraint is complex e.g. ^SUBJ NUM =c SG
		{
			// have found matching attribute in item list
			if (head_ID == (*item_it)->attribute)
	
		{
				// now have to find out what value is required (from the attribute string obtained from
				// the constraint), trace that out and check it's consistency with the values in the 
				// constraints
				
				// for the next function call we need the dummy f-structure that's keeping the links;
				// this should be the first (and only) value in item_it; therefor get it:
				list<P_ContextedValue*> to_get_value;
				list<P_ContextedValue*>::iterator tgv_it;
				P_FStructure* tgv_fs;
				to_get_value = (*item_it)->getContextedValues();
				tgv_it = to_get_value.begin();
				tgv_fs = (*tgv_it)->getFSLinkLink();
				item_values = tgv_fs->getComplexValues(attribute_string);
				//FindComplextValuesDeep(

				// now we have both sets of values; proceed with the checking
				for (cval_it = constraint_values.begin(),flags_it=FoundFlags.begin(); cval_it != constraint_values.end(); cval_it++,flags_it++)
				{	
					for (ival_it = item_values.begin(); ival_it != item_values.end(); ival_it++)
					{
						if (!ContextManager::opposingContextsPresent((*cval_it)->bcontext, (*ival_it)->bcontext))
						{
							if (operator_check == 128)	// =c, 10 000 000
							{
								if (!(*cval_it)->isConsistent(*ival_it))
								{
									ret_nogoods.push_back(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext));

									#ifdef GenLog
									wstring msg=L"Constraint:   ";
									byte operator_check = constraint->getAttributeType() & DOWNARROWATTR;
									if(operator_check == 0)	msg+=L"^";
									else msg+=L"!";
									msg+=Convert_str2wstr(P_FSSymbolTable::getSym(constraint->attribute));
									msg+=L"=c";
									msg+=Convert_str2wstr( (*cval_it)->getValString() );
									msg+=L"   failed.\r\n\t\t value found = ";
									msg+=Convert_str2wstr( (*ival_it)->getValString() );
									CLogManager::AddMessage(msg);
									/* CHANGED IN THIS (LINUX ONLY) VERSION
									LogContextByteList( ContextManager::convertbitwiseContextToList(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext)) );
									CHANGED IN THIS (LINUX ONLY) VERSION */
									/*CHANGE*/
									bitwiseContext btw_context = ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext);
									LogContextByteList( ContextManager::convertbitwiseContextToList(btw_context) );	
									/*END CHANGE*/
									#endif
								}
							}
							else
							{
								if ((*cval_it)->isConsistent(*ival_it))
								{
									ret_nogoods.push_back(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext));

									#ifdef GenLog
									wstring msg=L"Constraint:   ~[";
									byte operator_check = constraint->getAttributeType() & DOWNARROWATTR;
									if(operator_check == 0)	msg+=L"^";
									else msg+=L"!";
									msg+=Convert_str2wstr(P_FSSymbolTable::getSym(constraint->attribute));
									msg+=L"=c";
									msg+=Convert_str2wstr( (*cval_it)->getValString() );
									msg+=L"   failed.\r\n\t\t value found = ";
									msg+=Convert_str2wstr( (*ival_it)->getValString() );
									CLogManager::AddMessage(msg);
									/* CHANGED IN THIS (LINUX ONLY) VERSION
									LogContextByteList(ContextManager::convertbitwiseContextToList(ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext)) );
									/*CHANGE*/
									bitwiseContext btw_context = ContextManager::getUnion((*cval_it)->bcontext, (*ival_it)->bcontext);	
									LogContextByteList(ContextManager::convertbitwiseContextToList(btw_context) );
									/*END CHANGE*/
									#endif
								}
							}
							*(*flags_it)=true;
						}

						//(*ival_it)->makeLinksNull();
						//delete (*ival_it);
					}
				}
			}
		}
		item_it++;
	}

	}
	this_links = links->getContextedValues();

	// changed 27-02-06
	
	for (links_it = this_links.begin(); links_it != this_links.end(); links_it++)
	{
		//if(!opposingContextsPresent((*links_it)->bcontext,))
		{
			current_link = (*links_it)->getFSLinkLink();
			current_nogoods = current_link->checkConstraint(constraint,FoundFlags);
			for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
				ret_nogoods.push_back( ContextManager::getUnion(*cur_ng_it, (*links_it)->bcontext ) );
		}
	}
	/*
	// start of change
	// need to pick out those values of constraints that can validly be checked in each link value
	P_FSItem* valid_constraint = NULL;
//	valid_constraint = constraint->makeCopy();
//	valid_constraint->removeAllValues();
	list<bool*> valid_fflags;
	list<bool*>::iterator ff_it;
	
	for (links_it = this_links.begin(); links_it != this_links.end(); links_it++)
	{
		ff_it = FoundFlags.begin();
		// now check which of the constraint values can be checked validly with this link:
		for (cval_it = constraint_values.begin(); cval_it != constraint_values.end(); cval_it++)
		{
			if (!opposingContextsPresent((*links_it)->bcontext, (*cval_it)->bcontext))
			{
				if (valid_constraint == NULL)
				{
					valid_constraint = constraint->makeCopy();
					valid_constraint->removeAllValues();
				}
				valid_constraint->addContextedValue(*cval_it);
				valid_fflags.push_back(*ff_it);
			}
			ff_it++;
		}
		if (valid_constraint != NULL)
		{
			current_link = (*links_it)->getFSLinkLink();
			current_nogoods = current_link->checkConstraint(valid_constraint,valid_fflags);
			for (cur_ng_it = current_nogoods.begin(); cur_ng_it != current_nogoods.end(); cur_ng_it++)
				ret_nogoods.push_back(ContextManager::getUnion(*cur_ng_it, (*links_it)->bcontext ));
			// re-initialize for next iteration
			valid_constraint->removeAllValues();
			valid_constraint->makeLinksNull();
			delete valid_constraint;
			valid_constraint = NULL;
		}
	}
	// end of change*/

	return ret_nogoods;
}

list<list<contextByte> > getSolsForNogood(list<contextByte> &nogood)
{
	list<list<contextByte> > ret_sols;
	list<contextByte> solution;

	for(list<contextByte>::iterator cont_it=nogood.begin(); cont_it!=nogood.end(); cont_it++)
	{
		if((*cont_it)!=0)
		{
			list<contextByte> current_solution=solution;
			current_solution.push_back(-(*cont_it));
			ret_sols.push_back(current_solution);
			solution.push_back(*cont_it);
		}
	}

	return ret_sols;
}

list<bitwiseContext> FilterNogoodsAgainstSolution(list<bitwiseContext> nogoods,bitwiseContext solution)
{
	list<bitwiseContext> ret_nogoods;
	for(list<bitwiseContext>::iterator ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
	{
		if(!ContextManager::opposingContextsPresent(*ngit,solution))
		{
			ret_nogoods.push_back(*ngit);
		}
	}
	return ret_nogoods;
}

P_FStructure* P_FStructure::extractSolution(list<contextByte> & ext_solution)
{
	if(!failed)
	{
	/*ADDED IN THIS (LINUX ONLY) VERSION*/
	list < list<contextByte> > objlistCB1 ;
	list < list<contextByte> > objlistCB2 ;
	list<contextByte> objlistCB3 ;
	list<contextByte> objlistCB4 ;
	/*ADDED IN THIS (LINUX ONLY) VERSION*/	
	
		//return this;
	P_FStructure * output;
	list<P_ContextedValue*> values;
	list<P_FSItem*>::iterator item_it;
	P_FSItem* item;
	list<contextByte> solution;
	list<P_ContextedValue*> this_links;
	list<P_ContextedValue*>::iterator links_it;
	P_FStructure* current_link;
	P_FStructure* tempFS, * tempFS1;

	list < list<contextByte> > acc_nogoods,acc_solutions,temp;

	for(item_it = fs_items.begin(); item_it != fs_items.end(); item_it++)
	{
		values =(*item_it)->getContextedValues();

		for(list<P_ContextedValue*>::iterator valit=values.begin();valit!=values.end();valit++)
		{
			if((*valit)->zeroValue())
			{
				 tempFS1 = (*valit)->getFSLink();
				 if(tempFS1)
				 {
					/* CHANGED IN THIS (LINUX ONLY) VERSION
					acc_nogoods.merge( new2oldContext(tempFS1->getNogoods()) );
					CHANGED IN THIS (LINUX ONLY) VERSION */
					objlistCB1 = new2oldContext(tempFS1->getNogoods()) ;
					acc_nogoods.merge(objlistCB1);
	
				 	if(tempFS1->failed)
					{
						 addNogood((*valit)->bcontext);
					}
				 }	
			}
		}
	}

	list<bitwiseContext> all_nogoods=GetAllNogoods();
	list<bitwiseContext> filtered_nogoods;
	/*CHANGED IN THIS (LINUX ONLY) VERSION
	acc_nogoods.merge( new2oldContext(all_nogoods) );
	CHANGED IN THIS (LINUX ONLY) VERSION*/
	objlistCB2 = new2oldContext(all_nogoods) ;
	acc_nogoods.merge(objlistCB2);

	#ifdef GenLog
	CLogManager::AddMessage(L"in solution extraction");
	#endif
	
	
	if(!acc_nogoods.empty())
	{
		#ifdef GenLog
		CLogManager::AddMessage(L"__________________________________________________\r\nExternal Solution:");
		LogContextByteList(ext_solution);
		CLogManager::AddMessage(L"Nogoods:");
		LogContextByteLists(acc_nogoods);
		CLogManager::AddMessage(L"CC:");
		LogContextByteLists(new2oldContext(solutions));
		#endif
		
		solution = select_solution2(acc_nogoods,new2oldContext(solutions) );

		if(solution.empty())//num>=40)
		{
			#ifdef GenLog
			CLogManager::AddMessage( L"in SolTree");// (num=" + Convert_str2wstr(int2string(num)) + L")");
			#endif
			{
				if(solutions.size())
				{
					for(list<bitwiseContext>::iterator sol_it=solutions.begin();sol_it!=solutions.end();sol_it++)
					{
						/*CHANGED IN THIS (LINUX ONLY) VERSION
						list<list<contextByte> > sol_nogoods=getSolsForNogood( ContextManager::convertbitwiseContextToList(*sol_it) );
						CHANGED IN THIS (LINUX ONLY) VERSION*/
						objlistCB3 = ContextManager::convertbitwiseContextToList(*sol_it) ;
						list<list<contextByte> > sol_nogoods=getSolsForNogood( objlistCB3 );
						/**/P_SolutionTree sol;

						#ifdef GenLog
						CLogManager::AddMessage(L"Current CC Solution:");
						LogContextByteList(ContextManager::convertbitwiseContextToList(*sol_it));
						#endif

						for(list<list<contextByte> >::iterator sol_ng_it=sol_nogoods.begin();sol_ng_it!=sol_nogoods.end();sol_ng_it++)
						{
							(*sol_ng_it).unique();
							sol.addNogoods(abs_sort(*sol_ng_it));

							//CLogManager::AddMessage(L"Nogood Added:");
							//LogContextByteList(*sol_ng_it);
							//solution = sol.getSolution();
							//CLogManager::AddMessage(L"Current Solution:");
							//LogContextByteList(solution);
						}

						list<list<contextByte> >::iterator nogoods_it;
						filtered_nogoods=FilterNogoodsAgainstSolution(all_nogoods,*sol_it);
						acc_nogoods= new2oldContext(filtered_nogoods);
						nogoods_it = acc_nogoods.begin();
						for(; nogoods_it != acc_nogoods.end(); nogoods_it++)
						{
							(*nogoods_it).unique();
							sol.addNogoods(abs_sort(*nogoods_it));

							//CLogManager::AddMessage(L"Nogood Added:");
							//LogContextByteList(*nogoods_it);
							//solution = sol.getSolution();
							//CLogManager::AddMessage(L"Current Solution:");
							//LogContextByteList(solution);
						}

						solution = sol.getSolution();/**/

						if(!solution.empty() && !(ContextManager::convertListTobitwiseContext(solution)==zero) )
							break;
					}
				}
				else
				{
					/**/P_SolutionTree sol;
					list<list<contextByte> >::iterator nogoods_it;
					nogoods_it = acc_nogoods.begin();
					for(; nogoods_it != acc_nogoods.end(); nogoods_it++)
					{
						(*nogoods_it).unique();
						sol.addNogoods(abs_sort(*nogoods_it));

						//CLogManager::AddMessage(L"Nogood Added:");
						//LogContextByteList(*nogoods_it);
						//solution = sol.getSolution();
						//CLogManager::AddMessage(L"Current Solution:");
						//LogContextByteList(solution);
					}
					solution = sol.getSolution();/**/
				}
				//SolutionMaker sm(150);
				//solution=sm.makeSolution2(acc_nogoods);
				if(solution.empty() || ContextManager::convertListTobitwiseContext(solution)==zero)
				{
					return NULL;
				}
			}
			if(!ext_solution.empty())
			{
				solution.merge(ext_solution);
			}

		}
		else
		{	
			#ifdef GenLog
			CLogManager::AddMessage(L"in BinarySolution");
			#endif
			if(ext_solution.empty())
			{
			}
			else
			{
				//solution = getSolutionConsistent(acc_nogoods,ext_solution);
				//solution = makeconsistentsolution(acc_nogoods,ext_solution);
				//ext_solution.merge(select_solution2(acc_nogoods,new2oldContext(solutions) ));
				//solution=ext_solution;
				solution=select_solution2(acc_nogoods,new2oldContext(solutions) );
				/* CHANGED IN THIS (LINUX ONLY) VERSION
				ext_solution.merge(UnknowContexts(solution,ext_solution));
				CHANGED IN THIS (LINUX ONLY) VERSION */
				objlistCB4 = UnknowContexts(solution,ext_solution);
				ext_solution.merge(objlistCB4);
				solution=ext_solution;
			}
			if(solution.empty() || ContextManager::convertListTobitwiseContext(solution)==zero)
			{
				return NULL;
			}
		}
		#ifdef GenLog
		CLogManager::AddMessage(L"Solution against Nogoods:");
		LogContextByteList(solution);
		#endif

	}



	if(solution.empty())
		solution = ext_solution;
	output = new P_FStructure;
	for(item_it = fs_items.begin(); item_it != fs_items.end(); item_it++)
	{
		item =(*item_it)->getSolution(solution);
		if(item)
			output->addItem(item);

	}

	item = links->getSolution(solution);
	if(item)
		output->links = item;
	ext_solution = solution;

	return output;
	}
	else
		return NULL;
}
P_FStructure* P_FStructure::extractSolutionDeep(list<contextByte> & ext_solution)
{
	if(!failed)
	{
	P_FStructure * output;
	list<P_ContextedValue*> values;
	list<P_FSItem*>::iterator item_it;
	P_FSItem* item;
	list<contextByte> solution;
	list<P_ContextedValue*> this_links;
	list<P_ContextedValue*>::iterator links_it;
	P_FStructure* current_link;
	P_FStructure* tempFS, * tempFS1;

	list < bitwiseContext > acc_nogoods,temp;

	solution = ext_solution;
	output = new P_FStructure;
	for(item_it = fs_items.begin(); item_it != fs_items.end(); item_it++)
	{
		item =(*item_it)->getSolution(solution);
		if(item)
			output->addItem(item);
	}

	item = links->getSolution(solution);
	if(item)
		output->links = item;
	ext_solution = solution;

	return output;
	}
	else
		return NULL;
}

list<P_ContextedValue*> P_FStructure::getComplexValues(string string_trace)
// here we're getting a string with the head broken off, e.g., "NUM" from "SUBJ NUM" or "Y Z" from "X Y Z",
// this f-structure will be the "special dummy" that has the links inserted in it; need to trace out the 
// required values and send them back;
{
	// use this:
	// SearchInItemsLinks
	string head;
	list<P_FSItem*> searched_items;
	list<P_FSItem*>::iterator si_it;
	list<P_ContextedValue*> ret_values, current_values;
	list<P_ContextedValue*>::iterator cv_it;
	list<bitwiseContext > path_context;
	bitwiseContext dummy_context;
	list<bitwiseContext >::iterator cit;
	P_FStructure* furthur_fs;
	if (string_trace.find(' ') == string::npos)	// at end, no furthur break-up
	{
		//searched_items = SearchInItemsLinksWithContext(P_FSSymbolTable::getSymID(string_trace));
		SearchItemsDeepWithContext(P_FSSymbolTable::getSymID(string_trace),searched_items,path_context,dummy_context);
		// get all the values out of all the items and return them
		cit=path_context.begin();
		for (si_it = searched_items.begin(); si_it != searched_items.end(); si_it++,cit++)
		{	
			current_values = (*si_it)->getContextedValues();
			for (cv_it = current_values.begin(); cv_it != current_values.end(); cv_it++)
			{
				P_ContextedValue* one_val=(*cv_it)->makeCopy();
				one_val->addContexts(*cit);
				ret_values.push_back(one_val);
			}
			//delete (*si_it);
		}
	}
	
	else	// furthur breakup required
	{
		head = getHeadOfComplexAttr(string_trace);
		//searched_items = SearchInItemsLinks(P_FSSymbolTable::getSymID(head));
		//searched_items = SearchInItemsLinksWithContext(P_FSSymbolTable::getSymID(head));
		SearchItemsDeepWithContext(P_FSSymbolTable::getSymID(head),searched_items,path_context,dummy_context);
		cit=path_context.begin();
		for (si_it = searched_items.begin(); si_it != searched_items.end(); si_it++,cit++)
		{	
			current_values = (*si_it)->getContextedValues();
			for (cv_it = current_values.begin(); cv_it != current_values.end(); cv_it++)
			{
				// need to get the link from each value and call se
				furthur_fs = (*cv_it)->getFSLinkLink();
				list<P_ContextedValue*> vals_below=furthur_fs->getComplexValues(string_trace);
				for(list<P_ContextedValue*>::iterator vbit=vals_below.begin();vbit!=vals_below.end();vbit++)
				{
					(*vbit)->addContexts(*cit);
					ret_values.push_back((*vbit));
				}
			}
			//delete (*si_it);
		}
	}
	return ret_values;
}

list< bitwiseContext > P_FStructure::getNogoods(void)
{
	return nogoods;
}

list<P_FSItem*> P_FStructure::getConstraintsFromLinks(void)
// need to traverse all the links here and get all constraints that we find along the way
{
	list<P_FSItem*> collected_constraints;
	list<P_FSItem*> constraints_from_links;
	list<P_FSItem*>::iterator cfl_it;

	// collect the constraints that you have (make copies)
	list<P_FSItem*>::iterator const_it;
	for (const_it = constraints.begin(); const_it != constraints.end(); const_it++)
		collected_constraints.push_back((*const_it)->makeCopy());
	
	// now call same for all the links
	list<P_ContextedValue*> link_values;
	list<P_ContextedValue*>::iterator links_it;
	P_FStructure* a_link;
	
	link_values = links->getContextedValues();

	list<P_ContextedValue*> values_in_const;
	list<P_ContextedValue*>::iterator vic_it;

	for (links_it = link_values.begin(); links_it != link_values.end(); links_it++)
	{
		a_link = (*links_it)->getFSLinkLink();
		constraints_from_links = a_link->getConstraintsFromLinks();
		// to each of these constraints we need to add the context of the link itself
		for (cfl_it = constraints_from_links.begin(); cfl_it != constraints_from_links.end(); cfl_it++)
		{
			// need to do it for each value
			values_in_const = (*cfl_it)->getContextedValues();
			for (vic_it = values_in_const.begin(); vic_it != values_in_const.end(); vic_it++)
				//(*vic_it)->addContexts((*links_it)->bcontext);
				(*vic_it)->bcontext = ContextManager::getUnion( (*vic_it)->bcontext , (*links_it)->bcontext );
			// now add this to the final list
			collected_constraints.push_back(*cfl_it);
		}
	}

	return collected_constraints;
}

list<bitwiseContext > P_FStructure::GetNogoodsDeep(list<contextByte> solution)
{
    list<bitwiseContext > retList;
	bitwiseContext bsolution=ContextManager::convertListTobitwiseContext(solution);

	if(!failed)
	{
		retList=nogoods;
		list<P_ContextedValue*> link_values;
		list<P_ContextedValue*>::iterator valit;
		link_values=links->getContextedValues();
		valit=link_values.begin();
		list<bitwiseContext > nogoodsbelow;

		while(valit!=link_values.end())
		{
				if(solution.empty() || !ContextManager::opposingContextsPresent((*valit)->bcontext,bsolution))
				{
					if((*valit)->getFSLink())
					{
						nogoodsbelow=((*valit)->getFSLink())->GetNogoodsDeep(solution);
						for(list<bitwiseContext >::iterator ngit=nogoodsbelow.begin();ngit!=nogoodsbelow.end();ngit++)
						{
							(*ngit)=ContextManager::getUnion((*ngit),(*valit)->bcontext);
							retList.push_back(*ngit);
						}
					}
				}
				valit++;
		}

		//by passing -set-element
		/*list<P_FSItem*>::iterator it;
		it=fs_items.begin();
		while(it!=fs_items.end())// && (*it)->attribute<=att) //fs-items are sorted on attribute
		{
			if((*it)->attribute==P_FSSymbolTable::getSymID("SET"))
			{
				P_FStructure *set_fs= (*(*it)->getContextedValues().begin())->getFSLinkLink();
				if(set_fs)
				{
					list<P_FSItem*>::iterator elem_it;
					list<P_FSItem*> set_elements=set_fs->GetItemsDeep();
					elem_it=set_elements.begin();
					while(elem_it!=set_elements.end())
					{
						P_FStructure *elem_fs= (*(*elem_it)->getContextedValues().begin())->getFSLinkLink();
						if(elem_fs)
						{
							nogoodsbelow=elem_fs->GetNogoodsDeep(solution);
							for(list<bitwiseContext >::iterator ngit=nogoodsbelow.begin();ngit!=nogoodsbelow.end();ngit++)
							{
								(*ngit)=ContextManager::getUnion((*ngit),(*(*elem_it)->getContextedValues().begin())->bcontext);
								retList.push_back(*ngit);
							}
						}
						elem_it++;
					}
				}
			}
			it++;
		}*/
	}
	
	return retList;

}

list<bitwiseContext > P_FStructure::GetSolutionsDeep()

{
    list<bitwiseContext > retList;
	//if(!nogoods_extracted && !failed)
	if(!failed)
	{
		retList=solutions;
		list<P_ContextedValue*> link_values;
		list<P_ContextedValue*>::iterator valit;
		link_values=links->getContextedValues();
		valit=link_values.begin();

		while(valit!=link_values.end())
		{
				list<bitwiseContext > sol_below;
				if((*valit)->getFSLink())
				{
                    sol_below=((*valit)->getFSLink())->GetSolutionsDeep();
					retList.merge(sol_below);
				}
				valit++;
		}

	}
	return retList;
}
void P_FStructure::verifySolution(list<contextByte> & solution)
{
	//return;
	if(!failed)
	{
	P_FStructure * output;
	list<P_ContextedValue*> values;
	list<P_FSItem*>::iterator item_it, temp_it;
	P_FSItem* item;
	//bitwiseContext solution;
	list<P_ContextedValue*> this_links;
	list<P_ContextedValue*>::iterator links_it;
	P_FStructure* current_link;
	P_FStructure* tempFS, * tempFS1;

	for(item_it = fs_items.begin(); item_it != fs_items.end(); item_it++)
	{
		(*item_it)->verifySolution(solution);
		values = (*item_it)->getContextedValues();
		if(values.empty())
		{
			temp_it = item_it;
			item_it++;
			fs_items.erase(temp_it);
		}
	}
		links->verifySolution(solution);
	}
}

list<bitwiseContext > P_FStructure::GetAllNogoods()

{

    list<bitwiseContext > retList;

	if(!failed)
	{
		retList=nogoods;
		list<P_ContextedValue*> link_values;
		list<P_ContextedValue*>::iterator valit;
		link_values=links->getContextedValues();
		valit=link_values.begin();
		list<bitwiseContext > nogoodsbelow;

		while(valit!=link_values.end())
		{
			if((*valit)->getFSLink())
			{
				nogoodsbelow=((*valit)->getFSLink())->GetAllNogoods();
				for(list<bitwiseContext >::iterator ngit=nogoodsbelow.begin();ngit!=nogoodsbelow.end();ngit++)
				{
					(*ngit)=ContextManager::getUnion((*ngit),(*valit)->bcontext);
					retList.push_back(*ngit);
				}
			}
			valit++;
		}

		list<P_FSItem*>::iterator item_it;
		list<P_ContextedValue*> values;
		for(item_it = fs_items.begin(); item_it != fs_items.end(); item_it++)
		{
			if( !P_FSSymbolTable::isIsolatedFS((*item_it)->attribute) )
			{
				values = (*item_it)->getContextedValues();
				valit=values.begin();
				while(valit!=values.end())
				{
					if((*valit)->getFSLink())// && (*valit)->getFSLink()->solutions.empty())
					{
						nogoodsbelow=((*valit)->getFSLink())->GetAllNogoods();
						for(list<bitwiseContext >::iterator ngit=nogoodsbelow.begin();ngit!=nogoodsbelow.end();ngit++)
						{
							(*ngit)=ContextManager::getUnion((*ngit),(*valit)->bcontext);
							retList.push_back(*ngit);
						}
						//retList.merge(nogoodsbelow);
					}
					valit++;
				}
			}
		}

	}
	
	return retList;

}
