#pragma once
/*ADDED IN THIS (LINUX) VERSION*/
#ifndef P_FSTRUCTURE_H
#define P_FSTRUCTURE_H
/*ADDED IN THIS (LINUX) VERSION*/
#include "P_FSItem.h"
#include "P_ContextedValue.h"
#include "P_FSSymbolTable.h"
#include "P_FSItemSimple.h"
#include "P_FSItemComplex.h"
#include "P_ConValPlainValList.h"
#include "P_ConValFDLink.h"
#include "P_FSSymbolTable.h"
#include "fsglobal.h"
#include "global.h"
#include "P_Lexicon.h"
#include <math.h>
#include "ContextManager.h"

#include <list>

using namespace std;

class P_FStructure
{
public:
	P_FStructure(void);
	~P_FStructure(void);
	list<P_FSItem*> fs_items;
	list<P_FSItem*> constraints;
	P_FSItem* links;
	void addItem(P_FSItem* fs_item);
	void addConstraint(P_FSItem* constraint);
	void addLink(P_FSItem* link);
	void unify(void);
	void addNogood(bitwiseContext nogood);
private:    
	list< bitwiseContext > nogoods;
	list<contextByte> first_solution;
public:
	/* REMOVING FOR THIS (DOS/LINUX) VERSION
	static clock_t start_time;
	static clock_t max_time;
	clock_t end_time;
	REMOVING FOR THIS (DOS/LINUX) VERSION */
	list<P_FSItem*> ex_constraints;
	list<list<bitwiseContext> > ex_contexts;
	list<P_FStructure*> c_parents;
	bool FindInParents(P_FStructure *FS);
	//##########TAHIRA#############
	bool conts_checked;
	bool cc_checked;
	bool failed;
	bool nogoods_extracted;
	bool unified;
	list<bitwiseContext > solutions;

	void CheckCompleteness(); 
	list<P_FSItem*> SearchInItemsLinks(PFSsymID Att); // search Att(SUB OBJ NUM etc) in This FS
	list<P_FSItem*> SearchInItemsLinksWithContext(PFSsymID Att); // search Att(SUB OBJ NUM etc) in This FS
	bool SearchItemsDeepWithContext(PFSsymID att,list<P_FSItem*> &ResultList, list<bitwiseContext > &exContList, bitwiseContext extCont);
	P_FSItem* SearchInItemsUnordered(PFSsymID att); //does not search in links and constraints, does not assume any order of fs-items
	P_FSItem* SearchInConstraintsUnordered(PFSsymID att);
	list<P_FSItem*> GetItemsDeep();
	list<P_ContextedValue*> FindValuesDeep(PFSsymID att, list<bitwiseContext > &nogoodsbelow); //can find values with nogoods, deep down in links (only one level of depth is assumed)
	list<P_ContextedValue*> FindComplextValuesDeep(string long_att, list<bitwiseContext > &nogoodsbelow,bitwiseContext & ext_context); //can find complex values deep down in links (only one level of depth is assumed)
	void resolveValueLinks(void); //puts actual values in the place of !featurename like !NUM
	list<bitwiseContext > SearchSubcatsDeepWithContext(vector<list<P_ContextedValue*> > &ResultList, vector<list<bitwiseContext > > &exContList);
	list<bitwiseContext > SearchSubcatsDeepWithContext2(vector<list<P_ContextedValue*> > &ResultList);
	bool inNogoods(bitwiseContext context);
	P_FStructure* extractSolutionDeep(list<contextByte> & ext_solution);
	list<bitwiseContext > GetNogoodsDeep(list<contextByte> solution);
	list<bitwiseContext > GetAllNogoods();
	list<bitwiseContext > GetSolutionsDeep();
	list<P_ContextedValue*> FindValuesDeepWithContext(PFSsymID att, list<bitwiseContext > &nogoods_below, bitwiseContext & ext_context);
	list<P_FSItem*> SearchGF(vector<P_FStructure *> &visited);
	void SearchGFFS(list<P_FStructure *> &GFFS, list<list<bitwiseContext > > &exContLists, bitwiseContext extCont);
	//##########TAHIRA#############
	
	list< bitwiseContext > isConsistentWithItem(P_FSItem* in_item);
	void checkItemsConsistency(void);
	void checkItemsLinksConsistency(void);
	void checkLinkLinksConsistency(void);
	list< bitwiseContext > isConsistentWithFS(P_FStructure* in_fs);
	void checkConstraints(P_FStructure *FS, bitwiseContext ext_context);
	list< bitwiseContext > checkConstraint(P_FSItem* constraint,list<bool*> &FoundFlags);
	P_FStructure* extractSolution( list<contextByte> & ext_solution);
	list<P_ContextedValue*> getComplexValues(string string_trace);
	list< bitwiseContext > getNogoods(void);
	list<P_FSItem*> getConstraintsFromLinks(void);
	void verifySolution(list<contextByte> & solution);
};
#endif/*ADDED IN THIS (LINUX) VERSION*/