#ifndef P_GRAMMAR
#define P_GRAMMAR

#include <iostream>
#include <stdlib.h>
#include "global.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "CGrammar.h"
#include "PermutationMaker.h"
#include "global.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "CSymbolTableManager.h"

#include "FileReader.h"
#include "FileWriter.h"

#include "RawProduction.h"
#include "Symbol.h" /*CHANGED IN THIS (LINUX) VERSION*/

#include "CLexicon.h"
#include "FDExpression.h"


#include "CGrammar.h" /*CHANGED IN THIS (LINUX) VERSION*/


typedef pair<wstring,CProduction*> prod_pair;


#include "P_Production.h"


#include <string>
#include <vector>
#include <list>
#include <stack>
#include <map>

using namespace std;

//##ModelId=435C90F20344


class P_Grammar 
{

public:

	P_Grammar(const string & grules_fname,const string & macros_fname,const string & lfg_fname,const string & cfg_fname,bool ReplaceStarByRange);

	vector<P_Production*>* GetProduction(short LHS_Symbol, P_FirstSet FirstSet);
	vector<P_Production*>* GetProduction(short LHS_Symbol);
	P_Production* GetProduction(int ProdId);

	short GetStartSymbolID();

	void init();

public:

	void PurifyProductions(list<CRawProduction*> * rprod_list);
	//void ExtractConditionsAndConstraints(CProductionSymbol*psymb,wstring & condition);
	vector< vector<CSymbol*> * > *  GetAllCasesList(CSymbol*symb,CSymbol*mins,CSymbol*maxs);
	void GenerateNumberPermutations(short min, short max, vector<vector<short> > & vlist);
	void AddProdList(list<CRawProduction*>*first,list<CRawProduction*>*second);
	list<CRawProduction*>* GetResolvedProductionList(CRawProduction * prod);
	void ReadCGrammar(const string & grules_fname,const string & macros_fname,const string & lfg_fname,const string & cfg_fname,CLexicon*LexPtr,bool ReplaceStarByRange=false,bool IsGenerationGrammar=false)
	{
	}

	list<CRawProduction*>* ConvertLFG2CFG(list<CRawProduction*> * vlist);

	list<CRawProduction*>* ReadLFG(string LFGFileName);
	vector<CSymbol*> * GetStackList2WithCopy(stack<CSymbol*> *  stk1);
	vector<CSymbol*> * GetStackList(stack<CSymbol*> *  stk1);
	void AppendList(vector<CSymbol*> * first,vector<CSymbol*> * second);
	wstring GetNewProdName();
private:
/*****************************************************************/
	   /*					Utility Functions				*/
/*****************************************************************/
	vector<CSymbol*> * GetStackListRev(stack<CSymbol*> *  stk1);

	bool IsNonTerminal(wstring & TerOrNTer);

	int GiveSizeOfNT(list<CRawProduction*> * vlist ,vector<wstring> & fillNT);

	int GiveNTIndex(vector<wstring>& A,wstring Astring);

	bool Add(vector<wstring>& SetA, vector<wstring>& SetB);

	bool Add(vector<wstring>& Set, wstring toAdd);
/*****************************************************************/
/*****************************************************************/
	list<CRawProduction*>* GenerateSelectionSet(list<CRawProduction*> * vlist, map<wstring,bool>* nullables);
	map<wstring,bool>* Comp_Nullables( list<CRawProduction*> * vlist , map<wstring,bool>* nullables);
	map<wstring,bool>* Comp_Dir_Nullables( list<CRawProduction*> * vlist );
	bool PreprocessGrammar(const string & grules_fname,const string & macros_fname,const string & cfg_fname,bool ReplaceStarByRange=false);
	void AddInProductionsMap();
	list<CRawProduction*> * SortProductions(list<CRawProduction*> * vlist2);
private:
/////////////////////////////////////////////////////////////////
  ///////  ATTRIBUTES  ATTRIBUTES  ATTRIBUTES  ATTRIBUTES /////
/////////////////////////////////////////////////////////////////
	vector< list< CProduction *> > ProdTable;	//new
	
	typedef pair<short,P_Production*> ProdMapEntry;
	hash_multimap<short,P_Production*> ProductionsMap;

	vector<P_Production*>* AllProductions;

//	hash_map<short,P_Production*> ProductionsTable;
/*
	hash_map ProductionsTable has all the indeces of the vector	
*/
	short StartSymbolID;
	
	wstring NewProdName;
	//	CSymbol * DotPtr;
//	CLexicon * LexiconPtr;

	/*
		Symbol Table For the Productions Symbols
		Mostly will be used in Debugging
	*/
	
	typedef pair<string,int> ProdSymMapEntry;

	vector<string> ProdSymbols;			
	hash_map<string, int> ProdSymbolsMap;

	typedef pair<string,int> PosSymMapEntry;
	vector<string> Terminals;					//D
	hash_map<string, int> TerSymbolsMap;		//D


/************************************************************/
	/*	 Some Functions For interpretting the Grammar	*/
/************************************************************/
public:
	int GiveposIndex(string & temp);
	string GivePOSSym(int i);
	int GiveprodIndex(string & temp);
	string GiveProdSym(int i);
	void insertProdInProdMap(list<CRawProduction*> * vlist2);
	int insertProdInProdMap(string ProdName);
	string GiveprodAtIndex(int index);
	string GiveposAtIndex(int index);
	void insertPOSInPOSMap(string Path);

	bool Inserted(vector<string> & A,string & b,int &);

	void WriteGrammarInFile(vector<P_Production*> * prod_list,string CFGFileName);
	
/************************************************************/
	/*	 Some Functions For interpretting the Grammar	*/
/************************************************************/
private:
	void WriteCFGInFile(list<CRawProduction*> * prod_list,string CFGFileName);
	void LoadProductions();
	void DumpGrammartoDumpFile();
	bool GetALine(CFileReader & FHandler,string & A);
	void LoadGrammarFromDumpFile();
	void DumpP_Grammar();
	void ReadGrammar();
/************************************************************/
	CSymbol * GetDotPtr()
	{
			CSymbol* DotPtr=new CSymbol(L".",L"",true);
			return DotPtr;
	}
/************************************************************/
};

#endif /* _INC_P_GRAMMAR_435C90F20344_INCLUDED */