#include "stdafx.h"

#include "P_ChartItem.h"
#include "P_LexicalEntry.h"

int P_LexicalEntry::count = 0;
int _CFDescription::Max=0;

P_LexicalEntry ::P_LexicalEntry(int P, vector<PFSitemID> & FDIndeces, P_SemanticForm* SF=0, float prob=1)
{
	POS = P;
	FDescriptionIndices = FDIndeces;
	probability = prob;
	SemForm = SF;
	FSPtr = NULL;	// added 30-01-06 HUDA
}
P_LexicalEntry ::P_LexicalEntry(int P, vector<PFSitemID> & FDIndeces, int pred, float prob=1)
{
	POS = P;
	FDescriptionIndices = FDIndeces;
	probability = prob;
	SemForm = new P_SemanticForm ;
	SemForm->Pred = pred;
	FSPtr = NULL;	// added 30-01-06 HUDA
}

P_LexicalEntry ::P_LexicalEntry (int P, vector<PFSitemID>& FDIndeces, int pred)
{
	POS = P;
	FDescriptionIndices = FDIndeces;
	probability = 0;
	SemForm = new P_SemanticForm ;
	SemForm->Pred = pred;
	FSPtr = NULL;	// added 30-01-06 HUDA
}


P_LexicalEntry ::~P_LexicalEntry ()
{

	if(SemForm)
	{
		delete SemForm;
		SemForm=0;
	}
}


void P_LexicalEntry::Dump(short * Buffer, int & Bindex)
{
	Buffer[++Bindex]=this->POS;
	*((float*)&Buffer[++Bindex])=this->probability;
	Bindex++;
	Buffer[++Bindex]=MAXCONTEXT;
	Buffer[++Bindex]=FDescriptionIndices.size();

	for(int i=0;i<FDescriptionIndices.size();i++)
	{
		Buffer[++Bindex]=FDescriptionIndices[i];
	}

	if(SemForm)
	{
		Buffer[++Bindex]=1;		// Semantic Form Exists
		Buffer[++Bindex]=SemForm->Pred;
		Buffer[++Bindex]=SemForm->GFIndex.size();

		for(int j=0;j<SemForm->GFIndex.size();j++)
		{
			Buffer[++Bindex]=SemForm->GFIndex[j];
		}

	}
	else
	{
		Buffer[++Bindex]=0;
	}

}

void P_LexicalEntry::Load(short * Buffer, int & Bindex)
{
	this->POS=Buffer[++Bindex];
	this->probability=*((float*)&Buffer[++Bindex]);
	Bindex++;
	MAXCONTEXT=Buffer[++Bindex];
	FDescriptionIndices.resize(Buffer[++Bindex]);

	for(int i=0;i<FDescriptionIndices.size();i++)
	{
		FDescriptionIndices[i]=Buffer[++Bindex];
	}

	int IsSemForm = Buffer[++Bindex];
	if(IsSemForm)
	{
			//		Buffer[++Bindex]=1;		// Semantic Form Exists
		SemForm = new P_SemanticForm;
		SemForm->Pred=Buffer[++Bindex];
		SemForm->GFIndex.resize(Buffer[++Bindex]);

		for(int j=0;j<SemForm->GFIndex.size();j++)
		{
			SemForm->GFIndex[j]=Buffer[++Bindex];
		}

	}
}