#include "stdafx.h"

#include<fstream>

using namespace std;

#include "P_Lexicon.h"

#include "global.h" /*CHANGED IN THIS (LINUX) VERSION*/

#include "P_FSInitializer.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "CSymbolTableManager.h"
#include "P_FSSymbolTable.h"
#include "P_Grammar.h"

string wstringToString(wstring a);
wstring stringToWstring(string a);

//##########TAHIRA#############
vector<vector<PFSsymID> > P_Lexicon::SubCatFrames;
vector<vector<string> > P_Lexicon::SubCatFramesString;
//vector<string> P_Lexicon::AllSubcats;
//##########TAHIRA#############

bool operator == (vector<PFSsymID> & SubcatFrame1,vector<PFSsymID> & SubcatFrame2)
{
	if(SubcatFrame1.size()==SubcatFrame2.size())
	{
		for(int i=0;i<SubcatFrame1.size();i++)
		{
			if(SubcatFrame1[i]!=SubcatFrame2[i])
			{
				return false;
			}
		}
		return true;
	}
	return false;
}
PFSsymID P_Lexicon::GetSubcatFrameLineIndex(vector<PFSsymID> & SubcatFrame1)
{
	for(int i=0;i<SubCatFrames.size();i++)
	{
		if(SubCatFrames[i] == SubcatFrame1)
		{
			return i;
		}
	}

	/*MessageBox(NULL,L"RUN TIme Error In: --> GetSubcatFrameIndex() ",L"RUN TIme Error In: --> GetSubcatFrameIndex() ",MB_ICONINFORMATION); REMOVED IN THIS (DOS/LINUX) VERSION */

	return -1;
}

bool P_Lexicon::Inserted(vector<string> & A,string & b,PFSsymID & index)
{
	/*for(PFSsymID i=0;i<A.size();i++)CHANGED IN THIS (LINUX) VERSION*/
	PFSsymID i;
	for(i=0;i<A.size();i++)
	{
		if(A[i]==b)
		{
			index =i;
			return false;
		}
	}

	index = i;
	A.push_back(b);
	return true;
}

string* StringTok(char * A,const char c, int & size)
{
	string temp=A;
	string* TokArray;


	/*for(unsigned int i=strlen(A)-1;i>=0;i--)CHANGED IN THIS (LINUX) VERSION*/
	unsigned int i;
	for(i=strlen(A)-1;i>=0;i--)
	{
		if(A[i]!=' ')
		{
			break;
		}
	}
	A[i+1]=0;

	for(i=0;i<strlen(A);i++)
	{
		if(A[i]!=' ')
			break;
	}
	/*for(unsigned int k=0;i<strlen(A);i++,k++)CHANGED IN THIS (LINUX) VERSION*/
	unsigned int k;
	for(k=0;i<strlen(A);i++,k++)
	{
		A[k]=A[i];
	}
	
	A[k]=0;
	unsigned int len=strlen(A);
	int count=0;
	for(i=0;i<len;i++)
	{
		if(A[i]==c)
			count++;
	}
	count++;
	TokArray= new string[count];
	size=count;
	
	int prev=0;
	int countindex=0;
	for(i=0;i<len;i++)
	{
		if(A[i]==c)
		{
			A[i]=0;
			temp=A+prev;
			TokArray[countindex++]=temp;
			prev=i+1;
		}
	}
	temp=A+prev;
	TokArray[countindex++]=temp;
	
	return TokArray;
}


void P_Lexicon::ReadSubcatFrames()
{
	string GetPath = CConfiguration::GetConfigInfo("SubCats");

	fstream MyReader(GetPath.c_str(),ios::in);

	char A[1000];

	string temp;

	//static PFSsymID P_FSSymbolTable::getSymID(string symbol);

	vector<string> AStringVec;
	vector<PFSsymID> APFSsymVec;

	while(!MyReader.eof())
	{
		AStringVec.clear();
		APFSsymVec.clear();

		MyReader.getline(A,1000);
		temp = A;
		int size=0;
		string* vecStrings = StringTok(A,'\t',size);
		PFSsymID index=0;
		for(int i=0;i<size;i++)
		{
			AStringVec.push_back(vecStrings[i]);
			
//			Inserted(AllSubcats,vecStrings[i],index);

			APFSsymVec.push_back(P_FSSymbolTable::getSymID(vecStrings[i]));
		}

		SubCatFrames.push_back(APFSsymVec);
		SubCatFramesString.push_back(AStringVec);
	}
}

vector<PFSsymID> P_Lexicon::GetSubcatFrame1(PFSsymID index)
{
	return SubCatFrames[index];
}

vector<PFSsymID>* P_Lexicon::GetSubcatFrame(PFSsymID index)
{
	return &SubCatFrames[index];
}

vector<P_LexicalEntry *>& P_Lexicon::GetLexicalEntry(wstring word)
{
	vector<P_LexicalEntry *>* temp  = new vector<P_LexicalEntry *>;

	hash_multimap<wstring,P_LexicalEntry *>:: iterator i = Lexicon.find(word);

	while(i!=Lexicon.end() && i->first==word)
	{
		temp->push_back(i->second);
		i++;
	}
 return *temp;	
}

P_LexicalEntry* P_Lexicon::GenerateLexEntry(wstring pos, wstring Conditions)
{
	/*ADDED IN THIS (LINUX ONLY) VERSION*/
	vector<PFSitemID> objvec1;
	/*ADDED IN THIS (LINUX ONLY) VERSION*/
	
	string strPOS = wstringToString(pos);
	int posId = GramPtr->GiveposIndex(strPOS);
	contextByte dummy;
	string strcond = wstringToString(Conditions);
	
	/* CHANGED IN THIS (LINUX ONLY) VERSION
	P_LexicalEntry* temp = new P_LexicalEntry(posId,P_FSInitializer::getFDVector(strcond,dummy));
	CHANGED IN THIS (LINUX ONLY) VERSION*/
	objvec1 = P_FSInitializer::getFDVector(strcond,dummy) ;
	P_LexicalEntry* temp = new P_LexicalEntry(posId,objvec1);

	temp->SemForm->Pred=CSymbolTableManager::GetNum(L"EMPTY");
	temp->MAXCONTEXT=0;

	return temp;
}

P_LexicalEntry P_Lexicon::GetScannerEntry(Token tok)
{
	P_LexicalEntry aa;
	return aa;
}

void P_Lexicon::ReadScannerEntries()
{
}

vector<P_LexicalEntry *> P_Lexicon::GetDummyEntries( wstring pred)
{
//	DummyEntries
	
	vector<P_LexicalEntry *> aa;
	P_LexicalEntry * temp;

	short predNo;

	for(int i=0;i<DummyEntries.size();i++)
	{
		temp = new P_LexicalEntry();
		temp->SemForm = new P_SemanticForm;
		
		temp->FDescriptionIndices = DummyEntries[i]->FDescriptionIndices;
		temp->MAXCONTEXT = DummyEntries[i]->MAXCONTEXT;
		temp->POS = DummyEntries[i]->POS;
		temp->probability = DummyEntries[i]->probability;
		temp->FSPtr = NULL;

		wstring temp_pred=pred+L"_"+Convert_str2wstr(GramPtr->GivePOSSym(temp->POS));
		predNo = CSymbolTableManager::GetNum(temp_pred);

		temp->SemForm->Pred = predNo;

		aa.push_back(temp);
	}
	return aa;
}

bool P_Lexicon::GetALine(CFileReader & FHandler,string & A)
{
	A="";
	short ch=0;
	
	while((ch=FHandler.GetCurrentChar())!=0)
	{
start:
		switch(ch)
		{
				case LF:
				case CR:
//				case ' ':
//				case '\t':
					A="";

					break;
				case '@':
					A+=ch;
					FHandler.MoveNext();
					while((ch=FHandler.GetCurrentChar())!='@')
					{
						A+=ch;
						FHandler.MoveNext();
					}
					A+=ch;
					break;
				case '/' :				
						
						while(true)
						{						
							ch=FHandler.GetCurrentChar();
								
							if(ch==LF||ch==CR||ch<=0)
								break;					

							A+=ch;
							FHandler.MoveNext();					

						}
						break;

				case '.':
				{
					FHandler.MoveNext();
					return true;	// Line Ends
				}

				default:		
						A+=ch;
					
			}//end switch
	
		
		FHandler.MoveNext();
	}
	return false;
}


string P_Lexicon::trim(const string & A)
{
	string trimedString="";
	/*for(int i=0;i<A.size();i++)CHANGED IN THIS (LINUX) VERSION*/
	int i;
	for(i=0;i<A.size();i++)
	{
		if(A[i]!=' ')
		{
			break;
		}
	}

	/*for(int j= A.size()-1;j>i;j--)CHANGED IN THIS (LINUX) VERSION*/
	int j;
	for(j= A.size()-1;j>i;j--)
	{
		if(A[j]!=' ')
		{
			break;
		}
	}

	for(;i<=j;i++)
	{
		trimedString+=A[i];
	}
	return trimedString;
}


void P_Lexicon::DivideintoParts(string & ALine,string & pred,
								 string & fdesc, float & prob)
{
	pred = "";
	fdesc="";
	bool Ispred =true;
	for(int i=0;i<ALine.size()-1;i++)	// -1 is due to ';' at the end
	{
		if(ALine[i]=='@')
		{
			string strProb="";
			char ch = ALine[++i];
			while(ch!='@')
			{
				strProb+=ch;
				ch = ALine[++i];
			}
			
			prob=atof(strProb.c_str());
			break;
		}

		if(Ispred==true)
		{
			if(ALine[i]==':')
			{
				Ispred = false;
			}
			else
			{
				pred+=ALine[i];
			}
		}
		else
		{
			fdesc+=ALine[i];
		}
	}
}

/********************************************************/

void P_Lexicon::DivideintoParts(string & ALine,string & Label,
					 string & pred,string & pos,
					 vector<string>& SubCats,string & fdesc,float & prob)
{
	
	Label = "";
	pred = "";
	fdesc ="";
	SubCats.clear();

	bool IsLabel = true;
	bool IsPred = true;
	bool IsPos = true;
	bool IsSubCat = true;
	bool IsFdesc = true;

	char ch;

	prob = 1.00;

	for(int i=0;i<ALine.size();i++)
	{
		ch = ALine[i];
		
		if(ch=='@')
		{
			string strProb="";
			ch = ALine[++i];
			while(ch!='@')
			{
				strProb+=ch;
				ch = ALine[++i];
			}
			
			prob=atof(strProb.c_str());
		}

		else if(IsLabel==true && ch==':')
		{
			Label = trim(Label);
			IsPos = true;
			IsLabel = false;
		}
		else if(IsLabel==true)
		{
			Label += ch;
		}
		else if(IsPos==true && ch==',')
		{
			pos = trim(pos);
			IsPos = false;

			// what to on

			do{
				ch = ALine[++i];
			}
			while(ch==' ');
			if(ch == '^' && ALine.size()>i+4)	// P for Pred 
			{
				i++;
				if(ALine[i]=='P' && ALine[i+1]=='R' && ALine[i+2]=='E' && ALine[i+3]=='D')
				{
					i= i+3;
					
					while(ALine[++i]!='\'');
					
					// i will be ignored when it wd get ( ' ) as character
					
					IsPred = true;
					IsFdesc = false;
				}	
				else
				{
					i-=2;
					IsPred = false;
					IsFdesc = true;
				}
			}
			else
			{
				i-=1;
				IsPred = false;
				IsFdesc = true;
			}

		}
		else if(IsPos==true && ch=='.')
		{
			pos = trim(pos);
			
			IsPos = false;
			break;
		}
		else if(IsPos==true)
		{
			pos += ch;
		}

		else if(IsPred==true && ch=='\'')
		{
				pred = trim(pred);
				IsPred = false;
				IsFdesc = true;

				while((ch=ALine[++i])==' ');
				if(ch==',')
				{
					
				}
				else if(ch=='.')
				{
					break;
				}
		}
		else if(IsPred==true)
		{
			if(ch=='<')
			{
				string ASubcat;
				do{
					ch = ALine[++i];
					
					if(ch==',')
					{
						ASubcat = trim(ASubcat);
						SubCats.push_back(ASubcat);

						ASubcat="";
					}
					else
					{
						if(ch !='>')
						ASubcat+=ch;
					}
				}
				while(ch !='>');
			
				ASubcat = trim(ASubcat);
				SubCats.push_back(ASubcat);
			}
			else
			{
				pred += ch;
			}
		}
		else if(ch == '.')
		{
			fdesc = trim(fdesc);
			break;	// end of fdescription
		}
		else
		{
			fdesc+=ch;
		}
		
	}
	pos =  TrimString(pos);
	Label= TrimString(Label);
	pred = TrimString(pred);
	fdesc = TrimString(fdesc);

}

void P_Lexicon::ReadPOSs(string Path)
{
	fstream reader(Path.c_str(),ios::in);

	string apos = "";
	POSs.push_back(apos);
	while(!reader.eof())
	{
		apos="";
		reader>>apos;
		short POSindex = POSs.size();
		POSs.push_back(apos);
		POS_Hash.insert(POSEntry(apos,POSindex));
	}
}

vector<PFSsymID> P_Lexicon::GetSubcatFramesIndex(vector<string> & SubcatFrame)
{
	string temp = SubcatFrame[0];
	for(int i=0;i<SubCatFramesString.size();i++)
	{
		
		vector<string> curr = SubCatFramesString[i];
		string temp2 = curr[0];
		if(SubCatFramesString[i]==SubcatFrame)
		{
			return SubCatFrames[i];
		}
	}

	/*
		************************************************************
		Doing only for testing but will not be done at final Version
		************************************************************
	*/
	/*
		ends here
	*/

	wstring msg=L"Wrong SubCats: <";
	/*for(int i=0;i<(SubcatFrame.size()-1);i++)CHANGED IN THIS (LINUX) VERSION*/
	int i;
	for(i=0;i<(SubcatFrame.size()-1);i++)
	{
		msg+=Convert_str2wstr(SubcatFrame[i]);
		msg+=L",";
	}
	msg+=Convert_str2wstr(SubcatFrame[i]);
	msg+=L">";
	/*MessageBox(NULL,msg.c_str(),L"Wrong SubCats",MB_ICONINFORMATION); REMOVED IN THIS (DOS/LINUX) VERSION */
	CLogManager::AddMessage(msg.c_str()); /* ADDED IN THIS (DOS/LINUX) VERSION */

	throw("SubCats Error");
}

void P_Lexicon::ReadLexicon(string LexiconPath)
{
	vector<PFSsymID> objvec1;/*ADDED IN THIS (LINUX) VERSION*/	
	vector<PFSsymID> SubcatFrame;/*ADDED IN THIS (LINUX) VERSION*/

	if(CConfiguration::GetConfigInfo("CompileP_Grammar" , true)=="yes")
	{
	CFileReader FHandler(LexiconPath.c_str(),1024);
	string fdesc="";
	string label="";
	string pred="";
	string pos="";
	vector<string> SubCats;
	string ALine = "";

	P_LexicalEntry * ALexEntry = 0;

	P_SemanticForm * ASemanticForm = 0;


    /*	
		Same Lexical Entries having same Label POS and pred only change
		in FDescription shd be merged 
	*/
	vector<P_LexicalEntry*> tempLexForMerging;

	string labelPrev="",posPrev="",predPrev="";
	float PrevProb;
	vector<string> SubCatsPrev;

	vector<string> fdescVec;

	float prob = 1;
	if(GetALine(FHandler,ALine))
	{
			label="";pred="";pos="";fdesc="";

			DivideintoParts(ALine,label,pred,pos,SubCats,fdesc,prob);
						
			labelPrev=label;
			posPrev =pos;
			SubCatsPrev=SubCats;
			predPrev = pred;
			fdescVec.push_back(fdesc);
			PrevProb = prob;
	}
//string PrevLine="";
	while(GetALine(FHandler,ALine))
	{

			//if(ALine[0]=='m')
			//{
			//	ALine[0] = ALine[0];
			//}

		label="";pred="";pos="";fdesc="";

		float prob = 1;

		DivideintoParts(ALine,label,pred,pos,SubCats,fdesc,prob);		

		//if(label == "certainly")
		//{
		//	posPrev = posPrev;
		//}
		/*&& pred==predPrev*/
		if(label==labelPrev && pos==posPrev )
		{		
			//		ASemanticForm ->GFIndex = GetSubcatFrameIndex(SubCats);

			string GFString;//
			if(SubCats.size())
			{
				GFString= ",^GF=";		// e.g. ^ GF = 7
				/*CHANGED IN THIS (LINUX) VERSION
				GFString += int2string(GetSubcatFrameLineIndex(GetSubcatFramesIndex(SubCats)));
				CHANGED IN THIS (LINUX) VERSION*/
				objvec1 = GetSubcatFramesIndex(SubCats) ;
				GFString += int2string(GetSubcatFrameLineIndex(objvec1));

			}
			// Merging GF also
			fdesc+=GFString;
			fdescVec.push_back(fdesc);
		}
		else
		{
		short POSindex = GivePOSindex(posPrev);

		ASemanticForm = new P_SemanticForm;

		if(predPrev!="")
			ASemanticForm ->Pred = CSymbolTableManager::GetNum(stringToWstring(predPrev),true);
		else
			ASemanticForm ->Pred = 0;

		//P_FSInitializer a;
	
		//wstring temp = stringToWstring(labelPrev);
		wstring temp = Convert_str2wstr(labelPrev);
		/*
			Merging all FDescriptions
		*/
		string fdescMerged = "";
		string ob = "[",cb = "]",os="|";

		for(int i=0;i<fdescVec.size();i++)
		{
			if(i!=0)
			{
				fdescMerged=ob+fdescMerged+os+fdescVec[i]+cb;
			}
			else
			{
				fdescMerged=fdescVec[i];
			}
		}

		contextByte dummy=0;
		vector<PFSitemID> FDs = P_FSInitializer::getFDVector(fdescMerged,dummy);
		ALexEntry = new P_LexicalEntry(POSindex,FDs,ASemanticForm,PrevProb);
		ALexEntry->MAXCONTEXT=dummy;

		Lexicon.insert(LexEntry(temp,ALexEntry));

		fdescVec.clear();

		string GFString;//
		if(SubCats.size())
		{
			GFString= ",^GF=";		// e.g. ^ GF = 7
			/* CHANGED IN THIS (LINUX) VERSION
			GFString += int2string(GetSubcatFrameLineIndex(GetSubcatFramesIndex(SubCats)));
			*/
			SubcatFrame = GetSubcatFramesIndex(SubCats) ; 
			GFString += int2string(GetSubcatFrameLineIndex(SubcatFrame));
		}
		// Merging GF also
		fdesc+=GFString;
		

		labelPrev=label;
//if(pos=="")
//{
//	pos=pos;
//}
		posPrev=pos ;
		predPrev=pred;
		SubCats=SubCatsPrev;
		fdescVec.push_back(fdesc);
		PrevProb = prob;
		}
		//PrevLine = ALine;
	}

		short POSindex = GivePOSindex(pos);

		ASemanticForm = new P_SemanticForm;

		if(pred!="")
			ASemanticForm ->Pred = CSymbolTableManager::GetNum(stringToWstring(pred),true);
		else
			ASemanticForm ->Pred = 0;

		//P_FSInitializer a;
	
		wstring temp = stringToWstring(label);

		/*
			Merging all FDescriptions
		*/
		string fdescMerged = "";
		string ob = "[",cb = "]",os="|";

		for(int i=0;i<fdescVec.size();i++)
		{
			if(i!=0)
			{
				fdescMerged=ob+fdescMerged+os+fdescVec[i]+cb;
			}
			else
			{
				fdescMerged=fdescVec[i];
			}
		}

		contextByte dummy=0;
		vector<PFSitemID> FDs = P_FSInitializer::getFDVector(fdescMerged,dummy);
		ALexEntry = new P_LexicalEntry(POSindex,FDs,ASemanticForm,prob);
		ALexEntry->MAXCONTEXT=dummy;

		Lexicon.insert(LexEntry(temp,ALexEntry));
		DumpLexicalEntries(CConfiguration::GetConfigInfo("ELexiconDumpFileName"));
	}
	else
	{
		LoadLexicalEntriesfromDump(CConfiguration::GetConfigInfo("ELexiconDumpFileName"));
	}


/////////////////////////////////////////////////
	//		Lexicon Debugging
/////////////////////////////////////////////////

	//fstream outLex("DubugLex.txt",ios::out);

	//string tempStr;

	//for(hash_multimap<wstring,P_LexicalEntry*>::iterator lexDebug = Lexicon.begin();lexDebug != Lexicon.end();lexDebug++)
	//{
	//	tempStr =wstringToString(lexDebug->first);
	//	outLex<<tempStr<<endl;
	//}
}

bool P_Lexicon::Alreadypresent(vector<P_LexicalEntry*> & tempLexForMerging, P_LexicalEntry* newToEnter)
{
	for(int i=0;i<tempLexForMerging.size();i++)
	{
		if(tempLexForMerging[i]->POS == newToEnter->POS && 
			tempLexForMerging[i]->SemForm->Pred == newToEnter->SemForm->Pred /*&&
			tempLexForMerging[i]->SemForm->GFIndex == newToEnter->SemForm->GFIndex*/)
		{
			return true;
		}
	}
	return false;
}
short P_Lexicon::GivePOSindex(string & POS)
{
	hash_multimap<string,short>::iterator i = POS_Hash.find(POS);
	if(i!=POS_Hash.end())
	{
		return i->second;
	}
	

	/*
		************************************************************
		Doing only for testing but will not be done at final Version
		************************************************************
	*/

	int index = POSs.size();

	POS_Hash.insert(POSEntry(POS,index));


	/*
		ends here
	*/
	wstring msg=L"Wrong POS"+Convert_str2wstr(POS);
	/*MessageBox(NULL,msg.c_str(),L"Wrong POS",MB_ICONINFORMATION); REMOVED IN THIS (DOS/LINUX) VERSION */ 
	CLogManager::AddMessage(msg.c_str()); /* ADDED IN THIS VERSION */

	throw("Wrong POS Exception...");
}
void P_Lexicon::ReadDummyEntries()
{
	/*ADDED IN THIS (LINUX ONLY) VERSION*/
	vector<PFSsymID> subcat_frames_index;
	/*ADDED IN THIS (LINUX ONLY) VERSION*/
	
	if(CConfiguration::GetConfigInfo("CompileP_Grammar" , true)=="yes")
	{
	string DummyLexiconPath = CConfiguration::GetConfigInfo("Dummy");
	CFileReader FHandler(DummyLexiconPath.c_str(),1024);
	string ALine = "";

	P_LexicalEntry * ALexEntry = 0;
	
	string 	label="",pred="",pos="",fdesc="";
	float Dummyprob = 1;
	int dummyPOS = -1;

	vector<PFSitemID> ADummyFD;

	P_SemanticForm * ASemanticForm;

	while(GetALine(FHandler,ALine))
	{
		DivideintoParts(ALine,pos,fdesc,Dummyprob);

		ASemanticForm = new P_SemanticForm;

		ASemanticForm ->Pred = -1; //CSymbolTableManager::GetNum(stringToWstring(pred),true);
		if(pos=="v")
		{
			//ASemanticForm->GFIndex=
				fdesc+= ",^GF=";		// e.g. ^ GF = 7
				vector<string> GF;
				GF.push_back("SUBJ");
				/* CHANGED IN THIS (LINUX ONLY) VERSION
				fdesc += int2string(GetSubcatFrameLineIndex(GetSubcatFramesIndex( GF )));
				CHANGED IN THIS (LINUX ONLY) VERSION */
				subcat_frames_index = GetSubcatFramesIndex( GF );
				fdesc += int2string(GetSubcatFrameLineIndex(subcat_frames_index));
		}

		contextByte dummy;
		//	vector<PFSitemID> FDs;// = P_FSInitializer::getFDVector(fdescMerged,dummy);

		ADummyFD = P_FSInitializer::getFDVector(fdesc,dummy);

		int posInt = GivePOSindex(pos);

		ALexEntry = new P_LexicalEntry(posInt,ADummyFD,ASemanticForm,Dummyprob );

		ALexEntry->MAXCONTEXT=dummy;

		ALexEntry->FSPtr=NULL;

		DummyEntries.push_back(ALexEntry);

	}

		DumpDummyLexicalEntries(CConfiguration::GetConfigInfo("DummyDump"));
	}
	else
	{
		LoadDummyLexicalEntriesfromDump(CConfiguration::GetConfigInfo("DummyDump"));
	}

/*	string DummyLexiconPath = CConfiguration::GetConfigInfo("Dummy");
	CFileReader FHandler(DummyLexiconPath.c_str(),1024);
	string ALine = "";

	P_LexicalEntry * ALexEntry = 0;
	
	string 	label="",pred="",pos="",fdesc="";
	float Dummyprob = 1;
	int dummyPOS = -1;

	vector<PFSitemID> ADummyFD;

	P_SemanticForm * ASemanticForm;

	while(GetALine(FHandler,ALine))
	{
		DivideintoParts(ALine,pred,fdesc);

		ASemanticForm = new P_SemanticForm;

		ASemanticForm ->Pred = CSymbolTableManager::GetNum(stringToWstring(pred),true);
		
		ALexEntry = new P_LexicalEntry(dummyPOS,ADummyFD,ASemanticForm,Dummyprob );

		DummyEntries.push_back(ALexEntry);

	}
*/
}

bool P_Lexicon::DumpLexicalEntries(string Path)
{
		/*************************************************
		//	 Dumping Dumping Dumping Dumping Dumping 
		*************************************************/

		FILE* fwriter=fopen(Path.c_str(),"wb");

		short AEntrySize = 100;
		short LexiconSize100th = Lexicon.size()/100;
		short * Buffer;
		if(LexiconSize100th)
			Buffer = new short[AEntrySize*LexiconSize100th];
		else
			Buffer = new short[AEntrySize*Lexicon.size()];
		int Bindex=-1;

		wstring Label=L"";
		P_LexicalEntry*AnEntry=0;


		Buffer[++Bindex]=AEntrySize;
		Buffer[++Bindex]=LexiconSize100th;
		*((int*)(&Buffer[++Bindex]))=(int)Lexicon.size();
		++Bindex;

		for(hash_multimap<wstring,P_LexicalEntry*>::iterator li=Lexicon.begin();li!=Lexicon.end();li++)
		{
			Label = li->first;
			AnEntry = li->second;
			Buffer[++Bindex]=Label.size();
			for(int lsi=0;lsi<Label.size();lsi++)
			{
				Buffer[++Bindex]=Label[lsi];
			}
			AnEntry->Dump(Buffer,Bindex);
		
			if(Bindex>=AEntrySize*(LexiconSize100th-1))
			{
				size_t t = fwrite((void*)Buffer,2,(Bindex+1),fwriter);
				Bindex=-1;
			}
		}


		if(Bindex!=-1)
		{
				fwrite((void*)Buffer,2,(Bindex+1),fwriter);
				Bindex=-1;
		}
		delete []Buffer;

		fclose(fwriter);
		return true;
}

bool P_Lexicon::LoadLexicalEntriesfromDump(string Path)
{
		/*************************************************
		//	 Loading Loading Loading Loading Loading 
		*************************************************/

		FILE* freader=fopen(Path.c_str(),"rb");

		short AEntrySize ;
		short LexiconSize100th;
		int Bindex=-1;

		short * Buffer = new short[4];

		fread(Buffer,2,4,freader);

		AEntrySize=Buffer[++Bindex];
		LexiconSize100th=Buffer[++Bindex];
		int LexiconSize = *((int*)(&Buffer[++Bindex]));
		++Bindex;
		delete []Buffer;

		Buffer = new short[AEntrySize*LexiconSize100th];

		Bindex = -1;
		fread(Buffer,2,AEntrySize*LexiconSize100th,freader);

		wstring Label=L"";
		P_LexicalEntry*AnEntry=0;

		for(int hi=0;hi<LexiconSize;hi++)
		{
			AnEntry = new P_LexicalEntry();

			Label.resize(Buffer[++Bindex]);
			for(int lsi=0;lsi<Label.size();lsi++)
			{
				Label[lsi]=Buffer[++Bindex];
			}
			AnEntry->Load(Buffer,Bindex);
		
			if(Bindex>=AEntrySize*(LexiconSize100th-1))
			{
				int Seek_Back = AEntrySize*(LexiconSize100th)-Bindex-1;

				fseek(freader,-Seek_Back*2,1);	// Setting the Back 

				fread((void*)Buffer,2,AEntrySize*LexiconSize100th,freader);
				Bindex=-1;
			}
 
			Lexicon.insert(LexEntry(Label,AnEntry));
		}

		delete []Buffer;



	return true;
}


bool P_Lexicon::DumpDummyLexicalEntries(string Path)
{
		/*************************************************
		//	 Dumping Dumping Dumping Dumping Dumping 
		*************************************************/

		FILE* fwriter=fopen(Path.c_str(),"wb");

		short AEntrySize = 100;
		short LexiconSize = DummyEntries.size();
		short * Buffer = new short[AEntrySize*LexiconSize];
		int Bindex=-1;

		P_LexicalEntry*AnEntry=0;

		Buffer[++Bindex]=AEntrySize;
		Buffer[++Bindex]=LexiconSize;

		for(int li=0;li!=DummyEntries.size();li++)
		{
			AnEntry = DummyEntries[li];
			AnEntry->Dump(Buffer,Bindex);
		}

		if(Bindex!=-1)
		{
				fwrite((void*)Buffer,2,(Bindex+1),fwriter);
				Bindex=-1;
		}
		delete []Buffer;

		fclose(fwriter);
		return true;
}

bool P_Lexicon::LoadDummyLexicalEntriesfromDump(string Path)
{
		/*************************************************
		//	 Loading Loading Loading Loading Loading 
		*************************************************/

		FILE* freader=fopen(Path.c_str(),"rb");

		short AEntrySize ;
		short LexiconSize;
		int Bindex=-1;

		short * Buffer = new short[4];

		fread(Buffer,2,2,freader);

		AEntrySize=Buffer[++Bindex];
		LexiconSize=Buffer[++Bindex];
		delete []Buffer;

		Buffer = new short[AEntrySize*LexiconSize];

		Bindex = -1;
		fread(Buffer,2,AEntrySize*LexiconSize,freader);

		P_LexicalEntry*AnEntry=0;

		for(int hi=0;hi<LexiconSize;hi++)
		{
			AnEntry = new P_LexicalEntry();

			AnEntry->Load(Buffer,Bindex);
		
			DummyEntries.push_back(AnEntry);
		}

		delete []Buffer;



	return true;
}



//bool P_Lexicon::DumpLexicalEntries(string file_name)
//{
//	hash_multimap<wstring,P_LexicalEntry*>::iterator ar_it = Lexicon.begin();
//
//	P_LexicalEntry* ste;
//	wstring wstr;
//
//	FILE * bfw =fopen(file_name.c_str(),"wb");
//
//	if(!bfw)
//	{
//		return false;
//	}
//    
//	short index=0;
//	short len=0;
//	int record_counter=0;
//
//	while( ar_it != Lexicon.end() )
//	{
//		ste.Id=ar_it->first;
//		wstr=ar_it->second;
//	
//		///////Copying Data In Object////////
//		len=wstr.size();				
//		for(index=0;index<len;index++)
//			ste.String[index]=wstr[index];		
//		ste.String[index]=0;
//		/////////////////////////////////////
//
//		//test_fw.Write(wstr+L"\t"+GetWSTR(ste.Id)+L"\r\n");
//
//		fwrite(ste,sizeof(*ste),1,bfw);
//		
//		ar_it++;
//		record_counter++;
//	}
//
//	fclose(bfw);
//	//test_fw.CloseFile();
//	
//	return true;
//
//}


