#ifndef P_LEXICON
#define P_LEXICON

#include<string>
#include<vector>
/*#include<hash_map> REMOVED IN THIS (LINUX ONLY) VERSION*/
using namespace std;

#include "P_LexicalEntry.h"
#include "Token.h"
#include "FileReader.h"

#include "CConfiguration.h" /*CHANGED IN THIS (LINUX) VERSION*/
#include "P_Grammar.h"

class P_Lexicon 
{

/****************  Functions Functions Functions ****************/
public:

	void ReadLexicon(string LexiconPath);	
	
	P_Lexicon(string LexiconPath,P_Grammar* Aptr)
	{
		GramPtr = Aptr;
		ReadPOSs(CConfiguration::GetConfigInfo("POSs"));	// Passing the Path of the POSs
		ReadSubcatFrames();
		ReadLexicon(LexiconPath);
		ReadDummyEntries();
		
	}

	P_Grammar* GramPtr;

	vector<P_LexicalEntry *>& GetLexicalEntry(wstring word);
	
	P_LexicalEntry * GenerateLexEntry(wstring pos, wstring Conditions);
	
	
	bool GetALine(CFileReader & FHandler,string & A);

	void DivideintoParts(string & ALine,string & Label,
						string & pred,string & pos,
						vector<string>& SubCats,string & fdesc,float & prob);
	
	void DivideintoParts(string & ALine,string & pred,
								 string & fdesc, float & prob);
	void ReadDummyEntries();	//!Done
	
	string trim(const string & A);	//Done

	P_LexicalEntry GetScannerEntry(Token tok);	//!Done

	void ReadScannerEntries();	//!Done
																			
	vector<P_LexicalEntry *> GetDummyEntries(wstring pred);	//Done	

	static vector<PFSsymID>* GetSubcatFrame(PFSsymID index);//Done

	static vector<PFSsymID> GetSubcatFrame1(PFSsymID index);//Done

	PFSsymID GetSubcatFrameLineIndex(vector<PFSsymID> & SubcatFrame);//Done
	vector<PFSsymID> GetSubcatFramesIndex(vector<string> & SubcatFrame);//Done

	void ReadSubcatFrames();//Done

	bool Inserted(vector<string> & A,string & b,PFSsymID & index);//Done

	bool Alreadypresent(vector<P_LexicalEntry*> & tempLexForMerging, P_LexicalEntry* newToEnter);

	void ReadPOSs(string Path);

	short GivePOSindex(string & POS);


	bool DumpLexicalEntries(string Path);
	bool LoadLexicalEntriesfromDump(string Path);

	bool DumpDummyLexicalEntries(string Path);
	bool LoadDummyLexicalEntriesfromDump(string Path);
	
/***************  Attributes Attributes Attributes **************/

private:

	typedef pair<wstring,P_LexicalEntry*> LexEntry;
	hash_multimap<wstring,P_LexicalEntry*> Lexicon;

	vector<string> POSs;

	typedef pair<string,int> POSEntry;
	hash_multimap<string,short> POS_Hash;

	vector<P_LexicalEntry*> DummyEntries;

	//##########TAHIRA#############
	static vector<vector<PFSsymID> > SubCatFrames;//Done
	
	static vector<vector<string> > SubCatFramesString;//Done
	
//	static vector<string> AllSubcats;//Done
	//##########TAHIRA#############

};

#endif
