#include "stdafx.h"
#include "P_SegmentIndicator.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_SegmentIndicator::P_SegmentIndicator(void)
: indicator_pos(0)
, lexeme_pos(0)
, is_lexeme(false)
// DONE 23-08-06
{
}

P_SegmentIndicator::P_SegmentIndicator(wstring seg_indicator)
: indicator_pos(0)
, lexeme_pos(0)
, is_lexeme(false)
// DONE 23-08-06
{
	// sample string:
	// comma_-
	
	// get lexeme first
	wstring str;
	short i = 0;
	while (seg_indicator[i] != ':')
	{
		str.push_back(seg_indicator[i]);
		i++;
	}
	
	// get POS
	wstring pos_str;
	i++;
	while (i < seg_indicator.size())
	{
		pos_str.push_back(seg_indicator[i]);
		i++;
	}	
	

	if (pos_str == L"#")	// means that the indicator itself is a pos
	{
		indicator_pos = POSTable::getPOSNum(Convert_wstr2str(str));
	}
	else
	{
		is_lexeme = true;
		indicator_lexeme = str;
		lexeme_pos = POSTable::getPOSNum(Convert_wstr2str(pos_str));
	}
}

P_SegmentIndicator::~P_SegmentIndicator(void)
// DONE 23-08-06
{
}

bool P_SegmentIndicator::matchLexicalEntry(vector<P_LexicalEntry*> &lexical_entry, Token* &token)
// DONE 23-08-06
{
	if (is_lexeme)	// option 1
	{
		// check if lexeme matches
		if (token->lexeme == indicator_lexeme)
		{
			// check that any a pos matches
			vector<P_LexicalEntry*>::iterator lex_entry_it;
			for (lex_entry_it = lexical_entry.begin(); lex_entry_it != lexical_entry.end(); lex_entry_it++)
			{
				if ((*lex_entry_it)->POS == lexeme_pos)
					return true;		
			}
		}
	}
	else	// option 2
	{
		// need to compare w/ the highest probability POS
		vector<P_LexicalEntry*>::iterator lex_entry_it;
		float prob = 0;
		P_LexicalEntry* highest_prob_entry = NULL;
		lex_entry_it = lexical_entry.begin();
		prob = (*lex_entry_it)->probability;
		highest_prob_entry = (*lex_entry_it);
		for (lex_entry_it = lexical_entry.begin(); lex_entry_it != lexical_entry.end(); lex_entry_it++)
		{
			if (prob < (*lex_entry_it)->probability)	// using log probs
			{
				prob = (*lex_entry_it)->probability;
				highest_prob_entry = (*lex_entry_it);
			}
		}
		if (highest_prob_entry->POS == indicator_pos)
			return true;
	}
	return false;
}

void P_SegmentIndicator::removeInvalidEntries(vector<P_LexicalEntry*>& lexical_entry)
// DONE 24-08-06
{
	// only if 1+ entries
 	if (lexical_entry.size() > 1 )
	{
		if (!is_lexeme)
		{
			vector<P_LexicalEntry*>::iterator lex_entry_it;
			P_LexicalEntry* to_save;
			for (lex_entry_it = lexical_entry.begin(); lex_entry_it != lexical_entry.end(); lex_entry_it++)
			{
				if ((*lex_entry_it)->POS == indicator_pos)	// save this, drop the rest
				{
					to_save = (*lex_entry_it);
					break;
				}
			}
			lexical_entry.clear();
			lexical_entry.push_back(to_save);
		}
		else
		{
			vector<P_LexicalEntry*>::iterator lex_entry_it;
			P_LexicalEntry* to_save;
			for (lex_entry_it = lexical_entry.begin(); lex_entry_it != lexical_entry.end(); lex_entry_it++)
			{
				if ((*lex_entry_it)->POS == lexeme_pos)	// save this, drop the rest
				{
					to_save = (*lex_entry_it);
					break;
				}
			}
			lexical_entry.clear();
			lexical_entry.push_back(to_save);
		}
	}
}
