#pragma once

/*ADDED IN THIS (LINUX) VERSION*/
#ifndef P_SEGMENTINDICATOR_H
#define P_SEGMENTINDICATOR_H
/*ADDED IN THIS (LINUX) VERSION*/

#include <string>
using std::wstring;

#include "CSymbolTableManager.h"
#include "POSTable.h"
#include "global.h"
#include "P_LexicalEntry.h"
#include "Token.h"

class P_SegmentIndicator
{
public:
	P_SegmentIndicator(void);
	P_SegmentIndicator(wstring seg_indicator);
	~P_SegmentIndicator(void);
	bool matchLexicalEntry(vector<P_LexicalEntry*> &lexical_entry, Token* &token);

private:
	// there are actually 2 types of indicators:
	// 1. when the indicator is a word (includes a POS) e.g. said_v
	// 2. when the indicator is a POS e.g. v
	
	// both of these types will be represented as one of the following sets:
	// 1.
	wstring indicator_lexeme;
	short lexeme_pos;	// will only be used when eliminating redundant lexical entries during extraction

	// 2.
	short indicator_pos;
	
	// this will tell whether 1 or 2 is applicable
	bool is_lexeme;	// true: use 1, false: use 2

	// note: either 1 OR 2 can be valid at one time
public:
	void removeInvalidEntries(vector<P_LexicalEntry*>& lexical_entry);
};
#endif /*ADDED IN THIS (LINUX) VERSION*/
