#include "stdafx.h"
#include "P_SegmentIndicatorSequence.h" /*CHANGED IN THIS (LINUX) VERSION*/

P_SegmentIndicatorSequence::P_SegmentIndicatorSequence(void)
// DONE 23-08-06
{
}

P_SegmentIndicatorSequence::~P_SegmentIndicatorSequence(void)
// DONE 23-08-06
{
}

void P_SegmentIndicatorSequence::addIndicator(wstring indicator_string)
// DONE 23-08-06
{
	P_SegmentIndicator seg_ind(indicator_string);
	segment_indicators.push_back(seg_ind);
}

short P_SegmentIndicatorSequence::findMatch(vector<vector<P_LexicalEntry*> > &lexical_entry_list, vector<Token*> &token_list, short start_from)
// DONE 23-08-06
{
	vector<P_SegmentIndicator>::iterator inds_it;
	vector<vector<P_LexicalEntry*> >::iterator lex_entries_it;
	vector<Token*>::iterator tokens_it;
	short match_index = 0;
	bool first_match = false;
	inds_it = segment_indicators.begin();
	lex_entries_it = lexical_entry_list.begin();
	tokens_it = token_list.begin();
	short lex_entry_index = 0;

	// first take token and lex entry iterators to where i need to start from
	for (int i = 0; i < start_from; i++)
	{
		lex_entries_it++;
		tokens_it++;
		match_index++;
	}
	
	bool keep_checking = true;
	bool remaining_match = true;
	while ((keep_checking) && (lex_entries_it != lexical_entry_list.end()))
	{
		inds_it = segment_indicators.begin();
		// first find first match then take care of the rest
		for (lex_entries_it; lex_entries_it != lexical_entry_list.end(); lex_entries_it++)
		{
			// don't check first & last lexical entry; segment won't be viable
			if ((lex_entry_index < (lexical_entry_list.size() - 1)) && lex_entry_index > 0)	
				first_match = (*inds_it).matchLexicalEntry(*lex_entries_it, *tokens_it);					
			if (first_match)
 				break;
			match_index++;
			tokens_it++;
			lex_entry_index++;
		}
	
		if (!first_match)
			return 0;
		else	// match rest of the sequence
		{
			vector<P_SegmentIndicator>::iterator temp_inds_it = ++inds_it;
			vector<vector<P_LexicalEntry*> >::iterator temp_lex_entries_it = ++lex_entries_it++;
			vector<Token*>::iterator temp_tokens_it = ++tokens_it;
					
			remaining_match = true;
		
			while (temp_inds_it != segment_indicators.end())
			{
				if (temp_lex_entries_it != lexical_entry_list.end())
				{
					remaining_match = (*inds_it).matchLexicalEntry(*temp_lex_entries_it, *temp_tokens_it);
					if (!remaining_match)
					{
						match_index++;
						break;
					}
					temp_inds_it++;
					temp_lex_entries_it++;
					temp_tokens_it++;
				}
				else
				{
					match_index++;
                	break;
				}
			}
			if (remaining_match)
				keep_checking = false;
		}
		
	}
	if (remaining_match)
		return match_index;
	else 
		return 0;
}

short P_SegmentIndicatorSequence::getSequenceLength(void)
// DONE 23-08-06
{
	return segment_indicators.size();
}

void P_SegmentIndicatorSequence::removeInvalidEntries(vector<vector<P_LexicalEntry*> >& lexical_entry_list, P_SegmentMatch* match)
// DONE 24-08-06
{
	// go through segment indicator list and pass the corresponding lexical entry to each to clean up;
	// first go the lexical entry matching the first indicator
	vector<vector<P_LexicalEntry*> >::iterator lex_entries_it = lexical_entry_list.begin();
	for (short i = 0; i < match->match_index; i++)
		lex_entries_it++;

	// match this entry with the first indicator, the next w/ the next till the end of the indicators
	vector<P_SegmentIndicator>::iterator inds_it;
	for (inds_it = segment_indicators.begin(); inds_it != segment_indicators.end(); inds_it++)
	{
		(*inds_it).removeInvalidEntries(*lex_entries_it);
		lex_entries_it++;
	}
}
