#include "stdafx.h"
#include "P_SegmentRule.h" /*ADDED IN THIS (LINUX) VERSION*/

P_SegmentRule::P_SegmentRule(void)
// DONE 23-08-06
{
}

P_SegmentRule::~P_SegmentRule(void)
// DONE 23-08-06
{
}

void P_SegmentRule::insertIndicatorSequence(wstring ind_seq_str)
// DONE 23-08-06
{
	wstring indicator;
	// get each indicator string and give to indicator_sequence
	for (int i = 0; i < ind_seq_str.size(); i ++)
	{
		if (ind_seq_str[i] == '*')
		{
			RemoveEndSpaces(indicator);
			indicator_sequence.addIndicator(indicator);
			indicator.clear();
		}
		else
			indicator.push_back(ind_seq_str[i]);
	}
	RemoveEndSpaces(indicator);
	indicator_sequence.addIndicator(indicator);
}

void P_SegmentRule::insertDisqualifiers(wstring disqs_str)
// DONE 23-08-06
{
	// sample string received at this point:
	// known_v-1 | well_adv+1 | a_art+1 * result_n+2
	
	// get each disqualifier (separated by |s)
	wstring disqualifier;
	for (int i = 0; i < disqs_str.size(); i++)
	{
		if (disqs_str[i] == '|')
		{
			RemoveEndSpaces(disqualifier);
			disqualifiers.addDisqualifier(disqualifier);
			disqualifier.clear();
		}
		else
			disqualifier.push_back(disqs_str[i]);
	}
	RemoveEndSpaces(disqualifier);
	disqualifiers.addDisqualifier(disqualifier);
}

void P_SegmentRule::insertConnector(wstring connect_str)
// DONE 23-08-06
{
	connector = connect_str;
}

P_SegmentMatch* P_SegmentRule::findMatch(vector<vector<P_LexicalEntry*> > &lexical_entry_list, vector<Token*> &token_list)
// DONE 23-08-06
{
	short match_index = 0;
	match_index = indicator_sequence.findMatch(lexical_entry_list, token_list, match_index);
	while (match_index)
	{	
		if (!disqualifiers.disqualified(lexical_entry_list, token_list, match_index))
		{
			P_SegmentMatch *match = new P_SegmentMatch();
			match->match_index = match_index;
			match->match_length = indicator_sequence.getSequenceLength();
			match->connector = connector;
			return match;
		}
		match_index = indicator_sequence.findMatch(lexical_entry_list, token_list, match_index);
	}
	return NULL;
}

void P_SegmentRule::removeInvalidEntries(vector<vector<P_LexicalEntry*> >& lexical_entry_list, P_SegmentMatch* match)
// DONE 24-08-06
{
	// go through all indicators and disqualifiers and remove entries as required
	indicator_sequence.removeInvalidEntries(lexical_entry_list, match);
	disqualifiers.removeInvalidEntries(lexical_entry_list, match);
}
