#include "stdafx.h"
#include "P_Segmenter.h"

P_Segmenter::P_Segmenter(string segment_rule_file)
// DONE 23-08-06
{
	P_SegmentRule* segment_rule;
		
	// read in rules from file and populate segment_rules
	ifstream seg_stream;
	wchar_t* input_char;
	wstring input_wstring;
	input_char = new wchar_t[1];
	
	wstring indicator_wstring;
	wstring disqualifier_wstring;
	wstring connector_wstring;

	seg_stream.open(segment_rule_file.c_str(), ios::in | ios::binary);
	seg_stream.read((char*)input_char, 2);
		
	short rule_index = 0;

	while (!seg_stream.eof())
	{
		segment_rule =  new P_SegmentRule();
		
		// first skip comment line for each rule
		/*while (input_char[0] != 13 && input_char[0] != 10) CHANGED IN THIS (LINUX ONLY) VERSION*/
		while ((char)input_char[0] != '\r' && (char)input_char[0] != '\n')
		{
			seg_stream.read((char*)input_char, 2);
		}
		seg_stream.read((char*)input_char, 2);
		input_char[0] = '\0';

		/*while (input_char[0] != 13 && input_char[0] != 10)CHANGED IN THIS (LINUX ONLY) VERSION*/
		while ((char)input_char[0] != '\r' && (char)input_char[0] != '\n')
		{
			seg_stream.read((char*)input_char, 2);
			if (input_char[0] != 13 && input_char[0] != 10)
				indicator_wstring.push_back(input_char[0]);
		}
		segment_rule->insertIndicatorSequence(indicator_wstring);
		
		// checking what rule no.s the p & and rules will be
		if (indicator_wstring == L"p:#")
			p_rule_no = rule_index;
		if (indicator_wstring == L"and:coord_conj")
			and_rule_no = rule_index;
		// checking ends 

		indicator_wstring.clear();
		seg_stream.read((char*)input_char, 2);
		input_char[0] = '\0';
		
		/*while (input_char[0] != 13 && input_char[0] != 10)CHANGED IN THIS (LINUX ONLY) VERSION*/
		while ((char)input_char[0] != '\r' && (char)input_char[0] != '\n')
		{
			seg_stream.read((char*)input_char, 2);
			if (input_char[0] != 13 && input_char[0] != 13)
				disqualifier_wstring.push_back(input_char[0]);
		}
		if (disqualifier_wstring != L"#")	// indicates that there is no disqualifier
			segment_rule->insertDisqualifiers(disqualifier_wstring);
		disqualifier_wstring.clear();
		seg_stream.read((char*)input_char, 2);
		input_char[0] = '\0';

		/*while (input_char[0] != 13 && input_char[0] != 10 && !seg_stream.eof())CHANGED IN THIS (LINUX ONLY) VERSION*/
		while ((char)input_char[0] != '\r' && (char)input_char[0] != '\n' && !seg_stream.eof())
		{
			seg_stream.read((char*)input_char, 2);
			if (input_char[0] != 13 && input_char[0] != 10)
				connector_wstring.push_back(input_char[0]);
		}
		segment_rule->insertConnector(connector_wstring);
		connector_wstring.clear();
		seg_stream.read((char*)input_char, 2);
		input_char[0] = '\0';

		// get rid of new line
		seg_stream.read((char*)input_char, 2);
		seg_stream.read((char*)input_char, 2);
		input_char[0] = '\0';
		segment_rules.push_back(segment_rule);
		
		rule_index++;
	}	
	seg_stream.close();
}	

P_Segmenter::~P_Segmenter(void)
// DONE 23-08-06
{
}

vector<P_Segment*> P_Segmenter::startRecursiveSegmentation(vector<vector<P_LexicalEntry*> >& lexical_entry_list, vector<Token*>& token_list)
// DONE 23-08-06
{
	segment(lexical_entry_list, token_list);
	return segments;
}

void P_Segmenter::segment(vector<vector<P_LexicalEntry*> >& lexical_entry_list, vector<Token*>& token_list, P_SegmentMatch* in_match)
// DONE 23-08-06
{
	vector<P_SegmentRule*>::iterator rules_it;
	P_SegmentMatch *match = NULL;
	P_Segment* left_segment;
	short i = 0;
	
	for (rules_it = segment_rules.begin(); rules_it != segment_rules.end(); rules_it++)
	{
		match = (*rules_it)->findMatch(lexical_entry_list, token_list);
		if (match != NULL)
		{
			match->rule_index = i;	// to indicate the rule that was used for the  segmentation
			left_segment = extractSegment(lexical_entry_list, token_list, match);
			segment(left_segment->lexical_entry_list, left_segment->token_list, match);
			segment(lexical_entry_list, token_list, in_match);
			return;
		}
		i++;
	}
	addLastSegment(lexical_entry_list, token_list, in_match);
}

P_Segment* P_Segmenter::extractSegment(vector<vector<P_LexicalEntry*> >& lexical_entry_list, vector<Token*>& token_list, P_SegmentMatch *match)
// DONE 24-08-06
{
    short total_entries = lexical_entry_list.size();
	short segment_entries;
	short to_discard;
	short remaining_entries;
	
	vector<vector<P_LexicalEntry*> > temp_entries;
	vector<Token*> temp_BNC;
	P_Segment* segment = new P_Segment();
	segment->rule_no = match->rule_index;

	// first take the lexical entry list and discard the entries that have become invalid due to the 
	// rule application
	removeInvalidEntries(lexical_entry_list, match);
	
	// we need to figure out whether the segment indicator is part of the segment
	if ((match->connector != L"F") && (match->connector != L"S"))
	{
		// the indicator is not part of the segment; so copy upto the last entry b4 the connector;
		// for the remaining sentence remove the segment and the indicator
		segment->connector = match->connector;
		segment_entries = match->match_index;
		to_discard = match->match_length;
		remaining_entries = total_entries - (segment_entries + to_discard);
				
		// back up remaining entries
		short i = 0;
		while (i < remaining_entries)
		{
			temp_entries.push_back(lexical_entry_list.back());
			lexical_entry_list.pop_back();

			temp_BNC.push_back(token_list.back());
			token_list.pop_back();

			i++;
		}
		
		// get rid of indicator entries
		i = 0;
		while (i < to_discard)
		{
			lexical_entry_list.pop_back();
			token_list.pop_back();
			i++;
		}

		// get segment stuff
		segment->lexical_entry_list = lexical_entry_list;
		segment->token_list = token_list;
        
		// clear and re-do the remaing stuff
		lexical_entry_list.clear();
		token_list.clear();
		while (!temp_entries.empty())	
		{
			lexical_entry_list.push_back(temp_entries.back());
			temp_entries.pop_back();

			token_list.push_back(temp_BNC.back());
			temp_BNC.pop_back();
		}
		getRidOfCommas(segment);
	//	segments.push_back(segment);
	}
	else
	{
		segment->connector = L"";
		if (match->connector == L"F")
			segment_entries = match->match_index + match->match_length;
		else
			segment_entries = match->match_index;

		remaining_entries = total_entries - segment_entries;
		// get remaining
		int i = 0;
		while (i < remaining_entries)
		{
			temp_entries.push_back(lexical_entry_list.back());
			lexical_entry_list.pop_back();
				
			temp_BNC.push_back(token_list.back());
			token_list.pop_back();
			i++;
		}

		// get segment stuff
		segment->lexical_entry_list = lexical_entry_list;
		segment->token_list = token_list;
	        
		// clear and re-do the remaing stuff
		lexical_entry_list.clear();
		token_list.clear();
		while (!temp_entries.empty())	
		{
			lexical_entry_list.push_back(temp_entries.back());
			temp_entries.pop_back();

			token_list.push_back(temp_BNC.back());
			temp_BNC.pop_back();
		}
		getRidOfCommas(segment);
	//	segments.push_back(segment);
	}
	return segment;
}

void P_Segmenter::addLastSegment(vector<vector<P_LexicalEntry*> >& lexical_entry_list, vector<Token*>& token_list, P_SegmentMatch* match)
// DONE 24-08-06
{
	P_Segment* segment = new P_Segment();
	if (match)
		segment->rule_no = match->rule_index;
	segment->lexical_entry_list = lexical_entry_list;
	segment->token_list = token_list;
	if (match)
	{
		if ((match->connector != L"S") && (match->connector != L"F"))
		segment->connector = match->connector;
	}
	getRidOfCommas(segment);
	segments.push_back(segment);
}

void P_Segmenter::removeInvalidEntries(vector<vector<P_LexicalEntry*> >& lexical_entry_list, P_SegmentMatch* match)
// DONE 24-08-06
{
	// first get the rule that was applied
	vector<P_SegmentRule*>::iterator rules_it = segment_rules.begin();
	for (short i = 0; i < match->rule_index; i++)
		rules_it++;

	// invalid entries will be created due to 2 reasons:
	
	// 1. due to the segmentation indicators; if the selection has been made on account of a pos, it would
	// have been made using the entry with the highest probability pos, this will invalidate all the 
	// entries with the lower probability POSs
			
	// 2. due to the disqualification mechanism; the disqualifiers are also checked using the 
	// highest probability entry; so we need to check each disqualifier which is a pos and then remove the
	// entry (which will be a lower probability one - because the segment position would have been 
	// discarded if it had been the highest probably one and would never have reached this point)
	// that has that pos
	
	(*rules_it)->removeInvalidEntries(lexical_entry_list, match);
}

void P_Segmenter::collectSelectiveGarbage(void)
{
	segments.clear();
}

void P_Segmenter::getRidOfCommas(P_Segment* segment)
// removing commas at the start and at the end
{
	wchar_t* urdu_comma;
	urdu_comma = new wchar_t[1];
	urdu_comma[0] = '،';//1548
	vector<Token*>::iterator tok_it = segment->token_list.end();
	tok_it--;
	if ((*tok_it)->lexeme == L",")
	{
		segment->token_list.pop_back();
		segment->lexical_entry_list.pop_back();
		/*segment->connector.insert(0, 1548);*/
		segment->connector.insert(0, urdu_comma);
	}
	
	tok_it = segment->token_list.begin();
	if ((*tok_it)->lexeme == L",")
	{
		vector<vector<P_LexicalEntry*> > temp_entries;
		vector<Token*> temp_BNC;
		while (!(segment->token_list.empty()))
		{
			temp_BNC.push_back(segment->token_list.back());
			segment->token_list.pop_back();
			temp_entries.push_back(segment->lexical_entry_list.back());
			segment->lexical_entry_list.pop_back();
		}
		// now empty, get rid of comma
		temp_BNC.pop_back();
		temp_entries.pop_back();

		// re-fill
		while (!temp_BNC.empty())
		{
			segment->token_list.push_back(temp_BNC.back());
			temp_BNC.pop_back();
			segment->lexical_entry_list.push_back(temp_entries.back());
			temp_entries.pop_back();
		}
		(segments.back())->connector.push_back(1548);

	}
}
