#pragma once

/*ADDED IN THIS (LINUX) VERSION*/
#ifndef P_SEGMENTER_H
#define P_SEGMENTER_H
/*ADDED IN THIS (LINUX) VERSION*/

#include <vector>
#include <fstream>
using namespace std; 

#include "P_LexicalEntry.h"
#include "Token.h"
#include "P_Segment.h"
#include "P_SegmentRule.h"
#include "P_SegmentMatch.h"

class P_Segmenter
{
public:
	P_Segmenter(string segment_rule_file);
	~P_Segmenter(void);
	vector<P_Segment*> startRecursiveSegmentation(vector<vector<P_LexicalEntry*> > &lexical_entry_list, vector<Token*> &token_list);
	void collectSelectiveGarbage(void);
	short p_rule_no;
	short and_rule_no;

private:
	vector<P_Segment*> segments;
	vector<P_SegmentRule*> segment_rules;	

	void segment(vector<vector<P_LexicalEntry*> >& lexical_entry_list, vector<Token*> &token_list, P_SegmentMatch* in_match = NULL);
	P_Segment* extractSegment(vector<vector<P_LexicalEntry*> >& lexical_entry_list, vector<Token*> &token_list, P_SegmentMatch *match);
	void addLastSegment(vector<vector<P_LexicalEntry*> >& lexical_entry_list, vector<Token*> &token_list, P_SegmentMatch* match);
	void removeInvalidEntries(vector<vector<P_LexicalEntry*> >& lexical_entry_list, P_SegmentMatch* match);
public:
	void getRidOfCommas(P_Segment* segment);
};
#endif /*ADDED IN THIS (LINUX) VERSION*/

/***********INDICATOR & DISQUALIFIER USAGE***********
**********************************************************************************************************
TYPE:					  *	INDICATOR:								  * DISQUALIFIER:
						  ********************************************************************************
						  *	SELECT:			  * DISCARD:			  *	SELECT:			  *	DISACRD:
**********************************************************************************************************
word w/ pos (flies_n)	  *	any pos match	  *	all non-matching pos  *	any pos match	  *	matching pos
**********************************************************************************************************
pos (n)					  *	highest prob	  *	all non-matching pos  *	highes prob		  *	matching pos 
						  *	pos match		  *						  *	pos match		  *	
**********************************************************************************************************
***********INDICATOR & DISQUALIFIER USAGE***********/