// RawProduction.cpp: implementation of the CRawProduction class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

#include "RawProduction.h"

#include "LogManager.h"

int CRawProduction::counter=0;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRawProduction::CRawProduction()
{
	LHS=NULL;	
	counter++;
}

CRawProduction::~CRawProduction()
{
	using namespace std;

	if(LHS)
	{
		try{
			delete LHS;
			LHS=NULL;
		}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"~CRawProduction(): #### LHS");
			#endif
		}

	}
	
	if(!RHS.empty())
	{
		for(vector<CSymbol*>::iterator it=RHS.begin();it!=RHS.end();it++)
		{
			try{
				delete *it;
			}
			catch(...)
			{
				#ifdef GenLog
				CLogManager::AddMessage(L"~CRawProduction(): #### *it");
				#endif
			}
		}
		RHS.clear();
	}
	counter--;
}

vector<CSymbol*> * CRawProduction::GetRHSList(short index)
{
	vector<CSymbol*> * reqList=NULL;

	short len=RHS.size();

	if(index>=len)
		return reqList;

	reqList=new vector<CSymbol*>;

	if(!reqList)
		return NULL;

	for(;index<len;index++)
		reqList->push_back(RHS.at(index));

	return reqList;

}

void CRawProduction::print()
{
	using namespace std;

	wprintf(L"%s ==> ",LHS->lexeme.c_str());
	
	vector<CSymbol*> * rp_rhs=&RHS;
	CSymbol*symb=NULL;

	for(vector<CSymbol*>::iterator it2= rp_rhs->begin(); it2!=rp_rhs->end();it2++)
		{
			symb=*it2;
			//wprintf(L"		%s %s \n",rs->lexeme.c_str(),rs->condition.c_str()); 
			wprintf(L"%s ",symb->lexeme.c_str()); 
		}
		
	wprintf(L"\n"); 		
}

void CRawProduction::printW()
{
	using namespace std;

	wstring output=LHS->lexeme;

	output+=L" ==> ";	
	
	vector<CSymbol*> * rp_rhs=&RHS;
	CSymbol*symb=NULL;

	for(vector<CSymbol*>::iterator it2= rp_rhs->begin(); it2!=rp_rhs->end();it2++)
		{
			symb=*it2;
			output+=L"\n";
			output+=symb->lexeme;
			output+=L" @ ";
			output+=symb->condition;						
		}
		
	/*MessageBox(NULL,output.c_str(),L"Raw Production",MB_ICONINFORMATION); REMOVING IN THIS DOS/LINUX VERSION */
}
