// Transliterator.cpp: implementation of the CTransliterator class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#pragma warning(disable: 4786)

#include "Transliterator.h"
#include "Rule.h"/*CHANGED IN THIS (LINUX) VERSION*/
#include "global.h"
#include <iostream>
#include <list>
#include "FileReader.h"/*CHANGED IN THIS (LINUX) VERSION*/

#include "LogManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
/*#define new DEBUG_NEW [REMOVING IN THIS (DOS/LINUX) VERSION] */
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
// transliterator.cpp: implementation of the CTransliterator class.
//
//////////////////////////////////////////////////////////////////////


typedef list<int> INTEGERLIST;
 
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CTransliterator::counter=0;

CTransliterator::CTransliterator(string fname)
{
	counter++;

	CFileReader rulesReader(fname.c_str(),256);
	
	CRule * tempRule=NULL;

	short ch=0;
	short alph=0;
	short chk=0;
	wstring RuleStr=L"";
	wstring MapStr=L"";
	int replace=0;
	ch=rulesReader.GetCurrentChar();
	CRULEVECTOR v;
	
	short end=L'\n';

	while(ch!=0)
	{
		if(ch==L'=')
		{
			ch=rulesReader.MoveNext();
			alph=ch;
			CRULEVECTOR * vec=new CRULEVECTOR;
			
			if(!vec)
				continue;
			
			while(ch!=end)
			{
				ch=rulesReader.MoveNext();
			}
			ch=rulesReader.MoveNext();

			while(1)
			{				
				RuleStr=L"";
				MapStr=L"";
				replace=0;
				while(ch!=L':')
				{
					if(ch!=L':')
					{
						RuleStr+=ch;
					}
					ch=rulesReader.MoveNext();
				}
				ch=rulesReader.MoveNext();
				while(ch!=L'.')
				{
					if(ch!=L'.')
					{
						MapStr+=ch;
					}
					ch=rulesReader.MoveNext();
				}
				ch=rulesReader.MoveNext();
				if(ch>=48 && ch <=57)
				{
					replace=ch-48;
				}
				while(ch!=L'\n')
				{
					ch=rulesReader.MoveNext();
				}
				
				tempRule=new CRule(RuleStr,MapStr, replace);
				
				if(!tempRule)
					break;

				vec->push_back(tempRule);
				ch=rulesReader.MoveNext();
				if(ch==L'=' || ch==0)
				{
					this->ruleMap.insert(make_pair(alph,vec));
					break;
				}
			}
		}
	}
}

/////////////////////////////////////////////////////////////
CTransliterator::~CTransliterator()
{
	counter--;
	
	//ruleMap.erase(ruleMap.begin(),ruleMap.end());

	CRULEVECTOR * tvect = NULL;
	CRule*rule=NULL;

	for(map<short,CRULEVECTOR* >::iterator it=ruleMap.begin();it!=ruleMap.end();it++)
	{
		tvect=it->second;
		for(vector<CRule*>::iterator it2=tvect->begin();it2!=tvect->end();it2++)
		{
			rule=*it2;
			try{
			delete rule;
			}
		catch(...)
		{
			#ifdef GenLog
			CLogManager::AddMessage(L"#### rule");
			#endif
		}

		}
	}

}
/////////////////////////////////////////////////////////////
wstring CTransliterator::transliterate(wstring string)
{
	wstring CompleteString=string;
	wstring englishWord=L"";
	wstring urduString=L"";
	int index=0;
	int count=0;
	//englishWord=TrimString(englishWord);
	
	CRULEVECTOR * v=NULL;
	CRule*rule=NULL;

while(count<CompleteString.size())
{
	while(count<CompleteString.size() && CompleteString.at(count)!=32)
	{
		englishWord.push_back(CompleteString.at(count));
		count++;
	}
	englishWord=ConvertToLower(englishWord);
	this->normalize(englishWord);

	while(index!=englishWord.size())
	{
		if(ruleMap.count(englishWord.at(index))==0)
		{
			urduString+=englishWord.at(index);
			index=index+1;
		}
		else
		{
			v=ruleMap[englishWord.at(index)];
			for (vector<CRule*>::iterator i = v->begin(); i != v->end(); ++i)
			{
				rule=*i;
				if(rule->ApplyRule(englishWord,index,urduString)==true)
				{
					break;
				}
			}
		}
	}
	char a=32;
	urduString.push_back(a);
	count++;
	englishWord=L"";
	index=0;
}

	return urduString;
}
/////////////////////////////////////////////////////////////

void CTransliterator::normalize(wstring& eng)
{
	eng= L"<" + eng;
	eng= eng + L">";
	INTEGERLIST positions;

	if(eng.substr(eng.size()-2, eng.size()-1) == L"e>")
	{
		if(eng.find_last_of(L"i",eng.size()-3)<eng.size() && eng.find_last_of(L"i",eng.size()-3)>=0)
		{
			positions.push_back(eng.find_last_of(L"i",eng.size()-3));
		}
		if(eng.find_last_of(L"e",eng.size()-3)<eng.size() && eng.find_last_of(L"e",eng.size()-3)>=0)
		{
			positions.push_back(eng.find_last_of(L"e",eng.size()-3));
		}
		if(eng.find_last_of(L"u",eng.size()-3)<eng.size() && eng.find_last_of(L"u",eng.size()-3)>=0)
		{
			positions.push_back(eng.find_last_of(L"u",eng.size()-3));
		}
		if(eng.find_last_of(L"y",eng.size()-3)<eng.size() && eng.find_last_of(L"y",eng.size()-3)>=0)
		{
			positions.push_back(eng.find_last_of(L"y",eng.size()-3));
		}
		if(positions.size()>0)
		{
			positions.sort();
			if(positions.back()==eng.size()-4)
			{
				appendAt(eng, positions.back(), L"*");
			}
		}
	}
	else if(eng.size()>3 && eng.substr(eng.size()-3, eng.size()-1) == L"ed>" )
	{
		char a=eng.at(eng.size()-3);
		a=eng.at(eng.size()-2);
		wstring c=eng.substr(eng.size()-3, eng.size()-1);

		if(eng.find_last_of(L"i",eng.size()-4)<eng.size() && eng.find_last_of(L"i",eng.size()-4)>=0)
		{
			positions.push_back(eng.find_last_of(L"i",eng.size()-4));
		}
		if(eng.find_last_of(L"e",eng.size()-4)<eng.size() && eng.find_last_of(L"e",eng.size()-4)>=0)
		{
			positions.push_back(eng.find_last_of(L"e",eng.size()-4));
		}
		if(eng.find_last_of(L"u",eng.size()-4)<eng.size() && eng.find_last_of(L"u",eng.size()-4)>=0)
		{
			positions.push_back(eng.find_last_of(L"u",eng.size()-4));
		}
		if(eng.find_last_of(L"y",eng.size()-4)<eng.size() && eng.find_last_of(L"y",eng.size()-4)>=0)
		{
			positions.push_back(eng.find_last_of(L"y",eng.size()-4));
		}
		if(positions.size()>0)
		{
			positions.sort();
			if(positions.back()==eng.size()-5)
			{
				appendAt(eng, positions.back(), L"*");
			}
		}
	}
	int index=1;
}
//////////////////////////////////////////////////////////////




