#include "stdafx.h"
#include "WSDManager.h" /*CHANGED IN THIS (LINUX) VERSION*/

using namespace std;
CWSDManager::CWSDManager(void)
{
}

CWSDManager::~CWSDManager(void)
{
}

bool CWSDManager::Initialize()
{
	WordListFilePath=CConfiguration::GetConfigInfo("WSDWordListFile");
	SenseInfoFilePath=CConfiguration::GetConfigInfo("WSDSenseInfoFile");

	SenseInfoFile.open(SenseInfoFilePath.c_str(),ios::binary);
	if(!SenseInfoFile)
		return false;
	
	CollInfoFilePath=CConfiguration::GetConfigInfo("WSDCollInfoFile");

	CollInfoFile.open(CollInfoFilePath.c_str(),ios::binary);
	if(!CollInfoFile)
		return false;

	CollocationWindowSize=atoi(CConfiguration::GetConfigInfo("WSDCollocationWindowSize").c_str());

	return LoadWordList();

	//incorporate logging and maintain status of WSD-manager as initialized or un-innitialized
}

void CWSDManager::OnSentenceStart(int sentense_size)
{
	//this function is not being used, not needed
	AlreadyDoneWords.clear();
	AlreadyDoneWords.resize(sentense_size);
}

bool CWSDManager::RankData(wstring amb_word, list<CSenseInfo*> & senses,	CSentenceInfo & sentence, short CurrentWordIndex)
{
	vector<Collocation> CollList;
	list<CSenseInfo*>::iterator it1,it2;	
	wstring hash_key=L"";
	short pos;
	bool ret_val=false;
	int index=amb_word.find_last_of('_');
	amb_word=amb_word.substr(0,index);

	hash_key=amb_word;//sentence.Words[CurrentWordIndex]->Word;
	pos=sentence.Words[CurrentWordIndex]->POS;
	hash_key+=(wchar_t)pos; //commented for the time being........uncommented nnow
	
	if(WordListMap.find(hash_key)!=WordListMap.end())
	{
		GetCollocations(CollList, sentence, CurrentWordIndex);

		vector<SenseCollInfo> SCInfoList;
		LoadSenseInfoBlock(WordListMap[hash_key].SenseStartIndex,WordListMap[hash_key].SenseEndIndex,SCInfoList);

		for(it1=senses.begin();it1!=senses.end();it1++)
			(*it1)->Rank=GetSenseStrength((*it1)->SenseId,CollList,SCInfoList);

		for(it1=senses.begin();it1!=senses.end();it1++)
		{
			if((*it1)->Rank>0)
			{
				ret_val=true;
				senses.sort(JustForSorting());
				senses.reverse();
				break;
			}
		}
		return ret_val;
	}
	else
		return false;
}

int Hash(string key, char pos, int size)
{
	//key+=pos;
	unsigned long h = 0, a = 31415, b = 27183;
	if(size>1)
	{
		if(size > 0)
		{
			for(int i = 0; i < key.size(); i++, a = a*b%(size - 1))
			{
				h = (a*h + key[i]) % (size);
			}
		}
	}
	else
		h=0;
	
	return h;
}

float CWSDManager::GetSenseStrength(int SenseId,vector<Collocation> CollList, vector<SenseCollInfo> SCInfoList)
{
	CollInfo * CollBlock;
	int block_size;
	int i;
	
	for(i=0;i<SCInfoList.size();i++)
	{
		if(SCInfoList[i].SenseNo==SenseId)
		{
			block_size=SCInfoList[i].CollInfoEndIndex-SCInfoList[i].CollInfoStartIndex+1;
			CollBlock=new CollInfo[block_size];
			LoadCollBlock(SCInfoList[i], CollBlock);
			break;
		}
	}

	if(i<SCInfoList.size())
	{
		float MaxStrength=0.0;

		int index;

		for(int i=0;i<CollList.size();i++)
		{
			index=Hash(CollList[i].Word,CollList[i].POS,block_size); //commented for the time being...uncommented now
			if(index>=0)
			{
				while(!(strcmp(TrimString(CollBlock[index].Coll.Word).c_str(),CollList[i].Word)==0 && CollBlock[index].Coll.position==CollList[i].position)&& CollBlock[index].Next!=0)
				{
					index=CollBlock[index].Next;
				}
				if(strcmp(TrimString(CollBlock[index].Coll.Word).c_str(),CollList[i].Word)==0 && CollBlock[index].Coll.position==CollList[i].position)
				{
					if(CollBlock[index].Salience>MaxStrength)
						MaxStrength=CollBlock[index].Salience;
				}
			}
		}

		return MaxStrength;
	}
	else
		return 0.0;
}

bool CWSDManager::LoadWordList()
{
	ifstream words_file;
	words_file.open(WordListFilePath.c_str(),ios::binary);
	
	if(!words_file)
		return false;

	WordListNode WLNode;
	wstring hash_key;
	char c; short pos;

	while(!words_file.eof())
	{
		hash_key=L"";
		words_file.read((char *)&WLNode,sizeof(WLNode));
		for(int i=0;WLNode.Word[i]!='\0' && i<50;i++)
			hash_key+=WLNode.Word[i];
		pos=WLNode.POS;
		hash_key+=(wchar_t)pos; //commented for the time being
		WordListMap[hash_key]=WLNode;
	}

	words_file.close();

	return true;
}

void CWSDManager::GetCollocations(vector<Collocation> &CollList, CSentenceInfo SentencePOSInfo, int CurrentWordIndex)
{
	//+k collocations

	for(int i=CurrentWordIndex+1;i<SentencePOSInfo.Words.size() && i<=CurrentWordIndex+CollocationWindowSize;i++)
	{
		Collocation coll;
		strcpy(coll.Word,Convert_wstr2str(SentencePOSInfo.Words[i]->Word).c_str());
		coll.POS=SentencePOSInfo.Words[i]->POS;

		if(i<=CollocationWindowSize)
		{
			coll.position=i-CurrentWordIndex;
			CollList.push_back(coll);
		}
		else
		{
			//coll.position=CollocationWindowSize+1;
			//CollList.push_back(coll);

			coll.position=0;
			CollList.push_back(coll);
		}
	}

	//-k collocations

	for(int i=CurrentWordIndex-1;i>=0 && i>=CurrentWordIndex-CollocationWindowSize;i--)
	{
		Collocation coll;
		strcpy(coll.Word,Convert_wstr2str(SentencePOSInfo.Words[i]->Word).c_str());
		coll.POS=SentencePOSInfo.Words[i]->POS;
		
		if((CurrentWordIndex-i)<=CollocationWindowSize)
		{
			coll.position=(i-CurrentWordIndex);
			CollList.push_back(coll);
		}
		else
		{
			//coll.position=-(CollocationWindowSize+1);
			//CollList.push_back(coll);

			coll.position=0;
			CollList.push_back(coll);
		}
	}

}

void CWSDManager::LoadSenseInfoBlock (int StartSenseIndex, int EndSenseIndex, vector<SenseCollInfo> &SCInfoList)
{
	SenseInfoFile.seekg((StartSenseIndex-1)*sizeof(SenseCollInfo));
    
	SenseCollInfo SCI;

	for(int i=StartSenseIndex;i<=EndSenseIndex;i++)
	{
		SenseInfoFile.read((char *)&SCI,sizeof(SenseCollInfo));
		SCInfoList.push_back(SCI);
	}
}

void CWSDManager::LoadCollBlock(SenseCollInfo SCI, CollInfo * CollBlock)
{
	int test=sizeof(CollInfo);
	CollInfoFile.seekg((SCI.CollInfoStartIndex-1)*sizeof(CollInfo));
	CollInfoFile.read((char *)CollBlock,(SCI.CollInfoEndIndex-SCI.CollInfoStartIndex+1)*sizeof(CollInfo));
}


	//*******check for already disambiguated case**************
	//*********************************************************
	//if found give its sense ranks and then sort and set retval to what it was then
	/*
	int x=AlreadyDoneWords[CurrentWordIndex].size();

	for(list<DisambiguatedWord>::iterator it=AlreadyDoneWords[CurrentWordIndex].begin();it!=AlreadyDoneWords[CurrentWordIndex].end();it++)
	{
		if(it->word_and_pos==hash_key)
		{
			list<CSenseInfo>::iterator itsen_old=it->senses.begin();
			for(list<CSenseInfo*>::iterator itsen=senses.begin();itsen!=senses.end();itsen++)
			{
				(*itsen)->Rank=itsen_old->Rank;
				itsen_old++;
			}
			senses.sort(JustForSorting());
			
			if(it->retval)
			{
				senses.sort(JustForSorting());
				it1=senses.begin();
				while((*it1)->Rank==0 && it1!=senses.end())
				{
					it2=it1;
					it2++;
					senses.remove(*it1);
					it1=it2;
				}
			}

			return it->retval;
		}
	}*/
	//*********************************************************
	//**************************end check**********************

		//*************put in the map of disambiguated words**************
		//****************************************************************

		/*DisambiguatedWord dw;
		for(list<CSenseInfo*>::iterator itsen=senses.begin();itsen!=senses.end();itsen++)
		{
			dw.senses.push_back(*(*itsen));
		}
		dw.retval=ret_val;
		dw.word_and_pos=hash_key;
		AlreadyDoneWords[CurrentWordIndex].push_back(dw);*/

		//****************************************************************
		//*******************end put**************************************
		/*if(ret_val)
		{
			it1=senses.begin();
			while((*it1)->Rank==0 && it1!=senses.end())
			{
				it2=it1;
				it2++;
				senses.remove(*it1);
				it1=it2;
			}
		}*/