#pragma once

/*ADDED IN THIS (LINUX) VERSION*/
#ifndef WSDMANAGER_H
#define WSDMANAGER_H
/*ADDED IN THIS (LINUX) VERSION*/

#include "SentenceInfo.h"
#include "SenseInfo.h"
#include "WordListNode.h"
#include "SenseCollInfo.h"
#include "CollInfo.h"
#include "CConfiguration.h"
#include <fstream>
#include <list>
#include <string>

struct DisambiguatedWord
{
	wstring word_and_pos;
	list<CSenseInfo> senses;
	bool retval;
};

class CWSDManager
{
private:
	hash_map<wstring,WordListNode> WordListMap;
	vector< list<DisambiguatedWord> > AlreadyDoneWords;
	int CollocationWindowSize;
	string WordListFilePath;
	string SenseInfoFilePath;
	string CollInfoFilePath;
	ifstream SenseInfoFile;
	ifstream CollInfoFile;

	float GetSenseStrength(int SenseId,vector<Collocation> CollList, vector<SenseCollInfo> SCInfoList);
	void GetCollocations(vector<Collocation> &CollList, CSentenceInfo SentencePOSInfo, int CurrentWordIndex);
	void LoadSenseInfoBlock (int StartSenseIndex, int EndSenseIndex, vector<SenseCollInfo> &SCInfoList);
	void LoadCollBlock(SenseCollInfo SCI, CollInfo * CollBlock);
	bool LoadWordList();

public:
	CWSDManager(void);
	~CWSDManager(void);
	bool Initialize();
	void OnSentenceStart(int size);
	bool RankData(wstring amb_word,	list<CSenseInfo*> & senses,	CSentenceInfo & sentence, short CurrentWordIndex);
};


//Here is the functor you should make to tell the sort function how to sort your class:

struct JustForSorting : public binary_function < CSenseInfo *, CSenseInfo *, bool>
{
	bool operator()(CSenseInfo * x, CSenseInfo * y) 
	{ 
		return x->Rank < y->Rank ; 
	}
};
#endif /*ADDED IN THIS (LINUX) VERSION*/
