/*ADDED IN THIS (LINUX) VERSION*/
#ifndef FSGLOBAL_H
#define FSGLOBAL_H
/*ADDED IN THIS (LINUX) VERSION*/

typedef short PFSsymID;
typedef short PFSitemID;
typedef signed char contextByte;
typedef unsigned char byte;	/* ADDED FOR THIS (DOS/LINUX) VERSION */

#define OPEN_SQ_BRK -1
#define CLOSE_SQ_BRK -2
#define OR -3
#define AND -4
#define NOT -5
#define ENDFD -10

#define FSSYMBOLTABLESIZE 550
#define FSITEMTABLESIZE 25000

#define FDESCNUMSIZE 1000	// see fdesc_numeric description in P_FSInitializer

#define TEMPSTENTRIES 100	// no. of temp symbol table entries
#define TEMPFDSTRSIZE 2000	// for initializtion
#define PERCTEMPFDSTRSIZE 100	// for each cycle

// for bit operations in attribute and value types
#define FSATTR 128	// i.e. an attribute such as SUBJ that requires an f-structure as it's value
#define DOWNARROWATTR 32	// !, 3rd bit on 	
#define COMPLEXATTR 64	// 2nd bit on
#define OPEQUAL 0
#define OPSET 8
#define OPEQUALC 16
#define OPNOT 24
#define NOATTRTYPE 7	// 00000011
#define NOVALTYPE 63	// 00111111
#define DOWNARROWVAL 128	// 10000000
#define COMPLEXVAL 64	// 01000000

#pragma once

#include<list>
#include<stack>
#include<math.h>
#include"global.h"

using namespace std;
/* static clock_t current_time; REMOVED IN THIS (DOS/LINUX) VERSION */



class SubSet
{
public:
	int col;
	bool sign;
};
inline bool opposingContextsPresent(list<contextByte> &list1, list<contextByte> &list2)
{
	// assuming that the context expression is in ascending order: e.g., -4 -1 2 3
	list<contextByte>::iterator it1;
	list<contextByte>::iterator it2;

	for (it1 = list1.begin(); it1 != list1.end(); it1++)
	{
		for (it2 = list2.begin(); it2 != list2.end(); it2++)
		{
			if (((*it1) == -(*it2)) && ((*it1) != 0) )
				return true;
		}
	}
	return false;
}
inline bool opposingContextPresent(list<contextByte> &list1, contextByte context)
{
	// assuming that the context expression is in ascending order: e.g., -4 -1 2 3
	list<contextByte>::iterator it1;
	
	for (it1 = list1.begin(); it1 != list1.end(); it1++)
	{
		if (((*it1) == -(context)) && ((*it1) != 0) )
			return true;
	}
	return false;
}

inline list<contextByte> getUnion(list<contextByte> &list1, list<contextByte> &list2)
{
	bool found = false;
	list<contextByte> union_list = list1;
	
	list<contextByte>::iterator union_it;
	list<contextByte>::iterator it2;
	
	for (it2 = list2.begin(); it2 != list2.end(); it2++)
	{
		found = false;
		for (union_it = union_list.begin(); union_it != union_list.end(); union_it++)
		{
			if (*it2 == *union_it)
			{
				found = true;
				break;
			}
			if (*it2 < *union_it)	// sorted in ascending order so will not be found now
				break;
		}
		if (!found)
			union_list.push_back(*it2);
	}

	union_list.sort();
	return union_list;
}

inline list<contextByte> getIntersection(list<list<contextByte> > contextLists)
{
	int neg[256]={0};
	int pos[256]={0};
	for(list<list<contextByte> >::iterator listit=contextLists.begin(); listit!=contextLists.end(); listit++)
	{
		for(list<contextByte>::iterator it=(*listit).begin();it!=(*listit).end();it++)
		{
			if((*it)>0)
			{
				pos[*it]++;
			}
			else if((*it)<0)
			{
				neg[-(*it)]++;
			}
		}
	}

	list<contextByte> retlist;
	int number_of_lists=contextLists.size();
	for(int i=0;i<256;i++)
	{
		if(pos[i]==number_of_lists)
			retlist.push_back(i);
		if(neg[i]==number_of_lists)
			retlist.push_back(-i);
	}

	return retlist;
}

inline bool IsContextSubset(list<contextByte> &list1, list<contextByte> &list2)
{
	list<contextByte>::iterator it1=list1.begin();
	list<contextByte>::iterator it2=list2.begin();
	bool found;

	while(it1!=list1.end())
	{
		found=false;
		while(it2!=list2.end())
		{
			if(*it1==*it2)
			{
				found=true;
				break;
			}
			it2++;
		}

		if(!found)
			return false;
		it1++;
	}
	
	return true;	
}
inline bool IsSubset(list<contextByte> &list1, list<contextByte> &list2)
{
	list<contextByte>::iterator it1=list1.begin();
	list<contextByte>::iterator it2;
	bool found;

	while(it1!=list1.end())
	{
		found=false;
		it2=list2.begin();
		while(it2!=list2.end())
		{
			if(*it1==*it2)
			{
				found=true;
				break;
			}
			it2++;
		}

		if(!found)
			return false;
		it1++;
	}
	
	return true;	
}

inline list<contextByte> UnknowContexts(list<contextByte> &list1, list<contextByte> &list2)
{
      list<contextByte>::iterator it1;
      list<contextByte>::iterator it2=list2.begin();
      bool found;
	  list<contextByte> foundContexts;

	  for(it1=list1.begin(); it1!=list1.end(); it1++)
      {
           found=false;
           for(it2=list2.begin(); it2!=list2.end(); it2++)
           {
              if(*it1==*it2 || *it1==-(*it2))
              {
                  found=true;
                  break;
              }
           }
		
           if(!found)
		   {
/*if (*(it1) < 0)
			    	foundContexts.push_back(-*(it1));
			    else*/
				    foundContexts.push_back(*(it1));
	       }
     }

     return foundContexts;      
}
/*does not work for col > 31*/
inline int getSign(int row, int col)
{
//	int y = pow( 2 , (col + 1)); 
	int y = 1 << (col + 1); 
//	if(y != y1)
//		if(y1 = 1)
//			y1 = 2;

	int x = row % y; 
	
	y = y / 2;
	if( x <= (y - 1))
		return 1;
	else
		return -1;
}
/*inline list<contextByte> getSolution(list< list<contextByte> > nogoods)
{
	list<contextByte> solution_seg;
	list<contextByte> solution;
	list<contextByte> temp_list;
	list<contextByte> context_list, context_list1;
	list<contextByte> added_contexts;
	list< list<contextByte> >::iterator curr_nogd_it;
	list<contextByte>::iterator it;
	list<contextByte>::iterator it1;
	list<contextByte>::iterator it2;
	contextByte temp;
	stack<list<contextByte> > solution_stack;
	bool not_valid = false, zero_found = false, first = true;

	curr_nogd_it = nogoods.begin();
	(*curr_nogd_it).sort();
	(*curr_nogd_it).unique();
	it = (*curr_nogd_it).begin();

	if((*curr_nogd_it).size() == 1 && *it == 0)
		return solution;

	
	for (; it != (*curr_nogd_it).end(); it++)
	{
		if(*it)
		{
			solution_seg.push_back(-*(it));
			context_list1.push_back(*it);
		}
		else
			zero_found = true;
	}
	
	curr_nogd_it++;

	for (; curr_nogd_it != nogoods.end(); curr_nogd_it++)
	{
		(curr_nogd_it)->sort();
		(curr_nogd_it)->unique();
		temp_list = UnknowContexts(*(curr_nogd_it), context_list1);
		for(it = temp_list.begin(); it != temp_list.end(); it++)
			if( *it > 0)
				context_list.push_back(*it);
			else
				if( *it < 0)
					context_list.push_back(-(*it));
				else
					zero_found = true;
	}
	context_list.sort();
	context_list.unique();
	
	
	for (it = solution_seg.begin(); it != solution_seg.end(); it++)
	{
		temp = *(context_list1.begin());
		context_list1.pop_front();
		int context_count = context_list.size();
		int no_of_rows  = 1 << context_count;

		for (int row = 0; row < no_of_rows; row++)
		{
			not_valid = false;
			solution.push_back(*(it));
			int col = 0;
			for ( it1 = context_list.begin(); it1 != context_list.end(); it1++, col++)
			{	
				solution.push_back(getSign(row,col) * (*it1));
			}
			if(zero_found)
				solution.push_back(0);
			for ( it1 = context_list1.begin(); it1 != context_list1.end(); it1++)
			{	
				solution.push_back(*it1);
			}
			
			curr_nogd_it = nogoods.begin();
			curr_nogd_it++;
			for (; curr_nogd_it != nogoods.end(); curr_nogd_it++)
			{
				if((*curr_nogd_it).size() == 1 && (*(*curr_nogd_it).begin()) == 0)
				{
					solution.clear();
					return solution;
				} 

				if(IsSubset(*(curr_nogd_it), solution))
				{
					not_valid = true;
					break;
				}
			}
			if (not_valid)
			{
				solution.clear();
			}
			else
				break;
		}
		if( !not_valid)
			break;

		context_list.push_back(temp);
	}
	
	return solution;
}
*/
inline list<contextByte> getSolution(list< list<contextByte> > nogoods)
{
	list<contextByte> solution_seg;
	list<contextByte> solution;
	list<contextByte> temp_list;
	list<contextByte> context_list, context_list1;
	list<contextByte> added_contexts;
	list< list<contextByte> >::iterator curr_nogd_it;
	list<contextByte>::iterator it;
	list<contextByte>::iterator it1;
	list<contextByte>::iterator it2;
	contextByte temp;
	stack<list<contextByte> > solution_stack;
	bool not_valid = false, zero_found = false, first = true;

	curr_nogd_it = nogoods.begin();
	(*curr_nogd_it).sort();
	(*curr_nogd_it).unique();


	if((*curr_nogd_it).size() == 1 && (*(*curr_nogd_it).begin()) == 0)
		return solution;

	
	for (it = (*curr_nogd_it).begin(); curr_nogd_it != nogoods.end(); curr_nogd_it++)
	{
		(curr_nogd_it)->sort();
		(curr_nogd_it)->unique();
		if((*curr_nogd_it).size() == 1 && (*(*curr_nogd_it).begin()) == 0)
		{
			return solution;
		} 
		for(it = (*curr_nogd_it).begin(); it != (*curr_nogd_it).end(); it++)
			if( *it > 0)
				context_list.push_back(*it);
			else
				if( *it < 0)
					context_list.push_back(-(*it));
				else
					zero_found = true;
	}
	context_list.sort();
	context_list.unique();
	
	list< list< SubSet*> > nogoods_sets;
	list< list< SubSet*> >::iterator nogoods_sets_it;
	list< SubSet *> sub_set_list;
	list< SubSet *>::iterator sub_set_it;
	SubSet *sub_set;
	int count = 0;
	bool found;

	for (curr_nogd_it = nogoods.begin(); curr_nogd_it != nogoods.end(); curr_nogd_it++)
	{
		for(it = (*curr_nogd_it).begin(); it != (*curr_nogd_it).end(); it++)
		{
			count = 0;
			found = false;
			for(it1 = context_list.begin(); it1 != context_list.end(); it1++, count++)
			{
				if(found)
					break;
				if(*it1==*it || *it1==-(*it))
				{
					sub_set = new SubSet();
					sub_set->col = 1 << (count + 1);
					if( *it >= 0)
						sub_set->sign = 1;
					else
						sub_set->sign = 0;

					sub_set_list.push_back(sub_set);
					found = true;
				}
			}
		}
		nogoods_sets.push_back(sub_set_list);
		sub_set_list.clear();
	}
	int context_count = context_list.size();
	int no_of_rows  = 1 << context_count;
	bool is_subset;

	/*for (int row = 0; row < no_of_rows; row++)CHANGED IN THIS (LINUX) VERSION*/
	int row;
	for (row = 0; row < no_of_rows; row++)
	{
		for (nogoods_sets_it = nogoods_sets.begin(); nogoods_sets_it != nogoods_sets.end(); nogoods_sets_it++)
		{
			is_subset = true;
			for (sub_set_it = (*nogoods_sets_it).begin(); sub_set_it != (*nogoods_sets_it).end(); sub_set_it++)
			{
				int x = row % (*sub_set_it)->col;
				int y = (*sub_set_it)->col / 2;
				if(((*sub_set_it)->sign && x <= (y - 1)) || (!(*sub_set_it)->sign && x > (y - 1)))
					is_subset = true;
				else
				{
					is_subset = false;
					break;
				}
			}
			if(is_subset)
				break;
		}
		if(!is_subset)
			break;
	}
	if(!is_subset)
	{
		int col = 0;
		if(zero_found)
			solution.push_back(0);
		for ( it1 = context_list.begin(); it1 != context_list.end(); it1++, col++)
		{	
			solution.push_back(getSign(row,col) * (*it1));
		}
	}
    return solution;
}

/*
inline list<contextByte> getSolution(list< list<contextByte> > nogoods)
{
	list<contextByte> solution_seg;
	list<contextByte> solution;
	list<contextByte> context_list;
	list<contextByte> added_contexts;
	list< list<contextByte> >::iterator curr_nogd_it;
	list<contextByte>::iterator it;
	list<contextByte>::iterator it1;
	list<contextByte>::iterator it2;
	stack<list<contextByte> > solution_stack;
	bool not_valid = false, zero_found = false;

	int x,j;
	curr_nogd_it = nogoods.begin();
	it = (*curr_nogd_it).begin();
	if((*curr_nogd_it).size() == 1 && *it == 0)
		return solution;

	for (; it != (*curr_nogd_it).end(); it++)
	{
		if(*it)
		{
			solution_seg.push_back(-*(it));
			if (*(it) < 0)
				context_list.push_back(-*(it));
			else
				context_list.push_back(*(it));
		}
		else
			zero_found = true;
	}
	
	int context_count = context_list.size();

	for (it = solution_seg.begin(); it != solution_seg.end(); it++)
	{
		for (int i = 0; i < pow(2,context_count-1); i++)
		{
			not_valid = false;
			solution.push_back(*(it));
			j = 0;
			for ( it1 = context_list.begin(); it1 != context_list.end(); it1++, j++)
			{	
				if(*(it) != *(it1) && *(it) != -*(it1))
				{
					int y = pow( 2 , (j + 1)); 
					x = i % y; 
					y = y / 2;
					if( x <= (y - 1))
						solution.push_back(*it1);
					else
						solution.push_back(-*(it1));
				}
				else
					j--;
			}
			if(zero_found)
				solution.push_back(0);
			curr_nogd_it = nogoods.begin();
			curr_nogd_it++;
			for (; curr_nogd_it != nogoods.end(); curr_nogd_it++)
			{
				if((*curr_nogd_it).size() == 1 && (*(*curr_nogd_it).begin()) == 0)
				{
					solution.clear();
					return solution;
				}

				if(IsSubset(*(curr_nogd_it), solution))
				{
					not_valid = true;
					break;
				}
				else
				{
					added_contexts = UnknowContexts(*(curr_nogd_it), solution);
					if(!added_contexts.empty())
					{
						for ( it2 = added_contexts.begin(); it2 != added_contexts.end(); it2++)
						{
							if (*(it2) < 0)
								context_list.push_back(-*(it2));
							else
								context_list.push_back(*(it2));
						}			
						context_count = context_list.size();
						not_valid = true;
						break;
					}
				}
			}
			if (not_valid)
			{
				solution.clear();
			}
			else
				break;
		}
		if( !not_valid)
			break;
	}
//	if(!solution.size())
//		return NULL;
	
	return solution;
}
*/

inline bool find(list<contextByte> one_list, list< list<contextByte> > lists)
{
	for (list< list<contextByte> >::iterator it = lists.begin(); it != lists.end(); it++)
	{
		if((*it)==one_list)
			return true;
	}
	return false;
}

inline list<list<contextByte> > getSolutionNogoods(list< list<contextByte> > solutions)
{
	list<list<contextByte> > ret_nogoods;

	for (list< list<contextByte> >::iterator sol_it = solutions.begin(); sol_it != solutions.end(); sol_it++)
	{
		list<contextByte> nogood;
		(*sol_it).sort();
		for(list<contextByte>::iterator cont_it=(*sol_it).begin(); cont_it!=(*sol_it).end(); cont_it++)
		{
            list<contextByte> current_nogood=nogood;
			current_nogood.push_back(-(*cont_it));
			//if not already there then
			if(!find(current_nogood,ret_nogoods))
				ret_nogoods.push_back(current_nogood);
			nogood.push_back(*cont_it);
		}
	}

	return ret_nogoods;
}

inline list<list<contextByte> > getNogoodsAgainstSolution(list< list<contextByte> > nogoods)
{
	list<list<contextByte> > Solutions;
	list<list<contextByte> >::iterator ngit;
	//traverse all nogoods
	for(ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
	{
		//pick one nogood
		//list<list<contextByte> > TempSolutions;
		list<contextByte> temp;
		for(list<contextByte>::iterator it=(*ngit).begin();it!=(*ngit).end();it++)
		{
			temp.push_back(-(*it));
			//if temp is a valid solution put it in solutions
			list<list<contextByte> >::iterator ngit2;
			for(ngit2=nogoods.begin();ngit2!=nogoods.end();ngit2++)
			{
				if(IsSubset(temp,*ngit2))
					break;
			}
			if(ngit2==nogoods.end())
				Solutions.push_back(temp);
			temp.pop_back();
			temp.push_back((*it));
		}
	}
	Solutions.sort();
	Solutions.unique();
	return Solutions;
}

inline list<list<contextByte> > getSolNogoods(list< list<contextByte> > nogoods)
{
	list<list<contextByte> > Result;
	list<contextByte> solution_seg;
	list<contextByte> solution;
	list<contextByte> temp_list;
	list<contextByte> context_list, context_list1;
	list<contextByte> added_contexts;
	list< list<contextByte> >::iterator curr_nogd_it;
	list<contextByte>::iterator it;
	list<contextByte>::iterator it1;
	list<contextByte>::iterator it2;
	contextByte temp;
	stack<list<contextByte> > solution_stack;
	bool not_valid = false, zero_found = false, first = true;

	/*curr_nogd_it = nogoods.begin();
	it = (*curr_nogd_it).begin();
	if((*curr_nogd_it).size() == 1 && *it == 0)
		return Result;*/

	curr_nogd_it = nogoods.begin();
	(*curr_nogd_it).sort();
	(*curr_nogd_it).unique();
	it = (*curr_nogd_it).begin();

	if((*curr_nogd_it).size() == 1 && *it == 0)
		return Result;

	
	for (; it != (*curr_nogd_it).end(); it++)
	{
		if(*it)
		{
			solution_seg.push_back(-*(it));
			context_list1.push_back(*it);
		}
		else
			zero_found = true;
	}
	
	curr_nogd_it++;

	for (; curr_nogd_it != nogoods.end(); curr_nogd_it++)
	{
		(curr_nogd_it)->sort();
		(curr_nogd_it)->unique();
		temp_list = UnknowContexts(*(curr_nogd_it), context_list1);
		for(it = temp_list.begin(); it != temp_list.end(); it++)
			if( *it > 0)
				context_list.push_back(*it);
			else
				if( *it < 0)
					context_list.push_back(-(*it));
				else
					zero_found = true;
	}
	context_list.sort();
	context_list.unique();
	

	for (it = solution_seg.begin(); it != solution_seg.end(); it++)
	{
		temp = *(context_list1.begin());
		context_list1.pop_front();
		int context_count = context_list.size();
		int no_of_rows  = 1 << context_count;
	
		for (int row = 0; row < no_of_rows; row++)
		{
			not_valid = false;
			solution.push_back(*(it));
			int col = 0;
			for ( it1 = context_list.begin(); it1 != context_list.end(); it1++, col++)
			{	
				solution.push_back(getSign(row,col) * (*it1));
			}
			if(zero_found)
				solution.push_back(0);
			for ( it1 = context_list1.begin(); it1 != context_list1.end(); it1++)
			{	
				solution.push_back(*it1);
			}
			
			curr_nogd_it = nogoods.begin();
			curr_nogd_it++;
			for (; curr_nogd_it != nogoods.end(); curr_nogd_it++)
			{
				if((*curr_nogd_it).size() == 1 && (*(*curr_nogd_it).begin()) == 0)
				{
					solution.clear();
					Result.push_back(solution);
				} 

				if(IsSubset(*(curr_nogd_it), solution))
				{
					not_valid = true;
					break;
				}
			}
			if (not_valid)
			{
				solution.clear();
			}
			else
			{
				Result.push_back(solution);
				solution.clear();
			}
				
		}
		
		context_list.push_back(temp);
	}
	
	return Result;
}

inline string getHeadOfComplexAttr(string& attr_symbol)
// remove the head of the complex attribute string and return it
// (head is returned and attr_symbol goes back headless)
{
	short space_index;
	string temp_orig = attr_symbol;
	space_index = temp_orig.find(" ");
	attr_symbol.erase(0, space_index+1);
	return temp_orig.substr(0, space_index);
}

inline list<contextByte> getSolutionConsistent(list< list<contextByte> > nogoods, list<contextByte> ext_solution)
{
	list<contextByte> solution_seg;
	list<contextByte> solution;
	list<contextByte> temp_list;
	list<contextByte> context_list, context_list1,context_list_sol;
	list<contextByte> added_contexts;
	list< list<contextByte> >::iterator curr_nogd_it;
	list<contextByte>::iterator it;
	list<contextByte>::iterator it1;
	list<contextByte>::iterator it2;
	contextByte temp;
	stack<list<contextByte> > solution_stack;
	bool not_valid = false, zero_found = false;

	curr_nogd_it = nogoods.begin();
	
	(*curr_nogd_it).sort();
	(*curr_nogd_it).unique();
	it = (*curr_nogd_it).begin();
	
	if((*curr_nogd_it).size() == 1 && *it == 0)
		return solution;

	
	for (; it != (*curr_nogd_it).end(); it++)
	{
		if(*it)
		{
			if(!opposingContextPresent(ext_solution, -*(it)))
                solution_seg.push_back(-*(it));
			if(!opposingContextPresent(ext_solution, *(it)))
				context_list1.push_back(*it);
		}
		else
			zero_found = true;
	}
	
	curr_nogd_it++;

	for (; curr_nogd_it != nogoods.end(); curr_nogd_it++)
	{
		(curr_nogd_it)->sort();
		(curr_nogd_it)->unique();
		temp_list = UnknowContexts(*(curr_nogd_it), context_list1);
		for(it = temp_list.begin(); it != temp_list.end(); it++)
			if( *it > 0)
				context_list.push_back(*it);
			else
				if( *it < 0)
					context_list.push_back(-(*it));
				else
					zero_found = true;
	}

	added_contexts = UnknowContexts(ext_solution,context_list);
	for (it = added_contexts.begin(); it != added_contexts.end(); it++)
	{
		if(*it)
		{
		//	if (*(it) < 0)
		//		context_list.push_back(-*(it));
		//	else
				context_list_sol.push_back(*(it));
		}
		else
			zero_found = true;
	}
	context_list.sort();
	context_list.unique();
	//solution_seg.sort();
	//solution_seg.unique();
	//context_list1.sort();

	//context_list1.unique();
	
	int context_count = context_list.size();

	for (it = solution_seg.begin(); it != solution_seg.end(); it++)
	{
		temp = *(context_list1.begin());
		context_list1.pop_front();
		int context_count = context_list.size();
		int no_of_rows  = 1 << context_count;
	
		for (int row = 0; row < no_of_rows; row++)
		{
			not_valid = false;
			solution.push_back(*(it));
			int col = 0;
			
			for ( it1 = context_list.begin(); it1 != context_list.end(); it1++, col++)
			{	
				contextByte temp = getSign(row,col) * (*it1);
				if(!opposingContextPresent(ext_solution, temp))
					solution.push_back(temp);
				else
				{
					not_valid = true;
					solution.clear();
					break;	
				}
			}
			if (not_valid)
			{
				continue;	
			}
			
			if(zero_found)
				solution.push_back(0);
			for ( it1 = context_list1.begin(); it1 != context_list1.end(); it1++)
			{	
				solution.push_back(*it1);
			}
			for ( it1 = context_list_sol.begin(); it1 != context_list_sol.end(); it1++)
			{	
				solution.push_back(*it1);
			}			
			//if(opposingContextsPresent(ext_solution, solution))
			//{
			//	not_valid = true;
			//	solution.clear();
			//	continue;	
			//}
			curr_nogd_it = nogoods.begin();
			curr_nogd_it++;
			for (; curr_nogd_it != nogoods.end(); curr_nogd_it++)
			{
				if((*curr_nogd_it).size() == 1 && (*(*curr_nogd_it).begin()) == 0)
				{
					solution.clear();
					return solution;
				} 

				if(IsSubset(*(curr_nogd_it), solution))
				{
					not_valid = true;
					break;
				}
			}
			if (not_valid)
			{
				solution.clear();
			}
			else
				break;
		}
		if( !not_valid)
			break;

		context_list.push_back(temp);
	}
	solution.sort();
	solution.unique();
	return solution;
}

/*inline LogContextByteList(list<contextByte> context)CHANGED IN THIS (LINUX) VERSION*/
inline void LogContextByteList(list<contextByte> context)
{
	list<contextByte>::iterator it=context.begin();
	wstring contstring=L"";
	contstring+=Convert_str2wstr(int2string(*it));
	it++;

	while(it!=context.end())
	{
		if(*it)
		{
			contstring+=L"\t";
			contstring+=Convert_str2wstr(int2string(*it));
		}
		it++;
	}

	CLogManager::AddMessage(contstring);
}

/*inline LogContextByteLists(list<list<contextByte> > contexts)CHANGED IN THIS (LINUX) VERSION*/
inline void LogContextByteLists(list<list<contextByte> > contexts)
{
	list<list<contextByte> >::iterator it1=contexts.begin();
	list<contextByte>::iterator it2;

	wstring contstring=L"List:\r\n";
	while(it1!=contexts.end())
	{
		it2=(*it1).begin();
		contstring+=Convert_str2wstr(int2string(*it2));
		it2++;
		while(it2!=(*it1).end())
		{
			if(*it2)
			{
				contstring+=L"\t";
				contstring+=Convert_str2wstr(int2string(*it2));
			}
			it2++;
		}
		contstring+=L"\r\n";
		CLogManager::AddMessage(contstring);
		contstring=L"";
	it1++;
	}
}

struct binaryContext
{
	int pos;
	int neg;
	binaryContext()
	{
		pos=neg=0;
	}
};

inline list<contextByte> makesolution(list<list<contextByte> > nogoods)
{
	int map[32]={0};
	int x=1;
	for(int i=1;i<32;i++)
	{
		map[i]=x;
		x=x<<1;
	}

	list<contextByte> retsol;
	list<binaryContext> bnglist;
	int max=0;
	int cont_map[200]={0};
	int rev_cont_map[100]={0};
	x=1;
	int num;
	bool has_num;

	for(list<list<contextByte> >::iterator ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
	{
		binaryContext b;
		(*ngit).sort();
		has_num=false;
		for(list<contextByte>::iterator it=(*ngit).begin();it!=(*ngit).end();it++)
		{
			if((*it)<0)
			{
				has_num=true;
				if(cont_map[-(*it)])
                    b.pos=(b.pos|map[ cont_map[-(*it)] ]);
				else
				{
					cont_map[-(*it)]=x;
					rev_cont_map[x]=-(*it);
					b.pos=(b.pos|map[x]);
					x++;
				}
			}
			else if((*it)>0)
			{
				has_num=true;
				//b.neg=(b.neg|map[*it]);
				if(cont_map[*it])
					b.neg=(b.neg|map[ cont_map[*it] ]);
				else
				{
					cont_map[*it]=x;
					rev_cont_map[x]=(*it);
					b.neg=(b.neg|map[x]);
					x++;
				}
			}
		}		

		if(!has_num)
			return retsol;

		bnglist.push_back(b);
		//if((*ngit).size()>max)
		//		max=(*ngit).size();
		if(x>=25)
		//if(x>=32)
		{
			retsol.push_back(0);
			return retsol;
		}
	}

	max=x-1;
	/*int max_num=pow(2,max);CHANGED IN THIS (LINUX ONLY) VERSION*/
	int max_num=pow(2,(double)max);
	if(max>15)
	{
		/*max_num=pow(2,15);CHANGED IN THIS (LINUX ONLY) VERSION*/
		max_num=pow(2,(double)15);
		
	}

	binaryContext solution;
	for(int i=0;i<=max_num;i++)
	{
		solution.pos=i;
		solution.neg=~i;
		/* CHANGED IN THIS (LINUX) VERSION
		for(list<binaryContext>::iterator bit=bnglist.begin();bit!=bnglist.end();bit++)
		CHANGED IN THIS (LINUX) VERSION */
		list<binaryContext>::iterator bit;
		for(bit=bnglist.begin();bit!=bnglist.end();bit++)
		{
			if( ((*bit).pos&solution.pos) || ((*bit).neg&solution.neg) );
			else
				break;
		}
		if(bit==bnglist.end())
		{
			for(int i=1;i<=max;i++)
			{
				if( (solution.pos&map[i]) )
					retsol.push_back(rev_cont_map[i]);
				if( (solution.neg&map[i]) )
					retsol.push_back(-rev_cont_map[i]);
			}
			return retsol;
		}
	}	

	return retsol;
}
inline list<list<contextByte> > makeNogoodsolution(list<list<contextByte> > nogoods)
{
	list<list<contextByte> > Result;

	int map[32]={0};
	int x=1;
	for(int i=1;i<32;i++)
	{
		map[i]=x;
		x=x<<1;
	}

	list<contextByte> retsol;
	list<binaryContext> bnglist;
	int max=0;
	int cont_map[200]={0};
	int rev_cont_map[100]={0};
	x=1;
	int num;

	for(list<list<contextByte> >::iterator ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
	{
		binaryContext b;
		(*ngit).sort();
		for(list<contextByte>::iterator it=(*ngit).begin();it!=(*ngit).end();it++)
		{
			if((*it)<0)
			{
				if(cont_map[-(*it)])
                    b.pos=(b.pos|map[ cont_map[-(*it)] ]);
				else
				{
					cont_map[-(*it)]=x;
					rev_cont_map[x]=-(*it);
					b.pos=(b.pos|map[x]);
					x++;
				}
			}
			else if((*it)>0)
			{
				//b.neg=(b.neg|map[*it]);
				if(cont_map[*it])
					b.neg=(b.neg|map[ cont_map[*it] ]);
				else
				{
					cont_map[*it]=x;
					rev_cont_map[x]=(*it);
					b.neg=(b.neg|map[x]);
					x++;
				}
			}
		}		
		bnglist.push_back(b);
		//if((*ngit).size()>max)
		//		max=(*ngit).size();
	}

	max=x-1;
	/*int max_num=pow(2,max);CHANGED IN THIS (LINUX ONLY) VERSION*/
	int max_num=pow(2,(double)max);

	binaryContext solution;
	for(int i=0;i<=max_num;i++)
	{
		solution.pos=i;
		solution.neg=~i;
		/* CHANGED IN THIS (LINUX) VERSION
		for(list<binaryContext>::iterator bit=bnglist.begin();bit!=bnglist.end();bit++)
		*/
		list<binaryContext>::iterator bit;
		for(bit=bnglist.begin();bit!=bnglist.end();bit++)
		{
			if( ((*bit).pos&solution.pos) || ((*bit).neg&solution.neg) );
			else
				break;
		}
		if(bit==bnglist.end())
		{
			for(int i=1;i<=max;i++)
			{
				if( (solution.pos&map[i]) )
					retsol.push_back(rev_cont_map[i]);
				if( (solution.neg&map[i]) )
					retsol.push_back(-rev_cont_map[i]);
			}
			Result.push_back(retsol);
			retsol.clear();
		}
	}	

	return Result;
}

inline list<contextByte> makeconsistentsolution(list<list<contextByte> > nogoods, list<contextByte> ext_solution)
{
	int map[32]={0};
	int x=1;
	for(int i=1;i<32;i++)
	{
		map[i]=x;
		x=x<<1;
	}

	list<contextByte> retsol;
	list<binaryContext> bnglist;
	int max=0;
	int cont_map[100]={0};
	int rev_cont_map[50]={0};
	x=1;
	int num;

	//converting nogoods to binary goods
	for(list<list<contextByte> >::iterator ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
	{
		binaryContext b;
		(*ngit).sort();
		for(list<contextByte>::iterator it=(*ngit).begin();it!=(*ngit).end();it++)
		{
			if((*it)<0)
			{
				if(cont_map[-(*it)])
                    b.pos=(b.pos|map[ cont_map[-(*it)] ]);
				else
				{
					cont_map[-(*it)]=x;
					rev_cont_map[x]=-(*it);
					b.pos=(b.pos|map[x]);
					x++;
				}
			}
			else if((*it)>0)
			{
				if(cont_map[*it])
					b.neg=(b.neg|map[ cont_map[*it] ]);
				else
				{
					cont_map[*it]=x;
					rev_cont_map[x]=(*it);
					b.neg=(b.neg|map[x]);
					x++;
				}
			}
		}		
		bnglist.push_back(b);
	}

    max=x-1;
	/*int max_num=pow(2,max);CHANGED IN THIS (LINUX ONLY) VERSION*/
	int max_num=pow(2,(double)max);	

	//converting solition to bits solution
	binaryContext ex_solution;
	list<contextByte> dont_care_ext_sol;;
	for(list<contextByte>::iterator it=ext_solution.begin();it!=ext_solution.end();it++)
	{
		if((*it)>0)
		{
			if(cont_map[*it])
				ex_solution.pos=(ex_solution.pos|map[ cont_map[*it] ]);
			else
				dont_care_ext_sol.push_back(*it);
		}
		else if((*it)<0)
		{
			if(cont_map[-(*it)])
				ex_solution.neg=(ex_solution.neg|map[ cont_map[-(*it)] ]);
			else
				dont_care_ext_sol.push_back(*it);
		}
	}

	binaryContext solution;
	for(int i=0;i<=max_num;i++)
	{
		solution.pos=i;
		solution.neg=~i;
		if( !(ex_solution.neg&solution.pos) && !(ex_solution.pos&solution.neg) )
		{
			/* CHANGED IN THIS (LINUX) VERSION
			for(list<binaryContext>::iterator bit=bnglist.begin();bit!=bnglist.end();bit++)
			*/
			list<binaryContext>::iterator bit;
			for (bit=bnglist.begin();bit!=bnglist.end();bit++)
			{
				if( ((*bit).pos&solution.pos) || ((*bit).neg&solution.neg) );
				else
					break;
			}
		
			if(bit==bnglist.end())
			{
				for(int i=1;i<=max;i++)
				{
					if( (solution.pos&map[i]) )
						retsol.push_back(rev_cont_map[i]);
					if( (solution.neg&map[i]) )
						retsol.push_back(-rev_cont_map[i]);
				}
				retsol.merge(dont_care_ext_sol);
				return retsol;
			}
		}
	}	

	return retsol;
}

struct context
{
	int pos[50];
	int neg[50];
	context()
	{
		for(int i=0;i<50;i++)
		{
			pos[i]=neg[i]=0;
		}
	}
};

inline list<contextByte> makegood(list<contextByte> nogood)
{
	for(list<contextByte>::iterator it=nogood.begin();it!=nogood.end();it++)
	{
		(*it)=-(*it);
	}
	return nogood;
}

inline bool isIntersectionEmpty(context c, list<contextByte> nogood)
{
	for(list<contextByte>::iterator it=nogood.begin();it!=nogood.end();it++)
	{
		if((*it)>0)
		{
			if(c.pos[*it]==1)
				return false;
		}
		else if((*it)<0)
		{
			if(c.neg[-(*it)]==1)
				return false;
		}
	}
	return true;
}


inline list<contextByte> select_solution(list<list<contextByte> > nogoods, list<list<contextByte> > ext_solutions)
{
	int map[32]={0};
	int x=1;
	for(int i=1;i<32;i++)
	{
		map[i]=x;
		x=x<<1;
	}
	
	list<contextByte> retsol;

	//converting solition to bits solution
	if(ext_solutions.size())
	{
		//gathering all contexts in solutions
		hash_map<contextByte,contextByte> contextsmap;
		list<contextByte> all_contexts;
		for(list<list<contextByte> >::iterator solit=ext_solutions.begin();solit!=ext_solutions.end();solit++)
		{
			for(list<contextByte>::iterator it=(*solit).begin();it!=(*solit).end();it++)
			{
				if( contextsmap.find( abs(*it) ) == contextsmap.end() )
				{
					contextsmap[abs(*it)]=abs(*it);
					all_contexts.push_back(abs(*it));
				}
			}		
		}

		for(list<list<contextByte> >::iterator sit=ext_solutions.begin();sit!=ext_solutions.end();sit++)
		{
			list<binaryContext> bnglist;
			int max=0;
			int cont_map[200]={0};
			int rev_cont_map[100]={0};
			x=1;
			int num;

			//converting a solution to bitwise solution
			binaryContext ex_solution;
			(*sit).sort();
			for(list<contextByte>::iterator it=(*sit).begin();it!=(*sit).end();it++)
			{
				if((*it)<0)
				{
					if(cont_map[-(*it)])
						ex_solution.neg=(ex_solution.neg|map[ cont_map[-(*it)] ]);
					else
					{
						cont_map[-(*it)]=x;
						rev_cont_map[x]=-(*it);
						ex_solution.neg=(ex_solution.neg|map[x]);
						x++;
					}
				}
				else if((*it)>0)
				{
					if(cont_map[*it])
						ex_solution.pos=(ex_solution.pos|map[ cont_map[*it] ]);
					else
					{
						cont_map[*it]=x;
						rev_cont_map[x]=(*it);
						ex_solution.pos=(ex_solution.pos|map[x]);
						x++;
					}
				}
			}		

			int ex_sol_size=x-1;
			
			//converting nogoods to binary goods
			for(list<list<contextByte> >::iterator ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
			{
				binaryContext b;
				(*ngit).sort();
				for(list<contextByte>::iterator it=(*ngit).begin();it!=(*ngit).end();it++)
				{
					if((*it)<0)
					{
						if(cont_map[-(*it)])
							b.pos=(b.pos|map[ cont_map[-(*it)] ]);
						else
						{
							cont_map[-(*it)]=x;
							rev_cont_map[x]=-(*it);
							b.pos=(b.pos|map[x]);
							x++;
						}
					}
					else if((*it)>0)
					{
						if(cont_map[*it])
							b.neg=(b.neg|map[ cont_map[*it] ]);
						else
						{
							cont_map[*it]=x;
							rev_cont_map[x]=(*it);
							b.neg=(b.neg|map[x]);
							x++;
						}
					}
				}		
				bnglist.push_back(b);
			}

			//adding remaining contexts
			for(list<contextByte>::iterator it=all_contexts.begin();it!=all_contexts.end();it++)
			{
				if(cont_map[*it]);
				else
				{
					cont_map[*it]=x;
					rev_cont_map[x]=(*it);
					x++;
				}
			}	

			max=x-1;
			/*int max_num=pow(2, max - ex_sol_size );CHANGED IN THIS (LINUX ONLY) VERSION*/
	        	int max_num=pow(2, (double)(max - ex_sol_size) );

			binaryContext solution;
			for(int i=0;i<=max_num;i++)
			{
				solution=ex_solution;
				//i=i<<ex_sol_size;
				solution.pos|=(i<<ex_sol_size);
				solution.neg|=((~i)<<ex_sol_size);

				/* CHANGED IN THIS (LINUX) VERSION
				for(list<binaryContext>::iterator bit=bnglist.begin();bit!=bnglist.end();bit++)
				*/
				list<binaryContext>::iterator bit;
				for(bit=bnglist.begin();bit!=bnglist.end();bit++)
				{
					if( ((*bit).pos&solution.pos) || ((*bit).neg&solution.neg) );
					else
						break;
				}
			
				if(bit==bnglist.end())
				{
					for(int j=1;j<=max;j++)
					{
						if( (solution.pos&map[j]) )
							retsol.push_back(rev_cont_map[j]);
						if( (solution.neg&map[j]) )
							retsol.push_back(-rev_cont_map[j]);
					}
					return retsol;
				}
			}	
		}
	}
	else
	{
		retsol=makesolution(nogoods);
	}

	return retsol;
}

inline list<contextByte> select_solution2(list<list<contextByte> > nogoods, list<list<contextByte> > ext_solutions)
{
	int map[32]={0};
	int x=1;
	for(int i=1;i<32;i++)
	{
		map[i]=x;
		x=x<<1;
	}
	
	list<contextByte> retsol;

	
	if(ext_solutions.size())
	{

		//converting solition to bits solution
		for(list<list<contextByte> >::iterator sit=ext_solutions.begin();sit!=ext_solutions.end();sit++)
		{
			int max=0;
			int sol_cont_map[300]={0};
			int sol_rev_cont_map[50]={0};
			x=1;
			int num;

			list<binaryContext> one_sol_set;

			//converting a solution to bitwise solution
			binaryContext ex_solution;
			(*sit).sort();
			for(list<contextByte>::iterator it=(*sit).begin();it!=(*sit).end();it++)
			{
				if((*it)<0)
				{
					if(sol_cont_map[-(*it)])
						ex_solution.neg=(ex_solution.neg|map[ sol_cont_map[-(*it)] ]);
					else
					{
						sol_cont_map[-(*it)]=x;
						sol_rev_cont_map[x]=-(*it);
						ex_solution.neg=(ex_solution.neg|map[x]);
						x++;
					}
				}
				else if((*it)>0)
				{
					if(sol_cont_map[*it])
						ex_solution.pos=(ex_solution.pos|map[ sol_cont_map[*it] ]);
					else
					{
						sol_cont_map[*it]=x;
						sol_rev_cont_map[x]=(*it);
						ex_solution.pos=(ex_solution.pos|map[x]);
						x++;
					}
				}
			}

			if(x>31)
				continue;

			one_sol_set.push_back(ex_solution);
			
			bool same_set=true;
			while(same_set)
			{
				sit++;ex_solution.pos=0;ex_solution.neg=0;
				if(sit!=ext_solutions.end())
				{
					for(list<contextByte>::iterator it=(*sit).begin();it!=(*sit).end();it++)
					{
						if((*it)<0)
						{
							if(sol_cont_map[-(*it)])
								ex_solution.neg=(ex_solution.neg|map[ sol_cont_map[-(*it)] ]);
							else
							{
								same_set=false;
								sit--;
								break;
							}
						}
						else if((*it)>0)
						{
							if(sol_cont_map[*it])
								ex_solution.pos=(ex_solution.pos|map[ sol_cont_map[*it] ]);
							else
							{
								same_set=false;
								sit--;
								break;
							}
						}
					}
					if(same_set)
						one_sol_set.push_back(ex_solution);
				}
				else 
				{
					sit--;
					same_set=false;
				}
			}

			int ex_sol_size=x-1;


 

			for(list<binaryContext>::iterator sol_set_it=one_sol_set.begin();sol_set_it!=one_sol_set.end();sol_set_it++)
			{
				binaryContext solution=(*sol_set_it);

				//check the validity of the solution
				bool invalid=false;
				for(list<list<contextByte> >::iterator ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
				{
					binaryContext b;
					/* CHANGED IN THIS (LINUX) VERSION
					for(list<contextByte>::iterator it=(*ngit).begin();it!=(*ngit).end();it++)
					*/
					list<contextByte>::iterator it;
					for(it=(*ngit).begin();it!=(*ngit).end();it++)
					{
						if((*it)<0)
						{
							if(sol_cont_map[-(*it)])
							{
								b.neg=(b.neg|map[ sol_cont_map[-(*it)] ]);
							}
							else break;
						}
						else if((*it)>0)
						{
							if(sol_cont_map[*it])
							{
								b.pos=(b.pos|map[ sol_cont_map[*it] ]);
							}
							else break;
						}
					}
					if(it==(*ngit).end())
					{
						if( ((solution.pos&b.pos)==b.pos) && ((solution.neg&b.neg)==b.neg) )
						{
							invalid=true;
							break;
						}
					}
				}

				if(!invalid)
				{

					//converting nogoods to binary goods			
					list<binaryContext> bnglist;
					int ng_cont_map[200]={0};
					int ng_rev_cont_map[100]={0};

					x=1;
					bool OK;
					for(list<list<contextByte> >::iterator ngit=nogoods.begin();ngit!=nogoods.end();ngit++)
					{
						binaryContext b;
						(*ngit).sort();
						OK=false;
						for(list<contextByte>::iterator it=(*ngit).begin();it!=(*ngit).end();it++)
						{
							if((*it)<0)
							{
								if(!sol_cont_map[-(*it)])
								{
									if(ng_cont_map[-(*it)])
										b.pos=(b.pos|map[ ng_cont_map[-(*it)] ]);
									else
									{
										ng_cont_map[-(*it)]=x;
										ng_rev_cont_map[x]=-(*it);
										b.pos=(b.pos|map[x]);
										x++;
									}
								}
								else
								{
									if(solution.pos&map[ sol_cont_map[-(*it)] ])
										OK=true;
								}
							}
							else if((*it)>0)
							{
								if(!sol_cont_map[*it])
								{
									if(ng_cont_map[*it])
										b.neg=(b.neg|map[ ng_cont_map[*it] ]);
									else
									{
										ng_cont_map[*it]=x;
										ng_rev_cont_map[x]=(*it);
										b.neg=(b.neg|map[x]);
										x++;
									}
								}
								else
								{
									if(solution.neg&map[ sol_cont_map[(*it)] ])
										OK=true;
								}
							}
						}
						if(!OK)
							if(b.pos || b.neg)
								bnglist.push_back(b);
					}

					max=x-1;
					/*int max_num=pow(2,max);CHANGED IN THIS (LINUX ONLY) VERSION*/
					int max_num=pow(2,(double)max);
					if(max>=31)
					{
						max_num=-1;
					}
					else if(max>13)
					{
						/*max_num=pow(2,13);CHANGED IN THIS (LINUX ONLY) VERSION*/
						max_num=pow(2,(double)13);
					}
					

					//make full-length good solution
					for(int i=0;i<=max_num;i++)
					{
						solution.pos=i;
						solution.neg=~i;

						/* CHANGED IN THIS (LINUX) VERSION
						for(list<binaryContext>::iterator bit=bnglist.begin();bit!=bnglist.end();bit++)
						*/
						list<binaryContext>::iterator bit;
						for(bit=bnglist.begin();bit!=bnglist.end();bit++)
						{
							if( ((*bit).pos&solution.pos) || ((*bit).neg&solution.neg) );
							else
								break;
						}
					
						if(bit==bnglist.end())
						{
							for(int j=1;j<=max;j++)
							{
								if( (solution.pos&map[j]) )
									retsol.push_back(ng_rev_cont_map[j]);
								if( (solution.neg&map[j]) )
									retsol.push_back(-ng_rev_cont_map[j]);
							}

							for(int j=1;j<=ex_sol_size;j++)
							{
								if( ( (*sol_set_it).pos&map[j]) )
									retsol.push_back(sol_rev_cont_map[j]);
								if( ( (*sol_set_it).neg&map[j]) )
									retsol.push_back(-sol_rev_cont_map[j]);
							}
							
							return retsol;
						}
					}

					//break;

				}
			}
		}
	}
	else
	{
		retsol=makesolution(nogoods);
	}

	return retsol;
}

inline list<contextByte> abs_sort(list<contextByte> context_list)
{
	list<contextByte> neg_list,final_list;
	context_list.sort();
	list<contextByte>::iterator it, neg_it;
	it = context_list.begin();
	if(*it == 0)
	{
		context_list.pop_front();
		return context_list;
	}
	if(*it > 0)
		return context_list;

	while(it!=context_list.end())
	{
		if(*it < 0)
		{
			neg_list.push_front(*it);
			context_list.pop_front();
			it = context_list.begin();
		}
		else
			break;
	}
	if(it == context_list.end())
		return neg_list;

	it = context_list.begin();
	neg_it = neg_list.begin();
	if(*it == 0)
	{
		context_list.pop_front();
		it = context_list.begin();
	}

	while(neg_it!=neg_list.end() && it!=context_list.end())
	{
		if(-*neg_it < *it)
		{
			final_list.push_back(*neg_it);
			neg_it++;
		}
		else
		{
			final_list.push_back(*it);
			it++;
		}
	}
	if(it!=context_list.end())
	{
		while(it!=context_list.end())
		{
			final_list.push_back(*it);
			it++;
		}
	}
	if(neg_it!=neg_list.end())
	{
		while(neg_it!=neg_list.end())
		{
			final_list.push_back(*neg_it);
			neg_it++;
		}
	}
	return final_list;
}
#endif /*ADDED IN THIS (LINUX) VERSION*/




