// GLOBAL.h: interface for the GLOBAL class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLOBAL_H__3253A3DE_7F9D_4C1C_B80D_BDD6236CE374__INCLUDED_)
#define AFX_GLOBAL_H__3253A3DE_7F9D_4C1C_B80D_BDD6236CE374__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"

#include <cstring> // needed for stricmp()
#include <string>
#include <vector>
#include <math.h>

using std::string;
using std::wstring;
using std::vector;

/*ADDED IN THIS (LINUX ONLY) VERSION FOR ITOA*/
/**
	
 * C++ version char* style "itoa":
	
 http://www.jb.man.ac.uk/~slowe/cpp/index.html */
inline char* itoa( int value, char* result, int base ) {
	
	// check that the base if valid
	
	if (base < 2 || base > 16) { *result = 0; return result; }
	

	
	char* out = result;
	
	int quotient = value;
	

	
	do {
	
		*out = "0123456789abcdef"[ std::abs( quotient % base ) ];
	
		++out;
	
		quotient /= base;
	
	} while ( quotient );
	

	
	// Only apply negative sign for base 10
	
	if ( value < 0 && base == 10) *out++ = '-';
	

	
	std::reverse( result, out );
	
	*out = 0;
	
	return result;
	
}
/*ADDED IN THIS (LINUX ONLY) VERSION FOR ITOA END*/

inline int stricmp (const std::string &s1,const std::string &s2)
{
  return stricmp (s1.c_str(), s2.c_str()); // C's stricmp
}

inline int stricmp2 (const std::wstring &s1,const std::wstring &s2)
{
  //return stricmp (s1.c_str(), s2.c_str()); // C's stricmp

}

inline void c2u(const char * cstr,wstring & ustr)
{	
	unsigned int len=strlen(cstr);

	for(unsigned short k=0;k<len;k++)
		ustr+=cstr[k];
}

inline bool isDelim(short ch)
{
	if(ch==32 || ch==9  || ch==10 || ch==13)
	   return true;

	return false;
}


inline string Convert_wstr2str(const wstring & wstr)
{
	string result;

	unsigned int  len=wstr.size();

	for(unsigned short p=0;p<len;p++)
		result+=(char)wstr[p];

	return result;
}

inline string int2string(int num)
{
	char lineStr[20]="";
	itoa(num,lineStr,10);
	//printf(lineStr, "%i", num);
	string outStr = lineStr;
	return outStr;
}

inline int string2int(string str)
{
	int num=0;

	string numstring;

	for(int i=0;i<str.length();i++)
		if(str[i]>47&&str[i]<58)
			numstring+=str[i];

	/*for(i=0;i<numstring.length();i++)CHANGED IN THIS (LINUX) VERSION*/
	for(int i=0;i<numstring.length();i++)
		/*num+=pow(10,numstring.length()-i-1)*(numstring[i]-48);/*CHANGED IN THIS (LINUX ONLY) VERSION*/
		num+=pow(10,(double)numstring.length()-i-1)*(numstring[i]-48);
	return num;	
}

inline wstring Convert_str2wstr(const string & str)
{
	wstring result;

	unsigned int  len=str.size();

	for(unsigned short p=0;p<len;p++)
		result+=(unsigned char)str[p];

	return result;
}

inline wstring ConvertToLower(wstring & wstr)
{
	wstring result;

	unsigned int len=wstr.size();

	for(unsigned short p=0;p<len;p++)
		result+=tolower(wstr[p]);

	return result;
}

inline string ConvertToLower(string & str)
{
	string result;

	unsigned int len=str.size();

	for(unsigned short p=0;p<len;p++)
		result+=tolower(str[p]);

	return result;
}


//## Returns TRUE if first set is a sub set of second set

inline wstring GetWSTR(int id)
{
	wstring str;
	char buffer[10];
	itoa(id,buffer,10);

	string str1=buffer;

	return Convert_str2wstr(str1);

}

inline bool IsSubSet(vector<short> *list1,vector<short> *list2)
{
	if(!list1 || !list2)
		return false;
	
	unsigned int  len1=list1->size();
	unsigned int  len2=list2->size();
		
	bool found=false;
	short val=0;

	for(unsigned short t=0;t<len1;t++)
	{
		found=false;	
		val=list1->at(t);

		for(unsigned short p=0;p<len2;p++)
		{
			if(val==list2->at(p))
			{
				found=true;
				break;
			}
		}

		if(!found)
			return false;
	}
	
	return true;	
}

inline string TrimString(const std::string & in)
{
    string out = in;
    
	short len=out.size();
	
	short index;

	for(index=0;index<len && isDelim(out[index]);index++);
	
	if(index)
	{
		out=out.substr(index);
		len=out.size();
	}

	index=len-1;
	
	for(;index>=0 && isDelim(out[index]);index--);

	if(index!=len-1)
		out.erase(index+1);	

    return out;
}

inline wstring TrimString(const std::wstring & in)
{
    wstring out = in;
    
	unsigned int len=out.size();
	
	unsigned int index=0;

	for(index=0;index<len && isDelim(out[index]);index++);
	
	if(index)
	{
		out=out.substr(index);
		len=out.size();
	}

	index=len-1;
	
	for(;index>=0 && isDelim(out[index]);index--);

	if(index!=len-1)
		out.erase(index+1);	

    return out;
}

/* REMOVING IN THIS (DOS/LINUX VERSION)
inline wstring MakeXMLCompatible(wstring & instr)
{	
	CString str;
	str=instr.c_str();
	str.Replace(L"#",L"_");
	str.Replace(L"<",L"&lt;");
	str.Replace(L">",L"&gt;");	
	str.Replace(L"/",L"_");	
	str.TrimLeft();
	str.TrimRight();
	str.Replace(L" ",L"&#32;");
	//label.replace(label.begin(),label.end(),L"#",L"-");
	//label.replace(label.begin(),label.end(),L"<",L"&lt;");
	//label.replace(label.begin(),label.end(),L">",L"&gt;");
	wstring label=str;
	return label;
}
REMOVING IN THIS (DOS/LINUX VERSION) */

inline void PrintShortVect(vector<short> & vlist)
{
	using namespace std;
	
	printf("Short List: ");
	for(vector<short>::iterator it=vlist.begin();it!=vlist.end();it++)
		printf("%d,",*it);
	printf("\n");

}

/************************************************************************/

inline wstring CutOnSpace(const std::wstring & in)

{
    wstring Input = in;
    wstring out = L"";

    unsigned int  index = 0;

	while( Input[index] != 32 && Input.length()>index )
                out += Input[index++];

    wstring final_out = TrimString(out);
    return final_out;
}


inline void appendAt(wstring& str, int p, wstring app)
{
	str=str.substr(0,p+1) + app + str.substr(p+1,str.size()-1);
}

inline wstring RemoveCharFromWSTRING(wstring & str,short CharToRemove)
{
	wstring temp=L"";
	size_t vlen=str.length();
	
	short ch=0;

	for(size_t k=0;k<vlen;k++)
	{
		ch=str.at(k);
		if(ch!=CharToRemove)
			temp+=ch;
	}
	
	return temp;
}

inline wstring ReplaceWSTR(wstring & OrigStr, 
						   wstring & ReplacedStr,
						   wstring & ReplacedByStr
						   )
{
	wstring result=L"";

	size_t len=OrigStr.length();	
	size_t index=0;		
	size_t ind2=0;
	size_t store=0;

	bool found=true;
	
	size_t len2=ReplacedStr.length();
	short ch=0;

	while(index<len)
	{		
		found=true;		
		store=index;

		for( ind2=0 ; ind2<len2 && index<len ; index++,ind2++ )
		{
			if(tolower(OrigStr.at(index))!=tolower(ReplacedStr.at(ind2)))
			{
				found=false;
				break;
			}
		}
		
		if(found)
			result+=ReplacedByStr;
		else
		{
			index=store;
			result+=OrigStr.at(index);						
			index++;
		}			
	}	

	return 	result;
}

/************************************************************************/

const short WS=32;
const short LF=13;
const short CR=10;
const short TAB=9;

const short UNIFY_OP='=';
const short SET_OP='$';
const short CONSTRAINT_OP='c';

const short UP_OP='^';
const short DOWN_OP='!';
const short VALUE_OP='v';

const short SOURCE_OP='s';
const short TARGET_OP='t';
const short DELETE_OP='d';
const short INSERT_OP='i';
const short NO_OP=0;

const short OPTIONAL_OP='?';

/***********************************************************************/
//	Morphological Generator Extensions
/***********************************************************************/

#include "CFDescription.h"
#include "FDExpression.h"
#include "FileReader.h"

struct CEndCondition
{
	wstring sequence;
	bool present;
};

using namespace std;

class CFDescription;
class CMorphologicalRule;

typedef vector<CMorphologicalRule *> RULEVECTOR;
typedef pair<wstring,wstring> WSTRPAIR;
typedef vector<wstring> WSTRVECTOR;
typedef vector<WSTRPAIR*> REPVECT;
typedef vector<CEndCondition*> CONDITIONVECTOR;
typedef vector<CFDescription*> PROPVECT;

inline void RemoveEndSpaces(wstring & str)
{
	short len=str.size();
	/*for(int i=0; i< len; i++)CHANGED IN THIS (LINUX) VERSION*/
	int i;
	for(i=0; i< len; i++)
	{
		if(str.at(i)==L' ' || str.at(i)==L'\r' || str.at(i)==L'\n')
		{
		}
		else
		{
			break;
		}
	}
	str=str.substr(i,len-i);
	len=str.size();
	for(i=len-1;i >=0;i--)
	{
		if(str.at(i)==L' ' || str.at(i)==L'\r' || str.at(i)==L'\n')
		{
		}
		else
		{
			break;
		}
	}
	str=str.substr(0,i+1);
}

inline bool MatchEndSeq(wstring word, wstring seq)
{
	if( word.size()< seq.size() )
	{
		return false;
	}

	if(word.substr(word.size()-seq.size() , seq.size()) != seq)
	{
		return false;
	}
	return true;
}

/*inline short GetConstantNumber(wstring str,bool InsertIfNotFound)
{
	short ret=L'';
	if(str== L"NUM")
		ret=L'a';
		
	else if(str== L"SG")
		ret=L'b';
		
	else if(str== L"PL")
		ret=L'c';
		
	else if(str== L"FORM")
		ret=L'd';
		
	else if(str== L"NOM")
		ret=L'e';
		
	else if(str== L"OBL")
		ret=L'f';
		
	else if(str== L"RESPECT")
		ret=L'g';
		
	else if(str== L"NORESPECT")
		ret=L'h';
		
	else if(str== L"FAMILIAR")
		ret=L'i';
		
	else if(str== L"USUAL")
		ret=L'j';
		
	else if(str== L"EXTRA")
		ret=L'k';
		
	else if(str== L"GEND")
		ret=L'l';
		
	else if(str== L"M")
		ret=L'm';
		
	else if(str== L"F")
		ret=L'n';
	else 
	{
		ret=0;
	}
	return ret;
}

inline CFDExpression* GenerateFDExpressionEx2(wstring wstr)
{
	bool end=false;
	bool bracket=false;
	CFDExpression* fdexpPtr=new CFDExpression;
	wstring val=L"";
	RemoveEndSpaces(wstr);
	if(wstr.size()==0)
	{
		return fdexpPtr;
	}
	short ch=L'';
	ch=wstr.at(0);

	for(size_t i=0;i<wstr.size() && !end;i++)
	{
		ch=wstr.at(i);
		switch(ch)
		{
		case L'{':
		//	bracket=true;
			//to do
			break;
		case L'}':
			RemoveEndSpaces(val);
			fdexpPtr->list.push_back(GetConstantNumber(val,true));
			val=L"";
			end=true;
			break;
		case L',':
			RemoveEndSpaces(val);
			fdexpPtr->list.push_back(GetConstantNumber(val,true));
			val=L"";
			break;
		default:
			val+=ch;
			//to do
			break;
		}
	}
	if(i==wstr.size() && !bracket && val!=L"")
	{
		RemoveEndSpaces(val);
		fdexpPtr->list.push_back(GetConstantNumber(val,true));
	}
	return fdexpPtr;
}*/

inline short ReadFileTill(wstring & wstr, short delim, CFileReader* fr)
{
	/*short ch=L''; CHANGED IN THIS (LINUX) VERSION*/
	short ch;
	ch=fr->GetCurrentChar();
	while(ch!=delim)
	{
		wstr+=ch;
		ch=fr->MoveNext();
	}
	ch=fr->MoveNext();
	return ch;
}



///////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/***********************************************************************/


#endif // !defined(AFX_GLOBAL_H__3253A3DE_7F9D_4C1C_B80D_BDD6236CE374__INCLUDED_)

